* Compilation:
* ifort -i8 -o integ integ.f combin.o mem.o xalloc.o -fpp -lblas -llapack -DINT64
* ifort -o integ integ.f combin.o mem.o xalloc.o -fpp -lblas -llapack
* ifort -i8 -o integ integ.f combin.o mem.o xalloc.o -fpp -lblas -llapack -DINT64
* ifort -i8 -o integ integ.f combin.o mem.o xalloc.o -fpp -L/export/intel/mkl/9.0/lib/em64t -lmkl_lapack -lmkl -lguide -lpthread -DINT64
* gfortran -fdefault-integer-8 -x f77-cpp-input -o integ integ.f combin.o mem.o xalloc.o -lblas -llapack -DINT64
************************************************************************
      program integ
************************************************************************
#include "MRCCCOMMON"
      integer natoms,natwdummy,i,intalloc,dblalloc,icoord,iatmass,nbond
      integer iatnum,ix,iy,iz,kx,ky,kz,ii,ia,ka,scr,ij,nmax2,scr2,ibond
      integer iij,iang,jang,jx,jy,jz,jdim,kka,iatnumt,iatchg,ncent
      integer ibondat,nbondc,nangmax,ncontrmax,nprimmax,nshmax,ibasname
      integer iecpname,incorecp,niter,inadja,iqmhatom,nfuns(nirmax),ndao
      real*8 comega
      character*1 ch1,line2(16),cdmrcc1(512)
      character*2 ch2
      character*4 gval,cmpgrpo,route
      character*7 scfiguess
      character*8 qmmm,cscr8,qmreg,popul,gopt,cmpgrpo2,freq,embed,dual
      character*8 rsh
      character*10 cscr
      character*16 line1
      character*20 dfbasis_scf,dfbasis_cor,bfbasis
      character*512 cdmrcc
      logical ldom,lrest,llg,lorbloc,lfdm,lroute
      equivalence(line1,line2)
      equivalence(cdmrcc,cdmrcc1)
      equivalence(cmpgrpo,cmpgrpo2)
      integer*4 istat
#if !defined (gfortran) && !defined (G95)
      integer*4 system
      external system
#endif
C
      call mrccini
C Location of basis sets
      call basislocation(cdmrcc,cdmrcc1)
C Allocate memory
      call memalloc
C Restart SCF and CC in the case of geom. optimization/frequency calc.
      cmpgrpo2='        '
      call getkey('gopt',4,gopt,8)
      call getkey('freq',4,freq,8)
      inquire(file='ITER',exist=llg)
       if((gopt.ne.'off     '.or.freq.ne.'off     ').and.llg) then
        open(scrfile1,file='ITER')
        read(scrfile1,*) niter
        close(scrfile1)
         if(niter.gt.0) then
!!! !HB
!         if(niter.ge.0) then
          call getkey('embed',5,embed,8)
!!! HB!
          call changekey('scfiguess',9,'restart',7)
!!! !HB
          if(embed.eq.'sch') call changekey('scfiguess',9,'mo     ',7)
!!! HB!
          inquire(file='VARS',exist=llg)
           if(llg) then
            call getvar('cmpgrp    ',cmpgrpo2)
            call getkey('rest',4,gval,4)
             if(gval.ne.'0   ') cmpgrpo2='        '
           endif
         endif
       endif
C Retrieve the number of dropped AOs
      ndao=-1
      inquire(file='VARS',exist=llg)
       if(llg) then
        open(varsfile,file='VARS',form='UNFORMATTED')
         do
          read(varsfile,end=1002) cscr
           if(cscr.eq.'ndao      ') exit
         enddo
        backspace(varsfile)
        read(varsfile) cscr,i,ndao
1002    continue
        close(varsfile)
         if(ndao.ne.-1) call getvar('nfuns     ',nfuns)
       endif
C Route
      lfdm=.false.
      lroute=.false.
      route='    '
      comega=0.d0
      rsh='        '
      call getkey('embed',5,embed,8)
      call getkey('dual',4,dual,8)
      inquire(file='ROUTE',exist=lroute)
       if(lroute) then
        open(scrfile1,file='ROUTE')
        read(scrfile1,*,end=4582) route
        close(scrfile1,status='delete')
        route=adjustl(route)
       endif
       if(route.eq.'rsht') then
        open(varsfile,file='VARS',form='UNFORMATTED')
        call getvar('comega    ',comega)
        call getvar('rsh       ',rsh)
        close(varsfile)
       endif
C FDM?
       if(embed.eq.'fdm     '.and.lroute) then
        lfdm=trim(route).eq.'fdm'
         if(lfdm) then
          open(scrfile1,file='FDM',form='unformatted')
          read(scrfile1) natoms,nelec
          close(scrfile1)
          natwdummy=natoms
         endif
       endif
4582  continue
C Restart?
      lrest=.false.
       if(.not.lfdm) then
        call getkey('scfiguess',9,scfiguess,7)
         if(scfiguess.eq.'restart') inquire(file='VARS',exist=lrest)
       endif
C Open input file
      open(minpfile,file='MINP')
C Bond function basis
      call getkey('bfbasis',7,bfbasis,20)
      nbond=0
      nbondc=0
      nangmax=0
      ncontrmax=0
      nprimmax=0
      nshmax=0
      nbf(1:nbsetmax)=0
C Second integ call?
      call getkey('qmmm',4,qmmm,8)
      inquire(file='DOMAIN',exist=ldom)
      ldom=ldom.and..not.lfdm
       if(ldom) then
        open(scrfile2,file='DOMAIN',form='unformatted')
        rewind(scrfile2)
        read(scrfile2) nbasis,nelec,ncore,i,nangmax,ncontrmax,nprimmax,
     $nshmax
        read(scrfile2) nuc
        read(scrfile2)
        read(scrfile2)
        read(scrfile2) natoms
        natwdummy=natoms
        nal=nelec/2
        nbe=nal
       else
C Check geometry
        call getkeym('geom',4,gval,4)
        qmreg='        '
         if(gval.ne.'xyz '.and.gval.ne.'zmat'.and.gval.ne.'tmol'.and.
     $gval.ne.'mol '.and.gval.ne.'    ') call unknown('geom',4)
C Calculate the number of atoms if Z-matrix/bonds are given
         if(qmmm.ne.'charmm  '.and..not.lfdm) then
           if(gval.eq.'zmat'.or.gval.eq.'    ') then
            natoms=-1
            natwdummy=-1
            ch1='0'
             do while(ch1.ne.' ')
              line1='                '
              read(minpfile,"(a16)") line1
              call lowercase(line1,line1,16)
              i=1
               do while(line2(i).eq.' '.and.i.lt.16)
                i=i+1
               enddo
              ch1=line2(i)
              natwdummy=natwdummy+1
               if(ch1.ne.'x'.or.line2(i+1).eq.'e') natoms=natoms+1
             enddo
           else
             if(bfbasis.ne.'none                ') then
              read(minpfile,*) natoms,nbond
              call getnbondc(natoms,nbond,nbondc,minpfile,bfbasis,
     $gbasfile,iout,cdmrcc,icore(iimem+natoms),icore(iimem))
              natoms=natoms+nbondc
             else
              read(minpfile,*) natoms
               if(gval.ne.'mol ') read(minpfile,*)
             endif
            natwdummy=natoms
           endif
           if(qmmm.eq.'amber   ') then
            rewind(minpfile)
            cscr8='        '
             do while(cscr8.ne.'pointcha')
              read(minpfile,"(a8)") cscr8
             enddo
            read(minpfile,*) natwdummy
            natwdummy=natwdummy+natoms
            call getkeym('qmreg',5,qmreg,8)
           endif
         else if(qmmm.eq.'charmm  ') then
          open(scrfile1,file='q1.inp')
          cscr8='        '
           do while(cscr8.ne.'$molecul')
            read(scrfile1,"(a8)") cscr8
           enddo
          natoms=-2
           do while(cscr8.ne.'$end    ')
            read(scrfile1,"(a8)") cscr8
            natoms=natoms+1
           enddo
          natwdummy=natoms-1
          rewind(scrfile1)
          cscr8='        '
           do while(cscr8.ne.'$externa')
            read(scrfile1,"(a8)") cscr8
           enddo
           do while(cscr8.ne.'$end    ')
            read(scrfile1,"(a8)") cscr8
            natwdummy=natwdummy+1
           enddo
          close(scrfile1)
         endif
        write(iout,*)
       endif
       if(qmmm.eq.'off     ') then
        ncent=natoms
       else
        ncent=natwdummy
       endif
C Check how many basis sets are used
      nbset=1
      lorbloc=.false.
      call getkey('dfbasis_scf',11,dfbasis_scf,20)
      call getkey('dfbasis_cor',11,dfbasis_cor,20)
      call getkey('popul',5,popul,8)
      call getkey('orblocc',7,line1,16)
       if(line1.eq.'ibo             '.or.
     $    line1.eq.'no              '.or.
     $    line1.eq.'fragment        ') popul='iao     '
      lorbloc=lorbloc.or.line1.ne.'off             '
      call getkey('orbloco',7,line1,16)
       if(line1.eq.'ibo             '.or.
     $    line1.eq.'no              '.or.
     $    line1.eq.'fragment        ') popul='iao     '
      lorbloc=lorbloc.or.line1.ne.'off             '
      call getkey('orblocv',7,line1,16)
       if(line1.eq.'ibo             '.or.
     $    line1.eq.'no              '.or.
     $    line1.eq.'fragment        ') popul='iao     '
      lorbloc=lorbloc.or.line1.ne.'off             '
       if(dfbasis_scf.ne.'none                ') nbset=2
       if(dfbasis_cor.ne.'none                ') nbset=3
       if(popul      .eq.'iao     ')             nbset=4
       if(lrest)                                 nbset=5
C Call the driver for integral calculation
      iatnum=intalloc(natoms)
      iatnumt=intalloc(natoms)
      icoord=dblalloc(3*natwdummy)
      iatmass=dblalloc(natoms)
      iatchg=dblalloc(natwdummy)
      ibond=dblalloc(natoms)
      ibondat=intalloc(3*natoms)
      ibasname=intalloc(4*natoms*nbset)
      iecpname=intalloc(4*natoms)
      incorecp=intalloc(natoms)
      inadja=intalloc(natoms)
      iqmhatom=intalloc(natoms)
      call intdriver(natoms,natwdummy,icore(iatnum),dcore(icoord),
     $dcore(iatmass),ldom,dfbasis_scf,dfbasis_cor,icore(iatnumt),qmmm,
     $dcore(iatchg),ncent,bfbasis,nbond,dcore(ibond),icore(ibondat),
     $cdmrcc,nbondc,nangmax,ncontrmax,nprimmax,nshmax,qmreg,popul,lrest,
     $icore(ibasname),icore(iecpname),icore(incorecp),cmpgrpo,lorbloc,
     $icore(inadja),icore(iqmhatom),embed,lfdm,route,dual,ndao,nfuns,
     $comega,rsh)
C
      call mrccend(0)
      end
C
************************************************************************
      subroutine intdriver(natoms,natwdummy,atnum,coord,atmass,ldom,
     $dfbasis_scf,dfbasis_cor,atnumt,qmmm,atchg,ncent,bfbasis,nbond,
     $bond,bondat,cdmrcc,nbondc,nangmax,ncontrmax,nprimmax,nshmax,qmreg,
     $popul,lrest,basname,ecpname,ncorecp,cmpgrpo,lorbloc,nadja,qmhatom,
     $embed,lfdm,route,dual,ndao,nfuns,comega,rsh)
************************************************************************
* Driver for integral calculation
************************************************************************
#include "MRCCCOMMON"
      integer natoms,natwdummy,iatoms,i,j,atnum(natoms),icharge,idistc,n
      integer nang,ncontr,nprim,nangmax,ncontrmax,nprimmax,imult,igcoef
      integer intalloc,dblalloc,inang,inangmin,incontr,inprim,igexp,k
      integer nshmax,nsh,ii,naug,nsphermax,ncartmax,verbosity,ncent,ndao
      integer inshrange,inatrange,iindarr,igcn,atnumt(natoms),atmuls
      integer nbond,bondat(3,natoms),ieexp,iebf,nbondc,mmbond,nfuns
      integer ncorecp(natoms),necpatoms,iecpatoms,iecpn,iecpprim,iecpexp
      integer iecpcoef,iecpnang,nbseto
      integer l,nadja(natoms),qmhatom(natoms)
      real*8 coord(3,natwdummy),atmass(natoms),nucrep,gtol,sum,comega
      real*8 atchg(natwdummy)
      real*8 nucdip(3),nucsec(3,3),nucthi(3,3,3)
      character*1 ch1,angsym
      character*2 atsymbol(natwdummy)
      character*4 uval,gval,cval,cmult,uncontract,cmpgrp,cscr,cmpgrpo
      character*4 route,localcc
      character*5 scftype,cgauss
      character*8 qmmm,cscr8,bond(natoms),qmreg,popul,embed,dual,rsh
      character*16 ccalc
      character*20 basname(natoms,nbset),bsn,dfbasis_scf,dfbasis_cor,ecp
      character*20 bfbasis,ecpname(natoms)
      character*24 atsymbas,glabel
      character*512 cdmrcc
      logical ldom,cartg,lrest,lorbloc,lfdm
!!! !HB
      logical loniom
      inquire(file='ONIOMROUTE',exist=loniom)
!!! HB!
C Get old basis set names
      write (*,*) lrest  !modified
      nbseto=nbset
       if(lrest) then
        call getvar('nbasis    ',nbf(5))
        call getvar_c('basname   ',basname)
        basname(1:natoms,5)=basname(1:natoms,1)
        basname(1:natoms,1:4)='                    '
        call getvar('nangmax   ',i)
        nangmax=max(nangmax,i)
        call getvar('ncontrmax ',i)
        ncontrmax=max(ncontrmax,i)
        call getvar('nprimmax  ',i)
        nprimmax=max(nprimmax,i)
        call getvar('nshmax    ',i)
        nshmax=max(nshmax,i)
        call getvar('nbset     ',nbseto)
       else
        basname(1:natoms,1:nbset)='                    '
        nbf(5)=0
       endif
C Read coordinates in the case of FDM
       if(lfdm) then
        call getvar('eref      ',eref)
        open(scrfile1,file='FDM',form='unformatted')
        read(scrfile1) natoms,nelec
        read(scrfile1) atsymbol(1:natoms)
        read(scrfile1) coord(1:3,1:natoms)
        close(scrfile1,status='delete')
        icharge=0
       endif
      open(varsfile,file='VARS',form='unformatted')
C Get keywords
      call getkey('calc',4,ccalc,16)
      call getkey('verbosity',9,cscr,4)
      read(cscr,"(i4)") verbosity
      call getkey('unit',4,uval,4)
      call getkeym('geom',4,gval,4)
      call getkey('gtol',4,cscr,4)
      read(cscr,*) i
      gtol=10.d0**(-i)
      iebf=intalloc(natoms)
      call ifillzero(icore(iebf),natoms)
      mmbond=0
      idistc=dblalloc(natoms**2)
C Read coordinates in the case of local CC calculations
      necpatoms=0
       if(ldom) then
         do iatoms=1,natoms
          read(scrfile2) atnum(iatoms),atchg(iatoms),
     $(coord(j,iatoms),j=1,3),(basname(iatoms,i),i=1,nbseto),
     $ecpname(iatoms),atsymbol(iatoms),atnumt(iatoms),ncorecp(iatoms)
           if(ncorecp(iatoms).gt.0) then
            icore(imem+necpatoms)=iatoms
            necpatoms=necpatoms+1
           endif
         enddo
        iecpatoms=intalloc(necpatoms)
        close(scrfile2)
        goto 1001
       endif
       if(lfdm) goto 1002
C Read Cartesian coordinates in the case of QM/MM calculation
       if(qmmm.eq.'charmm  ') then
        open(scrfile1,file='q1.inp')
        cscr8='        '
         do while(cscr8.ne.'$molecul')
          read(scrfile1,"(a8)") cscr8
         enddo
        read(scrfile1,*) icharge,imult
         do iatoms=1,natoms
          atnum(iatoms)=0
          read(scrfile1,*) atsymbol(iatoms),(coord(j,iatoms),j=1,3)
         enddo
        rewind(scrfile1)
        cscr8='        '
         do while(cscr8.ne.'$externa')
          read(scrfile1,"(a8)") cscr8
         enddo
         do iatoms=natoms+1,natwdummy
          read(scrfile1,*) (coord(j,iatoms),j=1,3),atchg(iatoms)
         enddo
        close(scrfile1)
C Construct Z-matrix
       else if(gval.eq.'zmat'.or.gval.eq.'    ') then
        call zmattocart(coord,natwdummy,atsymbol)
         do iatoms=1,natoms
          atnum(iatoms)=0
         enddo
       else
C Read Cartesian coordinates
        write(iout,*)
        read(minpfile,*)
         if(gval.ne.'mol ') read(minpfile,*)
         if(gval.eq.'xyz ') then !xyz format
          read(minpfile,*) ch1
          backspace(minpfile)
          i=ichar(ch1)
           if(qmreg.eq.'0       ') then
             do iatoms=1,natoms
              atnum(iatoms)=0
              read(minpfile,*) atsymbol(iatoms),(coord(n,iatoms),n=1,3),
     $j,k,l
              mmbond=max(mmbond,j)
C Mark the MM host atom and get the number of adjacent heavy atoms
               if(j.ne.0.and.k.eq.1) then
                qmhatom(j)=iatoms
                nadja(j)=l
               endif
             enddo
           else if(i.ge.49.and.i.le.57) then
             do iatoms=1,natoms
              read(minpfile,*) atnum(iatoms),(coord(j,iatoms),j=1,3)
             enddo
           else
             do iatoms=1,natoms
              atnum(iatoms)=0
              read(minpfile,*) atsymbol(iatoms),(coord(j,iatoms),j=1,3)
             enddo
           endif
         else !Turbomole and mol format
          read(minpfile,*) sum,sum,sum,ch1
          backspace(minpfile)
          i=ichar(ch1)
          n=natoms
           if(bfbasis.ne.'none                ') n=n-nbondc
           if(i.ge.49.and.i.le.57) then
             do iatoms=1,n
              read(minpfile,*) (coord(j,iatoms),j=1,3),atnum(iatoms)
             enddo
           else
             do iatoms=1,n
              atnum(iatoms)=0
              read(minpfile,*) (coord(j,iatoms),j=1,3),atsymbol(iatoms)
             enddo
           endif
           if(bfbasis.ne.'none                ') then
             do iatoms=n+1,natoms
              atnum(iatoms)=0
              atsymbol(iatoms)='Bf'
             enddo
           endif
         endif
       endif
C Read point charges in the case Amber interface
       if(qmmm.eq.'amber   ') then
        rewind(minpfile)
        cscr8='        '
         do while(cscr8.ne.'pointcha')
          read(minpfile,"(a8)") cscr8
         enddo
        read(minpfile,*) i
         do iatoms=natoms+1,natwdummy
          read(minpfile,*) (coord(j,iatoms),j=1,3),atchg(iatoms)
         enddo
       endif
1002  continue
C Look up nuclear masses and atomic numbers
      call nucmass(natoms,atsymbol,atmass,atnum,atnumt)
C Basis set and ECP names
       if(route.eq.'sml ') then
        call getkeym('basis_sm',8,bsn,20)
       else
        call getkeym('basis',5,bsn,20)
       endif
      call getbasnames(basname,atsymbol,natoms,minpfile,iout,atnumt,bsn,
     $bfbasis,route)
      call getkeym('ecp',3,ecp,20)
      call getkey('ecp',3,ecp,20)
      call getecpnames(ecpname,atsymbol,natoms,minpfile,iout,atnum,ecp,
     $basname,ncorecp,gbasfile,cdmrcc,necpatoms,icore(iimem),nangmax,
     $nprimmax)
      iecpatoms=intalloc(necpatoms)
C Number of electrons, core electrons, nuclear charges
      call neleccalc(natoms,atnum,icore(iimem),mmbond,ncorecp,atchg,
     $atmass,nadja,qmreg,qmhatom,lfdm)
C Calculate the centers of bond functions
       if(bfbasis.ne.'none                ') call mbcoord(nbond,natoms,
     $minpfile,coord,bfbasis,atsymbol,atnum,gbasfile,iout,bond,bondat,
     $cdmrcc,icore(iebf),nbondc,nangmax,ncontrmax,nprimmax,nshmax,
     $icore(iimem),icore(iimem+100),icore(iimem+200))
C Scale coordinates if angstrom is used
       if(lfdm) then
        write(varsfile) 'eref      ',ifltln,eref
       else
         if(uval.ne.'bohr')call dscal(natwdummy*3,1d0/angtobohr,coord,1)
C Get charge
         if(qmmm.ne.'charmm  ') then
          icharge=0
          call getkey('charge',6,cval,4)
          read(cval,*) icharge
         endif
       endif
      nelec=nelec-icharge
      ncore=min(2*ncore,nelec)/2
C Set multiplicity
       if(qmmm.ne.'charmm  ') then
        call getkey('mult',4,cmult,4)
         if(cmult.eq.'    ') then
           if(mod(nelec,2).eq.0) then
            cmult='1   '
           else
            cmult='2   '
           endif
           if(natoms.eq.1.and.icharge.eq.0)
     $write(cmult,'(i4)') atmuls(atnum(1))
          cmult=adjustl(cmult)
          call changekey('mult',4,cmult,4)
         endif
        read(cmult,*) imult
       else
        write(cmult,'(i4)') imult
        cmult=adjustl(cmult)
        call changekey('mult',4,cmult,4)
       endif
      nbe=(nelec-imult+1)/2
      nal=nbe+imult-1
c      if(nal.ne.nbe) call changekey('ccprog',6,'mrcc',4) !Bernat
C Type of SCF
      call getkey('scftype',7,scftype,5)
       if(scftype.eq.'     ') then
         if(imult.eq.1) then
          scftype='rhf  '
         else
          call getkey('localcc',7,localcc,4)
          if (localcc.ne.'off ') then
           scftype='rohf '
          else
           scftype='uhf  '
          endif
         endif
        call changekey('scftype',7,scftype,5)
       endif
C Set nacto and nactv
       if(scftype.eq.'mcscf') then
        call getkey('nacto',5,cval,4)
        read(cval,*) nacto
        call getkey('nactv',5,cval,4)
        read(cval,*) nactv
         if(nacto+nactv.eq.0) then
          call getocc('docc',nacto)
          call getocc('mact',nactv)
          nacto=nal+nbe-2*nacto
          nactv=2*nactv-nacto
          write(cval,'(i4)') nacto
          cval=adjustl(cval)
          call changekey('nacto',5,cval,4)
          write(cval,'(i4)') nactv
          cval=adjustl(cval)
          call changekey('nactv',5,cval,4)
         endif
       endif
C
      write(iout,"(1x,a25,i10)") 'Number of atoms:         ',natoms
       if(nbond.gt.0)
     $write(iout,"(1x,a25,i10)") 'Number of bond:          ',nbond
       if(nbondc.gt.0)
     $write(iout,"(1x,a25,i10)") 'Number of bond centers:  ',nbondc
      write(iout,"(1x,a25,i10)") 'Charge:                  ',icharge
      write(iout,"(1x,a25,i10)") 'Number of electrons:     ',nelec
      write(iout,"(1x,a25,i10)") 'Number of core electrons:',ncore*2
      write(iout,"(1x,a25,i10)") 'Spin multiplicity:       ',imult
       if(qmmm.ne.'off     ') 
     $write(iout,"(1x,a25,i10)") 'Number of point charges: ',
     $natwdummy-natoms
      write(iout,*)
      write(iout,*) '                Cartesian coordinates [bohr]' //
     $'      Atomic mass [AMU]  Z'
       do iatoms=1,natoms
         if(atnum(iatoms).eq.0) then
          write(iout,"(i4,1x,a3,3f14.8,3x,f10.6,5x,i3)") iatoms,
     $atsymbol(iatoms),(coord(j,iatoms),j=1,3),0.d0,0
         else
          write(iout,"(i4,1x,a3,3f14.8,3x,f10.6,5x,i3)") iatoms,
     $atsymbol(iatoms),(coord(j,iatoms),j=1,3),atmass(iatoms),
     $atnum(iatoms)
         endif
       enddo
      write(varsfile) 'atmass    ',natoms*ifltln,atmass
c     write(6,*) 'szemet!szemet!szemet!szemet!szemet!szemet!szemet!'
c      if(.false.) then
       if(qmmm.eq.'off     '.and..not.lfdm.and..not.loniom) then       
C Shift the origin to the center of mass
        call centmass(natoms,coord,atmass,varsfile,ifltln)
C Rotate to principal axis system and determine point group
        call princax(natoms,coord,atmass,cmpgrp,gtol,embed)
        write(iout,*)
        write(iout,*) 
     $'Cartesian coordinates in standard orientation [bohr]'
         do iatoms=1,natoms
          write(iout,"(i4,1x,a3,3f14.8)") iatoms,atsymbol(iatoms),
     $(coord(j,iatoms),j=1,3)
         enddo
       else
        cmpgrp='C1  '
        write(varsfile) 'cmpgrp    ',8,cmpgrp // '    '
        write(varsfile) 'pntgrp    ',8,cmpgrp // '    '
        write(varsfile) 'centmass  ',3*ifltln,0.d0,0.d0,0.d0
       endif
       if(cmpgrp.eq.cmpgrpo) call changekey('rest',4,'1   ',4)
C Calculate interatomic distances
      call intdist(natoms,coord,dcore(idistc))
C Calculate nuclear repulsion energy
      nuc=nucrep(natoms-nbondc,coord,atchg)
      sum=0.d0
      write(iout,*)
       if(qmmm.eq.'off     ') then
        write(iout,"(' Nuclear repulsion energy [au]:',f24.12)") nuc
       else
        write(iout,"(' Nuclear repulsion energy [au]:            ',
     $f24.12)") nuc
        nuc=nucrep(ncent,coord,atchg)
        write(iout,"(' Nuclear repulsion with point charges [au]:',
     $f24.12)") nuc
        sum=nucrep(ncent-natoms,coord(1,natoms+1),atchg(natoms+1))
        write(iout,"(' Self energy of the point charges [au]:    ',
     $f24.12)") sum
        if (verbosity.ge.3) call timer
       endif
      write(varsfile) 'selfenergy',ifltln,sum
7596  format(a8,1x,a15,1x,3(i2,1x),1pe23.15,2(1pe15.8))
C Calculate nuclear contribution to dipole and second moments
      call nuccontr(natoms,coord,atnum,nucdip,nucsec,nucthi)
C Auxiliary basis set names
       if(dfbasis_scf.ne.'none                ') then
         if(dfbasis_scf.eq.'auto                ') then
          call dfautobas(basname,basname(1,2),natoms,.true.,ccalc.eq.
     $'scf             '.or.dfbasis_cor.eq.'none                ',route,
     $atnumt)
         else
          call getkeym('dfbasis_scf',11,dfbasis_scf,20)
           if(dfbasis_scf.eq.'                    ')
     $    call getkeym('dfbasis_cor',11,dfbasis_scf,20)
          call getbasnames(basname(1,2),atsymbol,natoms,minpfile,iout,
     $atnumt,dfbasis_scf,bfbasis,route)
         endif
       endif
       if(dfbasis_cor.ne.'none                ') then
         if(dfbasis_cor.eq.'auto                ') then
          call dfautobas(basname,basname(1,3),natoms,.false.,.false.,
     $route,atnumt)
         else
          call getkeym('dfbasis_cor',11,dfbasis_cor,20)
          call getbasnames(basname(1,3),atsymbol,natoms,minpfile,iout,
     $atnumt,dfbasis_cor,bfbasis,route)
         endif
       endif
       if(popul.eq.'iao     ')basname(1:natoms,4)='cc-pvtz-min         '
1001  continue
C Preread basis set
      call prereadbas(natoms,nangmax,ncontrmax,nprimmax,nshmax,
     $basname,atsymbol,gbasfile,icore(iimem),icore(iimem+100),iout,bond,
     $bfbasis,cdmrcc,nbondc,icore(iimem+200),atnumt)
       if(dfbasis_scf.ne.'none                ')
     $call prereadbas(natoms,nangmax,ncontrmax,nprimmax,nshmax,
     $basname(1,2),atsymbol,gbasfile,icore(iimem),icore(iimem+100),iout,
     $bond,bfbasis,cdmrcc,nbondc,icore(iimem+200),atnumt)
       if(dfbasis_cor.ne.'none                ')
     $call prereadbas(natoms,nangmax,ncontrmax,nprimmax,nshmax,
     $basname(1,3),atsymbol,gbasfile,icore(iimem),icore(iimem+100),iout,
     $bond,bfbasis,cdmrcc,nbondc,icore(iimem+200),atnumt)
       if(popul.eq.'iao     ')
     $call prereadbas(natoms,nangmax,ncontrmax,nprimmax,nshmax,
     $basname(1,4),atsymbol,gbasfile,icore(iimem),icore(iimem+100),iout,
     $bond,bfbasis,cdmrcc,nbondc,icore(iimem+200),atnumt)
       if(lrest.and.trim(dual).ne.'e1'.and.trim(dual).ne.'e2') then
        lrest=.false.
         do iatoms=1,natoms
           if(basname(iatoms,1).ne.basname(iatoms,5)) then
            lrest=.true.
            exit
           endif
         enddo
c     lrest=.true. !szemet
       endif
      call getkey('uncontract',10,uncontract,4)
       if(uncontract.eq.'on  ') ncontrmax=max(nprimmax,ncontrmax)
      write(iout,*)
      write(iout,*)
      write(iout,*) 'Basis set information:'
      write(iout,*)
      write(iout,*) 'Maximum angular momentum: ',angsym(nangmax)
      write(iout,"(1x,a39,i5)") 
     $'Maximum number of contracted Gaussians:',ncontrmax
      write(iout,"(1x,a39,i5)") 
     $'Maximum number of primitive Gaussians: ',nprimmax
C Cartesian or spherical basis set?
      call getkey('gauss',5,cgauss,5)
      cartg=.false.
       if(cgauss.eq.'cart ') then
        cartg=.true.
        write(iout,*) 'Cartesian GTOs are used.'
       else
        write(iout,*) 'Spherical harmonic GTOs are used.'
       endif
      ncartmax=(nangmax+1)*(nangmax+2)/2
      nsphermax=2*nangmax+1
       if(cartg) nsphermax=ncartmax
      write(iout,*)
C Memory allocations
      inang=intalloc(natoms*nbset)
      inangmin=intalloc(natoms*nbset)
      incontr=intalloc((nangmax+1)*natoms*nbset)
      inprim=intalloc((nangmax+1)*natoms*nbset)
      igexp=dblalloc((nangmax+1)*nprimmax*natoms*nbset)
      igcoef=dblalloc(nprimmax*ncontrmax*(nangmax+1)*natoms*nbset)
       if(bfbasis.ne.'none                ') then
        ieexp=dblalloc(9*nprimmax*(nangmax+1)*natoms*nbset)
       else
        ieexp=igexp
       endif
      inshrange=intalloc(2*(nangmax+1)*natoms*nbset)
      inatrange=intalloc(2*natoms*nbset)
      iindarr=intalloc(nsphermax*ncontrmax*(nangmax+1)*natoms*nbset)
      igcn=intalloc(2*ncontrmax*(nangmax+1)*natoms*nbset)
      iecpn   =intalloc(nprimmax*(nangmax+1)*necpatoms)
      iecpprim=intalloc((nangmax+1)*necpatoms)
      iecpnang=intalloc(necpatoms)
      iecpexp =dblalloc(nprimmax*(nangmax+1)*necpatoms)
      iecpcoef=dblalloc(nprimmax*(nangmax+1)*necpatoms)
C Initialize arrays to avoid saving of uninitialized bytes
      icore(incontr:incontr+(nangmax+1)*natoms*nbset-1)=0
      icore(inprim:inprim+(nangmax+1)*natoms*nbset-1)=0
      dcore(igcoef:
     $      igcoef+nprimmax*ncontrmax*(nangmax+1)*natoms*nbset-1)=0.d0
      icore(inshrange:inshrange+2*(nangmax+1)*natoms*nbset-1)=0
      dcore(igexp:igexp+(nangmax+1)*nprimmax*natoms*nbset-1)=0.d0
      icore(iindarr:
     $      iindarr+nsphermax*ncontrmax*(nangmax+1)*natoms*nbset-1)=0
      icore(igcn:igcn+2*ncontrmax*(nangmax+1)*natoms*nbset-1)=0
C Calculate integrals
      call intcalc(natoms,nangmax,ncontrmax,nprimmax,atsymbol,basname,
     $coord,icore(inang),icore(incontr),icore(inprim),dcore(igexp),
     $dcore(igcoef),atnum,icore(inangmin),nshmax,uncontract,ldom,cmpgrp,
     $gtol,icore(inshrange),icore(inatrange),icore(iindarr),icore(igcn),
     $nsphermax,ncartmax,cartg,dfbasis_scf,dfbasis_cor,verbosity,
     $dcore(idistc),ccalc,atnumt,icharge,imult,atchg,ncent,bond,bfbasis,
     $bondat,dcore(ieexp),icore(iebf),cdmrcc,qmreg,popul,lrest,ecpname,
     $icore(iecpn),icore(iecpprim),dcore(iecpexp),dcore(iecpcoef),
     $necpatoms,icore(iecpatoms),icore(iecpnang),ncorecp,lorbloc,nucdip,
     $nucsec,nucthi,embed,route,ndao,nfuns,comega,rsh)
C
      return
      end
C
************************************************************************
      subroutine intcalc(natoms,nangmax,ncontrmax,nprimmax,atsymbol,
     $basname,coord,nang,ncontr,nprim,gexp,gcoef,atnum,nangmin,nshmax,
     $uncontract,ldom,cmpgrp,gtol,nshrange,natrange,indarr,gcn,
     $nsphermax,ncartmax,cartg,dfbasis_scf,dfbasis_cor,verbosity,distc,
     $ccalc,atnumt,icharge,imult,atchg,ncent,bond,bfbasis,bondat,eexp,
     $ebf,cdmrcc,qmreg,popul,lrest,ecpname,ecpn,ecpprim,ecpexp,ecpcoef,
     $necpatoms,ecpatoms,ecpnang,ncorecp,lorbloc,nucdip,nucsec,nucthi,
     $embed,route,ndao,nfuns,comega,rsh)
************************************************************************
* Calculate integrals
************************************************************************
#if defined (LIBXC)
      use xc_f03_lib_m
#endif
#include "MRCCCOMMON"
#if defined (LIBXC)
      type(xc_f03_func_t) :: xc_func
      type(xc_f03_func_info_t) :: xc_info
      character(len=128) info
#endif
      integer natoms,nangmax,ncontrmax,nprimmax,ncartmax,i,n
      integer dblalloc,ictostr,iang,nsphermax,it1,it2,ict,mgga
      integer atnum(*),iboysval,nmboys,icf,intalloc,ipre,nagrid,imult
      integer itisjsk,itisjk,itisjsksl,itisjsksls,iatoms,j,iprim,ip
      integer inzipr,inzjpr,inzkpr,inzlpr,imolperm,imem1,idfrqq,itcdfint
      integer noeint,nbfshmax,nfunc(nirmax),nfuns(nirmax),ndao
      integer it3,it4,it5,idfipre,idfn,ngrid,nstateall
      integer nshrange(2,0:nangmax,natoms,nbset),ispctostr,verbosity
      integer indarr(natoms,0:nangmax,ncontrmax,nsphermax,nbset),maxleb
      integer gcn(2,ncontrmax,0:nangmax,natoms,nbset),iagrid,iaweight
      integer maxmom,ispre,idfipra,nstate,info8,printfile,maxint,nnsing
      parameter(maxmom=3,noeint=(maxmom+1)*(maxmom+2)*(maxmom+3)/6+7)
      parameter(maxint=(maxmom+1)*(maxmom+2)*(maxmom+3)/6+5)
      parameter (maxleb=22,printfile=scrfile6)
      integer iinti,iintj,iintf,iints,nntrip
      integer iintc,iinta,nang(natoms,nbset),igcoem
      integer inzint,nleb(maxleb),aleb(maxleb),ii
      integer nprim(0:nangmax,natoms,nbset),nlgrid,nagridmin
      integer ncontr(0:nangmax,natoms,nbset),idvec,isqrt
      integer iintpos,nangmin(natoms,nbset),nshmax,iianm,iicon,iipri
      integer inang,incontr,inprim,igcoef,icoord,icmo,itra,ivi,ivj,iwnaf
      integer ithad,ithcf2,iscoord,irqqij,irqqkl,ibftrans
      integer natrange(2,natoms,nbset),ihrec,ivprim,dhyb
      integer isgrid,atnumt(natoms),iintpostc,icharge
      integer ncent,bondat(3,natoms),ebf(natoms),iragr,iatcl
      integer necpatoms,ecpn(nprimmax,0:nangmax,necpatoms),isymat,ihmat
      integer ecpnang(necpatoms),ncorecp(natoms),ilogkc,ikp,igck
      integer ecpprim(0:nangmax,necpatoms),ecpatoms(necpatoms),nbfatmax
      character*1 fgrid1(13),agrid1(6)
      character*2 atsymbol(natoms),agrid2(3),c2
      character*4 citol,uncontract,cmpgrp,intalg,localcc,cscr4,ccprog
      character*4 route
      character*6 molden,core,agrid,aagrid,rgrid,c16
      character*7 scfiguess
      character*8 bond(natoms),qmreg,dfalg,drpaalg,popul,embed,epert,rsh
      character*8 grdens,cialg,orblocguess,scfalg,cpssp
      character*13 fgrid
      character*16 ccalc,naf_cor,naf_scf
      character*20 basname(natoms,nbset),dfbasis_scf,dfbasis_cor
      character*20 bfbasis,ecpname(natoms)
      character*32 dft,cdft
      character*512 cdmrcc
      real*8 gexp(nprimmax,0:nangmax,natoms,nbset),coord(3,natoms),itol
      real*8 gcoef(nprimmax,ncontrmax,0:nangmax,natoms,nbset),distc,chfx
      real*8 temp,cmp2,cmp2s,cmp2t,cdrpa,cdrpae,cdrpas,cdrpat,gtol,tcmax
      real*8 csosex,csosexs,csosext,naftol,atchg(natoms),fhfx,tmp,r
      real*8 eexp(3,3,nprimmax,0:nangmax,natoms,nbset),cpert(maxint)
      real*8 ecpexp(nprimmax,0:nangmax,necpatoms),clrhfx,flrhfx
      real*8 ecpcoef(nprimmax,0:nangmax,necpatoms),omega,fomega,getomega
      real*8 nucdip(3),nucsec(3,3),nucthi(3,3,3),csrhfx,fsrhfx,comega
      logical cartg,ldom,lll,lseqc,lexc,dofit,lrpa,lnaf,laibj,lebf,lrest
      logical fulltc,lorbloc,lfhfx,lnl,localcc15p,lpssp
      common/memcom/ imem1
      equivalence(agrid1,agrid)
      equivalence(agrid2,aagrid)
      equivalence(fgrid1,fgrid)
      equivalence(c2,cdft)
      integer*4 info4,ii4,jj4
      equivalence(info8,info4)
      data nleb /6,14,26,38,50,74,86,110,146,170,194,230,266,302,350,
     $434,590,770,974,1202,1454,1730/
      data aleb /3, 5, 7, 9,11,13,15, 17, 19, 21, 23, 25, 27, 29, 31,
     $ 35, 41, 47, 53,  59,  65,  71/
C Gyula
      integer nangmaxv(nbset),nan1,nan2
      interface
      subroutine rhffock
      end
      subroutine uhffock
      end
      subroutine boys
      end
      subroutine boyslr
      end
      subroutine boyssr
      end
      end interface
C Will drpa be called?
      call getkey('dft',3,dft,32)
      call getkey('grdens',6,grdens,8)
      call getkey('localcc',7,localcc,4)
       lrpa=ccalc.eq.'mp2             '.or.
     $      ccalc.eq.'drpa            '.or.
     $      ccalc.eq.'sosex           '.or.
     $      ccalc.eq.'rpa             '.or.
     $      localcc15p(localcc)
      call getkey('orblocguess',11,orblocguess,8)
      call getkey('pssp',4,cpssp,8)
      if(cpssp.eq.'off     ') then
        lpssp = .false.
      else
        lpssp=.true. ! scf.f
      endif
C Local correlation for excited states?
      call getkey('nstate',6,cscr4,4)
      read(cscr4,*) nstate
      call getkey('nsing',5,cscr4,4)
      read(cscr4,*) nnsing
      call getkey('ntrip',5,cscr4,4)
      read(cscr4,*) nntrip
      nstateall=nstate+nnsing+nntrip
C Only (ai|bj) list is needed
       laibj=ccalc.eq.'mp2             '.or.
     $       ccalc.eq.'drpa            '.or.
     $       ccalc.eq.'sosex           '
C Integral evaluation method
      call getkey('intalg',6,intalg,4)
      call getkey('dfalg',5,dfalg,8)
      call getkey('dens',4,cscr4,4)
      call getkey('ccprog',4,ccprog,4)
      call getkey('scfiguess',9,scfiguess,7)
      read(cscr4,*) dens
C Threshold for integral calculation
      call getkey('itol',4,citol,4)
      read(citol,*) i
      itol=10.d0**(-i)
C Check what SCF algorithm is executed
      call getkey('scfalg',6,scfalg,8)
       if(ldom) scfalg='disk    '
C Variables for basis sets
      igcoem=dblalloc(nprimmax*ncontrmax*(nangmax+1)*natoms)
      iianm=intalloc(nshmax)
      iicon=intalloc(nshmax)
      iipri=intalloc(nshmax)
      nbfshmax=0
      nbfatmax=0
C Read conventional basis set
       if(nbset.gt.1) then
        write(iout,*)
        write(iout,*) 'Conventional basis set:'
        write(iout,*)
       endif
      call readbas(natoms,nangmax,ncontrmax,nprimmax,atsymbol,basname,
     $nang,ncontr,nprim,gexp,gcoef,cartg,indarr,nsphermax,
     $gcn,itol,dcore(igcoem),atnumt,nbfshmax,nbfatmax,nshrange,
     $nangmin,icore(iianm),icore(iicon),icore(iipri),uncontract,
     $natrange,gbasfile,iout,nbasis,verbosity,bfbasis,bond,coord,bondat,
     $eexp,ebf,cdmrcc)
      nbf(1)=nbasis
C Decide what CI algorithm is executed
      call getkey('cialg',5,cialg,8)
       if(trim(cialg).eq.'auto') then
         if((trim(ccprog).eq.'cis'.or.localcc.ne.'off ')
     $.and.nbasis.gt.2500) then
          cialg='direct  '
         else
          cialg='disk    '
         endif
        call changekey('cialg',5,cialg,8)
       endif
      call getkey('redcost_exc',11,cscr4,4)
      if((cialg.eq.'direct  '.or.cialg.eq.'direct2 '
     $.or.cialg.eq.'direct3 ').and.(cscr4.eq.'cust'
     $.or.cscr4.eq.'1   '.or.cscr4.eq.'7   '.or.cscr4.eq.'8   '.or.
     $cscr4.eq.'9   '.or.cscr4.eq.'10  ')) then
       write(iout,*) 'Inconsistent options for cialg and redcost_exc!'
       write(iout,*) 'CS-NAF approximation is available only with 
     $cialg.eq.disk keyword!'
       write(iout,*) 'Please set that or use other approximations!'
       call mrccend(1)
      endif
C Write MOLDEN input if required
      call getkey('molden',6,molden,6)
       if(ldom) molden='off   '
       call getkeym('moldenloc',9,cscr4,4)
       if (trim(cscr4).eq.'on') write(varsfile) 'gcoem     ', ! needed in ldrpa.f for MOLDEN files
     $ifltln*nprimmax*ncontrmax*(nangmax+1)*natoms,
     $dcore(igcoem:igcoem+nprimmax*ncontrmax*(nangmax+1)*natoms-1)
       if(molden.eq.'on    ') then
        imolperm=intalloc(ncontrmax*nsphermax*(nangmax+1)*natoms)
        call moldeninp(natoms,nangmax,ncontrmax,nprimmax,atsymbol,nang,
     $ncontr,nprim,gexp,dcore(igcoem),coord,atnum,cartg,icore(imolperm))
       endif
!!! !HB
C write xyz file of the active subsystem if embedding is used
      call getkey('embed',5,embed,8)
      if(embed.ne.'off') 
     $ call get_subsyscoord(natoms,atsymbol,coord,atnum)
!!! !HB
C Read density fitting basis sets
       if(dfbasis_scf.ne.'none                ') then
        write(iout,*)
        write(iout,*) 
     $'Fitting basis set for the SCF calculation:'
        write(iout,*)
        call readbas(natoms,nangmax,ncontrmax,nprimmax,atsymbol,
     $basname(1,2),nang(1,2),ncontr(0,1,2),nprim(0,1,2),gexp(1,0,1,2),
     $gcoef(1,1,0,1,2),cartg,indarr(1,0,1,1,2),nsphermax,gcn(1,1,0,1,2),
     $itol,dcore(igcoem),atnumt,nbfshmax,nbfatmax,nshrange(1,0,1,2),
     $nangmin(1,2),icore(iianm),icore(iicon),icore(iipri),uncontract,
     $natrange(1,1,2),gbasfile,iout,nbf(2),verbosity,bfbasis,bond,coord,
     $bondat,eexp(1,1,1,0,1,2),ebf,cdmrcc)
         if(nbf(1).gt.nbf(2)) then
          write(iout,*) 
     $'The AO basis set must not be larger than the fitting basis!'
          call mrccend(1)
         endif
       endif
       if(dfbasis_cor.ne.'none                ') then
        write(iout,*)
        write(iout,*) 
     $'Fitting basis set for the correlation calculation:'
        write(iout,*)
        call readbas(natoms,nangmax,ncontrmax,nprimmax,atsymbol,
     $basname(1,3),nang(1,3),ncontr(0,1,3),nprim(0,1,3),gexp(1,0,1,3),
     $gcoef(1,1,0,1,3),cartg,indarr(1,0,1,1,3),nsphermax,gcn(1,1,0,1,3),
     $itol,dcore(igcoem),atnumt,nbfshmax,nbfatmax,nshrange(1,0,1,3),
     $nangmin(1,3),icore(iianm),icore(iicon),icore(iipri),uncontract,
     $natrange(1,1,3),gbasfile,iout,nbf(3),verbosity,bfbasis,bond,coord,
     $bondat,eexp(1,1,1,0,1,3),ebf,cdmrcc)
         if(nbf(1).gt.nbf(3)) then
          write(iout,*) 
     $'The AO basis set must not be larger than the fitting basis!'
          call mrccend(1)
         endif
       endif
C Basis set for IAO construction
       if(popul.eq.'iao     ') then
        write(iout,*)
        write(iout,*) 'Minimal atomic basis set'
        write(iout,*)
        call readbas(natoms,nangmax,ncontrmax,nprimmax,atsymbol,
     $basname(1,4),nang(1,4),ncontr(0,1,4),nprim(0,1,4),gexp(1,0,1,4),
     $gcoef(1,1,0,1,4),cartg,indarr(1,0,1,1,4),nsphermax,gcn(1,1,0,1,4),
     $itol,dcore(igcoem),atnumt,nbfshmax,nbfatmax,nshrange(1,0,1,4),
     $nangmin(1,4),icore(iianm),icore(iicon),icore(iipri),uncontract,
     $natrange(1,1,4),gbasfile,iout,nbf(4),verbosity,bfbasis,bond,coord,
     $bondat,eexp(1,1,1,0,1,4),ebf,cdmrcc)
       endif
C Old basis set for SCF restart
       if(lrest) then
        write(iout,*)
        write(iout,*) 'Old basis set for SCF restart'
        write(iout,*)
        call readbas(natoms,nangmax,ncontrmax,nprimmax,atsymbol,
     $basname(1,5),nang(1,5),ncontr(0,1,5),nprim(0,1,5),gexp(1,0,1,5),
     $gcoef(1,1,0,1,5),cartg,indarr(1,0,1,1,5),nsphermax,gcn(1,1,0,1,5),
     $itol,dcore(igcoem),atnumt,nbfshmax,nbfatmax,nshrange(1,0,1,5),
     $nangmin(1,5),icore(iianm),icore(iicon),icore(iipri),uncontract,
     $natrange(1,1,5),gbasfile,iout,nbf(5),verbosity,bfbasis,bond,coord,
     $bondat,eexp(1,1,1,0,1,5),ebf,cdmrcc)
         if(nbf(5).gt.nbf(1)) then
          write(iout,*) 
     $'No restart is possible from bigger basis set calculations!'
          call mrccend(1)
         endif
       endif
C Read ECPs
       if(necpatoms.gt.0) then
        write(iout,*)
        write(iout,*) 'Effective core potentials:'
        write(iout,*)
        call readecp(ecpname,atsymbol,natoms,gbasfile,cdmrcc,necpatoms,
     $ecpatoms,nangmax,nprimmax,ecpn,ecpnang,ecpprim,ecpexp,ecpcoef,
     $iout)
       endif
C Do we have elliptical functions
      lebf=.false.
       do iatoms=1,natoms
        lebf=lebf.or.ebf(iatoms).gt.0
       enddo
C Atomic density initial guess for SCF
       if((trim(dft).ne.'off'.or.scfiguess.eq.'sad    ').and.
     $.not.ldom) then
        write(iout,*)
        write(iout,*)
     $'Generating atomic densities for the SCF calculation...'
        call sadscfiguess(natoms,atnum,atsymbol,basname,icharge,imult,
     $atnumt,qmreg,ecpname,scrfile1,iout,dft,cdmrcc,scfiguess)
        call timer
       endif
      call aoscfiguess(nbasis,atnum,nang,natoms,nangmax,cartg,
     $ncontr,scrfile1,dcore(imem),dcore(imem+nbasis),nal,nbe)
      call dbldealloc(igcoem)
C Occupation vector
      open(inpfile,status='unknown',file='OCCUP')
      rewind(inpfile)
      call getkey('core',4,core,6)
      j=0
       if(core.ne.'corr  ') j=ncore
      write(inpfile,"(1000000i2)") (2,i=1,nbe-j),(1,i=1,nal-nbe),
     $(0,i=1,nbasis-nal)
      close(inpfile)
c Initialize integral files
      open(oeintfile,file='OEINT',form='unformatted',status='unknown')
      open(printfile,file='PRINT',form='unformatted',status='unknown')
      open(tedatfile,file='TEDAT',form='unformatted',status='unknown')
C Calculate Cartesian to spherical GTO transformation matrices
      ictostr=dblalloc((nangmax+1)*ncartmax**2)
      ispctostr=dblalloc((nangmax+1)*(3*ncartmax**2+1))
      dcore(ictostr:ictostr+(nangmax+1)*ncartmax**2-1)=0.d0
      dcore(ispctostr:ispctostr+(nangmax+1)*(3*ncartmax**2+1)-1)=0.d0
       do iang=0,nangmax
        call cart_gto_to_sphharm(iang,dcore(ictostr+iang*ncartmax**2),
     $dcore(ictostr+iang*ncartmax**2),
     $dcore(ispctostr+iang*(3*ncartmax**2+1)),
     $dcore(ispctostr+iang*(3*ncartmax**2+1)),cartg)
       enddo
C Symmetry adaptation of basis functions
       if(.not.ldom) then
        ibftrans=intalloc(nbasis*nirmax)
        ivi=dblalloc(3*ncartmax)
        ivj=dblalloc(3*ncartmax)
        ict=intalloc(ncartmax)
        icmo=dblalloc(nbasis**2)
        itra=intalloc(nirmax)
        isymat=intalloc(natoms*nirmax)
        call symadapt(natoms,coord,cmpgrp,gtol,icore(ibftrans),
     $dcore(imem),nang,ncontr,nangmax,nshrange,dcore(ivi),dcore(ivj),
     $icore(ict),ncartmax,dcore(ictostr),cartg,dcore(icmo),dcore(imem),
     $icore(itra),dcore(imem),dcore(imem),itol,icore(isymat),embed,
     $natrange,nfunc)
        call intdealloc(ibftrans)
       endif
C Integration grid for DFT
      chfx=-1.d0
      clrhfx=0.d0
      csrhfx=0.d0
      flrhfx=0.d0
      fsrhfx=0.d0
      omega=0.d0
      fomega=0.d0
      cmp2=0.d0
      cmp2s=0.d0
      cmp2t=0.d0
      if(trim(ccprog).eq.'cis') then
       cmp2=1.d0
       cmp2t=1.d0
       cmp2s=1.d0
      endif
      cdrpa=0.d0
      cdrpae=1.d0
      cdrpas=0.d0
      cdrpat=0.d0
      csosex=0.d0
      csosexs=0.d0
      csosext=0.d0
      mgga=0
      dhyb=0
      embed='        '
      lfhfx=.true.
      lnl=.false.
       if(trim(dft).eq.'off') then
        call getkey('embed',5,embed,8)
         if(embed.ne.'off     ') then
c         open(minpfile,file='MINP')
          call getkeym('embed',5,embed,8)
          read(minpfile,*)
          read(minpfile,*) dft
          dft=adjustl(dft)
          call lowercase(dft,dft,32)
           if(trim(dft).eq.'hf') dft='off                             '
c         close(minpfile)
         endif
       endif
       if((trim(dft).ne.'off'.or.lebf.or.trim(grdens).ne.'off'.or.
     $lpssp).and..not.ldom) then
        call getkey('agrid',5,fgrid,13)
        agrid1(1:6)=fgrid1(1:6)
        nagridmin=0
         if(fgrid1(7).eq.'-') then
          aagrid=agrid
           if(agrid2(1).ne.'ld') call unknown('agrid',5)
          agrid2(1)='  '
          aagrid=adjustl(aagrid)
          read(aagrid,*) nagridmin
          agrid1(1:6)=fgrid1(8:13)
          i=1
           do while(nagridmin.ne.nleb(i).and.i.lt.maxleb)
            i=i+1
           enddo
           if(nagridmin.ne.nleb(i).and.nagridmin.lt.nleb(maxleb)) 
     $call unknown('agrid',5)
         endif
        aagrid=agrid
        lll=agrid2(1).eq.'ld'
        agrid2(1)='  '
        aagrid=adjustl(aagrid)
        read(aagrid,*) nagrid
         if(lll) then
          i=1
           do while(nagrid.ne.nleb(i).and.i.lt.maxleb)
            i=i+1
           enddo
           if(nagrid.ne.nleb(i).and.nagrid.lt.nleb(maxleb))
     $call unknown('agrid',5)
         endif
        nlgrid=1
         if(fgrid1(7).eq.'-') then
           do i=1,maxleb
             if(nleb(i).lt.nagrid) nlgrid=nlgrid+1
           enddo
         endif
         if(nagridmin.eq.0) nagridmin=nagrid
        write(iout,*)
        chfx=0.d0
         if(trim(dft).eq.'lda') then
          write(iout,*) 
     $'Density functional: Slater-Dirac exchange (LDA)'
         else if(trim(dft).eq.'b88') then
          write(iout,*) 
     $'Density functional: Becke 1988 exchange functional (B88)'
         else if(trim(dft).eq.'pbex') then
          write(iout,*) 
     $'Density functional: PBE exchange functional (PBEx)'
         else if(trim(dft).eq.'lyp') then
          write(iout,*) 
     $'Density functional: Lee-Yang-Parr correlation functional (LYP)'
         else if(trim(dft).eq.'pw91x') then
          write(iout,*) 
     $'Density functional: Perdew-Wang 1991 exchange functional (PW91x)'
         else if(trim(dft).eq.'vwn5') then
          write(iout,*) 'Density functional: ' //
     $'Vosko-Wilk-Nusair correlation functional (VWN5)'
         else if(trim(dft).eq.'pw') then
          write(iout,*) 
     $'Density functional: Perdew-Wang correlation functional (PW)'
         else if(trim(dft).eq.'p86') then
          write(iout,*) 
     $'Density functional: Perdew 1986 correlation functional (P86)'
         else if(trim(dft).eq.'pbec') then
          write(iout,*) 
     $'Density functional: PBE correlation functional (PBEc)'
         else if(trim(dft).eq.'pw91c') then
          write(iout,*) 'Density functional: Perdew-Wang 1991 '
     $// 'correlation functional (PW91c)'
         else if(trim(dft).eq.'blyp') then
          write(iout,*) 'Density functional: BLYP'
         else if(trim(dft).eq.'bhlyp') then
          write(iout,*) 'Density functional: BHLYP'
          chfx=-0.5d0
         else if(trim(dft).eq.'b3lyp') then
          write(iout,*) 'Density functional: B3LYP'
          chfx=-0.2d0
         else if(trim(dft).eq.'b3pw91') then
          write(iout,*) 'Density functional: B3PW91'
          chfx=-0.2d0
         else if(trim(dft).eq.'b3lyp3') then
          write(iout,*) 'Density functional: B3LYP3'
          chfx=-0.2d0
         else if(trim(dft).eq.'b97') then
          write(iout,*) 'Density functional: B97'
          chfx=-0.1943d0
         else if(trim(dft).eq.'bp86') then
          write(iout,*) 'Density functional: BP86'
         else if(trim(dft).eq.'pbe') then
          write(iout,*) 
     $'Density functional: PBE exchange-correlation functional (PBE)'
         else if(trim(dft).eq.'pbe0') then
          write(iout,*) 
     $'Density functional: PBE hybrid functional (PBE0)'
          chfx=-0.25d0
         else if(trim(dft).eq.'pw91') then
          write(iout,*) 
     $'Density functional: Perdew-Wang 1991 functional (PW91)'
         else if(trim(dft).eq.'hcth120') then
          write(iout,*) 'Density functional: HCTH120'
         else if(trim(dft).eq.'hcth147') then
          write(iout,*) 'Density functional: HCTH147'
         else if(trim(dft).eq.'hcth407') then
          write(iout,*) 'Density functional: HCTH407'
         else if(trim(dft).eq.'ncap') then
          write(iout,*)
     $'Density functional: nearly correct asymptotic potential (NCAP)'
         else if(trim(dft).eq.'b2plyp') then
          write(iout,*) 'Density functional: B2PLYP'
          chfx=-0.53d0
          cmp2=0.27d0
          dhyb=1
         else if(trim(dft).eq.'b2gpplyp') then
          write(iout,*) 'Density functional: B2GPPLYP'
          chfx=-0.65d0
          cmp2=0.36d0
          dhyb=1
         else if(trim(dft).eq.'dsdpbep86') then
          write(iout,*) 'Density functional: DSDPBEP86'
          chfx=-0.70d0
          cmp2s=0.53d0
          cmp2t=0.25d0
          dhyb=1
         else if(trim(dft).eq.'xyg3') then
          write(iout,*) 'Density functional: XYG3'
          chfx=-0.20d0
          fhfx=-0.8033d0
          cmp2=0.3211d0
          lfhfx=.false.
          dhyb=1
         else if(trim(dft).eq.'drpa75') then
          write(iout,*) 'Density functional: dRPA75'
          chfx=-0.75d0
          fhfx=-0.75d0
          lfhfx=.false.
          cdrpa=1.d0
          dhyb=1
         else if(trim(dft).eq.'scs-drpa75') then
          write(iout,*) 'Density functional: SCS-dRPA75'
          chfx=-0.75d0
          fhfx=-0.75d0
          lfhfx=.false.
          cdrpas=1.5d0
          cdrpat=0.5d0
          dhyb=1
         else if(trim(dft).eq.'user'.or.
     $           trim(dft).eq.'userd') then
          write(iout,*) 'Density functional: user-defined'
          call getkeym('dft',3,dft,32)
          read(minpfile,*) n
           do i=1,n
            read(minpfile,*) temp,cdft
            cdft=adjustl(cdft)
            call lowercase(cdft,cdft,32)
#if defined (LIBXC)
            call libxcconv(cdft)
             if(xc_f03_functional_get_number(cdft).gt.0) then
              call xc_f03_func_init(xc_func,
     $xc_f03_functional_get_number(cdft),XC_UNPOLARIZED)
              xc_info=xc_f03_func_get_info(xc_func)
               if(
     $xc_f03_func_info_get_family(xc_info).eq.XC_FAMILY_MGGA.or.
     $xc_f03_func_info_get_family(xc_info).eq.XC_FAMILY_HYB_MGGA) mgga=1
              call xc_f03_func_end(xc_func)
               if(xc_f03_func_info_get_flags(xc_info).ge.
     $            XC_FLAGS_NEEDS_LAPLACIAN) mgga=2
c     call xc_f03_hyb_cam_coef(xc_info,xx1,xx2,xx3)
c     write(6,*) trim(cdft),xx1,xx2,xx3
             endif
#endif
             if(c2.eq.'lr'.or.c2.eq.'sr') then
               if(trim(cdft).ne.'lrhfx'.and.trim(cdft).ne.'srhfx') then
                comega=getomega(minpfile)
                rsh=c2 // '      '
                c2='  '
                cdft=adjustl(cdft)
               else
                omega=getomega(minpfile)
               endif
             endif
             if(trim(cdft).eq.'hfx') then
              chfx=-temp
             else if(trim(cdft).eq.'lrhfx') then
              clrhfx=-temp
             else if(trim(cdft).eq.'srhfx') then
              csrhfx=-temp
             else if(trim(cdft).eq.'mp2') then
              cmp2=temp
              dhyb=1
             else if(trim(cdft).eq.'mp2s') then
              cmp2s=temp
              dhyb=1
             else if(trim(cdft).eq.'mp2t') then
              cmp2t=temp
              dhyb=1
             else if(trim(cdft).eq.'drpa') then
              cdrpa=temp
              dhyb=1
             else if(trim(cdft).eq.'drpae') then
              cdrpae=temp
              dhyb=1
             else if(trim(cdft).eq.'drpas') then
              cdrpas=temp
              dhyb=1
             else if(trim(cdft).eq.'drpat') then
              cdrpat=temp
              dhyb=1
             else if(trim(cdft).eq.'sosex') then
              csosex=temp
              dhyb=1
             else if(trim(cdft).eq.'sosexs') then
              csosexs=temp
              dhyb=1
             else if(trim(cdft).eq.'sosext') then
              csosext=temp
              dhyb=1
             else if(trim(cdft).eq.'vv10nl'.or.trim(cdft).eq.'vv10')then
              lnl=.true.
             endif
           enddo
           if(trim(dft).eq.'userd') then
            read(minpfile,*) n
            fhfx=0.d0
            lfhfx=.false.
             do i=1,n
              read(minpfile,*) temp,cdft
              cdft=adjustl(cdft)
              call lowercase(cdft,cdft,32)
#if defined (LIBXC)
              call libxcconv(cdft)
               if(xc_f03_functional_get_number(cdft).gt.0) then
                call xc_f03_func_init(xc_func,
     $xc_f03_functional_get_number(cdft),XC_UNPOLARIZED)
                xc_info=xc_f03_func_get_info(xc_func)
                 if(
     $xc_f03_func_info_get_family(xc_info).eq.XC_FAMILY_MGGA.or.
     $xc_f03_func_info_get_family(xc_info).eq.XC_FAMILY_HYB_MGGA) mgga=1
                call xc_f03_func_end(xc_func)
                 if(xc_f03_func_info_get_flags(xc_info).ge.
     $              XC_FLAGS_NEEDS_LAPLACIAN) mgga=2
               endif
#endif
               if(c2.eq.'lr'.or.c2.eq.'sr') then
                 if(trim(cdft).ne.'lrhfx'.and.trim(cdft).ne.'srhfx')then
                  comega=getomega(minpfile)
                  rsh=c2 // '      '
                  c2='  '
                  cdft=adjustl(cdft)
                 else
                  fomega=getomega(minpfile)
                 endif
               endif
               if(trim(cdft).eq.'hfx') then
                fhfx=-temp
               else if(trim(cdft).eq.'lrhfx') then
                flrhfx=-temp
               else if(trim(cdft).eq.'srhfx') then
                fsrhfx=-temp
               else if(trim(cdft).eq.'mp2') then
                cmp2=temp
                dhyb=1
               else if(trim(cdft).eq.'mp2s') then
                cmp2s=temp
                dhyb=1
               else if(trim(cdft).eq.'mp2t') then
                cmp2t=temp
                dhyb=1
               else if(trim(cdft).eq.'drpa') then
                cdrpa=temp
                dhyb=1
               else if(trim(cdft).eq.'drpae') then
                cdrpae=temp
                dhyb=1
               else if(trim(cdft).eq.'drpas') then
                cdrpas=temp
                dhyb=1
               else if(trim(cdft).eq.'drpat') then
                cdrpat=temp
                dhyb=1
               else if(trim(cdft).eq.'sosex') then
                csosex=temp
                dhyb=1
               else if(trim(cdft).eq.'sosexs') then
                csosexs=temp
                dhyb=1
               else if(trim(cdft).eq.'sosext') then
                csosext=temp
                dhyb=1
               else if(trim(cdft).eq.'vv10nl'.or.trim(cdft).eq.'vv10')
     $then
                lnl=.true.
               endif
             enddo
           endif
#if defined (LIBXC)
         else if(trim(dft).eq.'m06-2x') then
          write(iout,*) 'Density functional: M06-2X'
          chfx=-0.54d0
          mgga=1
         else if(trim(dft).eq.'m06-hf') then
          write(iout,*) 'Density functional: M06-HF'
          chfx=-1.d0
          mgga=1
         else if(trim(dft).eq.'m08-hx') then
          write(iout,*) 'Density functional: M08-HX'
          mgga=1
          chfx=-0.5223d0
         else if(trim(dft).eq.'m08-so') then
          write(iout,*) 'Density functional: M08-SO'
          mgga=1
          chfx=-0.5679d0
         else if(trim(dft).eq.'m06-l') then
          write(iout,*) 'Density functional: M06-L'
          mgga=1
         else if(trim(dft).eq.'tpss') then
          write(iout,*) 'Density functional: TPSS'
          mgga=1
         else if(trim(dft).eq.'revtpss') then
          write(iout,*) 'Density functional: revTPSS'
          mgga=1
         else if(trim(dft).eq.'scan') then
          write(iout,*) 'Density functional: SCAN'
          mgga=1
         else if(trim(dft).eq.'scan0') then
          write(iout,*) 'Density functional: SCAN0'
          chfx=-0.25d0
          mgga=1
         else if(trim(dft).eq.'revscan') then
          write(iout,*) 'Density functional: revSCAN'
          mgga=1
         else if(trim(dft).eq.'revscan0') then
          write(iout,*) 'Density functional: revSCAN0'
          chfx=-0.25d0
          mgga=1
         else if(trim(dft).eq.'cam-b3lyp') then
          write(iout,*) 'Density functional: ' //
     $'Coulomb-attenuating B3LYP functional (CAM-B3LYP)'
          chfx=-0.19d0
          clrhfx=-0.46d0
          omega=0.33d0
         else if(trim(dft).eq.'m11') then
          write(iout,*) 'Density functional: M11'
          chfx=-1.d0
          csrhfx=0.572d0
          omega=0.25d0
          mgga=1
         else if(trim(dft).eq.'mn12-sx') then
          write(iout,*) 'Density functional: MN12-SX'
          csrhfx=-0.25d0
          omega=0.11d0
          mgga=1
         else if(trim(dft).eq.'mn15') then
          write(iout,*) 'Density functional: MN15'
          chfx=-0.44d0
          mgga=1
         else if(trim(dft).eq.'wb97') then
          write(iout,*) 'Density functional: wB97'
          clrhfx=-1.d0
          omega=0.4d0
         else if(trim(dft).eq.'wb97x') then
          write(iout,*) 'Density functional: wB97X'
          chfx=-0.157706d0
          clrhfx=-0.842294d0
          omega=0.3d0
         else if(trim(dft).eq.'wb97x-v') then
          write(iout,*) 'Density functional: wB97X-V'
          chfx=-0.167d0
          clrhfx=-0.833d0
          omega=0.3d0
          lnl=.true.
         else if(trim(dft).eq.'b97m-v') then
          write(iout,*) 'Density functional: B97M-V'
          lnl=.true.
          mgga=1
         else if(trim(dft).eq.'wb97m-v') then
          write(iout,*) 'Density functional: wB97M-V'
          chfx=-0.15d0
          clrhfx=-0.85d0
          omega=0.3d0
          lnl=.true.
          mgga=1
         else if(trim(dft).eq.'hse06') then
          write(iout,*) 'Density functional: ' //
     $'HSE06 functional of Heyd, Scuseria, and Ernzerhof'
          csrhfx=-0.25d0
          omega=0.11d0
         else if(trim(dft).eq.'lc-wpbe') then
          write(iout,*) 'Density functional: ' //
     $'LC-wPBE functional of Vydrov and Scuseria'
          clrhfx=-1.d0
          omega=0.4d0
         else if(trim(dft).eq.'dsdpbehb95') then
          write(iout,*) 'Density functional: DSDPBEhB95'
          chfx=-0.66d0
          cmp2s=0.47d0
          cmp2t=0.09d0
          dhyb=1
          mgga=1
         else if(trim(dft).eq.'scan0-2') then
          write(iout,*) 'Density functional: SCAN0-2'
          chfx=-0.793701d0
          cmp2=0.5d0
          dhyb=1
          mgga=1
         else if(xc_f03_functional_get_number(dft).gt.0) then
          call xc_f03_func_init(xc_func,
     $xc_f03_functional_get_number(dft),XC_UNPOLARIZED)
          xc_info=xc_f03_func_get_info(xc_func)
          info=xc_f03_func_info_get_name(xc_info)
          chfx=xc_f03_hyb_exx_coef(xc_func)
           if(
     $xc_f03_func_info_get_family(xc_info).eq.XC_FAMILY_MGGA.or.
     $xc_f03_func_info_get_family(xc_info).eq.XC_FAMILY_HYB_MGGA) mgga=1
          call xc_f03_func_end(xc_func)
          chfx=-chfx
           if(xc_f03_func_info_get_flags(xc_info).ge.
     $XC_FLAGS_NEEDS_LAPLACIAN) mgga=2
          write(iout,*) 'Density functional: ' // trim(info)
#endif
         else if(trim(bfbasis).ne.'none'.or.trim(grdens).ne.'off'.or.
     $lpssp) then
          chfx=-1.d0
         else
          write(iout,*) 'Unknown density functional!'
          call mrccend(1)
         endif
        if(embed.ne.'        ') chfx=-1.d0
        write(iout,*) 'Constructing integration grid for DFT...'
        write(aagrid,"(i6)") nagrid
         if(lll) then
           if(nlgrid.eq.1) then
            write(iout,*) 'Angular integration grid: ' // 
     $trim(adjustl(aagrid)) // '-point Lebedev quadrature'
           else
            write(iout,*) 'Angular integration grid: adaptive ' // 
     $trim(adjustl(aagrid)) // '-point Lebedev quadrature'
           endif
         else
          write(iout,*) 'Angular integration grid: ' // agrid
         endif
        call getkey('rgrid',5,rgrid,6)
         if(rgrid.eq.'em    ') then
          write(iout,*) 'Radial integration grid: ' // 
     $'Euler-Maclaurin quadrature'
         else if (rgrid.eq.'gc    ') then
          write(iout,*) 'Radial integration grid: ' // 
     $'Gauss-Chebyshev quadrature'
         else
          write(iout,*) 'Radial integration grid: Log3 quadrature'
         endif
        iagrid=dblalloc(3*nagrid*nlgrid)
        iaweight=dblalloc(nagrid*nlgrid)
        ip=dblalloc(natoms)
        ivprim=dblalloc(nprimmax)
        isgrid=dblalloc(3*nleb(maxleb))
        idvec=dblalloc(nbasis*nagrid)
        iragr=dblalloc(natoms)
        iatcl=intalloc(natoms)
        call ishell('rm -f mrdftgrid.*')
        call dftgrid(nagrid,agrid,dcore(iagrid),dcore(iaweight),natoms,
     $atnumt,coord,dcore(imem),distc,dcore(ip),rgrid,ngrid,nlgrid,nleb,
     $nagridmin,maxleb,nangmax,ncontrmax,nprimmax,ncartmax,nsphermax,
     $nang,ncontr,nprim,gexp,gcoef,dcore(ictostr),cartg,dcore(ivprim),
     $dcore(isgrid),dcore(idvec),atsymbol,basname,cdmrcc,nangmin,
     $dcore(iragr),icore(iatcl),gcn,natrange,lnl,nbfatmax,aleb)
        call ishell('rm -f mrdftgrid.*')
        call dbldealloc(iagrid)
         if(omega.ne.0.d0)
     $write(iout,"(' Range-separation parameter:',f7.4)") omega
         if(.not.lfhfx.and.fomega.ne.0.d0)
     $write(iout,"(' Final range-separation parameter:',f7.4)") fomega
         if(comega.ne.0.d0) write(iout,"(
     $' Range-separation parameter for correlation:',f7.4)") comega
        call timer
       endif
       if(lfhfx) then
        fhfx=chfx
        flrhfx=clrhfx
        fsrhfx=csrhfx
        fomega=omega
       endif
       if(omega.ne.0.d0.or.fomega.ne.0.d0) then
         if(scfalg.eq.'auto    '.or.scfalg.eq.'disk    ') then
          scfalg='direct  '
          call changekey('scfalg',6,scfalg,8)
         endif
        dfalg='lineq   '
        call changekey('dfalg',5,dfalg,8)
        intalg='os  '
        call changekey('intalg',6,intalg,4)
       endif
      write(varsfile) 'chfx      ',ifltln,chfx
      write(varsfile) 'fhfx      ',ifltln,fhfx
      write(varsfile) 'clrhfx    ',ifltln,clrhfx
      write(varsfile) 'flrhfx    ',ifltln,flrhfx
      write(varsfile) 'csrhfx    ',ifltln,csrhfx
      write(varsfile) 'fsrhfx    ',ifltln,fsrhfx
      write(varsfile) 'cmp2      ',ifltln,cmp2
      write(varsfile) 'cmp2s     ',ifltln,cmp2s
      write(varsfile) 'cmp2t     ',ifltln,cmp2t
      write(varsfile) 'cdrpa     ',ifltln,cdrpa
      write(varsfile) 'cdrpae    ',ifltln,cdrpae
      write(varsfile) 'cdrpas    ',ifltln,cdrpas
      write(varsfile) 'cdrpat    ',ifltln,cdrpat
      write(varsfile) 'csosex    ',ifltln,csosex
      write(varsfile) 'csosexs   ',ifltln,csosexs
      write(varsfile) 'csosext   ',ifltln,csosext
      write(varsfile) 'mgga      ',iintln,mgga
      write(varsfile) 'dhyb      ',iintln,dhyb
      write(varsfile) 'omega     ',ifltln,omega
      write(varsfile) 'fomega    ',ifltln,fomega
      write(varsfile) 'comega    ',ifltln,comega
      write(varsfile) 'rsh       ',8,rsh
C Read perturbations
      npert=0
      cpert=0.d0
      call getkey('epert',5,epert,8)
       if(epert.ne.'none    ') then
        call getkeym('epert',5,epert,8)
        read(epert,*) npert
         do i=1,npert
          read(minpfile,*) epert,temp
           if(     trim(epert).eq.'x') then
            j=1
            nuc=nuc-nucdip(1)*temp
           else if(trim(epert).eq.'y') then
            j=2
            nuc=nuc-nucdip(2)*temp
           else if(trim(epert).eq.'z') then
            j=3
            nuc=nuc-nucdip(3)*temp
           else if(trim(epert).eq.'xx') then
            j=4
            nuc=nuc-nucsec(1,1)*temp
           else if(trim(epert).eq.'yy') then
            j=5
            nuc=nuc-nucsec(2,2)*temp
           else if(trim(epert).eq.'zz') then
            j=6
            nuc=nuc-nucsec(3,3)*temp
           else if(trim(epert).eq.'xy') then
            j=7
            nuc=nuc-nucsec(1,2)*temp
           else if(trim(epert).eq.'xz') then
            j=8
            nuc=nuc-nucsec(1,3)*temp
           else if(trim(epert).eq.'yz') then
            j=9
            nuc=nuc-nucsec(2,3)*temp
           else if(trim(epert).eq.'xxx') then
            j=10
            nuc=nuc-nucthi(1,1,1)*temp
           else if(trim(epert).eq.'xxy') then
            j=11
            nuc=nuc-nucthi(1,1,2)*temp
           else if(trim(epert).eq.'xxz') then
            j=12
            nuc=nuc-nucthi(1,1,3)*temp
           else if(trim(epert).eq.'xyy') then
            j=13
            nuc=nuc-nucthi(1,2,2)*temp
           else if(trim(epert).eq.'xyz') then
            j=14
            nuc=nuc-nucthi(1,2,3)*temp
           else if(trim(epert).eq.'xzz') then
            j=15
            nuc=nuc-nucthi(1,3,3)*temp
           else if(trim(epert).eq.'yyy') then
            j=16
            nuc=nuc-nucthi(2,2,2)*temp
           else if(trim(epert).eq.'yyz') then
            j=17
            nuc=nuc-nucthi(2,2,3)*temp
           else if(trim(epert).eq.'yzz') then
            j=18
            nuc=nuc-nucthi(2,3,3)*temp
           else if(trim(epert).eq.'zzz') then
            j=19
            nuc=nuc-nucthi(3,3,3)*temp
           else
            write(iout,*) 'Unknown perturbation!'
            call mrccend(1)
           endif
          cpert(j)=cpert(j)+temp
         enddo
       endif
C Generate the values of the Boys function
      nmboys=max(4*nangmax+6,40)
      icf=dblalloc(nmboys+1)
      iboysval=dblalloc((nmboys+1)*1481)
      call mkboys(dcore(icf),nmboys,dcore(iboysval))
C Calculate one-electron integrals
C One-electron integrals in OEINT
C  1: overlap integrals
C  2: kinetic energy + nuclear attraction integrals + ECP
C Property integrals in PRINT
C  1: Kinetic energy integrals
C  2:   x component of dipole  moment   integrals
C  3:   y component of dipole  moment   integrals
C  4:   z component of dipole  moment   integrals
C  5:  xx component of second  moment   integrals
C  6:  yy component of second  moment   integrals
C  7:  zz component of second  moment   integrals
C  8:  xy component of second  moment   integrals
C  9:  xz component of second  moment   integrals
C 10:  yz component of second  moment   integrals
C 11: xxx component of third   moment   integrals
C 12: xxy component of third   moment   integrals
C 13: xxz component of third   moment   integrals
C 14: xyy component of third   moment   integrals
C 15: xyz component of third   moment   integrals
C 16: xzz component of third   moment   integrals
C 17: yyy component of third   moment   integrals
C 18: yyz component of third   moment   integrals
C 19: yzz component of third   moment   integrals
C 20: zzz component of third   moment   integrals
C 21:   x component of linear  momentum integrals
C 22:   y component of linear  momentum integrals
C 23:   z component of linear  momentum integrals
C 24:   x component of angular momentum integrals
C 25:   y component of angular momentum integrals
C 26:   z component of angular momentum integrals
       if(.not.ldom) then
        write(iout,*)
         if(lebf) then
          write(iout,*) 'Calculation of one-electron integrals...'
C Calculate integrals over elliptical Gaussians
          call ellip(ngrid,scrfile3,dcore,natoms,nangmax,ncontrmax,
     $nprimmax,ncartmax,nsphermax,nang,ncontr,nprim,gexp,gcoef,coord,
     $cartg,dcore(ictostr),nbasis,iout,atnum,iinta,oeintfile,itol,eexp)
         else
C Calculate one-electron integrals over conventional GTOs
          write(iout,*) 'Calculation of overlap integrals...'
          call overla(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
          call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),oeintfile,0.01d0*itol,nbasis)
          call timer
C Calculate the square root of the overlap matrix
           if(ndao.eq.-1.or.(nir.ne.0.and..not.(localcc.ne.'off '.and.  ! if NOT restart with completed SCF and localization
     $orblocguess.eq.'read    '.and.scfiguess.eq.'off '))) then
            write(iout,*)
            write(iout,*)
     $'Calculation of the square root of the overlap matrix...'
            call dcopy(nbasis**2,dcore(imem),1,dcore(imem+nbasis**2),1)
            call fillup(dcore(imem),nbasis)
            call sroot(dcore(imem),nbasis,dcore(imem+2*nbasis**2),iout,
     $scrfile1,scrfile2,itol,dcore(imem+2*nbasis**2+nbasis),
     $dcore(imem+nbasis+3*nbasis**2),nfunc,nfuns,nir,ndao,
     $dcore(imem+nbasis**2)) ! warning: both overlap mx copies are overwritten if ndao>0
            call timer
            write(iout,*)
           endif
          write(varsfile) 'ndao      ',iintln,ndao
          write(varsfile) 'nfuns     ',nir*iintln,nfuns(1:nir)
           if(ndao.gt.0.and.nir.ne.0) then
            itol=0.1d0*itol
            write(cscr4,'(i4)') -idnint(dlog10(itol))
            cscr4=adjustl(cscr4)
            call changekey('itol',4,cscr4,4)
           endif
          write(iout,*) 'Calculation of kinetic energy integrals...'
          call kineti(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
          call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
          call timer
           if(dens.gt.0.or.nstateall.gt.1.or.
     $npert.gt.0.or.lorbloc) then
            write(iout,*) 'Calculation of dipole moment integrals...'
            call dipolx(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
            call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
            call dipoly(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
            call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
            call dipolz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
            call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
            call timer
             if(dens.gt.0.or.nstateall.gt.1.or.
     $npert.gt.0) then
              write(iout,*) 'Calculation of second moment integrals...'
              call secoxx(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call secoyy(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call secozz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call secoxy(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call secoxz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call secoyz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call timer
              write(iout,*) 'Calculation of third moment integrals...'
              call thixxx(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thixxy(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thixxz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thixyy(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thixyz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thixzz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thiyyy(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thiyyz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thiyzz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call thizzz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call timer
             endif
             if(dens.eq.5.or.dens.eq.6.or.
     $nstateall.gt.1.or.npert.gt.0) then
              write(iout,*)'Calculation of linear momentum integrals...'
c             call linea1(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
c    $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
c    $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),
c    $dcore(imem+2*nbasis**2),dcore(imem+3*nbasis**2),gcn,nshrange,
c    $cartg,0,.false.)
c             call woeint(dcore(imem+3*nbasis**2),dcore(imem+
c    $3*nbasis**2),dcore(imem            ),printfile,itol,nbasis)
c             call woeint(dcore(imem+3*nbasis**2),dcore(imem+
c    $3*nbasis**2),dcore(imem+  nbasis**2),printfile,itol,nbasis)
c             call woeint(dcore(imem+3*nbasis**2),dcore(imem+
c    $3*nbasis**2),dcore(imem+2*nbasis**2),printfile,itol,nbasis)
              call lineax(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call lineay(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call lineaz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call timer
          write(iout,*) 'Calculation of angular momentum integrals...'
              call angulx(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call anguly(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call angulz(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis**2),gcn,
     $nshrange,cartg)
              call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,itol,nbasis)
              call timer
             endif
           endif
C Calculate nuclear attraction integrals
          write(iout,*) 'Calculation of nuclear attraction integrals...'
          ihmat=dblalloc(nbasis**2)
          call nucatt(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(ihmat),dcore(imem),gcn,nshrange,cartg,
     $dcore(iboysval),nmboys,dcore(icf),itol,atchg,ncent,coord)
c     write(6,*) 'ihmat'
c     call fillup(dcore(ihmat),nbasis)
c     write(6,"(58f9.5)") dcore(ihmat:ihmat-1+nbasis**2)
c     write(6,*)
          rewind(printfile)
          call roeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),printfile,nbasis)
          call daxpy(nbasis**2,1.d0,dcore(imem),1,dcore(ihmat),1)
          call timer
C Calculate core potential integrals
           if(necpatoms.gt.0) then
            write(iout,*) 'Calculation of core potential integrals...'
            iinti=dblalloc(ncontrmax*nprimmax*nsphermax**2)
            iintj=dblalloc(nprimmax*nsphermax**2)
            iintf=dblalloc(ncontrmax**2*nsphermax**2)
            iints=dblalloc(ncartmax**2)
            iintc=dblalloc(ncartmax*nsphermax)
            call ecpint(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(ihmat),dcore(imem),gcn,nshrange,cartg,
     $itol,necpatoms,ecpn,ecpnang,ecpprim,ecpexp,ecpcoef,ecpatoms,
     $dcore(iinti),dcore(iintj),dcore(iintf),dcore(iints),dcore(iintc),
     $0,0,0)
            call dbldealloc(iinti)
            call timer
           endif
          call woeint(dcore(ihmat+nbasis**2),dcore(ihmat+nbasis**2),
     $dcore(ihmat),oeintfile,itol,nbasis)
          call dbldealloc(ihmat)
C Add perturbations
           if(npert.gt.0) then
            rewind(oeintfile)
            read(oeintfile)
            call roeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),oeintfile,nbasis)
            rewind(printfile)
            read(printfile)
             do i=1,maxint
               if(dabs(cpert(i)).eq.0.d0) then
                read(printfile)
               else
                call roeint(dcore(imem+2*nbasis**2),
     $dcore(imem+2*nbasis**2),dcore(imem+nbasis**2),printfile,nbasis)
                call daxpy(nbasis**2,cpert(i),dcore(imem+nbasis**2),1,
     $dcore(imem),1)
               endif
             enddo
            backspace(oeintfile)
            call woeint(dcore(imem+nbasis**2),dcore(imem+nbasis**2),
     $dcore(imem),oeintfile,itol,nbasis)
           endif
C Calculate overlap matrices for IAOs
           if(popul.eq.'iao     '.or.lrest) then
            write(iout,*) 'Calculation of overlap integrals...'
             if(popul.eq.'iao     ') then
              open(scrfile1,file='S12MAT',form='unformatted')
              call overla(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang(1,4),nangmin,ncontr(0,1,4),nprim(0,1,4),
     $gexp(1,0,1,4),gcoef(1,1,0,1,4),coord,dcore(ictostr),nbf(4),
     $dcore(imem),dcore(imem+nbf(4)**2),gcn(1,1,0,1,4),
     $nshrange(1,0,1,4),cartg)
            call invsqrt(dcore(imem),nbf(4),dcore(imem+nbf(4)**2),iout,
     $i,0.d0,1)
               if(i.ne.0) call mrccend(1)
              call woeint(dcore(imem+nbf(4)**2),dcore(imem+nbf(4)**2),
     $dcore(imem),scrfile1,itol,nbf(4))
              call overld(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis*nbf(4)),gcn,
     $nshrange,cartg,nang(1,4),ncontr(0,1,4),nprim(0,1,4),gexp(1,0,1,4),
     $gcoef(1,1,0,1,4),gcn(1,1,0,1,4),nshrange(1,0,1,4))
              call wtdmx(dcore(imem+nbasis*nbf(4)),
     $dcore(imem+nbasis*nbf(4)),dcore(imem),scrfile1,itol,nbasis,nbf(4))
              close(scrfile1)
             endif
C Calculate overlap matrices for SCF restart
             if(lrest) then
              call overld(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $nsphermax,nang,nangmin,ncontr,nprim,gexp,gcoef,coord,
     $dcore(ictostr),nbasis,dcore(imem),dcore(imem+nbasis*nbf(5)),gcn,
     $nshrange,cartg,nang(1,5),ncontr(0,1,5),nprim(0,1,5),gexp(1,0,1,5),
     $gcoef(1,1,0,1,5),gcn(1,1,0,1,5),nshrange(1,0,1,5))
              open(scrfile1,file='S12MATold',form='unformatted')
              call wtdmx(dcore(imem+nbasis*nbf(5)),
     $dcore(imem+nbasis*nbf(5)),dcore(imem),scrfile1,itol,nbasis,nbf(5))
              close(scrfile1)
             endif
            call timer
           endif
         endif
       endif
C Allocate memory for two-electron integral calculation
      ipre =dblalloc((nangmax+1)**2*natoms**2)
      ispre=dblalloc((nangmax+1)**2*natoms**2)
      inzipr=intalloc(nprimmax+1)
      inzjpr=intalloc(nprimmax+1)
      inzkpr=intalloc(nprimmax+1)
      inzlpr=intalloc(nprimmax+1)
      inzint=intalloc(nbfshmax**2)
      iintpos=intalloc(3*(nbasis+1)*nbasis/2)
      iintpostc=iintpos
       if(dens.gt.0.and.dfbasis_cor.ne.'none                ') 
     $iintpostc=intalloc(3*(nbasis+1)*nbasis/2)
      ithad=intalloc((nangmax+1)*(2*nangmax+2)*(2*nangmax+1)**2)
      ithcf2=dblalloc(3*(nangmax+1)**2*natoms**2)
      iscoord=dblalloc(3*(natoms**2)*(nangmax+2))
      irqqij=dblalloc((4*nangmax+1)*nprimmax**2)
      irqqkl=dblalloc((4*nangmax+1)*nprimmax**2)
      ihrec=dblalloc(4*nangmax*nprimmax*(nangmax+1)*natoms)
C Calculate prescreening integrals
       if(.not.ldom.or..not.localcc15p(localcc).or.
     $trim(ccprog).eq.'cis') then !NP
         if(route.eq.'gues') then !szemet
          dcore(ipre:ipre+(nangmax+1)**2*natoms**2-1)=1.d0
         else
          write(iout,*)
          write(iout,*) 'Calculation of prescreening integrals...'
          call teint(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,gcoef,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,indarr,
     $tedatfile,nbasis,gcn,dcore(imem),dcore(ipre),0,0.d0,
     $icore(inzipr),icore(inzjpr),icore(inzkpr),icore(inzlpr),nbfshmax,
     $icore(inzint),nshrange,icore(iintpos),iout,dcore,dcore,
     $dcore,dcore,dcore,dcore,'     ',imem1,maxcor,icore(ithad),
     $dcore(ithcf2),dcore(iscoord),dcore(irqqij),dcore(irqqkl),
     $dcore(ihrec),0,1,dcore,dcore,dcore,dcore,chfx,
     $eexp,ebf,nangmin,dcore(ispctostr),i,i,i,0.d0,rhffock,uhffock,boys)
         endif
        call cipra(dcore(imem),dcore(ipre),natoms,nang,nangmax,varsfile,
     $ifltln)
        call timer
       endif
C Calculate maximal elements of overlap matrix for prescreening
      itcdfint=dblalloc(nbasis**2)
      rewind(oeintfile)
      call roeint(dcore(imem),dcore(imem),dcore(itcdfint),oeintfile,
     $nbasis)
      call sspre(dcore(ispre),natoms,nangmax,ncontrmax,nsphermax,
     $cartg,indarr,nang,ncontr,dcore(itcdfint),nbasis)
      call dbldealloc(itcdfint)
C Calculate two-electron integrals
      write(iout,*)
      lseqc=.false.
      call getkey('naf_scf',7,naf_scf,16)
      call getkey('naf_cor',7,naf_cor,16)
       if(ldom.and.naf_cor.ne.'off             '.and..not.laibj.and.
     $.not.localcc15p(localcc).and.trim(ccprog).ne.'cis') then
        lnaf=.true.
        read(naf_cor,*) naftol
       else if(.not.ldom.and.naf_scf.ne.'off             ') then
        lnaf=.true.
        read(naf_scf,*) naftol
       else
        lnaf=.false.
        naftol=0.d0
       endif
c     dofit=dens.gt.0.or..not.(ldom.and.((localcc.ne.'off '.and.lrpa)
c    $.or.ccalc.eq.'mp2             '.or.ccalc.eq.'drpa            '
c    $.or.ccalc.eq.'sosex           '
c    $.or.naf_cor.ne.'off             '))
      dofit=(dens.gt.0.or..not.(ldom.and.((localcc.ne.'off '.and.lrpa)
     $.or.laibj).and.(naf_cor.eq.'off             '.or.laibj)).or.
     $trim(ccprog).eq.'cis').and.route.ne.'rsht'.and.route.ne.'rsh '
      fulltc=trim(scfalg).eq.'disk'.or.dfalg.ne.'lineq   '
      if(ldom.and.(trim(ccprog).eq.'cis'.and.trim(cialg).ne.'disk').or.
     $   ldom.and.(localcc.ne.'2015'.and.localcc15p(localcc).and.
     $nstateall.le.1)) then !NP
       if(trim(ccalc).eq.'scf'.or.trim(ccalc).eq.'cis'.or.
     $localcc.ne.'off ') then
        fulltc=.false.
       endif
       dfalg='lineq   '
       call changekey('dfalg',5,dfalg,8)
      endif
       if(route.eq.'rsh '.or.route.eq.'rsht') fulltc=.false.
       if((dfbasis_scf.ne.'none                '.and..not.ldom.and.
     $scfiguess.ne.'off    ').or.
     $    (dfbasis_cor.ne.'none                '.and.ldom)) then
        idfn=2
         if(ldom) idfn=3
         if(fulltc) then
          itcdfint=dblalloc(nbf(idfn)**2)
         else
          itcdfint=dblalloc((nbf(idfn)+1)*nbf(idfn)/2)
         endif
         if(lnaf) then
          iwnaf=dblalloc(nbf(idfn)**2)
          call dfillzero(dcore(iwnaf),nbf(idfn)**2)
         else
          iwnaf=itcdfint
         endif
        idfipre=dblalloc((nangmax+1)*natoms)
        idfipra=dblalloc(natoms)
        ilogkc=intalloc((nangmax+1)*natoms)
        idfrqq=dblalloc((4*nangmax+1)*nprimmax*(nangmax+1)*natoms)
        inquire(file='DOMAIN',exist=lll)
C Two-center Coulomb integrals for DF
        write(iout,*) 'Calculation of two-center Coulomb integrals...'
         if(ldom.and.rsh.eq.'lr      ') then
          call df2int(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,1,0.00001d0*itol,
     $nshrange(1,0,1,idfn),iout,imem1,maxcor,icore(ithad),dcore(ithcf2),
     $dcore(iscoord),dcore(irqqij),dcore(irqqkl),0,1,nang(1,idfn),
     $ncontr(0,1,idfn),nprim(0,1,idfn),gexp(1,0,1,idfn),
     $gcn(1,1,0,1,idfn),dcore(idfrqq),nbf(idfn),gcoef(1,1,0,1,idfn),
     $indarr(1,0,1,1,idfn),dcore(itcdfint),dcore(idfipre),varsfile,
     $ifltln,ldom,scrfile3,dcore(itcdfint),dcore(ispctostr),.true.,
     $dcore(idfipra),tcmax,fulltc,dcore(itcdfint),comega,boyslr)
         else if(ldom.and.rsh.eq.'sr      ') then
          call df2int(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,1,0.00001d0*itol,
     $nshrange(1,0,1,idfn),iout,imem1,maxcor,icore(ithad),dcore(ithcf2),
     $dcore(iscoord),dcore(irqqij),dcore(irqqkl),0,1,nang(1,idfn),
     $ncontr(0,1,idfn),nprim(0,1,idfn),gexp(1,0,1,idfn),
     $gcn(1,1,0,1,idfn),dcore(idfrqq),nbf(idfn),gcoef(1,1,0,1,idfn),
     $indarr(1,0,1,1,idfn),dcore(itcdfint),dcore(idfipre),varsfile,
     $ifltln,ldom,scrfile3,dcore(itcdfint),dcore(ispctostr),.true.,
     $dcore(idfipra),tcmax,fulltc,dcore(itcdfint),comega,boyssr)
         else
          call df2int(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,1,0.00001d0*itol,
     $nshrange(1,0,1,idfn),iout,imem1,maxcor,icore(ithad),dcore(ithcf2),
     $dcore(iscoord),dcore(irqqij),dcore(irqqkl),0,1,nang(1,idfn),
     $ncontr(0,1,idfn),nprim(0,1,idfn),gexp(1,0,1,idfn),
     $gcn(1,1,0,1,idfn),dcore(idfrqq),nbf(idfn),gcoef(1,1,0,1,idfn),
     $indarr(1,0,1,1,idfn),dcore(itcdfint),dcore(idfipre),varsfile,
     $ifltln,ldom,scrfile3,dcore(itcdfint),dcore(ispctostr),.true.,
     $dcore(idfipra),tcmax,fulltc,dcore(itcdfint),0.d0,boys)
         endif
c     write(6,*) fulltc,dofit
c     write(6,"(8f10.5)") dcore(itcdfint:itcdfint-1+nbf(idfn)**2)
        call timer
        write(iout,*)
         if((trim(scfalg).eq.'disk'.and..not.ldom).or.(ldom.and.
     $.not.(lrpa.and.localcc.ne.'off '.or.trim(ccprog).eq.'cis')).or.
     $(ldom.and.trim(ccprog).eq.'cis'.and.(cialg.eq.'disk    '.or.(
     $(trim(ccalc).ne.'cis'.and.trim(ccalc).ne.'scf'.and.
     $localcc.eq.'off '))))) then
           if(route.eq.'rsh ') then
C Calculate the Cholesky deco of the two-center matrix
            write(iout,*) 'Cholesky decomposition of the '//
     $'two-center matrix...'
            call dpptrf('L',nbf(idfn),dcore(itcdfint),info4)
             if(info4.ne.0) then
              write(iout,*)
     $'Fatal error at the Cholesky decomposition!'
              call mrccend(1)
             endif
            open(scrfile3,file='DFINV',form='unformatted')
            write(scrfile3) (dcore(itcdfint-1+i),
     $i=1,(nbf(idfn)+1)*nbf(idfn)/2)
            close(scrfile3)
            call timer
            write(iout,*)
           else if(dofit.and.(ldom.or.naf_scf.eq.'off             ')
     $.and.(.not.ldom.or.naf_cor.eq.'off             ').and.
     $(.not.ldom.or.ccprog.ne.'cis ')) then
C Calculate the inverse square root of the two-center integral matrix
            isqrt=1
            write(iout,*) 'Calculation of inverse square root ' //
     $'of the two-center integral matrix...'
            call invsqrt(dcore(itcdfint),nbf(idfn),dcore(imem),iout,i,
     $1d-12,1)
             if(i.ne.0) call mrccend(1)
             if(dens.gt.0) then
              open(scrfile3,file='DFINV',form='unformatted')
              write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
c             call woeint(dcore(imem),dcore(imem),dcore(itcdfint),
c    $scrfile3,itol,nbf(idfn))
              close(scrfile3)
             endif
            call timer
            write(iout,*)
           else if((route.ne.'rsht'.and.ldom.and.(ccprog.eq.'cis '.or.
     $(localcc.eq.'off '.and.
     $                         (ccalc.eq.'mp2             '.or.
     $                          ccalc.eq.'drpa            '.or.
     $                          ccalc.eq.'sosex           '.or.
     $                          naf_cor.ne.'off             ')))).or.
     $             (.not.ldom.and.naf_scf.ne.'off             ')) then
            isqrt=3
            call getkey('drpaalg',7,drpaalg,8)
             if(drpaalg.eq.'auto    '.and.localcc.eq.'off ') then
               if(nelec-2*ncore.gt.180) then
                drpaalg='nofit   '
               else
                drpaalg='fit     '
               endif
              call changekey('drpaalg',7,drpaalg,8)
             endif
             if(drpaalg.eq.'fit     '.or.drpaalg.eq.'plasmon '.or.
     $ccprog.eq.'cis ') then
C Calculate the Cholesky deco of the inverse of the two-center matrix
              write(iout,*) 'Cholesky decomposition of the inverse of '
     $// 'the two-center matrix...'
C
               if(ccprog.eq.'cis '.and.cialg.ne.'disk    ') then
                if(4*nbf(idfn)+(nbf(idfn)+1)*nbf(idfn)/2.le.
     $maxcor-(imem-imem1)) then
C
                 ii=-1
                 do j=1,nbf(idfn)
                  do i=j,nbf(idfn)
                   ii=ii+1
                   dcore(imem+ii)=dcore(itcdfint-1+nbf(idfn)*(j-1)+i)
                  enddo
                 enddo
C
                 open(scrfile3,file='DFINV_CIS',form='unformatted')
                  call dpptrf('L',nbf(idfn),dcore(imem),info4)
                   if(info4.ne.0) then
                    write(iout,*) 
     $'Fatal error at the Cholesky decomposition!'
                    call mrccend(1)
                   endif
                  write(scrfile3) (dcore(imem-1+i),
     $i=1,(nbf(idfn)+1)*nbf(idfn)/2)
                  call dtpcon('1','L','N',nbf(idfn),dcore(imem),tmp,
     $dcore(imem+(nbf(idfn)+1)*nbf(idfn)/2+nbf(idfn)),
     $icore(imem+(nbf(idfn)+1)*nbf(idfn)/2),info4)
                  write(iout,
     $"(' Reciprocal of the condition number: ',e13.6)"),tmp
                   if(dabs(tmp).lt.1d-6) then
          write(iout,*)
     $'Warning! Ill-conditioned two-center integral matrix.'
          write(iout,*) 'This may result in convergence problems.'
                   endif
                 close(scrfile3)
                else
C
                 open(scrfile3,file='DFINT_SCR',form='unformatted')
                 write(scrfile3) dcore(itcdfint:itcdfint+nbf(idfn)**2-1)
                 close(scrfile3)
                 call dpotrf('L',nbf(idfn),dcore(itcdfint),
     $nbf(idfn),info4)
                 if(info4.ne.0) then
                  write(iout,*) 
     $'Fatal error at the Cholesky decomposition!'
                  call mrccend(1)
                 endif
                 open(scrfile3,file='DFINV_CIS',form='unformatted')
                  write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
c           call woeint(dcore(imem),dcore(imem),dcore(itcdfint),
c    $scrfile3,itol,nbf(idfn))
                 close(scrfile3)
                 open(scrfile3,file='DFINT_SCR',form='unformatted')
                  read(scrfile3) dcore(itcdfint:itcdfint+nbf(idfn)**2-1)
                 close(scrfile3,status='delete')
C
                endif
               endif
C
              call invsqrt(dcore(itcdfint),nbf(idfn),dcore(imem),iout,i,
     $1d-12,4)
               if(i.ne.0) call mrccend(1)
              call dpotrf('L',nbf(idfn),dcore(itcdfint),nbf(idfn),info4)
               if(info4.ne.0) then
                write(iout,*)
     $'Fatal error at the Cholesky decomposition!'
                call mrccend(1)
               endif
             else
              write(iout,*) 
     $'Calculation of the inverse of the two-center integral matrix...'
              call syminv(dcore(itcdfint),dcore(itcdfint),nbf(idfn),
     $nbf(idfn),dcore(imem))
             endif
            open(scrfile3,file='DFINV',form='unformatted')
            write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
c           call woeint(dcore(imem),dcore(imem),dcore(itcdfint),
c    $scrfile3,itol,nbf(idfn))
            close(scrfile3)
            call timer
            write(iout,*)
           else
C Save two-center Coulomb integrals
c            if(.not.ldom.and.naf_scf.ne.'off             ') isqrt=3
             if(route.eq.'rsht') then
               open(scrfile3,file='DFINT_PQ_RS',form='unformatted')
             else
               open(scrfile3,file='DFINT',form='unformatted')
             endif
             if(fulltc) then
              write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
             else
              write(scrfile3) (dcore(itcdfint-1+i),
     $i=1,(nbf(idfn)+1)*nbf(idfn)/2)
             endif
c           call woeint(dcore(imem),dcore(imem),dcore(itcdfint),
c    $scrfile3,itol,nbf(idfn))
            close(scrfile3)
           endif
C Three-center Coulomb integrals for DF
          write(iout,*) 
     $'Calculation of three-center Coulomb integrals...'
          lexc=.false.
          igck=dblalloc(nprimmax*ncontrmax*(nangmax+1)*natoms) ! rescaled primitive contraction matrices for the fitting functions
          ikp=intalloc(nprimmax*(nangmax+1)*natoms) ! mark uncontracted fitting functions
           if(ldom.and.rsh.eq.'lr      ') then
            call df3int(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,gcoef,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,indarr,
     $tedatfile,nbasis,gcn,dcore(imem),dcore(ipre),1,itol,nbfshmax,
     $nshrange,icore(iintpos),iout,
     $dcore,dcore,dcore,dcore,'     ',imem1,maxcor,icore(ithad),
     $dcore(ithcf2),dcore(iscoord),dcore(irqqij),dcore(irqqkl),
     $dcore(ihrec),0,1,nang(1,idfn),ncontr(0,1,idfn),
     $nprim(0,1,idfn),gexp(1,0,1,idfn),gcn(1,1,0,1,idfn),
     $nbf(idfn),gcoef(1,1,0,1,idfn),indarr(1,0,1,1,idfn),dcore(imem),
     $dcore(itcdfint),dcore(idfipre),dcore,dcore,icore,1,dcore,i,i,i,i,
     $i,i,i,i,itol,scrfile3,dcore(ispctostr),1,1,dcore,
     $.false.,lexc,scrfile4,chfx,dofit,isqrt,dens,icore(iintpostc),
     $lnaf,naftol,dcore(iwnaf),0,i,i,i,i,i,i,i,dcore,i,i,i,i,0,dcore,1,
     $.false.,dcore,.false.,i,natrange(1,1,idfn),
     $i,i,i,i,i,i,i,i,i,dcore,i,dcore,dcore,dcore,dcore,dcore,
     $dcore(ispre),dcore(idfipra),tcmax,icore(ilogkc),icore(ikp),
     $dcore(igck),dcore,0,0,i,i,i,i,i,i,natrange,i,i,i,0,icore,
     $comega,boyslr,1,dcore,i,i,i,.false.,dcore,i,dcore,i,dcore,
     $dcore,i,nangmin,.true.,i,i,r,r,r,r,r,r,r,r,r,r,r,'off     ',i,
     $.false.,dcore,.false.)
           else if(ldom.and.rsh.eq.'sr      ') then
            call df3int(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,gcoef,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,indarr,
     $tedatfile,nbasis,gcn,dcore(imem),dcore(ipre),1,itol,nbfshmax,
     $nshrange,icore(iintpos),iout,
     $dcore,dcore,dcore,dcore,'     ',imem1,maxcor,icore(ithad),
     $dcore(ithcf2),dcore(iscoord),dcore(irqqij),dcore(irqqkl),
     $dcore(ihrec),0,1,nang(1,idfn),ncontr(0,1,idfn),
     $nprim(0,1,idfn),gexp(1,0,1,idfn),gcn(1,1,0,1,idfn),
     $nbf(idfn),gcoef(1,1,0,1,idfn),indarr(1,0,1,1,idfn),dcore(imem),
     $dcore(itcdfint),dcore(idfipre),dcore,dcore,icore,1,dcore,i,i,i,i,
     $i,i,i,i,itol,scrfile3,dcore(ispctostr),1,1,dcore,
     $.false.,lexc,scrfile4,chfx,dofit,isqrt,dens,icore(iintpostc),
     $lnaf,naftol,dcore(iwnaf),0,i,i,i,i,i,i,i,dcore,i,i,i,i,0,dcore,1,
     $.false.,dcore,.false.,i,natrange(1,1,idfn),
     $i,i,i,i,i,i,i,i,i,dcore,i,dcore,dcore,dcore,dcore,dcore,
     $dcore(ispre),dcore(idfipra),tcmax,icore(ilogkc),icore(ikp),
     $dcore(igck),dcore,0,0,i,i,i,i,i,i,natrange,i,i,i,0,icore,
     $comega,boyssr,1,dcore,i,i,i,.false.,dcore,i,dcore,i,dcore,
     $dcore,i,nangmin,.true.,i,i,r,r,r,r,r,r,r,r,r,r,r,'off     ',i,
     $.false.,dcore,.false.)
           else
            call df3int(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,gcoef,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,indarr,
     $tedatfile,nbasis,gcn,dcore(imem),dcore(ipre),1,itol,nbfshmax,
     $nshrange,icore(iintpos),iout,
     $dcore,dcore,dcore,dcore,'     ',imem1,maxcor,icore(ithad),
     $dcore(ithcf2),dcore(iscoord),dcore(irqqij),dcore(irqqkl),
     $dcore(ihrec),0,1,nang(1,idfn),ncontr(0,1,idfn),
     $nprim(0,1,idfn),gexp(1,0,1,idfn),gcn(1,1,0,1,idfn),
     $nbf(idfn),gcoef(1,1,0,1,idfn),indarr(1,0,1,1,idfn),dcore(imem),
     $dcore(itcdfint),dcore(idfipre),dcore,dcore,icore,1,dcore,i,i,i,i,
     $i,i,i,i,itol,scrfile3,dcore(ispctostr),1,1,dcore,
     $.false.,lexc,scrfile4,chfx,dofit,isqrt,dens,icore(iintpostc),
     $lnaf,naftol,dcore(iwnaf),0,i,i,i,i,i,i,i,dcore,i,i,i,i,0,dcore,1,
     $.false.,dcore,.false.,i,natrange(1,1,idfn),
     $i,i,i,i,i,i,i,i,i,dcore,i,dcore,dcore,dcore,dcore,dcore,
     $dcore(ispre),dcore(idfipra),tcmax,icore(ilogkc),icore(ikp),
     $dcore(igck),dcore,0,0,i,i,i,i,i,i,natrange,i,i,i,0,icore,
     $0.d0,boys,1,dcore,i,i,i,.false.,dcore,i,dcore,i,dcore,
     $dcore,i,nangmin,.true.,i,i,r,r,r,r,r,r,r,r,r,r,r,'off     ',i,
     $.false.,dcore,.false.)
           endif
          call dbldealloc(igck)
          dfnbasis=nbf(idfn)
          call timer
         else
C Save two-center Coulomb integrals
          open(scrfile3,file='DFINT',form='unformatted')
           if(fulltc) then
            write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
           else
            write(scrfile3) (dcore(itcdfint-1+i),
     $i=1,(nbf(idfn)+1)*nbf(idfn)/2)
           endif
c         call woeint(dcore(imem),dcore(imem),dcore(itcdfint),scrfile3,
c    $itol,nbf(idfn))
          close(scrfile3)
           if(.not.ldom.or..not.(lrpa.and.localcc.ne.'off ').or.
     $trim(ccprog).eq.'cis') then
            open(scrfile3,file='DFINV',form='unformatted')
             if(dfalg.eq.'invsqrt '.and.
     $(trim(ccprog).ne.'cis'.or..not.ldom)) then
              write(iout,*) 'Calculation of inverse square root ' //
     $'of the two-center integral matrix...'
               if(3*nbf(idfn)**2+nbf(idfn).gt.maxcor-(imem-imem1)) then
      write(iout,*) 'Warning: Insufficient memory for the '//
     $'diagonalization of the'
      write(iout,*) 'two-center integral matrix. You can try ' //
     $'dfalg=LinEq. '
               endif
              call invsqrt(dcore(itcdfint),nbf(idfn),dcore(imem),iout,i,
     $1d-12,1)
              write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
             else if(dfalg.eq.'lineq   '.or.
     $(trim(ccprog).eq.'cis'.and.ldom)) then
C Calculate the Cholesky deco of the two-center matrix
              write(iout,*) 'Cholesky decomposition of the '//
     $'two-center matrix...'
              call dpptrf('L',nbf(idfn),dcore(itcdfint),info4)
               if(info4.ne.0) then
                write(iout,*) 
     $'Fatal error at the Cholesky decomposition!'
                call mrccend(1)
               endif
              write(scrfile3) (dcore(itcdfint-1+i),
     $i=1,(nbf(idfn)+1)*nbf(idfn)/2)
              call dtpcon('1','L','N',nbf(idfn),dcore(itcdfint),tmp,
     $dcore(imem+nbf(idfn)),icore(imem),info4)
              write(iout,
     $"(' Reciprocal of the condition number: ',e13.6)"),tmp
               if(dabs(tmp).lt.1d-6) then
      write(iout,*)
     $'Warning! Ill-conditioned two-center integral matrix.'
      write(iout,*) 'This may result in convergence problems.'
               endif
             else
C Invert two-center Coulomb integral matrix
              write(iout,*) 
     $'Calculation of the inverse of the two-center integral matrix...'
c             call invsqrt(dcore(itcdfint),nbf(idfn),dcore(imem),iout,i,
c    $1d-12,4)
c              if(i.ne.0) call mrccend(1)
cc            call syminvpd(dcore(itcdfint),nbf(idfn),nbf(idfn))
              call syminv(dcore(itcdfint),dcore(itcdfint),nbf(idfn),
     $nbf(idfn),dcore(imem))
              write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
             endif
C Save the inverse
c           call woeint(dcore(imem),dcore(imem),dcore(itcdfint),
c    $scrfile3,itol,nbf(idfn))
            call timer
            write(iout,*)
             if(dfalg.eq.'cholesky'.and.(chfx.ne.0.d0.or.
     $(trim(dft).ne.'off'.and.ccalc.ne.'scf             '.and.
     $dhyb.eq.0))) then
C Calculate the Cholesky deco of the inverse of the two-center matrix
              write(iout,*)'Cholesky decomposition of the inverse of '//
     $'the two-center matrix...'
              call dpotrf('L',nbf(idfn),dcore(itcdfint),nbf(idfn),info4)
               if(info4.ne.0) then
                write(iout,*) 
     $'Fatal error at the Cholesky decomposition!'
                call mrccend(1)
               endif
C Save the Cholesky deco
              write(scrfile3) ((dcore(itcdfint-1+nbf(idfn)*(j-1)+i),
     $i=j,nbf(idfn)),j=1,nbf(idfn))
c             call woeint(dcore(imem),dcore(imem),dcore(itcdfint),
c    $scrfile3,itol,nbf(idfn))
              call timer
              write(iout,*)
             endif
            close(scrfile3)
           else
            dfnbasis=nbf(idfn)
           endif
         endif
c        if(.not.ldom.or..not.(lrpa.and.localcc.ne.'off ')) call timer
c
c      ipa=dblalloc(nbasis**2*nbf(idfn))
c      call readtci(dcore(ipa),nbf(idfn),nbasis,icore(iintpos),tedatfile,
c     $dcore(imem))
c      ipb=dblalloc(nbf(idfn)**2)
c      rewind(999)
c      read(999) dcore(ipb:ipb-1+nbf(idfn)**2)
c      call invsqrt(dcore(ipb),nbf(idfn),dcore(imem),iout,i,1d-12,2)
c      call dsymm('r','l',nbasis**2,nbf(idfn),1.d0,dcore(ipb),nbf(idfn),
c     $dcore(ipa),nbasis**2,0.d0,dcore(imem),nbasis**2)
c      call dcopy(nbasis**2*nbf(idfn),dcore(imem),1,dcore(ipa),1)
c      rewind(999)
c      read(999) dcore(ipb:ipb-1+nbf(idfn)**2)
c      call fillup(dcore(ipb),nbf(idfn))
c      call fitcoef(dcore(ipa),nbasis,nbf(idfn),natoms,natrange,
c     $natrange(1,1,idfn),dcore(imem),dcore(ipb),ii)
cc     idv=dblalloc(ii)
cc     open(scrfile5,file='DFTGRID',form='unformatted')
cc     iagrid=dblalloc(3*ngrid)
cc     iaweight=dblalloc(ngrid)
cc     read(scrfile5) (dcore(iagrid+i),i=0,3*ngrid-1)
cc     read(scrfile5) (dcore(iaweight+i),i=0,ngrid-1)
cc     rewind(999)
cc      do i=1,ngrid
cc       call espint(natoms,nangmax,ncontrmax,nprimmax,ncartmax,
cc    $nsphermax,nang(1,idfn),nangmin(1,idfn),ncontr(0,1,idfn),
cc    $nprim(0,1,idfn),
cc    $gexp(1,0,1,idfn),gcoef(1,1,0,1,idfn),coord,dcore(ictostr),
cc    $nbf(idfn),dcore(imem),dcore(imem+nbf(idfn)),gcn(1,1,0,1,idfn),
cc    $nshrange(1,0,1,idfn),cartg,dcore(iboysval),nmboys,dcore(icf),itol,
cc    $-0.5d0*chfx*dcore(iaweight-1+i),1,dcore(iagrid+3*(i-1)))
cc        if(.false.) then
cc         call dsymv('l',nbf(idfn),1.d0,dcore(itcdfint),nbf(idfn),
cc    $dcore(imem),1,0.d0,dcore(imem+nbf(idfn)),1)
cc         call dcopy(nbf(idfn),dcore(imem+nbf(idfn)),1,dcore(imem),1)
cc         call dsymv('l',nbf(idfn),1.d0,dcore(itcdfint),nbf(idfn),
cc    $dcore(imem),1,0.d0,dcore(imem+nbf(idfn)),1)
cc         call dcopy(nbf(idfn),dcore(imem+nbf(idfn)),1,dcore(imem),1)
cc         call dgemv('n',nbasis**2,nbf(idfn),1.d0,dcore(ipa),nbasis**2,
cc    $dcore(imem),1,0.d0,dcore(imem+nbf(idfn)),1)
cc        else
cc         call calca(dcore(imem+nbf(idfn)),dcore(idv),nbasis,natoms,
cc    $natrange,natrange(1,1,idfn),dcore(imem+nbf(idfn)+nbasis**2),
cc    $dcore(imem))
cc        endif
cc       write(999) dcore(imem+nbf(idfn):imem+nbf(idfn)-1+nbasis**2)
cc      enddo
c      call dbldealloc(ipa)
c      close(scrfile5)
c      close(999)
c      call timer
c
        call dbldealloc(itcdfint)
       else if(trim(scfalg).eq.'disk') then
C Conventional four-center two-electron integrals
        write(iout,*) 'Calculation of two-electron integrals...'
        call teint(natoms,nangmax,ncontrmax,nprimmax,nang,ncontr,
     $nprim,gexp,gcoef,coord,ncartmax,dcore(ictostr),cartg,nsphermax,
     $dcore(icf),dcore(iboysval),nmboys,dcore,imem,indarr,
     $tedatfile,nbasis,gcn,dcore(imem),dcore(ipre),1,itol,
     $icore(inzipr),icore(inzjpr),icore(inzkpr),icore(inzlpr),nbfshmax,
     $icore(inzint),nshrange,icore(iintpos),iout,dcore,dcore,
     $dcore,dcore,dcore,dcore,'     ',imem1,maxcor,icore(ithad),
     $dcore(ithcf2),dcore(iscoord),dcore(irqqij),dcore(irqqkl),
     $dcore(ihrec),0,1,dcore,dcore,dcore,dcore,chfx,
     $eexp,ebf,nangmin,dcore(ispctostr),i,i,i,0.d0,rhffock,uhffock,boys)
        call timer
       endif
C Shall we recalculate three-center integrals?
       if(dfbasis_scf.eq.dfbasis_cor.and.trim(scfalg).eq.'disk'.and.
     $nbset.ge.3.and.trim(ccprog).ne.'cis'.and.
     $(dens.eq.0.or.trim(naf_cor).eq.'off')) then
        lseqc=.true.
         do iatoms=1,natoms
          lseqc=lseqc.and.basname(iatoms,2).eq.basname(iatoms,3)
         enddo
       endif
C Save information for the DF integrals for the correlation calculation
       if((dfbasis_scf.eq.'none                '.or.scfalg.ne.'disk    '
     $.or.(dfbasis_scf.ne.'none                '.and.
     $     dfbasis_scf.ne.dfbasis_cor).or..not.lseqc.or.
     $    (dfbasis_scf.ne.'none                '.and.lseqc).or.
     $    (localcc.eq.'2013'.and.lrpa)).and.
     $(dfbasis_cor.ne.'none                '.or.scfalg.ne.'disk    ')
     $.and..not.ldom) then
        inquire(file='DOMAIN',exist=lll)
         if(.not.lll) then
          open(scrfile2,file='DOMAIN',form='unformatted')
          rewind(scrfile2)
          write(scrfile2) nbasis,nelec,ncore,0,nangmax,ncontrmax,
     $nprimmax,nshmax
          write(scrfile2) nuc
          write(scrfile2)
          write(scrfile2)
          write(scrfile2) natoms
           do iatoms=1,natoms
            write(scrfile2) atnum(iatoms),atchg(iatoms),
     $(coord(j,iatoms),j=1,3),(basname(iatoms,i),i=1,nbset),
     $ecpname(iatoms),atsymbol(iatoms),atnumt(iatoms),ncorecp(iatoms)
           enddo
          close(scrfile2)
         endif
        dofit=dens.gt.0.or..not.(((localcc.ne.'off '.and.lrpa)
     $.or.laibj).and.(naf_cor.eq.'off             '.or.laibj))
       endif
C Save variables to VARS file
      call tedatw(varsfile,natoms,nangmax,ncontrmax,nprimmax,ncartmax,
     $cartg,nsphermax,nmboys,nbasis,itol,nbfshmax,nang,ncontr,nprim,
     $gexp,gcoef,coord,dcore(ictostr),dcore(icf),dcore(iboysval),indarr,
     $gcn,dcore(ipre),nshrange,nangmin,atnum,nbf,iintln,ifltln,nbset,
     $dcore(ispctostr),atchg,ncent,ebf,necpatoms,ecpn,ecpnang,ecpprim,
     $ecpexp,ecpcoef,ecpatoms,nbfatmax,dcore(ispre))
C Gyula
C nangmaxv: max angular momenta for the different basis sets
      nangmaxv=0
      do nan1=1,nbset
        do nan2=1,natoms
         nangmaxv(nan1)=max(nangmaxv(nan1),nang(nan2,nan1))
        enddo
      enddo
      write(varsfile) 'nangmaxv  ',iintln*nbset,nangmaxv
C
      write(varsfile) 'natrange  ',iintln*2*natoms*nbset,natrange
      write(varsfile) 'basname   ',20*natoms*nbset,basname
      write(varsfile) 'ecpname   ',20*natoms,ecpname
      write(varsfile) 'atsymbol  ',2*natoms,atsymbol
      write(varsfile) 'nuc       ',ifltln,nuc
      write(varsfile) 'nal       ',iintln,nal
      write(varsfile) 'nbe       ',iintln,nbe
      write(varsfile) 'lseqc     ',iintln,lseqc
      write(varsfile) 'dofit     ',iintln,dofit
      write(varsfile) 'ncore     ',iintln,ncore
      write(varsfile) 'atnumt    ',iintln*natoms,atnumt
      write(varsfile) 'ncorecp   ',iintln*natoms,ncorecp
       if(bfbasis.ne.'none                ')
     $write(varsfile) 'eexp      ',
     $iintln*9*nprimmax*(nangmax+1)*natoms*nbset,eexp
      write(varsfile) 'cdmrcc    ',512,cdmrcc
      write(varsfile) 'nshmax    ',iintln,nshmax
      write(varsfile) 'lrest     ',iintln,lrest
c Initialize fort.55 file
       if(.not.ldom.or.localcc.ne.'off ') then
        rewind(inp)
        write(inp,"(4i15)") nbasis,nelec,ncore,dfnbasis
        write(inp,"(100000i2)") (1,i=1,nbasis)
        write(inp,"(a7)") ' 150000'
        write(inp,"(e28.20)") nuc
        close(inp)
       endif
C Deallocate memory
      call dbldealloc(iboysval)
C
      return
      end
C
************************************************************************
      subroutine readbas(natoms,nangmax,ncontrmax,nprimmax,atsymbol,
     $basname,nang,ncontr,nprim,gexp,gcoef,cartg,indarr,nsphermax,gcn,
     $itol,gcoem,atnum,nbfshmax,nbfatmax,nshrange,nangmin,ianm,icon,
     $ipri,uncontract,natrange,gbasfile,iout,nbasis,verbosity,bfbasis,
     $bond,coord,bondat,eexp,ebf,cdmrcc)
************************************************************************
* Read basis set
************************************************************************
      implicit none
      integer natoms,nangmax,ncontrmax,nprimmax,i,j,k,l,m,icontr,icart
      integer nsphermax,indarr(natoms,0:nangmax,ncontrmax,nsphermax),ii
      integer gbasfile,iout,nbasis,natrange(2,natoms),verbosity,nbfatmax
      integer bondat(3,natoms),ebf(natoms),icnt,ncnt
      integer*8 dfact2
      character*1 angsym,str1,pstr(-1:1),bsn1(20)
      character*2 atsymbol(natoms),str2
      character*3 str3,stri,strk,strm
      character*4 uncontract,str4
      character*5 str5,bsn2
      character*8 bond(natoms)
      character*20 basname(natoms),bsn,bfbasis
      character*24 atsymbas,glabel
      character*128 bprint,bpr
      character*14 brow(10)
      character*512 cdmrcc
      integer nang(natoms),ncontr(0:nangmax,natoms),jj,nsh
      integer iang,iprim,jprim,iatoms,nprim(0:nangmax,natoms),atnum(*)
      integer gcn(2,ncontrmax,0:nangmax,natoms),nbo,nbfshmax,ish
      integer nshrange(2,0:nangmax,natoms),nangmin(natoms)
      integer ianm(*),icon(*),ipri(*),naug,nangaugmax
      real*8 gexp(nprimmax,0:nangmax,natoms),norm,ci,cj,ai,aj,itol,vocc
      real*8 gcoef(nprimmax,ncontrmax,0:nangmax,natoms),sum,pi,ex
      real*8 gcoem(nprimmax,ncontrmax,0:nangmax,natoms),coord(3,natoms)
      real*8 eexp(3,3,nprimmax,0:nangmax,natoms)
      real*8 matexp(3,3),vec(3),alpha,norm2,sina,cosa,u,v,w,r(3,3)
      real*8 tr(3,3),sr(3,3),norm3,cosdeg
      logical cartg,lgb,lmin,nangaugmaxinit
      data pstr /'z','y','x'/
c     data pstr /'x','y','z'/
      equivalence(bsn,bsn2,bsn1)
      parameter(pi=3.14159265358979323846264338327950288419716939938d0)
C
      call dfillzero(gexp,(nangmax+1)*nprimmax*natoms)
      call dfillzero(gcoef,nprimmax*ncontrmax*(nangmax+1)*natoms)
      call ifillzero(nang,natoms)
      call ifillzero(ncontr,(nangmax+1)*natoms)
      call ifillzero(nprim,(nangmax+1)*natoms)
C
      icnt=0
       do iatoms=1,natoms
        nangaugmaxinit=.false.
        nangmin(iatoms)=nangmax
        bsn=basname(iatoms)
        naug=0
         if(bsn2.eq.'d-aug') naug=1
         if(bsn2.eq.'t-aug') naug=2
         if(bsn2.eq.'q-aug') naug=3
         if(bsn2.eq.'p-aug') naug=4
         if(naug.gt.0) bsn2='  aug'
         if(trim(adjustl(bsn)).eq.'aug-cc-pvdz-ri-jk'.or.
     $      trim(adjustl(bsn)).eq.'aug-cc-pvtz-ri-jk'.or.
     $      trim(adjustl(bsn)).eq.'aug-cc-pvqz-ri-jk'.or.
     $      trim(adjustl(bsn)).eq.'aug-cc-pv5z-ri-jk') then
          naug=naug+1
          bsn=adjustl(bsn)
          bsn2='    c'
         endif
         if(trim(adjustl(bsn)).eq.'def2-qzvppd-ri-jk') then
          naug=naug+1
          bsn='def2-qzvpp-ri-jk    '
          nangaugmax=2
           if(atsymbol(iatoms).eq.'H ') nangaugmax=1
          nangaugmaxinit=.true.
         endif
        lmin=.false.
         do i=1,17
           if(bsn1(i  ).eq.'-'.and.
     $        bsn1(i+1).eq.'m'.and.
     $        bsn1(i+2).eq.'i'.and.
     $        bsn1(i+3).eq.'n') then
            lmin=.true.
            bsn1(i:i+3)=' '
           endif
         enddo
         if(icnt.eq.0) then
           if(atsymbol(iatoms).eq.'Bf') then
            atsymbas='B' // trim(bond(iatoms)) // ':' // trim(bfbasis)
           else
            atsymbas=trim(atsymbol(iatoms)) // ":" // adjustl(bsn)
           endif
          call lowercase(atsymbas,atsymbas,24)
          call gbcheck(lgb,atsymbas,gbasfile)
           if(.not.lgb) then
             if(atsymbol(iatoms).eq.'Bf') then
              open(gbasfile,file=trim(trim(cdmrcc) // 'Bond'))
             else
              open(gbasfile,file=trim(trim(cdmrcc) // atsymbol(iatoms)))
             endif
            glabel='                        '
             do while(atsymbas.ne.glabel)
              read(gbasfile,*) glabel
              call lowercase(glabel,glabel,24)
             enddo
           endif
           if(atsymbol(iatoms).eq.'Bf') then
            read(gbasfile,*)
            read(gbasfile,*)
            read(gbasfile,*) ncnt
            read(gbasfile,*)
           endif
         endif
         if(atsymbol(iatoms).eq.'Bf') then
          icnt=icnt+1
           if(icnt.eq.ncnt) icnt=0
         endif
C Read basis set
        read(gbasfile,*)
        read(gbasfile,*)
        read(gbasfile,*) nsh
         if(lmin) then
           if(     atnum(iatoms).le. 2) then
            nsh=min(nsh,1)
           else if(atnum(iatoms).gt. 2.and.atnum(iatoms).le.20) then
            nsh=min(nsh,2)
           else if(atnum(iatoms).gt.20.and.atnum(iatoms).le.56) then
            nsh=min(nsh,3)
           else 
            nsh=min(nsh,4)
           endif
         endif
        read(gbasfile,*) (ianm(ish),ish=1,nsh)
        read(gbasfile,*) (icon(ish),ish=1,nsh)
        read(gbasfile,*) (ipri(ish),ish=1,nsh)
         if(lmin) then
           if(     atnum(iatoms).le. 2) then
            icon(1)=1 !s
           else if(atnum(iatoms).ge. 3.and.atnum(iatoms).le. 4) then
            icon(1)=2 !s
           else if(atnum(iatoms).ge. 5.and.atnum(iatoms).le.10) then
            icon(1)=2 !s
            icon(2)=1 !p
           else if(atnum(iatoms).ge.11.and.atnum(iatoms).le.12) then
            icon(1)=3 !s
            icon(2)=1 !p
           else if(atnum(iatoms).ge.13.and.atnum(iatoms).le.18) then
            icon(1)=3 !s
            icon(2)=2 !p
           else if(atnum(iatoms).ge.19.and.atnum(iatoms).le.20) then
            icon(1)=4 !s
            icon(2)=2 !p
           else if(atnum(iatoms).ge.21.and.atnum(iatoms).le.30) then
            icon(1)=4 !s
            icon(2)=2 !p
            icon(3)=1 !d
           else if(atnum(iatoms).ge.31.and.atnum(iatoms).le.36) then
            icon(1)=4 !s
            icon(2)=3 !p
            icon(3)=1 !d
           else if(atnum(iatoms).ge.37.and.atnum(iatoms).le.38) then
            icon(1)=5 !s
            icon(2)=3 !p
            icon(3)=1 !d
           else if(atnum(iatoms).ge.39.and.atnum(iatoms).le.48) then
            icon(1)=5 !s
            icon(2)=3 !p
            icon(3)=2 !d
           else if(atnum(iatoms).ge.49.and.atnum(iatoms).le.54) then
            icon(1)=5 !s
            icon(2)=4 !p
            icon(3)=2 !d
           else if(atnum(iatoms).ge.55.and.atnum(iatoms).le.56) then
            icon(1)=6 !s
            icon(2)=4 !p
            icon(3)=2 !d
           else if(atnum(iatoms).ge.57.and.atnum(iatoms).le.80) then
            icon(1)=6 !s
            icon(2)=4 !p
            icon(3)=3 !d
            icon(4)=1 !f
           else if(atnum(iatoms).ge.81.and.atnum(iatoms).le.86) then
            icon(1)=6 !s
            icon(2)=5 !p
            icon(3)=3 !d
            icon(4)=1 !f
           else if(atnum(iatoms).ge.87.and.atnum(iatoms).le.88) then
            icon(1)=7 !s
            icon(2)=5 !p
            icon(3)=3 !d
            icon(4)=1 !f
           else if(atnum(iatoms).ge.89.and.atnum(iatoms).le.112) then
            icon(1)=7 !s
            icon(2)=5 !p
            icon(3)=4 !d
            icon(4)=2 !f
           else
            icon(1)=7 !s
            icon(2)=6 !p
            icon(3)=4 !d
            icon(4)=2 !f
           endif          
         endif
         do ish=1,nsh
           if(ebf(iatoms).eq.1) then
            read(gbasfile,*)
             do iprim=1,ipri(ish)
              read(gbasfile,*) ex
              read(gbasfile,*) sum
              read(gbasfile,*)
              gexp(iprim,ianm(ish),iatoms)=ex
              gcoef(iprim,iprim,ianm(ish),iatoms)=1.d0/
     $dsqrt(dsqrt(pi**3/(8.d0*ex**3*sum)))
              matexp(1,1)=ex
              matexp(2,2)=ex
              matexp(3,3)=ex*sum
              matexp(1,2)=0.d0
              matexp(1,3)=0.d0
              matexp(2,1)=0.d0
              matexp(2,3)=0.d0
              matexp(3,1)=0.d0
              matexp(3,2)=0.d0
              vec(1)=coord(2,bondat(1,iatoms))-coord(2,bondat(2,iatoms))
              vec(2)=coord(1,bondat(2,iatoms))-coord(1,bondat(1,iatoms))
              vec(3)=0.d0
              norm2=0.d0
               do i=1,3
                norm2=norm2+vec(i)**2.d0
               enddo
              norm2=dsqrt(norm2)
              norm3=0.d0
               do i=1,3
                norm3=norm3+(coord(i,bondat(2,iatoms))-
     $coord(i,bondat(1,iatoms)))**2.d0
               enddo
              norm3=dsqrt(norm3)
              cosdeg=(coord(3,bondat(2,iatoms))-
     $coord(3,bondat(1,iatoms)))/norm3
              alpha=-dacos(cosdeg)
              sina=dsin(alpha)
              cosa=dcos(alpha)
              u=vec(1)/norm2
              v=vec(2)/norm2
              w=vec(3)/norm2
              r(1,1)=u**2+(1.d0-u**2)*cosa
              r(1,2)=u*v*(1.d0-cosa)-w*sina
              r(1,3)=u*w*(1.d0-cosa)+v*sina
              r(2,1)=u*v*(1.d0-cosa)+w*sina
              r(2,2)=v**2+(1.d0-v**2)*cosa
              r(2,3)=v*w*(1.d0-cosa)-u*sina
              r(3,1)=u*w*(1.d0-cosa)-v*sina
              r(3,2)=v*w*(1.d0-cosa)+u*sina
              r(3,3)=w**2+(1.d0-w**2)*cosa
              tr(1,1)=r(1,1)
              tr(1,2)=r(2,1)
              tr(1,3)=r(3,1)
              tr(2,1)=r(1,2)
              tr(2,2)=r(2,2)
              tr(2,3)=r(3,2)
              tr(3,1)=r(1,3)
              tr(3,2)=r(2,3)
              tr(3,3)=r(3,3)
              sr=matmul(tr,matexp)
              matexp=matmul(sr,r)
              eexp(1,1,iprim,ianm(ish),iatoms)=matexp(1,1)
              eexp(1,2,iprim,ianm(ish),iatoms)=matexp(1,2)
              eexp(1,3,iprim,ianm(ish),iatoms)=matexp(1,3)
              eexp(2,1,iprim,ianm(ish),iatoms)=matexp(2,1)
              eexp(2,2,iprim,ianm(ish),iatoms)=matexp(2,2)
              eexp(2,3,iprim,ianm(ish),iatoms)=matexp(2,3)
              eexp(3,1,iprim,ianm(ish),iatoms)=matexp(3,1)
              eexp(3,2,iprim,ianm(ish),iatoms)=matexp(3,2)
              eexp(3,3,iprim,ianm(ish),iatoms)=matexp(3,3)
             enddo
           else
            read(gbasfile,*)
            read(gbasfile,*) (gexp(j,ianm(ish),iatoms),
     $j=nprim(ianm(ish),iatoms)+1,nprim(ianm(ish),iatoms)+ipri(ish))
            read(gbasfile,*)
             do iprim=1,ipri(ish)
              read(gbasfile,*) 
     $(gcoef(nprim(ianm(ish),iatoms)+iprim,j,ianm(ish),iatoms),
     $j=ncontr(ianm(ish),iatoms)+1,ncontr(ianm(ish),iatoms)+icon(ish))
             enddo
             if(bfbasis.ne.'none                ') then
               do j=nprim(ianm(ish),iatoms)+1,
     $              nprim(ianm(ish),iatoms)+ipri(ish)
                call dfillzero(eexp(1,1,j,ianm(ish),iatoms),9)
                ex= gexp(j,ianm(ish),iatoms)
                eexp(1,1,j,ianm(ish),iatoms)=ex
                eexp(2,2,j,ianm(ish),iatoms)=ex
                eexp(3,3,j,ianm(ish),iatoms)=ex
               enddo
             endif
           endif
          nang(iatoms)=max(nang(iatoms),ianm(ish))
          nangmin(iatoms)=min(nangmin(iatoms),ianm(ish))
          ncontr(ianm(ish),iatoms)=ncontr(ianm(ish),iatoms)+icon(ish)
          nprim(ianm(ish),iatoms)=nprim(ianm(ish),iatoms)+ipri(ish)
         enddo
         if(.not.nangaugmaxinit) nangaugmax=nang(iatoms)
C Augmentation functions
         if(naug.gt.0) then
           do iang=0,min(nangaugmax,nang(iatoms))
             if(nprim(iang,iatoms).eq.1) then
              ai=2.5d0
              cj=gexp(1,iang,iatoms)
             else
              cj=gexp(1,iang,iatoms)
              ii=1
               do iprim=2,nprim(iang,iatoms)
                 if(gexp(iprim,iang,iatoms).lt.cj) then
                  cj=gexp(iprim,iang,iatoms)
                  ii=iprim
                 endif
               enddo
              ci=cj
               do iprim=1,nprim(iang,iatoms)
                 if(gexp(iprim,iang,iatoms).gt.ci) 
     $ci=gexp(iprim,iang,iatoms)
               enddo
               do iprim=1,nprim(iang,iatoms)
                 if(gexp(iprim,iang,iatoms).lt.ci.and.iprim.ne.ii) 
     $ci=gexp(iprim,iang,iatoms)
               enddo
              ai=ci/cj
             endif
             do i=1,naug
              cj=cj/ai
              gexp(nprim(iang,iatoms)+i,iang,iatoms)=cj
      gcoef(nprim(iang,iatoms)+i,ncontr(iang,iatoms)+i,iang,iatoms)=1.d0
             enddo
            ncontr(iang,iatoms)=ncontr(iang,iatoms)+naug
            nprim(iang,iatoms) =nprim(iang,iatoms) +naug
           enddo
         endif
C Uncontract basis set
         if(uncontract.eq.'on  ') then
           do iang=0,nang(iatoms)
            ncontr(iang,iatoms)=nprim(iang,iatoms)
             do iprim=1,nprim(iang,iatoms)
              gcoef(iprim,iprim,iang,iatoms)=1.d0
               do jprim=1,iprim-1
                gcoef(iprim,jprim,iang,iatoms)=0.d0
                gcoef(jprim,iprim,iang,iatoms)=0.d0
               enddo
             enddo
           enddo
         endif
C Zero blocks in contraction coefficent matrix
         do iang=0,nang(iatoms)
          gcn(1,1:ncontr(iang,iatoms),iang,iatoms)=0
          gcn(2,1:ncontr(iang,iatoms),iang,iatoms)=-1
           do iprim=1,nprim(iang,iatoms)
             do j=1,ncontr(iang,iatoms)
              gcoem(iprim,j,iang,iatoms)=gcoef(iprim,j,iang,iatoms)
               if(dabs(gcoef(iprim,j,iang,iatoms)).gt.itol.and.
     $gcn(1,j,iang,iatoms).eq.0) gcn(1,j,iang,iatoms)=iprim
               if(dabs(gcoef(iprim,j,iang,iatoms)).gt.itol)
     $gcn(2,j,iang,iatoms)=iprim
             enddo
           enddo
         enddo
C Normalize basis functions
         if(ebf(iatoms).eq.0) then
           do iang=0,nang(iatoms)
             do j=1,ncontr(iang,iatoms)
              norm=0.d0
               do iprim=1,nprim(iang,iatoms)
                ai=gexp(iprim,iang,iatoms)
                ci=gcoef(iprim,j,iang,iatoms)
                 do jprim=1,nprim(iang,iatoms)
                  aj=gexp(jprim,iang,iatoms)
                  cj=gcoef(jprim,j,iang,iatoms)
                 norm=norm+
     $ci*cj*(2.d0*dsqrt(ai*aj)/(ai+aj))**(1.5d0+iang)
                 enddo
               enddo
              norm=1.d0/(dsqrt(norm*dble(dfact2(iang))))
               do iprim=1,nprim(iang,iatoms)
c               gcoef(iprim,j,iang,iatoms)=gcoef(iprim,j,iang,iatoms)
                gcoef(iprim,j,iang,iatoms)=gcoef(iprim,j,iang,iatoms)*
     $norm*(4.d0*gexp(iprim,iang,iatoms))**(0.5d0*iang+0.75d0)*
     $(0.5d0/pi)**0.75d0
               enddo
             enddo
           enddo
         endif
C Print basis set information
        write(str4,'(i4)') iatoms
        bprint=str4 // '  ' // atsymbol(iatoms) // ' ' //
     $trim(basname(iatoms)) // ' ['
         do i=nangmin(iatoms),nang(iatoms)
           if(nprim(i,iatoms).lt.10) then
            write(str1,'(i1)') nprim(i,iatoms)
            bprint=trim(bprint) // ' ' // str1 // angsym(i)
           else
            write(str2,'(i2)') nprim(i,iatoms)
            bprint=trim(bprint) // ' ' // str2 // angsym(i)
           endif
         enddo
        bprint=trim(bprint) // ' |'
         do i=nangmin(iatoms),nang(iatoms)
           if(ncontr(i,iatoms).lt.10) then
            write(str1,'(i1)') ncontr(i,iatoms)
            bprint=trim(bprint) // ' ' // str1 // angsym(i)
           else
            write(str2,'(i2)') ncontr(i,iatoms)
            bprint=trim(bprint) // ' ' // str2 // angsym(i)
           endif
         enddo
        bprint=trim(bprint) // ' ]'
c       write(iout,"(a72)") bprint
        write(iout,*) trim(bprint)
C Minimal angular momenta
c        if(atnum(iatoms).le. 2) nangmin(iatoms)=0
c        if(atnum(iatoms).gt. 2.and.atnum(iatoms).le.20)
c    $nangmin(iatoms)=1
c        if(atnum(iatoms).gt.20.and.atnum(iatoms).le.56)
c    $nangmin(iatoms)=2
c        if(atnum(iatoms).gt.56) nangmin(iatoms)=3
c       nangmin(iatoms)=min(nangmin(iatoms),nang(iatoms))
         if(icnt.eq.0) close(gbasfile)
       enddo
C Print basis functions
      write(iout,*)
       if(verbosity.gt.2) write(iout,*) 'Basis functions:'
       if(verbosity.gt.2) write(iout,"(5x,10(i8,6x))") (i,i=1,10)
      nbasis=0
      ii=0
       do iatoms=1,natoms
        natrange(1,iatoms)=nbasis
         do iang=0,nang(iatoms)
          nbo=nbasis
          nshrange(1,iang,iatoms)=nbasis
           do icontr=1,ncontr(iang,iatoms)
            write(str4,'(i4)') iatoms
            write(str2,'(i2)') icontr
            bpr=trim(str4) // trim(atsymbol(iatoms)) // 
     $trim(adjustl(str2)) // angsym(iang)
            icart=0
             if(cartg) then
               do i=0,iang
                 if(iang.le.3.and.i.eq.0) then
                  stri='   '
                 else if(iang.le.3.and.i.eq.1) then
                  stri='x  '
                 else if(iang.le.3.and.i.eq.2) then
                  stri='x2 '
                 else if(iang.le.3.and.i.eq.3) then
                  stri='x3 '
                 else
                  write(str2,'(i2)') i
                  stri=adjustl(str2)
                 endif
                 do k=0,iang-i
                  m=iang-i-k
                   if(iang.le.3.and.k.eq.0) then
                    strk='   '
                   else if(iang.le.3.and.k.eq.1) then
                    strk='y  '
                   else if(iang.le.3.and.k.eq.2) then
                    strk='y2 '
                   else if(iang.le.3.and.k.eq.3) then
                    strk='y3 '
                   else
                    write(str2,'(i2)') k
                    strk=adjustl(str2)
                   endif
                   if(iang.le.3.and.m.eq.0) then
                    strm='   '
                   else if(iang.le.3.and.m.eq.1) then
                    strm='z  '
                   else if(iang.le.3.and.m.eq.2) then
                    strm='z2 '
                   else if(iang.le.3.and.m.eq.3) then
                    strm='z3 '
                   else
                    write(str2,'(i2)') m
                    strm=adjustl(str2)
                   endif
c                  if(iang.eq.1) then ! p functions, for order x, y, z
c                    if(stri.eq.'x  ') stri='z  '
c                    if(strm.eq.'z  ') strm='x  '
c                  endif
                  icart=icart+1
                  nbasis=nbasis+1
                  indarr(iatoms,iang,icontr,icart)=nbasis
                  bprint=trim(bpr) // trim(stri) //
     $trim(strk) // trim(strm)
                  ii=ii+1
                  brow(ii)=' ' // trim(bprint)
                   if(mod(nbasis,10).eq.0) then
                   if(verbosity.gt.2) 
     $write(iout,"(i5,10a14)")nbasis/10-1,(brow(jj),jj=1,10)
                    ii=0
                   endif
                 enddo
               enddo
             else
               do l=-iang,iang
                nbasis=nbasis+1
                indarr(iatoms,iang,icontr,l+iang+1)=nbasis
                write(str3,'(i3)') l
                 if(iang.eq.0) then
                  bprint=trim(bpr)
                 else if(iang.eq.1) then
                  bprint=trim(bpr) // pstr(l)
                 else if(l.gt.0) then
                  bprint=trim(bpr) // '+' // trim(adjustl(str3))
                 else
                  bprint=trim(bpr) // trim(adjustl(str3))
                 endif
                ii=ii+1
                brow(ii)=' ' // trim(bprint)
                 if(mod(nbasis,10).eq.0) then
                   if(verbosity.gt.2)
     $write(iout,"(i5,10a14)")nbasis/10-1,(brow(jj),jj=1,10)
                  ii=0
                 endif
               enddo
             endif
           enddo
          nbfshmax=max(nbfshmax,nbasis-nbo)
          nshrange(2,iang,iatoms)=nbasis
         enddo !iang
        natrange(2,iatoms)=nbasis
        nbfatmax=max(nbfatmax,natrange(2,iatoms)-natrange(1,iatoms))
       enddo !iatoms
       if(mod(nbasis,10).ne.0) then
        ii=nbasis-mod(nbasis,10)
         if(verbosity.gt.2)
     $write(iout,"(i5,10a14)") ii/10,(brow(jj),jj=1,mod(nbasis,10))
       endif
C
       if(verbosity.gt.2) write(iout,*)
       if(verbosity.gt.2) write(iout,"(1x,a44,i5)") 
     $'Maximum number of basis functions per shell:',nbfshmax
      write(iout,"(1x,a32,i7)")'Total number of basis functions:',nbasis
      write(iout,*)
C
      return
      end
C
************************************************************************
      subroutine nucmass(natoms,atsymbol,atmass,atnum,atnumt)
************************************************************************
* Collect atomic masses and atomic symbols
************************************************************************
#include "MRCCCOMMON"
      integer natoms,i,j,iatoms,ii,jj,atnum(natoms),ncorb(natoms)
      integer n,m,atnumt(natoms)
      real*8 atmass(natoms),atmas(0:natmax)
      character*1 line2(16),line3(max(512,6*natoms))
      character*2 atsymbol(natoms)
      character*8 ghost
      character*16 line1
      equivalence(line1,line2)
      data atmas / 0.d0,
     $             1.007825035d+00,  4.00260324d+00,   7.0160030d+00,
     $               9.0121822d+00,  11.0093054d+00,  12.0000000d+00,
     $            14.003074002d+00, 15.99491463d+00, 18.99840322d+00,
     $              19.9924356d+00,  22.9897677d+00,  23.9850423d+00,
     $              26.9815386d+00,  27.9769271d+00,  30.9737620d+00,
     $             31.97207070d+00,34.968852721d+00,  39.9623837d+00,
     $              38.9637074d+00,  39.9625906d+00,  44.9559100d+00,
     $              47.9479473d+00,  50.9439617d+00,  51.9405098d+00,
     $              54.9380471d+00,  55.9349393d+00,  58.9331976d+00,
     $              57.9353462d+00,  62.9295989d+00,  63.9291448d+00,
     $               68.925580d+00,  73.9211774d+00,  74.9215942d+00,
     $              79.9165196d+00,  78.9183361d+00,   83.911507d+00,
     $               84.911794d+00,  87.9056188d+00,   88.905849d+00,
     $              89.9047026d+00,  92.9063772d+00,  97.9054073d+00,
     $               97.907215d+00, 101.9043485d+00,  102.905500d+00,
     $              105.903478d+00,  106.905092d+00,  113.903357d+00,
     $              114.903882d+00, 119.9021991d+00,  120.9038212d+00,
     $              129.906229d+00,  126.904473d+00,  131.904144d+00,
     $              132.905429d+00,  137.905232d+00,  138.906347d+00,
     $              139.905433d+00,  140.907647d+00,  141.907719d+00,
     $              144.912743d+00,  151.919728d+00,  152.921225d+00,
     $              157.924019d+00,  158.925342d+00,  163.929171d+00,
     $              164.930319d+00,  165.930290d+00,  168.934212d+00,
     $              173.938859d+00,  174.940770d+00, 179.9465457d+00,
     $              180.947462d+00,  183.950928d+00,  186.955744d+00,
     $              191.961467d+00,  192.962917d+00,  194.964766d+00,
     $              196.966543d+00,  201.970617d+00,  204.974401d+00,
     $              207.976627d+00,  208.980374d+00,  208.982404d+00,
     $              209.987126d+00,  222.017571d+00,  223.019733d+00,
     $              226.025403d+00,  227.027750d+00,  232.038051d+00,
     $              231.035880d+00,  238.050785d+00,  237.048168d+00,
     $              244.064199d+00,  243.061373d+00,  247.070347d+00,
     $              247.070300d+00,  251.079580d+00,  252.082944d+00,
     $              257.095099d+00,  258.098570d+00,  259.100931d+00,
     $              260.105320d+00,  261.108690d+00,  262.113760d+00,
     $              263.118220d+00,  262.122930d+00,  269.134100d+00,
     $              267.138000d+00,  268.143500d+00,  272.000000d+00,
     $              277.000000d+00,  283.000000d+00,  289.000000d+00,
     $              294.000000d+00,  300.000000d+00,  306.000000d+00,
     $              310.000000d+00 /
C Atom number, symbol, mass
       do iatoms=1,natoms
        call getatnum(atsymbol(iatoms),atnum(iatoms))
        atmass(iatoms)=atmas(atnum(iatoms))
       enddo
      atnumt(1:natoms)=atnum(1:natoms)
C Ghost atoms
      call getkeym('ghost',5,ghost,8)
       if(ghost.eq.'serialno') then
        n=0
        line3=' '
         do
          n=n+1
          read(minpfile,'(a)',advance='no',eor=1234,end=1234) line3(n)
         enddo
1234    continue
        n=1
         do while(line3(n).ne.' ')
          m=n
           do while(line3(n).ne.','.and.line3(n).ne.'-'
     $.and.line3(n).ne.' ')
            n=n+1
           enddo
          line1='                '
           do i=m,n-1
            line2(i-m+1)=line3(i)
           enddo
          read(line1,*) ii
          jj=ii
           if(line3(n).eq.'-') then
            n=n+1
            m=n
             do while(line3(n).ne.','.and.line3(n).ne.' ')
              n=n+1
             enddo
            line1='                '
             do i=m,n-1
              line2(i-m+1)=line3(i)
             enddo
            read(line1,*) jj
           endif
           if(jj.gt.natoms) then
            write(iout,*) 'Invalid serial number for ghost atoms!'
            call mrccend(1)
           endif
           do iatoms=ii,jj
            atnum(iatoms)=0
            atmass(iatoms)=atmass(iatoms)/10.d0
           enddo
          n=n+1
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine neleccalc(natoms,atnum,ncorb,mmbond,ncorecp,atchg,
     $atmass,nadja,qmreg,qmhatom,lfdm)
************************************************************************
* Number of electrons, core electrons, nuclear charges
************************************************************************
#include "MRCCCOMMON"
      integer natoms,i,j,iatoms,ii,jj,atnum(natoms),ncorb(natoms),mmbond
      integer n,m,ncorecp(natoms),qmhatom(mmbond),nadja(mmbond)
      real*8 atchg(natoms),atmass(natoms)
      character*6 core
      character*8 qmreg
      logical lfdm
C Number of core orbitals
      ncore=0
       do iatoms=1,natoms
         if(atnum(iatoms).le.2) then
          i=0
         else if(atnum(iatoms).le.10) then
          i=1
         else if(atnum(iatoms).le.18) then
          i=5
         else if(atnum(iatoms).le.30) then
          i=9
         else if(atnum(iatoms).le.36) then
          i=14
         else if(atnum(iatoms).le.48) then
          i=18
         else if(atnum(iatoms).le.54) then
          i=23
         else if(atnum(iatoms).le.80) then
          i=27
         else if(atnum(iatoms).le.86) then
          i=39
         else
          i=43
         endif
        i=max(0,i-ncorecp(iatoms)/2)
        ncorb(iatoms)=i
        ncore=ncore+i
       enddo
      call getkey('core',4,core,6)
       if(core.ne.'frozen'.and.core.ne.'corr  ') read(core,*) ncore
      write(varsfile) 'ncorb     ',iintln*natoms,(ncorb(i),i=1,natoms)
      write(varsfile) 'mmbond    ',iintln,mmbond
C Number of electrons and nuclear charge
       do iatoms=1,natoms
        atchg(iatoms)=dble(max(0,atnum(iatoms)-ncorecp(iatoms)))
       enddo
       if(lfdm) return
      nelec=0
       do iatoms=1,natoms
        nelec=nelec+max(0,atnum(iatoms)-ncorecp(iatoms))
       enddo
       if(qmreg.eq.'0       ') then
         do iatoms=1,natoms
           do i=1,mmbond
             if(iatoms.eq.qmhatom(i)) then
              atmass(iatoms)=atmass(iatoms)/10.d0
              atnum(iatoms)=atnum(iatoms)-nadja(i)
              nelec=nelec-nadja(i)
              atchg(iatoms)=dble(atnum(iatoms))
             endif
           enddo
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine getatnum(atsymbol,atnum)
************************************************************************
* Get atomic number and atomic symbol
************************************************************************
#include "MRCCCOMMON"
      integer atnum
      character*2 atsymbol,atsym(0:natmax),ch1,ch2
      data atsym /'Bf',
     $            'H ','He','Li','Be','B ','C ','N ','O ','F ','Ne',
     $            'Na','Mg','Al','Si','P ','S ','Cl','Ar','K ','Ca',
     $            'Sc','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     $            'Ga','Ge','As','Se','Br','Kr','Rb','Sr','Y ','Zr',
     $            'Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd','In','Sn',
     $            'Sb','Te','I ','Xe','Cs','Ba','La','Ce','Pr','Nd',
     $            'Pm','Sm','Eu','Gd','Tb','Dy','Ho','Er','Tm','Yb',
     $            'Lu','Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg',
     $            'Tl','Pb','Bi','Po','At','Rn','Fr','Ra','Ac','Th',
     $            'Pa','U ','Np','Pu','Am','Cm','Bk','Cf','Es','Fm',
     $            'Md','No','Lr','Rf','Db','Sg','Bh','Hs','Mt','Ds',
     $            'Rg','Cn','Nh','Fl','Mc','Lv','Ts','Og'/
C
       if(atnum.eq.0) then
        call lowercase(atsymbol,ch1,2)
        atnum=-1
        ch2='  '
         do while(ch1.ne.ch2)
          atnum=atnum+1
           if(atnum.gt.natmax) then
            call uppercase(atsymbol,atsymbol,1)
            write(iout,*) 'Unknown atomic symbol '//trim(atsymbol)//'!'
            call mrccend(1)
           endif
          call lowercase(atsym(atnum),ch2,2)
         enddo
       endif
      atsymbol=atsym(atnum)
C
      return
      end
C
************************************************************************
      subroutine centmass(natoms,coord,atmass,varsfile,ifltln)
************************************************************************
* Shift to center of mass
************************************************************************
      implicit none 
      integer i,natoms,varsfile,ifltln
      real*8 xcordcentmass,ycordcentmass,zcordcentmass,x,y,z,summass
      real*8 coord(3,natoms),atmass(natoms)
C
      summass=0.d0
       x=0.d0
       y=0.d0
       z=0.d0
       do i=1,natoms
        x=x+atmass(i)*coord(1,i)
        y=y+atmass(i)*coord(2,i)
        z=z+atmass(i)*coord(3,i)
        summass=summass+atmass(i)
       enddo
      xcordcentmass=x/summass
      ycordcentmass=y/summass
      zcordcentmass=z/summass
       do i=1,natoms
        coord(1,i)=coord(1,i)-xcordcentmass
        coord(2,i)=coord(2,i)-ycordcentmass
        coord(3,i)=coord(3,i)-zcordcentmass
       enddo
      write(varsfile) 'centmass  ',3*ifltln,xcordcentmass,ycordcentmass,
     $zcordcentmass
C
      return
      end
C
***********************************************************************
      subroutine princax(natoms,coord,atmass,cmpgrp,gtol,embed)
***********************************************************************
* Transformation to principal axis system
***********************************************************************
#include "MRCCCOMMON"
      integer*4 ii
      integer natoms,i,j,re,rf,ic1,ic2,dblalloc,iatoms,ideg
      real*8 gtol,etol,sum
      real*8 ten(3,3),coord(3,natoms),atmass(natoms),cscr(3,natoms)
      real*8 eig(3),work(10),rotconst(3)
      real*8 tent(3,3)
      character*1 cscr1(4)
      character*4 pntgrp,cmpgrp,symm,cscr4,oldcmp
      character*8 ghost,embed
      character*16 ccalc
      equivalence(cscr1,cscr4)
      logical lplan
C Tolerance for symmetry recognization
C     Build inertial tensor
      call buildinertial(natoms,coord,atmass,ten,gtol,etol)
C     Principal axis transformation
      call dsyev("V","U",3,ten,3,eig,work,10,ii)
      tent=transpose(ten)
c     write(6,*) eig,eig(3)-eig(2)-eig(1),gtol
       if(ii.ne.0) then
        write(iout,*) 'Fatal error in matrix diagonalization!'
        call mrccend(1)
       endif
C     New coordinates
      call dgemm('t','n',3,natoms,3,1.d0,ten,3,coord,3,0.d0,cscr,3)
      call dcopy(natoms*3,cscr,1,coord,1)
c     write(varsfile) 'ten       ',9*ifltln,ten
C     Compute rotational constants
      j=0
       do i=1,3
         if(dabs(eig(i)).gt.etol) then
          j=j+1
          rotconst(j)=100.d0*planck*navogadro/(8.d0*pi**2*clight*eig(i)*
     $angtobohr**2)
         endif
       enddo
      write(iout,*)
c     write(6,"(3f22.12)") etol
c     write(6,"(3f22.12)") eig
       if(j.eq.2) then
        write(iout,*) 'This molecule is linear.'
        j=1
       else if(dabs(eig(1)-eig(2)).gt.etol.and.
     $         dabs(eig(2)-eig(3)).gt.etol) then
        write(iout,*) 'This molecule is an asymmetric top.'
       else if(dabs(eig(1)-eig(2)).gt.etol.and.
     $         dabs(eig(2)-eig(3)).le.etol) then
        write(iout,*) 'This molecule is a prolate symmetric top.'
       else if(dabs(eig(1)-eig(2)).le.etol.and.
     $         dabs(eig(2)-eig(3)).gt.etol) then
        write(iout,*) 'This molecule is an oblate symmetric top.'
       else if(dabs(eig(1)-eig(2)).le.etol.and.
     $         dabs(eig(2)-eig(3)).le.etol) then
        write(iout,*) 'This molecule is a spherical top.'
       endif
      lplan=.false.
       if(j.ne.2.and.dabs(eig(3)-eig(2)-eig(1)).le.etol
     $.and.eig(3)-eig(2).gt.etol) then
        write(iout,*) 'This molecule is planar.'
        lplan=.true.
       endif
      call getkey('ghost',5,ghost,8)
       if(ghost.eq.'none    ') then
        write(iout,*)
        write(iout,*) 'Rotational constants [cm-1]: '
        write(iout,"(3f20.12)") (rotconst(i),i=1,j)
       endif
C Degenerate groups
      ideg=1
       if(dabs(eig(2)-eig(3)).le.etol) then
        ideg=ideg+1
        call coordswap(natoms,coord,1,3)
        call coordswap(3,tent,1,3)
        sum=eig(1)
        eig(1)=eig(3)
        eig(3)=sum
       endif
       if(dabs(eig(1)-eig(2)).le.etol) ideg=ideg+1
C Determine point group symmetry
      ic1=dblalloc(natoms*3)
      ic2=dblalloc(natoms*3)
      call pgroup(natoms,atmass,coord,dcore(ic1),dcore(ic2),eig,gtol,
     $etol,pntgrp,cmpgrp,tent)
       if(pntgrp.eq.'D*h ') pntgrp='Dxh '
       if(pntgrp.eq.'C*v ') pntgrp='Cxv '
       if(j.eq.1.and.pntgrp.ne.'Dxh '.and.pntgrp.ne.'Cxv ') then
        write(iout,*)
        write(iout,*) 'Warning! This molecule is probably linear, ' //
     $'but the coordinates are not'
        write(iout,*) 'symmetric enough!'
       endif
      call dbldealloc(ic1)
      write(iout,*)
      write(iout,"(' Point group: ',a4)") pntgrp
      call getkey('symm',4,symm,4)
       if(symm.eq.'0   ') cmpgrp='C1  '
      oldcmp=cmpgrp
      call getkey('cmpgrp',6,cscr4,4)
       if(cscr4.ne.'auto'.and.cmpgrp.ne.'C1  ') then
         if(cscr1(1).eq.'d') cscr1(1)='D'
         if(cscr1(1).eq.'c') cscr1(1)='C'
         if(cmpgrp.ne.cscr4) then
          cmpgrp=cscr4
           if((oldcmp.eq.'D2  '.and.cmpgrp.ne.'C2  ').or.
     $(oldcmp.eq.'C2h '.and.(cmpgrp.eq.'C2v '.or.cmpgrp.eq.'D2  '.or.
     $cmpgrp.eq.'D2h ')).or.
     $(oldcmp.eq.'C2v '.and.(cmpgrp.eq.'Ci  '.or.cmpgrp.eq.'D2  '.or.
     $cmpgrp.eq.'D2h ')).or.
     $((oldcmp.eq.'C2  '.or.oldcmp.eq.'Cs  '.or.oldcmp.eq.'Ci  ').and.
     $cmpgrp.ne.'C1  ')) then
            write(iout,*)
            write(iout,*) 'Invalid option for keyword "cmpgrp"!'
            write(iout,*) trim(cmpgrp) // ' is not a subgroup of ' //
     $trim(oldcmp) // '!'
            call mrccend(1)
           endif
         endif
       endif
      write(iout,"(' Computational point group: ',a4)") cmpgrp
c     call mrccend(0)
C Which CC code is to be used?
c     call getkey('calc',4,ccalc,16)
c     call getkey('ccprog',6,ccprog,4)
c      if(ccprog.eq.'    ') then
c        if(cmpgrp.eq.'C1  '.and.(ccalc.eq.'ccsd            '.or.
c    $ccalc.eq.'ccsd(t)         ')) then
c         call changekey('ccprog',6,'ccsd',4)
c        else
c         call changekey('ccprog',6,'mrcc',4)
c        endif
c      endif
C Sepcial arrangement for planar Cs and C2v molecules
       if(lplan.and.(pntgrp.eq.'C2v '.or.pntgrp.eq.'Cs  ')) then
        call coordswap(natoms,coord,2,3)
        call coordswap(3,tent,2,3)
        call coordswap(natoms,coord,1,2)
        call coordswap(3,tent,1,2)
       endif
C Check orientation, search for axes and planes if necessary
      call orcheck(natoms,atmass,coord,dcore(ic1),dcore(ic2),gtol,
     $pntgrp,cmpgrp,tent)
       if(embed.eq.'coulomb ') cmpgrp='C2  '
      write(varsfile) 'ten       ',9*ifltln,tent
      write(varsfile) 'cmpgrp    ',8,cmpgrp // '    '
      write(varsfile) 'pntgrp    ',8,pntgrp // '    '
C
      return
      end
C
***********************************************************************
      subroutine symadapt(natoms,c1,cmpgrp,gtol,bftrans,c2,nang,ncontr,
     $nangmax,nshrange,vi,vj,ct,ncartmax,ctostr,cartg,cmo,c,tra,r8core,
     $i4core,itol,symat,embed,natrange,nfunc)
***********************************************************************
* Determine the effect of symmetry operations on atoms
***********************************************************************
#include "MRCCCOMMON"
      integer maxsymop,maxptg,nirptg(nirmax),nangmax,i,j,k,l,m,n
      parameter(maxsymop=nirmax,maxptg=8) !Abelian groups only
      integer bftrans(nbasis,maxsymop),nsymop(maxptg),nop,iang,ibas,jbas
      integer natoms,iatoms,jatoms,ngrp,isymop,ct(*),ncartmax,icontr,ii
      integer nshrange(2,0:nangmax,natoms),nicart,nispher,ispher,jspher
      integer chartabs(maxsymop,nirmax,maxptg),nfunc(nirmax),icti,icj
      integer nang(natoms),ncontr(0:nangmax,natoms),tra(maxsymop),ici
      integer symat(natoms,nirmax),natrange(2,natoms)
      real*8 c1(3,natoms),gtol,r(3,3),alpha,sina,cosa,u,v,w,sum,dnrm2
      real*8 c2(3,natoms),vi(3,*),vj(3,*),c(nbasis)
      real*8 ctostr(ncartmax**2,0:nangmax),itol
      real*8 cmo(nbasis,nbasis),r8core(*),pggen(3,3,maxsymop)
      integer*4 i4core(*)
      character*1 cscr1(4)
      character*4 cmpgrp,symop(maxsymop,maxptg),ptglab(maxptg),cscr4
      character*4 irlab(nirmax,maxptg),symm
      character*8 embed
      equivalence(cscr1,cscr4)
      logical cartg,log
      data ptglab
     $/'C1  ','Ci  ','Cs  ','C2  ','C2v ','C2h ','D2 ','D2h '/
      data nirptg /1,2,2,2,4,4,4,8/
      data nsymop /1,2,2,2,4,4,4,8/
      data symop
     $/'E   ','    ','    ','    ','    ','    ','    ','    ', !C1
     $ 'E   ',' i  ','    ','    ','    ','    ','    ','    ', !Ci
     $ 'E   ','Qh  ','    ','    ','    ','    ','    ','    ', !Cs
     $ 'E   ','C2  ','    ','    ','    ','    ','    ','    ', !C2
     $ 'E   ','C2  ','Qh  ','Qv  ','    ','    ','    ','    ', !C2v
     $ 'E   ','C2z ',' i  ','Qh  ','    ','    ','    ','    ', !C2h
     $ 'E   ','C2z ','C2y ','C2x ','    ','    ','    ','    ', !D2
     $ 'E   ','C2z ','C2y ','C2x ',' i  ','Qxy ','Qxz ','Qyz '/ !D2h
      data irlab
     $/'A   ','    ','    ','    ','    ','    ','    ','    ', !C1
     $ 'A1g ','A1u ','    ','    ','    ','    ','    ','    ', !Ci
     $ 'A`  ','A"  ','    ','    ','    ','    ','    ','    ', !Cs
     $ 'A   ','B   ','    ','    ','    ','    ','    ','    ', !C2
     $ 'A1  ','B1  ','B2  ','A2  ','    ','    ','    ','    ', !C2v
     $ 'Ag  ','Bg  ','Au  ','Bu  ','    ','    ','    ','    ', !C2h
     $ 'A   ','B1  ','B2  ','B3  ','    ','    ','    ','    ', !D2
     $ 'Ag  ','B1g ','B2g ','B3g ','Au  ','B1u ','B2u ','B3u '/ !D2h
      data chartabs
     $/1, 0, 0, 0, 0, 0, 0, 0, !C1
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 1, 1, 0, 0, 0, 0, 0, 0, !Ci
     $ 1,-1, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 1, 1, 0, 0, 0, 0, 0, 0, !Cs
     $ 1,-1, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 1, 1, 0, 0, 0, 0, 0, 0, !C2
     $ 1,-1, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 1, 1, 1, 1, 0, 0, 0, 0, !C2v
     $ 1,-1, 1,-1, 0, 0, 0, 0,
     $ 1,-1,-1, 1, 0, 0, 0, 0,
     $ 1, 1,-1,-1, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 1, 1, 1, 1, 0, 0, 0, 0, !C2h
     $ 1,-1, 1,-1, 0, 0, 0, 0,
     $ 1, 1,-1,-1, 0, 0, 0, 0,
     $ 1,-1,-1, 1, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 1, 1, 1, 1, 0, 0, 0, 0, !D2
     $ 1, 1,-1,-1, 0, 0, 0, 0,
     $ 1,-1, 1,-1, 0, 0, 0, 0,
     $ 1,-1,-1, 1, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 0, 0, 0, 0, 0, 0, 0, 0,
     $ 1, 1, 1, 1, 1, 1, 1, 1, !D2h
     $ 1, 1,-1,-1, 1, 1,-1,-1,
     $ 1,-1, 1,-1, 1,-1, 1,-1,
     $ 1,-1,-1, 1, 1,-1,-1, 1,
     $ 1, 1, 1, 1,-1,-1,-1,-1,
     $ 1, 1,-1,-1,-1,-1, 1, 1,
     $ 1,-1, 1,-1,-1, 1,-1, 1,
     $ 1,-1,-1, 1,-1, 1, 1,-1/
C
      irlab(1,3)='A' // char(39)
C Serial no. of the group
      ngrp=1
       do while(cmpgrp.ne.ptglab(ngrp))
        ngrp=ngrp+1
       enddo
      nir=nirptg(ngrp)
      nop=nsymop(ngrp)
      write(varsfile)'irlab     ',nir*iintln/2,(irlab(ir,ngrp),ir=1,nir)
C Coulomb embedding
       if(embed.eq.'coulomb ') then
        nfunc=0
        cmo=0.d0
        call embedat(natoms,minpfile,symat,iout)
        n=0
         do iatoms=1,natoms
           if(symat(iatoms,1).eq.1) then
             do i=natrange(1,iatoms)+1,natrange(2,iatoms)
              n=n+1
              cmo(i,n)=1.d0
              nfunc(1)=nfunc(1)+1
             enddo
           endif
         enddo
         do iatoms=1,natoms
           if(symat(iatoms,1).eq.0) then
             do i=natrange(1,iatoms)+1,natrange(2,iatoms)
              n=n+1
              cmo(i,n)=1.d0
              nfunc(2)=nfunc(2)+1
             enddo
           endif
         enddo
        pggen=0.d0
         do ir=1,nir
           do i=1,3
            pggen(i,i,ir)=1.d0
           enddo
         enddo
         do i=1,natoms
          symat(i,1:nir)=i
         enddo
        goto 9876
       endif
C Print character table
      write(iout,*)
      write(iout,*) 'Character table for point group ' // trim(cmpgrp) 
     $// ':'
      write(iout,*)
      write(iout,"(10x,a3,1000a4)") (symop(isymop,ngrp),isymop=1,nop)
       do ir=1,nir
        write(iout,"(4x,a4,i3,1000i4)") irlab(ir,ngrp),
     $(chartabs(isymop,ir,ngrp),isymop=1,nop)
       enddo
      write(iout,*)
C Set keyword symm
      call getkey('symm',4,symm,4)
       if(symm.ne.'0   '.and.symm.ne.'1   '.and.symm.ne.'2   '.and.
     $symm.ne.'3   '.and.symm.ne.'4   '.and.symm.ne.'5   '.and.
     $symm.ne.'6   '.and.symm.ne.'7   '.and.symm.ne.'8   '.and.
     $symm.ne.'    ') then
        ir=0
        log=.true.
         do while(ir.lt.nir.and.log)
          ir=ir+1
          call lowercase(irlab(ir,ngrp),cscr4,4)
           if(symm.eq.cscr4) then
            log=.false.
            write(symm,"(i4)") ir
            symm=adjustl(symm)
           endif
         enddo
         if(log) then
          write(iout,*) 'Invalid option for keyword "symm"!'
          call mrccend(1)
         endif
        call changekey('symm',4,symm,4)
       endif
C Loop over symmetry operations
       do isymop=1,nop
        cscr4=symop(isymop,ngrp)
c       write(6,*) cscr4
        call dfillzero(r,9)
C E
         if(symop(isymop,ngrp).eq.'E   ') then
          r(1,1)=1.d0
          r(2,2)=1.d0
          r(3,3)=1.d0
C Inversion
         else if(symop(isymop,ngrp).eq.' i  ') then
          r(1,1)=-1.d0
          r(2,2)=-1.d0
          r(3,3)=-1.d0
C Rotations
         else if(cscr1(1).eq.'C') then
          read(cscr1(2),*) n
          alpha=2.d0*pi/dble(n)
          sina=dsin(alpha)
          cosa=dcos(alpha)
          u=0.d0
          v=0.d0
          w=0.d0
           if(cscr1(3).eq.'x') then
            u=1.d0
           else if(cscr1(3).eq.'y') then
            v=1.d0
           else
            w=1.d0
           endif
          r(1,1)=u**2+(1.d0-u**2)*cosa
          r(1,2)=u*v*(1.d0-cosa)-w*sina
          r(1,3)=u*w*(1.d0-cosa)+v*sina
          r(2,1)=u*v*(1.d0-cosa)+w*sina
          r(2,2)=v**2+(1.d0-v**2)*cosa
          r(2,3)=v*w*(1.d0-cosa)-u*sina
          r(3,1)=u*w*(1.d0-cosa)-v*sina
          r(3,2)=v*w*(1.d0-cosa)+u*sina
          r(3,3)=w**2+(1.d0-w**2)*cosa
C Reflections
         else if(cscr1(1).eq.'Q') then
          r(1,1)=1.d0
          r(2,2)=1.d0
          r(3,3)=1.d0
           if((cscr1(2).eq.'x'.and.cscr1(3).eq.'y').or.
     $        (cscr1(2).eq.'h'.and.cmpgrp.eq.'C2h ')) then
            r(3,3)=-1.d0
           else if((cscr1(2).eq.'x'.and.cscr1(3).eq.'z').or.
     $              cscr1(2).eq.'v') then
            r(2,2)=-1.d0
           else
            r(1,1)=-1.d0
           endif
         else
          write(iout,*)'Symmetry operation ' // trim(symop(isymop,ngrp))
     $// ' is not implemented!'
          call mrccend(1)
         endif
        pggen(1:3,1:3,isymop)=r
C Transformation of atoms
        call dgemm('t','n',3,natoms,3,1.d0,r,3,c1,3,0.d0,c2,3)
        ibas=0
         do iatoms=1,natoms
          jatoms=1
           do while(jatoms.le.natoms.and.
     $       (dabs(c1(1,iatoms)-c2(1,jatoms)).gt.gtol.or.
     $        dabs(c1(2,iatoms)-c2(2,jatoms)).gt.gtol.or.
     $        dabs(c1(3,iatoms)-c2(3,jatoms)).gt.gtol))
            jatoms=jatoms+1
           enddo
           if(jatoms.gt.natoms) then
            write(iout,*)'Fatal error at symmetry adaptation!'
            call mrccend(1)
           endif
          symat(iatoms,isymop)=jatoms
c         write(6,"(100i3)") iatoms,jatoms
C Transformation of basis functions
           do iang=0,nang(iatoms)
            nicart=(iang+1)*(iang+2)/2
            nispher=2*iang+1
             if(cartg) nispher=nicart
            ici=0
             do i=0,iang
               do k=0,iang-i
                m=iang-i-k
                ici=ici+1
                call dfillzero(vi(1,ici),3)
                call dfillzero(vj(1,ici),3)
                 do l=1,3
                  vi(l,ici)=vi(l,ici)+dble(i)*r(1,l)**i
                  vi(l,ici)=vi(l,ici)+dble(k)*r(2,l)**k
                  vi(l,ici)=vi(l,ici)+dble(m)*r(3,l)**m
                 enddo
                vj(1,ici)=vj(1,ici)+dble(i)
                vj(2,ici)=vj(2,ici)+dble(k)
                vj(3,ici)=vj(3,ici)+dble(m)
                 if(iang.gt.0) then
                  sum=1.d0
                   do l=1,3
                     if(dabs(vi(l,ici)).gt.1d-5) sum=sum*vi(l,ici)
                   enddo
                   if(sum.gt.0.d0) then
                     do l=1,3
                      vi(l,ici)=dabs(vi(l,ici))
                     enddo
                   else
                     do l=1,3
                      vi(l,ici)=-dabs(vi(l,ici))
                     enddo
                   endif
                  sum=1.d0
                   do l=1,3
                     if(dabs(vj(l,ici)).gt.1d-5) sum=sum*vj(l,ici)
                   enddo
                   if(sum.gt.0.d0) then
                     do l=1,3
                      vj(l,ici)=dabs(vj(l,ici))
                     enddo
                   else
                     do l=1,3
                      vj(l,ici)=-dabs(vj(l,ici))
                     enddo
                   endif
                 endif
c         write(6,"(a4,100i3)") 'ici1',i,k,m
c         write(6,"(100f4.0)") vi(1,ici),vi(2,ici),vi(3,ici)
c         write(6,"(100f4.0)") vj(1,ici),vj(2,ici),vj(3,ici)
               enddo
             enddo
             do ispher=1,nispher
               do jspher=1,nispher
                log=.true.
                ii=1
                 do icti=1,nicart
                  u=ctostr((icti-1)*nispher+ispher,iang)
                  v=ctostr((icti-1)*nispher+jspher,iang)
                   if((dabs(u*vi(1,icti)-v*vj(1,icti)).gt.gtol.or.
     $                 dabs(u*vi(2,icti)-v*vj(2,icti)).gt.gtol.or.
     $                 dabs(u*vi(3,icti)-v*vj(3,icti)).gt.gtol).and.
     $                (dabs(u*vi(1,icti)+v*vj(1,icti)).gt.gtol.or.
     $                 dabs(u*vi(2,icti)+v*vj(2,icti)).gt.gtol.or.
     $                 dabs(u*vi(3,icti)+v*vj(3,icti)).gt.gtol)) then
                     log=.false.
                     exit
                   else
                     if(dabs(u*vi(1,icti)+v*vj(1,icti)).le.gtol.and.
     $                  dabs(u*vi(2,icti)+v*vj(2,icti)).le.gtol.and.
     $                  dabs(u*vi(3,icti)+v*vj(3,icti)).le.gtol.and.
     $                 (dabs(u*vi(1,icti)).gt.gtol.or.
     $                  dabs(u*vi(2,icti)).gt.gtol.or.
     $                  dabs(u*vi(3,icti)).gt.gtol)) ii=-1
                   endif
                 enddo
                 if(log) then
                  ct(ispher)=ii*jspher
                  exit
                 endif
                 if(log) exit
               enddo
             enddo
             if(.not.log) then
              write(iout,*)'Fatal error at symmetry adaptation!'
              call mrccend(1)
             endif
C
            jbas=nshrange(1,iang,jatoms)
             do icontr=1,ncontr(iang,iatoms)
               do ispher=1,nispher
                ibas=ibas+1
      bftrans(ibas,isymop)=isign(jbas+iabs(ct(ispher)),ct(ispher))
c         write(6,"(100i4)") ibas,bftrans(ibas,isymop)
               enddo
              jbas=jbas+nispher
             enddo
           enddo
         enddo
       enddo
C Symmetry adaptation of basis functions
      write(iout,*) 'Number of basis functions per irrep:'
      jbas=0
      ii=0
       do ir=1,nir
        nfunc(ir)=0
         do ibas=1,nbasis
           if(jbas.lt.nbasis) then
            call dfillzero(c,nbasis)
             do isymop=1,nop
              tra(isymop)=iabs(bftrans(ibas,isymop))
              c(tra(isymop))=c(tra(isymop))+
     $dble(isign(1,bftrans(ibas,isymop))*chartabs(isymop,ir,ngrp))
             enddo
c       write(6,"(1000f6.2)") (c(i),i=1,nbasis)
            sum=dnrm2(nbasis,c,1)
             if(sum.gt.1d-5) then
              sum=1.d0/sum
              i=nbasis+1
               do isymop=1,nop
                i=min(i,tra(isymop))
               enddo
               if(c(i).lt.0.d0) sum=-sum
              call dscal(nbasis,sum,c,1)
              log=.false.
               do i=ii+1,jbas
                log=.true.
                 do isymop=1,nop
                   if(cmo(tra(isymop),i).ne.c(tra(isymop))) then
                    log=.false.
                    exit
                   endif
                 enddo
                 if(log) exit
               enddo
               if(.not.log) then
                jbas=jbas+1
                nfunc(ir)=nfunc(ir)+1
                call dcopy(nbasis,c,1,cmo(1,jbas),1)
c       write(6,*) ir,nfunc(ir),jbas
c       write(6,"(1000f6.2)") (c(i),i=1,nbasis)
               endif
             endif
           endif
         enddo
        ii=ii+nfunc(ir)
        write(iout,"(4x,a4,i5)") irlab(ir,ngrp),nfunc(ir)
       enddo
C Save variables and symmetry functions
9876  continue
      write(varsfile) 'nir       ',iintln,nir
      write(varsfile) 'nfunc     ',nir*iintln,(nfunc(ir),ir=1,nir)
      write(varsfile) 'pggen     ',9*nir*ifltln,
     $(pggen(1:3,1:3,ir),ir=1,nir)
      write(varsfile) 'chartab   ',nirmax**2*iintln,
     $chartabs(1:nirmax,1:nirmax,ngrp)
      write(varsfile) 'symat     ',iintln*nir*natoms,
     $symat(1:natoms,1:nir)
      open(scrfile1,file='SYMTRA',form='unformatted')
      call wtdmx(r8core,i4core,cmo,scrfile1,itol,nbasis,nbasis)
      close(scrfile1)
      write(iout,*)
C
      return
      end
C
***********************************************************************
      subroutine coordswap(natoms,coord,ii,jj)
***********************************************************************
* Interchanges components of Cartesian coordinates
***********************************************************************
      implicit none
      integer natoms,ii,jj,iatoms
      real*8 coord(3,natoms),sum
C
       do iatoms=1,natoms
        sum=coord(ii,iatoms)
        coord(ii,iatoms)=coord(jj,iatoms)
        coord(jj,iatoms)=sum
       enddo
C
      return
      end
C
************************************************************************
      subroutine intdist(natoms,coord,distc)
************************************************************************
* Calculate interatomic distances
************************************************************************
#include "MRCCCOMMON"
      integer natoms,iatoms,jatoms
      real*8 coord(3,natoms),distc(natoms,natoms),avgd
      character*8 scfalg
      character*20 dfbasis_scf
C
      avgd=0.d0
       do iatoms=1,natoms
        distc(iatoms,iatoms)=0.d0
         do jatoms=iatoms+1,natoms
          distc(iatoms,jatoms)=dsqrt(
     $(coord(1,iatoms)-coord(1,jatoms))**2+
     $(coord(2,iatoms)-coord(2,jatoms))**2+
     $(coord(3,iatoms)-coord(3,jatoms))**2)
          distc(jatoms,iatoms)=distc(iatoms,jatoms)
          avgd=avgd+distc(iatoms,jatoms)
c       write(6,"(2i3,2x,f9.4)") iatoms,jatoms,distc(iatoms,jatoms)
         enddo
       enddo
      write(varsfile) 'distc     ',ifltln*natoms**2,distc
C Select SCF algorithm
       if(natoms.ge.2) avgd=avgd/dfloat(natoms*(natoms-1)/2)
      call getkey('scfalg',6,scfalg,8)
      call getkey('dfbasis_scf',11,dfbasis_scf,20)
       if(trim(scfalg).eq.'auto') then
         if((avgd.gt.14.d0.and.natoms.gt.100).or.natoms.gt.150.or.
     $      (dfbasis_scf.ne.'none                '.and.natoms.ge.20
c    $.and.(avgd.gt.10.d0.and.natoms.gt.40 ).or.natoms.gt.70)
     $)) then
          scfalg='direct  '
         else
          scfalg='disk    '
          call changekey('dfalg',5,'invsqrt ',8)
         endif
        call changekey('scfalg',6,scfalg,8)
       endif
C
      return
      end
C
************************************************************************
      real*8 function nucrep(natoms,coord,atchg)
************************************************************************
* Calculate nuclear repulsion energy
************************************************************************
      implicit none
      integer natoms,iatoms,jatoms
      real*8 coord(3,natoms),atchg(natoms),r
C
      nucrep=0.d0
C$OMP PARALLEL DO Schedule(Dynamic) DEFAULT(SHARED)
C$OMP& PRIVATE(iatoms,jatoms,r)
C$OMP& REDUCTION(+:nucrep)
       do iatoms=1,natoms
         do jatoms=1,iatoms-1
          r=dsqrt((coord(1,iatoms)-coord(1,jatoms))**2+
     $            (coord(2,iatoms)-coord(2,jatoms))**2+
     $            (coord(3,iatoms)-coord(3,jatoms))**2)
           if(r.gt.1d-12) nucrep=nucrep+atchg(iatoms)*atchg(jatoms)/r
         enddo
       enddo
C$OMP END PARALLEL DO
C
      return
      end
C
************************************************************************
      subroutine nuccontr(natoms,coord,atnum,dip,sec,thi)
************************************************************************
* Calculate nuclear contribution to dipole, second, and third  moments
************************************************************************
#include "MRCCCOMMON"
      integer natoms,iatoms,atnum(natoms),i,j,k
      real*8 coord(3,natoms),dip(3),sec(3,3),thi(3,3,3)
C Dipole moment
       do i=1,3
        dip(i)=0.d0
         do iatoms=1,natoms
          dip(i)=dip(i)+dble(atnum(iatoms))*coord(i,iatoms)
         enddo
       enddo
      write(varsfile) 'nucdip    ',ifltln*3,dip
C Second moment
       do i=1,3
         do j=1,i
          sec(i,j)=0.d0
           do iatoms=1,natoms
            sec(i,j)=sec(i,j)+dble(atnum(iatoms))*coord(i,iatoms)
     $                                           *coord(j,iatoms)
           enddo
          sec(j,i)=sec(i,j)
         enddo
       enddo
      write(varsfile) 'nucsec    ',ifltln*9,sec
C Third moment
       do i=1,3
         do j=1,i
           do k=1,j
            thi(i,j,k)=0.d0
             do iatoms=1,natoms
              thi(i,j,k)=thi(i,j,k)+dble(atnum(iatoms))*coord(i,iatoms)
     $                                                 *coord(j,iatoms)
     $                                                 *coord(k,iatoms)
             enddo
            thi(i,k,j)=thi(i,j,k)
            thi(j,k,i)=thi(i,j,k)
            thi(j,i,k)=thi(i,j,k)
            thi(k,i,j)=thi(i,j,k)
            thi(k,j,i)=thi(i,j,k)
           enddo
         enddo
       enddo
      write(varsfile) 'nucthi    ',ifltln*27,thi
C
      return
      end
C
************************************************************************
      subroutine cart_gto_to_sphharm(l,ctspmat,ctspmat2,spctspmat,
     $spctspmat2,cartg)
************************************************************************
* This subroutine generates the transformation matrix, 
* to be used to convert Cartesian GTOs to spherical-harmonic GTOs
************************************************************************
      implicit none
      integer l,i,j,k,m,ii,jj,kk,mm
      real*8 getcf,iscr((l+1)*(l+2)/2)
      real*8 ctspmat(-l:l,(l+1)*(l+2)/2),norm,normcoeff
      real*8 ctspmat2((l+1)*(l+2)/2,(l+1)*(l+2)/2),spctspmat,spctspmat2
      logical cartg,log
C
       if(cartg) then
        call dfillzero(ctspmat,((l+1)*(l+2)/2)**2)
c        if(l.eq.1) then ! px, py, pz order for p functions
c         ctspmat2(1,3)=1.d0
c         ctspmat2(2,2)=1.d0
c         ctspmat2(3,1)=1.d0
c        else
           do i=1,(l+1)*(l+2)/2
            ctspmat2(i,i)=1.d0
           enddo
c        endif
        call sppack((l+1)*(l+2)/2,(l+1)*(l+2)/2,ctspmat2,spctspmat2,
     $spctspmat2,1d-10)
       else
         do mm=-l,l !Loop over spherical GTOs
           if(l.eq.1) then ! pz, py, px order for p functions
             if(mm.eq.-1) m= 0
             if(mm.eq. 0) m=-1
             if(mm.eq. 1) m= 1
c          if(l.eq.1) then ! px, py, pz order for p functions
c            if(mm.eq.-1) m= 1
c            if(mm.eq. 0) m=-1
c            if(mm.eq. 1) m= 0
           else            ! m = -l, -l+1, ..., l-1, l otherwise
            m=mm
           endif
          ii=0
           do i=0,l !Loop over Cartesian GTOs
             do j=0,l-i
              k=l-i-j
C z, y, x
              ii=ii+1
              iscr(ii)=getcf(i,j,k,l,m)
c             ctspmat(m,ii)=dble(getcf(i,j,k,l,m))
c          write(6,"(100i2)") ii,i,j,k
             enddo   
           enddo
C Integer norm
c         jj=0
c          do ii=1,(l+1)*(l+2)/2
c           jj=max(jj,iabs(iscr(ii)))
c          enddo
c         norm=1.d0
c          do kk=1,jj
c           log=.true.
c            do ii=1,(l+1)*(l+2)/2
c              if(mod(iabs(iscr(ii)),kk).ne.0) log=.false.
c            enddo
c            if(log) norm=dabs(dble(kk))
c          enddo
C Standard norm, comment out following line for integer norm
          norm=1.d0/normcoeff(l,mm)
           do ii=1,(l+1)*(l+2)/2
            ctspmat(mm,ii)=dble(iscr(ii))/norm
c           ctspmat(mm,ii)=normcoeff(l,mm)*dble(iscr(ii))
           enddo
         enddo
c     write(6,*)
c      do m=-l,l
c       write(6,"(100f11.6)") (ctspmat(m,i),i=1,(l+1)*(l+2)/2)
c      enddo
        call sppack(2*l+1,(l+1)*(l+2)/2,ctspmat,spctspmat,spctspmat,
     $1d-10)
       endif
C
      return 
      end 
C
************************************************************************
      subroutine orcheck(natoms,atmass,coord,c1,c2,gtol,pntgrp,cmpgrp,
     $                   tent)
************************************************************************
* Check orientation, search for axes and planes if necessary
************************************************************************
#include "MRCCCOMMON"
      integer natoms,i,j,k,kinc,nv,npl,nc2,iax,ipl
      real*8 coord(3,natoms),vec(3),vec2(3),alpha,gtol
      real*8 atmass(natoms),c1(3,natoms),c2(3,natoms),norm,dnrm2
      real*8 tent(3,3),c3(3,3)
      logical log,check,lfound
      character*4 pntgrp,cmpgrp
      c3=0.d0
C Check for C2 axes
       if(cmpgrp.eq.'D2h '.or.cmpgrp.eq.'D2  '.or.cmpgrp.eq.'C2h '.or.
     $cmpgrp.eq.'C2v '.or.cmpgrp.eq.'C2  ') then
        nc2=0
         do i=1,3
          call rotate(natoms,pi,coord,c1,i)
           if(check(natoms,gtol,atmass,coord,c1)) then
            nc2=nc2+1
            iax=i
           endif
         enddo
C One C2 found, rotate to z axis
         if(nc2.eq.1.and.iax.ne.3) then
           if(iax.eq.1) then
            call coordswap(natoms,coord,1,3)
            call coordswap(3,tent,1,3)
           endif
           if(iax.eq.2) then
            call coordswap(natoms,coord,2,3)
            call coordswap(3,tent,2,3)
           endif
         endif
C No C2 found, search for first C2, rotate to z axis
         if(nc2.eq.0) then
          call getc2(natoms,atmass,coord,c1,gtol,vec)
          call dscal(3,1.d0/dnrm2(3,vec,1),vec,1)
          alpha=-dacos(vec(3))
c         alpha=dacos(vec(3))
          vec2(1)=vec(2)
          vec2(2)=-vec(1)
          vec2(3)=0.d0
          call grotate(natoms,alpha,coord,c1,vec2)
          call dcopy(3*natoms,c1,1,coord,1)
          call grotate(3,alpha,tent,c3,vec2)
          call dcopy(3*3,c3,1,tent,1)
          nc2=1
         endif
c        do i=1,natoms
c         write(iout,"(i3,3f14.8)") i,(coord(j,i),j=1,3)
c        enddo
C Search for second C2 (if any), rotate to x axis
         if(nc2.eq.1.and.(cmpgrp.eq.'D2h '.or.cmpgrp.eq.'D2  ')) then
          call getc2xy(natoms,atmass,coord,c1,gtol,vec,lfound)
          call dscal(3,1.d0/dnrm2(3,vec,1),vec,1)
          alpha=dsign(dacos(vec(1)),-vec(2))
          call rotate(natoms,alpha,coord,c1,3)
          call dcopy(3*natoms,c1,1,coord,1)
          call rotate(3,alpha,tent,c3,3)
          call dcopy(3*3,c3,1,tent,1)
         endif
       endif
C Check for symmetry planes
       if(cmpgrp.eq.'D2h '.or.cmpgrp.eq.'C2h '.or.cmpgrp.eq.'C2v '.or.
     $cmpgrp.eq.'Cs  ') then
        npl=0
         do i=1,3
          call reflect(natoms,coord,c1,i)
           if(check(natoms,gtol,atmass,coord,c1)) then
            npl=npl+1
            ipl=i
           endif
         enddo
C Move symmetry plane to yz for Cs group
         if(npl.eq.1.and.cmpgrp.eq.'Cs  '.and.ipl.ne.3) then
           if(ipl.eq.2) then
            call coordswap(natoms,coord,1,2)
            call coordswap(3,tent,1,2)
           endif
           if(ipl.eq.1) then
            call coordswap(natoms,coord,1,3)
            call coordswap(3,tent,1,3)
           endif
         endif
C No sufficent number of planes, search for one, rotate to yz
         if(npl.eq.0.or.(npl.eq.1.and.(cmpgrp.eq.'D2h '.or.
     $cmpgrp.eq.'C2v '))) then
          call getplanexy(natoms,atmass,coord,c1,gtol,vec)
          call dscal(3,1.d0/dnrm2(3,vec,1),vec,1)
          alpha=dsign(dacos(vec(1)),-vec(2))
          call rotate(natoms,alpha,coord,c1,3)
          call dcopy(3*natoms,c1,1,coord,1)
          call rotate(3,alpha,tent,c3,3)
          call dcopy(3*3,c3,1,tent,1)
         endif
       endif
C
      return
      end
C
************************************************************************
      subroutine getc2(natoms,atmass,coord,c1,gtol,zvec)
************************************************************************
* Search for C2 rotation axes
************************************************************************
#include "MRCCCOMMON"
      integer natoms,i,j,k
      integer naxis,maxn,iatoms,jatoms,katoms
      real*8 coord(3,natoms),vec(3),vec2(3),gtol,tp,rp,norm,zvec(3)
      real*8 atmass(natoms),c1(3,natoms),dnrm2
      logical check
C
       do iatoms=1,natoms
         if(dnrm2(3,coord(1,iatoms),1).gt.gtol) then
          call grotate(natoms,pi,coord,c1,coord(1,iatoms))
           if(check(natoms,gtol,atmass,coord,c1)) then
            call dcopy(3,coord(1,iatoms),1,zvec,1)
            return
           endif
           do jatoms=1,iatoms-1
            tp=0.d0
             do i=1,3
              vec(i)=(coord(i,iatoms)+coord(i,jatoms))/2.d0
              tp=tp+(coord(i,iatoms)-coord(i,jatoms))**2
             enddo
            tp=dsqrt(tp)
            rp=tp/(2.d0*dsin(pi/5.d0))
             if(dnrm2(3,vec,1).gt.gtol) then
              call grotate(natoms,pi,coord,c1,vec)
               if(check(natoms,gtol,atmass,coord,c1)) then
                call dcopy(3,vec,1,zvec,1)
                return
               endif
             endif
             do katoms=1,natoms
               if(katoms.ne.iatoms.and.katoms.ne.jatoms) then
                norm=0.d0
                 do i=1,3
                  vec2(i)=vec(i)-coord(i,katoms)
                  norm=norm+vec2(i)**2
                 enddo
                 if(norm.gt.gtol) then
                  norm=rp/dsqrt(norm)
                   do i=1,3
                    vec2(i)=norm*vec2(i)+coord(i,katoms)
                   enddo
                   if(dnrm2(3,vec2,1).gt.gtol) then
                    call grotate(natoms,pi,coord,c1,vec2)
                     if(check(natoms,gtol,atmass,coord,c1)) then
                      call dcopy(3,vec2,1,zvec,1)
                      return
                     endif
                   endif
                 endif
c      if(nrot.eq.5) then
c     write(6,*)'rp',rp*angtobohr
c      do k=1,natoms
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,k)*angtobohr,j=1,3)
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,iatoms)*angtobohr,j=1,3)
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,jatoms)*angtobohr,j=1,3)
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,katoms)*angtobohr,j=1,3)
c      enddo
c     write(66,"(a2,1x,3f12.6)") 'F ',(vec2(j)*angtobohr,j=1,3)
c     stop
c      endif
               endif
             enddo
           enddo
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine getc2xy(natoms,atmass,coord,c1,gtol,zvec,lfound)
************************************************************************
* Search for C2 rotation axes in the xy plane
************************************************************************
#include "MRCCCOMMON"
      integer natoms,i,j,k,iatoms,jatoms
      real*8 coord(3,natoms),vec(3),vec2(3),gtol,zvec(3),dnrm2
      real*8 atmass(natoms),c1(3,natoms)
      logical check,lfound
C
      lfound=.false.
       do iatoms=1,natoms
         if(dabs(coord(3,iatoms)).le.gtol.and.
     $             dnrm2(3,coord(1,iatoms),1).gt.gtol) then
          call grotate(natoms,pi,coord,c1,coord(1,iatoms))
           if(check(natoms,gtol,atmass,coord,c1)) then
            call dcopy(3,coord(1,iatoms),1,zvec,1)
            lfound=.true.
            return
           endif
         endif
         do jatoms=1,iatoms-1
           do i=1,3
            vec(i)=(coord(i,iatoms)+coord(i,jatoms))/2.d0
           enddo
           if(dabs(vec(3)).le.gtol.and.dnrm2(3,vec,1).gt.gtol) then
            call grotate(natoms,pi,coord,c1,vec)
             if(check(natoms,gtol,atmass,coord,c1)) then
              call dcopy(3,vec,1,zvec,1)
              lfound=.true.
              return
             endif
           endif
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine getplanexy(natoms,atmass,coord,c1,gtol,zvec)
************************************************************************
* Search for symmetry planes, surface normal in the xy plane
************************************************************************
#include "MRCCCOMMON"
      integer natoms,i,j,k,iatoms,jatoms
      real*8 coord(3,natoms),vec(3),vec2(3),gtol,zvec(3),dnrm2
      real*8 atmass(natoms),c1(3,natoms)
      logical check
C
      vec(3)=0.d0
      zvec(3)=0.d0
       do iatoms=1,natoms
         if(dnrm2(3,coord(1,iatoms),1).gt.gtol) then
          vec(1)= coord(2,iatoms) !Cross product with (0,0,1)
          vec(2)=-coord(1,iatoms)
          call greflect(natoms,coord,c1,vec)
           if(check(natoms,gtol,atmass,coord,c1)) then
            call dcopy(2,coord(1,iatoms),1,zvec,1)
            return
           endif
         endif
         do jatoms=1,iatoms-1
          vec(1)= (coord(2,iatoms)+coord(2,jatoms))/2.d0
          vec(2)=-(coord(1,iatoms)+coord(1,jatoms))/2.d0
           if(dnrm2(3,vec,1).gt.gtol) then
            call greflect(natoms,coord,c1,vec)
             if(check(natoms,gtol,atmass,coord,c1)) then
              zvec(1)=-vec(2)
              zvec(2)= vec(1)
c             call dcopy(3,vec,1,zvec,1)
              return
             endif
           endif
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine pgroup(natoms,atmass,coord,c1,c2,eig,gtol,etol,pntgrp,
     $cmpgrp,tent)
************************************************************************
* Determine the point group of the molecule
************************************************************************
#include "MRCCCOMMON"
      integer natoms,i,j,k,kinc,nv,nplane,nsaxis,ndaxis,ndplan,maxaxis
      parameter(maxaxis=24) ! Must be even!
      integer nrot,nsh(3),naxis,maxn,iatoms,jatoms,katoms,iax
      real*8 eig(3),coord(3,natoms),vec(3),vec2(3),rnv,alpha,gtol,tp,rp
      real*8 atmass(natoms),c1(3,natoms),c2(3,natoms),norm,etol,dnrm2
      real*8 tent(3,3),c3(3,3)
      logical invcen,planxy,log,check,planev,rotc2d,planed,rotsn,rots2n
      logical latop,lfound
      character*4 pntgrp,cmpgrp
      data nsh/3,2,1/
C
      c3=0.d0
      invcen=.false.
      planxy=.false.
      planev=.false.
      planed=.false.
      rotc2d=.false.
      rotsn=.false.
      rots2n=.false.
      latop=(eig(3)-eig(1)).gt.etol.and.(eig(3)-eig(2)).gt.etol.and.
     $(eig(2)-eig(1)).gt.etol
C Check for symmetry center
      call dcopy(natoms*3,coord,1,c2,1)
      call dscal(natoms*3,-1.d0,c2,1)
      invcen=check(natoms,gtol,atmass,coord,c2)
C Linear molecules
       if(eig(3).le.etol.and.dabs(eig(1)-eig(2)).le.etol) then
         if(invcen) then
          pntgrp='Dxh '
          cmpgrp='D2h '
         else
          pntgrp='Cxv '
          cmpgrp='C2v '
         endif
c       return
       endif
C Non-linear molecules
C Check for Cn proper rotation axes
      naxis=0
      nrot=0
       do i=1,3
         do maxn=2,maxaxis
          call rotate(natoms,2.d0*pi/dble(maxn),coord,c2,i)
           if(check(natoms,gtol,atmass,coord,c2).and.(.not.latop.or.
     $maxn.eq.2)) then
            iax=i
            naxis=naxis+1
            nrot=max(nrot,maxn)
           endif
         enddo
       enddo
C One C2 found, search for further ones
       if(naxis.eq.1.and.nrot.eq.2.and.iax.eq.3) then
        call getc2xy(natoms,atmass,coord,c1,gtol,vec,lfound)
         if(lfound) then !Found another one, rotate to x
          naxis=naxis+1
          call dscal(3,1.d0/dnrm2(3,vec,1),vec,1)
          alpha=dsign(dacos(vec(1)),-vec(2))
          call rotate(natoms,alpha,coord,c1,3)
          call dcopy(3*natoms,c1,1,coord,1)
          call rotate(3,alpha,tent,c3,3)
          call dcopy(3*3,c3,1,tent,1)
          call rotate(natoms,pi,coord,c2,2) !Check y
           if(check(natoms,gtol,atmass,coord,c2)) naxis=naxis+1
         endif
       endif
C Check for Cn proper rotation axes
       if(dabs(eig(3)-eig(2)).le.etol.or.
     $    dabs(eig(2)-eig(1)).le.etol)then
c      if(dabs(eig(3)-eig(1)).le.etol) then
c       maxn=5
       do maxn=2,maxaxis
         do iatoms=1,natoms
           if(dnrm2(3,coord(1,iatoms),1).gt.gtol) then
            call grotate(natoms,2.d0*pi/dble(maxn),coord,c2,
     $coord(1,iatoms))
             if(check(natoms,gtol,atmass,coord,c2)) nrot=max(nrot,maxn)
             do jatoms=1,iatoms-1
              tp=0.d0
               do i=1,3
                vec(i)=(coord(i,iatoms)+coord(i,jatoms))/2.d0
                tp=tp+(coord(i,iatoms)-coord(i,jatoms))**2
               enddo
              tp=dsqrt(tp)
              rp=tp/(2.d0*dsin(pi/5.d0))
               if(dnrm2(3,vec,1).gt.gtol) then
                call grotate(natoms,2.d0*pi/dble(maxn),coord,c2,vec)
                 if(check(natoms,gtol,atmass,coord,c2)) 
     $nrot=max(nrot,maxn)
               endif
               do katoms=1,natoms
                 if(katoms.ne.iatoms.and.katoms.ne.jatoms) then
                  norm=0.d0
                   do i=1,3
                    vec2(i)=vec(i)-coord(i,katoms)
                    norm=norm+vec2(i)**2
                   enddo
                   if(norm.gt.gtol) then
                    norm=rp/dsqrt(norm)
                     do i=1,3
                      vec2(i)=norm*vec2(i)+coord(i,katoms)
                     enddo
                     if(dnrm2(3,vec2,1).gt.gtol) then
                      call grotate(natoms,2.d0*pi/dble(maxn),coord,c2,
     $vec2)
                       if(check(natoms,gtol,atmass,coord,c2))
     $nrot=max(nrot,maxn)
                     endif
                   endif
c      if(nrot.eq.5) then
c     write(6,*)'rp',rp*angtobohr
c      do k=1,natoms
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,k)*angtobohr,j=1,3)
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,iatoms)*angtobohr,j=1,3)
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,jatoms)*angtobohr,j=1,3)
c     write(66,"(a2,1x,3f12.6)") 'C ',(coord(j,katoms)*angtobohr,j=1,3)
c      enddo
c     write(66,"(a2,1x,3f12.6)") 'F ',(vec2(j)*angtobohr,j=1,3)
c     stop
c      endif
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
       endif
C Check for Sn improper rotation axes
      nsaxis=0
       do i=1,3
         do maxn=2,maxaxis
          call rotate(natoms,2.d0*pi/dble(maxn),coord,c1,i)
          call reflect(natoms,c1,c2,nsh(i))
           if(check(natoms,gtol,atmass,coord,c2)) nsaxis=nsaxis+1
         enddo
       enddo
C Check for Sn and S2n improper rotations around proper rotation axis
       if(naxis.ne.0) then
        alpha=pi/dble(nrot)
         do i=1,2
          call rotate(natoms,alpha,coord,c1,3)
          call reflect(natoms,c1,c2,1)
           if(check(natoms,gtol,atmass,coord,c2).and.i.eq.1) then
            rots2n=.true.
           else if(check(natoms,gtol,atmass,coord,c2).and.i.eq.2) then
            rotsn=.true.
           endif
          alpha=2.d0*alpha
         enddo
       endif
C Check for symmetry planes
      nplane=0
       do i=1,3
        call reflect(natoms,coord,c2,i)
         if(check(natoms,gtol,atmass,coord,c2)) then
          nplane=nplane+1
           if(i.eq.1) planxy=.true.
         endif
       enddo
C Determine point group
       if(dabs(eig(3)-eig(1)).le.etol) then
C Spherical top molecules
         if(.not.invcen) then
          pntgrp='Td  '
          cmpgrp='C2v '
         else
           if(nrot.eq.5) then
            pntgrp='Ih  '
            cmpgrp='D2h '
           else
            pntgrp='Oh  '
            cmpgrp='D2h '
           endif
         endif
       else if(latop.or.nrot.eq.0) then
C Asymmetric top molecules
         if(naxis.eq.0) then
           if(nplane.gt.0) then
            pntgrp='Cs  '
            cmpgrp='Cs  '
           else
             if(invcen) then
              pntgrp='Ci  '
              cmpgrp='Ci  '
             else
              pntgrp='C1  '
              cmpgrp='C1  '
             endif
           endif
         else
           if(naxis.eq.1) then
             if(nplane.eq.0) then
              pntgrp='C2  '
              cmpgrp='C2  '
             else
               if(invcen) then
                pntgrp='C2h '
                cmpgrp='C2h '
               else
                pntgrp='C2v '
                cmpgrp='C2v '
               endif
             endif
           else
             if(invcen) then
              pntgrp='D2h '
              cmpgrp='D2h '
             else
              pntgrp='D2  '
              cmpgrp='D2  '
             endif
           endif
         endif
       else if(dabs(eig(3)-eig(1)).gt.etol.and.
     $(dabs(eig(3)-eig(2)).le.etol.or.dabs(eig(2)-eig(1)).le.etol)) then
C Symmetric top molecules
        nv=1
         do while(nv.le.natoms.and.dabs(coord(1,nv)).le.gtol.and.
     $dabs(coord(2,nv)).le.gtol)
          nv=nv+1
         enddo
         if(nv.le.natoms) then
          rnv=dsqrt(coord(1,nv)**2+coord(2,nv)**2)
          alpha=dsign(dacos(coord(1,nv)/rnv),-coord(2,nv))
C Move atom nv to the xz plane via rotation around the z-axis
          call rotate(natoms,alpha,coord,c2,3)
          call dcopy(natoms*3,c2,1,coord,1)
          call rotate(3,alpha,tent,c3,3)
          call dcopy(3*3,c3,1,tent,1)
         endif
C Reflection to the xz-plane
        call reflect(natoms,coord,c2,2)
         if(check(natoms,gtol,atmass,coord,c2)) planev=.true.
C Check for C2' rotations
        kinc=1
          ndaxis=0
         do while(ndaxis.ne.nrot.and.kinc.lt.maxaxis)
          ndaxis=0
           do k=0,179,kinc
            call rotate(natoms,dble(k)*pi/180.d0,coord,c1,3)
            call rotate(natoms,pi,c1,c2,1)
             if(check(natoms,gtol,atmass,c1,c2)) ndaxis=ndaxis+1
            kinc=kinc+1
           enddo
         enddo
        rotc2d=ndaxis.eq.nrot
C Check for sigma_d rotations
        kinc=1
          ndplan=0
         do while(ndplan.ne.nrot.and.kinc.lt.maxaxis)
          ndplan=0
           do k=0,179,kinc
            call rotate(natoms,dble(k)*pi/180.d0,coord,c1,3)
            call reflect(natoms,c1,c2,2)
             if(check(natoms,gtol,atmass,c1,c2)) ndplan=ndplan+1
           enddo
          kinc=kinc+1
         enddo
        planed=ndplan.eq.nrot
C Determine point group
         if(nrot.gt.2) then
           if(planxy.and.planev) then
            write(pntgrp,'(a,i1,a1)') 'D',nrot,'h'
             if(mod(nrot,2).eq.1) then
              cmpgrp='C2v '
             else
              cmpgrp='D2h '
             endif
            return
           elseif(.not.planxy.and.planev.and..not.rotsn.and..not.
     $rots2n) then
            write(pntgrp,'(a,i1,a1)') 'C',nrot,'v'
             if(mod(nrot,2).eq.1) then
              cmpgrp='Cs  '
             else
              cmpgrp='C2v '
             endif
            return
           elseif(.not.planev.and.planxy) then
            write(pntgrp,'(a,i1,a1)') 'C',nrot,'h'
             if(mod(nrot,2).eq.1) then
              cmpgrp='Cs  '
             else
              cmpgrp='C2h '
             endif
            return
           endif
         else
           if(naxis.eq.3) then
            pntgrp='D2d '
            cmpgrp='C2v '
            return
           endif
         endif
C
         if(rotc2d) then
           if(planed) then
c            if(nrot.eq.0) then
c             pntgrp='Cs  '
c             cmpgrp='Cs  '
c             return
c            endif
            write(pntgrp,'(a,i1,a1)') 'D',nrot,'d'
             if(pntgrp.eq.'D3d ') then
              cmpgrp='C2h '
             else if(mod(nrot,2).eq.1) then
              cmpgrp='Cs  '
             else
              cmpgrp='C2v '
             endif
            return
           else
            write(pntgrp,'(a,i1)') 'D',nrot
             if(mod(nrot,2).eq.1) then
              cmpgrp='C2  '
             else
              cmpgrp='D2  '
             endif
            return
           endif
         endif
C
         if(rots2n) then
          write(pntgrp,'(a,i1)') 'S',2*nrot
           if(mod(nrot,2).eq.1) then
            cmpgrp='Ci  '
           else
            cmpgrp='C2  '
           endif
          return
         else
          write(pntgrp,'(a,i1)') 'C',nrot
           if(mod(nrot,2).eq.1) then
            cmpgrp='C1  '
           else
            cmpgrp='C2  '
           endif
          return
         endif
       endif
C
      return
      end
C
************************************************************************
      logical function check(natoms,gtol,atmass,c1,c2)
************************************************************************
* Check if transformed coordinates are identical to the original ones
************************************************************************
      implicit none
      integer i,j,natoms
      real*8 c1(3,natoms),c2(3,natoms),atmass(natoms),gtol
C
      check=.false.
       do i=1,natoms
        j=1
         do while(j.le.natoms.and.(dabs(atmass(i)-atmass(j)).gt.gtol.or.
     $        dabs(c1(1,i)-c2(1,j)).gt.gtol.or.
     $        dabs(c1(2,i)-c2(2,j)).gt.gtol.or.
     $        dabs(c1(3,i)-c2(3,j)).gt.gtol))
          j=j+1
         enddo
         if(j.gt.natoms) return
       enddo
      check=.true.
C
      return
      end
C
************************************************************************
      subroutine rotate(natoms,alpha,c1,c2,xyz)
************************************************************************
* Rotate the molecule around the x, y, or z axis
************************************************************************
      implicit none
      integer i,j,k,natoms,xyz
      real*8 r(3,3),c1(3,natoms),c2(3,natoms),sina,cosa,alpha
C
      call dfillzero(r,9)
      sina=dsin(alpha)
      cosa=dcos(alpha)
       if(xyz.eq.1) then
c x axis
        r(1,1)=1.d0
        r(2,2)=cosa
        r(2,3)=sina
        r(3,2)=-sina
        r(3,3)=cosa
       else if(xyz.eq.2) then
c y axis
        r(1,1)=cosa
        r(1,3)=-sina
        r(2,2)=1.d0
        r(3,1)=sina
        r(3,3)=cosa
       else if(xyz.eq.3) then
c z axis
        r(1,1)=cosa
        r(1,2)=sina
        r(2,1)=-sina
        r(2,2)=cosa
        r(3,3)=1.d0
       endif
      call dgemm('t','n',3,natoms,3,1.d0,r,3,c1,3,0.d0,c2,3)
C
      return
      end
C
************************************************************************
      subroutine grotate(natoms,alpha,c1,c2,vec)
************************************************************************
* Rotate the molecule around an arbitrary axis defined by (u,v,w)
************************************************************************
      implicit none
      integer i,j,k,natoms
      real*8 r(3,3),c1(3,natoms),c2(3,natoms),vec(3),sina,cosa,alpha
      real*8 u,v,w,norm
C
      sina=dsin(alpha)
      cosa=dcos(alpha)
      norm=0.d0
       do i=1,3
        norm=norm+vec(i)**2
       enddo
      norm=dsqrt(norm)
      u=vec(1)/norm
      v=vec(2)/norm
      w=vec(3)/norm
      r(1,1)=u**2+(1.d0-u**2)*cosa
      r(1,2)=u*v*(1.d0-cosa)-w*sina
      r(1,3)=u*w*(1.d0-cosa)+v*sina
      r(2,1)=u*v*(1.d0-cosa)+w*sina
      r(2,2)=v**2+(1.d0-v**2)*cosa
      r(2,3)=v*w*(1.d0-cosa)-u*sina
      r(3,1)=u*w*(1.d0-cosa)-v*sina
      r(3,2)=v*w*(1.d0-cosa)+u*sina
      r(3,3)=w**2+(1.d0-w**2)*cosa
      call dgemm('t','n',3,natoms,3,1.d0,r,3,c1,3,0.d0,c2,3)
C
      return
      end
C
************************************************************************
      subroutine greflect(natoms,c1,c2,vec)
************************************************************************
* Reflection through an arbitrary plane given by surface normal vec
************************************************************************
      implicit none
      integer i,j,k,natoms
      real*8 r(3,3),c1(3,natoms),c2(3,natoms),vec(3),dnrm2
C
      call dscal(3,1.d0/dnrm2(3,vec,1),vec,1)
      r=0.d0
      r(1,1)=1.d0
      r(2,2)=1.d0
      r(3,3)=1.d0
      call dger(3,3,-2.d0,vec,1,vec,1,r,3)
      call dgemm('t','n',3,natoms,3,1.d0,r,3,c1,3,0.d0,c2,3)
C
      return
      end
C
************************************************************************
      subroutine reflect(natoms,c1,c2,xyz)
************************************************************************
* Reflection through xy, xz, and yz planes
************************************************************************
      implicit none
      integer natoms,xyz,i,ii
      real*8 c1(3,natoms),c2(3,natoms)
C
      call dcopy(natoms*3,c1,1,c2,1)
      ii=3-xyz+1
       do i=1,natoms
        c2(ii,i)=-c1(ii,i)
       enddo
C
      return
      end
C
***********************************************************************
      subroutine generateboys(n,boysval)
***********************************************************************
#include "MRCCCOMMON"
      real*8 boysval(0:n,0:1480),to_dpr,chtdbl
      character*22 b1(1024),b2(456)
C Arrays
************************************************************************
      integer*1 h(arrs),div(arrs),yy(arrs),xx(arrs),fact(arrs),
     $          scdif(arrs),temp(arrs),ka(arrs),fact1(arrs),scr1(arrs),
     $          scr2(arrs),tp(arrs),mn(arrs),bt(arrs),bz(arrs),res(arrs)
     $          ,tmp1(arrs),tmp2(arrs),tmp3(arrs),tmp4(arrs),xpo(arrs),
     $          pointa(arrs)
C Signs
      integer*1 hs,divs,yys,xxs,facts,tps,mns,fact1s,bts,bzs,ress,scr1s,
     $          scr2s,scdifs,temps,kas,tmp1s,tmp2s,tmp3s,tmp4s,xpos
     $          ,points
C Exponents
      integer   hx,divx,yyx,xxx,factx,factx1,btx,scr1x1,scr2x2,scdifx,
     $          tempx,kax,ii,i,k,tpx,mnx,bze,
     $          rese,tmp1e,tmp2e,tmp3e,tmp4e,xpoe,n,kk,nn,pointx,point

      data b1/'1175773869018734370101', '1119781347129319740001',
     $'1066456774166844012501', '1015672959462047777501',
     $'9673087790522022999902', '9212488861727405947602',
     $'8773834355708819035702', '8356078209810530261402',
     $'7958224251334571671802', '7579323816971800808602',
     $'7218473485878264504602', '6874812920969153016602',
     $'6547522813261971994002', '6235822924347502783902',
     $'5938970222302260845302', '5656257106580062031802',
     $'5387009717633504631802', '5130586327219183052202',
     $'4886375805533754152302', '4653796161512043403502',
     $'4432293152793647037102', '4221338962031378741502',
     $'4020430936373825806202', '3829090387105601204902',
     $'3646861446572968086302', '3473309979659717223502',
     $'3308022547208825371902', '3150605418909826649902',
     $'3000683633290288466602', '2857900102562582344302',
     $'2721914760184548851502', '2592403749094932403002',
     $'2469058648681851261702', '2351585738635304277502',
     $'2239705297923021167402', '2133150937213049273602',
     $'2031668963146538394702', '1935017772940428509702',
     $'1842967277872345832902', '1755298354269144764202',
     $'1671802320686362706502', '1592280440028539251702',
     $'1516543445420041210702', '1444411088692873474202',
     $'1375711710412079033802', '1310281830410869414502',
     $'1247965757856702828302', '1188615219916259198902',
     $'1132089008131760863702', '1078252641663461882802',
     $'1026978046593479058102', '9781432505245606969503',
     $'9316320917439769320903', '8873339422575557256703',
     $'8451434440320650291803', '8049602578157334570403',
     $'7666888239367849552703', '7302381345085093996303',
     $'6955215164966694787203', '6624564251310199655703',
     $'6309642471674507932003', '6009701135308194859803',
     $'5724027208909678879503', '5451941617457765036303',
     $'5192797626054482905103', '4945979298915811331903',
     $'4710900031830308782703', '4487001154581288891803',
     $'4273750599995416546203', '4070641636439851044003',
     $'3877191660741710914403', '3692941048648043044103',
     $'3517452060081992616103', '3350307796581819333103',
     $'3191111208434102992203', '3039484149131226291103',
     $'2895066474896299062403', '2757515187126366672303',
     $'2626503615707283874303', '2501720641251279428603',
     $'2382869954401220034103', '2269669350434127139903',
     $'2161850057480818940203', '2059156096758844135303',
     $'1961343673292336018703', '1868180595665228131403',
     $'1779445723423610351703', '1694928440809032787803',
     $'1614428155567442216603', '1537753821638312511203',
     $'1464723484585549795303', '1395163848686051368103',
     $'1328909864643504675403', '1265804336944252455503',
     $'1205697549918940459903', '1148446911618317002303',
     $'1093916614654075842003', '1041977313196127259803',
     $'9925058153562434932004', '9453847902247461915504',
     $'9005024888618730423904', '8577524785787618486704',
     $'8170333898747027258404', '7782486754275085767704',
     $'7413063805626127967204', '7061189246538900256204',
     $'6726028929352761772604', '6406788382271002875904',
     $'6102710921046923129304', '5813075850593544115404',
     $'5537196752232323018604', '5274419852500492746004',
     $'5024122469631171685004', '4785711534005625901004',
     $'4558622179053471388704', '4342316399244595480704',
     $'4136281771976556143204', '3940030240313567937404',
     $'3753096953678267936604', '3575039163735620526204',
     $'3405435172839896886904', '3243883332540967425704',
     $'3090001089765472833004', '2943424078402076852004',
     $'2803805254128222725204', '2670814070418874112704',
     $'2544135693775866229504', '2423470256309958431504',
     $'2308532143896688721304', '2199049318211896207304',
     $'2094762671033501872404', '1995425409273013841504',
     $'1900802469273434261404', '1810669958979965717604',
     $'1724814626656312277804', '1643033354882602298604',
     $'1565132678631178004604', '1490928326273844311304',
     $'1420244782428783308104', '1352914871607351597804',
     $'1288779361670509460304', '1227686586151801783304',
     $'1169492084548733452904', '1114058259727163647004',
     $'1061254051624086301104', '1010954626472965148104',
     $'9630410808127437570306', '9174001595768420739206',
     $'8739239875919650628106', '8325098138484661140806',
     $'7930597679344040721106', '7554806280543805426606',
     $'7196836000818126269706', '6855841071195511480306',
     $'6531015890687584094906', '6221593117297721900206',
     $'5926841849813608182006', '5646065896063718753806',
     $'5378602123523458378406', '5123818888352548427306',
     $'4881114539131824493006', '4649915991745272490206',
     $'4429677372022338121306', '4219878722916690834106',
     $'4020024773151093702806', '3829643764404190851906',
     $'3648286334254222499006', '3475524452227246191006',
     $'3310950406423697300106', '3154175838317363221406',
     $'3004830823435360520806', '2862562995736765387806',
     $'2727036713611415039106', '2597932265519318669306',
     $'2474945113385326834706', '2357785171953432240206',
     $'2246176122390526520606', '2139854758510820323006',
     $'2038570364069641664406', '1942084119649144769506',
     $'1850168537728764205006', '1762606924600204543506',
     $'1679192867850523480906', '1599729748197598129206',
     $'1524030274520104745206', '1451916040979229143806',
     $'1383217105181789651206', '1317771586384421577406',
     $'1255425282786060794106', '1196031307001287369206',
     $'1139449738850256230706', '1085547294642053247206',
     $'1034197012167469779206', '9852779506544798564307',
     $'9386749049752204195007', '8942781334271010524707',
     $'8519830984428858106107', '8116902196152727792107',
     $'7733046384507198820607', '7367359942950977223507',
     $'7018982109002580965707', '6687092931258533322707',
     $'6370911332947868191007', '6069693267435762227507',
     $'5782729961307223635107', '5509346240869504789607',
     $'5248898938109759791507', '5000775372332908910407',
     $'4764391903884147881307', '4539192556531477854507',
     $'4324647705246437914707', '4120252826276283548407',
     $'3925527306548539876107', '3740013309589518956607',
     $'3563274695272360375707', '3394895990837752072607',
     $'3234481410752017222807', '3081653923083001790707',
     $'2936054360184441186407', '2797340571584485260007',
     $'2665186617074068171107', '2539281998086061073407',
     $'2419330925546867389107', '2305051622468528225507',
     $'2196175659631704488107', '2092447322788287969807',
     $'1993623009887052323507', '1899470656896863693807',
     $'1809769190869698770507', '1724308008950225977507',
     $'1642886482100146614207', '1565313482364012920607',
     $'1491406932558978187307', '1420993377324022524507',
     $'1353907574514762766607', '1289992105978116271007',
     $'1229097006786960391107', '1171079412058621051407',
     $'1115803220522638828407', '1063138774042898016707',
     $'1012962552336957394507', '9651568821713803973108',
     $'9196096603461124803908', '8762140898135758771708',
     $'8348684283092241306908', '7954757488998944170008',
     $'7579437118844849947008', '7221843475083349760708',
     $'6881138489782577100408', '6556523752895380522008',
     $'6247238633994054441208', '5952558493035940576608',
     $'5671792975936506834408', '5404284390927004711908',
     $'5149406161864775996508', '4906561354846177432308',
     $'4675181274645349346308', '4454724127667081693108',
     $'4244673748259219776208', '4044538385379774612708',
     $'3853849546756514391808', '3672160897812651713808',
     $'3499047212761628189808', '3334103375397240146208',
     $'3176943427222738613508', '3027199660674351631908',
     $'2884521755301182077108', '2748575954864882007308',
     $'2619044283419135275608', '2495623798521022715208',
     $'2378025879814016606608', '2265975551305860999708',
     $'2159210835744139566508', '2057482139568101359808',
     $'1960551666987486562408', '1868192861807839908908',
     $'1780189875687281701308', '1696337061572080251008',
     $'1616438491117782799508', '1540307494959255142508',
     $'1467766224746887254608', '1398645235917570754708',
     $'1332783090217965602008', '1270025977044163691808',
     $'1210227352706236287908', '1153247596768425473608',
     $'1098953684656007048508', '1047218875758208793608',
     $'9979224162931045185809', '9509492562352071987309',
     $'9061897796396361330909', '8635395477283118063609',
     $'8228990541337126971009', '7841734917243817720309',
     $'7472725304636645937909', '7121101057791603788709',
     $'6786042169451334398009', '6466767350037237784309',
     $'6162532197732679301609', '5872627455134476085209',
     $'5596377348373748591309', '5333138004801464920009',
     $'5082295945519034220609', '4843266649210559310909',
     $'4615493183901254149709', '4398444903426465636609',
     $'4191616205548089220909', '3994525348800293856909',
     $'3806713325284716744109', '3627742786766978555709',
     $'3457197021551816505309', '3294678979733631857709',
     $'3139810344533082557809', '2992230647538789289709',
     $'2851596425776520519609', '2717580418626622779809',
     $'2589870802704198904109', '2468170462905830386709',
     $'2352196297911701263009', '2241678558513010651809',
     $'2136360217211750578709', '2035996367613457056309',
     $'1940353652203589140909', '1849209717164918069009',
     $'1762352692956874028009', '1679580699438351580009',
     $'1600701374373159073009', '1525531424212248586209',
     $'1453896196099210673209', '1385629270095385826809',
     $'1320572070668449794009', '1258573496533584614609',
     $'1199489567979458254509', '1143183090852304571909',
     $'1089523336410518918709', '1038385736299455143009',
     $'9896515919316149786910', '9432077975912444508110',
     $'8989465766145737033910', '8567652300276324907710',
     $'8165658970528157925010', '7782553269232315049910',
     $'7417446614704005590110', '7069492279761616223210',
     $'6737883418037173201210', '6421851183457033666610',
     $'6120662938490201829210', '5833620546969899500810',
     $'5560058747492396463810', '5299343603586091423210',
     $'5050871027023873771110', '4814065370823313885510',
     $'4588378088642628926010', '4373286457436036638710',
     $'4168292360380407909010', '3972921127226408660810',
     $'3786720429361915646410', '3609259227003715368910',
     $'3440126766055652492710', '3278931622287771001010',
     $'3125300790601861782310', '2978878817254455056110',
     $'2839326973008923475910', '2706322465284228525610',
     $'2579557687459174364710', '2458739503578044324810',
     $'2343588566786390375710', '2233838669904719932910',
     $'2129236126623063003710', '2029539181871082715410',
     $'1934517449986682181110', '1843951379371120933910',
     $'1757631742380637660910', '1675359149263628337110',
     $'1596943585008688826910', '1522203968022430750410',
     $'1450967729607044808110', '1383070413256236751110',
     $'1318355292834512048710', '1256673008748944862410',
     $'1197881221264638902110', '1141844280155170876110',
     $'1088432909917495662510', '1037523909817175670810',
     $'9889998680644605274911', '9427488894547685636011',
     $'8986643358385861143811', '8566445788157781884711',
     $'8165927640778649743211', '7784165868490299243611',
     $'7420280779025506349211', '7073433996540442338411',
     $'6742826518564524333411', '6427696864441129964111',
     $'6127319310946266807111', '5841002210975818556311',
     $'5568086391385906576111', '5307943626255662167011',
     $'5059975182017734648511', '4823610431069575844011',
     $'4598305530638335814311', '4383542163824452216711',
     $'4178826339894073220511', '3983687251028661375711',
     $'3797676182871806999011', '3620365476338742999011',
     $'3451347538273592484711', '3290233898653275981911',
     $'3136654312145523347311', '2990255901931830639811',
     $'2850702343804716392711', '2717673088642495555011',
     $'2590862621454222594311', '2469979755272667208911',
     $'2354746958254376229611', '2244899712423233619211',
     $'2140185902567638019511', '2040365233871646522911',
     $'1945208676927348567011', '1854497938839491603911',
     $'1768024959194129633611', '1685591429720948881811',
     $'1607008336534077240011', '1532095523888734523211',
     $'1460681278441152022111', '1392601933046899299311',
     $'1327701489178215226511', '1265831257084255155911',
     $'1206849512859438087511', '1150621171624403205311',
     $'1097017476061556087311', '1045915699582888814411',
     $'9971988634417785181712', '9507554671328850898212',
     $'9064792314551565517012', '8642688536423820911412',
     $'8240277739937767252212', '7856639534638034753012',
     $'7490896616959011804112', '7142212750090481102612',
     $'6809790838692099882012', '6492871093997498624112',
     $'6190729285058678816712', '5902675072081404247512',
     $'5628050417992868683212', '5366228074564530253612',
     $'5116610139586053088312', '4878626681751193407312',
     $'4651734430073594929812', '4435415524800183584712',
     $'4229176326932523205812', '4032546283602444829312',
     $'3845076846677809328212', '3666340442097708391912',
     $'3495929487554040031112', '3333455456248485988512',
     $'3178547984560730877512', '3030854021565545437712',
     $'2890037018433346096712', '2755776155841266031512',
     $'2627765607609844374012', '2505713838864365250612',
     $'2389342937099852401312', '2278387974604934421812',
     $'2172596400772417633612', '2071727462893607275712',
     $'1975551654099364210512', '1883850187173727129412',
     $'1796414493025815571612', '1713045742662796285212',
     $'1633554391561077325412', '1557759745384717323012',
     $'1485489546049422097412', '1416579577177562102612',
     $'1350873288034491518812', '1288221435079187414512',
     $'1228481740302954676012', '1171518565568754004712',
     $'1117202602200696436812', '1065410575108494501512',
     $'1016024960765249220512', '9689337183889616988813',
     $'9240300337086624434613', '8812120747251216304613',
     $'8403827589038068474113', '8014495312641557037113',
     $'7643241528543904408513', '7289224991250787008913',
     $'6951643677374945935113', '6629732953646101827413',
     $'6322763830633000367013', '6030041298161187103213',
     $'5750902738598588549813', '5484716414360598009913',
     $'5230880026157546111013', '4988819338670574615913',
     $'4757986870497406121613', '4537860645357672300513',
     $'4327943001688672962313', '4127759457897014809713',
     $'3936857630659834298513', '3754806203791540779113',
     $'3581193945308507377113', '3415628770435157810713',
     $'3257736848400704779413', '3107161750976634820413',
     $'2963563640801139196813', '2826618497628283056813',
     $'2696017380726997882913', '2571465725738177281113',
     $'2452682674377446040513', '2339400435446740689113',
     $'2231363675689861382913', '2128328939095796580113',
     $'2030064093319042405613', '1936347801948489270713',
     $'1846969021415873412213', '1761726521391428029013',
     $'1680428427568348584413', '1602891785789134470013',
     $'1528942146515903515713', '1458413168693510167913',
     $'1391146242098840553313', '1326990127312111060413',
     $'1265800612486459605813', '1207440186130683900813',
     $'1151777725156737898513', '1098688197478631079713',
     $'1048052378482766260313', '9997565807215772632714',
     $'9536923962126616043214', '9097564507545153047114',
     $'8678501696975338220814', '8278795546352084742314',
     $'7897549705054822421314', '7533909426160902382914',
     $'7187059631304534684814', '6856223065723722612914',
     $'6540658539284278905514', '6239659249466951194914',
     $'5952551182491400643714', '5678691588929701859114',
     $'5417467530332576146914', '5168294493554127083814',
     $'4930615069615791857114', '4703897694097910856714',
     $'4487635446188091858414', '4281344903649728077214',
     $'4084565051101930437814', '3896856239124048145514',
     $'3717799191814158735914', '3546994060541676775314',
     $'3384059521739814229114', '3228631916684268214914',
     $'3080364431300445003614', '2938926314132973441014',
     $'2804002130698426797114', '2675291052525259903314',
     $'2552506179264169384314', '2435373892327580947214',
     $'2323633238588932632114', '2217035342741022065314',
     $'2115342846978076772314', '2018329376728539759314',
     $'1925779031224981078914', '1837485897754186468814',
     $'1753253588484466478914', '1672894798818697791714',
     $'1596230886270670868514', '1523091468909087263714',
     $'1453314042458133302014', '1386743615186056631914',
     $'1323232359753685983314', '1262639281233455224314',
     $'1204829900546309128714', '1149675952598964580514',
     $'1097055098437457739714', '1046850650764801694714',
     $'9989513122009834420315', '9532509256925133763215',
     $'9096482365063712446615', '8680466652695330628615',
     $'8283540915403741362115', '7904826474221816072815',
     $'7543485207518306921815', '7198717674184342251615',
     $'6869761323875151216515', '6555888790260233704615',
     $'6256406263423684339515', '5970651937736076051115',
     $'5697994531690620619515', '5437831876359642615715',
     $'5189589569283102879815', '4952719690749344153415',
     $'4726699579569744145915', '4511030665583873682015',
     $'4305237356260378038815', '4108865974881422084315',
     $'3921483747915444579315', '3742677839294421076015',
     $'3572054429418092841315', '3409237836808923817615',
     $'3253869680438130141915', '3105608080835207677215',
     $'2964126898181172557815', '2829115005669428275515',
     $'2700275596497971320615', '2577325522932727905715',
     $'2459994665954350377715', '2348025334069959004415',
     $'2241171689937250594115', '2139199203511260199815',
     $'2041884130483999268115', '1949013014844339618215',
     $'1860382214439997788715', '1775797448475422705515',
     $'1695073365928919624115', '1618033133919567688815',
     $'1544508045099514755315', '1474337143190163849815',
     $'1407366865821698501015', '1343450703874422336015',
     $'1282448876557600575315', '1224228021496972053315',
     $'1168660899135930822215', '1115626110787633213815',
     $'1065007829706042753615', '1016695544573251488315',
     $'9705838148283787230016', '9265720372900104323216',
     $'8845642235495652701716', '8444687876372139050516',
     $'8061983434850924097116', '7696695117345901094616',
     $'7348027354555076818316', '7015221043649200990916',
     $'6697551871526866880816', '6394328715387705007016',
     $'6104892117049026749116', '5828612827596939208216',
     $'5564890419120922555316', '5313151960431494454316',
     $'5072850753804224399416', '4843465129930329455716',
     $'4624497298384692285216', '4415472251046688330216',
     $'4215936716027973696316', '4025458159774637548816',
     $'3843623835119119104716', '3670039873160274008016',
     $'3504330416948181078316', '3346136795043930308516',
     $'3195116733113938407416', '3050943601803501101116',
     $'2913305699215504399916', '2781905566397663691016',
     $'2656459334315514881316', '2536696100858812784016',
     $'2422357336496157636316', '2313196317256722770516',
     $'2208977583779039681116', '2109476425225048962616',
     $'2014478386913178320016', '1923778800577187466416',
     $'1837182336208043750016', '1754502574484275779616',
     $'1675561598842203820916', '1600189606281268925216',
     $'1528224536041476437516', '1459511715329827905216',
     $'1393903521310628293816', '1331259058610808463616',
     $'1271443851625977718316', '1214329550945895776316',
     $'1159793653249501977616', '1107719234049632712516',
     $'1057994692696163448416', '1010513509073593695116',
     $'9651740114551131597217', '9218791550000037257717',
     $'8805363104049005324417', '8410570622420095537217',
     $'8033570165389094041817', '7673556171751000155717',
     $'7329759706900464629817', '7001446791161465611917',
     $'6687916804678678462017', '6388500965352932015717',
     $'6102560876465228244717', '5829487140788398227517',
     $'5568698038132921722117', '5319638263414081159017',
     $'5081777722461768889717', '4854610382922219789917',
     $'4637653177722986581417', '4430444958688885986717',
     $'4232545498007680839417', '4043534535350175226717',
     $'3863010868550423795117', '3690591485848118643117',
     $'3525910737787133431817', '3368619546951880118617',
     $'3218384653806765192417', '3074887896983806492617',
     $'2937825526439566993017', '2806907547975148424917',
     $'2681857097682227509617', '2562409844944165570817',
     $'2448313422684225928617', '2339326883613033427817',
     $'2235220181284740910117', '2135773674826056350517',
     $'2040777656254453785317', '1950031899351657443517',
     $'1863345229105962642117', '1780535110782244885417',
     $'1701427257721711155217', '1625855257014660892617',
     $'1553660212228840460517', '1484690402413481520517',
     $'1418800956634894284817', '1355853543333620658017',
     $'1295716073825715852417', '1238262419301792585817',
     $'1183372140707098575517', '1130930230914171617417',
     $'1080826868626589966217', '1032957183478068953017',
     $'9872210318157049789818', '9435227826795897489618',
     $'9017711135133628766018', '8618788151615894121018',
     $'8237626057301877458318', '7873429529055378539818',
     $'7525439043464130310218', '7192929257805411568718',
     $'6875207464544533413518', '6571612116013558291818',
     $'6281511416071009677118', '6004301975689688217118',
     $'5739407529559350826918', '5486277710924241836218',
     $'5244386882002584876918', '5013233017456432033818',
     $'4792336638495991218718', '4581239795312969717218',
     $'4379505095642825559518', '4186714777356341655218',
     $'4002469823076852659718', '3826389114910973209018',
     $'3658108627468000593218', '3497280657426487952918',
     $'3343573087985989595618', '3196668686617843487018',
     $'3056264434601244730918', '2922070886899937556618',
     $'2793811561000764279418', '2671222353398203149818',
     $'2554050982469041558718', '2442056456538598898018',
     $'2335008565994560620318', '2232687398356631979018',
     $'2134882875259981347418', '2041394310357928374118',
     $'1952029987194645988118', '1866606756141887047818',
     $'1784949649535011287518', '1706891514182966825418',
     $'1632272660464459371618', '1560940527258403928218',
     $'1492749361990976948118', '1427559915114246714618',
     $'1365239148362527784218', '1305659956162350055318',
     $'1248700899600319612618', '1194245952380239164918',
     $'1142184258226710010518', '1092409899217111663518',
     $'1044821674547403584218', '9993228892596674368819',
     $'9558211524807571196519', '9142281847418944103919',
     $'8744596339685852092719', '8364348997488777524919',
     $'8000769655057805744719', '7653122382166432894119',
     $'7320703953385145477219', '7002842386139641927919',
     $'6698895544466244725419', '6408249805498003700519',
     $'6130318785849524540419', '5864542125196964477919',
     $'5610384324472199643919', '5367333636207152639719',
     $'5134901004675929367219', '4912619053588994196019',
     $'4700041119195344141619', '4496740326745747257819',
     $'4302308708362799139619', '4116356360452025845619',
     $'3938510638872714005819', '3768415390167762905719',
     $'3605730217228804037219', '3450129777846288089819',
     $'3301303114664357067319', '3158953015127252310619',
     $'3022795400067902879619', '2892558739650331545319',
     $'2767983495435739774419', '2648821587397714724919',
     $'2534835884765060801419', '2425799719621410632819',
     $'2321496422239125079919', '2221718877171153668219',
     $'2126269099168595530919', '2034957828033771813619',
     $'1947604141558784467019', '1864035085737880214419',
     $'1784085321478545038119', '1707596787071202814219',
     $'1634418375710757165019', '1564405627395070164719',
     $'1497420434555883929019', '1433330760806726900519',
     $'1372010372220068371219', '1313338580572452185219',
     $'1257199998021610619019', '1203484302703686541219',
     $'1152086014761728016019', '1102904282338614076919',
     $'1055842677088570753119', '1010808998781487699519',
     $'9677150885933910479220', '9264766506947084641820',
     $'8870130817654171109520', '8492473080828317214820',
     $'8131056298437040411920', '7785175723975006031620',
     $'7454157440822357402020', '7137357003680919822020',
     $'6834158140272902119720', '6543971510613054751620',
     $'6266233521285881907820', '6000405192274704898320',
     $'5745971073999381487420', '5502438212324535896620',
     $'5269335159400471320820', '5046211028294735176220',
     $'4832634589463791407220', '4628193407201619183120',
     $'4432493014285489527020', '4245156123118848692420',
     $'4065821871747329195520', '3894145103196578398020',
     $'3729795676649995119120', '3572457809050744617120',
     $'3421829445775722410820', '3277621659089592392420',
     $'3139558073144762999720', '3007374314348309523020',
     $'2880817485969518013720', '2759645665912028523320',
     $'2643627426622599252620', '2532541376154400511320',
     $'2426175719446575450920', '2324327838923666184220',
     $'2226803893558487820120', '2133418435580223733320',
     $'2043994044045993891020', '1958360974528991399620',
     $'1876356824209564287120', '1797826211687410216220',
     $'1722620470863418479120', '1650597358268700362420',
     $'1581620773246056991620', '1515560490415601522120',
     $'1452291903881535819020', '1391695782661233852120',
     $'1333658036840855788220', '1278069493983756757720',
     $'1224825685339008893320', '1173826641417468756020',
     $'1124976696522036971820', '1078184301837113169620',
     $'1033361846699785687120', '9904254876920488206621',
     $'9492949852093457749621', '9098935471760264950421',
     $'8721476795929182864121', '8359870436161641566021',
     $'8013443188798183702721', '7681550727874287126621',
     $'7363576355100070545121', '7058929804394194580221',
     $'6767046098573385650421', '6487384455905175755821',
     $'6219427244332889251221', '5962678981278829702521',
     $'5716665377024228121121', '5480932419753001304921',
     $'5255045500430920084821', '5038588575772578060821',
     $'4831163367625750089721', '4632388597176496970721',
     $'4441899252448861862421', '4259345887640361450821',
     $'4084393952898840706921', '3916723153207767849321',
     $'3756026835105823505521', '3602011400022806953021',
     $'3454395743067559146121', '3312910716154898217021',
     $'3177298614407584492121', '3047312684816180253521',
     $'2922716656184441395421', '2803284289430666357421',
     $'2688798947356320656721', '2579053183032337452921',
     $'2473848345990846531821', '2372994205445782933221',
     $'2276308589799945790721', '2183617041728688100121',
     $'2094752488161586250521', '2009554924513228401921',
     $'1927871112542734451521', '1849554291248835958121',
     $'1774463900233357901321', '1702465314990808982721',
     $'1633429593605554355721', '1567233234360762973121',
     $'1503757943785037727421', '1442890414683394750721',
     $'1384522113719101135121', '1328549078131848552321',
     $'1274871721195872595021', '1223394646038961207621',
     $'1174026467459865724721', '1126679641397468648821',
     $'1081270301720205685521', '1037718104018716616621',
     $'9959460760985398304722', '9558804748828969522622',
     $'9174506494482639501422', '8805889099275190969622',
     $'8452304020270208183722', '8113129869150232691622',
     $'7787771262494069001122', '7475657721228067649622',
     $'7176242617128833722722', '6889002164347191006722',
     $'6613434454011562874822', '6349058530053389568222',
     $'6095413504477958677722', '5852057710381244685222',
     $'5618567891087190479722', '5394538423850467963722',
     $'5179580576637268756522', '4973321796561235781622',
     $'4775405028613382377622', '4585488063383881875422',
     $'4403242912530066234222', '4228355210798960933022',
     $'4060523643464313445122', '3899459398087448057122',
     $'3744885639558499703622', '3596537007419738646822',
     $'3454159134515886840022', '3317508186057632239222',
     $'3186350418224051925522', '3060461755467437762422',
     $'2939627385720155021722', '2823641372737727232422',
     $'2712306284845398488122', '2605432839387043605022',
     $'2502839562205539944022', '2404352461512642708122',
     $'2309804715534075743922', '2219036373342017417722',
     $'2131894068312478673222', '2048230743669288259422',
     $'1967905389599566475422', '1890782791447729614122',
     $'1816733288516266594522', '1745632543021809078922',
     $'1677361318774416886322', '1611805269166560147722',
     $'1548854734076035141422', '1488404545304037210222',
     $'1430353840185865175522', '1374605883027279306722',
     $'1321067894034409887222', '1269650885419345046922',
     $'1220269504377142885422', '1172841882643040776322',
     $'1127289492351099784122', '1083537007927448838722',
     $'1041512173762705144422', '1001145677419066659122',
     $'9623710281380207884223', '9251244404246111964723',
     $'8893447224937714169423', '8549731693733884987923',
     $'8219534604675201463023', '7902315613915718411123',
     $'7597556298992626441923', '7304759257288854280723',
     $'7023447242037141614423', '6753162334284418808123',
     $'6493465149302618323123', '6243934075996440487223',
     $'6004164547920228672823', '5773768344575095702523',
     $'5552372921713898985523', '5339620769435696038023',
     $'5135168796903029431723', '4938687742564891053523',
     $'4749861608815595676623', '4568387120065144902223',
     $'4393973203240072194523', '4226340489775311850223',
     $'4065220838197409506623', '3910356876437465916323',
     $'3761501563048652562423', '3618417766538027434823'/
      data b2/'3480877862055779065223', '3348663344717000931023',
     $'3221564458861708005623', '3099379842588111309723',
     $'2981916186922220994323', '2868987909013707538823',
     $'2760416838773665484823', '2656031918394543962423',
     $'2555668914216080154023', '2459170140423640806123',
     $'2366384194086986023623', '2277165701068160056323',
     $'2191375072347025051423', '2108878270331923505123',
     $'2029546584741119488723', '1953256417658062179323',
     $'1879889077380170808223', '1809330580696789476323',
     $'1741471463247233592323', '1676206597624475910123',
     $'1613435018904026959423', '1553059757290978558023',
     $'1494987677591025417023', '1439129325223582854223',
     $'1385398778506901518423', '1333713506956365001823',
     $'1283994235347964544023', '1236164813309297020923',
     $'1190152090210347543723', '1145885795135814880223',
     $'1103298421729834371223', '1062325117712666112523',
     $'1022903578877262217423', '9849739473816215953424',
     $'9484787141604988245924', '9133626252873696667824',
     $'8795725921245832628624', '8470576051063631722624',
     $'8157686510057687081524', '7856586335429064910824',
     $'7566822971976012823424', '7287961540954059641324',
     $'7019584138412635366524', '6761289161803392786424',
     $'6512690663705284143224', '6273417731559229802224',
     $'6043113892350999292024', '5821436541224793061624',
     $'5608056393052046824424', '5402656956020256954124',
     $'5204934026345219309024', '5014595203247056145124',
     $'4831359423365844463624', '4654956513826619365524',
     $'4485126763196070099924', '4321620509604434202224',
     $'4164197745335983572024', '4012627737220140273924',
     $'3866688662182711642124', '3726167257343044106124',
     $'3590858484068111067624', '3460565205418718131824',
     $'3335097876446173083324', '3214274246819970354624',
     $'3097919075288320757024', '2985863855493755586624',
     $'2877946552685586917824', '2774011350889748406224',
     $'2673908410114507202324', '2577493633187760139024',
     $'2484628441838137353024', '2395179561647963735024',
     $'2309018815521301666824', '2226022925324844720524',
     $'2146073321373377586624', '2069055959444887544824',
     $'1994861145023231325324', '1923383364478551257724',
     $'1854521122907418198724', '1788176788365977007624',
     $'1724256442240203505124', '1662669735507769299024',
     $'1603329750655971137824', '1546152869029732341824',
     $'1491058643392842392624', '1437969675494383242224',
     $'1386811498440712969924', '1337512463681454031624',
     $'1290003632425678855724', '1244218671311913688024',
     $'1200093752162705528024', '1157567455661329356824',
     $'1116580678794765693524', '1077076545913363436624',
     $'1039000323263631011724', '1002299336856380707524',
     $'9669228935379969047825', '9328222051379184545425',
     $'8999503155705280814225', '8682620307745363427725',
     $'8377138513776429391325', '8082639079787622775425',
     $'7798718989444210147825', '7524990306200804076625',
     $'7261079598611129087825', '7006627387919775064625',
     $'6761287617057984630025', '6524727140200637282825',
     $'6296625232075284998825', '6076673116246420200425',
     $'5864573511629173501025', '5660040196516399218625',
     $'5462797589431662831125', '5272580346148045702625',
     $'5089132972238975878425', '4912209450552524889125',
     $'4741572883024822817925', '4576995146271479046925',
     $'4418256560418194076525', '4265145570653146904325',
     $'4117458441004279381425', '3974998959864308939625',
     $'3837578156805217836125', '3705014030242122965525',
     $'3577131285523856341725', '3453761083044312295925',
     $'3334740795984671791025', '3219913777312024332025',
     $'3109129135674699982525', '3002241519848823097625',
     $'2899110911404229647025', '2799602425270974533125',
     $'2703586117900216263525', '2610936802725324941425',
     $'2521533872640636182925', '2435261129226387764425',
     $'2352006618459046294425', '2271662472656475946925',
     $'2194124758417237508725', '2119293330322750212225',
     $'2047071690180116876725', '1977366851592119969525',
     $'1910089209649256891625', '1845152415546711064325',
     $'1782473255936864656125', '1721971536835361890425',
     $'1663569971905841154325', '1607194074955281414025',
     $'1552772056478465071325', '1500234724096356271525',
     $'1449515386739241206425', '1400549762431285196325',
     $'1353275889538739856425', '1307634041349391698925',
     $'1263566643855989912725', '1221018196621334299025',
     $'1179935196607452543825', '1140266064855856996425',
     $'1101961075910252383225', '1064972289877274603425',
     $'1029253487024883823825', '9947601048219191330326',
     $'9614491773260533749126', '9292792768309715479726',
     $'8982104576870401825026', '8682042022130439912126',
     $'8392233686197452195526', '8112321408690756607726',
     $'7841959803957062051326', '7580815796205588187726',
     $'7328568171885355594126', '7084907148653430150926',
     $'6849533960307926013026', '6622160457083615073426',
     $'6402508720731096164026', '6190310693822681528626',
     $'5985307822749497025826', '5787250713894800311226',
     $'5595898802488230786926', '5411020033664647930626',
     $'5232390555269421025426', '5059794421969532364326',
     $'4893023310246675613226', '4731876243864697978926',
     $'4576159329419274847726', '4425685501592643346626',
     $'4280274277750580516726', '4139751521532615252126',
     $'4003949215099732680726', '3872705239716586239526',
     $'3745863164357496450626', '3623272042037305689526',
     $'3504786213579493610626', '3390265118544856195926',
     $'3279573113054529732526', '3172579294251215850426',
     $'3069157331152150848326', '2969185301656677056926',
     $'2872545535480230506326', '2779124462795171640626',
     $'2688812468367167704226', '2601503750983799589126',
     $'2517096187979724775226', '2435491204670093405826',
     $'2356593648510997943626', '2280311667812549221426',
     $'2206556594836723570526', '2135242833118427211726',
     $'2066287748854284939826', '1999611566209489671926',
     $'1935137266398656629326', '1872790490402019408026',
     $'1812499445183493230826', '1754194813282121232026',
     $'1697809665653220338126', '1643279377640161512626',
     $'1590541547962161891126', '1539535920607740410126',
     $'1490204309527600451526', '1442490526024659022526',
     $'1396340308742748100026', '1351701256159175737726',
     $'1308522761489857938726', '1266755949919122444326',
     $'1226353618069547621726', '1187270175630338461526',
     $'1149461589065762056826', '1112885327328071376726',
     $'1077500309502143029926', '1043266854311746247226',
     $'1010146631419950526226', '9781026144586721527927',
     $'9470990357247588748427', '9171013424823209372727',
     $'8880761548132389281427', '8599912249599177574327',
     $'8328153981064147621627', '8065185745460514684227',
     $'7810716731855258809627', '7564465963373781391227',
     $'7326161957544296910927', '7095542398615174086727',
     $'6872353821414818006627', '6656351306339451005127',
     $'6447298185069328205027', '6244965756628536135827',
     $'6049133013417591085527', '5859586376861598465027',
     $'5676119442329775298427', '5498532732994694054827',
     $'5326633462311695741627', '5160235304810561109327',
     $'4999158174902737922827', '4843228013418215837727',
     $'4692276581596534139927', '4546141262266416556627',
     $'4404664867958165996727', '4267695455702234390527',
     $'4135086148276322159127', '4006694961671971159527',
     $'3882384638559906614327', '3762022487541369477327',
     $'3645480227980372370927', '3532633840219220706027',
     $'3423363420986776453027', '3317553043815815504127',
     $'3215090624292450452727', '3115867789966968374327',
     $'3019779754761576905827', '2926725197716470330627',
     $'2836606145921328891227', '2749327861484857265427',
     $'2664798732400259832527', '2582930167169648519327',
     $'2503636493055290847127', '2426834857830338238727',
     $'2352445134906234359227', '2280389831718396665127',
     $'2210594001255997607927', '2142985156625751016027',
     $'2077493188543539782127', '2014050285651508612627',
     $'1952590857561895548227', '1893051460532393332427',
     $'1835370725681221393227', '1779489289653355926027',
     $'1725349727652513875327', '1672896488756520863627',
     $'1622075833436617531827', '1572835773204077368427',
     $'1525126012310225829127', '1478897891428569117127',
     $'1434104333250265032127', '1390699789926601270827',
     $'1348640192294491821227', '1307882900823262852727',
     $'1268386658223178876327', '1230111543658260899027',
     $'1193018928507973718227', '1157071433624312141527',
     $'1122232888032698452927', '1088468289026918433927',
     $'1055743763610073152527', '1024026531235210944427',
     $'9932848678009307991228', '9634880708588169468628',
     $'9346064259910769340228', '9066111743182139204528',
     $'8794744810979702974028', '8531694053781359049228',
     $'8276698706671219465028', '8029506365874629118728',
     $'7789872714786251192228', '7557561259166735037928',
     $'7332343071194795804628', '7113996542072446041228',
     $'6902307142891642991328', '6697067193480765293128',
     $'6498075638959122834828', '6305137833737146581328',
     $'6118065332709013817528', '5936675689393250509428',
     $'5760792260785327986628', '5590244018694447105428',
     $'5424865367344590226428', '5264495967027530151328',
     $'5108980563602825590628', '4958168823646914448528',
     $'4811915175060248481428', '4670078652948004673628',
     $'4532522750596268607128', '4399115275371721472728',
     $'4269728209378783204128', '4144237574713877214028',
     $'4022523303161994809028', '3904469110186056725228',
     $'3789962373064702249428', '3678894013039089737028',
     $'3571158381334072400028', '3466653148923726205528',
     $'3365279199915658545328', '3266940528432822740228',
     $'3171544138875709967828', '3078999949451792169228',
     $'2989220698862952035828', '2902121856045364254228',
     $'2817621532859890560228', '2735640399634524427328',
     $'2656101603463773813428', '2578930689173106596528',
     $'2504055522859707248028', '2431406217923808910228',
     $'2360915063507776169328', '2292516455262924150528',
     $'2226146828366772660328', '2161744592716053385728',
     $'2099250070223316944028', '2038605434147428046128',
     $'1979754650390594253428', '1922643420696849756028',
     $'1867219127689113109428', '1813430781684059715328',
     $'1761228969226098659928', '1710565803283721897328',
     $'1661394875053404155328', '1613671207318076724928',
     $'1567351209308979772428', '1522392633021418193028',
     $'1478754530936607454228', '1436397215103400394928',
     $'1395282217535235566428', '1355372251879144310328',
     $'1316631176315099235328', '1279023957645382852528',
     $'1242516636535003573728', '1207076293865488733528',
     $'1172671018165642359028', '1139269874084070620528',
     $'1106842871869451746228', '1075360937825661105228',
     $'1044795885709957537928', '1015120389043495185728',
     $'9863079543044473161629', '9583328949750162182029',
     $'9311703064145573312529', '9047960415319675498729',
     $'8791866872313782125929', '8543195416060537256229',
     $'8301725918562281237129', '8067244929074151364129',
     $'7839545467065034743829', '7618426821736990107529',
     $'7403694357891002083029', '7195159327933934017529',
     $'6992638689828312267629', '6795954930793113998829',
     $'6604935896570049801129', '6419414626075939349429',
     $'6239229191267680199029', '6064222542052013623129',
     $'5894242356077803953029', '5729140893253875698429',
     $'5568774854840602130829', '5413005246968416087929',
     $'5261697248441224385529', '5114720082687357077929',
     $'4971946893725177371329', '4833254626014822545729',
     $'4698523908071745895729', '4567638939721789373229',
     $'4440487382881441074529', '4316960255750725542729',
     $'4196951830309842492429', '4080359533014215285229',
     $'3967083848586038421829', '3857028226803727462429',
     $'3750098992193878989229', '3646205256533446201429',
     $'3545258834072831081029', '3447174159393490245129',
     $'3351868207816451958329', '3259260418280849553129',
     $'3169272618614194811929', '3081828953118646716829',
     $'2996855812399979291129', '2914281765368319831929',
     $'2834037493342018405029', '2756055726188223639329',
     $'2680271180435881166129', '2606620499298941934429',
     $'2535042194549570464729', '2465476590183080154229',
     $'2397865767818196224729', '2332153513778058936929',
     $'2268285267799132329529', '2206208073316878979029',
     $'2145870529278701012929', '2087222743436233716729',
     $'2030216287070612328829', '1974804151105816754929',
     $'1920940703566634614029', '1868581648339171880929',
     $'1817683985193183948529', '1768205971026799733129',
     $'1720107082295468911829', '1673347978588178940729',
     $'1627890467315165500029', '1583697469472478765529',
     $'1540732986449869679129', '1498962067849526412129',
     $'1458350780284222660929', '1418866177124437437429',
     $'1380476269164971713429', '1343149996182521718829',
     $'1306857199356572913129', '1271568594526853636629'/
      if(n.le.40) then
        do i=1,1480
        if(i.le.1024)boysval(40,i)=chtdbl(b1(i))
        if(i.gt.1024)boysval(40,i)=chtdbl(b2(i-1024))
        enddo
       do i=0,n
        boysval(i,0)=1.d0/(2.d0*dfloat(i)+1.d0)
       enddo
       do ii=1,1480
        do i=39,0,-1
         boysval(i,ii)=(dfloat(ii)*0.1d0*boysval(i+1,ii)+
     $   dexp(-dfloat(ii)*0.05d0))/(2.d0*dfloat(i)+1.d0)
        enddo   
       enddo
      endif

      if(n.gt.40) then
      write(iout,*)'Error in boys function'
      call mrccend(1)
c      do i=0,n
c       boysval(i,0)=1.d0/(2.d0*dfloat(i)+1.d0)
c      enddo
c       call to_mp(0.05d0,h,hs,hx)
c      do nn=0,0
c       do point=1,1
c        k=0
c        call to_mp(dfloat(point),pointa,points,pointx)
c        call mpmpy(h,pointa,xx,hx,pointx,xxx,hs,points,xxs)
c        call to_mp(0.d0,scr1,scr1s,scr1x1)
c        call to_mp(0.d0,fact1,fact1s,factx1)
c        call to_mp(1.d0,scr2,scr2s,scr2x2)
c        call to_mp(1.d0,fact,facts,factx)
c        call to_mp(1.d0,scdif,scdifs,scdifx)
c        do while(to_dpr(scdif,scdifs,scdifx).gt.10d-20)
c         call mpeq(scr2,scr1,scr2x2,scr1x1,scr2s,scr1s)
c      write(6,"(1x,50i1)") (scr2(i),i=1,50)
c         call to_mp(dfloat((-1)**k),mn,mns,mnx)
c      write(6,"(1x,50i1)") (mn(i),i=1,50)

c         call to_mp(dfloat(2*(nn+k)+1),bt,bts,btx)
c      write(6,"(1x,50i1)") (bt(i),i=1,50)
c         call mpdiv(mn,bt,temp,mnx,btx,tempx,mns,bts,temps)
c      write(6,"(1x,50i1)") (temp(i),i=1,50)
c      write(6,*)divs,divx
c         call mpmpy(temp,fact,div,tempx,factx,divx,temps,facts,divs)
c      write(6,*)'scr1'
c      write(6,*)scr1s,scr1x1
c      write(6,"(1x,50i1)") (scr1(i),i=1,50)
c      write(6,*)'div'
c      write(6,*)divs,divx,temps,facts
c      write(6,"(1x,50i1)") (div(i),i=1,50)
c         call mpadd(scr1,div,tp,scr1x1,divx,tpx,scr1s,divs,tps)
c      write(6,"(1x,50i1)") (tp(i),i=1,50)
c         call mpeq(scr1,tp,scr1x1,tpx,scr1s,tps)
c      write(6,"(1x,50i1)") (scr1(i),i=1,50)
c         k=k+1
c         call to_mp(dfloat(k),ka,kas,kax)
c      write(6,*)scr1s,scr1x1
c      write(6,"(1x,50i1)") (ka(i),i=1,50)
c         call mpdiv(xx,ka,yy,xxx,kax,yyx,xxs,kas,yys)
c      write(6,*)scr1s,scr1x1
c      write(6,"(1x,50i1)") (yy(i),i=1,50)
c         call mpmpy(yy,fact,fact1,yyx,factx,factx1,yys,facts,fact1s)
c      write(6,*)scr1s,scr1x1
c      write(6,"(1x,50i1)") (fact1(i),i=1,50)
c         call mpeq(fact,fact1,factx,factx1,facts,fact1s)
c      write(6,*)scr1s,scr1x1
c      write(6,"(1x,50i1)") (fact(i),i=1,50)
c         call mpsub(scr1,scr2,scdif,scr1x1,
c    $         scr2x2,scdifx,scr1s,scr2s,scdifs)
c      write(6,"(1x,50i1)") (scdif(i),i=1,50)
c      write(6,*)scr1s,scr1x1
c         scdifs=abs(scdifs)
c      write(6,*)'scr1'
c      write(6,*)scr1s,scr1x1
c      write(6,*)'---------------------------------' 
c        enddo
c        boysval(nn,point)=(to_dpr(scr1,scr1s,scr1x1)+
c    $                    to_dpr(scr2,scr2s,scr2x2))/2.d0
c        write(6,*)boysval(nn,point),nn,point
c        enddo
c      enddo
       endif
      end
**********************************************************************
      subroutine boyscf(cf,n)
***********************************************************************
* Calculate the coefficient for large boysfunction arguments
***********************************************************************
#include "MRCCCOMMON"
      integer n,i,arg,ii
      real*8 cf(0:n),dblfact
      do ii=0,n
      arg=2*ii-1
      dblfact=1.d0
      if(mod(arg,2).eq.1) then
       do i=1,arg
        if (mod(i,2).eq.1) then
        dblfact=dblfact*dfloat(i)
        endif
       enddo
      else 
       do i=1,arg
        if (mod(i,2).eq.0) then
        dblfact=dblfact*dfloat(i)
        endif
       enddo
      endif
      cf(ii)=dblfact*pi**0.5d0/2.d0**(dfloat(ii)+1.d0)
      enddo
      end
**********************************************************************
      subroutine mkboys(cf,nnn,boysval)
***********************************************************************
* Calculate necessary data for Coulomb integrals
***********************************************************************
#include "MRCCCOMMON"
      integer nnn
      real*8 cf,boysval
      call generateboys(nnn,boysval)
      call boyscf(cf,nnn)
      end
**********************************************************************
      subroutine to_mp(x,xx,isg,xexp)
***********************************************************************
#include "MRCCCOMMON"
      character*1 str1(arrs+7)
      character*(arrs+7) str
      real*8 x
      integer*1 xx(arrs),isg
      integer xexp,i
      equivalence(str1,str)
C
      write(str,'(d87.80)') x
       do i=1,arrs
        xx(i)=ichar(str1(i+3))-48
       enddo
       do i=17,arrs
        xx(i)=0
       enddo
      isg=1
       if(str1(1).eq.'-') isg=-1
      xexp=(ichar(str1(arrs+6))-48)*10+ichar(str1(arrs+7))-48
       if(str1(arrs+5).eq.'-') xexp=xexp*(-1)
       xexp=xexp-1
      end
**********************************************************************
      real*8 function to_dpr(xx,isg,xexp)
***********************************************************************
#include "MRCCCOMMON"
      integer*1 xx(arrs),isg
      integer xexp,i,ii
      
      to_dpr=0.d0
      ii=1
      do i=xexp,-(arrs-xexp)+1,-1
       to_dpr=to_dpr+dfloat(xx(ii))*10.d0**i
       ii=ii+1
      enddo
      if(isg.lt.0)to_dpr=-to_dpr
      end
**********************************************************************
      subroutine mpadd(x1,x2,msum,xexp1,xexp2,xexps,isg1,isg2,isgs)
***********************************************************************
#include "MRCCCOMMON"
      integer*1 x1(arrs),x2(arrs),msum(arrs),scr(arrs),isg1,isg2,isgs
      integer*1 i1one
      parameter(i1one=1)
      integer xexp1,xexp2,xexps,carry,d,i,ii,k,iii
      logical ovfl,zero
C Argumentumok!!!
      ovfl=.false.
      if (isg1+isg2.eq.2.or.isg1+isg2.eq.-2) then
      d=abs(xexp1-xexp2)
      xexps=max(xexp1,xexp2)
      do i=1,d
       if (xexp1.gt.xexp2) then
        msum(i)=x1(i)
       else
        msum(i)=x2(i)
       endif 
      enddo
        carry=0
       if (xexp1.ge.xexp2) then
        do i=arrs,d+1,-1
         if (x1(i)+carry+x2(i-d).lt.10) then
          msum(i)=x1(i)+x2(i-d)+carry
          carry=0
         else
          msum(i)=x1(i)+x2(i-d)-10+carry  
          carry=1
          if (i.eq.1) then
           ovfl=.true.
           xexps=xexps+1
          endif
          if(i.eq.d+1) then
           k=1
           ii=d
           do while(k.eq.1.and.ii.ge.1)
            k=floor((dfloat(msum(ii))+dfloat(1))/10.d0)
            msum(ii)=mod(msum(ii)+1,10)
            if(ii.eq.1.and.k.eq.1) then
            xexps=xexps+1
             do iii=1,arrs
              scr(iii)=msum(iii)
             enddo
             do iii=2,arrs
              msum(iii)=scr(iii-1)
             enddo
              msum(1)=1
            endif
           ii=ii-1
           enddo
          endif
         endif
        enddo    
      else
        do i=arrs,d+1,-1
          if (x2(i)+carry+x1(i-d).lt.10) then
           msum(i)=x2(i)+x1(i-d)+carry
           carry=0
          else
           msum(i)=x2(i)+x1(i-d)-10+carry  
           carry=1
           if (i.eq.1) then
            ovfl=.true.
            xexps=xexps+1
           endif
           if(i.eq.d+1) then
            k=1
           ii=d
           do while(k.eq.1.and.ii.ge.1)
            k=floor((dfloat(msum(ii))+dfloat(1))/10.d0)
            msum(ii)=mod(msum(ii)+1,10)
            if(ii.eq.1.and.k.eq.1) then
            xexps=xexps+1
             do iii=1,arrs
              scr(iii)=msum(iii)
             enddo
             do iii=2,arrs
              msum(iii)=scr(iii-1)
             enddo
              msum(1)=1
            endif
           ii=ii-1
           enddo
          endif
         endif
        enddo    
      endif
      if(ovfl) then
          do ii=1,arrs
           scr(ii)=msum(ii)
          enddo
          do ii=2,arrs
           msum(ii)=scr(ii-1)
          enddo
          msum(1)=1
      endif
       isgs=1
      if(isg1+isg2.eq.-2) then
       isgs=-1
      endif
      else
       if(isg1.eq.1) then
        call mpsub(x1,x2,msum,xexp1,xexp2,xexps,i1one,i1one,isgs)
       else
        call mpsub(x2,x1,msum,xexp2,xexp1,xexps,i1one,i1one,isgs)
       endif
      endif
      i=1
      zero=.true.
      do while(zero.and.i.lt.arrs)
      if (msum(i).ne.0)zero=.false.
      i=i+1
      enddo
      i=i-2
      do ii=1,arrs
       if (ii+i.lt.arrs)then
        msum(ii)=msum(ii+i)
       else
        msum(ii)=0
       endif
      enddo
      xexps=xexps-i
      end
**********************************************************************
      subroutine mpeq(x1,x2,xexp1,xexp2,isg1,isg2)
***********************************************************************
*     x1=x2
************************************************************************
#include "MRCCCOMMON"
      integer*1 x1(arrs),x2(arrs),isg1,isg2
      integer xexp1,xexp2,i,ii
      do i=1,arrs
       x1(i)=x2(i)
      enddo
      xexp1=xexp2
      isg1=isg2
      end
**********************************************************************
      subroutine mpsub(x1,x2,msub,xexp1,xexp2,xexps,isg1,isg2,isgs)
***********************************************************************
*     msub=x1-x2
***********************************************************************
#include "MRCCCOMMON"
      integer*1 x1(arrs),x2(arrs),msub(arrs),scr(arrs),isg1,isg2,isgs
      integer*1 i1one
      parameter(i1one=1)
      real*8 to_dpr
      integer xexp1,xexp2,xexps,carry,d,i,ii,jj
      logical x1g,x12eq,zero,war
 
      war=.true.
      do i=1,arrs
       if(x1(i).ne.0) then
        war=.false.
       endif
      enddo
      if(war) then
       do i=1,arrs
        msub(i)=x2(i)
       enddo
       isgs=isg2
       xexps=xexp2
       return
      endif
      war=.true.
      do i=1,arrs
       if(x2(i).ne.0) then
        war=.false.
       endif
      enddo
      if(war) then
      do i=1,arrs
       msub(i)=x1(i)
      enddo
       isgs=isg1
       xexps=xexp1
       return
      endif
      d=abs(xexp1-xexp2)
      xexps=max(xexp1,xexp2)
 
      x12eq=.true.
      x1g=.false.
      if(isg2.eq.-1.and.isg1.eq.1) then
       call mpadd(x2,x1,msub,xexp2,xexp1,xexps,i1one,i1one,isgs)
       return
      endif
      if(isg2.eq.1.and.isg1.eq.-1) then
       call mpadd(x2,x1,msub,xexp2,xexp1,xexps,i1one,i1one,isgs)
       isgs=-1
       return
      endif
      if(isg2.eq.-1.and.isg1.eq.-1) then
       call mpadd(x1,x2,msub,xexp1,xexp2,xexps,-i1one,i1one,isgs)
       return
      endif
      if(xexp1.gt.xexp2) then
       x12eq=.false.
       x1g=.true.
      else if(xexp1.eq.xexp2) then
       i=1
       do while(i.le.arrs.and.x12eq)
        if(x1(i).gt.x2(i)) then
         x1g=.true.
        endif
        if(.not.x1(i).eq.x2(i)) then
         x12eq=.false.
        endif 
       i=i+1
       enddo
      else if(xexp2.gt.xexp1)then
       x1g=.false.
       x12eq=.false.
      endif
      if(x12eq) then
       do i=1,arrs
        msub(i)=0
       enddo
       isgs=1
       xexps=0
       return
      else if(x1g) then
       do i=1,d
        msub(i)=x1(i)
       enddo
        carry=0
       do i=arrs,d+1,-1
        if (x1(i).lt.x2(i-d)+carry) then
         msub(i)=x1(i)-x2(i-d)+10-carry
        carry=1
         if(i.eq.d+1) then
          jj=d
          zero=.true.
          do while(jj.ge.1.and.zero)
           if(msub(jj).eq.0)then 
            msub(jj)=9
           else
            msub(jj)=msub(jj)-1
            zero=.false.
           endif
           jj=jj-1
          enddo

         endif
        else
         msub(i)=x1(i)-x2(i-d)-carry
         carry=0
        endif
       enddo
        isgs=1
      else
      do i=1,d
        msub(i)=x2(i)
       enddo
        carry=0
       do i=arrs,d+1,-1
        if (x2(i).lt.x1(i-d)+carry) then
         msub(i)=x2(i)-x1(i-d)+10-carry
        carry=1
         if(i.eq.d+1) then
          jj=d
          zero=.true.
          do while(jj.ge.1.and.zero)
           if(msub(jj).eq.0)then 
            msub(jj)=9
           else
            msub(jj)=msub(jj)-1
            zero=.false.
           endif
           jj=jj-1
          enddo
         endif
        else
         msub(i)=x2(i)-x1(i-d)-carry
         carry=0
        endif
       enddo
        isgs=-1
      endif
      i=1
      zero=.true.
      do while(zero.and.i.lt.arrs)
      if (msub(i).ne.0)zero=.false.
      i=i+1
      enddo
      i=i-2
      do ii=1,arrs
       if (ii+i.lt.arrs)then 
        msub(ii)=msub(ii+i)
       else
        msub(ii)=0
       endif
      enddo
      xexps=xexps-i 
      end
**********************************************************************
      subroutine mpmpy(u,v,w1,ux,vx,wx,us,vs,ws)
***********************************************************************
*     w1=u*v
***********************************************************************
#include "MRCCCOMMON"
      integer*1 u(arrs),v(arrs),w1(arrs)
      integer*1 scr1(0:arrs-1),scr2(0:arrs-1),us,vs,ws
      integer i,ul,vl,ux,vx,wx,ii
      logical zero,war
      war=.true.
      do i=1,arrs
       if(v(i).ne.0) then
        war=.false.
       endif
      enddo
      if(war)then
       do i=1,arrs
        w1(i)=0
       enddo
       wx=0
       ws=0
       return
      endif
      war=.true.
      do i=1,arrs
       if(u(i).ne.0) then
        war=.false.
       endif
      enddo
      if(war)then
       do i=1,arrs
        w1(i)=0
       enddo
       wx=0 
       ws=0
       return
      endif
      i=arrs
      zero=.true.
      do while(zero.and.i.ge.1)
       if (v(i).ne.0) then
         vl=max(i,vx)
         zero=.false.
       endif
      i=i-1
      enddo
      i=arrs
      zero=.true.
      do while(zero.and.i.ge.1)
       if (u(i).ne.0) then
         ul=max(i,ux)
         zero=.false.
       endif
      i=i-1
      enddo
      ws=us*vs
      wx=ux+vx
      call mpmpy1(u,v,w1,ul,vl,wx)
      i=1
      zero=.true.
      do while(zero.and.i.lt.arrs)
      if (w1(i).ne.0)zero=.false.
      i=i+1
      enddo
      i=i-2
      do ii=1,arrs
       if (ii+i.lt.arrs)then 
        w1(ii)=w1(ii+i)
       else
        w1(ii)=0
       endif
      enddo
      wx=wx-i 
      end
**********************************************************************
      subroutine mpmpy1(uu,vv,w1,m,n,wx)
***********************************************************************
*     w1=u*v
***********************************************************************
#include "MRCCCOMMON"
      integer*1 uu(*),vv(*),w1(arrs),w(0:m+n-1),u(0:m-1),v(0:n-1)
      integer*1 scr(arrs)
      integer m,n,i,j,t,k,wx
      
      do i=0,m-1
       u(i)=uu(m-i)
      enddo
      do i=0,n-1
       v(i)=vv(n-i)
      enddo
      do i=1,arrs
       w1(i)=0
      enddo

      do i=0,m+n-1
       w(i)=0
      enddo
      j=0
      do while(j.lt.n)
       k=0
        i=0
        do while(i.lt.m)
        t=u(i)*v(j)+w(i+j)+k
        w(i+j)=mod(t,10)
        k=floor(dfloat(t)/10.d0)
        i=i+1
       enddo
      w(j+m)=k
        j=j+1
      enddo
      if(w(m+n-1).ne.0) then
      do i=1,arrs
       if (m+n.ge.i) then
       w1(i)=w(m+n-i)
       else
       w1(i)=0
       endif
      enddo
       wx=wx+1
       return
       else
      do i=1,arrs
       if (m+n.ge.i+1) then
       w1(i)=w(m+n-i-1)
       else
       w1(i)=0
       endif
      enddo
      return
      endif
      end
***********************************************************************
      subroutine mpdiv(u,v,mpdv,ux,vx,dvx,us,vs,dvs)
***********************************************************************
*     mpdiv=u1/v 
***********************************************************************
#include "MRCCCOMMON"
      integer*1 v(arrs),u(arrs),mpdv(arrs)
      integer ux,vx,dvx,us,vs,dvs,vl,ul,i,ii
      logical zero,war
      zero=.true.
      war=.true.
      do i=1,arrs
       if(v(i).ne.0) then
        war=.false.
       endif
      enddo
      if(war) then
       write(iout,*)'Division by zero in subroutine mpdiv!'
       call mrccend(1)
      endif
      war=.true.
      do i=1,arrs
       if(u(i).ne.0) then
        war=.false.
       endif
      enddo
      if(war)then
       do i=1,arrs
        mpdv(i)=0
       enddo
       dvx=0
       dvs=0
       return
      endif
      i=arrs
      do while(zero.and.i.ge.1)
       if (v(i).ne.0) then
         vl=max(i,vx+1)
         zero=.false.
       endif
      i=i-1
      enddo
      i=arrs
      zero=.true.
      do while(zero.and.i.ge.1)
       if (u(i).ne.0) then
         ul=max(i,ux)
         zero=.false.
       endif
      i=i-1
      enddo
      call mpdiv1(u,v,mpdv,ul,vl)
      dvs=us*vs
      dvx=ux-vx
      i=1
      zero=.true.
      do while(zero.and.i.lt.arrs)
      if (mpdv(i).ne.0)zero=.false.
      i=i+1
      enddo
      i=i-2
      do ii=1,arrs
       if (ii+i.lt.arrs)then 
        mpdv(ii)=mpdv(ii+i)
       else
        mpdv(ii)=0
       endif
      enddo
      dvx=dvx-i 
      end
***********************************************************************
      subroutine mpdiv1(u,v,mpdv,ul,vl) 
***********************************************************************
*     mpdiv=u1/v 
***********************************************************************
#include "MRCCCOMMON"
      integer vl,ul,i,j,carry,ii
      integer*1 v(arrs),u(arrs),mpdv(arrs),scr(vl+1),vv(vl+1)
      logical zero,sg,sgeq
      do i=1,arrs
       mpdv(i)=0
      enddo
      do i=1,vl
       scr(i+1)=u(i)
      enddo
      scr(1)=0
       do i=1,vl
        vv(i+1)=v(i)
       enddo
      vv(1)=0
      do j=1,arrs
       sg=.true.
        sgeq=.false.
       do while(sg.or.sgeq)
        sgeq=.true.
        sg=.false.
        i=1
        do while(i.le.vl+1.and.sgeq)
         if(scr(i).gt.vv(i)) then
          sg=.true.
         endif
         if(.not.scr(i).eq.vv(i)) then
          sgeq=.false.
         endif 
         i=i+1
        enddo
        if(sgeq)sg=.true.
        if (sg.or.sgeq) then
         mpdv(j)=mpdv(j)+1
        endif
        i=vl+1
        carry=0
        do while(sg.and.i.ge.1)
          if (scr(i).lt.vv(i)+carry) then
           scr(i)=scr(i)-vv(i)+10-carry
           carry=1
         i=i-1
          else
           scr(i)=scr(i)-vv(i)-carry
           carry=0
         i=i-1
          endif
        enddo
       enddo
        do i=2,vl+1
         scr(i-1)=scr(i)
        enddo
        if (vl+j.gt.ul) then
         scr(vl+1)=0
        else
         scr(vl+1)=u(vl+j)
        endif
      enddo
      end
***********************************************************************
      real*8 function chtdbl(ch)
***********************************************************************
      implicit none
      character*1 ch(22)
      integer e,ii,i
      e=ichar(ch(22))-48+(ichar(ch(21))-48)*10
      e=-e
      chtdbl=0.d0
      ii=1
      do i=e,-(22-e)+1,-1
       chtdbl=chtdbl+dfloat(ichar(ch(ii))-48)*10.d0**i
       ii=ii+1
      enddo
      end
************************************************************************
      subroutine hrr2(iang,jang,nmax,t1,inttt,xab,yab,zab,njcart,ct1)
************************************************************************
C Horizontal recurrence relation
************************************************************************
      implicit none
      integer iang,jang,nmax,njcart,ix,iy,iz,jx,jy,jz,jln,j,ia,icart
      integer jcart,jdim,kka,ij,ii,iij,ka
      real*8 t1(0:nmax,0:nmax,0:nmax,0:nmax,0:nmax,0:nmax),inttt(*)
      real*8 xab,yab,zab,ct1(*)

C Horizontal recurrence
         do jx=1,jang
       do ia=iang,nmax-jx
       jy=1
       do ix=0,ia
        do iy=0,ia-ix
         iz=ia-ix-iy
         t1(ix,iy,iz,jx,0,0)=t1(ix+1,iy,iz,jx-1,0,0)+
     $                   xab*t1(ix,  iy,iz,jx-1,0,0)
C     write(6,*)t1(ix,iy,iz,0,0,0)
c     write(6,*)ct1(jy)

         enddo
         enddo
        enddo
       enddo
          do jy=1,jang
         do jx=0,jang-jy
       do ia=iang,nmax-jx-jy
       do ix=0,ia
        do iy=0,ia-ix
         iz=ia-ix-iy
         t1(ix,iy,iz,jx,jy,0)=t1(ix,iy+1,iz,jx,jy-1,0)+
     $                    yab*t1(ix,iy,  iz,jx,jy-1,0)
          enddo
         enddo
         enddo
        enddo
       enddo
c         write(40,*)'hrht'
           do jz=0,jang
         do jx=0,jang-jz
          do jy=0,jang-jx-jz
       do ia=iang,nmax-jx-jy-jz
       do ix=0,ia
        do iy=0,ia-ix
         iz=ia-ix-iy
          if(jz.gt.0)then
         t1(ix,iy,iz,jx,jy,jz)=t1(ix,iy,iz+1,jx,jy,jz-1)+
     $                     zab*t1(ix,iy,iz,  jx,jy,jz-1)
         endif 
          if(ia.eq.iang.and.jx+jy+jz.eq.jang)then
      jdim=(jang+1)*(jang+2)/2
           kka=0
          iij=-1 
          do ii=ix,1,-1
          kka=kka+ix+iy+iz-iij
          iij=iij+1
          enddo
          ij=-1 
          ka=0
          do ii=jx,1,-1
          ka=ka+jx+jy+jz-ij
          ij=ij+1
          enddo
          
          inttt(ka+jy+kka*jdim+iy*jdim+1)=t1(ix,iy,iz,jx,jy,jz)
c       write(40,'(6i2,f20.14)')ix,iy,iz,jx,jy,jz,t1(ix,iy,iz,jx,jy,jz)
c       write(40,'(i4)')ka+jy+kka*jdim+iy*jdim+1
         endif 
           enddo
         enddo
          enddo
         enddo
        enddo
       enddo
c      jln=1
c      do ix=0,iang
c        do iy=0,iang-ix
c         iz=iang-ix-iy
c         do jx=0,jang
c          do jy=0,jang-jx
c           jz=jang-jx-jy
c           inttt(jln)=t1(ix,iy,iz,jx,jy,jz)
c       write(40,'(6i2,f20.14)')ix,iy,iz,jx,jy,jz,t1(ix,iy,iz,jx,jy,jz)
c           jln=jln+1
c          enddo
c         enddo
c        enddo
c      enddo
c
      return
      end
************************************************************************
      subroutine getbasnames(basname,atsymbol,natoms,minpfile,iout,
     $atnum,bsn,bfbasis,route)
************************************************************************
* Get the names of the basis sets for atoms
************************************************************************
      implicit none
      integer natoms,iatoms,i,j,minpfile,iout,atnum(*),m,n,nbas,ibas
      integer ii,jj
      character*1 ats(24),bsn1(20),bsn4(20),line2(16)
      character*1 line3(max(512,6*natoms))
      character*2 atsymbol(*),ch2,at2
      character*4 route
      character*5 bsn3
      character*8 c8
      character*16 line1
      character*20 basname(natoms),bsn,bsn2,bsn5,bfbasis
      character*24 atsymbas,ats1
      equivalence(ats,ats1)
      equivalence(bsn1,bsn2,bsn3)
      equivalence(bsn4,bsn5)
      equivalence(line1,line2)
C
       if(bsn.eq.'                    ') then
        write(iout,*)
        write(iout,*) 'Basis set is not specified!'
        call mrccend(1)
       else if(bsn.eq.'special             ') then
         do iatoms=1,natoms
          read(minpfile,*) basname(iatoms)
          call lowercase(basname(iatoms),basname(iatoms),20)
         enddo
       else if(bsn.eq.'atomtype            ') then
         do
          read(minpfile,"(a24)") ats1
           if(ats(2).eq.':') then
            ats(2)=' '
            call lowercase(ats(3),atsymbas,20)
           else if(ats(3).eq.':') then
            ats(3)=' '
            call lowercase(ats(4),atsymbas,20)
           else
            exit
           endif
          call lowercase(ats,ch2,2)
           do iatoms=1,natoms
            call lowercase(atsymbol(iatoms),at2,2)
             if(at2.eq.ch2) basname(iatoms)=atsymbas
           enddo
         enddo
       else if(bsn.eq.'mixed               '.or.
     $         bsn.eq.'corembed            '.or.
     $         bsn.eq.'embed               ') then
         if(bsn.eq.'mixed               ') then
          basname='                    '
          read(minpfile,*) nbas
         else
          nbas=1
          read(minpfile,*) bsn2
          bsn2=adjustl(bsn2)
          call lowercase(bsn2,bsn2,20)
          basname=bsn2
          read(minpfile,*) bsn2
          call lowercase(bsn2,bsn2,20)
           if(bsn.eq.'corembed            ') then
            call getkeym('corembed',8,c8,8)
           else
            call getkeym('embed',5,c8,8)
           endif
         endif
         do ibas=1,nbas
          n=0
          line3=' '
           do
            n=n+1
            read(minpfile,'(a)',advance='no',eor=1234,end=1234) line3(n)
           enddo
1234      continue
          n=1
           if(bsn.eq.'mixed               ') then
            bsn1=' '
             do while(line3(n).ne.' ')
              bsn1(n)=line3(n)
              n=n+1
             enddo
            call lowercase(bsn1,bsn1,20)
             do while(line3(n).eq.' ')
              n=n+1
             enddo
           endif
           do while(line3(n).ne.' ')
            m=n
             do while(line3(n).ne.','.and.line3(n).ne.'-'
     $    .and.line3(n).ne.' ')
              n=n+1
             enddo
            line1='                '
             do i=m,n-1
              line2(i-m+1)=line3(i)
             enddo
            read(line1,*) ii
            jj=ii
             if(line3(n).eq.'-') then
              n=n+1
              m=n
               do while(line3(n).ne.','.and.line3(n).ne.' ')
                n=n+1
               enddo
              line1='                '
               do i=m,n-1
                line2(i-m+1)=line3(i)
               enddo
              read(line1,*) jj
             endif
             if(jj.gt.natoms.or.ii.le.0.or.jj.le.0) then
              write(iout,*) 'Invalid serial number for atoms!'
              call mrccend(1)
             endif
            basname(ii:jj)=bsn2
            n=n+1
           enddo
         enddo
         do iatoms=1,natoms
           if(basname(iatoms).eq.'                    ') then
            write(line1,"(i16)") iatoms
            write(iout,*) 'Basis set is not specified for atom ' //
     $trim(adjustl(line1)) // '!'
            call mrccend(1)
           endif
         enddo
       else 
        bsn2=bsn
        bsn5=bsn
         if(bsn3.eq."aug'-") then
          bsn3='     '
          bsn2=adjustl(bsn2)
           do i=4,19
            bsn4(i)=bsn4(i+1)
           enddo
         endif
         do iatoms=1,natoms
           if(atnum(iatoms).eq.1) then
            basname(iatoms)=bsn2
           else if(atnum(iatoms).eq.0) then
            basname(iatoms)=bfbasis
           else
            basname(iatoms)=bsn5
           endif
         enddo
C No (aug-)cc-pVXZ-PP basis
        bsn2=bsn
         do i=1,17
           if(bsn1(i  ).eq.'-'.and.
     $        bsn1(i+1).eq.'p'.and.
     $        bsn1(i+2).eq.'p'.and.
     $        bsn1(i+3).eq.' ') then
            bsn1(i:i+3)=' '
             do iatoms=1,natoms
               if(atnum(iatoms).le.28) basname(iatoms)=bsn2
             enddo
           endif
         enddo
C No (aug-)cc-pV(X+d)Z
        bsn2=bsn
         do i=1,17
           if(bsn1(i  ).eq.'('.and.
     $        bsn1(i+2).eq.'+'.and.
     $        bsn1(i+3).eq.'d'.and.
     $        bsn1(i+4).eq.')') then
            bsn1(i  )=bsn1(i+1)
            bsn1(i+1)='z'
            bsn1(i+2)=' '
            bsn1(i+3)=' '
            bsn1(i+4)=' '
            bsn1(i+5)=' '
             do iatoms=1,natoms
               if(atnum(iatoms).lt.13.or.atnum(iatoms).gt.18)
     $basname(iatoms)=bsn2
             enddo
           endif
         enddo
       endif
C Problems with basis set names
       do iatoms=1,natoms
        bsn2=basname(iatoms)
        i=1
         do while(bsn1(i).ne.' ')
          i=i+1
         enddo
C Polarization functions for Pople's basis sets
         if(bsn1(1).eq.'3'.or.bsn1(1).eq.'6') then
           if(bsn1(i-1).eq.'*') then
             if(atnum(iatoms).le.2) then
               if(bsn1(i-2).ne.'*') bsn1(i-1)=' '
             else
               if(bsn1(i-2).eq.'*') bsn1(i-1)=' '
             endif
           endif
C Diffuse functions for Pople's basis sets
          i=1
           do while(bsn1(i).ne.'+'.and.bsn1(i).ne.' ')
            i=i+1
           enddo
           if(bsn1(i).eq.'+') then
             if(atnum(iatoms).le.2) then
               if(bsn1(i+1).ne.'+') then
                 do j=i,19
                  bsn1(j)=bsn1(j+1)
                 enddo
               endif
             else
               if(bsn1(i+1).eq.'+') then
                 do j=i,19
                  bsn1(j)=bsn1(j+1)
                 enddo
               endif
             endif
           endif
C Core functions for H and He for Dunnings's basis sets
         else if(atnum(iatoms).le.2.and.bsn1(i-5).eq.'p'.and.
     $bsn1(i-4).eq.'c'.and.bsn1(i-3).eq.'v') then
          bsn1(i-4)=bsn1(i-3)
          bsn1(i-3)=bsn1(i-2)
          bsn1(i-2)=bsn1(i-1)
          bsn1(i-1)=' '
         endif
        basname(iatoms)=bsn2
       enddo
C Minimal basis initial guess
       if(trim(route).eq.'min') then
         do iatoms=1,natoms
          basname(iatoms)='cc-pvtz-min         '
c         basname(iatoms)=trim(basname(iatoms)) // '-min'
         enddo
       endif
C
      return 
      end 
C
************************************************************************
      subroutine getecpnames(ecpname,atsymbol,natoms,minpfile,iout,
     $atnum,ecp,basname,ncorecp,gbasfile,cdmrcc,necpatoms,ecpatoms,
     $nangmax,nprimmax)
************************************************************************
* Get the names of the ECPs for atoms
************************************************************************
      implicit none
      integer natoms,iatoms,i,j,minpfile,iout,atnum(*),ncorecp(*),lmax
      integer gbasfile,necpatoms,ecpatoms(*),nangmax,nprimmax,nprim,eang
      character*1 ats(24),bsn1(20),ecp4(20),c1
      character*2 atsymbol(*),ch2,at2
      character*5 bsn3
      character*20 ecpname(natoms),ecp,bsn2,ecp5,basname(natoms)
      character*24 atsymecp,ats1,glabel
      character*512 cdmrcc
      equivalence(ats,ats1)
      equivalence(bsn1,bsn2,bsn3)
      equivalence(ecp4,ecp5)
      logical lgb
C
      ecpname(1:natoms)='                    '
      necpatoms=0
       if(ecp.eq.'none                ') then
C No ECP
        return
       else if(ecp.eq.'special             ') then
C ECP is specified for each atom
         do iatoms=1,natoms
          read(minpfile,*) ecpname(iatoms)
          call lowercase(ecpname(iatoms),ecpname(iatoms),20)
           if(ecpname(iatoms).eq.'none                ') 
     $ecpname(iatoms)='                    '
         enddo
       else if(ecp.eq.'atomtype            ') then
C ECP is specified for each atomtype
         do
          read(minpfile,"(a24)") ats1
           if(ats(2).eq.':') then
            ats(2)=' '
            call lowercase(ats(3),atsymecp,20)
           else if(ats(3).eq.':') then
            ats(3)=' '
            call lowercase(ats(4),atsymecp,20)
           else
            exit
           endif
          call lowercase(ats,ch2,2)
           if(atsymecp.ne.'none                ') then
             do iatoms=1,natoms
              call lowercase(atsymbol(iatoms),at2,2)
               if(at2.eq.ch2) ecpname(iatoms)=atsymecp
             enddo
           endif
         enddo
       else if(ecp.eq.'auto                ') then
C ECPs are selected automatically
         do iatoms=1,natoms
          bsn2=basname(iatoms)
           if(trim(bsn2).eq.'lanl2dz'.and.atnum(iatoms).ge.11) then
             if(     atnum(iatoms).le.29) then
              ecpname(iatoms)='lanl2dz-ecp-10      '
             else if(atnum(iatoms).le.30) then
              ecpname(iatoms)='lanl2dz-ecp-18      '
             else if(atnum(iatoms).le.47) then
              ecpname(iatoms)='lanl2dz-ecp-28      '
             else if(atnum(iatoms).le.48) then
              ecpname(iatoms)='lanl2dz-ecp-36      '
             else if(atnum(iatoms).le.57) then
              ecpname(iatoms)='lanl2dz-ecp-46      '
             else if(atnum(iatoms).le.79) then
              ecpname(iatoms)='lanl2dz-ecp-60      '
             else if(atnum(iatoms).le.81) then
              ecpname(iatoms)='lanl2dz-ecp-68      '
             else
              ecpname(iatoms)='lanl2dz-ecp-78      '
             endif
           else if(bsn3.eq.'def2-'.and.atnum(iatoms).ge.37) then
             if(     atnum(iatoms).le.54) then
              ecpname(iatoms)='def2-ecp-28         '
             else if(atnum(iatoms).le.57) then
              ecpname(iatoms)='def2-ecp-46         '
             else
              ecpname(iatoms)='def2-ecp-60         '
             endif
           else
             do i=1,17
               if(bsn1(i  ).eq.'-'.and.
     $            bsn1(i+1).eq.'p'.and.
     $            bsn1(i+2).eq.'p'.and.
     $            bsn1(i+3).eq.' '.and.atnum(iatoms).ge.29) then
                 if(     atnum(iatoms).le.36) then
                  ecpname(iatoms)='mcdhf-ecp-10        '
                 else if(atnum(iatoms).le.54) then
                  ecpname(iatoms)='mcdhf-ecp-28        '
                 else
                  ecpname(iatoms)='mcdhf-ecp-60        '
                 endif
               endif
             enddo
           endif
         enddo
       else 
C Same ECP for each atom
        call lowercase(ecp,ecp,20)
        ecpname(1:natoms)=ecp
       endif
c      do iatoms=1,natoms
c       write(6,*) basname(iatoms),ecpname(iatoms)
c      enddo
C Number of core electrons replaced by the ECP
       do iatoms=1,natoms
         if(atnum(iatoms).eq.0) ecpname(iatoms)='                    '
        bsn2=ecpname(iatoms)
         if(bsn2.eq.'                    ') then
          ncorecp(iatoms)=0
         else
          atsymecp=trim(atsymbol(iatoms)) // ":" // adjustl(bsn2)
          call lowercase(atsymecp,atsymecp,24)
          call gbcheck(lgb,atsymecp,gbasfile)
           if(.not.lgb) then
            open(gbasfile,file=trim(trim(cdmrcc) // atsymbol(iatoms)))
            glabel='                        '
             do while(atsymecp.ne.glabel)
              read(gbasfile,*,end=1000) glabel
              call lowercase(glabel,glabel,24)
             enddo
           endif
          c1=' '
           do while(c1.ne.'*')
            read(gbasfile,"(a1)") c1
           enddo
          read(gbasfile,"(11x,i3,11x,i1)") ncorecp(iatoms),lmax
          nangmax=max(nangmax,lmax)
          read(gbasfile,"(a1)") c1
           do eang=0,lmax
            read(gbasfile,"(a1)") c1
            c1=' '
            nprim=0
             do 
     $while(c1.eq.' '.or.(ichar(c1).ge.43.and.ichar(c1).le.57))
c            do while(c1.eq.' ')
              nprim=nprim+1
              backspace(gbasfile)
              read(gbasfile,*) 
              read(gbasfile,"(a1)") c1
             enddo
            nprimmax=max(nprimmax,nprim)
           enddo
          close(gbasfile)
         endif
         if(ncorecp(iatoms).gt.0) then
          necpatoms=necpatoms+1
          ecpatoms(necpatoms)=iatoms
         endif
       enddo
C
      return
1000  continue
      write(iout,*)
      write(iout,*) 'ECP ' // trim(bsn2) // ' not found!'
      call mrccend(1)
      end
C
************************************************************************
      subroutine readecp(ecpname,atsymbol,natoms,gbasfile,cdmrcc,
     $necpatoms,ecpatoms,nangmax,nprimmax,ecpn,ecpnang,ecpprim,ecpexp,
     $ecpcoef,iout)
************************************************************************
* Read the parameters of ECPs
************************************************************************
      implicit none
      integer natoms,iatoms,nangmax,nprimmax,nprim,eang,iout,i
      integer gbasfile,necpatoms,ecpatoms(necpatoms),iecpatoms
      integer ecpn(nprimmax,0:nangmax,necpatoms),ecpnang(necpatoms)
      integer ecpprim(0:nangmax,necpatoms)
      real*8 ecpexp(nprimmax,0:nangmax,necpatoms)
      real*8 ecpcoef(nprimmax,0:nangmax,necpatoms)
      character*1 c1
      character*2 atsymbol(*)
      character*20 ecpname(natoms),bsn2
      character*24 atsymecp,glabel
      character*512 cdmrcc
      logical lgb
C
      ecpn=0
      ecpnang=0
      ecpprim=0
      ecpexp=0.d0
      ecpcoef=0.d0
C
       do iecpatoms=1,necpatoms
        iatoms=ecpatoms(iecpatoms)
        bsn2=ecpname(iatoms)
        write(iout,"(i4,2x,a2,1x,a20)") iatoms,atsymbol(iatoms),bsn2
        atsymecp=trim(atsymbol(iatoms)) // ":" // adjustl(bsn2)
        call lowercase(atsymecp,atsymecp,24)
        call gbcheck(lgb,atsymecp,gbasfile)
         if(.not.lgb) then
          open(gbasfile,file=trim(trim(cdmrcc) // atsymbol(iatoms)))
          glabel='                        '
           do while(atsymecp.ne.glabel)
            read(gbasfile,*,end=1000) glabel
            call lowercase(glabel,glabel,24)
           enddo
         endif
        c1=' '
         do while(c1.ne.'*')
          read(gbasfile,"(a1)") c1
         enddo
        read(gbasfile,"(11x,i3,11x,i1)") i,ecpnang(iecpatoms)
        read(gbasfile,"(a1)") c1
         do eang=0,ecpnang(iecpatoms)
          read(gbasfile,"(a1)") c1
          c1=' '
          nprim=0
           do while(c1.eq.' '.or.(ichar(c1).ge.43.and.ichar(c1).le.57))
c          do while(c1.eq.' ')
            nprim=nprim+1
            backspace(gbasfile)
            read(gbasfile,*) ecpcoef(nprim,eang,iecpatoms),
     $ecpn(nprim,eang,iecpatoms),ecpexp(nprim,eang,iecpatoms)
c     write(6,"(f10.5,i4,f10.5)") ecpcoef(nprim,eang,iecpatoms),
c    $ecpn(nprim,eang,iecpatoms),ecpexp(nprim,eang,iecpatoms)
            read(gbasfile,"(a1)") c1
           enddo
          ecpprim(eang,iecpatoms)=nprim
         enddo
        close(gbasfile)
       enddo
C
      return
1000  continue
      write(iout,*)
      write(iout,*) 'ECP ' // trim(bsn2) // ' not found!'
      call mrccend(1)
      end
C
************************************************************************
      subroutine dfautobas(basname,dfbasname,natoms,lscf,lcor,route,
     $atnum)
************************************************************************
* Automatic fitting basis set names
************************************************************************
      implicit none
      integer natoms,iatoms,i,atnum(natoms)
      character*1 bsn1(20)
      character*4 bsn4,route
      character*5 bsn5
      character*20 basname(natoms),dfbasname(natoms),bsn
      equivalence(bsn,bsn1,bsn4,bsn5)
      logical lscf,lcor,ldef2,lpp,warn
C
       warn=.false. ! if T: warning for unconventional df basis choices
       do iatoms=1,natoms
        bsn=basname(iatoms)
         if(trim(route).eq.'min') then
          dfbasname(iatoms)=bsn
          cycle
         endif
C Minimal bases
         do i=1,17
           if(bsn1(i  ).eq.'-'.and.
     $        bsn1(i+1).eq.'m'.and.
     $        bsn1(i+2).eq.'i'.and.
     $        bsn1(i+3).eq.'n') then
            bsn1(i  )=' '
            bsn1(i+1)=' '
            bsn1(i+2)=' '
            bsn1(i+3)=' '
           endif
         enddo
C cc-pVXZ-F12
         do i=1,17
           if(bsn1(i  ).eq.'-'.and.
     $        bsn1(i+1).eq.'f'.and.
     $        bsn1(i+2).eq.'1'.and.
     $        bsn1(i+3).eq.'2') then
            bsn1(i  )=' '
            bsn1(i+1)=' '
            bsn1(i+2)=' '
            bsn1(i+3)=' '
            bsn='aug-' // adjustl(bsn)
           endif
         enddo
C (aug-)cc-pV(X+d)Z
         do i=1,17
           if(bsn1(i  ).eq.'('.and.
     $        bsn1(i+2).eq.'+'.and.
     $        bsn1(i+3).eq.'d'.and.
     $        bsn1(i+4).eq.')') then
            bsn1(i  )=bsn1(i+1)
            bsn1(i+1)='z'
            bsn1(i+2)=' '
            bsn1(i+3)=' '
            bsn1(i+4)=' '
            bsn1(i+5)=' '
           endif
         enddo
C def2 or cc-pVXZ-PP for SCF
        ldef2=.false.
        lpp=.false.
         do i=1,17
          ldef2=ldef2.or.(bsn1(i  ).eq.'d'.and.
     $                    bsn1(i+1).eq.'e'.and.
     $                    bsn1(i+2).eq.'f'.and.
     $                    bsn1(i+3).eq.'2')
          lpp=lpp.or.    (bsn1(i  ).eq.'-'.and.
     $                    bsn1(i+1).eq.'p'.and.
     $                    bsn1(i+2).eq.'p')
         enddo
         if((ldef2.or.lpp).and.lscf) then
           if((ldef2.and.(trim(adjustl(bsn)).eq.'def2-svpd'.or.
     $                    trim(adjustl(bsn)).eq.'def2-tzvpd'.or.
     $                    trim(adjustl(bsn)).eq.'def2-tzvppd'.or.
     $                    trim(adjustl(bsn)).eq.'def2-qzvpd'.or.
     $                    trim(adjustl(bsn)).eq.'def2-qzvppd')).or.
     $        (lpp  .and.bsn1(1).eq.'a'.and.
     $                   bsn1(2).eq.'u'.and.
     $                   bsn1(3).eq.'g'.and.
     $                   bsn1(4).eq.'-')) then
            bsn='def2-qzvppd         '
           else
            bsn='def2-qzvpp          '
           endif
         endif
C Pople
         if(bsn4.eq.'sto-'.or.bsn4.eq.'3-21'.or.bsn4.eq.'6-31') then
          dfbasname(iatoms)='cc-pvdz-ri          '
           if(bsn5.eq.'6-311') dfbasname(iatoms)='cc-pvtz-ri          '
           if(bsn1(5).eq.'+'.or.bsn1(6).eq.'+'.or.bsn1(7).eq.'+')
     $dfbasname(iatoms)='aug-' // adjustl(dfbasname(iatoms))
         else
          dfbasname(iatoms)=trim(bsn) // '-ri'
         endif
C Special default for SCF
         if(lscf) then
c          if(lcor.or.dfbasname(iatoms).eq.'cc-pvdz-ri          '.or.
c    $                dfbasname(iatoms).eq.'aug-cc-pvdz-ri      ')
c    $dfbasname(iatoms)=trim(dfbasname(iatoms)) // '-jk'
           dfbasname(iatoms)=trim(dfbasname(iatoms)) // '-jk'
            if(atnum(iatoms).eq.1.and.(
     $trim(adjustl(bsn)).eq.'def2-qzvp'.or.
     $trim(adjustl(bsn)).eq.'def2-qzvpd'.or.
     $trim(adjustl(bsn)).eq.'def2-qzvpp'.or.
     $trim(adjustl(bsn)).eq.'def2-qzvppd')) then
              dfbasname(iatoms)=adjustl(bsn)
              warn=.true.
            endif 
         endif ! lscf
       enddo
       if (warn) then
      write(*,*) 
      write(*,*) 'Warning: for H atoms in the case of dfbasis_scf=auto',
     $'the AO basis is set as dfbasis_scf instead of ',
     $'def2-qzvp(pd)-ri-jk because the AO basis is larger.',
     $'Set the dfbasis_scf=def2-qzvp(pd)-ri-jk in MINP if that is 
     $desired.'
       endif ! warn
C
      return 
      end 
C
************************************************************************
      subroutine prereadbas(natoms,nangmax,ncontrmax,nprimmax,nshmax,
     $basname,atsymbol,gbasfile,iscr,ianm,iout,bond,bfbasis,cdmrcc,
     $nbondc,icon,atnum)
************************************************************************
* Preread basis sets
************************************************************************
      implicit none
      integer natoms,nangmax,ncontrmax,nprimmax,nshmax,iatoms,naug,iout
      integer gbasfile,ii,i,j,nsh,iscr(*),ianm(*),nbondc,icon(*)
      integer atnum(natoms)
      character*1 bsn1(20)
      character*2 atsymbol(*)
      character*5 bsn2
      character*8 bond(natoms)
      character*20 basname(natoms),bsn,bfbasis
      character*24 atsymbas,glabel
      character*512 cdmrcc
      logical lgb,lmin
      equivalence(bsn,bsn2,bsn1)
C
       do iatoms=1,natoms-nbondc
c       rewind(gbasfile)
        bsn=basname(iatoms)
        naug=0
         if(bsn2.eq.'d-aug') naug=1
         if(bsn2.eq.'t-aug') naug=2
         if(bsn2.eq.'q-aug') naug=3
         if(bsn2.eq.'p-aug') naug=4
         if(naug.gt.0) bsn2='  aug'
         if(trim(adjustl(bsn)).eq.'aug-cc-pvdz-ri-jk'.or.
     $      trim(adjustl(bsn)).eq.'aug-cc-pvtz-ri-jk'.or.
     $      trim(adjustl(bsn)).eq.'aug-cc-pvqz-ri-jk'.or.
     $      trim(adjustl(bsn)).eq.'aug-cc-pv5z-ri-jk') then
          naug=naug+1
          bsn=adjustl(bsn)
          bsn2='    c'
         endif
         if(trim(adjustl(bsn)).eq.'def2-qzvppd-ri-jk') then
          naug=naug+1
          bsn='def2-qzvpp-ri-jk    '
         endif
        lmin=.false.
         do i=1,17
           if(bsn1(i  ).eq.'-'.and.
     $        bsn1(i+1).eq.'m'.and.
     $        bsn1(i+2).eq.'i'.and.
     $        bsn1(i+3).eq.'n') then
            lmin=.true.
            bsn1(i:i+3)=' '
           endif
         enddo
        atsymbas=trim(atsymbol(iatoms)) // ":" // adjustl(bsn)
        call lowercase(atsymbas,atsymbas,24)
        call gbcheck(lgb,atsymbas,gbasfile)
         if(.not.lgb) then
          open(gbasfile,file=trim(trim(cdmrcc) // atsymbol(iatoms)))
          glabel='                        '
           do while(atsymbas.ne.glabel)
            read(gbasfile,*,end=1000) glabel
            call lowercase(glabel,glabel,24)
           enddo
         endif
        read(gbasfile,*)
        call prereadbas1(nangmax,ncontrmax,nprimmax,nshmax,gbasfile,
     $iscr,ianm,nsh,icon,naug,lmin,atnum(iatoms))
        close(gbasfile)
       enddo
C
      return 
1000  continue
      write(iout,*)
      write(iout,*) 'Basis set ' // trim(bsn) // ' not found!'
      call mrccend(1)
      end 
C
************************************************************************
      subroutine prereadbas1(nangmax,ncontrmax,nprimmax,nshmax,gbasfile,
     $iscr,ianm,nsh,icon,naug,lmin,atnum)
************************************************************************
* Preread basis sets
************************************************************************
      implicit none
      integer nangmax,ncontrmax,nprimmax,nshmax,iatoms,naug,iout
      integer gbasfile,ii,i,j,nsh,iscr(*),ianm(*),icon(*),atnum
      logical lmin
C
      read(gbasfile,*)
      read(gbasfile,*) nsh
       if(lmin) then
         if(     atnum.le. 2) then
          nsh=1
         else if(atnum.gt. 2.and.atnum.le.20) then
          nsh=2
         else if(atnum.gt.20.and.atnum.le.56) then
          nsh=3
         else
          nsh=4
         endif
       endif
      nshmax=max(nshmax,nsh)
      read(gbasfile,*) (ianm(j),j=1,nsh)
       do i=1,nsh
        nangmax=max(nangmax,ianm(i))
       enddo
      read(gbasfile,*) (icon(j),j=1,nsh)
       do i=1,nsh
        ii=icon(i)
         do j=i+1,nsh
           if(ianm(i).eq.ianm(j)) ii=ii+icon(j)
         enddo
        ncontrmax=max(ncontrmax,ii+naug)
       enddo
      read(gbasfile,*) (iscr(j),j=1,nsh)
       do i=1,nsh
        ii=iscr(i)
         do j=i+1,nsh
           if(ianm(i).eq.ianm(j)) ii=ii+iscr(j)
         enddo
        nprimmax=max(nprimmax,ii+naug)
       enddo
C
      return 
      end 
C
************************************************************************
      subroutine aoscfiguess(nbasis,atnum,nang,natoms,nangmax,cartg,
     $ncontr,scrfile1,scfiga,scfigb,nal,nbe)
************************************************************************
* Atomic density initial guess for SCF
************************************************************************
      implicit none
      integer nbasis,atnum(*),nang(*),natoms,nangmax,scrfile1,iatoms
      integer ibasis,iang,i,j,k,l,m,icart,ncontr(0:nangmax,natoms),nal
      integer ncf(0:nangmax),nvf(0:nangmax),ntf(0:nangmax),icontr,nbe
      integer nva,nvb,nvfmax
      real*8 scfiga(nbasis),scfigb(nbasis),sum,nvoa(0:nangmax)
      real*8 nvob(0:nangmax),voca,vocb
      logical cartg
C
      ibasis=0
       do iatoms=1,natoms
         do iang=0,nang(iatoms)
          ntf(iang)=0
          ncf(iang)=0
          nvf(iang)=0
          nvoa(iang)=1.d0
          nvob(iang)=1.d0
         enddo
         if(atnum(iatoms).le.2) then
          nvf(0)=1 !1s
         else if(atnum(iatoms).ge.3.and.atnum(iatoms).le.4) then
          ncf(0)=1 !1s
          nvf(0)=1 !2s
         else if(atnum(iatoms).ge.5.and.atnum(iatoms).le.10) then
          ncf(0)=1 !1s
          nvf(0)=1 !2s
          nvf(1)=1 !2p
         else if(atnum(iatoms).ge.11.and.atnum(iatoms).le.12) then
          ncf(0)=2 !1s, 2s
          ncf(1)=1 !2p
          nvf(0)=1 !3s
         else if(atnum(iatoms).ge.13.and.atnum(iatoms).le.18) then
          ncf(0)=2 !1s, 2s
          ncf(1)=1 !2p
          nvf(0)=1 !3s
          nvf(1)=1 !3p
         else if(atnum(iatoms).ge.19.and.atnum(iatoms).le.20) then
          ncf(0)=3 !1s, 2s, 3s
          ncf(1)=2 !2p, 3p
          nvf(0)=1 !4s
         else if(atnum(iatoms).ge.21.and.atnum(iatoms).le.30) then
          ncf(0)=3 !1s, 2s, 3s
          ncf(1)=2 !2p, 3p
          nvf(0)=1 !4s
          nvf(2)=1 !3d
         else if(atnum(iatoms).ge.31.and.atnum(iatoms).le.36) then
          ncf(0)=4 !1s, 2s, 3s, 4s
          ncf(1)=2 !2p, 3p
          ncf(2)=1 !3d
          nvf(1)=1 !4p
         else if(atnum(iatoms).ge.37.and.atnum(iatoms).le.38) then
          ncf(0)=4 !1s, 2s, 3s, 4s
          ncf(1)=3 !2p, 3p, 4p
          ncf(2)=1 !3d
          nvf(0)=1 !5s
         else if(atnum(iatoms).ge.39.and.atnum(iatoms).le.48) then
          ncf(0)=4 !1s, 2s, 3s, 4s
          ncf(1)=3 !2p, 3p, 4p
          ncf(2)=1 !3d
          nvf(0)=1 !5s
          nvf(2)=1 !4d
         else if(atnum(iatoms).ge.49.and.atnum(iatoms).le.54) then
          ncf(0)=5 !1s, 2s, 3s, 4s, 5s
          ncf(1)=3 !2p, 3p, 4p
          ncf(2)=2 !3d, 4d
          nvf(1)=1 !5p
         else if(atnum(iatoms).ge.55.and.atnum(iatoms).le.56) then
          ncf(0)=5 !1s, 2s, 3s, 4s, 5s
          ncf(1)=4 !2p, 3p, 4p, 5p
          ncf(2)=2 !3d, 4d
          nvf(0)=1 !6s
         else if(atnum(iatoms).ge.57.and.atnum(iatoms).le.80) then
          ncf(0)=5 !1s, 2s, 3s, 4s, 5s
          ncf(1)=4 !2p, 3p, 4p, 5p
          ncf(2)=2 !3d, 4d
          nvf(0)=1 !6s
          nvf(2)=1 !5d
          nvf(3)=1 !4f
         else if(atnum(iatoms).ge.81.and.atnum(iatoms).le.86) then
          ncf(0)=6 !1s, 2s, 3s, 4s, 5s, 6s
          ncf(1)=4 !2p, 3p, 4p, 5p
          ncf(2)=3 !3d, 4d, 5d
          ncf(3)=1 !4f
          nvf(1)=1 !6p
         else if(atnum(iatoms).ge.87.and.atnum(iatoms).le.88) then
          ncf(0)=6 !1s, 2s, 3s, 4s, 5s, 6s
          ncf(1)=5 !2p, 3p, 4p, 5p, 6p
          ncf(2)=3 !3d, 4d, 5d
          ncf(3)=1 !4f
          nvf(0)=1 !7s
         else if(atnum(iatoms).ge.89.and.atnum(iatoms).le.112) then
          ncf(0)=6 !1s, 2s, 3s, 4s, 5s, 6s
          ncf(1)=5 !2p, 3p, 4p, 5p, 6p
          ncf(2)=3 !3d, 4d, 5d
          ncf(3)=1 !4f
          nvf(0)=1 !7s
          nvf(2)=1 !6d
          nvf(3)=1 !5f
         else
          ncf(0)=7 !1s, 2s, 3s, 4s, 5s, 6s, 7s
          ncf(1)=5 !2p, 3p, 4p, 5p, 6p
          ncf(2)=4 !3d, 4d, 5d, 6d
          ncf(3)=2 !4f, 5f
          nvf(1)=1 !7p
         endif
C Valence occupation
        i=0
        j=0
        nva=0
        nvb=0
        nvfmax=0
         do iang=0,nang(iatoms)
          i=i+ncf(iang)*(2*iang+1)
           if(nvf(iang).ne.0) nvfmax=iang
         enddo
        i=atnum(iatoms)-2*i
         do iang=0,nvfmax-1
          nva=nva+nvf(iang)*(2*iang+1)
          nvb=nvb+nvf(iang)*(2*iang+1)
         enddo
        nva=nva+min(i-nva-nvb,nvf(nvfmax)*(2*iang+1))
        nvb=nvb+i-nva-nvb
         if(cartg) then
           do iang=0,nang(iatoms)
            j=j+nvf(iang)*(iang+1)*(iang+2)
            ncf(iang)=ncf(iang)*(iang+1)*(iang+2)/2
            nvf(iang)=ncf(iang)+nvf(iang)*(iang+1)*(iang+2)/2
           enddo
         else
           do iang=0,nang(iatoms)
            j=j+nvf(iang)*(2*iang+1)
            ncf(iang)=ncf(iang)*(2*iang+1)
            nvf(iang)=ncf(iang)+nvf(iang)*(2*iang+1)
           enddo
         endif
C Hybridization
        voca=dble(nva)/dble(j)
        vocb=dble(nvb)/dble(j)
c        if(.false.) then
         if(atnum(iatoms).ge.5.and.atnum(iatoms).le.18) then
           if(atnum(iatoms).eq. 5) nvoa(0)=0.65d0 !B
           if(atnum(iatoms).eq. 6) nvoa(0)=0.50d0 !C
           if(atnum(iatoms).eq. 7) nvoa(0)=0.85d0 !N
           if(atnum(iatoms).eq. 8) nvoa(0)=0.90d0 !O
           if(atnum(iatoms).eq. 9) nvoa(0)=0.95d0 !F
           if(atnum(iatoms).eq.11) nvoa(0)=0.50d0 !Na
           if(atnum(iatoms).eq.13) nvoa(0)=0.75d0 !Al
           if(atnum(iatoms).eq.14) nvoa(0)=0.80d0 !Si
           if(atnum(iatoms).eq.15) nvoa(0)=0.85d0 !P
           if(atnum(iatoms).eq.16) nvoa(0)=0.90d0 !S
           if(atnum(iatoms).eq.17) nvoa(0)=0.95d0 !Cl
          nvob(0)=min(dble(nvb),nvoa(0))
          nvoa(1)=(dble(nva)-nvoa(0))/3.d0
          nvob(1)=(dble(nvb)-nvob(0))/3.d0
         else
           do iang=0,nvfmax
            nvoa(iang)=voca
            nvob(iang)=vocb
           enddo
         endif
C
         do iang=0,nang(iatoms)
           do icontr=1,ncontr(iang,iatoms)
            icart=0
             if(cartg) then
               do i=0,iang
                 do k=0,iang-i
                  m=iang-i-k
                  icart=icart+1
                  ibasis=ibasis+1
                  ntf(iang)=ntf(iang)+1
                   if(ntf(iang).le.ncf(iang)) then
                    scfiga(ibasis)=
     $dble(2*iang+1)/dble((iang+1)*(iang+2)/2)
                    scfigb(ibasis)=scfiga(ibasis)
                   else if(ntf(iang).le.nvf(iang)) then
                    scfiga(ibasis)=nvoa(iang)
                    scfigb(ibasis)=nvob(iang)
                   else
                    scfiga(ibasis)=0.d0
                    scfigb(ibasis)=0.d0
                   endif
                 enddo
               enddo
             else
               do l=-iang,iang
                ibasis=ibasis+1
                ntf(iang)=ntf(iang)+1
                 if(ntf(iang).le.ncf(iang)) then
                  scfiga(ibasis)=1.d0
                  scfigb(ibasis)=1.d0
                 else if(ntf(iang).le.nvf(iang)) then
                  scfiga(ibasis)=nvoa(iang)
                  scfigb(ibasis)=nvob(iang)
                 else
                  scfiga(ibasis)=0.d0
                  scfigb(ibasis)=0.d0
                 endif
               enddo
             endif
           enddo
         enddo !iang
       enddo !iatoms
C Save initial guess for SCF AO density
       do i=1,nbasis
        scfiga(i)=scfiga(i)+scfigb(i)
        scfigb(i)=scfiga(i)
       enddo
      sum=0.d0
       do i=1,nbasis
        sum=sum+scfiga(i)
       enddo
      call dscal(nbasis,dble(nal)/sum,scfiga,1)
      sum=0.d0
       do i=1,nbasis
        sum=sum+scfigb(i)
       enddo
      call dscal(nbasis,dble(nbe)/sum,scfigb,1)
C
       if(scrfile1.gt.0) then
        rewind(scrfile1)
        write(scrfile1) scfiga
        write(scrfile1) scfigb
c       write(6,"(10f13.4)") (scfiga(i)+scfigb(i),i=1,nbasis)
c       write(6,"(10f13.4)") (scfiga(i),i=1,nbasis)
c       write(6,"(10f13.4)") (scfigb(i),i=1,nbasis)
        close(scrfile1)
       endif
C
      return 
      end 
C
************************************************************************
      subroutine dftgrid(nagrid,tagrid,agrid,aweight,natoms,atnum,
     $coord,grid,distc,p,rrgrid,ngrid,nlgrid,nleb,nagridmin,maxleb,
     $nangmax,ncontrmax,nprimmax,ncartmax,nsphermax,nang,ncontr,nprim,
     $gexp,gcoef,ctostr,cartg,vprim,sgrid,dvec,atsymbol,basname,cdmrcc,
     $nangmin,ragr,atcl,gcn,natrange,lnl,nbfatmax,aleb)
************************************************************************
* Construct integration grid for DFT (Becke, s from Murray)
************************************************************************
#include "MRCCCOMMON"
      integer nagrid,iagrid,natoms,atnum(natoms),iatoms,igrtol,nrgrid,i
      integer irgrid,iatnum,ngrid,jatoms,katoms,nlgrid,ilgrid,maxleb,j,k
      integer nagridmax,nagridmin,nleb(maxleb),lmin,lmax,ibasis,jprim
      integer nangmax,ncontrmax,nprimmax,ncartmax,nsphermax,jspher,jcart
      integer nang(natoms),ncontr(0:nangmax,natoms),jcontr,nba,atmuls
      integer nprim(0:nangmax,natoms),njcontr,njspher,jang,nbrg,nbrgmax
      integer nragrid,iragrid,atcl(natoms),kkatoms,natrange(2,natoms)
      integer gcn(2,ncontrmax,0:nangmax,natoms),nangmin(natoms),ibrg
      integer nblsize,nblock,nbl,nbll,imind2,nbfatmax,aleb(maxleb),llmin
      integer nrgridmin,nrgridmax
      parameter(nbrgmax=4,nblsize=128) !nblsize: stack in libxcifc!
      real*8 gexp(nprimmax,0:nangmax,natoms),ln2,dsinp,alp
      real*8 gcoef(nprimmax,ncontrmax,0:nangmax,natoms),r2
      real*8 ctostr(ncartmax**2,0:nangmax),ax,ay,az,y,z
      real*8 aweight(nagrid,nlgrid),agrid(3,nagrid,nlgrid),radtol,a,w
      real*8 bragg(0:natmax),pingri,x,rm,ragr(natoms)
      real*8 vprim(nprimmax),coordd(3),brg
      real*8 brgg(nbrgmax),brgh,en,eo
      real*8 err(nbfatmax,nbrgmax),enn(nbfatmax)
      real*8 rgrid,rweight,pingr,coord(3,natoms),xcoord,ycoord,zcoord
      real*8 grid(4,*),distc(natoms,natoms),p(natoms),grtol,xgr,ygr,zgr
      real*8 psum,pj,rri,ri,rj,rij,chi,uij,aij,muij,s,wgr,sum
      real*8 sgrid(3,nleb(maxleb)),dvec(nagrid*nbasis)
      character*1 ch1
      character*2 ch2,atsymbol(natoms)
      character*3 ch3
      character*4 ch4,citol
      character*6 tagrid,aagrid,rrgrid
      character*7 scfiguess
      character*12 cgr
      character*20 basname(natoms),bsn
      character*40 grfile
      character*512 cdmrcc
      logical cartg,llg,llf,lnl
C Bragg-Slater radii in pm, 35 pm insted of 25 pm is taken for H (covalent radii for noble gases, At, Fr, and elements beyond Am)
      data bragg / 70.d0,
     $             35.d0,32.d0,145.d0,105.d0,85.d0,70.d0,65.d0,60.d0,
     $ 50.d0, 69.d0,180.d0,150.d0,125.d0,110.d0,100.d0,100.d0,100.d0,
     $ 71.d0,220.d0,180.d0,160.d0,140.d0,135.d0,140.d0,140.d0,140.d0,
     $135.d0,135.d0,135.d0,135.d0,130.d0,125.d0,115.d0,115.d0,115.d0,
     $110.d0,235.d0,200.d0,180.d0,155.d0,145.d0,145.d0,135.d0,130.d0,
     $135.d0,140.d0,160.d0,155.d0,155.d0,145.d0,145.d0,140.d0,140.d0,
     $130.d0,260.d0,215.d0,195.d0,185.d0,185.d0,185.d0,185.d0,185.d0,
     $185.d0,180.d0,175.d0,175.d0,175.d0,175.d0,175.d0,175.d0,175.d0,
     $155.d0,145.d0,135.d0,135.d0,130.d0,135.d0,135.d0,135.d0,150.d0,
     $190.d0,180.d0,160.d0,190.d0,150.d0,120.d0,260.d0,215.d0,195.d0,
     $180.d0,180.d0,175.d0,175.d0,175.d0,175.d0,169.d0,168.d0,168.d0,
     $165.d0,167.d0,173.d0,176.d0,161.d0,157.d0,149.d0,143.d0,141.d0,
     $134.d0,129.d0,128.d0,121.d0,122.d0,136.d0,143.d0,162.d0,175.d0,
     $165.d0,157.d0/
      data coordd /0.d0,0.d0,0.d0/
      brgh=bragg(1)/(angtobohr*100.d0)
C Read angular grid
      nagridmax=nagrid
      nagridmin=max(nagridmin,6)
       do i=1,maxleb
         if(nleb(i).eq.nagridmin) lmin=i
         if(nleb(i).eq.nagridmax) lmax=i
       enddo
       do ilgrid=1,nlgrid
         if(nlgrid.ne.1) then
          nagrid=nleb(ilgrid)
           if(nagrid.lt.10) then
            write(ch1,"(i1)") nagrid
            tagrid='ld' // '000' // ch1
           else if(nagrid.lt.100) then
            write(ch2,"(i2)") nagrid
            tagrid='ld' // '00' // ch2
           else if(nagrid.lt.1000) then
            write(ch3,"(i3)") nagrid
            tagrid='ld' // '0' // ch3
           else
            write(ch4,"(i4)") nagrid
            tagrid='ld' // ch4
           endif
         endif
        bsn=tagrid // '              '
        call gbcheck(llg,bsn,gbasfile)
         if(.not.llg) then
          open(gbasfile,file=trim(trim(cdmrcc) // 'Grid'))
          aagrid='      '
           do while(aagrid.ne.tagrid)
            read(gbasfile,*) aagrid
            call lowercase(aagrid,aagrid,6)
           enddo
         endif
        sum=0.d0
         do iagrid=1,nagrid
          read(gbasfile,*)agrid(1,iagrid,ilgrid),agrid(2,iagrid,ilgrid),
     $                    agrid(3,iagrid,ilgrid),aweight(iagrid,ilgrid)
          sum=sum+aweight(iagrid,ilgrid)
         enddo
        call dscal(nagrid,4.d0*pi/sum,aweight(1,ilgrid),1)
        close(gbasfile)
       enddo
      ilgrid=1
      ln2=dlog(2.d0)
C Accuracy
      call getkey('grtol',5,citol,4)
      read(citol,*) igrtol
      grtol=10.d0**(-igrtol)
C Loop over atoms
      ngrid=0
       do iatoms=1,natoms
        nragrid=ngrid
        iatnum=atnum(iatoms)
        llmin=lmin
         do while(aleb(llmin).lt.2*nang(iatoms)+1)
          llmin=llmin+1
         enddo
        xcoord=coord(1,iatoms)
        ycoord=coord(2,iatoms)
        zcoord=coord(3,iatoms)
        alp=5.d0
         if(iatnum.le.2) then
          i=0
         else if(iatnum.le.10) then
          i=1
           if(iatnum.le.4) then
            alp=7.d0
           endif
         else if(iatnum.le.18) then
          i=2
           if(iatnum.le.12) alp=7.d0
         else if(iatnum.le.36) then
          i=3
           if(iatnum.le.20) alp=7.d0
         else if(iatnum.le.54) then
          i=4
         else if(iatnum.le.86) then
          i=5
         else
          i=6
         endif
         if(mod(igrtol,2).eq.0) then
          nrgridmax=max(20,5*(3*igrtol/2+i+10))
         else
          nrgridmax=max(20,5*(3*(igrtol+1)/2+i+9))
         endif
        radtol=10.d0*grtol
C Select radial grid
         if(nlgrid.ne.1) then
          nba=natrange(2,iatoms)-natrange(1,iatoms)
          grfile='mrdftgrid.' // trim(adjustl(atsymbol(iatoms))) // '.'
     $// trim(adjustl(basname(natoms)))
          inquire(file=grfile,exist=llg)
          open(unit=scrfile5,file=grfile,status='unknown',
     $form='unformatted')
           if(llg) then
            read(scrfile5) nrgrid
           else
            en=-1d30
            nrgridmin=20
            nrgridmax=max(nrgridmin,min(nrgridmax,nleb(maxleb)))
            nrgrid=nrgridmax+1
             do while(nrgrid.gt.nrgridmin.and.en.lt.radtol)
              nrgrid=nrgrid-1
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(irgrid,x,rgrid)
               do irgrid=1,nrgrid
                x=dble(irgrid)/dble(nrgrid+1)
                rgrid=-alp*dlog(1.d0-x**3)
                sgrid(1,irgrid)=0.d0
                sgrid(2,irgrid)=0.d0
                sgrid(3,irgrid)=rgrid
                grid(irgrid,nragrid+1)=
     $3.d0*rgrid**2*alp*x**2/((1.d0-x**3)*dble(nrgrid+1))
               enddo
C$OMP END PARALLEL DO
              call calcorb(nrgrid,sgrid,1,nangmax,ncontrmax,
     $nprimmax,ncartmax,nsphermax,nang(iatoms),ncontr(0,iatoms),
     $nprim(0,iatoms),gexp(1,0,iatoms),gcoef(1,1,0,iatoms),coordd,
     $ctostr,cartg,dvec,nba,vprim,ibasis,nangmin(iatoms),
     $gcn(1,1,0,iatoms),0.d0,.false.,i,i)
               if(nba.ne.ibasis) then
                write(iout,*) 'Fatal error at grid construction!'
                call mrccend(1)
               endif
              call nrmcalc(nrgrid,nba,dvec,1.d0,grid(1,nragrid+1),enn)
               if(nrgrid.eq.nrgridmax) then
                err(1:nba,1)=enn(1:nba)
                en=-1d30
               else
                en=maxval(dabs(enn(1:nba)-err(1:nba,1)))
               endif
             enddo
             if(nrgrid.gt.nrgridmin.or.en.ge.radtol) nrgrid=nrgrid+1
            write(scrfile5) nrgrid
           endif
         else
          nrgrid=nrgridmax
         endif
c       write(6,*) nrgrid,igrtol,radtol,grtol
        brg=bragg(iatnum)/(angtobohr*100.d0)
        rm=brg
        brgg(1)=0.d0
        brgg(2)=2.d0*brg
        brgg(3)=brg
        brgg(4)=brgh+brg
        nbrg=3
         if(iatnum.ne.1.and.rrgrid.eq.'gc    ') rm=0.5d0*rm
c       nbrg=1 !szemet szemet szemet szemet szemet szemet szemet 
        pingr=pi/dble(nrgrid+1)
C Loop over points of the radial grid
         do irgrid=1,nrgrid
           if(rrgrid.eq.'log3  ') then !Mura-Knowles Log3
            x=dble(irgrid)/dble(nrgrid+1)
            rgrid=-alp*dlog(1.d0-x**3)
            rweight=3.d0*rgrid**2*alp*x**2/((1.d0-x**3)*dble(nrgrid+1))
           else if(rrgrid.eq.'gc    ') then !Gauss-Chebyshev
C Gauss-Chebyshev, Becke
c           pingri=dble(nrgrid-irgrid+1)*pingr
c           x=dcos(pingri)
c           rgrid=rm*(1.d0+x)/(1.d0-x)
c           rweight=rgrid**2*pingr*dsin(pingri)**2*2.d0*rm/
c    $(dsqrt(1.d0-x**2)*(1.d0-x)**2)
C Gauss-Chebyshev, Treutler and Ahlrichs, with Becke's rm
c           pingri=dble(nrgrid-irgrid+1)*pingr
c           x=dcos(pingri)
c           rgrid=rm*(1.d0+x)**0.6d0*dlog(2.d0/(1.d0-x))/ln2
c           rweight=rgrid**2*(rm*(1.d0+x)**0.6d0/((1.d0-x)*ln2)+
c    $rgrid*0.6d0/(1.d0+x))*pingr*dsin(pingri)**2/dsqrt(1.d0-x**2)
C Gauss-Chebyshev, modified Krack and Koster: Becke's rm included
            pingri=dble(nrgrid-irgrid+1)*pingr
            dsinp=dsin(pingri)
            x=dble(2*irgrid-nrgrid-1)/dble(nrgrid+1)+
     $(2.d0+4.d0*dsinp**2/3.d0)*dcos(pingri)*dsinp/pi
            rgrid=rm*dlog(2.d0/(1.d0-x))/ln2
            rweight=rgrid**2*(rm/((1.d0-x)*ln2))
     $*16.d0*dsinp**4/(3.d0*(nrgrid+1))
           else !Euler-Maclaurin of Murray
            x=dble(irgrid)/dble(nrgrid+1)
            rgrid=rm*(x/(1.d0-x))**2
            rweight=2.d0*rm**3*x**5/((1.d0-x)**7*dble(nrgrid+1))
           endif
c       write(6,"(i4,30f15.6)") irgrid,rgrid,rweight,alp,x
C Select angular grid
           if(nlgrid.ne.1) then
             if(llg) then
              read(scrfile5) ilgrid
              nagrid=nleb(ilgrid)
             else
              en=-1d30
              ilgrid=lmax+1
               do while(ilgrid.gt.llmin.and.en.lt.radtol)
                ilgrid=ilgrid-1
                nagrid=nleb(ilgrid)
                en=0.d0
                 do ibrg=1,nbrg
                  call dcopy(3*nagrid,agrid(1,1,ilgrid),1,sgrid,1)
                  call dscal(3*nagrid,rgrid,sgrid,1)
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(iagrid)
                   do iagrid=1,nagrid
                    sgrid(3,iagrid)=sgrid(3,iagrid)+brgg(ibrg)
                   enddo
C$OMP END PARALLEL DO
                  call calcorb(nagrid,sgrid,1,nangmax,ncontrmax,
     $nprimmax,ncartmax,nsphermax,nang(iatoms),ncontr(0,iatoms),
     $nprim(0,iatoms),gexp(1,0,iatoms),gcoef(1,1,0,iatoms),coordd,
     $ctostr,cartg,dvec,nba,vprim,ibasis,nangmin(iatoms),
     $gcn(1,1,0,iatoms),0.d0,.false.,i,i)
                   if(nba.ne.ibasis) then
                    write(iout,*) 'Fatal error at grid construction!'
                    call mrccend(1)
                   endif
                  call nrmcalc(nagrid,nba,dvec,rweight,
     $aweight(1,ilgrid),enn)
                   if(ilgrid.eq.lmax) then
                    err(1:nba,ibrg)=enn(1:nba)
                    en=-1d30
                   else
c     write(6,"(i6,10f15.10)") ilgrid,sum,err(ibrg),dabs(sum-err(ibrg))
                    en=max(en,maxval(dabs(enn(1:nba)-err(1:nba,ibrg))))
                   endif
                 enddo
               enddo
               if(ilgrid.gt.llmin.or.en.ge.radtol) ilgrid=ilgrid+1
              nagrid=nleb(ilgrid)
c     write(6,"(1000i6,10f12.7)") irgrid,ilgrid,nagrid
              write(scrfile5) ilgrid
             endif
           endif
           do iagrid=1,nagrid
            nragrid=nragrid+1
            grid(1,nragrid)=xcoord+rgrid*agrid(1,iagrid,ilgrid)
            grid(2,nragrid)=ycoord+rgrid*agrid(2,iagrid,ilgrid)
            grid(3,nragrid)=zcoord+rgrid*agrid(3,iagrid,ilgrid)
            grid(4,nragrid)=rweight*aweight(iagrid,ilgrid)
           enddo !iagrid
         enddo !irgrid
        call qsortd(atcl,natoms,distc(1,iatoms))
c         write(6,*) nragrid-ngrid
c         write(6,"(i4,20f20.6)") irgrid,rgrid,rweight,rm,x
C Loop over points of the angular grid
           do iragrid=ngrid+1,nragrid
            xgr=grid(1,iragrid)
            ygr=grid(2,iragrid)
            zgr=grid(3,iragrid)
            wgr=grid(4,iragrid)
C Construct Voronoi polyhedron
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(jatoms)
             do jatoms=1,natoms
              ragr(jatoms)=dsqrt((xgr-coord(1,jatoms))**2+
     $                           (ygr-coord(2,jatoms))**2+
     $                           (zgr-coord(3,jatoms))**2)
             enddo
C$OMP END PARALLEL DO
            psum=0.d0
C$OMP PARALLEL DO Schedule(Dynamic)
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(natoms,bragg,atnum,xgr,ygr,zgr,coord,distc,grtol,p,ragr)
C$OMP& SHARED(atcl)
C$OMP& REDUCTION(+:psum)
             do jatoms=1,natoms
              pj=1.d0
              rri=bragg(atnum(jatoms))
              ri=ragr(jatoms)
               do kkatoms=1,natoms
                katoms=atcl(kkatoms)
                 if(katoms.eq.jatoms) cycle
                rij=distc(katoms,jatoms)
                chi=rri/bragg(atnum(katoms))
                rj=ragr(katoms)
                uij=(chi-1.d0)/(chi+1.d0)
                aij=min(0.5d0,max(-0.5d0,uij/(uij**2-1.d0)))
                muij=(ri-rj)/rij
                s=muij+aij*(1.d0-muij**2)
C Becke, k=3
c                do i=1,3
c                 s=1.5d0*s-0.5d0*s**3
c                enddo
c               pj=pj*0.5d0*(1.d0-s)
C Murray, m_mu=10
                muij=1.d0-s*s
                sum=-0.5d0*s
                s=0.5d0+sum
                sum=sum*muij*0.5d0
                s=s+sum
                sum=sum*muij*0.75d0
                s=s+sum
                sum=sum*muij*0.83333333333333333333d0
                s=s+sum
                sum=sum*muij*0.875d0
                s=s+sum
                sum=sum*muij*0.9d0
                s=s+sum
                sum=sum*muij*0.91666666666666666666d0
                s=s+sum
                sum=sum*muij*0.92857142857142857142d0
                s=s+sum
                sum=sum*muij*0.9375d0
                s=s+sum
                sum=sum*muij*0.94444444444444444444d0
                s=s+sum+sum*muij*0.95d0
c                do i=3,10
c                 s=s+sum
c                 sum=sum*muij*dble(2*i+1)/dble(2*i+2)
c                enddo
                pj=pj*s
c          write(6,"(2i4,30f20.6)") 
c    $jatoms,katoms,rri,bragg(atnum(katoms)),s,pj
                 if(pj.lt.grtol) exit
               enddo !katoms
              psum=psum+pj
              p(jatoms)=pj
             enddo !jatoms
C$OMP END PARALLEL DO
            wgr=wgr*p(iatoms)/psum
C Prescreening grid point
c             sum=0.d0
c C$OMP PARALLEL DO
c C$OMP& DEFAULT(PRIVATE)
c C$OMP& SHARED(natoms,ragr,nang,nprim,gexp,atcl)
c C$OMP& REDUCTION(max:sum)
c              do katoms=1,min(30,natoms)
c               jatoms=atcl(katoms)
c               ri=ragr(jatoms)
c               r2=ri*ri
c                do jang=0,nang(jatoms)
c                  do jprim=1,nprim(jang,jatoms)
c                  sum=max(sum,ri**jang*dexp(-gexp(jprim,jang,jatoms)*r2))
c                  enddo
c                enddo
c              enddo !jatoms
c C$OMP END PARALLEL DO
c     write(6,*) wgr,sum
c            if(dabs(wgr*sum**2).gt.0.0001d0*grtol) then
             if(dabs(wgr).gt.1d-4*grtol) then
              ngrid=ngrid+1
              grid(1,ngrid)=xgr
              grid(2,ngrid)=ygr
              grid(3,ngrid)=zgr
              grid(4,ngrid)=wgr
c         write(6,"(i3,f24.6,3f13.6)") ngrid,wgr,xgr,ygr,zgr
             endif
           enddo !iragrid
         if(nlgrid.ne.1) close(scrfile5)
       enddo !iatoms
      write(cgr,"(i12)") ngrid
      write(iout,*) 'Total number of grid points: ' // adjustl(cgr)
C Save grid
      call gridsort_semi(grid, ngrid, coord, natoms, grid(1,ngrid+1),
     &     grid(1,ngrid+ngrid/4+2), grid(1,ngrid+ngrid/4+natoms/4+3),
     &     grid(1,ngrid+ngrid/4+natoms/4+ngrid+4), 
     &     grid(1,ngrid+ngrid/4+natoms/4+ngrid+ngrid/4+5), 
     &     nblsize)
c      call gridsort(grid,grid(1,ngrid+1),grid(1,2*ngrid+1),ngrid,
c    $nblsize)
      nbl=nblsize ! No memory check
       if(nbl.eq.0) then
        write(iout,*) 'Insufficient memory for the construction of the'
        write(iout,*) 'exchange-correlation matrix!'
        call mrccend(1)
       endif
      nbll=mod(ngrid,nbl)
      nblock=(ngrid-nbll)/nbl
       if(nbll.ne.0) then
        nblock=nblock+1
       else
        nbll=nbl
       endif
      write(varsfile) 'ngrid     ',iintln,ngrid
      open(scrfile5,file='DFTGRID',form='unformatted')
      rewind(scrfile5)
      write(scrfile5) ((grid(i,j),i=1,3),j=1,ngrid)
      write(scrfile5) ( grid(4,j)       ,j=1,ngrid)
      write(scrfile5) nblock,nbl,nbll
       if(lnl) then
        call timer
        write(iout,*)
        write(iout,*) 'Calculation of prescreening values for van der '
     $// 'Waals functionals...'
        imind2=imem+ngrid*4
        call mindist2(grid,ngrid,nblock,nbl,dcore(imind2))
        write(scrfile5) dcore(imind2:imind2-1+nblock*(nblock-1)/2)
       endif
      close(scrfile5)
C
      return 
      end 
C
************************************************************************
      subroutine gridsort_semi(grid, ngrid, coord, natoms, work, atord,
     &  work2, iord, work3, nblsize)
************************************************************************
* Grid batches for seminumerical calculation
************************************************************************
      implicit none
      integer ngrid, natoms, work(ngrid), atord(natoms)
      integer igrid, iatoms, natord, last, i, grid_per_at, i0
      integer nblsize, iord(ngrid)
      logical ll
      double precision grid(4, ngrid), coord(3, natoms), work2(4, ngrid)
      double precision work3(4, ngrid)
      double precision min_dist, dist

      work = 0
      ! Find the closest atom to each gridpoint
C$OMP PARALLEL DO
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(ngrid,natoms,grid,coord,work)
      do igrid = 1, ngrid
        min_dist = 1.0d20
        do iatoms = 1, natoms
          dist = (grid(1, igrid)-coord(1, iatoms))**2 +
     &           (grid(2, igrid)-coord(2, iatoms))**2 +
     &           (grid(3, igrid)-coord(3, iatoms))**2 
          if(dist .lt. min_dist) then
            work(igrid) = iatoms
            min_dist = dist
          endif
        enddo
      enddo
C$OMP END PARALLEL DO

      ! sort atoms
      atord = 0
      atord(1) = 1
      natord = 1
      do while (natord .ne. natoms)
        last = atord(natord)
        min_dist = 1.0d20
        do iatoms = 1, natoms
          ll = .false.
          do i = 1, natord
            if(iatoms .eq. atord(i)) then
              ll = .true.
              exit
            endif
          enddo
          if(ll) cycle
          dist = (coord(1, last) - coord(1, iatoms))**2 +
     &           (coord(2, last) - coord(2, iatoms))**2 +
     &           (coord(3, last) - coord(3, iatoms))**2
          if(dist .lt. min_dist) then
            min_dist = dist
            atord(natord+1) = iatoms
          endif
        enddo
        natord = natord + 1
      enddo

      ! reordering gridpoints
      i = 0
      i0 = 1
      do natord = 1, natoms
        iatoms = atord(natord)
        grid_per_at = 0
        do igrid = 1, ngrid
          if(work(igrid) .eq. iatoms) then
            i = i + 1
            grid_per_at = grid_per_at + 1
            work2(1:4, i) = grid(1:4, igrid)
          endif
        enddo
c       write(*,'(I4,I8)') iatoms, grid_per_at
        call gridsort(work2(1, i0), work3, iord, grid_per_at, 
     &       nblsize)
        i0 = i0 + grid_per_at
      enddo
      call dcopy(4*ngrid, work2, 1, grid, 1)

      end subroutine
************************************************************************
      subroutine gridsort(grid,work,iord,ngrid,nblsize)
************************************************************************
* Sort grid points
************************************************************************
      implicit none
      integer ngrid,iord(ngrid),igrid,nblock,nblsize,nblxx,nblx,ix
      integer xblock,nblyy,nbly,iy,yblock,xb,yb
      real*8 grid(4,ngrid),work(4,ngrid)
C
       if(ngrid.le.nblsize) return
C reorder z
      call dcopy(ngrid,grid(3,1),4,work,1)
      call qsortd(iord,ngrid,work)
      call dcopy(4*ngrid,grid,1,work,1)
       do igrid=1,ngrid
        grid(1,igrid)=work(1,iord(igrid))
        grid(2,igrid)=work(2,iord(igrid))
        grid(3,igrid)=work(3,iord(igrid))
        grid(4,igrid)=work(4,iord(igrid))
       enddo
c     return
C reorder y
      nblock=idnint((dble(ngrid)/dble(nblsize))**(1.d0/3.d0))
       if(nblock.eq.1) return
      ix=mod(ngrid,nblock)
      nblx=(ngrid-ix)/nblock
       do xblock=1,nblock
        nblxx=nblx
         if(xblock.eq.nblock) nblxx=nblx+ix
        xb=(xblock-1)*nblx
        call dcopy(nblxx,grid(2,xb+1),4,work,1)
        call qsortd(iord,nblxx,work)
        call dcopy(4*nblxx,grid(1,xb+1),1,work,1)
         do igrid=1,nblxx
          grid(1,xb+igrid)=work(1,iord(igrid))
          grid(2,xb+igrid)=work(2,iord(igrid))
          grid(3,xb+igrid)=work(3,iord(igrid))
          grid(4,xb+igrid)=work(4,iord(igrid))
         enddo
C reorder x
        iy=mod(nblxx,nblock)
        nbly=(nblxx-iy)/nblock
c       write(6,"(10i6)") ngrid,nblock,nblxx,nbly
         do yblock=1,nblock
          nblyy=nbly
           if(yblock.eq.nblock) nblyy=nbly+iy
          yb=xb+(yblock-1)*nbly
          call dcopy(nblyy,grid(1,yb+1),4,work,1)
          call qsortd(iord,nblyy,work)
          call dcopy(4*nblyy,grid(1,yb+1),1,work,1)
           do igrid=1,nblyy
            grid(1,yb+igrid)=work(1,iord(igrid))
            grid(2,yb+igrid)=work(2,iord(igrid))
            grid(3,yb+igrid)=work(3,iord(igrid))
            grid(4,yb+igrid)=work(4,iord(igrid))
           enddo
         enddo
       enddo
c      do igrid=1,ngrid
c       write(999,"(10f10.5)") (grid(ix,igrid),ix=1,3)
c       write(999,"(10f10.5)") (grid(ix,igrid)*0.52917721067d0,ix=1,3)
c      enddo
c     write(6,*)
C
      return 
      end 
C
************************************************************************
      subroutine sadscfiguess(natoms,atnum,atsymbol,basname,charge,
     $imult,atnumt,qmreg,ecpname,scrfile1,iout,dft,cdmrcc,scfiguess)
************************************************************************
* Superposition of atomic densites initial guess for SCF
************************************************************************
      implicit none
      integer natoms,atnum(natoms),iatoms,charge,ich,atmuls,imult,i
      integer atnumt(natoms),scrfile1,iout
      character*1 cpwd1(512),bname1(20),line2(16)
      character*2 ch2,atsymbol(natoms)
      character*7 scfiguess
      character*8 qmreg
      character*16 c16
      character*20 basname(natoms),bname,ecpname(natoms)
      character*32 dft
      character*40 grfile,c40,cm
      character*512 cpwd,cminp,cinteg,cscf,cdmrcc
      logical llg,llm
      equivalence(cpwd,cpwd1)
      equivalence(bname,bname1)
      equivalence(c16,line2)
      integer*4 istat
#if !defined (gfortran) && !defined (G95)
      integer*4 system
      external system
#endif
C     
      c16='                '
      call getkey('mem',3,c16,16)
      i=1
       do while(line2(i).ne.' '.and.i.lt.16)
        i=i+1
       enddo
      call lowercase(line2(i-2),ch2,2)
      line2(i-2)=' '
      line2(i-1)=' '
      read(c16,*) i
       if(ch2.eq.'gb') i=1024*i
      i=min(1024,i)
      write(c16,'(i16)') i
      cm='mem=' // trim(adjustl(c16)) // 'mb'
C
#ifdef WINTEL
      call ishell('echo %CD%>junkscript')
#else
      call ishell('pwd > junkscript')
#endif
      open(unit=scrfile1,file='junkscript')
      cpwd1(1:512)=' '
      read(scrfile1,'(a512)') cpwd
      close(scrfile1)
      cpwd=adjustl(cpwd)
      call ishell('rm -rf mrccjunk/')
      call ishell('mkdir mrccjunk')
#ifdef WINTEL
      call ishell('where minp.exe>junkscript')
      call ishell('where integ.exe>>junkscript')
      call ishell('where scf.exe>>junkscript')
#else
      call ishell('which minp>junkscript;which integ>>junkscript;' //
     $'which scf>>junkscript')
#endif
      open(unit=scrfile1,file='junkscript')
      read(scrfile1,'(a512)') cminp
      read(scrfile1,'(a512)') cinteg
      read(scrfile1,'(a512)') cscf
       if(trim(adjustl(cminp)).eq.'./minp') cminp=trim(cpwd) // '/minp'
       if(trim(adjustl(cinteg)).eq.'./integ')cinteg=trim(cpwd)//'/integ'
       if(trim(adjustl(cscf)).eq.'./scf') cscf=trim(cpwd) // '/scf'
      rewind(scrfile1)
      write(scrfile1,'(a512)') trim(adjustl(cminp))
      write(scrfile1,'(a512)') trim(adjustl(cinteg))
      write(scrfile1,'(a512)') trim(adjustl(cscf))
      close(scrfile1)
#ifdef WINTEL
      call ishell('ren junkscript junkscript.bat')
      call ishell('mv junkscript.bat mrccjunk/')
#else
      call ishell('chmod +x junkscript; mv junkscript mrccjunk/')
#endif
       do iatoms=1,natoms
         if(atnum(iatoms).gt.0.or.((trim(dft).ne.'off'.or.
     $qmreg.eq.'0       ').and.atnumt(iatoms).gt.0)) then
          call getgrfile(grfile,atsymbol(iatoms),basname(iatoms),charge,
     $ich,natoms)
          inquire(file=grfile,exist=llg)
           if(.not.llg) then
#ifdef WINTEL
            open(unit=scrfile1,file="mrccjunk\ROUTE")
#else
            open(unit=scrfile1,file='mrccjunk/ROUTE')
#endif
            write(scrfile1,"(a4)") 'gues' !szemet
            close(scrfile1)
#ifdef WINTEL
            open(unit=scrfile1,file="mrccjunk\MINP")
#else
            open(unit=scrfile1,file='mrccjunk/MINP')
#endif
c           call getkey('mem',3,c16,16)
c           c40='mem=' // trim(adjustl(c16))
c           write(scrfile1,"(a40)") c40
            write(scrfile1,"(a40)") cm
            c40='basis=' // trim(adjustl(basname(iatoms)))
            write(scrfile1,"(a40)") c40
            c40='ecp=' // trim(adjustl(ecpname(iatoms)))
             if(trim(c40).eq.'ecp=') 
     $c40='ecp=none                                '
            write(scrfile1,"(a40)") c40
            c40='dfbasis_scf=' // trim(adjustl(basname(iatoms)))
            write(scrfile1,"(a40)") c40
            write(scrfile1,"(a10)") 'calc=UHF'
            write(scrfile1,"(a14)") 'scfiguess=core'
            write(c40,'(i5)') atmuls(atnumt(iatoms))-iabs(ich)
             if(natoms.eq.1) write(c40,'(i5)') imult
            c40='mult=' // trim(adjustl(c40))
            write(scrfile1,"(a40)") c40
            write(c40,'(i5)') ich
            c40='charge=' // trim(adjustl(c40))
            write(scrfile1,"(a40)") c40
             if(ich.eq.0.and.ecpname(iatoms).eq.'                    ')
     $then
              c40='                                        '
               if(     atnumt(iatoms).eq. 1) then !H
                c40='occ=1,0,0,0,0,0,0,0/0,0,0,0,0,0,0,0     '
               else if(atnumt(iatoms).eq. 2) then !He
                c40='occ=1,0,0,0,0,0,0,0/1,0,0,0,0,0,0,0     '
               else if(atnumt(iatoms).eq. 3) then !Li
                c40='occ=2,0,0,0,0,0,0,0/1,0,0,0,0,0,0,0     '
               else if(atnumt(iatoms).eq. 4) then !Be
                c40='occ=2,0,0,0,0,0,0,0/2,0,0,0,0,0,0,0     '
               else if(atnumt(iatoms).eq. 5) then !B
                c40='occ=2,0,0,0,0,1,0,0/2,0,0,0,0,0,0,0     '
               else if(atnumt(iatoms).eq. 6) then !C
                c40='occ=2,0,0,0,0,0,1,1/2,0,0,0,0,0,0,0     '
               else if(atnumt(iatoms).eq. 7) then !N
                c40='occ=2,0,0,0,0,1,1,1/2,0,0,0,0,0,0,0     '
               else if(atnumt(iatoms).eq. 8) then !O
                c40='occ=2,0,0,0,0,1,1,1/2,0,0,0,0,0,1,0     '
               else if(atnumt(iatoms).eq. 9) then !F
                c40='occ=2,0,0,0,0,1,1,1/2,0,0,0,0,0,1,1     '
               else if(atnumt(iatoms).eq.10) then !Ne
                c40='occ=2,0,0,0,0,1,1,1/2,0,0,0,0,1,1,1     '
               else if(atnumt(iatoms).eq.11) then !Na
                c40='occ=3,0,0,0,0,1,1,1/2,0,0,0,0,1,1,1     '
               else if(atnumt(iatoms).eq.12) then !Mg
                c40='occ=3,0,0,0,0,1,1,1/3,0,0,0,0,1,1,1     '
               else if(atnumt(iatoms).eq.13) then !Al
                c40='occ=3,0,0,0,0,2,1,1/3,0,0,0,0,1,1,1     '
               else if(atnumt(iatoms).eq.14) then !Si
                c40='occ=3,0,0,0,0,1,2,2/3,0,0,0,0,1,1,1     '
               else if(atnumt(iatoms).eq.15) then !P
                c40='occ=3,0,0,0,0,2,2,2/3,0,0,0,0,1,1,1     '
               else if(atnumt(iatoms).eq.16) then !S
                c40='occ=3,0,0,0,0,2,2,2/3,0,0,0,0,1,2,1     '
               else if(atnumt(iatoms).eq.17) then !Cl
                c40='occ=3,0,0,0,0,2,2,2/3,0,0,0,0,1,2,2     '
               else if(atnumt(iatoms).eq.18) then !Ar
                c40='occ=3,0,0,0,0,2,2,2/3,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.19) then !K
                c40='occ=4,0,0,0,0,2,2,2/3,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.20) then !Ca
                c40='occ=4,0,0,0,0,2,2,2/4,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.21) then !Sc
                c40='occ=5,0,0,0,0,2,2,2/4,0,0,0,0,2,2,2     '
c                c40='occ=4,1,0,0,0,2,2,2/4,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.22) then !Ti
                c40='occ=6,0,0,0,0,2,2,2/4,0,0,0,0,2,2,2     '
c                c40='occ=4,1,1,0,0,2,2,2/4,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.23) then !V
                c40='occ=6,1,0,0,0,2,2,2/4,0,0,0,0,2,2,2     '
c                c40='occ=4,1,1,1,0,2,2,2/4,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.24) then !Cr
                c40='occ=6,1,1,1,0,2,2,2/3,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.25) then !Mn
                c40='occ=6,1,1,1,0,2,2,2/4,0,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.26) then !Fe
                c40='occ=6,1,1,1,0,2,2,2/5,0,0,0,0,2,2,2     '
c                c40='occ=6,1,1,1,0,2,2,2/4,1,0,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.27) then !Co
                c40='occ=6,1,1,1,0,2,2,2/6,0,0,0,0,2,2,2     '
c                c40='occ=6,1,1,1,0,2,2,2/4,1,1,0,0,2,2,2     '
               else if(atnumt(iatoms).eq.28) then !Ni
                c40='occ=6,1,1,1,0,2,2,2/6,1,0,0,0,2,2,2     '
c                c40='occ=6,1,1,1,0,2,2,2/4,1,1,1,0,2,2,2     '
               else if(atnumt(iatoms).eq.29) then !Cu
                c40='occ=6,1,1,1,0,2,2,2/6,1,1,0,0,2,2,2     '
c                c40='occ=6,1,1,1,0,2,2,2/5,1,1,1,0,2,2,2     '
               else if(atnumt(iatoms).eq.30) then !Zn
                c40='occ=6,1,1,1,0,2,2,2/6,1,1,1,0,2,2,2     '
               else if(atnumt(iatoms).eq.31) then !Ga
                c40='occ=6,1,1,1,0,3,2,2/6,1,1,1,0,2,2,2     '
               else if(atnumt(iatoms).eq.32) then !Ge
                c40='occ=6,1,1,1,0,2,3,3/6,1,1,1,0,2,2,2     '
               else if(atnumt(iatoms).eq.33) then !As
                c40='occ=6,1,1,1,0,3,3,3/6,1,1,1,0,2,2,2     '
               else if(atnumt(iatoms).eq.34) then !Se
                c40='occ=6,1,1,1,0,3,3,3/6,1,1,1,0,3,2,2     '
               else if(atnumt(iatoms).eq.35) then !Br
                c40='occ=6,1,1,1,0,3,3,3/6,1,1,1,0,3,3,2     '
               else if(atnumt(iatoms).eq.36) then !Kr
                c40='occ=6,1,1,1,0,3,3,3/6,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.37) then !Rb
                c40='occ=7,1,1,1,0,3,3,3/6,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.38) then !Sr
                c40='occ=7,1,1,1,0,3,3,3/7,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.39) then !Y
                c40='occ=8,1,1,1,0,3,3,3/7,1,1,1,0,3,3,3     '
c                c40='occ=7,2,1,1,0,3,3,3/7,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.40) then !Zr
                c40='occ=9,1,1,1,0,3,3,3/7,1,1,1,0,3,3,3     '
c                c40='occ=7,2,2,1,0,3,3,3/7,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.41) then !Nb 4d4 5s
                c40='occ=9,2,2,1,0,3,3,3/6,1,1,1,0,3,3,3     '
c                c40='occ=8,2,2,2,0,3,3,3/6,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.42) then !Mo 4d5 5s
                c40='occ=9,2,2,2,0,3,3,3/6,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.43) then !Tc 4d5 5s2
                c40='occ=9,2,2,2,0,3,3,3/7,1,1,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.44) then !Ru 4d7 5s
                c40='occ=9,2,2,2,0,3,3,3/8,1,1,1,0,3,3,3     '
c                c40='occ=9,2,2,2,0,3,3,3/6,2,2,1,0,3,3,3     '
               else if(atnumt(iatoms).eq.45) then !Rh 4d8 5s
                c40='occ=9,2,2,2,0,3,3,3/8,2,1,1,0,3,3,3     '
c                c40='occ=9,2,2,2,0,3,3,3/6,2,2,2,0,3,3,3     '
               else if(atnumt(iatoms).eq.46) then !Pd 4d10 5s0
                c40='occ=8,2,2,2,0,3,3,3/8,2,2,2,0,3,3,3     '
               else if(atnumt(iatoms).eq.47) then !Ag 4d10 5s
                c40='occ=9,2,2,2,0,3,3,3/8,2,2,2,0,3,3,3     '
               else if(atnumt(iatoms).eq.48) then !Cd 4d10 5s2
                c40='occ=9,2,2,2,0,3,3,3/9,2,2,2,0,3,3,3     '
               else if(atnumt(iatoms).eq.49) then !In 
                c40='occ=9,2,2,2,0,4,3,3/9,2,2,2,0,3,3,3     '
               else if(atnumt(iatoms).eq.50) then !Sn 
                c40='occ=9,2,2,2,0,4,4,3/9,2,2,2,0,3,3,3     '
               else if(atnumt(iatoms).eq.51) then !Sb
                c40='occ=9,2,2,2,0,4,4,4/9,2,2,2,0,3,3,3     '
               else if(atnumt(iatoms).eq.52) then !Te
                c40='occ=9,2,2,2,0,4,4,4/9,2,2,2,0,4,3,3     '
               else if(atnumt(iatoms).eq.53) then !I
                c40='occ=9,2,2,2,0,4,4,4/9,2,2,2,0,4,4,3     '
               else if(atnumt(iatoms).eq.54) then !Xe
                c40='occ=9,2,2,2,0,4,4,4/9,2,2,2,0,4,4,4     '
               else if(atnumt(iatoms).eq.55) then !Cs
                c40='occ=10,2,2,2,0,4,4,4/9,2,2,2,0,4,4,4     '
               else if(atnumt(iatoms).eq.56) then !Ba 6s2
                c40='occ=10,2,2,2,0,4,4,4/10,2,2,2,0,4,4,4     '
c ... La-Yb
               else if(atnumt(iatoms).eq.71) then !Lu 5d 6s2
                c40='occ=11,2,2,2,1,6,6,6/10,2,2,2,1,6,6,6     '
c                c40='occ=10,3,2,2,1,6,6,6/10,2,2,2,1,6,6,6     '
               else if(atnumt(iatoms).eq.72) then !Hf 5d2 6s2
                c40='occ=12,2,2,2,1,6,6,6/10,2,2,2,1,6,6,6     '
c                c40='occ=10,3,3,2,1,6,6,6/10,2,2,2,1,6,6,6     '
               else if(atnumt(iatoms).eq.73) then !Ta 5d3 6s2
                c40='occ=12,3,2,2,1,6,6,6/10,2,2,2,1,6,6,6     '
c                c40='occ=10,3,3,3,1,6,6,6/10,2,2,2,1,6,6,6     '
               else if(atnumt(iatoms).eq.74) then !W 5d4 6s2
                c40='occ=12,3,3,2,1,6,6,6/10,2,2,2,1,6,6,6     '
c                c40='occ=11,3,3,3,1,6,6,6/10,2,2,2,1,6,6,6     '
               else if(atnumt(iatoms).eq.75) then !Re 5d5 6s2
                c40='occ=12,3,3,3,1,6,6,6/10,2,2,2,1,6,6,6     '
               else if(atnumt(iatoms).eq.76) then !Os 5d6 6s2
                c40='occ=12,3,3,3,1,6,6,6/11,2,2,2,1,6,6,6     '
c                c40='occ=12,3,3,3,1,6,6,6/10,3,2,2,1,6,6,6     '
               else if(atnumt(iatoms).eq.77) then !Ir 5d7 6s2
                c40='occ=12,3,3,3,1,6,6,6/12,2,2,2,1,6,6,6     '
c                c40='occ=12,3,3,3,1,6,6,6/10,3,3,2,1,6,6,6     '
               else if(atnumt(iatoms).eq.78) then !Pt 5d9 6s
                c40='occ=12,3,3,3,1,6,6,6/11,3,3,2,1,6,6,6     '
c                c40='occ=12,3,3,3,1,6,6,6/10,3,3,3,1,6,6,6     '
               else if(atnumt(iatoms).eq.79) then !Au 5d10 6s
                c40='occ=12,3,3,3,1,6,6,6/11,3,3,3,1,6,6,6     '
               else if(atnumt(iatoms).eq.80) then !Hg 5d10 6s2
                c40='occ=12,3,3,3,1,6,6,6/12,3,3,3,1,6,6,6     '
               else if(atnumt(iatoms).eq.81) then !Tl
                c40='occ=12,3,3,3,1,7,6,6/12,3,3,3,1,6,6,6     '
               else if(atnumt(iatoms).eq.82) then !Pb
                c40='occ=12,3,3,3,1,7,7,6/12,3,3,3,1,6,6,6     '
               else if(atnumt(iatoms).eq.83) then !Bi
                c40='occ=12,3,3,3,1,7,7,7/12,3,3,3,1,6,6,6     '
               else if(atnumt(iatoms).eq.84) then !Po
                c40='occ=12,3,3,3,1,7,7,7/12,3,3,3,1,7,6,6     '
               else if(atnumt(iatoms).eq.85) then !At
                c40='occ=12,3,3,3,1,7,7,7/12,3,3,3,1,7,7,6     '
               else if(atnumt(iatoms).eq.86) then !Rn
                c40='occ=12,3,3,3,1,7,7,7/12,3,3,3,1,7,7,7     '
               else if(atnumt(iatoms).eq.87) then !Fr
                c40='occ=13,3,3,3,1,7,7,7/12,3,3,3,1,7,7,7     '
               else if(atnumt(iatoms).eq.88) then !Ra
                c40='occ=13,3,3,3,1,7,7,7/13,3,3,3,1,7,7,7     '
               else !if(atnumt(iatoms).ge.89) then
                c40='symm=off                                '
               endif
             else
              c40='symm=off                                '
              write(scrfile1,"(a40)") c40
             endif
            write(scrfile1,"(a4)") 'geom'
            c40=trim(adjustl(atsymbol(iatoms)))
            write(scrfile1,"(a40)") c40
            write(scrfile1,*)
            write(scrfile1,*)
            close(scrfile1)
            c40=trim(c40) // ':' // trim(adjustl(basname(iatoms)))
            call lowercase(c40,c40,40)
            call gbcheck(llm,c40,scrfile1)
             if(llm) then
              call ishell('cp GENBAS mrccjunk/')
              close(scrfile1)
             else
              call ishell('cp ' // 
     $trim(trim(cdmrcc) // atsymbol(iatoms))//' mrccjunk/GENBAS ')
             endif
c           call ishell('cd mrccjunk/; ./junkscript > /dev/null')
#ifdef WINTEL
            call execute_command_line("cd mrccjunk&.\junkscript>NUL",
     $ exitstat=istat)
            inquire(file='mrccjunk\EXIT',exist=llm)
             if(.not.llm) istat=-1
            inquire(file='mrccjunk\SCFDENSITIES',exist=llm)
             if(.not.llm) istat=-1
             if(istat.ge.0) then
              open(unit=scrfile1,file='mrccjunk\EXIT')
#else
            istat=system('cd mrccjunk/; ./junkscript > /dev/null')
            inquire(file='mrccjunk/EXIT',exist=llm)
             if(.not.llm) istat=-1
            inquire(file='mrccjunk/SCFDENSITIES',exist=llm)
             if(.not.llm) istat=-1
             if(istat.ge.0) then
              open(unit=scrfile1,file='mrccjunk/EXIT')
#endif
              read(scrfile1,*) i
               if(i.ne.0) istat=-1
              close(scrfile1)
             endif
             if(istat.lt.0) then
              write(iout,*) 'Problem with SAD SCF initial guess!'
               if(scfiguess.eq.'sad    ') then
                write(iout,*) 'scfiguess has been changed to ao!'
                call changekey('scfiguess',9,'ao     ',7)
               endif
              goto 9876
             endif
            call ishell(
     $'cp mrccjunk/SCFDENSITIES ' // adjustl(trim(grfile)))
           endif
         endif
       enddo
C
9876  continue
      call ishell('rm -rf mrccjunk/')
C
      return
      end
C
************************************************************************
      integer function atmuls(atnum)
************************************************************************
* Returns atomic multiplicities
************************************************************************
#include "MRCCCOMMON"
      integer atnum,atmul(natmax)
      data atmul /2 ,1 ,2 ,1 ,2 ,3 ,4 ,3 ,2 ,1 ,
C                 H  He Li Be B  C  N  O  F  Ne
     $            2 ,1 ,2 ,3 ,4 ,3 ,2 ,1 ,2 ,1 ,
C                 Na Mg Al Si P  S  Cl Ar K  Ca
     $            2 ,3 ,4 ,7 ,6 ,5 ,4 ,3 ,2 ,1 ,
C                 Sc Ti V  Cr Mn Fe Co Ni Cu Zn
     $            2 ,3 ,4 ,3 ,2 ,1 ,2 ,1 ,2 ,3 ,
C                 Ga Ge As Se Br Kr Rb Sr Y  Zr
     $            6 ,7 ,6 ,5 ,4 ,1 ,2 ,1 ,2 ,3 ,
C                 Nb Mo Tc Ru Rh Pd Ag Cd In Sn
     $            4 ,3 ,2 ,1 ,2 ,1 ,2 ,1 ,4 ,5 ,
C                 Sb Te I  Xe Cs Ba La Ce Pr Nd
     $            6 ,7 ,8 ,9 ,6 ,5 ,4 ,3 ,2 ,1 ,
C                 Pm Sm Eu Gd Tb Dy Ho Er Tm Yb
     $            2 ,3 ,4 ,5 ,6 ,5 ,4 ,3 ,2 ,1 ,
C                 Lu Hf Ta W  Re Os Ir Pt Au Hg
     $            2 ,3 ,4 ,3 ,2 ,1 ,2 ,1 ,2 ,3 ,
C                 Tl Pb Bi Po At Rn Fr Ra Ac Th
     $            4 ,5 ,6 ,7 ,8 ,9 ,6 ,5 ,4 ,3 ,
C                 Pa U  Np Pu Am Cm Bk Cf Es Fm
     $            2 ,1 ,2 ,3 ,4 ,5 ,6 ,7 ,8 ,9 ,
C                 Md No Lr Rf Db Sg Bh Hs Mt Ds
     $            2 ,1 ,2 ,3 ,4 ,3 ,2 ,1 /
C                 Rg Cn Nh Fl Mc Lv Ts Og
      atmuls=atmul(atnum)
C
      return
      end
C
************************************************************************
      subroutine mbcoord(nbond,natoms,minpfile,coord,bfbasis,atsymbol,
     $atnum,gbasfile,iout,bond,bondat,cdmrcc,ebf,nbondc,nangmax,
     $ncontrmax,nprimmax,nshmax,iscr,ianm,icon)
************************************************************************
* Calculates the centers of bond functions
************************************************************************
      implicit none
      integer nbond,natoms,minpfile,at1,at2,at3,atnum(natoms),i,iatoms
      integer gbasfile,iout,bondat(3,natoms),ebf(natoms),nbondc,ibond
      integer ncnt,icnt,nangmax,ncontrmax,nprimmax,nshmax,iscr(*),nsh
      integer ianm(*),ish,icon(*)
      real*8 coord(3,natoms),alpha,eps,sigma
      character*2 atsymbol(natoms)
      character*8 bond(natoms),bnd,cbndo
      character*20 bfbasis
      character*24 atsymbas,glabel
      character*64 line
      character*512 cdmrcc
      logical lgb
C
      call getkeym('geom',4,atsymbas,4)
       do iatoms=1,natoms-nbondc+1
        read(minpfile,*)
       enddo
      iatoms=natoms-nbondc
       do ibond=1,nbond
        read(minpfile,*) at1,at2,at3
         if(atnum(at1).lt.atnum(at2)) then
          i=at1
          at1=at2
          at2=i
         endif
         if(at3.eq.1) then
          bnd=trim(atsymbol(at1)) // trim(atsymbol(at2))
         else
          write(cbndo,'(i8)') at3
          bnd=trim(atsymbol(at1)) // trim(atsymbol(at2)) //
     $trim(adjustl(cbndo))
         endif
        atsymbas='B' // trim(bnd) // ':' // trim(bfbasis)
        call lowercase(atsymbas,atsymbas,24)
        call gbcheck(lgb,atsymbas,gbasfile)
         if(.not.lgb) then
          open(gbasfile,file=trim(trim(cdmrcc) // 'Bond'))
          glabel='                        '
           do while(atsymbas.ne.glabel)
            read(gbasfile,*,end=1000) glabel
            call lowercase(glabel,glabel,24)
           enddo
         endif
        read(gbasfile,*)
        read(gbasfile,*)
        read(gbasfile,*) ncnt
         do icnt=1,ncnt
          iatoms=iatoms+1
          read(gbasfile,*)
          read(gbasfile,*) sigma
          call prereadbas1(nangmax,ncontrmax,nprimmax,nshmax,gbasfile,
     $iscr,ianm,nsh,icon,0,.false.,atnum)
           do ish=1,nsh
            read(gbasfile,*)
            read(gbasfile,*)
            read(gbasfile,"(a64)") line
             if(trim(line).ne.'') then
              backspace(gbasfile)
              read(gbasfile,*) eps
               if(dabs(1.d0-eps).gt.1d-10) ebf(iatoms)=1
             endif
             do i=1,icon(ish)
              read(gbasfile,*)
             enddo
           enddo
          bondat(1,iatoms)=at1
          bondat(2,iatoms)=at2
          bondat(3,iatoms)=at3
          bond(iatoms)=bnd
          coord(1,iatoms)=sigma*(coord(1,at2)-coord(1,at1))+coord(1,at1)
          coord(2,iatoms)=sigma*(coord(2,at2)-coord(2,at1))+coord(2,at1)
          coord(3,iatoms)=sigma*(coord(3,at2)-coord(3,at1))+coord(3,at1)
         enddo
        close(gbasfile)
       enddo
C
      return
1000  continue
      write(iout,*)
      write(iout,*) 'Basis set ' // trim(bfbasis) // ' not found!'
      call mrccend(1)
      end
C
************************************************************************
      subroutine getnbondc(natoms,nbond,nbondc,minpfile,bfbasis,
     $gbasfile,iout,cdmrcc,atsymbol,atnum)
************************************************************************
* Get the number of bond function centers
************************************************************************
      implicit none
      integer nbond,natoms,minpfile,at1,at2,bndo,atnum(natoms),i,iatoms
      integer gbasfile,iout,nbondc
      real*8 coord(3,natoms),sigma,temp
      character*2 atsymbol(natoms)
      character*8 cbndo
      character*20 bfbasis
      character*24 atsymbas,glabel
      character*512 cdmrcc
      logical lgb
C
      nbondc=0
       do iatoms=1,natoms
        read(minpfile,*) temp,temp,temp,atsymbol(iatoms)
        atnum(iatoms)=0
        call getatnum(atsymbol(iatoms),atnum(iatoms))
       enddo
       do iatoms=1,nbond
        read(minpfile,*) at1,at2,bndo
         if(atnum(at1).lt.atnum(at2)) then
          i=at1
          at1=at2
          at2=i
         endif
         if(bndo.eq.1) then
          atsymbas='B' // trim(atsymbol(at1)) // trim(atsymbol(at2)) // 
     $':' // trim(bfbasis)
         else
          write(cbndo,'(i8)') bndo
          atsymbas='B' // trim(atsymbol(at1)) // trim(atsymbol(at2)) // 
     $trim(adjustl(cbndo)) // ':' // trim(bfbasis)
         endif
        call lowercase(atsymbas,atsymbas,24)
        call gbcheck(lgb,atsymbas,gbasfile)
         if(.not.lgb) then
          open(gbasfile,file=trim(trim(cdmrcc) // 'Bond'))
          glabel='                        '
           do while(atsymbas.ne.glabel)
            read(gbasfile,*,end=1000) glabel
            call lowercase(glabel,glabel,24)
           enddo
         endif
        read(gbasfile,*)
        read(gbasfile,*)
        read(gbasfile,*) i
        nbondc=nbondc+i
        close(gbasfile)
       enddo
C
      return
1000  continue
      write(iout,*)
      write(iout,*) 'Basis set ' // trim(bfbasis) // ' not found!'
      call mrccend(1)
      end
C
************************************************************************
      subroutine cipra(ipra,ipre,natoms,nang,nangmax,varsfile,ifltln)
************************************************************************
* Calculate presreening integrals for pairs of atoms
************************************************************************
      implicit none
      integer natoms,nang(natoms),nangmax,iatoms,jatoms,iang,jang,ifltln
      integer varsfile
      real*8 ipre(natoms,0:nangmax,natoms,0:nangmax),ipra(natoms,natoms)
      real*8 tmp
C
       do iatoms=1,natoms
         do jatoms=1,iatoms
          tmp=0.d0
           do iang=0,nang(iatoms)
             do jang=0,nang(jatoms)
              tmp=max(tmp,ipre(iatoms,iang,jatoms,jang))
             enddo
           enddo
          ipra(iatoms,jatoms)=tmp
          ipra(jatoms,iatoms)=tmp
         enddo
       enddo
      write(varsfile) 'ipra      ',ifltln*natoms**2,ipra
C
      return
      end
C
************************************************************************
      subroutine sspre(spre,natoms,nangmax,ncontrmax,nsphermax,
     $cartg,indarr,nang,ncontr,s,nbasis)
************************************************************************
* Calculate maximal elements of overlap matrix for prescreening
************************************************************************
      implicit none
      integer natoms,nangmax,ncontrmax,nsphermax,nbasis
      integer indarr(natoms,0:nangmax,ncontrmax,nsphermax)
      integer nang(natoms),ncontr(0:nangmax,natoms)
      integer iatoms,iang,nicontr,nispher,icontr,ispher,i
      integer jatoms,jang,njcontr,njspher,jcontr,jspher,j
      real*8 spre(natoms,0:nangmax,natoms,0:nangmax),s(nbasis,nbasis),ss
      logical cartg
C
      spre=0.d0
       do iatoms=1,natoms
         do iang=0,nang(iatoms)
          nicontr=ncontr(iang,iatoms)
          nispher=2*iang+1
           if(cartg) nispher=(iang+1)*(iang+2)/2
           do jatoms=1,iatoms
             do jang=0,nang(jatoms)
              njcontr=ncontr(jang,jatoms)
              njspher=2*jang+1
               if(cartg) njspher=(jang+1)*(jang+2)/2
              ss=0.d0
               do icontr=1,nicontr
                 do ispher=1,nispher
                  i=indarr(iatoms,iang,icontr,ispher)
                   do jcontr=1,njcontr
                     do jspher=1,njspher
                      j=indarr(jatoms,jang,jcontr,jspher)
                      ss=max(ss,dabs(s(i,j)))
                     enddo
                   enddo
                 enddo
               enddo
              spre(iatoms,iang,jatoms,jang)=ss
              spre(jatoms,jang,iatoms,iang)=ss
c     write(6,"(4i3,f10.5)") iatoms,iang,jatoms,jang,ss
             enddo
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine nrmcalc(ngrid,nbasis,dvec,rweight,aweight,en)
************************************************************************
* Calculate norm of basis functions
************************************************************************
      implicit none
      integer ngrid,nbasis,igrid,ibasis
      real*8 dvec(ngrid,nbasis),aweight(ngrid),rweight,en(nbasis),ena
C
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(ibasis,ena,igrid)
       do ibasis=1,nbasis
        ena=0.d0
         do igrid=1,ngrid
          ena=ena+rweight*aweight(igrid)*
     $dvec(igrid,ibasis)*dvec(igrid,ibasis)
         enddo
        en(ibasis)=dabs(ena)
       enddo
C$OMP END PARALLEL DO
C
      return
      end
C
************************************************************************
      subroutine mindist2(grid,ngrid,nblock,nbl,mind2)
************************************************************************
* Calculates minimal distance between the grid point of two blocks
************************************************************************
      implicit none
      integer,intent(in)::ngrid,nblock,nbl
      real*8,dimension(4,ngrid),intent(in)::grid
      real*8,dimension(nblock*(nblock-1)/2),intent(out)::mind2
      integer::block1,block2,blu1,blu2,bll1,bll2,grid1,grid2,blp
      real*8::distx,disty,distz,dist2,grx1,gry1,grz1,grx2,gry2,grz2
      real*8::mind2val
C Minimal square distance of blocks
      mind2=1.d30
C$OMP PARALLEL DO Schedule(Dynamic)
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(nblock,nbl,ngrid,mind2,grid)
      do block1=1,nblock
       bll1=(block1-1)*nbl+1
       blu1=min(bll1-1+nbl,ngrid)
       do grid1=bll1,blu1
        grx1=grid(1,grid1)
        gry1=grid(2,grid1)
        grz1=grid(3,grid1)
        do block2=1,block1-1
         bll2=(block2-1)*nbl+1
         blu2=bll2-1+nbl
         blp=(block1-1)*(block1-2)/2+block2
         mind2val=mind2(blp)
         do grid2=bll2,blu2
          grx2=grid(1,grid2)
          gry2=grid(2,grid2)
          grz2=grid(3,grid2)
          distx=grx2-grx1
          disty=gry2-gry1
          distz=grz2-grz1
          dist2=distx*distx+disty*disty+distz*distz
          mind2val=min(mind2val,dist2)
         enddo
         mind2(blp)=mind2val
        enddo
       enddo
      enddo
C$OMP END PARALLEL DO
C Sixth power
C$OMP PARALLEL DO
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(nblock,mind2)
      do blp=1,nblock*(nblock-1)/2
       mind2val=mind2(blp)
       mind2(blp)=mind2val*mind2val*mind2val
      enddo
C$OMP END PARALLEL DO
C
      return
      end
C
************************************************************************
      subroutine sroot(mat,n,eig,iout,scrfile1,scrfile2,itol,scr,scr2,
     $nfunc,nfuns,nir,ndao,smat)
************************************************************************
* Calculate the inverse square root of the overlap matrix
************************************************************************
      implicit none
      integer n,iout,i,info8,scrfile1,ndao,scrfile2,nv,j
      integer nir,nfunc(nir),nfuns(nir),sqroffset(nir),offset(nir)
      integer*4 info4
      real*8 mat(*),eig(n),scr(*),scr2(*),ss,itol,ovltol,smat(*),fact
      equivalence(info8,info4)
      character(len=16) c1,c2
C
      offset(1)=1
      sqroffset(1)=1
       do i=2,nir
        offset(i)=offset(i-1)+nfunc(i-1)
        sqroffset(i)=sqroffset(i-1)+nfunc(i-1)*nfunc(i-1)
       enddo
C Transform S to symmetry basis
       if(nir.gt.1) then
        open(scrfile1,file='SYMTRA',form='unformatted')
        call rtdmx(scr2,scr2,scr,scrfile1,n,n)
        close(scrfile1)
        call dsymm('l','u',n,n,1.d0,mat,n,scr,n,0.d0,scr2,n)
         do i=1,nir
           if(nfunc(i).gt.0) then
            call dgemm('t','n',nfunc(i),nfunc(i),n,1.d0,
     $scr((offset(i)-1)*n+1),n,scr2((offset(i)-1)*n+1),n,0.d0,
     $mat(sqroffset(i)),nfunc(i))
           endif
         enddo
       endif
C Diagonalize S, calculate inverse square root
      call getkey('ovltol',6,c1,16)
      read(c1,*) ovltol
      open(scrfile1,file='SCHOL',form='unformatted')
      open(scrfile2,file='DAO',form='unformatted')
      ndao=0
      ss=1d30
       do i=1,nir
         if(nfunc(i).gt.0) then
          call dcopy(nfunc(i)**2,mat(sqroffset(i)),1,scr,1)
          call dsyev('V','L',nfunc(i),scr,nfunc(i),eig(offset(i)),scr2,
     $       min(20,2*n)*n,info8)
           if(info4.ne.0) then
             write(iout,*)
     $'Fatal error at the diagonalization of the overlap matrix!'
            call mrccend(1)
           endif
          ss=min(ss,eig(offset(i)))
          call dcopy(nfunc(i)**2,scr,1,scr2,1)
          nv=0
           do j=1,nfunc(i)
             if(eig(offset(i)+j-1).lt.ovltol) then
              nv=nv+1
             else
              call dscal(nfunc(i),1.d0/dsqrt(eig(offset(i)+j-1)),
     $scr((j-1)*nfunc(i)+1),1)
             endif
           enddo
          nfuns(i)=nfunc(i)-nv
          write(scrfile1) scr(nv*nfunc(i)+1:nfunc(i)**2)
           if(nv.gt.0) then
            ndao=ndao+nv
            write(scrfile2) scr(1:nv*nfunc(i))
            write(c1,'(i16)') nv
            write(c2,'(i16)') i
            write(iout,*) trim(adjustl(c1)) //
     $' AOs are eliminated for irrep ' // trim(adjustl(c2)) // '.'
             do j=1,nv
c              call dscal(nfunc(i),1.d0/dsqrt(eig(offset(i)+j-1)),
c     $scr((j-1)*nfunc(i)+1),1)
               call dscal(nfunc(i),0.d0,scr((j-1)*nfunc(i)+1),1) ! discard quasi nullspace from S^-1/2
             enddo
           endif
          call dgemm('n','t',nfunc(i),nfunc(i),nfunc(i),1.d0,scr,
     $nfunc(i),scr2,nfunc(i),0.d0,mat(sqroffset(i)),nfunc(i))
          if (ndao.gt.0) 
     $        call dcopy(nfunc(i)**2,scr2,1,smat(sqroffset(i)),1) 
         endif
       enddo
      close(scrfile1)
      close(scrfile2)
      write(iout,"(' Minimum eigenvalue of the overlap matrix:',e13.6)")
     $ss
       if(ss.lt.0.d0) then
        write(iout,*) 'The overlap matrix is not positive definite!'
        call mrccend(1)
       endif
       if(ss.lt.1d-6) then
        write(iout,*)
     $'Warning! Near linear dependence in the AO basis set.'
        write(iout,*) 'This may result in convergence problems.'
       endif
C Transform inverse square root to AO basis
       call sym2aobasistrf(mat,mat,n,nir,nfunc,offset,
     $sqroffset,scr,scr2,scrfile1)
c
C SROOT: 1st line S^1/2, 2nd line S^-1/2
       open(scrfile1,file='SROOT',form='unformatted')
       if (ndao.eq.0) then ! case of no linear dependency
        call dsymm('l','l',n,n,1.d0,smat,n,mat,n,0.d0,scr2,n)
       else 
c  build S^1/2 in spectral form the S eigenvectors stored in smat
         do i=1,nir
          call dcopy(nfunc(i)**2,smat(sqroffset(i)),1,scr,1) 
          if(nfunc(i).gt.0) then
           do j=1,nfunc(i)
             if(j.le.nfunc(i)-nfuns(i)) then
              fact=0.d0 ! ! discard quasi nullspace from S^1/2
             else
              fact=dsqrt(eig(offset(i)+j-1))
             endif
             call dscal(nfunc(i),fact,scr((j-1)*nfunc(i)+1),1)
           enddo
         call dgemm('n','t',nfunc(i),nfunc(i),nfunc(i),1.d0,scr,nfunc(i)
     $,smat(sqroffset(i)),nfunc(i),0.d0,scr2(sqroffset(i)),nfunc(i))
          endif
         enddo
C Transf orm the square root to AO basis
         call sym2aobasistrf(scr2,scr2,n,nir,nfunc,offset,
     $                       sqroffset,scr,smat,scrfile2)
       endif
       call woeint(scr,scr,scr2,scrfile1,itol/100.d0,n)  ! S^1/2 in scr2
       call woeint(scr,scr,mat,scrfile1,itol/100.d0,n)   ! S^-1/2 in mat
       close(scrfile1)
C
      return
      end
C
************************************************************************
      subroutine readtci(tci,dfnbasis,nbasis,intpos,tedatfile,i4core)
************************************************************************
* Read three-center ERIs
************************************************************************
      implicit none
      integer teintfile(10),npos,nbasis,intpos(3,(nbasis+1)*nbasis/2)
      integer tedatfile,i,j,k,kk,n,ipos,dfnbasis
      real*8 ss,tci(nbasis,nbasis,dfnbasis)
      integer*4 i4core(*),ssi(2)
      equivalence(ss,ssi)
C
      tci=0.d0
      rewind(tedatfile)
      read(tedatfile) npos,intpos
      call intopenrsq(teintfile)
       do ipos=1,npos
        i=intpos(1,ipos)
        j=intpos(2,ipos)
        n=intpos(3,ipos)
        call intreadsq(i4core,n,teintfile)
         do kk=0,n-1
          ssi(1)=i4core(3*kk+1)
          ssi(2)=i4core(3*kk+2)
          k     =i4core(3*kk+3)
          tci(i,j,k)=ss
          tci(j,i,k)=ss
         enddo
       enddo
      call intclose(teintfile)
C
      return
      end
C
************************************************************************
      subroutine fitcoef(tci,nbasis,dfnbasis,natoms,natrange,dfnatrange,
     $work,tcd,ii)
************************************************************************
* Generate PARI fitting coefficients
************************************************************************
      implicit none
      integer nbasis,dfnbasis,natoms,iatoms,jatoms,ni,nj,nk,i1,i2,j1,j2
      integer natrange(2,natoms),dfnatrange(2,natoms),ik1,ik2,jk1,jk2,ii
      integer nik,njk,i,j,k,iii,jj
      real*8 tci(nbasis,nbasis,dfnbasis),work(*),tcd(dfnbasis,dfnbasis)
C
      ii=1
       do iatoms=1,natoms
        i1=natrange(1,iatoms)
        i2=natrange(2,iatoms)
        ni=i2-i1
        i1=i1+1
        ik1=dfnatrange(1,iatoms)
        ik2=dfnatrange(2,iatoms)
        nik=ik2-ik1
        ik1=ik1+1
         do jatoms=1,iatoms-1
          j1=natrange(1,jatoms)
          j2=natrange(2,jatoms)
          nj=j2-j1
          j1=j1+1
          jk1=dfnatrange(1,jatoms)
          jk2=dfnatrange(2,jatoms)
          njk=jk2-jk1
          jk1=jk1+1
          nk=nik+njk
          iii=ii
           do j=j1,j2
             do i=i1,i2
               do k=ik1,ik2
                work(ii)=tci(i,j,k)
                ii=ii+1
               enddo
               do k=jk1,jk2
                work(ii)=tci(i,j,k)
                ii=ii+1
               enddo
             enddo
           enddo
          jj=ii
           do i=ik1,ik2
             do j=ik1,ik2
              work(jj)=tcd(i,j)
              jj=jj+1
             enddo
             do j=jk1,jk2
              work(jj)=tcd(i,j)
              jj=jj+1
             enddo
           enddo
           do i=jk1,jk2
             do j=ik1,ik2
              work(jj)=tcd(i,j)
              jj=jj+1
             enddo
             do j=jk1,jk2
              work(jj)=tcd(i,j)
              jj=jj+1
             enddo
           enddo
          call dpotrf('L',nk,work(ii),nk,i)
          call dpotrs('L',nk,ni*nj,work(ii),nk,work(iii),nk,i)
         enddo
        iii=ii
         do j=i1,i2
           do i=i1,i2
             do k=ik1,ik2
              work(ii)=tci(i,j,k)
              ii=ii+1
             enddo
           enddo
         enddo
        jj=ii
         do i=ik1,ik2
           do j=ik1,ik2
            work(jj)=tcd(i,j)
            jj=jj+1
           enddo
         enddo
        call dpotrf('L',nik,work(ii),nik,i)
        call dpotrs('L',nik,ni*ni,work(ii),nik,work(iii),nik,i)
       enddo
      ii=ii-1
      rewind(999)
      write(999) ii
      write(999) work(1:ii)
c     write(6,*) work(1)
c     write(6,"(58f12.5)") work(1:ii)
C
      return
      end
C
************************************************************************
      subroutine getocc(string,n)
************************************************************************
* Calculate the number of doubly occupied/active orbitals
************************************************************************
      implicit none
      integer n,i,i1,nn
      character(len=4) string
      character(len=1) docc(256)
C
      call getkey(string,4,docc,256)
      n=0
      i1=1
       do i=1,256
         if(docc(i).eq.','.or.docc(i).eq.' ') then
          read(docc(i1:i-1),*) nn
          n=n+nn
           if(docc(i).eq.' ') exit
          i1=i+1
         endif
       enddo
C
      return
      end
C
************************************************************************
      real*8 function getomega(minpfile)
************************************************************************
* Get the range-separation parameter
************************************************************************
      implicit none
      integer minpfile,i
      real*8 tmp
      character(len=1) line1(512)
      character(len=512) line
      equivalence(line,line1)
C
      getomega=0.15d0
      line1=' '
      backspace(minpfile)
      read(minpfile,'(a512)') line
      call lowercase(line,line,512)
      i=1
       do while((line1(i  ).ne.'l'.and.line1(i  ).ne.'s').or.
     $           line1(i+1).ne.'r')!.or.
c    $           line1(i+2).ne.'h'.or.
c    $           line1(i+3).ne.'f'.or.
c    $           line1(i+4).ne.'x')
        i=i+1
       enddo
       if(line1(i+6).ne.' '.or.line1(i+7).ne.' ') then
        backspace(minpfile)
        read(minpfile,*) tmp,line,getomega
       endif
C
      return
      end
C
