************************************************************************
      program mrcc
************************************************************************
*     Date last modified: 06/05/2008                                   *
*     Author:      Mihaly Kallay                                       *
*     Version:     536                                                 *
*     Description: This program solves the (MR)CC/CI/(left and right   *
*                  hand) LR-CC equations for any excitation level.     *
*     Routines called: getmemr8,getmem,gconfig,intinp,initialt,mpdenom,*
*                      ccit,gcoupl                                     *
*     Compile: g77 -O4 -o mrcc mrcc.f lambda.f mem.f xalloc.c combin.f *
*              -lblaspii -llapack (-lessl on AIX; -ldxml on DEC)       *
*     References: J. Chem. Phys. 115, 2945 (2001); 117, 980 (2002);    *
*                 119, 2991 (2003).                                    *
************************************************************************
C To do:
C 1) fix if(let) ... in conini
C 2) check nlength in lambda.f
C 3) check tlength, slength in lambda.f and pert.f
C 4) check transposition in the case of lambda
C
#if defined (Q5Cost)
      use q5cost
      use hdf5
#endif
#include "MRCCCOMMON"
      integer i,j,k,l,m,n,nnb,ntcase,ii,jj,itol,maxbuf,spsht,itcase2
      integer kk,l2mapmem,intadd,dbladd,ioffs,rmem,j1mem,j2mem,j3mem
      integer j4mem,j5mem,j6mem,iref,optfile,ikrmem,iha,ihb,dblalloc
      integer icc2,parent,ierror
      parameter(optfile=99)
      real*8 coef,tprtol,scspe
      character*4 localcc,dfbasis_cor,ovirt
      character*5 scftype
      character*6 core
      character*8 iface,hamilton,c8
      character*13 rohftype
      character*16 tprint,c16
      character*64 files
      integer*4 istat,chdir
#if defined (Q5Cost)
      integer iq5err,q5noccmem
#endif
      logical lll,lfock,ltpr, done
      integer ios, error

c      logical ope
C
#ifdef MPI
      call mrccini_mpi
#else
      call mrccini
#endif
C
      rank=0
      mpisiz1=1
      mpicount=0
      thrd=0
      xyzsiz1=1
#if defined (MPI)
      tag=0
c      call MPI_INIT(mpierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,mpierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,mpisiz1,mpierr)
      call MPI_COMM_GET_PARENT(parent,ierror)
c       if(parent.ne.MPI_COMM_NULL) then
c        close(iout)
c         if(rank.eq.0) open(unit=iout,file='mrcc.out',position='APPEND')
c       endif
      write(c8,'(i8)') rank
      c16='mrccdir.' // trim(adjustl(c8))
#ifdef WINTEL
      call ishell('mkdir ' // c16)
#else
      call ishell('mkdir -p ' // c16)
#endif
      if(master_thread) then
         files = 'fort.1* fort.5* MINP KEYWD VARS'
      inquire(file='fort.63',exist=lll)
       if(lll) files=trim(files) // ' fort.63'
         call ishell('cp ' // trim(files) // ' ' // c16 // 
#ifdef WINTEL
     $         '\ 2>NUL')
#else
     $         ' 2> /dev/null')
#endif
#ifdef WINTEL
         call ishell('dir /b ' // trim(files) // '>' // 
     $         trim(adjustl(c16)) // '\files')
#else
         call ishell('ls -1 ' // trim(files) // ' > ' // 
     $         trim(adjustl(c16)) // '/files')
#endif
      end if
      istat=chdir(c16)
c send files fort.1* fort.5* and MINP to other tasks
      open(scrfile2, file = 'files')
      done = .false.
      do while(.not. done)
         if(master_thread) read(scrfile2, *, iostat = ios) c16
         call MPI_Bcast(ios, 1, MPI_INTEGER, master_rank, 
     $         MPI_COMM_WORLD, error)
         if(ios .eq. 0) then
            call MPI_Bcast(c16, 16, MPI_CHARACTER, 
     $            master_rank, MPI_COMM_WORLD, error)
            if(.not.master_thread) write(scrfile2, *) c16
            call bcast_file(c16, MPI_COMM_WORLD)
         else
            done = .true.
         end if
      end do
      close(scrfile2)

#endif
#if defined (OMP)
C$OMP PARALLEL
C$OMP& DEFAULT(SHARED)
      xyzsiz1=OMP_GET_NUM_THREADS()
C$OMP END PARALLEL
#endif
      xyzsize=xyzsiz1-1
      mpisize=mpisiz1-1
C
      open(intfile ,status='unknown',access='direct',recl=irecln)
      open(mpfile  ,status='unknown',access='direct',recl=irecln)
      open(diisfile,status='unknown',access='direct',recl=irecln)
      open(errfile ,status='unknown',access='direct',recl=irecln)
      open(scrfile2,status='unknown',access='direct',recl=irecln)
      open(scrfile3,status='unknown',access='direct',recl=irecln)
      open(scrfile4,status='unknown',access='direct',recl=irecln)
      open(strfile ,status='unknown',access='direct',recl=irecln)
      open(inp     ,status='unknown',file='fort.55')
      open(inpfile ,status='unknown',file='fort.56')
#ifdef MPI
#ifdef WINTEL
      open(ifcfile ,status='unknown',file="..\iface")
#else
      open(ifcfile ,status='unknown',file='../iface')
#endif
#else
      open(ifcfile ,status='unknown',file='iface')
#endif
      i=0
       do while(.true.)
        read(ifcfile,*,end=1111)
        i=i+1
       enddo
1111  continue
      rewind(ifcfile)
       do j=1,i
        read(ifcfile,*)
       enddo
      recmax=idnint(2.d0*dble(2**30)-10.d0) !No 2Gbyte limit
c     recmax=idnint((2.d0*dble(2**30)-1.d0)/dble(irecln))!2Gb limit
c     recmax=idnint(dble(2**30)/dble(irecln))
C Default values of options
      mrop=2
      nsing=1
      ntrip=0
      l=0
      calc=1
      dens=0
      conver=0
      isym=1
      isy1=1
      isy2=1
      diag=0
      iclsh=1
      k=1
      ihf=1
      ndoub=0
      nacto=0
      nactv=0
      nroot=1
      mr=.false.
      eomcc=.false.
      eomroute=.false.
      left=.false.
      hess=.false.
      leftroute=.false.
      densroute=.false.
      ptroute=.false.
      ccroute=.false.
      t1route=.false.
      t2route=.false.
      l1route=.false.
      l2route=.false.
      l3route=.false.
      d1route=.false.
      d2route=.false.
      dbroute=.false.
      ss1route=.false.
      ss2route=.false.
      ss3route=.false.
      ds1route=.false.
      ds2route=.false.
      dt1route=.false.
      dt2route=.false.
      dsroute=.false.
      dtroute=.false.
      pertroute=0
      pert=0
      nmr=.false.
      eomgrad=.false.
      zroute=.false.
      osc=.false.
      dipm=.false.
      ptsym(1)=1
      sacc=0
      col=.false.
      itol=8
      maxex=0
      ptfreq=0.d0
      fdpci=.false.
      dboc=0
      lcc=.false.
      ssmrcc=0
      pleft=.false.
      third=.false.
      optrec=.false.
      q5inp=.false.
      rohfdiag=0
      lfvo=.false.
      qcc=0
      rel=0
      rest=0
      locno=0
C Try to read options
      rewind(inpfile)
      read(inpfile,*,end=1004) mrop,nsing,ntrip,rest,calc,dens,conver,
     $isym,diag,iclsh,k,ihf,ndoub,nacto,nactv,itol,maxex,sacc,ptfreq,
     $dboc,maxcor!,locno
1004  continue
      inquire(file='MINP',exist=lll)
       if(lll) then
        call getkey('localcc',7,localcc,4)
        call getkey('dfbasis_cor',11,dfbasis_cor,4)
        call getkey('iface',5,iface,8)
        call getkey('hamilton',8,hamilton,8)
        call getkey('ovirt',5,ovirt,4)
        call getkey('rohftype',8,rohftype,13)
        call getkey('scftype',7,scftype,5)
c      lfock=localcc.ne.'off '.or.dfbasis_cor.ne.'none'.or.
c    $(iface.eq.'dirac   '.and.hamilton.eq.'x2cmmf  ')
        lfock=ovirt.eq.'off '.and.dens.eq.0.and.
     $  .not.(scftype.eq.'rohf '.and.rohftype.eq.'standard     ')
         if(localcc.ne.'off '.and.nsing.eq.1) locno=3
        call getkey('tprint',6,tprint,16)
         if(tprint.ne.'off             ') then
          ltpr=.true.
          read(tprint,*) tprtol
         else
          ltpr=.false.
         endif
         if(iface.eq.'none    ') then
          call getvar('ncore     ',ncore)
          call getkey('core',4,core,6)
           if(core.eq.'corr  ') ncore=0
         else
          ncore=0
         endif
        call getkey('scspe',5,c16,16)
        read(c16,*) scspe
       else
        lfock=.false.
        ltpr=.false.
        ncore=0
        scspe=1.d0
       endif
      icc2=0
       if(calc.ge.2.and.calc.le.8) then
        icc2=calc-1
         if(mrop.le.2) calc=1
       endif
c      rewind(inpfile)
c      read(inpfile,*,end=1001) mrop,nsing,ntrip,rest,calc,dens,conver,
c     $isym,diag,iclsh,k,ihf,ndoub,nacto,nactv,itol,maxex,sacc,freq,dboc
c1001  continue
      tol=10.d0**dble(-itol)
C MR options
      mrop2=max(mrop,2)
       if(mod(nactv,2).eq.0) then
        nactva=nactv/2
        nactvb=nactv/2
       else
        nactva=(nactv-1)/2+1
        nactvb=(nactv-1)/2
       endif
       if(mod(nacto,2).eq.0) then
        nactoa=nacto/2
        nactob=nacto/2
       else
        nactoa=(nacto-1)/2+1
        nactob=(nacto-1)/2
       endif
C Multiplicities
      nroot=nsing+ntrip+ndoub
      call getmem(nroot+2,icore(1),multmem)
       do m=1,nsing
        icore(multmem+m-1)=1
       enddo
       do m=nsing+1,nsing+ntrip
        icore(multmem+m-1)=3
       enddo
       do m=nsing+ntrip+1,nroot
        icore(multmem+m-1)=2
       enddo
      multip=icore(multmem)
       if(iclsh.eq.1) then
        cs=.true.
       else
        cs=.false.
       endif
       if(k.eq.1) then
        spatial=.true.
       else
        spatial=.false.
       endif
      calc=iabs(calc)
       if((calc.lt.1.or.calc.gt.3.or.calc.eq.2.or.
     $(calc.eq.3.and.op.gt.4).or.conver.gt.0.or.nacto.ne.0).and.
     $locno.eq.3) then
        write(iout,*)
     $'The local approach is not implemented for the specified method!'
        call mrccend(1)
       endif
       if(calc.eq.20) then
        calc=1
        qcc=1
        eomcc=.true.
        left=.true.
       endif
      qccop=mrop
       if(calc.eq.9) then
        calc=3
        lfvo=.true.
       endif
       if(dboc.ne.0) dens=4
       if(dens.lt.0) col=.true.
      dens=iabs(dens)
C
#if defined (Q5Cost)
      call Q5Cost_init(iq5err) 
       if(iq5err.eq.-1) then
        write(iout,*) 'Unable to initialize the Q5Cost interface! '
       else
        call Q5Cost_file_open('fort.55.h5',q5file,iq5err) 
         if(iq5err.eq.-1) then
          write(iout,*) 'Unable to open Q5Cost file! '
         else
          call Q5Cost_System_exists(q5file,lll)
           if(lll) then
            call Q5Cost_MO_exists(q5file,lll)
             if(.not.lll) write(iout,*) 
     $'No information on MOs in Q5Cost file! '
           else
            write(iout,*) 'Empty Q5Cost file! '
           endif
         endif
       endif
       if(iq5err.eq.0.and.lll) then
        q5inp=.true.
       else
        write(iout,*) 'Trying to read fort.55... '
#endif
         if(locno.eq.3) then
          rewind(inp)
          read(inp,*,end=1002) m,m,locno
         else
          locno=0
          rewind(inp)
          read(inp,*,end=1002) m
         endif
#if defined (Q5Cost)
       endif
#endif
       if(m.le.0) then
         if(dens.ne.3.and.dens.ne.4) then
          write(iout,*) 'Corrupted input file!'
          call mrccend(1)
         endif
        ptroute=.true.
         if(m.eq.-2) dsroute=.true.
         if(m.eq.-3) dtroute=.true.
        npert=iabs(m)
         if(npert.eq.0) npert=1
       else
        rewind(inp)
        read(inp,*,end=1002) nbasis,nocc
        read(inp,*,end=1002) (m,i=1,nbasis)
        read(inp,*,end=1002) m
        rewind(inp)
         if(m.eq.-2.or.m.eq.-3) rel=iabs(m)-1
        npert=0
       endif
       if(rel.gt.0) then
        nactva=nactv
        nactvb=0
        nactoa=nacto
        nactob=0
       endif
       if(npert.gt.ptmax) then
        write(iout,*) 'Too many perturbations! '
        call mrccend(1)
       endif
C
       if(calc.gt.0.and.nroot.gt.1) then
        eomcc=.true.
         if(dens.ne.0) eomgrad=.true.
         if(dens.eq.3.or.dens.eq.4) then
          write(iout,*)
     $'Second derivatives are not implemented for LR-CC methods!'
          call mrccend(1)
         endif
         if(dens.eq.7.or.dens.eq.8) then
          write(iout,*)
     $'Third derivatives are not implemented for LR-CC methods!'
          call mrccend(1)
         endif
       endif
       if(calc.ge.2.and.calc.le.8) then
c        if(mrop.le.2) then
c         write(iout,*) 
c    $'Approximate CC methods are not implemented for excitation level',
c    $mrop,'!'
c         call mrccend(1)
c        endif
         if(.not.cs.and.(spatial.or.ihf.eq.0).and.calc.eq.7) then
          write(iout,*) 
     $'CCn methods are not implemented for ROHF reference!'
          write(iout,*) 'Use UHF orbitals!'
          call mrccend(1)
         endif
         if(.not.cs.and.spatial.and.rel.eq.0) then
          write(iout,*) 
     $'Approximate CC methods are not implemented for standard ' //
     $'ROHF orbitals!'
          write(iout,*) 'Use semicanonical orbitals!'
          call mrccend(1)
         endif
         if(nroot.gt.1) then
          write(iout,*) 
     $'Approximate CC methods are not implemented for excited states!'
          call mrccend(1)
         endif
         if(dens.gt.0) then
          write(iout,*) 
     $'Derivatives are not implemented for approximate CC methods!'
          call mrccend(1)
         endif
        pert=calc-1
        calc=1
       endif
       if(calc.eq.10) then
        calc=0
        lcc=.true.
       endif
       if(calc.gt.10.and.calc.lt.20) then
        ssmrcc=calc-10
        calc=1
         if(dens.gt.0) then
          write(iout,*) 
     $'Derivatives are not implemented for SSMRCC methods!'
          call mrccend(1)
         endif
        open(ssfile,status='old',file='fort.31',form='formatted')
        rewind(ssfile)
        read(ssfile,*) ss1route,ss2route,ss3route,iref,coef
         if(ss1route) calc=0
c        if(ss3route) calc=0 !mrszemet
       endif
       if((dens.gt.0.and.calc.eq.1).or.pert.eq.3) then
        eomcc=.true.
        left=.true.
       endif
       if(dens.eq.3.or.dens.eq.4) then
        hess=.true.
        dens=dens-2
       endif
       if(dens.eq.5.or.dens.eq.6) then
        osc=.true.
c       dens=1
        dens=dens-4
       endif
       if(dens.eq.7.or.dens.eq.8) then
        hess=.true.
        third=.true.
        dens=dens-6
       endif
      lc3=left.or.dens.gt.0.or.pert.ne.0
      fdpci=calc.eq.0.and.ptroute.and.ptfreq.ne.0.d0
       if(nroot.gt.2.and.eomgrad.and..not.osc) then
        write(iout,*) 'LR-CC analytic gradient calculation is only '
        write(iout,*) 'possible for one excited state at a time!'
        call mrccend(1)
       endif
C Optical rectification hyperpolarizability
       if(calc.eq.0.and.ptroute.and.ptfreq.eq.0.d0) then
        open(unit=optfile,file='OPTREC',status='old',err=6429)
        read(optfile,*,end=6429) i
         if(i.eq.1) optrec=.true.
        close(optfile)
6429    continue
       endif
      nfroz=0
       if(q5inp) then
#if defined (Q5Cost)
        call Q5Cost_MO_get_num_orb_tot(q5file,nbasis,iq5err)
         if(iq5err.eq.-1) then
          write(iout,*) 
     $'Unable to read the number of orbitals from Q5Cost file! '
          call mrccend(1)
         endif
C
        call getmem(nbasis,icore(1),itrmem)
        ii=0
         do i=1,nbasis
          call Q5Cost_MO_is_frozen(q5file,i,lll,iq5err)
           if(iq5err.eq.-1) then
            write(iout,*) 
     $'Unable to read frozen orbitals from Q5Cost file! '
            call mrccend(1)
           endif
           if(lll) then
            icore(itrmem+i-1)=0
            nfroz=nfroz+1
           else
            ii=ii+1
            icore(itrmem+i-1)=ii
           endif
         enddo
c       write(6,*) 'nbasis',nbasis,nfroz
        nbasis=nbasis-nfroz
C
        call getmemr8(nbasis+nfroz,icore(1),q5noccmem)
        call get_occ_num(q5file,dcore(q5noccmem),iq5err,nbasis+nfroz)
        write(6,*) 'occ',(dcore(q5noccmem+i-1),i=1,nbasis)
         if(iq5err.eq.-1) then
          write(iout,*) 
     $'Unable to read the occupation vector from Q5Cost file! '
          call mrccend(1)
         else
          ii=0
           do i=1,nbasis+nfroz
             if(icore(itrmem+i-1).eq.0) then
              ii=ii+1
             else
              dcore(q5noccmem+i-1-ii)=dcore(q5noccmem+i-1)
             endif
           enddo
          nocc=0
           do i=1,nbasis
            nocc=nocc+idnint(dabs(dcore(q5noccmem+i-1)))
           enddo
         endif
#endif
       else
        read(inp,*,end=1002) nbasis,nocc
       endif
      nbasis=2*nbasis
      nvirt=nbasis-nocc
       if(mod(nocc,2).ne.0) then
        nal=(nocc+1)/2
       else
        nal=nocc/2
       endif
      nbe=nocc-nal
C Occupancies and active orbitals
      call getmem(nbasis+2,icore(1),noccmem)
      call getmem(nbasis+2,icore(1),nactmem)
      call getmem(nbasis+2,icore(1),iordmem)
      call ifillzero(icore(noccmem),nbasis+1)
      call ifillzero(icore(nactmem),nbasis+1)
       do m=1,min(nal,nbe)
        icore(noccmem+m)=2
       enddo
       do m=nbe+1,nal
        icore(noccmem+m)=1
       enddo
       do m=nal-max(nactoa,nactob)+1,nal+max(nactva,nactvb)
        icore(nactmem+m)=1
       enddo
#if defined (Q5Cost)
       if(q5inp) then
         do i=1,nbasis/2
          icore(noccmem+i)=idnint(dcore(q5noccmem+i-1))
         enddo
       endif
#endif
      read(inpfile,*,end=1013)
      read(inpfile,*,end=1013) (icore(noccmem+m),m=1,nbasis/2)
       if(rel.gt.0) then
         do m=1,nbasis/2
           if(icore(noccmem+m).ne.1.and.icore(noccmem+m).ne.0) then
            write(iout,*) 'Invalid occupation numbers! '
            call mrccend(1)
           endif
         enddo
       endif
      nal=0
      nbe=0
       do m=1,nbasis/2
         if(icore(noccmem+m).eq.2) then
          nal=nal+1
          nbe=nbe+1
         endif
         if(iabs(icore(noccmem+m)).eq.1) then
           if(icore(noccmem+m).eq.1) nal=nal+1
           if(icore(noccmem+m).eq.-1) nbe=nbe+1
           if(cs) then
            write(iout,*) 'Invalid option! Open shell system!'
            call mrccend(1)
           endif
         endif
       enddo
      nocc=nal+nbe
      read(inpfile,*,end=1013) (icore(nactmem+m),m=1,nbasis/2)
      nactva=0
      nactvb=0
      nactoa=0
      nactob=0
       do m=1,nbasis/2
         if(icore(nactmem+m).eq.1) then
           if(icore(noccmem+m).eq.2) then
            nactoa=nactoa+1
            nactob=nactob+1
           endif
           if(icore(noccmem+m).eq.1) then
            nactoa=nactoa+1
            nactvb=nactvb+1
           endif
           if(icore(noccmem+m).eq.-1) then
            nactob=nactob+1
            nactva=nactva+1
           endif
           if(icore(noccmem+m).eq.0) then
            nactva=nactva+1
            nactvb=nactvb+1
           endif
         endif
       enddo
       if(rel.ne.0) then
        nactvb=0
        nactob=0
       endif
      nactv=nactva+nactvb
      nacto=nactoa+nactob
1013  continue
       if(nacto.ne.0.and.locno.gt.0) then
        write(iout,*)
     $'The local approach is not implemented for the specified method!'
        call mrccend(1)
       endif
      ms2=nal-nbe
C
       if(nactv+nacto.gt.0) mr=.true.
c      if(nactv*nacto.gt.0) mr=.true.
       if((ndoub.gt.0.and.cs).or.(cs.and.ms2.ne.0).or.
     $(cs.and.nsing.eq.0.and.calc.eq.1)) then
        write(iout,*) 'Invalid multiplicity!'
        call mrccend(1)
       endif
      nvirtal=nbasis/2-nal
      nvirtbe=nbasis/2-nbe
       if(rel.gt.0) then
        nvirtbe=0
        nactvb=0
        nactob=0
       endif
      nelec=nal+nbe
      op=min(mrop+min(nactv,nacto),nocc,nvirt)
       if(maxex.gt.0) op=min(op,maxex)
       if(dboc.eq.2.and.calc.eq.1) then
c       dboc=op
        op=min(nocc,nvirt)
        mrop=op
        mrop2=max(mrop,2)
       endif
       if(qcc.eq.1) then
        op=min(2*op,nocc,nvirt)
        mrop=op
        mrop2=max(mrop,2)
       endif
      nactmax=min(max(nactva,nactvb,nactoa,nactob),op)
      op2=op+2
       if(op.gt.max(nocc,nvirt)) then
        write(iout,*) 'Invalid excitation level!'
        call mrccend(1)
       endif
      rhf=cs.and.spatial
      minvirtal=min(op,nvirtal,nal)
      minoccal=min(op,nvirtal,nal)
      minvirtbe=min(op,nvirtbe,nbe)
      minoccbe=min(op,nvirtbe,nbe)
      minvirtal2=max(minvirtal,2)
      minvirtbe2=max(minvirtbe,2)
      minoccal2=max(minoccal,2)
      minoccbe2=max(minoccbe,2)
       if(rel.gt.0) then
        minvirtbe=0
        minoccbe=0
       endif
      oo=max(op,minvirtal2,minvirtbe2,minoccal2,minoccbe2)
      lfvo=lfvo.or.(pert.eq.3.and.op.ge.4).or.(ihf.eq.0.and..not.
     $(mod(op,2).eq.0.and.(pert.eq.1.or.pert.eq.4)))
      write(iout,1003)
1003  format(1x,70('*'))
      call acrmet(icc2)
       if(lcc) conver=0
      write(iout,*)
      write(iout,*)
#if defined (MPI)
      write(iout,*) 'MPI parallel version is running.'
      write(iout,"(' Number of MPI tasks:',i4)") mpisiz1
#endif
#if defined (OMP)
C$OMP PARALLEL
C$OMP& DEFAULT(SHARED)
      xyzsiz1=OMP_GET_NUM_THREADS()
      thrd=OMP_GET_THREAD_NUM()
       if(thrd.eq.0) then
        write(iout,*) 'OpenMP parallel version is running.'
        write(iout,"(' Number of CPU cores:',i4)") xyzsiz1
       endif
C$OMP END PARALLEL
#endif
      call npropdet
      call getmem(op+1,icore(1),ntcase)
      rewind(gfile)
      read(gfile,*,end=1000) i,j,k,maxmem,l
      read(gfile,*,end=1000) nimed,wspcmax,iimed,(icore(ntcase+m),
     $m=0,op),ccimed,eomimed,leftimed,densimed,l3imed,d2imed,nimed2,
     $ds2imed,dt2imed
       if(ptroute.and.calc.eq.0) nimed2=d2imed+ccimed
      nimed3=nimed2+3*nprop*iimed
       if(i.ne.op.or.j.ne.nvirt.or.k.ne.nocc.or.l.ne.ihf) goto 1008
      call getmem((oo+1)*(2*nactmax+1)**2,icore(1),itcase)
      call getmem(2*(oo+1)*(2*nactmax+1)**2,icore(1),itcase2)
      call ifillzero(icore(itcase),(oo+1)*(2*nactmax+1)**2)
      call ifillzero(icore(itcase2),2*(oo+1)*(2*nactmax+1)**2)
       do m=0,op
         do n=1,icore(ntcase+m)
          read(gfile,*) i1,i2,ii
          icore(itcase+m*(2*nactmax+1)**2+i2*(2*nactmax+1)+i1)=ii
          icore(itcase2+m*2*(2*nactmax+1)**2+(ii-1)*2  )=i1
          icore(itcase2+m*2*(2*nactmax+1)**2+(ii-1)*2+1)=i2
         enddo
       enddo
      write(iout,132) maxmem
132   format(' Allocation of',f7.1, ' Mbytes of memory...')
      maxmem=maxmem*dble(twoto20)/dble(ifltln)
      maxcor=idnint(maxmem)
      maxcor=maxcor+ibufln
      call getmemr8(maxcor,icore(1),imem)
c     write(6,*) 'imem',imem,maxcor
       if(rel.gt.0) then
        write(iout,"(' Number of spinors:',i4)") nbasis/2
        write(iout,"(' Number of electrons:',i3)") nal+nbe
       else
        write(iout,"(' Number of spinorbitals:',i4)") nbasis
        write(iout,"(' Number of alpha electrons:',i3)") nal
        write(iout,"(' Number of beta  electrons:',i3)") nbe
       endif
       if(mr) then
        write(iout,*) 'Number of active particles:',nactv
        write(iout,*) 'Number of active holes:    ',nacto
       endif
       if(nroot.eq.1) write(iout,"(' Spin multiplicity:',i2)") multip
      write(iout,1014) ms2*0.5d0
1014  format(' z-component of spin: ',f4.1)
       if(isym.eq.0) then
        write(iout,*) 'Spatial symmetry is not used.'
       else
         if(isym.gt.10) then
          isy1=(isym-mod(isym,10))/10
          isy2=isym-isy1*10
          write(iout,7538) isy1,isy2
          isym=isy2
         else
          isy1=isym
          isy2=isym
           if(eomcc) isy1=1
          write(iout,7538) isym
         endif
       endif
      write(iout,2015) tol
7538  format(' Spatial symmetry:',2i2)
2015  format(' Convergence criterion: ',1pe8.1)
#if defined (MPI)
      iimem=intadd(imem)
      icore(iimem+mpisiz1:iimem+mpisiz1+mpisize)=0
      icore(iimem+mpisiz1+rank)=xyzsiz1
      call MPI_AllReduce(icore(iimem+mpisiz1),icore(iimem),mpisiz1,
     $MPI_INTEGER,MPI_MAX,MPI_COMM_WORLD,error)
      mpicount=0
       do i=0,rank-1
        mpicount=mpicount+icore(iimem+i)
       enddo
      mpisiz1=mpicount
       do i=rank,mpisize
        mpisiz1=mpisiz1+icore(iimem+i)
       enddo
      mpisize=mpisiz1-1
c      write(6,"(2i4,100i2)") rank,mpicount,icore(iimem:iimem+mpisize)
#else
      mpisiz1=xyzsiz1
      mpisize=xyzsize
#endif
C Initialize symmetry variables
      nnb=nbasis/2
      call getmem(5*nbasis+1,icore(1),mosymmem)
      call getmem(2*8*nnb+1,icore(1),iabsmem)
      call symini(icore(mosymmem),icore(mosymmem+nbasis),nbasis,
     $icore(noccmem+1),icore(nactmem+1),icore(iabsmem),
     $icore(iabsmem+8*nnb),icore(intadd(imem)),icore(itrmem),
     $nbasis/2+nfroz)
       if(isym.gt.nir.or.(calc.eq.1.and.isym.ne.1.and.(.not.eomcc)).or.
     $isy1.gt.nir.or.isy2.gt.nir) then
        write(iout,*) 'Invalid spatial symmetry!'
        call mrccend(1)
       endif
      read(inp,*)
C Number of configurations and occupation graphs
      call getmem(4*nir*(oo+1)*(nactmax+1)+
     $            nirrep*(oo+1)**2*(nactmax+1)**4,icore(1),iconfmem)
      call getmem(nirrep*(oo+1)**2*(nactmax+1)**4,icore(1),itrecmem)
      call getmem(nirrep*(oo+1)**2*(nactmax+1)**4,icore(1),itarecmem)
      call getmem(nirrep*(oo+1)*(2*nactmax+1)**2,icore(1),itrec2mem)
       if((eomcc.and.isym.ne.1).or.(ptroute.and.ptsym(1).ne.isym).or.
     $(calc.eq.0.and.isy1.ne.isy2)) then
        econfmem=iconfmem+4*nir*(oo+1)*(nactmax+1)
     $                     +(oo+1)**2*(nactmax+1)**4
        iearecmem=itarecmem+(oo+1)**2*(nactmax+1)**4
        ierecmem =itrecmem +(oo+1)**2*(nactmax+1)**4
        ierec2mem=itrec2mem+(oo+1)*(2*nactmax+1)**2
       else
        econfmem=iconfmem+4*nir*(oo+1)*(nactmax+1)
        iearecmem=itarecmem
        ierecmem=itrecmem
        ierec2mem=itrec2mem
       endif
      call getmem(4*nir*(oo+1)*(nactmax+1),icore(1),istrmem)
      call getmem(4*nir*(oo+1)*(nactmax+1),icore(1),istrecmem)
      call getmem(2*4*(oo+1)*(nactmax+1),icore(1),itransmem)
      call getmem(2*4*(oo+1)*(nactmax+1),icore(1),iarcmem)
      call getmem(2*(oo+2)**3+10,icore(1),itspmem)
      call getmem(oo+2,icore(1),iucvmem)
      call getmem(oo+5,icore(1),iindmem)
      call getmem(2*(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2,icore(1),
     $isympmem)
      call getmem(nir**4,icore(1),itamem)
      call ifillzero(icore(itamem),nir**4)
      open(tafile,status='unknown',access='direct',recl=nir**4*iintln)
      iimem=intadd(imem)
      call gconfig(icore(iconfmem),
     $icore(iconfmem+nir*(oo+1)*(nactmax+1)),
     $icore(iconfmem+2*nir*(oo+1)*(nactmax+1)),
     $icore(iconfmem+3*nir*(oo+1)*(nactmax+1)),
     $icore(iconfmem+4*nir*(oo+1)*(nactmax+1)),
     $icore(iarcmem),icore(itspmem),oo,nir,
     $icore(istrmem),icore(istrmem+nir*(oo+1)*(nactmax+1)),
     $icore(istrmem+2*nir*(oo+1)*(nactmax+1)),
     $icore(istrmem+3*nir*(oo+1)*(nactmax+1)),
     $icore(mosymmem+nbasis),nbasis,icore(isympmem),
     $icore(isympmem+(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2),
     $icore(itamem),icore(itarecmem),nactmax,icore(econfmem),
     $icore(iearecmem),icore(itrecmem),icore(ierecmem),icore(itrec2mem),
     $icore(ierec2mem),icore(itcase),icore(ntcase),
     $icore(istrecmem),icore(istrecmem+nir*(oo+1)*(nactmax+1)),
     $icore(istrecmem+2*nir*(oo+1)*(nactmax+1)),
     $icore(istrecmem+3*nir*(oo+1)*(nactmax+1)),
     $icore(itransmem),icore(itransmem+2*(oo+1)*(nactmax+1)),
     $icore(itransmem+4*(oo+1)*(nactmax+1)),
     $icore(itransmem+6*(oo+1)*(nactmax+1)),
     $icore(iarcmem+4*(oo+1)*(nactmax+1)))
C Coupling coefficients
      call getmem(4*(oo+1)**2*nir**2*(nactmax+1)**2,icore(1),icoupmem)
      call gcoupl(icore(icoupmem),icore(iconfmem),
     $icore(iconfmem+nir*(oo+1)*(nactmax+1)),
     $icore(iconfmem+2*nir*(oo+1)*(nactmax+1)),
     $icore(iconfmem+3*nir*(oo+1)*(nactmax+1)),icore(iarcmem),oo,nir,
     $icore(istrmem),icore(istrmem+nir*(oo+1)*(nactmax+1)),
     $icore(istrmem+2*nir*(oo+1)*(nactmax+1)),
     $icore(istrmem+3*nir*(oo+1)*(nactmax+1)),nactmax,icore(iimem),
     $icore(istrecmem),icore(istrecmem+nir*(oo+1)*(nactmax+1)),
     $icore(istrecmem+2*nir*(oo+1)*(nactmax+1)),
     $icore(istrecmem+3*nir*(oo+1)*(nactmax+1)),
     $icore(itransmem),icore(itransmem+2*(oo+1)*(nactmax+1)),
     $icore(itransmem+4*(oo+1)*(nactmax+1)),
     $icore(itransmem+6*(oo+1)*(nactmax+1)))
C Initialize cluster amplitudes
      call initialt(icore(iimem))
       if(ss3route) then
        open(cfile,file='fort.17',status='unknown',access='direct',
     $recl=irecln)
        open(scrfile5,status='unknown',access='direct',recl=irecln)
        iimem=intadd(imem)
        rmem=iimem
        iimem=iimem+nbasis/2
        read(ssfile,*) (icore(rmem-1+i),i=1,nbasis/2)
        j1mem=iimem
        iimem=iimem+(nactmax+1)**4*(oo+1)**2
        j2mem=iimem
        iimem=iimem+(nactmax+1)**4*(oo+1)**2
        j3mem=iimem
        iimem=iimem+2*4*(oo+1)*(nactmax+1)
        j4mem=iimem
        iimem=iimem+4*nir*(oo+1)*(nactmax+1)
        j5mem=iimem
        iimem=iimem+8*nnb
        j6mem=iimem
        iimem=iimem+8*nnb
c
        ioffs=dbladd(iimem)
        call cconv(icore(econfmem),icore(ierecmem),icore(iconfmem),oo,
     $dcore(ioffs),nir,icore(isympmem),
     $icore(isympmem+(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2),nnb,
     $nactmax,icore(noccmem+1),icore(iabsmem),icore(istrecmem),ioffs,
     $icore(rmem),icore(nactmem+1),icore(j1mem),icore(j2mem),
     $icore(mosymmem),icore(iarcmem+4*(oo+1)*(nactmax+1)),icore(j3mem),
     $icore(itarecmem),icore(itamem),icore(j4mem),icore(j5mem),
     $icore(j6mem),coef)
      call mrszemet(scrfile5,icore(iconfmem+4*nir*(oo+1)*(nactmax+1)),
     $oo,nactmax,icore(itrecmem),dcore(imem),0,i,i,i,
     $icore(iconfmem+4*nir*(oo+1)*(nactmax+1)),icore(itrecmem))
       endif
C Integral lists and intermediates
      wspcmax=wspcmax*12
      call getmem(nimed3+op+wspcmax+19,icore(1),intrecmem)
      call getmem(iimed+1,icore(1),denrecmem)
      call ifillzero(icore(intrecmem),op2)
      intrecmem=intrecmem+op+1
      call getmem(leftimed-eomimed+2,icore(1),l2mapmem)
      call getmem(nimed3+op+18,icore(1),itypamem)
      call getmem(nimed3+op+18,icore(1),itypbmem)
      call getmem(nimed3+op+wspcmax+18,icore(1),isymamem)
      call getmem(nimed3+op+wspcmax+18,icore(1),isymbmem)
      itypamem=itypamem+op+1
      itypbmem=itypbmem+op+1
      isymamem=isymamem+op+1
      isymbmem=isymbmem+op+1
       do i=-op,-1
        icore(itypamem+i-1)=2
        icore(itypbmem+i-1)=2
       enddo
      call getmem(16*(nimed3+14)+10,icore(1),imedmem)
      call getmem((wspcmax+1)*nimed3,icore(1),wspcbmem)
      call getmem((wspcmax+1)*(nimed3+op+1),icore(1),wspcamem)
      wspcamem=wspcamem+(op+1)*(wspcmax+1)
      i=4
       if(left.or.dens.ne.0) i=5
C Not lower than 6*nir**4 (intinp)
      call getmem(max(op+2,wspcmax+1,max(12*nir**i,nir**(i+1))),
     $icore(1),isamem) 
      call getmem(14*nir**4,icore(1),iswmem)
      call getmem(iimed+1,icore(1),int2mem)
      call readsp(icore(wspcbmem),icore(wspcamem),oo,wspcmax,
     $icore(int2mem),iimed,icore(imedmem),icore(intrecmem),
     $icore(itypamem),icore(itypbmem),icore(l2mapmem))
      jj=1
       if(.not.spatial.or.q5inp.or.rel.eq.2) jj=2
      ii=maxcor-jj*nnb**2
       if(lfock) ii=maxcor-2*jj*nnb**2
       if(q5inp) ii=maxcor-(jj+1)*nnb**2-4*nnb**2/iintfp
      maxbuf=min(nnb,(ii-mod(ii,nnb**3))/nnb**3)
       if(maxbuf.eq.0.or.(q5inp.and.3*(nnb+nfroz)**2.gt.maxbuf*nnb**3)) 
     $then
        write(iout,*) 'Insufficient memory!'
        call mrccend(1)
       endif
      call getmem(nbasis,icore(1),ikrmem)
      umatmem=imem
       if(locno.gt.0) call getmemr8(nocc,icore(1),umatmem)
C Fock-matrix or one-electron integrals?
       if(lfock) then
        iha=imem
        imem=imem+nnb**2
        ihb=iha
         if(jj.eq.2) then
          ihb=imem
          imem=imem+nnb**2
         endif
       else
        iha=imem+maxbuf*nnb**3
        ihb=imem+(jj-1)*nnb**2+maxbuf*nnb**3
       endif
C
      call intinp(dcore(imem),dcore(imem+maxbuf*nnb**3),
     $dcore(imem+(jj-1)*nnb**2+maxbuf*nnb**3),dcore(imem),maxbuf,nnb,oo,
     $icore(iconfmem),icore(intrecmem),icore(imedmem),icore(mosymmem),
     $nir,icore(isympmem),
     $icore(isympmem+(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2),
     $icore(istrmem),icore(isamem),nactmax,icore(wspcbmem),
     $icore(wspcamem),wspcmax,icore(int2mem),icore(noccmem+1),
     $icore(denrecmem),icore(iabsmem),icore(itypamem),icore(itypbmem),
     $icore(isymamem),icore(isymbmem),icore(nactmem+1),icore(iordmem),
     $icore(iordmem+nnb),icore(intadd(imem+(nnb+nfroz)**2)),
     $icore(intadd(imem+jj*nnb**2+maxbuf*nnb**3)),
     $dcore(imem+(jj-1)*nnb**2+maxbuf*nnb**3),nnb+nfroz,
     $dcore(imem+jj*nnb**2+maxbuf*nnb**3+4*nnb**2/iintfp),icore(itrmem),
     $icore(ikrmem),icore(intadd(imem+jj*nnb**2+maxbuf*nnb**3)),
     $icore(intadd(imem+jj*nnb**2+maxbuf*nnb**3)+nnb+1),
     $icore(intadd(imem+jj*nnb**2+maxbuf*nnb**3)+nnb+1+nnb**2),
     $dcore(umatmem),dcore(iha),dcore(ihb),lfock,scspe)
       if(lfock) imem=iha
#if defined (Q5Cost)
       if(q5inp) then
        call Q5Cost_file_close(q5file,iq5err)
         if(iq5err.eq.-1) write(iout,*) 'Unable to close Q5Cost file! '
       endif
#endif
C Calculate many-body denominators
      spsht=0
       if(.not.spatial) spsht=nnb+2*nnb**2
       if(dsroute.or.dtroute) goto 4846
       if(eomcc.and.(.not.ptroute).and.pert.ne.3.and.qcc.eq.0) calc=0
      ii=econfmem
      jj=ierecmem
      kk=iearecmem
347   continue
      call mpdenom(icore(ii),icore(jj),icore(iconfmem),icore(intrecmem),
     $oo,dcore(imem),dcore(imem+nvirtal),dcore(imem+nvirt),
     $dcore(imem+nvirt+nal),dcore(imem+spsht+nnb+2*nnb**2),nir,
     $icore(isympmem),
     $icore(isympmem+(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2),
     $icore(istrmem),dcore(imem),dcore(imem+nnb),
     $dcore(imem+nnb+nnb**2),dcore(imem+spsht),dcore(imem+spsht+nnb),
     $nnb,icore(wspcbmem),icore(wspcamem),wspcmax,nactmax,
     $icore(imedmem),icore(int2mem),icore(noccmem+1),icore(iabsmem),
     $icore(istrecmem),imem+spsht+nnb+2*nnb**2,.true.,.false.,tprtol,
     $icore(ierecmem),icore(econfmem))
C Initialize CI coefficients
      call initialc(icore(ii),icore(jj),icore(iconfmem),oo,dcore(imem),
     $nir,icore(isympmem),
     $icore(isympmem+(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2),nroot,
     $icore(itamem),icore(kk),nactmax,icore(multmem),
     $icore(iabsmem+8*nnb),nbasis,icore(itransmem),icore(iarcmem),
     $icore(nactmem+1),icore(iimem),icore(mosymmem+nbasis),nroot)
      if(pert.eq.3.and.rest.eq.0) open(cfile,file='fort.17',
     $status='unknown',access='direct',recl=irecln)
       if(eomcc.and.calc.eq.0) then
        ii=iconfmem+4*nir*(oo+1)*(nactmax+1)
        jj=itrecmem
        calc=1
        call savevec(mpfile,cfile,trecmax,0,0)
        goto 347
       endif
       if(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy2) then
        ii=iconfmem+4*nir*(oo+1)*(nactmax+1)
        jj=itrecmem
        kk=itarecmem
        isym=isy1
         if(rest.ne.0) call savevec(cfile,tfile,trecmax,0,0)
        call savevec(mpfile,cfile,trecmax,0,0)
        goto 347
       endif
4846  continue
       if(sacc.eq.0.and.pert.eq.0.and.ssmrcc.eq.0.and..not.ltpr)
     $close(strfile,status='delete')
      close(scrfile1,status='delete')
      open(scrfile1,status='unknown',access='direct',recl=irecln)
C CC/CI iteration
      call getmem(max(2*nbasis,2*nir**6),icore(1),iwamem)
      call getmemr8(4*ndiis**2+ndiis+5,icore(1),idiismem)
      call ccit(icore(iconfmem),icore(iconfmem+4*nir*(oo+1)*(nactmax+1))
     $,icore(itrecmem),icore(intrecmem),icore(imedmem),dcore(imem),oo,
     $icore(istrmem),icore(isympmem),
     $icore(isympmem+(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2),
     $icore(itamem),icore(itarecmem),icore(iwamem),icore(isamem),
     $icore(iswmem),icore(wspcbmem),icore(wspcamem),nactmax,
     $icore(int2mem),icore(ntcase),icore(multmem),icore(iearecmem),
     $icore(econfmem),icore(ierecmem),wspcmax,icore(denrecmem),
     $icore(itrec2mem),icore(ierec2mem),icore(itcase2),icore(itypamem),
     $icore(itypbmem),icore(isymamem),icore(isymbmem),icore(l2mapmem),
     $imem,spsht,icore(iabsmem),icore(istrecmem),tprtol,ltpr,scspe)
C Generate reference determinants for SSMRCC
       if(ss1route) then
        ii=econfmem
        jj=ierecmem
      call mpdenom(icore(ii),icore(jj),icore(iconfmem),icore(intrecmem),
     $oo,dcore(imem),dcore(imem+nvirtal),dcore(imem+nvirt),
     $dcore(imem+nvirt+nal),dcore(imem+spsht+nnb+2*nnb**2),nir,
     $icore(isympmem),
     $icore(isympmem+(oo+1)**2*nir*(nir+1)*2*(nactmax+1)**2),
     $icore(istrmem),dcore(imem),dcore(imem+nnb),
     $dcore(imem+nnb+nnb**2),dcore(imem+spsht),dcore(imem+spsht+nnb),
     $nnb,icore(wspcbmem),icore(wspcamem),wspcmax,nactmax,
     $icore(imedmem),icore(int2mem),icore(noccmem+1),icore(iabsmem),
     $icore(istrecmem),imem+spsht+nnb+2*nnb**2,.false.,ltpr,tprtol,
     $icore(ierecmem),icore(econfmem))
        iimem=intadd(imem)
        call savemr(nir,oo,nactmax,icore(ii),icore(jj),
     $icore(iarcmem+4*(oo+1)*(nactmax+1)),icore(itransmem),
     $icore(itarecmem),icore(iconfmem),icore(iabsmem),nbasis,
     $icore(iabsmem+8*nnb),icore(mosymmem+nbasis))
       endif
C
      close(mpfile,status='delete')
      close(diisfile,status='delete')
      close(errfile,status='delete')
      close(scrfile1,status='delete')
      close(scrfile2,status='delete')
      close(scrfile3,status='delete')
      close(scrfile4,status='delete')
      close(tafile,status='delete')
       if(.not.hess) then
         do i=0,nfile
          close(intfile+i,status='delete')
         enddo
       endif
       if(left) close(scrfile6,status='delete')
       if(ptroute.or.eomgrad) then
        close(t1file,status='delete')
        close(l2file,status='delete')
       endif
       if(dipm) close(dipfile,status='delete')
       if(qcc.eq.1) then
        close(scrfile7,status='delete')
       endif
#if defined (Q5Cost)
       if(q5inp) then
        call Q5Cost_deinit(iq5err) 
         if(iq5err.eq.-1) then
          write(iout,*) 'Unable to stop the Q5Cost interface! '
          call mrccend(1)
         endif
       endif
#endif
C
#ifdef MPI
      if(master_thread) then
         lll=.false.
         inquire(file='CCDENSITIES',exist=lll)
#ifdef WINTEL
         if (lll) call ishell('mv CCDENSITIES .. 2>NUL')
         call ishell('cp fort.16 .. 2>NUL')
         call ishell('cp fort.17 .. 2>NUL')
         call ishell('cp fort.63 .. 2>NUL')
#else
         if (lll) call ishell('mv CCDENSITIES .. 2> /dev/null')
         call ishell('cp fort.16 .. 2> /dev/null')
         call ishell('cp fort.17 .. 2> /dev/null')
         call ishell('cp fort.63 .. 2> /dev/null')
#endif
      end if
      open(scrfile2, file = 'files')
      do
         read(scrfile2, *, iostat = ios) c16
         if(ios .ne. 0) exit
         call delete_file(c16, .true.)
      end do
      close(scrfile2)
      call delete_file('files', .true.)
      call delete_file('CCDENSITIES', .true.)
c      if(master_thread) call ishell('cat pids >> ../pids 2> /dev/null')
c      call delete_file('pids', .true.)
#ifdef WINTEL
      call ishell('rm -f fort.* 2>NUL')
#else
      call ishell('rm -f fort.* 2> /dev/null')
#endif
      istat = chdir('..')
      if(.not.master_thread) call delete_file('iface', inbcast)
      write(c8,'(i8)') rank
      call gather_file('mrcc.out.' // trim(adjustl(c8)), MPI_COMM_WORLD)
      call delete_file('mrcc.out.' // trim(adjustl(c8)), .true.)
      call ishell('rmdir mrccdir.' // trim(adjustl(c8)))
#endif
      call mrccend(0)
1000  continue
      write(iout,*) 'Execute goldstone before this program!'
1002  continue
      write(iout,*) 'Input file does not exist!'
      call mrccend(1)
1008  continue
      write(iout,*) 'Formula tape is too old!'
      write(iout,*) 'Execute goldstone before this program!'
      call mrccend(1)
      end
C
************************************************************************
      subroutine intinp(vint,fa,fb,v,maxinc,nbmax,nmax,nstr,intrec,imed,
     $mosym,nnir,isympv,isympo,istr,iwa,nactm,wspcb,wspca,wsmax,intn,
     $noccup,denrec,absind,itypa,itypb,imedsyma,imedsymb,nactd,iorda,
     $iordb,idx1,idx2,vs,inbf,vs2,itrans,ikram,ktos,indk,indl,umat,ha,
     $hb,lfock,scspe)
************************************************************************
* This subroutine reads and sorts integrals and constructs correlation *
* energy operator (temporary)                                          *
************************************************************************
#if defined (Q5Cost)
      use q5cost
      use hdf5
#endif
#include "MRCCCOMMON"
      integer nnir,nbmax,nactm,i,j,k,l,ii,absind(2*nbmax,-3:0),ire,nspc
      integer nmax,irec,mosym(*),jj,kk,nstr,wsmax,iw,intn(*),intrec(*),n
      integer isc,imed(16,1),intl,kkk,noccup(*),istr,ispc,irecold,maxinc
      integer isympv,isympo,iwa,wslen,ssym,ndist,idist,il1,il11,il2,ix
      integer wspcb(0:wsmax,13),wspca(0:wsmax,13),denrec(13),ifile
      integer ncn,ncnt,imedsyma(*),itypa(*),itypb(*),imedsymb(*),diprec
      integer ihm,inbf,nactd(*),iorda(*),iordb(*),itrans(*),iprop
      integer idx1(inbf**2,2),idx2(nbmax**2,4),nhm,ikram(*)
      integer ngrdal,ngrdbt,nungrdal,nungrdbt
      real*8 vint(nbmax,nbmax,nbmax,maxinc),v(inbf**2),vs2(nbmax,nbmax)
      real*8 fa(nbmax,nbmax),fb(nbmax,nbmax),vs(nbmax**2),itol,sum
      real*8 ha(nbmax,nbmax),hb(nbmax,nbmax),scspe
      real*8 umat(*),norm1,norm2
      logical lasym,lll,lfock
      parameter(itol=10d-20)
      character*1 ddir(3)
      character*9 chscr1
      character*32 chscr
      data ddir /'X','Y','Z'/
#if defined (Q5Cost)
      integer iq5err
#endif
C Dirac
      integer ikr,jkr,ktos(-nbmax/2:nbmax/2)
      integer indk(nbmax**2),indl(nbmax**2)
      character(10) dgen
      character(8)  tgen
C Initialize wsfile
       if(nroot.gt.1.and.((calc.eq.0.and.isy1.ne.isy2).or.(left.and.
     $(isym.ne.1.or.eomgrad)))) then
        wslen=iintln*(2*(wsmax+1)+3)
        open(wsfile,status='unknown',access='direct',recl=wslen)
         if(calc.eq.0) then
          il1=iimed
          il2=ccimed
         else
          il1=eomimed
          il2=nimed
         endif
        imedsyma(il1+1:il2)=0
        imedsymb(il1+1:il2)=0
         do i=il1+1,il2
          call wswrite(intrec(i),imedsyma(i),imedsymb(i),wspca(0,i),
     $wspcb(0,i),wsmax+1,i-il1)
         enddo
       endif
C Length of intermediates and structure of intermediate file
      ptfst=0
      irecold=0
      irec=0
C Integral list
c     write(6,*) '@ IN',0,iimed
c hsym,rsym,lsym,csym
      call imedlen(1,isym,isym,ptsym,0,iimed,0,itypa,itypb,wspca,wspcb, 
     $wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
      ccfst=irec
C CC intermediates
c     write(6,*) '@ CC',iimed,ccimed
      call imedlen(1,isym,isym,ptsym,iimed,ccimed,0,itypa,itypb,wspca,
     $wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
      leftfst=irec
C Right-hand LR-CC intermediates
       if(eomcc) then
c     write(6,*) '@ EO',ccimed,eomimed
        call imedlen(1,isym,isym,isym,ccimed,eomimed,0,itypa,itypb,
     $wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
       endif
C Left-hand LR-CC intermediates
       if(left) then
        irecold=max(irec,irecold)
        ssym=isym
         if(.not.eomgrad) irec=leftfst
         if(eomgrad.and.osc) ssym=1
c     write(6,*) '@ LE',eomimed,leftimed
        call imedlen(1,isym,ssym,isym,eomimed,leftimed,0,itypa,itypb,
     $wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
       endif
       if(eomgrad.and.osc.and.nroot.gt.2) leftfst=irec
C Density-matrix intermediates
       if(dens.gt.0.and.(.not.eomgrad)) then
c     write(6,*) '@ DE',leftimed,densimed
        ssym=isym
        kk=isym
         if(calc.eq.0) then
          ssym=ptsym(1)
           if(isy1.ne.isy2) then
            kk=isy1
            ssym=isy2
           endif
           if(dsroute) then
            ssym=ptsym(1)
            kk=ptsym(2)
           endif
         endif
        call imedlen(1,kk,ssym,kk,leftimed,densimed,0,itypa,itypb,
     $wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
       endif
      ptfst=irec
       if(ptroute) then
C T1 intermediates, <K|exp(-T) dH/dx exp(T)|0>
c     write(6,*) '@ T1',d2imed,t1imed
        ssym=mult(isym,ptsym(1))
         if(dsroute.or.dtroute) ssym=denssym
        call imedlen(ssym,ptsym,isym,isym,nimed,t1imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
       endif
       if(dsroute) then
        irecold=max(irec,irecold)
        irec=ptfst
C DS1 intermediates, <0|dL/dx [exp(-T) {p+q-} exp(T), dT/dy]|0>
c     write(6,*) '@ DS1',d1imed,ds1imed
        call imedlen(1,ptsym(2),ptsym(1),1,d1imed,ds1imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,
     $ptsym(2),1)
        irecold=max(irec,irecold)
        irec=ptfst
C DS2 intermediates, <0|(1+L)[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy]|0>
        call imedlen(1,ptsym(1),1,1,d2imed,ds2imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,
     $ptsym(2),1)
       else if(dtroute) then
C DT1 intermediates, <0|dL/dx [[exp(-T) {p+q-} exp(T), dT/dy], dT/dz]|0>
        call imedlen(1,ptsym(1),ptsym(3),1,ds1imed,dt1imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,
     $ptsym(2),ptsym(3))
        irecold=max(irec,irecold)
        irec=ptfst
C DT2 int., <0|(1+L)[[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy], dT/dz]|0>
        call imedlen(1,ptsym(1),1,1,ds2imed,dt2imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,
     $ptsym(2),ptsym(3))
       else
       if(ptroute) then
C L2 intermediates, <0|(1+L) exp(-T) dH/dx exp(T)|K>
c     write(6,*) '@ L2',dt1imed,l2imed
        call imedlen(mult(isym,ptsym(1)),ptsym,isym,isym,dt1imed,l2imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
C T2 intermediates, <K|[exp(-T) H exp(T), dT/dx]|0>
        irecold=max(irec,irecold)
        irec=ptfst
c     write(6,*) '@ T2',t1imed,t2imed
        call imedlen(1,ptsym,isym,isym,t1imed,t2imed,nimed,itypa,itypb
     $,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
       endif
       if(ptroute.or.eomgrad) then
C L3 intermediates, <0|(1+L)[exp(-T) H exp(T), dT/dx]|K>
c     write(6,*) '@ L3',densimed,l3imed
        ssym=isym
        kk=isym
         if(ptroute) ssym=ptsym(1)
         if(eomgrad.and.osc) kk=1
        call imedlen(1,ssym,kk,isym,densimed,l3imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
C D2 intermediates, <0|(1+L)[exp(-T) {p+q-} exp(T), dT/dx]|0>
c     write(6,*) '@ D2',l3imed,d2imed
        call imedlen(1,ssym,kk,isym,l3imed,d2imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
       endif
       if(ptroute) then
C L1 intermediates, <0|dL/dx exp(-T) H exp(T)|K>
        irecold=max(irec,irecold)
        irec=ptfst
c     write(6,*) '@ L1',t2imed,l1imed
        call imedlen(1,ptsym,ptsym,isym,t2imed,l1imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
C D1 intermediates, <0|dL/dx exp(-T) {p+q-} exp(T)|0>
c     write(6,*) '@ D1',l1imed,d1imed
        call imedlen(1,ptsym,ptsym,isym,l1imed,d1imed,
     $nimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,
     $nactm,irec,intrec,nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
       endif
       endif
C Integral lists from diagrams 12 and 13
       if(ptroute) then
        ptsh=nimed
        call diag12(0,i,12, 3,intn,intrec,wspca,denrec,wsmax,imed,
     $.true.)
        call diag12(0,i,13,11,intn,intrec,wspca,denrec,wsmax,imed,
     $.true.)
        call diag12(nimed,drecmax,12, 3,intn,intrec,wspca,denrec,wsmax,
     $imed,.true.)
        call diag12(nimed,drecmax,13,11,intn,intrec,wspca,denrec,wsmax,
     $imed,.true.)
       else
        ptsh=0
        call diag12(0,drecmax,12, 3,intn,intrec,wspca,denrec,wsmax,imed,
     $.true.)
        call diag12(0,drecmax,13,11,intn,intrec,wspca,denrec,wsmax,imed,
     $.true.)
       endif
C
      call wszero(wsmax,wspca,0,nimed2)
      call wszero(wsmax,wspcb,0,nimed2)
C Ground-state (tot. symmetric) lh LR-CC intermediates
       if(nroot.gt.1.and.left.and.(isym.ne.1.or.eomgrad)) then
        irecold=max(irec,irecold)
        irec=leftfst
        call wschange(wspca,wspcb,wsmax,intrec,imedsyma,imedsymb)
        ssym=1
         if(eomgrad.and.osc) ssym=isym
C Left-hand LR-CC intermediates for tot.sym. L amplitudes
        call imedlen(1,1,ssym,isym,eomimed,leftimed,0,itypa,itypb,wspca,
     $wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,nstr,
     $denrec,ptfst,intn,imedsyma,imedsymb,1,1)
C LR-CC density-matrix intermediates
         if(eomgrad)
     $call imedlen(1,1,ssym,isym,leftimed,densimed,0,itypa,itypb,
     $wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
        call wszero(wsmax,wspca,eomimed,nimed2)
        call wszero(wsmax,wspcb,eomimed,nimed2)
         if(eomgrad.and.osc) call wschange(wspca,wspcb,wsmax,intrec,
     $imedsyma,imedsymb)
       endif
C Ground-state CI "intermediates"
       if(calc.eq.0.and.isy1.ne.isy2) then
        irecold=max(irec,irecold)
        irec=ccfst
        call wschange(wspca,wspcb,wsmax,intrec,imedsyma,imedsymb)
        call imedlen(1,isy1,isy1,isy1,iimed,ccimed,0,itypa,itypb,wspca,
     $wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,ptfst,intn,imedsyma,imedsymb,1,1)
        call wszero(wsmax,wspca,iimed,ccimed)
        call wszero(wsmax,wspcb,iimed,ccimed)
c       isym=isy1
       endif
C
c     write(6,*) 'imedsym'
c      do i=1,nimed3
c       write(6,*) i,imedsyma(i),imedsymb(i),'   ',itypa(i),itypb(i)
c      enddo
      insym=1
       if(ptroute) then
        insym=isym
         do i=1,npert
          insym=mult(insym,ptsym(i))
         enddo
       endif
C Initialize integral file
      irec=max(irec,irecold)
      maxrec=irec
      sum=dble(irec)*dble(ifltln)*dble(ibufln)/dble(twoto20)
      write(iout,113) sum
113   format(' Length of intermediate file (Mbytes): ',f9.1)
      call dfillzero(ibuf,ibufln)
      j=mod(irec,recmax)
      nfile=(irec-j)/recmax
      jj=intfile
       do k=1,nfile
        open(intfile+k,status='unknown',access='direct',recl=irecln)
       enddo
       if(.not.ptroute) ptfst=0
C No integral sort if rest is negative
       if(rest.lt.0) then
        write(iout,"(' Old integral file, unit',i3,' is used.')")intfile
        eref=0.d0
        nuc=0.d0
        return
       endif
C
      l=mod(ptfst,recmax)
      ifile=(ptfst-l)/recmax
       do k=ifile+1,nfile
         if(k.eq.ifile+1) then
           do i=l+1,recmax
            write(jj,rec=i) ibuf
           enddo
         else
           do i=1,recmax
            write(jj,rec=i) ibuf
           enddo
         endif
        jj=jj+1
       enddo
       if(ptroute.and.ifile.eq.0) then
         do i=l+1,j+1    !(1-for the above sorting algorithm)
          write(jj,rec=i) ibuf
         enddo
       else
         do i=1,j+1    !(1-for the above sorting algorithm)
          write(jj,rec=i) ibuf
         enddo
       endif
       if(dsroute.or.dtroute) then
        goto 5384
       endif
C Reading and sorting integrals
#if defined (Q5Cost)
       if(q5inp) then
        call Q5Cost_System_get_nuc_energy(q5file,nuc,iq5err)
         if(iq5err.eq.-1) then
          write(iout,*) 
     $'Unable to read nuclear repulsion energy from Q5Cost file! '
          call mrccend(1)
         endif
        call dfillzero(vs2,nbmax**2)
       endif
#endif
      rewind(scrfile1)
       if(rel.eq.2) then
        write(iout,"(
     $' Reading integral list from files MRCONEE and MDCINT...')")
       else
        write(iout,"(' Reading integral list from unit',i3,'...')") inp
       endif
      call dfillzero(fa,nbmax**2)
      call dfillzero(ha,nbmax**2)
      k=mod(nbmax,maxinc)
       if(k.ne.0) then
        kk=k
        k=maxinc-k
       else
        kk=maxinc
       endif
      ndist=(nbmax+k)/maxinc
       if(ndist.gt.1) 
     $write(iout,*) 'Warning! Executing out-of-core algorithm!'
      nspc=1
       if(.not.spatial) nspc=4
      ncnt=0
       do ispc=1,nspc
      il2=0
       do idist=1,ndist
         if(ndist.gt.1) write(iout,
     $"(' Reading integral list: cycle',i3,' of',i3)") idist,ndist
        call flush(iout)
c       call timer
        ncn=1
        il1=il2+1
        il11=il1-1
         if(idist.eq.ndist) then
          kkk=kk
         else
          kkk=maxinc
         endif
        il2=il2+kkk
         if(q5inp) then
          i=1
         else
          rewind(inp)
           if(ptroute) read(inp,*) i
          read(inp,*) i,j
          read(inp,*) (i,j=1,nbmax)
           if(ptroute) then
            read(inp,*) i,i
            read(inp,*) (i,j=1,nir)
           endif
           if(locno.gt.0) then
            read(inp,*) i,(umat(j),j=1,nocc/2)
c           call dfillzero(umat,nocc/2)
c           umat(locno)=1.d0
           else
            read(inp,*) i
           endif
         endif
        lasym=.true.
         if(ptroute.and.i.lt.0) nmr=.true.
         if((.not.spatial).and.(i.eq.0.or.i.eq.-1)) lasym=.false.
c       rel=.false.
c        if(i.eq.-2.or.i.eq.-3) rel=.true.
C Mapping of Kramers pairs
         if(rel.eq.2) then
          read(inp,*) ii
           do i=1,ii
            read(inp,*) (jj,j=1,ii)
           enddo
C
           if(ii/2.eq.4) then
            read(inp,*) ngrdal,ngrdbt,nungrdal,nungrdbt
           elseif(ii/2.eq.2) then
            read(inp,*) ngrdal,ngrdbt
            nungrdal = 0
            nungrdbt = 0
           else
            write(iout,*)'Check the inputfile for the no. g/u orbitals!'
           endif
C
          ii=nungrdal+nungrdbt
          jj=ngrdal+ngrdbt
           if(nbasis/2.ne.(jj+ii)) then
            write(iout,*)'Check the inputfile for the no. g/u orbitals!'
            call mrccend(1)
           endif
C
           if(mod(jj,2).eq.0.and.mod(ii,2).eq.0) then
              do j=1,jj/2
               ikram(j)=jj/2+j
               ikram(jj/2+j)=j
              enddo
              do j=jj+1,jj+ii/2
               ikram(j)=ii/2+j
               ikram(ii/2+j)=j
               enddo
C         write(6,*) (ikram(j),j=1,nbasis/2)
           elseif(mod(jj,2).eq.0)then
              do j=1,jj/2
               ikram(j)=jj/2+j
               ikram(jj/2+j)=j
              enddo
             if(nungrdal.gt.nungrdbt)then
              do j=jj+1,jj+ii/2-1
               ikram(j)=ii/2+j
               ikram(ii/2+j)=j
               enddo
             else
             do j=jj+1,jj+ii/2-1
               ikram(j)=ii/2+j
               ikram(ii/2+j)=j
               enddo
             endif
           endif
         else
           do j=1,nbasis
            ikram(j)=j
           enddo
         endif
         if(.not.q5inp) then
           do i=1,ncnt
            read(inp,*)
           enddo
         endif
        call dfillzero(vint,kkk*nbmax**3)
c     write(6,*) 'lasym',lasym
C Two-electron part
       if(rel.eq.2) then
C Dirac
        open(mdcintfile,file='MDCINT',form='UNFORMATTED')
        read(mdcintfile) dgen,tgen,n,(ktos(i),ktos(-i),i=1,nbmax/2)
C
        read(mdcintfile) ikr
         do
           do while((ktos(ikr).lt.il1.or.ktos(ikr).gt.il2).and.
     $((ikram(ktos(ikr)).lt.il1.or.ikram(ktos(ikr)).gt.il2)))
            read(mdcintfile) ikr
             if(ikr.eq.0) exit
           enddo
           if(ikr.eq.0) exit
          backspace(mdcintfile)
           do while((ktos(ikr).ge.il1.and.ktos(ikr).le.il2).or.
     $((ikram(ktos(ikr)).ge.il1.and.ikram(ktos(ikr)).le.il2)))
          read(mdcintfile) ikr,jkr,n,(indk(ii),indl(ii),ii=1,n),
     $(vs(ii),ii=1,n)
           if(ikr.eq.0) exit
           do ii=1,n
            sum=vs(ii)
            i=ktos(ikr)
            j=ktos(jkr)
            k=ktos(indk(ii))
            l=ktos(indl(ii))
             if(i.ge.il1.and.i.le.il2) vint(k,j,l,i-il11)=sum
c            if(j.ge.il1.and.j.le.il2) vint(l,i,k,j-il11)=sum
c            if(k.ge.il1.and.k.le.il2) vint(i,l,j,k-il11)=sum
c            if(l.ge.il1.and.l.le.il2) vint(j,k,i,l-il11)=sum
            i=ikram(i)
            k=ikram(k)
            j=ikram(j)
            l=ikram(l)
             if(i.ge.il1.and.i.le.il2) vint(k,j,l,i-il11)=sum
c            if(j.ge.il1.and.j.le.il2) vint(l,i,k,j-il11)=sum
c            if(k.ge.il1.and.k.le.il2) vint(i,l,j,k-il11)=sum
c            if(l.ge.il1.and.l.le.il2) vint(j,k,i,l-il11)=sum
           enddo
           enddo
           if(ikr.eq.0) exit
         enddo
C
        close(mdcintfile)
        l=0
       else
        read(inp,*) sum,i,j,k,l
       endif
C NMR: vint(i,k,j,l) = -vint(j,l,i,k) = vint(k,i,l,j) = -vint(l,j,k,i)
       if(nmr) then
         if(lasym.or.ispc.ge.3) then
           do while(l.ne.0)
             if(dabs(sum).gt.itol.and.mult(mult(mosym(i),mosym(j)),
     $mult(mosym(k),mosym(l))).eq.insym) then
               if(ispc.eq.4) then
                ii=i
                i=k
                k=ii
                ii=j
                j=l
                l=ii
               endif
               if(i.ge.il1.and.i.le.il2) vint(k,j,l,i-il11)=sum
               if(j.ge.il1.and.j.le.il2) vint(l,i,k,j-il11)=-sum
               if(spatial.or.ispc.lt.3) then
                 if(k.ge.il1.and.k.le.il2) vint(i,l,j,k-il11)=sum
                 if(l.ge.il1.and.l.le.il2) vint(j,k,i,l-il11)=-sum
               endif
             endif
            read(inp,*) sum,i,j,k,l
            ncn=ncn+1
           enddo
         else
           do while(l.ne.0)
             if(dabs(sum).gt.itol.and.mult(mult(mosym(i),mosym(j)),
     $mult(mosym(k),mosym(l))).eq.insym) then
               if(ispc.eq.4) then
                ii=i
                i=k
                k=ii
                ii=j
                j=l
                l=ii
               endif
               if(i.ge.il1.and.i.le.il2) then
                vint(k,j,l,i-il11)=sum
                vint(k,l,j,i-il11)=-sum
               endif
               if(j.ge.il1.and.j.le.il2) then
                vint(l,i,k,j-il11)=-sum
                vint(l,k,i,j-il11)=sum
               endif
               if(k.ge.il1.and.k.le.il2) then
                vint(i,l,j,k-il11)=sum
                vint(i,j,l,k-il11)=-sum
               endif
               if(l.ge.il1.and.l.le.il2) then
                vint(j,k,i,l-il11)=-sum
                vint(j,i,k,l-il11)=sum
               endif
             endif
            read(inp,*) sum,i,j,k,l
            ncn=ncn+1
           enddo
         endif
       else
         if(lasym.or.ispc.ge.3) then
           if(q5inp) then
            ncn=0
            nhm=nbmax**2
           else
            nhm=1
           endif
c     nhm=0 !q5szemet
           do while((l.ne.0.and..not.q5inp).or.
     $(q5inp.and.nhm.eq.nbmax**2))
             if(q5inp) then
#if defined (Q5Cost)
              call Q5Cost_MOTwoInt_read(q5file,ncn,nhm,idx2,vs,iq5err)
               if(iq5err.eq.-1) then
                write(iout,*) 
     $'Unable to read two-electron integrals from Q5Cost file! '
                call mrccend(1)
               endif
              ncn=ncn+nhm
#endif
             endif
             do ihm=1,nhm
               if(q5inp) then
                i=idx2(ihm,1) !q5szemet ???????????????????????????
                j=idx2(ihm,2) !q5szemet ???????????????????????????
                k=idx2(ihm,3) !q5szemet ???????????????????????????
                l=idx2(ihm,4) !q5szemet ???????????????????????????
                sum=vs(ihm)
                call freeze(i,j,k,l,itrans,nuc,sum,vs2,lll,nbmax)
               else
                lll=.true.
               endif
               if(lll) then
                 if(dabs(sum).gt.itol.and.mult(mult(mosym(ikram(i)),
     $mosym(j)),mult(mosym(ikram(k)),mosym(l))).eq.insym) then
                   if(ispc.eq.4) then
                    ii=i
                    i=k
                    k=ii
                    ii=j
                    j=l
                    l=ii
                   endif
C Relativistic: vint(i,k,j,l)=vint(j,l,i,k)=vint(k,i,l,j)=vint(l,j,k,i)
                   if(rel.gt.0) then
                     if(i.ge.il1.and.i.le.il2) then
                      vint(k,j,l,i-il11)=sum
                     endif
                     if(j.ge.il1.and.j.le.il2) then
                      vint(l,i,k,j-il11)=sum
                     endif
                     if(k.ge.il1.and.k.le.il2) then
                      vint(i,l,j,k-il11)=sum
                     endif
                     if(l.ge.il1.and.l.le.il2) then
                      vint(j,k,i,l-il11)=sum
                     endif
                    i=ikram(i)
                    k=ikram(k)
                    j=ikram(j)
                    l=ikram(l)
                     if(i.ge.il1.and.i.le.il2) then
                      vint(k,j,l,i-il11)=sum
                     endif
                     if(j.ge.il1.and.j.le.il2) then
                      vint(l,i,k,j-il11)=sum
                     endif
                     if(k.ge.il1.and.k.le.il2) then
                      vint(i,l,j,k-il11)=sum
                     endif
                     if(l.ge.il1.and.l.le.il2) then
                      vint(j,k,i,l-il11)=sum
                     endif
                   else
                     if(i.ge.il1.and.i.le.il2) then
                      vint(k,j,l,i-il11)=sum
                      vint(l,j,k,i-il11)=sum
                     endif
                     if(j.ge.il1.and.j.le.il2) then
                      vint(l,i,k,j-il11)=sum
                      vint(k,i,l,j-il11)=sum
                     endif
                     if(spatial.or.ispc.lt.3) then
                       if(k.ge.il1.and.k.le.il2) then
                        vint(i,l,j,k-il11)=sum
                        vint(j,l,i,k-il11)=sum
                       endif
                       if(l.ge.il1.and.l.le.il2) then
                        vint(i,k,j,l-il11)=sum
                        vint(j,k,i,l-il11)=sum
                       endif
                     endif
                   endif
                 endif
               endif
             enddo
             if(.not.q5inp) then
              read(inp,*) sum,i,j,k,l
              ncn=ncn+1 
             endif
           enddo
         else
           do while(l.ne.0)
             if(dabs(sum).gt.itol.and.mult(mult(mosym(i),mosym(j)),
     $mult(mosym(k),mosym(l))).eq.insym) then
               if(ispc.eq.4) then
                ii=i
                i=k
                k=ii
                ii=j
                j=l
                l=ii
               endif
               if(i.ge.il1.and.i.le.il2) then
                vint(k,j,l,i-il11)=sum
                vint(k,l,j,i-il11)=-sum
               endif
               if(j.ge.il1.and.j.le.il2) then
                vint(l,i,k,j-il11)=sum
                vint(l,k,i,j-il11)=-sum
               endif
               if(k.ge.il1.and.k.le.il2) then
                vint(i,l,j,k-il11)=sum
                vint(i,j,l,k-il11)=-sum
               endif
               if(l.ge.il1.and.l.le.il2) then
                vint(j,k,i,l-il11)=sum
                vint(j,i,k,l-il11)=-sum
               endif
             endif
            read(inp,*) sum,i,j,k,l
            ncn=ncn+1 
           enddo
         endif
       endif
       if(calc.eq.0.or.conver.eq.1.or.eomcc) then
         if(ispc.le.2) then
           if(lasym) then
             do ii=1,kkk
              write(scrfile1) (vint(l,ii+il11,l,ii)-vint(l,l,ii+il11,ii)
     $,l=1,nbmax)
             enddo
           else
             do ii=1,kkk
              write(scrfile1) (vint(l,ii+il11,l,ii),l=1,nbmax)
             enddo
           endif
         endif
         if(spatial.or.ispc.eq.3) then
           do ii=1,kkk
             do l=1,nbmax
              fa(ii+il11,l)=vint(l,ii+il11,l,ii)
             enddo
           enddo
         endif
       endif
C One-electron part
       if(idist.eq.ndist.and.ispc.eq.nspc) then
         if(calc.eq.0.or.conver.eq.1.or.eomcc) write(scrfile1) fa
         if(q5inp) then
          call dcp(vs2,fa,nbmax**2)
         else
          call dfillzero(fa,nbmax**2)
          call dfillzero(ha,nbmax**2)
         endif
         if(q5inp) then
#if defined (Q5Cost)
          ii=inbf**2
          call Q5Cost_MOOneInt_read(q5file,0,ii,idx1,v,iq5err)
           if(iq5err.eq.-1) then
            write(iout,*) 
     $'Unable to read one-electron integrals from Q5Cost file! '
            call mrccend(1)
           endif
c         write(6,*) 'ii',ii
           do l=1,ii
            i=idx1(l,1) !q5szemet ???????????????????????????????????
            j=idx1(l,2) !q5szemet ???????????????????????????????????
            sum=v(l)
c     write(6,"(2i3,f14.8)") i,j,sum
             if(itrans(i).eq.0.or.itrans(j).eq.0.and.i.eq.j) then
              nuc=nuc+2.d0*sum
             else if(itrans(i)*itrans(j).ne.0) then
              i=itrans(i)
              j=itrans(j)
               if(dabs(sum).gt.itol.and.mult(mosym(i),mosym(j)).eq.insym
     $) then
                fa(i,j)=fa(i,j)+sum
                 if(i.ne.j) then
                   if(nmr) then
                    fa(j,i)=fa(i,j)-sum
                   else
                    fa(j,i)=fa(i,j)+sum
                   endif
                 endif
               endif
             endif
           enddo
#endif
         else
           if(rel.eq.2) then
C Dirac
            open(mrconeefile,file='MRCONEE',form='UNFORMATTED')
             if(lfock) then
              read(mrconeefile) n,lll,nuc,i,j,sum,k,eref
             else
              read(mrconeefile) n,lll,nuc,i,j,sum,k
             endif
            read(mrconeefile) 
            read(mrconeefile) 
            read(mrconeefile) 
             if(lfock) then
              read(mrconeefile) (j,j,fa(i,i),i=1,nbmax)
             else
              read(mrconeefile) 
              read(mrconeefile) ((fa(i,j),sum,i=1,nbmax),j=1,nbmax)
             endif
            close(mrconeefile)
           else
             if(.not.spatial) read(inp,*) sum,i,j,k,l
             do while(i.ne.0)
             if(dabs(sum).gt.itol.and.mult(mosym(ikram(i)),mosym(j)).eq.
     $insym) then
                fa(i,j)=sum
                 if(nmr) then
                  fa(j,i)=-sum
                 else 
                  fa(j,i)=sum
                 endif
               endif
              read(inp,*) sum,i,j,k,l
             enddo
             if(.not.spatial) then
              call dfillzero(fb,nbmax**2)
              call dfillzero(hb,nbmax**2)
              read(inp,*) sum,i,j,k,l
               do while(i.ne.0)
                 if(dabs(sum).gt.itol.and.mult(mosym(ikram(i)),mosym(j))
     $.eq.insym) then
                  fb(i,j)=sum
                   if(nmr) then
                    fb(j,i)=-sum
                   else 
                    fb(j,i)=sum
                   endif
                 endif
                read(inp,*) sum,i,j,k,l
               enddo
              read(inp,*) sum,i,j,k,l
             endif
            nuc=sum
           endif
         endif
       endif
C Sort integral lists
      call intwrt(vint,fa,fb,maxinc,nbmax,nmax,nstr,intrec,imed,
     $nnir,isympv,isympo,istr,iwa,nactm,wspcb,wspca,wsmax,intn,absind,
     $lasym,insym,ptsh,il1,il2,il11,idist,ndist,ispc,nspc,iimed,.true.,
     $intfile,noccup,lfock,ha,hb)
         if(idist.eq.ndist.and.ispc.eq.nspc) then
           if(calc.eq.0.or.conver.eq.1.or.eomcc) then
            write(scrfile1) (ha(i,i),i=1,nbmax)
             if(.not.spatial) write(scrfile1) (hb(i,i),i=1,nbmax)
           endif
         endif
       enddo !ndist
         if(ispc.le.2) ncnt=ncnt+ncn
       enddo !nspc
C
       if(nmr) then
         do i=ptsh+1,ptsh+iimed
           if(intn(i-ptsh).eq.2.or.
     $        intn(i-ptsh).eq.5.or.
     $        intn(i-ptsh).eq.6.or.
     $        intn(i-ptsh).eq.8.or.
     $        intn(i-ptsh).eq.9.or.
     $        intn(i-ptsh).eq.10) then
             do iw=1,wspca(0,i)
              ire=intrec(i)+wspca((iw-1)*12+11,i)
              kk=wspca((iw-1)*12+12,i)
              call getlst(intfile,ire,v(1),kk)
              call add(v(1),v(1),kk,0,-1,1.d0,scspe)
              call putlst(intfile,ire,v(1),kk)
             enddo
           endif
         enddo
       endif
C
C PRINTING OUT integral lists
c      do i=ptsh+1,ptsh+11
c       write(6,*) 'list',i-ptsh,wspca(0,i)
c        do iw=1,wspca(0,i)
c         ire=intrec(i)+wspca((iw-1)*12+11,i)
c         kk=wspca((iw-1)*12+12,i)
c         call getlst(intfile,ire,v(1),kk)
c         write(6,"(4f14.8)") (v(j),j=1,kk)
c         write(6,*)
c        enddo
c      enddo
C Hartree-Fock (reference determinant) energy
       if(rel.ne.2.or..not.lfock) then
         if(lfock.and.rel.ne.2) then
           if(locno.gt.0) then
            eref=0.d0
           else
            call getvar('eref      ',eref)
           endif
         else
          call refener(v,imed,wspca,wsmax,intrec,istr,nnir,nactm,nmax,
     $absind,ha,hb,nbmax,nstr,intn)
         endif
       endif
C Read mapping vectors
5384  continue
c      if(rel.ne.2) then
         do i=1,nbmax
          iorda(i)=i
          iordb(i)=i
         enddo
       if(rel.ne.2) then
        read(inp,*,end=6899) (iorda(i),i=1,nbmax)
        read(inp,*,end=6899) (iordb(i),i=1,nbmax)
       endif
       if(dens.eq.0.or.hess) return
C Try to read property integrals
       if(rel.eq.2) then
        inquire(file='MDPROP',exist=lll)
         if(lll) then
          open(mrconeefile,file='MDPROP',form='UNFORMATTED')
           if(nprop.eq.0) goto 6899
          dipm=.true.
          write(iout,"(
     $' Reading property integrals from file MDPROP...')")
          call dfillzero(dipc,3*nprop)
          call dfillzero(dipn,3*nprop)
         else
          return
         endif
       else
        nprop=1
        propnm(1)='-DIP    '
        read(inp,*,end=6899) sum,i,j,k,l
        backspace(inp)
        dipm=.true.
       endif
      open(dipfile,status='unknown',access='direct',recl=irecln)
       if(calc.ne.0) ptsh=nimed2
C Length of property integrals
      diprec=0
      irecold=0
       do i=1,3*nprop
        call imedlen(denssym,1,1,1,nimed+(i-1)*iimed,nimed+i*iimed,
     $nimed+(i-1)*iimed,itypa,itypb,wspca,wspcb,wsmax,imed,nmax,nnir,
     $isympv,isympo,nactm,diprec,intrec,nstr,denrec,irecold,intn,
     $imedsyma,imedsymb,1,1)
        call diag12(nimed+(i-1)*iimed,drecmax,12, 3,intn,intrec,wspca,
     $denrec,wsmax,imed,.true.)
        call diag12(nimed+(i-1)*iimed,drecmax,13,11,intn,intrec,wspca,
     $denrec,wsmax,imed,.true.)
        irecold=diprec
       enddo
      call wszero(wsmax,wspca,nimed2,nimed3)
      call wszero(wsmax,wspcb,nimed2,nimed3)
C Initialize property integral file
      write(iout,
     $"(' Length of property integral file (Mbytes): ',f9.1)")
     $dble(diprec)*dble(ifltln)*dble(ibufln)/dble(twoto20)
      call dfillzero(ibuf,ibufln)
       do i=1,diprec
        write(dipfile,rec=i) ibuf
       enddo
C Reading and sorting property integrals
       do iprop=1,nprop
         do ix=1,3
          call dfillzero(fa,nbmax**2)
          chscr='                                '
           if(rel.eq.2) then
            rewind(mrconeefile)
             do while(chscr(26:32).ne.propnm(iprop).or.
     $                chscr(25:25).ne.ddir(ix))
              read(mrconeefile,end=7463) chscr
             enddo
            read(mrconeefile) ((fa(i,j),fb(i,j),i=1,nbmax),j=1,nbmax)
c          write(6,"(i1,' ',a2,100000f10.6)") ix,'fa',fa
c          write(6,"(i1,' ',a2,100000f10.6)") ix,'fb',fb
            call scalprod(fa,fa,nbmax**2,norm1)
            call scalprod(fb,fb,nbmax**2,norm2)
             if(norm2.gt.norm1) call dcp(fb,fa,nbmax**2)
C Rearrange integrals for hyperfine and anapole interaction operators
             if((chscr(28:30).eq.'HYP'.or.chscr(28:30).eq.'ANA').and.
     $ix.ne.3) then
               do i=1,nbmax
                 do j=1,nbmax/2
                  l=j+nbmax/2
                  sum=fa(i,j)
                  fa(i,j)=fa(i,l)
C                  if(ix.eq.2) then
                   if(norm1.gt.norm2) then
                    fa(i,l)=sum
                   else
                    fa(i,l)=-sum
                   endif
                 enddo
               enddo
             endif
7463      continue
            sum=0.d0
           else
            chscr(25:32)=ddir(ix) // propnm(iprop)
            read(inp,*) sum,i,j,k,l
             do while(i.ne.0)
               if(dabs(sum).gt.itol.and.mult(mosym(ikram(i)),mosym(j))
     $.eq.denssym) then
                fa(i,j)=sum
                fa(j,i)=sum
               endif
              read(inp,*) sum,i,j,k,l
             enddo
            dipc(ix,iprop)=sum
            read(inp,*) dipn(ix,iprop),i,j,k,l
             if(.not.spatial) then
              call dfillzero(fb,nbmax**2)
              read(inp,*) sum,i,j,k,l
               do while(i.ne.0)
                 if(dabs(sum).gt.itol.and.mult(mosym(ikram(i)),mosym(j))
     $.eq.denssym) then
                  fb(i,j)=sum
                  fb(j,i)=sum
                 endif
                read(inp,*) sum,i,j,k,l
               enddo
              read(inp,*) dipn(ix,iprop),i,j,k,l
             endif
            sum=0.d0
           endif
C Core, nuclear, and reference contribution
           do i=1,nbasis/2
             if(noccup(i).ge.1) sum=sum+fa(i,i)
             if(noccup(i).eq.-1.or.noccup(i).eq.2) sum=sum+fb(i,i)
           enddo
          dipc(ix,iprop)=dipc(ix,iprop)+sum
          chscr1=trim(chscr(25:32)) // ':'
          write(iout,"(a40,f19.12)")
     $' Property value for ref. det., ' // chscr1,dipc(ix,iprop)+
     $                                            dipn(ix,iprop)
C
      call intwrt(vint,fa,fb,maxinc,nbmax,nmax,nstr,intrec,imed,
     $nnir,isympv,isympo,istr,iwa,nactm,wspcb,wspca,wsmax,intn,absind,
     $lasym,denssym,nimed+(3*(iprop-1)+(ix-1))*iimed,1,nbasis,0,ndist,
     $ndist,nspc,nspc,i1med,.false.,dipfile,noccup,.false.,fa,fb)
         enddo
       enddo
       if(rel.eq.2) close(mrconeefile)
c      do i=nimed2+2*iimed+1,nimed2+3*iimed
c       write(6,*) 'dip list',i-nimed2-2*iimed
c        do iw=1,wspca(0,i)
c         ire=intrec(i)+wspca((iw-1)*12+11,i)
c         kk=wspca((iw-1)*12+12,i)
c         call getlst(dipfile,ire,v(1),kk)
c         write(6,"(4f14.8)") (v(j),j=1,kk)
c         write(6,*)
c        enddo
c      enddo
c     write(6,*) 'dipc',dipc
c     write(6,*) 'dipn',dipn
c     write(6,*) 'dip ',(dipn(i)+dipc(i),i=1,3)
C
6899  continue
       if(osc.and.(.not.dipm)) then
        write(iout,*) 'Property integrals are missing! '
        write(iout,*) 'Unable to calculate transition moments! '
        call mrccend(1)
       endif
C
      return
      end
C
************************************************************************
      subroutine gconfig(nvstral,nvstrbe,nostral,nostrbe,nconf,iarc,tsp,
     $nmax,nnir,ivstral,ivstrbe,iostral,iostrbe,mosym,nb,isympv,isympo,
     $ita,tarec,nactm,econf,earec,trec,erec,trec2,erec2,tcase,ntcase,
     $ivrecal,ivrecbe,iorecal,iorecbe,itrecva,itrecvb,itrecoa,itrecob,
     $iarcrec)
************************************************************************
* This subroutine generates virtual and occupied excitation operator   *
* strings and their lexical indices.                                   *
* For references see e.g. J. Phys. A 18, 3283 (1985); Adv. Quant. Chem.*
* 34, 143 (1999).                                                      *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,nb,ii,mosym(nb,4),nact,nactm,nacta,nactb,ntcase
      integer nvstral(nnir,0:nactm,0:nmax),nvstrbe(nnir,0:nactm,0:nmax)
      integer nostral(nnir,0:nactm,0:nmax),nostrbe(nnir,0:nactm,0:nmax)
      integer ivstral(nnir,0:nactm,0:nmax),ivstrbe(nnir,0:nactm,0:nmax)
      integer iostral(nnir,0:nactm,0:nmax),iostrbe(nnir,0:nactm,0:nmax)
      integer iactv,iacto,iactva,iactvb,minva,minvb
      integer nconf((nactm+1)**4*(nmax+1)**2,*)
      integer trec((nactm+1)**4*(nmax+1)**2,*)
      integer tarec((nactm+1)**4*(nmax+1)**2,*)
      integer trec2((2*nactm+1)**2*(nmax+1),*)
      integer iarc(0:nactm,0:nmax,4),iactoa,econf,earec
      integer tsp(0:2*(nmax+1)**2,0:nmax),nex,i,j,k,m,isum,istr2mem,ir1
      integer isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,iactob
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer ita(nnir,nnir,nnir,nnir),erec,erec2,tcase
      integer ivrecal(nnir,0:nactm,0:nmax),ivrecbe(nnir,0:nactm,0:nmax)
      integer iorecal(nnir,0:nactm,0:nmax),iorecbe(nnir,0:nactm,0:nmax)
      integer itrecva(2,0:nactm,0:nmax),itrecvb(2,0:nactm,0:nmax)
      integer itrecoa(2,0:nactm,0:nmax),itrecob(2,0:nactm,0:nmax)
      integer iarcrec(0:nactm,0:nmax,4)
C
      write(iout,*) 'Construction of occupation graphs...'
       do i=0,op
        read(gfile,*) tsp(0,i),(tsp(j,i),j=1,2*tsp(0,i))
       enddo
      i=(oo+1)*nir*(nactm+1)
      call ifillzero(nvstral,i)
      call ifillzero(nvstrbe,i)
      call ifillzero(nostral,i)
      call ifillzero(nostrbe,i)
      i=(oo+1)**2*nir*(nir+1)*2*(nactm+1)**2
      call ifillzero(isympv,i)
      call ifillzero(isympo,i)
      i=2*(nmax+1)*(nactm+1)
      call ifillzero(itrecva,i)
      call ifillzero(itrecvb,i)
      call ifillzero(itrecoa,i)
      call ifillzero(itrecob,i)
      istrc=1
      minva=max(min(op,nvirtal,nal),2)
      minvb=max(min(op,nvirtbe,nbe),2)
C Virtual alpha strings
       do nex=0,minva
         do nact=max(0,nex-mrop2,nex-nvirtal+nactva),min(nactva,nex)
        call getmem((nvirtal+1)*(nex+1),icore(1),iarc(nact,nex,1))
        call occgraph(nvirtal,nex,icore(iarc(nact,nex,1)),
     $nvstral(1,nact,nex),ivstral(1,nact,nex),mosym(1,1),nactva,nact,
     $.true.,ivrecal(1,nact,nex),itrecva(1,nact,nex),
     $iarcrec(nact,nex,1))
           if(nex.le.2) then
             do ir=1,nir
              call getmem(nvstral(ir,nact,nex)*nex,icore(1),istr2mem)
               do i=0,nvstral(ir,nact,nex)*nex-1
                icore(istr2mem+i)=icore(ivstral(ir,nact,nex)+i)
               enddo
              ivstral(ir,nact,nex)=istr2mem
             enddo
           endif
         enddo
       enddo
C Virtual beta strings
       if(cs.and.nvirtal.eq.nvirtbe.and.minvirtal2.eq.minvirtbe2.and.
     $nactva.eq.nactvb) then
         do nex=0,minvb
           do nact=max(0,nex-mrop2),min(nactvb,nex)
            iarc(nact,nex,2)=iarc(nact,nex,1)
            iarcrec(nact,nex,2)=iarcrec(nact,nex,1)
            itrecvb(1,nact,nex)=itrecva(1,nact,nex)
            itrecvb(2,nact,nex)=itrecva(2,nact,nex)
             do ir=1,nir
              nvstrbe(ir,nact,nex)=nvstral(ir,nact,nex)
              ivstrbe(ir,nact,nex)=ivstral(ir,nact,nex)
              ivrecbe(ir,nact,nex)=ivrecal(ir,nact,nex)
             enddo
           enddo
         enddo
       else
         do nex=0,minvb
           do nact=max(0,nex-mrop2,nex-nvirtbe+nactvb),min(nactvb,nex)
            call getmem((nvirtbe+1)*(nex+1),icore(1),iarc(nact,nex,2))
            call occgraph(nvirtbe,nex,icore(iarc(nact,nex,2)),
     $nvstrbe(1,nact,nex),ivstrbe(1,nact,nex),mosym(1,2),nactvb,nact,
     $.true.,ivrecbe(1,nact,nex),itrecvb(1,nact,nex),
     $iarcrec(nact,nex,2))
             if(nex.le.2) then
               do ir=1,nir
                call getmem(nvstrbe(ir,nact,nex)*nex,icore(1),istr2mem)
                 do i=0,nvstrbe(ir,nact,nex)*nex-1
                  icore(istr2mem+i)=icore(ivstrbe(ir,nact,nex)+i)
                 enddo
                ivstrbe(ir,nact,nex)=istr2mem
               enddo
             endif
           enddo
         enddo
       endif
C Symmetry pairs for virtual strings
       do i=0,minva
         do nacta=max(0,i-mrop2),min(nactva,i)
           do j=0,minvb
             do nactb=max(0,j-mrop2),min(nactvb,j)
               if(i+j-mrop2.le.nacta+nactb) then
               do ir=1,nir
                isum=0
                 do irv=1,nir
                   if(nvstral(isympair(ir,irv,1),nacta,i).gt.0.and.
     $                nvstrbe(isympair(ir,irv,2),nactb,j).gt.0) then
                    isum=isum+1
                    isympv(isum,ir,nacta,nactb,i,j,1)=isympair(ir,irv,1)
                    isympv(isum,ir,nacta,nactb,i,j,2)=isympair(ir,irv,2)
                   endif
                 enddo
                isympv(0,ir,nacta,nactb,i,j,1)=isum
               enddo
               endif
             enddo
           enddo
         enddo
       enddo
C Occupied alpha strings
       do nex=0,minoccal2
         do nact=max(0,nex-mrop2,nex-nal+nactoa),min(nactoa,nex)
          call getmem((nal+1)*(nex+1),icore(1),iarc(nact,nex,3))
          call occgraph(nal,nex,icore(iarc(nact,nex,3)),
     $nostral(1,nact,nex),iostral(1,nact,nex),mosym(1,3),nactoa,nact,
     $.false.,iorecal(1,nact,nex),itrecoa(1,nact,nex),
     $iarcrec(nact,nex,3))
           if(nex.le.2) then
             do ir=1,nir
              call getmem(nostral(ir,nact,nex)*nex,icore(1),istr2mem)
               do i=0,nostral(ir,nact,nex)*nex-1
                icore(istr2mem+i)=icore(iostral(ir,nact,nex)+i)
               enddo
              iostral(ir,nact,nex)=istr2mem
             enddo
           endif
         enddo
       enddo
C Occupied beta strings
       if(cs.and.nal.eq.nbe.and.minoccal2.eq.minoccbe2.and.
     $nactoa.eq.nactob) then
         do nex=0,minoccbe2
           do nact=max(0,nex-mrop2),min(nactob,nex)
            iarc(nact,nex,4)=iarc(nact,nex,3)
            iarcrec(nact,nex,4)=iarcrec(nact,nex,3)
            itrecob(1,nact,nex)=itrecoa(1,nact,nex)
            itrecob(2,nact,nex)=itrecoa(2,nact,nex)
             do ir=1,nir
              nostrbe(ir,nact,nex)=nostral(ir,nact,nex)
              iostrbe(ir,nact,nex)=iostral(ir,nact,nex)
              iorecbe(ir,nact,nex)=iorecal(ir,nact,nex)
             enddo
           enddo
         enddo
       else
         do nex=0,minoccbe2
           do nact=max(0,nex-mrop2,nex-nbe+nactob),min(nactob,nex)
            call getmem((nbe+1)*(nex+1),icore(1),iarc(nact,nex,4))
            call occgraph(nbe,nex,icore(iarc(nact,nex,4)),
     $nostrbe(1,nact,nex),iostrbe(1,nact,nex),mosym(1,4),nactob,nact,
     $.false.,iorecbe(1,nact,nex),itrecob(1,nact,nex),
     $iarcrec(nact,nex,4))
             if(nex.le.2) then
               do ir=1,nir
                call getmem(nostrbe(ir,nact,nex)*nex,icore(1),istr2mem)
                 do i=0,nostrbe(ir,nact,nex)*nex-1
                  icore(istr2mem+i)=icore(iostrbe(ir,nact,nex)+i)
                 enddo
                iostrbe(ir,nact,nex)=istr2mem
               enddo
             endif
           enddo
         enddo
       endif
C Symmetry pairs for occupied strings
       do i=0,minoccal2
         do nacta=max(0,i-mrop2),min(nactoa,i)
           do j=0,minoccbe2
             do nactb=max(0,j-mrop2),min(nactob,j)
               if(i+j-mrop2.le.nacta+nactb) then
               do ir=1,nir
                isum=0
                 do irv=1,nir
                   if(nostral(isympair(ir,irv,1),nacta,i).gt.0.and.
     $                nostrbe(isympair(ir,irv,2),nactb,j).gt.0) then
                    isum=isum+1
                    isympo(isum,ir,nacta,nactb,i,j,1)=isympair(ir,irv,1)
                    isympo(isum,ir,nacta,nactb,i,j,2)=isympair(ir,irv,2)
                   endif
                 enddo
                isympo(0,ir,nacta,nactb,i,j,1)=isum
               enddo
               endif
             enddo
           enddo
         enddo
       enddo
C Number of configurations
      ii=0
      trecmax=0
       if(hess) then
         do ir1=1,nir
           if(nirmap(ir1).eq.0) 
     $call nconfig(nvstral,nvstrbe,nostral,nostrbe,nconf,tsp,nmax,nnir,
     $isympv,isympo,ita,tarec,nactm,i,ir1,trec,trec2,tcase,ntcase,
     $.false.)
         enddo
       endif
       do ir1=1,nir
        i=nirmap(ir1)
         if(i.ne.0) then
           if(nirrep.gt.1) write(iout,"(
     $' Number of excitations for irrep',i2,': ')") ir1
          call nconfig(nvstral,nvstrbe,nostral,nostrbe,nconf(1,i),tsp,
     $nmax,nnir,isympv,isympo,ita,tarec(1,i),nactm,ii,ir1,trec(1,i),
     $trec2(1,i),tcase,ntcase,.true.)
         endif
       enddo
C
       if(ss1route) then
        open(tmfile,status='unknown',access='direct',recl=nir**4*iintln)
         do i=1,ii
          read (tafile,rec=i) ita
          write(tmfile,rec=i) ita
         enddo
        close(tmfile)
       endif
C
      return
      end
C
************************************************************************
      subroutine occgraph(norb,nex,idrt,nstr,istr,mosym,nactvo,
     $nact,lvirt,irec,itrecv,iarcrec)
************************************************************************
* This subroutine generates occupation graph of excitation operators   *
* and generates states in symmetry order                               *
************************************************************************
#include "MRCCCOMMON"
      integer norb,nex,idrt(0:norb,0:nex),nstr(*),istr(*),iarcrec
      integer mosym(*),i,j,ii,m,n,nactvo,nact,irec(*),itrecv(*)
      logical lvirt
C Vertex weights
       do i=0,norb
         do j=0,nex
          idrt(i,j)=0
         enddo
       enddo
       if(lvirt) then
        m=nactvo-nact
         do i=0,nactvo
          ii=min(i,nact)
           do j=max(0,i-m,ii-nact),ii
             if(j.eq.0) then
              idrt(i,j)=1
             else
              idrt(i,j)=idrt(i-1,j-1)+idrt(i-1,j)
             endif
           enddo
         enddo
        m=(norb-nactvo)-(nex-nact)
         do i=0,(norb-nactvo)
          ii=min(i,(nex-nact))
           do j=max(0,i-m,ii-(nex-nact)),ii
             if(j+nact.eq.0) then
              idrt(i+nactvo,j+nact)=1
             else
              idrt(i+nactvo,j+nact)=idrt(i+nactvo-1,j+nact-1)+
     $                             idrt(i+nactvo-1,j+nact)
             endif
           enddo
         enddo
       else
        m=(norb-nactvo)-(nex-nact)
         do i=0,norb-nactvo
          ii=min(i,nex-nact)
           do j=max(0,i-m,ii-(nex-nact)),ii
             if(j.eq.0) then
              idrt(i,j)=1
             else
              idrt(i,j)=idrt(i-1,j-1)+idrt(i-1,j)
             endif
           enddo
         enddo
        m=nactvo-nact
         do i=0,nactvo
          ii=min(i,nact)
           do j=max(0,i-m,ii-nact),ii
             if(j+(nex-nact).eq.0) then
              idrt(i+(norb-nactvo),j+(nex-nact))=1
             else
              idrt(i+(norb-nactvo),j+(nex-nact))=
     $idrt(i+(norb-nactvo)-1,j+(nex-nact)-1)+
     $idrt(i+(norb-nactvo)-1,j+(nex-nact))
             endif
           enddo
         enddo
       endif
      n=idrt(norb,nex)
C Generate strings
      istr(1)=iimem+n
      iivirt=0
      iiocc=0
      istrv=1
      call opstr1(norb,nex,icore(iucvmem),idrt,icore(istr(1)))
      call ifillzero(nstr,nir)
      call symanal(icore(iimem),icore(istr(1)),nex,n,mosym,nstr,
     $icore(iimem+n*(nex+1)))
      itrecv(1)=istrc
      itrecv(2)=n
      call putint(strfile,itrecv(1),icore(iimem),n)
      call irecupd(istrc,n)
       do i=1,nir
         if(i.gt.1) istr(i)=istr(i-1)+nex*nstr(i-1)
        m=nex*nstr(i)
        irec(i)=istrc
        call putint(strfile,irec(i),icore(istr(i)),m)
        call irecupd(istrc,m)
       enddo
      iarcrec=istrc
      call putint(strfile,iarcrec,idrt,(norb+1)*(nex+1))
      call irecupd(istrc,(norb+1)*(nex+1))
C
      return
      end
C
************************************************************************
      subroutine irecupd(ircm,n)
************************************************************************
* Calculate records for an integer direct access file                  *
************************************************************************
#include "MRCCCOMMON"
      integer irc,ircm,n,i,k,m
C
      i=mod(n*iintln,ifltln)
       if(i.ne.0) i=ifltln-i
      m=(n*iintln+i)/ifltln
      k=mod(m,ibufln)
       if(k.ne.0) k=ibufln-k
      ircm=ircm+(m+k)/ibufln
C
      return
      end
C
************************************************************************
      subroutine symanal(istrsym,istr,nex,n,mosym,nstr,istrsym2)
************************************************************************
* This subroutine analyses the symmetry of operator strings            *
************************************************************************
#include "MRCCCOMMON"
      integer nex,n,istrsym(*),istr(nex,2*n),mosym(*),nstr(*)
      integer iisym,i,j,isum,istrsym2(*)
C Symmetry of strings
       do i=1,n
        iisym=1
         do j=1,nex
          iisym=mult(iisym,mosym(istr(j,i)))
         enddo
        istrsym(i)=iisym
        nstr(iisym)=nstr(iisym)+1
       enddo
C Symmetry order
       do i=1,n
         do j=1,nex
          istr(j,n+i)=istr(j,i)
         enddo
       enddo
      isum=0
       do ir=1,nir
         do i=1,n
           if(istrsym(i).eq.ir) then
            isum=isum+1
             do j=1,nex
              istr(j,isum)=istr(j,n+i)
             enddo
           endif
         enddo
       enddo
       do i=1,n
        istrsym2(i)=istrsym(i)
       enddo
       do ir=1,nir
        isum=0
         do i=1,n
           if(istrsym2(i).eq.ir) then
            isum=isum+1
            istrsym(i)=isum
           endif
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine opstr1(norb,nex,iucv,idrt,istr)
************************************************************************
* This subroutine generates operator strings                           *
************************************************************************
#include "MRCCCOMMON"
      integer norb,nex,iucv(*),i,idrt(0:norb,0:nex),istr(nex,*)
C
       if(iivirt.eq.nex) then
         do i=1,nex
          istr(i,istrv)=iucv(i)
         enddo
       else
        iiocc=iiocc+1
         if(idrt(iiocc,iivirt).gt.0) then
          call opstr2(norb,nex,iucv,idrt,istr)
         endif
         if(idrt(iiocc,iivirt+1).gt.0) then
          iivirt=iivirt+1
          iucv(iivirt)=iiocc
          istrv=istrv+idrt(iiocc-1,iivirt)
          call opstr2(norb,nex,iucv,idrt,istr)
          istrv=istrv-idrt(iiocc-1,iivirt)
          iivirt=iivirt-1
         endif
        iiocc=iiocc-1
       endif
C
      return
      end
C
************************************************************************
      subroutine opstr2(norb,nex,iucv,idrt,istr)
************************************************************************
* This subroutine generates operator strings                           *
************************************************************************
#include "MRCCCOMMON"
      integer norb,nex,iucv,idrt,istr
C
      call opstr1(norb,nex,iucv,idrt,istr)
C
      return
      end
C
************************************************************************
      subroutine initialt(iscr)
************************************************************************
* This subroutine generates initial cluster amplitudes                 *
************************************************************************
#include "MRCCCOMMON"
      integer ii,jj,i,nex,nn,iii,iscr
C
      iii=calc+1
       if(calc.eq.0.and.(ptfreq.ne.0.d0.or.optrec)) iii=2
       if(ptroute) then
        open(tfile,file='fort.16',status='old',access='direct',
     $recl=irecln,err=1009)
        open(cfile,file='fort.17',status='old',access='direct',
     $recl=irecln,err=1009)
        open(prfile,file='fort.61',status='old',access='direct',
     $recl=irecln,err=1009)
         if(dsroute.or.dtroute) return
        open(ptfile,status='unknown')
        close(ptfile,status='delete')
        open(ptfile,status='unknown',access='direct',recl=irecln)
        open(plfile,status='unknown')
        close(plfile,status='delete')
        open(plfile,status='unknown',access='direct',recl=irecln)
        read(prfile,rec=1) ibuf
        naopt=idnint(ibuf(1))+1
        ibuf(1)=dble(naopt)
        write(prfile,rec=1) ibuf
         if(rest.ne.0) then
          write(iout,"(
     $' Initial perturbed amplitudes are read from unit',i3,'.')") 
     $prfile
          ii=iii*(naopt-1)*trecmax+1
           do i=1,trecmax
            read(prfile,rec=ii+i) ibuf 
            write(ptfile,rec=i) ibuf 
           enddo
           if(calc.ne.0) then
            ii=ii+trecmax
             do i=1,trecmax
              read(prfile,rec=ii+i) ibuf
              write(plfile,rec=i) ibuf   
             enddo
           endif
         else
          write(iout,*) 'Initial perturbed amplitudes are generated.'
          call dfillzero(ibuf,ibufln)
           do i=1,trecmax
            write(ptfile,rec=i) ibuf
c           write(plfile,rec=i) ibuf
           enddo
         endif
        return
       endif
       if(rest.ne.0) then
         if(hess) then
          open(prfile,file='fort.61',status='old',access='direct',
     $recl=irecln,err=1009)
          read(prfile,rec=1) ibuf
          nn=idnint(ibuf(1))
c       write(6,*) 'nn=',nn
          nex=idnint(ibuf(2))
          ibuf(1)=0.d0
          ibuf(2)=dble(trecmax)
          write(prfile,rec=1) ibuf
          call dfillzero(ibuf1,ibufln)
          ii=iii*nn*trecmax+1
          jj=iii*nn*nex+1
           do iroot=1,iii*nn
             do i=1,trecmax-nex
              write(prfile,rec=ii) ibuf1
              ii=ii-1
             enddo
             do i=1,nex
              read(prfile,rec=jj) ibuf
              write(prfile,rec=ii) ibuf
              ii=ii-1
              jj=jj-1
             enddo
           enddo
         endif
C
        open(tfile,file='fort.16',status='old',access='direct',
     $recl=irecln,err=1009)
         if((calc.eq.1.and.conver.eq.1).or.nroot.gt.1.or.eomcc.or.
     $(calc.eq.0.and.dens.ne.0)) open(cfile,file='fort.17',
     $status='old',access='direct',recl=irecln,err=1009)
         if(left) then
           if(abs(rest).ge.3) then
            call fopen(lfile,'fort.63')
           else
            open(lfile,file='fort.63',status='old',access='direct',
     $recl=irecln,err=1009)
           endif
         endif
        nex=0
2018     continue
          nex=nex+1
          read(tfile,rec=nex,err=2019) ibuf
         goto 2018
2019    continue
        nex=nex-1
        write(iout,"(
     $' Initial cluster amplitudes are read from unit',i3,'.')") tfile
         if(nroot.gt.1.or.abs(rest).ge.3) 
     $call flskip(nex,cfile,nroot,iscr)
         if(left.and.abs(rest).lt.3) then
           if(eomgrad.and.osc) then
            call flskip(nex,lfile,nroot+1,iscr)
           else
            call flskip(nex,lfile,nroot,iscr)
           endif
         endif
        call dfillzero(ibuf,ibufln)
       else
         if(hess) then
          call fopen(prfile,'fort.61')
          call dfillzero(ibuf,ibufln)
          ibuf(2)=dble(trecmax)
          write(prfile,rec=1) ibuf
         endif
        call fopen(tfile,'fort.16')
        write(iout,*) 'Initial cluster amplitudes are generated.'
        nex=1
        call dfillzero(ibuf,ibufln)
        ibuf(1)=1.d0
        write(tfile,rec=1) ibuf
         if(left) call fopen(lfile,'fort.63')
         if(calc.eq.1.and.conver.eq.1) then
          call fopen(cfile,'fort.17')
          write(cfile,rec=1) ibuf
         endif
        ibuf(1)=0.d0
       endif
       do i=nex+1,trecmax
        write(tfile,rec=i) ibuf
       enddo
c      if(rest.eq.0.and.qcc.eq.1) call savevec(tfile,lfile,trecmax,0,0)
       if(left) call savevec(tfile,lfile,trecmax,0,0)
       if((calc.eq.1.and.conver.eq.1).or.(left.and.rest.ne.0.and.
     $abs(rest).lt.3)) then
         do i=nex+1,trecmax
          write(cfile,rec=i) ibuf
         enddo
       endif
       if(rest.ne.0.and.eomcc) call savevec(cfile,tfile,trecmax,0,0)
C
      return
1009  continue
      write(iout,*) 'Former cluster amplitudes are missing!'
      write(iout,*) 'The program is unable to restart!'
      call mrccend(1)
      end
C
************************************************************************
      subroutine mpdenom(nconf,trec,nstr,intrec,nmax,faaal,faabe,fiial,
     $fiibe,f,nnir,isympv,isympo,istr,hval,kmal,jmat,hvbe,kmbe,nbmax,
     $wspcb,wspca,wsmax,nactm,imed,intn,noccup,absind,irec,ioffs,mpd,
     $ltpr,tprtol,erec,econf)
************************************************************************
* This subroutine calculates MP denominators                           *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nmax,nactm,i,j,k,intrec(*),nex,ii,jj,nn,ssym,absind
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),ioffs
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer n1,n2,n3,n4,ire,ile,nbmax,wsmax,intn(*),imed(16,1),l,kk
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactv,iacto,iactva,iactoa,iactvb,iactob,noccup(nbmax)
      integer nstr(nnir,0:nactm,0:nmax,4),istr(nnir,0:nactm,0:nmax,4)
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,dbladd
      integer wspcb(0:wsmax,13),wspca(0:wsmax,13),nn1,nn2,nn3,nn4
      integer nactvintal,nactointal,nactvintbe,nactointbe,nactvirtal
      integer nactoccal,nactvirtbe,nactoccbe,irec(nnir,0:nactm,0:nmax,4)
      integer nampvirtal,nampvirtbe,nampoccal,nampoccbe,nref,intadd
      real*8 f(*),faaal(*),faabe(*),fiial(*),fiibe(*),tprtol
      real*8 hval(nbmax),kmal(nbmax,nbmax),jmat(nbmax,nbmax)
      real*8 hvbe(nbmax),kmbe(nbmax,nbmax)
      logical mpd,ltpr
C
       if(mpd) then
        rewind(scrfile1)
        call dfillzero(ibuf,ibufln)
        write(mpfile,rec=trecmax+1) ibuf
         if((calc.eq.0.or.conver.eq.1).and.(.not.ptroute).and.
     $rest.ge.0) then
          write(iout,*)
     $'Calculation of diagonal elements of Hamiltonian...'
           do i=1,nbmax
            read(scrfile1) (kmal(i,j),j=1,nbmax)
           enddo
           if(.not.spatial) then
             do i=1,nbmax
              read(scrfile1) (kmbe(i,j),j=1,nbmax)
             enddo
           endif
          read(scrfile1) jmat
          read(scrfile1) hval
           if(.not.spatial) read(scrfile1) hvbe
          call dfillzero(ibuf,ibufln)
          write(mpfile,rec=1) ibuf
         else
          write(iout,*) 'Calculation of MP denominators...'
C Read diagonal Fock-matrix elements
          call rfock(faaal,faabe,fiial,fiibe,f,intn,intrec,imed,wspca,
     $wsmax,nstr,istr,nnir,nmax,nactm)
         endif
       else
         if(ltpr) then
          write(iout,*)
           if(calc.eq.1.and.iroot.eq.1) then
            write(iout,*) 'Dominant cluster amplitudes'
           else
            write(iout,*) 'Dominant CI coefficients'
           endif
          write(iout,"(' Printing threshold: ',1pe9.2)") tprtol
          write(iout,*)
         endif
        rewind(scfile)
        nref=0
       endif
C Loop over excitations
      ssym=isym
       if(calc.eq.1.and.(.not.ltpr.or.iroot.eq.1)) ssym=1
       if(ptroute) ssym=ptsym(1)
       do nex=0,op
         do iactv=max(0,nex-mrop),min(nactv,nex)
           do iacto=max(0,nex-mrop),min(nacto,nex)
             do i1=0,nex
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                   if(ltpr.and.iroot.gt.1) then
                    nn=econf(iactva,iactvb,iactoa,iactob,i1,nex)
                   else
                    nn=nconf(iactva,iactvb,iactoa,iactob,i1,nex)
                   endif
             if(nn.gt.0) then
              nampvirtal=i1
              nampvirtbe=nex-nampvirtal
              nampoccal=i1
              nampoccbe=nex-nampoccal
               if(.not.mpd) then
                 if(ltpr.and.iroot.gt.1.or.(calc.eq.0.and.nroot.gt.1))
     $then
c                 call getlst(tfile,erec(iactva,iactvb,iactoa,iactob,i1,
c    $nex),f(1),nn)
                  call getlst(cfile,(iroot-1)*trecmax+
     $erec(iactva,iactvb,iactoa,iactob,i1,nex),f(1),nn)
                 else
                  call getlst(tfile,trec(iactva,iactvb,iactoa,iactob,i1,
     $nex),f(1),nn)
                 endif
               endif
              ii=1
               do ir=1,nir
                isymv=csympair(ssym,ir,1)
                isymo=csympair(ssym,ir,2)
                 do irv=1,isympv(0,isymv,iactva,iactvb,nampvirtal,
     $nampvirtbe,1)
      isymva=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,1)
      isymvb=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,2)
                  n1=nstr(isymva,iactva,nampvirtal,1)
                  n2=nstr(isymvb,iactvb,nampvirtbe,2)
                  k=n1*n2
                   do iro=1,isympo(0,isymo,iactoa,iactob,nampoccal,
     $nampoccbe,1)
      isymoa=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,1)
      isymob=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,2)
                    n3=nstr(isymoa,iactoa,nampoccal,3)
                    n4=nstr(isymob,iactob,nampoccbe,4)
      call strread(nn1,nn2,nn3,nn4,n1,n2,n3,n4,nampvirtal,nampvirtbe,
     $nampoccal,nampoccbe,isymva,isymvb,isymoa,isymob,iactva,iactvb,
     $iactoa,iactob,nnir,nactm,nmax,irec,jj,ioffs+nn)
                     if(mpd.or.ltpr) then
      kk=intadd(jj)
      jj=dbladd(kk+nbmax)
      call mpdenom1(nampvirtal,nampvirtbe,nampoccal,nampoccbe,n1,n2,n3,
     $n4,faaal,faabe,fiial,fiibe,icore(nn1),icore(nn2),icore(nn3),
     $icore(nn4),f(ii),hval,hvbe,kmal,kmbe,jmat,nbmax,f(ii),noccup,
     $dcore(jj),absind,icore(kk),ltpr,tprtol)
                     else
       if(nampvirtal.eq.iactva.and.nampvirtbe.eq.iactvb.and.
     $    nampoccal.eq.iactoa.and.nampoccbe.eq.iactob) !mrszemet
     $call mrrefdet(nampvirtal,nampvirtbe,nampoccal,nampoccbe,n1,n2,n3,
     $n4,icore(nn1),icore(nn2),icore(nn3),icore(nn4),f(ii),nbmax,
     $absind,noccup,nref)
                     endif
                    ii=ii+n3*n4*k
                   enddo
                 enddo
               enddo
               if(mpd) call putlst(mpfile,
     $trec(iactva,iactvb,iactoa,iactob,i1,nex),f(1),nn)
             endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
       if(ss1route.and..not.mpd.and..not.ltpr) then
        rewind(ssfile)
        write(ssfile,*) nref
       endif
      call szemet(mpfile,nconf,nmax,nactm,trec,f,0,wspca,wsmax,i,
     $nconf,trec)
C
      return
      end
C
************************************************************************
      subroutine rfock(faaal,faabe,fiial,fiibe,f,intn,intrec,imed,wspca,
     $wsmax,nstr,istr,nnir,nmax,nactm)
************************************************************************
* This subroutine reads diagonal Fock-matrix elements                  *
************************************************************************
#include "MRCCCOMMON"
      integer intn(*),intrec(*),imed(16,*),wsmax,nactm,nnir,nmax
      integer nstr(nnir,0:nactm,0:nmax,4),istr(nnir,0:nactm,0:nmax,4)
      integer wspca(0:wsmax,*),kk,l,nactvirtal,ire,ile,jj,nn,ii,i
      integer nactvirtbe,nactoccal,nactoccbe,isymi,isyma,ira,isymav
      integer isymao,iri,isymiv,isymio
      real*8 f(*),faaal(*),faabe(*),fiial(*),fiibe(*)
C
      kk=max(0,1-nvirtal+nactva)
       do l=1,iimed
         do nactvirtal=kk,min(1,nactva)
c3         if(intn(l).eq.1.and.imed(9,l).eq.kk.and.
           if(intn(l).eq.1.and.imed(9,l).eq.nactvirtal.and.
     $                         imed(11,l).eq.nactvirtal) then
      call fwspc(wspca(0,l),1,0,1,0,nactvirtal,0,0,0,nactvirtal,0,
     $ire,ile)
            call getlst(intfile,intrec(l)+ire,f(1),ile)
            jj=0
             do ir=1,nir
              isymi=isympair(1,ir,1)
              isyma=isympair(1,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
                 if(isymao.eq.1) then
                   do iri=1,nir
                    isymiv=dsympair(isymi,iri,1)
                    isymio=dsympair(isymi,iri,2)
                     if(isymio.eq.1.and.isymav.eq.isymiv) then
                      nn=nstr(isymiv,nactvirtal,1,1)
                      ii=istr(isymiv,nactvirtal,1,1)-1
                       do i=1,nn
                        faaal(icore(ii+i))=f(jj+(i-1)*nn+i)
                       enddo
                      jj=jj+nn**2
                     endif
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
C
      kk=max(0,1-nvirtbe+nactvb)
       do l=1,iimed
         do nactvirtbe=kk,min(1,nactvb)
c3         if(intn(l).eq.1.and.imed(9,l).eq.kk.and.
           if(intn(l).eq.1.and.imed(9,l).eq.nactvirtbe.and.
     $                         imed(11,l).eq.nactvirtbe) then
      call fwspc(wspca(0,l),0,0,0,0,0,0,nactvirtbe,0,0,0,
     $ire,ile)
            call getlst(intfile,intrec(l)+ire,f(1),ile)
            jj=0
             do ir=1,nir
              isymi=isympair(1,ir,1)
              isyma=isympair(1,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
                 if(isymao.eq.1) then
                   do iri=1,nir
                    isymiv=dsympair(isymi,iri,1)
                    isymio=dsympair(isymi,iri,2)
                     if(isymio.eq.1.and.isymav.eq.isymiv) then
                      nn=nstr(isymiv,nactvirtbe,1,2)
                      ii=istr(isymiv,nactvirtbe,1,2)-1
                       do i=1,nn
                        faabe(icore(ii+i))=f(jj+(i-1)*nn+i)
                       enddo
                      jj=jj+nn**2
                     endif
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
C
      kk=max(0,1-nal+nactoa)
       do l=1,iimed
         do nactoccal=kk,min(1,nactoa)
c3         if(intn(l).eq.2.and.imed(10,l).eq.kk.and.
           if(intn(l).eq.2.and.imed(10,l).eq.nactoccal.and.
     $                         imed(12,l).eq.nactoccal) then
      call fwspc(wspca(0,l),0,1,0,1,0,nactoccal,0,0,0,nactoccal,ire,ile)
            call getlst(intfile,intrec(l)+ire,f(1),ile)
            jj=0
             do ir=1,nir
              isymi=isympair(1,ir,1)
              isyma=isympair(1,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
                 if(isymav.eq.1) then
                   do iri=1,nir
                    isymiv=dsympair(isymi,iri,1)
                    isymio=dsympair(isymi,iri,2)
                     if(isymiv.eq.1.and.isymao.eq.isymio) then
                      nn=nstr(isymio,nactoccal,1,3)
                      ii=istr(isymio,nactoccal,1,3)-1
                       do i=1,nn
                        fiial(icore(ii+i))=f(jj+(i-1)*nn+i)
                       enddo
                      jj=jj+nn**2
                     endif
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
C
      kk=max(0,1-nbe+nactob)
       do l=1,iimed
         do nactoccbe=kk,min(1,nactob)
c3         if(intn(l).eq.2.and.imed(10,l).eq.kk.and.
           if(intn(l).eq.2.and.imed(10,l).eq.nactoccbe.and.
     $                         imed(12,l).eq.nactoccbe) then
            call fwspc(wspca(0,l),0,0,0,0,0,0,0,nactoccbe,0,0,ire,ile)
            call getlst(intfile,intrec(l)+ire,f(1),ile)
            jj=0
             do ir=1,nir
              isymi=isympair(1,ir,1)
              isyma=isympair(1,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
                 if(isymav.eq.1) then
                   do iri=1,nir
                    isymiv=dsympair(isymi,iri,1)
                    isymio=dsympair(isymi,iri,2)
                     if(isymiv.eq.1.and.isymao.eq.isymio) then
                      nn=nstr(isymio,nactoccbe,1,4)
                      ii=istr(isymio,nactoccbe,1,4)-1
                       do i=1,nn
                        fiibe(icore(ii+i))=f(jj+(i-1)*nn+i)
                       enddo
                      jj=jj+nn**2
                     endif
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
C
      return
      end
C

************************************************************************
      subroutine strread(nn1,nn2,nn3,nn4,n1,n2,n3,n4,nva,nvb,noa,nob,
     $isymva,isymvb,isymoa,isymob,iactva,iactvb,iactoa,iactob,nnir,
     $nactm,nmax,irec,mscr,ioffs)
************************************************************************
* This subroutine reads strings from file                              *
************************************************************************
#include "MRCCCOMMON"
      integer nn1,nn2,nn3,nn4,n1,n2,n3,n4,nva,nvb,noa,nob,isymva,isymvb
      integer isymoa,isymob,iactva,iactvb,iactoa,iactob,nnir,nactm,mscr
      integer nmax,irec(nnir,0:nactm,0:nmax,4),ioffs,intadd,dbladd
C
      nn1=n1*nva
      nn2=n2*nvb
      nn3=n3*noa
      nn4=n4*nob
      iimem=intadd(ioffs)
      call getint(strfile,irec(isymva,iactva,nva,1),icore(iimem),nn1)
      call getint(strfile,irec(isymvb,iactvb,nvb,2),
     $icore(iimem+nn1),nn2)
      call getint(strfile,irec(isymoa,iactoa,noa,3),
     $icore(iimem+nn1+nn2),nn3)
      call getint(strfile,irec(isymob,iactob,nob,4),
     $icore(iimem+nn1+nn2+nn3),nn4)
      mscr=iimem+nn1+nn2+nn3+nn4
      nn4=iimem+nn1+nn2+nn3
      nn3=iimem+nn1+nn2
      nn2=iimem+nn1
      nn1=iimem
      mscr=dbladd(mscr)
C
      return
      end
C
************************************************************************
      subroutine mpdenom1(nva,nvb,noa,nob,nvstral,nvstrbe,nostral,
     $nostrbe,faaal,faabe,fiial,fiibe,istrva,istrvb,istroa,istrob,mpd,
     $hval,hvbe,kmal,kmbe,jmat,nbmax,diags,noccup,part,absind,string,
     $ltpr,tprtol)
************************************************************************
* This subroutine calculates MP denominators or diagonal H matrix elem.*
************************************************************************
#include "MRCCCOMMON"
      integer nva,nvb,noa,nob,nvstral,nvstrbe,nostral,nostrbe,ii,nbmax
      integer i,ivstral,ivstrbe,iostral,iostrbe,absind(2*nbmax,-3:0)
      integer istrva(nva,nvstral),istrvb(nvb,nvstrbe),string(nbmax)
      integer istroa(noa,nostral),istrob(nob,nostrbe),p,q,noccup(*)
      real*8 mpd(*),sum1,sum2,sum3,sum4,sum,tprtol
      real*8 diags(nvstral,nvstrbe,nostral,nostrbe)
      real*8 faaal(*),faabe(*),fiial(*),fiibe(*)
      real*8 hval(nbmax),kmal(nbmax,nbmax),jmat(nbmax,nbmax)
      real*8 hvbe(nbmax),kmbe(nbmax,nbmax),part(nbmax,nvstrbe,nostrbe)
      logical ltpr
      character*4 str4
      character*12 str12
      character*72 bprint
C Printing dominant cluster amplitudes/CI coefficients
       if(ltpr) then
        ii=0
         do iostrbe=1,nostrbe
           do iostral=1,nostral
             do ivstrbe=1,nvstrbe
               do ivstral=1,nvstral
                ii=ii+1
                 if(dabs(mpd(ii)).ge.tprtol) then
                  write(str12,'(1x,f11.6)') mpd(ii)
                  bprint='                                    ' //
     $                   '                                    '
                   do i=1,noa
                    write(str4,'(i4)')ncore+absind(istroa(i,iostral),-1)
                    bprint=trim(bprint)//' '//trim(adjustl(str4))//'a'
                   enddo
                   do i=1,nob
                    write(str4,'(i4)')ncore+absind(istrob(i,iostrbe), 0)
                    bprint=trim(bprint)//' '//trim(adjustl(str4))//'b'
                   enddo
                   if(noa+nob+nva+nvb.eq.0) then
                    bprint=trim(bprint)//'Reference determinant'
                   else
                    bprint=trim(bprint)//' ->'
                   endif
                   do i=1,nva
                    write(str4,'(i4)')ncore+absind(istrva(i,ivstral),-3)
                    bprint=trim(bprint)//' '//trim(adjustl(str4))//'a'
                   enddo
                   do i=1,nvb
                    write(str4,'(i4)')ncore+absind(istrvb(i,ivstrbe),-2)
                    bprint=trim(bprint)//' '//trim(adjustl(str4))//'b'
                   enddo
                  bprint=str12//'  '//trim(adjustl(bprint))
                  write(iout,"(a72)") bprint
                 endif
               enddo
             enddo
           enddo
         enddo
       endif
C MP denominators for (MR)CC/LCC
       if((calc.ne.0.and.conver.ne.1).or.ptroute.or.rest.lt.0) then
        ii=0
         do iostrbe=1,nostrbe
          sum1=0.d0
           do i=1,nob
            sum1=sum1+fiibe(istrob(i,iostrbe))
           enddo
           do iostral=1,nostral
            sum2=sum1
             do i=1,noa
              sum2=sum2+fiial(istroa(i,iostral))
             enddo
             do ivstrbe=1,nvstrbe
              sum3=sum2
               do i=1,nvb
                sum3=sum3-faabe(istrvb(i,ivstrbe))
               enddo
               do ivstral=1,nvstral
                sum4=sum3
                 do i=1,nva
                  sum4=sum4-faaal(istrva(i,ivstral))
                 enddo
                ii=ii+1
                mpd(ii)=sum4
               enddo
             enddo
           enddo
         enddo
       else
C Build partial sums
        sum2=dble(nal)
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(ivstrbe,i,string,iostrbe,sum,q,p,sum1)
         do ivstrbe=1,nvstrbe
           do i=1,nbasis/2
             if(noccup(i).eq.1.or.noccup(i).eq.0) string(i)=0
           enddo
           do i=1,nvb
            string(absind(istrvb(i,ivstrbe),-2))=1
           enddo
           do iostrbe=1,nostrbe 
             do i=1,nbasis/2
               if(noccup(i).eq.-1.or.noccup(i).eq.2) string(i)=1
             enddo
             do i=1,nob
              string(absind(istrob(i,iostrbe),0))=0
             enddo
            sum=0.d0
             do q=1,nbmax
               if(string(q).eq.1) then
                sum=sum+hvbe(q)
                 do p=1,q-1
                   if(string(p).eq.1) sum=sum+kmbe(p,q)
                 enddo
               endif
             enddo
            sum1=sum/sum2
             do p=1,nbmax
              sum=sum1
               do q=1,nbmax
                 if(string(q).eq.1) sum=sum+jmat(p,q)
               enddo
              part(p,ivstrbe,iostrbe)=sum
             enddo
           enddo
         enddo
C$OMP END PARALLEL DO
C Build diagonals
        sum2=-(eref-nuc)
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(ivstral,iostral,i,string,ivstrbe,iostrbe,sum,q,p,sum1)
         do ivstral=1,nvstral
           do i=1,nbasis/2
             if(noccup(i).le.0) string(i)=0
           enddo
           do i=1,nva
            string(absind(istrva(i,ivstral),-3))=1
           enddo
           do iostral=1,nostral 
             do i=1,nbasis/2
               if(noccup(i).ge.1) string(i)=1
             enddo
             do i=1,noa
              string(absind(istroa(i,iostral),-1))=0
             enddo
            sum1=sum2
             do q=1,nbmax
               if(string(q).eq.1) then
                sum1=sum1+hval(q)
                 do p=1,q-1
                   if(string(p).eq.1) sum1=sum1+kmal(p,q)
                 enddo
               endif
             enddo
             do ivstrbe=1,nvstrbe
               do iostrbe=1,nostrbe
                sum=sum1
                 do p=1,nbmax
                   if(string(p).eq.1) sum=sum+part(p,ivstrbe,iostrbe)
                 enddo
                diags(ivstral,ivstrbe,iostral,iostrbe)=sum
               enddo
             enddo
           enddo
         enddo
C$OMP END PARALLEL DO
       endif
C
      return
      end
C
************************************************************************
      subroutine energy(t1aa,t1bb,t1ab,t1ba,t2,v,nva,nvb,na,nb,econf,
     $trec,intrec,nmax,istr,nnir,nstr,isympv,isympo,file,wspca,wsmax,
     $nactm,intn,imed,c1aa,c1bb,c1ab,c1ba,ifile,c0,itsh,file1,ire1,
     $nconf,absind,umat,t1a,t1b)
************************************************************************
* This subroutine calculates coupled-cluster energy                    *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nva,nvb,na,nb,nmax,a,b,i,j,isum,aa,bb,l,ifile,file1
      integer intrec(*),file,wsmax,nactm,istr(nnir,0:nactm,0:nmax,4),k
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),ire1
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,*)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),itsh
      integer nstr(nnir,0:nactm,0:nmax,4),ii,jj,n1,n2,n3,n4,nn,intn(*)
      integer wspca(0:wsmax,13),ire,ile,iactva,iactvb,iactoa,iactob,pts
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),iisym
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),ire2
      integer isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,imed(16,1)
      integer ire3,file2,absind(nbasis,-3:0),ab
      real*8 t1aa(nva,na),t1bb(nvb,nb),t1ab(nva,nb),t1ba(nvb,na),v(*)
      real*8 c1aa(nva,na),c1bb(nvb,nb),c1ab(nva,nb),c1ba(nvb,na)
      real*8 t2(*),sum,c0,ccc,umat(*),t1a(*),t1b(*)
C
       if((densroute.and.calc.eq.0.and.denssym.ne.isy1.and..not.
     $ds1route).or.(d1route.and.
     $(.not.eomgrad).and.(.not.dbroute.or.ptsym(1).ne.1)).or.
     $(eomgrad.and.osc.and.densroute.and.(.not.d2route)).or.dtroute.or.
     $(ds1route.and.calc.eq.1)) 
     $return
      ire2=ire1
      ire3=0
      file2=file1
      pts=0 
      iisym=1
       if(d2route) then
        pts=itsh
        iisym=ptsym(1)
       endif
      ecc=eref
       if(op.lt.1) return
      ccc=0.5d0 !1/2 for equivalent T1 vertices
       if((eomroute.and..not.ds2route)
c    $.or.(ds2route.and.(ptsym(1).ne.ptsym(2).or.nopt(1).ne.nopt(2)))
     $)ccc=1.d0
c     write(6,*) 'ccc',ccc,ptsym(1),ptsym(2),nopt(1),nopt(2),
c    $eomroute,ds2route.and.(ptsym(1).ne.ptsym(2).or.
c    $nopt(1).ne.nopt(2))
       if(ds2route.or.(ds1route.and.calc.eq.0)) then
        pts=itsh
        iisym=mult(ptsym(1),ptsym(2))
        ire2=2*(nopt(1)-1)*trecmax+1
        ire3=2*(nopt(2)-1)*trecmax+1
         if(ds1route.and.calc.eq.0) then
           if(ptfreq.eq.0.d0.and..not.optrec) then
            ire2=  (nopt(2)-1)*trecmax+1
           else
            ire2=(2*nopt(2)-1)*trecmax+1
           endif
         endif
        file2=file
         if(ds2route) goto 6492
       endif
C T1 part
      k=max(0,1-(nvirt-nactv))
      j=max(0,1-(nocc-nacto))
c3      l=itsh
c33904   continue
c3        l=l+1
c3       if(intn(l-itsh).ne.3.or.imed(9,l).ne.k.or.imed(10,l).ne.j) goto 3904
       do iactva=max(0,1-nvirtal+nactva),min(nactva,1)
         do iactoa=max(0,1-nal+nactoa),min(nactoa,1)
      l=itsh
3904   continue
        l=l+1
       if(intn(l-itsh).ne.3.or.imed(9,l).ne.iactva.or.imed(10,l).ne.
     $iactoa) goto 3904
           if(ds1route.and.calc.eq.0) then
            nn=nconf(iactva,0,iactoa,0,1,1,nirmap(iisym))
           else
            nn=econf(iactva,0,iactoa,0,1,1)
           endif
           if(nn.gt.0) then
      call getlst(file,ire2+trec(iactva,0,iactoa,0,1,1),t1aa,nn)
      call fwspc(wspca(0,l),1,1,0,0,iactva,iactoa,0,0,0,0,ire,ile)
      call getlst(ifile,intrec(l-pts)+ire,v,ile)
       if(densroute) then
         if(isym.eq.1.or.(calc.eq.0.and.ptroute.and.ptsym(1).eq.1).or.
     $(eomgrad.and.d1route).or.osc.or.dbroute) then
          call add(v(1),t1aa,ile,2,1,c0,1.d0)
          call putlst(ifile,intrec(l-pts)+ire,v,ile)
         endif
       else
         if(locno.gt.0) then
          ii=0
           do ir=1,nir
            isymv=csympair(iisym,ir,1)
            isymo=csympair(iisym,ir,2)
            n1=nstr(isymv,iactva,1,1)
            n2=nstr(isymo,iactoa,1,3)
            i2=istr(isymo,iactoa,1,3)-1
            call dfillzero(v(nn+1),n1)
            call dfillzero(v(nn+n1+1),n1)
             do j=1,n2
               do i=1,n1
                ii=ii+1
      v(nn+i)   =v(nn+i)   +umat(absind(icore(i2+j),-1))*v(ii)
      v(nn+n1+i)=v(nn+n1+i)+umat(absind(icore(i2+j),-1))*t1a(ii)
               enddo
             enddo
            call scalprod(v(nn+1),v(nn+n1+1),n1,sum)
            ecc=ecc+sum
           enddo
         else
          call scalprod(v,t1aa,nn,sum)
          ecc=ecc+sum
         endif
       endif
           endif
         enddo
       enddo
       do iactvb=max(0,1-nvirtbe+nactvb),min(nactvb,1)
         do iactob=max(0,1-nbe+nactob),min(nactob,1)
      l=itsh
3906   continue
        l=l+1
       if(intn(l-itsh).ne.3.or.imed(9,l).ne.iactvb.or.imed(10,l).ne.
     $iactob) goto 3906
           if(ds1route.and.calc.eq.0) then
            nn=nconf(0,iactvb,0,iactob,0,1,nirmap(iisym))
           else
            nn=econf(0,iactvb,0,iactob,0,1)
           endif
           if(nn.gt.0) then
      call getlst(file,ire2+trec(0,iactvb,0,iactob,0,1),t1bb,nn)
      call fwspc(wspca(0,l),0,0,0,0,0,0,iactvb,iactob,0,0,ire,ile)
      call getlst(ifile,intrec(l-pts)+ire,v,ile)
c       write(6,*) 'v   ',(v(k),k=1,nn),ifile,l-pts,intrec(l-pts),ire
c       write(6,*) 't1bb',t1bb,file
       if(densroute) then
         if(isym.eq.1.or.(calc.eq.0.and.ptroute.and.ptsym(1).eq.1).or.
     $(eomgrad.and.d1route).or.osc.or.dbroute) then
          call add(v(1),t1bb,ile,2,1,c0,1.d0)
          call putlst(ifile,intrec(l-pts)+ire,v,ile)
c       write(6,*) 'vb  ',(v(k),k=1,ile)
         endif
       else
         if(locno.gt.0) then
          ii=0
           do ir=1,nir
            isymv=csympair(iisym,ir,1)
            isymo=csympair(iisym,ir,2)
            n1=nstr(isymv,iactvb,1,2)
            n2=nstr(isymo,iactob,1,4)
            i2=istr(isymo,iactob,1,4)-1
            call dfillzero(v(nn+1),n1)
            call dfillzero(v(nn+n1+1),n1)
             do j=1,n2
               do i=1,n1
                ii=ii+1
      v(nn+i)   =v(nn+i)   +umat(absind(icore(i2+j),0))*v(ii)
      v(nn+n1+i)=v(nn+n1+i)+umat(absind(icore(i2+j),0))*t1b(ii)
               enddo
             enddo
            call scalprod(v(nn+1),v(nn+n1+1),n1,sum)
            ecc=ecc+sum
           enddo
         else
          call scalprod(v,t1bb,nn,sum)
          ecc=ecc+sum
         endif
       endif
           endif
         enddo
       enddo
C
6492  continue
       if(op.lt.2.or.(densroute.and.dens.lt.2).or.dbroute) return
       if(ds2route.or.(ds1route.and.calc.eq.0)) then
        call unpackt(t1aa,t1bb,t1ab,t1ba,v,nva,nvb,na,nb,
     $icore(iconfmem+4*nir*(nmax+1)*(nactm+1)+(nirmap(ptsym(1))-1)*
     $(nactm+1)**4*(nmax+1)**2),icore(itrecmem+(nirmap(ptsym(1))-1)*
     $(nactm+1)**4*(nmax+1)**2),nmax,istr,nnir,nstr,file,nactm,ptsym(1),
     $ire2)
        call unpackt(c1aa,c1bb,c1ab,c1ba,v,nva,nvb,na,nb,
     $icore(iconfmem+4*nir*(nmax+1)*(nactm+1)+(nirmap(ptsym(2))-1)*
     $(nactm+1)**4*(nmax+1)**2),icore(itrecmem+(nirmap(ptsym(2))-1)*
     $(nactm+1)**4*(nmax+1)**2),nmax,istr,nnir,nstr,file2,nactm,
     $ptsym(2),ire3)
       else
        call unpackt(t1aa,t1bb,t1ab,t1ba,v,nva,nvb,na,nb,econf,trec,
     $nmax,istr,nnir,nstr,file,nactm,iisym,ire2)
         if(eomroute)
     $call unpackt(c1aa,c1bb,c1ab,c1ba,v,nva,nvb,na,nb,
     $icore(iconfmem+4*nir*(oo+1)*(nactmax+1)),icore(itrecmem),
     $nmax,istr,nnir,nstr,file2,nactm,1,ire3)
       endif
c     write(6,*) 't1aa',t1aa
c     write(6,*) 't1bb',t1bb
c     write(6,*) 'c1aa',c1aa
c     write(6,*) 'c1bb',c1bb
C T2 and T1^2 part
      k=max(0,2-(nvirt-nactv))
      j=max(0,2-(nocc-nacto))
c3       l=itsh
c3 3905   continue
c3         l=l+1
c3        if(intn(l-itsh).ne.11.or.imed(9,l).ne.k.or.imed(10,l).ne.j) goto 3905
C aa
       do iactva=max(0,2-nvirtal+nactva),min(nactva,2)
         do iactoa=max(0,2-nal+nactoa),min(nactoa,2)
           if(ds2route.or.(ds1route.and.calc.eq.0)) then
            nn=nconf(iactva,0,iactoa,0,2,2,nirmap(iisym))
           else
            nn=econf(iactva,0,iactoa,0,2,2)
           endif
           if(nn.gt.0.or.(nn.eq.0.and.calc.eq.1.and.mrop.eq.1).or.
     $(nn.eq.0.and.densroute.and.isym.ne.1)) then
      l=itsh
3907   continue
        l=l+1
       if(intn(l-itsh).ne.11.or.imed(9,l).ne.iactva.or.imed(10,l).ne.
     $iactoa) goto 3907
      call fwspc(wspca(0,l),2,2,0,0,iactva,iactoa,0,0,0,0,ire,ile)
       if(ile.gt.0) call getlst(ifile,intrec(l-pts)+ire,v,ile)
             if(nn.eq.0.or.ds2route) then
              nn=ile
              call dfillzero(t2,nn)
             else
      call getlst(file,ire2+trec(iactva,0,iactoa,0,2,2),t2,nn)
             endif
             if(locno.gt.0) then
              isum=0
               do ir=1,nir
                isymv=csympair(iisym,ir,1)
                isymo=csympair(iisym,ir,2)
                n1=nstr(isymv,iactva,2,1)
                n2=nstr(isymo,iactoa,2,3)
                i1=istr(isymv,iactva,2,1)-1
                i2=istr(isymo,iactoa,2,3)-1
                call dfillzero(v(nn+1),2*n1*nal)
                 do ii=1,n2
                  j=icore(i2+2*ii-1)
                  i=icore(i2+2*ii)
                   do aa=1,n1
                    b=icore(i1+2*aa-1)
                    a=icore(i1+2*aa)
                    isum=isum+1
      v(nn+(aa-1)*nal+j)=v(nn+(aa-1)*nal+j)+
     $                   umat(absind(i,-1))*v(isum)
      v(nn+n1*nal+(aa-1)*nal+j)=v(nn+n1*nal+(aa-1)*nal+j)+
     $                          umat(absind(i,-1))*(t2(isum)+
     $ccc*(t1aa(a,i)*c1aa(b,j)-t1aa(a,j)*c1aa(b,i)+
     $     t1aa(b,j)*c1aa(a,i)-t1aa(b,i)*c1aa(a,j)))
      v(nn+(aa-1)*nal+i)=v(nn+(aa-1)*nal+i)-
     $                   umat(absind(j,-1))*v(isum)
      v(nn+n1*nal+(aa-1)*nal+i)=v(nn+n1*nal+(aa-1)*nal+i)-
     $                          umat(absind(j,-1))*(t2(isum)+
     $ccc*(t1aa(a,i)*c1aa(b,j)-t1aa(a,j)*c1aa(b,i)+
     $     t1aa(b,j)*c1aa(a,i)-t1aa(b,i)*c1aa(a,j)))
                   enddo
                 enddo
                call scalprod(v(nn+1),v(nn+n1*nal+1),n1*nal,sum)
                ecc=ecc+0.5d0*sum
               enddo
             else
               if(calc.eq.1.and.conver.ne.1) then
                isum=0
                 do ir=1,nir
                  isymv=csympair(iisym,ir,1)
                  isymo=csympair(iisym,ir,2)
                  n1=nstr(isymv,iactva,2,1)
                  n2=nstr(isymo,iactoa,2,3)
                  i1=istr(isymv,iactva,2,1)-1
                  i2=istr(isymo,iactoa,2,3)-1
                   do ii=1,n2
                    j=icore(i2+2*ii-1)
                    i=icore(i2+2*ii)
                     do aa=1,n1
                      b=icore(i1+2*aa-1)
                      a=icore(i1+2*aa)
                      isum=isum+1
        t2(isum)=t2(isum)+ccc*(t1aa(a,i)*c1aa(b,j)-t1aa(a,j)*c1aa(b,i)+
     $                         t1aa(b,j)*c1aa(a,i)-t1aa(b,i)*c1aa(a,j))
                     enddo
                   enddo
                 enddo
               endif
               if(densroute) then
                call add(v(1),t2,ile,2,1,c0,1.d0)
                call putlst(ifile,intrec(l-pts)+ire,v,ile)
c       write(6,*) 'aa',ifile,l,pts,intrec(l-pts),ire,(v(i),i=1,ile)
               else
                call scalprod(v,t2,nn,sum)
c       write(6,*) 'aa',sum
                ecc=ecc+sum
               endif
             endif
           endif
         enddo
       enddo
C bb
       do iactvb=max(0,2-nvirtbe+nactvb),min(nactvb,2)
         do iactob=max(0,2-nbe+nactob),min(nactob,2)
           if(ds2route.or.(ds1route.and.calc.eq.0)) then
            nn=nconf(0,iactvb,0,iactob,0,2,nirmap(iisym))
           else
            nn=econf(0,iactvb,0,iactob,0,2)
           endif
           if(nn.gt.0.or.(nn.eq.0.and.calc.eq.1.and.mrop.eq.1).or.
     $(nn.eq.0.and.densroute.and.isym.ne.1)) then
      l=itsh
3908   continue
        l=l+1
       if(intn(l-itsh).ne.11.or.imed(9,l).ne.iactvb.or.imed(10,l).ne.
     $iactob) goto 3908
      call fwspc(wspca(0,l),0,0,0,0,0,0,iactvb,iactob,0,0,ire,ile)
       if(ile.gt.0) call getlst(ifile,intrec(l-pts)+ire,v,ile)
             if(nn.eq.0.or.ds2route) then
              nn=ile
              call dfillzero(t2,nn)
             else
      call getlst(file,ire2+trec(0,iactvb,0,iactob,0,2),t2,nn)
             endif
             if(locno.gt.0) then
              isum=0
               do ir=1,nir
                isymv=csympair(iisym,ir,1)
                isymo=csympair(iisym,ir,2)
                n1=nstr(isymv,iactvb,2,2)
                n2=nstr(isymo,iactob,2,4)
                i1=istr(isymv,iactvb,2,2)-1
                i2=istr(isymo,iactob,2,4)-1
                call dfillzero(v(nn+1),2*n1*nbe)
                 do ii=1,n2
                  j=icore(i2+2*ii-1)
                  i=icore(i2+2*ii)
                   do aa=1,n1
                    b=icore(i1+2*aa-1)
                    a=icore(i1+2*aa)
                    isum=isum+1
      v(nn+(aa-1)*nbe+j)=v(nn+(aa-1)*nbe+j)+
     $                   umat(absind(i,0))*v(isum)
      v(nn+n1*nbe+(aa-1)*nbe+j)=v(nn+n1*nbe+(aa-1)*nbe+j)+
     $                          umat(absind(i,0))*(t2(isum)+
     $ccc*(t1bb(a,i)*c1bb(b,j)-t1bb(a,j)*c1bb(b,i)+
     $     t1bb(b,j)*c1bb(a,i)-t1bb(b,i)*c1bb(a,j)))
      v(nn+(aa-1)*nbe+i)=v(nn+(aa-1)*nbe+i)-
     $                   umat(absind(j,0))*v(isum)
      v(nn+n1*nbe+(aa-1)*nbe+i)=v(nn+n1*nbe+(aa-1)*nbe+i)-
     $                          umat(absind(j,0))*(t2(isum)+
     $ccc*(t1bb(a,i)*c1bb(b,j)-t1bb(a,j)*c1bb(b,i)+
     $     t1bb(b,j)*c1bb(a,i)-t1bb(b,i)*c1bb(a,j)))
                   enddo
                 enddo
                call scalprod(v(nn+1),v(nn+n1*nbe+1),n1*nbe,sum)
                ecc=ecc+0.5d0*sum
               enddo
             else
               if(calc.eq.1.and.conver.ne.1) then
                isum=0
                 do ir=1,nir
                  isymv=csympair(iisym,ir,1)
                  isymo=csympair(iisym,ir,2)
                  n1=nstr(isymv,iactvb,2,2)
                  n2=nstr(isymo,iactob,2,4)
                  i1=istr(isymv,iactvb,2,2)-1
                  i2=istr(isymo,iactob,2,4)-1
                   do ii=1,n2
                    j=icore(i2+2*ii-1)
                    i=icore(i2+2*ii)
                     do aa=1,n1
                      b=icore(i1+2*aa-1)
                      a=icore(i1+2*aa)
                      isum=isum+1
      t2(isum)=t2(isum)+ccc*(t1bb(a,i)*c1bb(b,j)-t1bb(a,j)*c1bb(b,i)+
     $                       t1bb(b,j)*c1bb(a,i)-t1bb(b,i)*c1bb(a,j))
                     enddo
                   enddo
                 enddo
               endif
               if(densroute) then
                call add(v(1),t2,ile,2,1,c0,1.d0)
                call putlst(ifile,intrec(l-pts)+ire,v,ile)
c       write(6,*) 'bb',ifile,l,pts,intrec(l-pts),ire,(v(i),i=1,ile)
               else
                call scalprod(v,t2,nn,sum)
c       write(6,*) 'bb',sum
                ecc=ecc+sum
               endif
             endif
           endif
         enddo
       enddo
C ab
       do iactva=max(0,1-nvirtal+nactva),min(nactva,1)
         do iactoa=max(0,1-nal+nactoa),min(nactoa,1)
           do iactvb=max(0,1-nvirtbe+nactvb),min(nactvb,1)
             do iactob=max(0,1-nbe+nactob),min(nactob,1)
               if(ds2route.or.(ds1route.and.calc.eq.0)) then
                nn=nconf(iactva,iactvb,iactoa,iactob,1,2,nirmap(iisym))
               else
                nn=econf(iactva,iactvb,iactoa,iactob,1,2)
               endif
               if(nn.gt.0.or.(nn.eq.0.and.calc.eq.1.and.mrop.eq.1).or.
     $(nn.eq.0.and.densroute.and.isym.ne.1)) then
      l=itsh
3909   continue
        l=l+1
       if(intn(l-itsh).ne.11.or.imed(9,l).ne.iactva+iactvb.or.
     $                         imed(10,l).ne.iactoa+iactob) goto 3909
      call fwspc(wspca(0,l),1,1,0,0,iactva,iactoa,iactvb,iactob,0,0,
     $ire,ile)
c       write(6,*) 'itsh',itsh,intn(l-itsh),l
       if(ile.gt.0) call getlst(ifile,intrec(l-pts)+ire,v,ile)
             if(nn.eq.0.or.ds2route) then
              nn=ile
              call dfillzero(t2,nn)
             else
      call getlst(file,ire2+trec(iactva,iactvb,iactoa,iactob,1,2),t2,nn)
             endif
             if(locno.gt.0) then
        isum=0
         do ir=1,nir
          isymv=csympair(iisym,ir,1)
          isymo=csympair(iisym,ir,2)
           do irv=1,isympv(0,isymv,iactva,iactvb,1,1,1)
            isymva=isympv(irv,isymv,iactva,iactvb,1,1,1)
            isymvb=isympv(irv,isymv,iactva,iactvb,1,1,2)
            n1=nstr(isymva,iactva,1,1)
            n2=nstr(isymvb,iactvb,1,2)
            i1=istr(isymva,iactva,1,1)-1
            i2=istr(isymvb,iactvb,1,2)-1
             do iro=1,isympo(0,isymo,iactoa,iactob,1,1,1)
              isymoa=isympo(iro,isymo,iactoa,iactob,1,1,1)
              isymob=isympo(iro,isymo,iactoa,iactob,1,1,2)
              n3=nstr(isymoa,iactoa,1,3)
              n4=nstr(isymob,iactob,1,4)
              i3=istr(isymoa,iactoa,1,3)-1
              i4=istr(isymob,iactob,1,4)-1
              call dfillzero(v(nn+1),2*n1*n2*n3)
               do jj=1,n4
                j=icore(i4+jj)
                 do ii=1,n3
                  i=icore(i3+ii)
                  ab=0
                   do bb=1,n2
                    b=icore(i2+bb)
                     do aa=1,n1
                      a=icore(i1+aa)
                      isum=isum+1
                      ab=ab+1
      v(nn+(ab-1)*n3+i)=v(nn+(ab-1)*n3+i)-
     $                  umat(absind(j,-1))*v(isum)
      v(nn+n1*n2*n3+(ab-1)*n3+i)=v(nn+n1*n2*n3+(ab-1)*n3+i)-
     $                        umat(absind(j,-1))*(t2(isum)+
     $ccc*(t1aa(a,i)*c1bb(b,j)-t1ab(a,j)*c1ba(b,i)+
     $     t1bb(b,j)*c1aa(a,i)-t1ba(b,i)*c1ab(a,j)))
                     enddo
                   enddo
                 enddo
               enddo
              call scalprod(v(nn+1),v(nn+n1*n2*n3+1),n1*n2*n3,sum)
              ecc=ecc+sum
             enddo
           enddo
         enddo
             else
       if(calc.eq.1.and.conver.ne.1) then
        isum=0
         do ir=1,nir
          isymv=csympair(iisym,ir,1)
          isymo=csympair(iisym,ir,2)
           do irv=1,isympv(0,isymv,iactva,iactvb,1,1,1)
            isymva=isympv(irv,isymv,iactva,iactvb,1,1,1)
            isymvb=isympv(irv,isymv,iactva,iactvb,1,1,2)
            n1=nstr(isymva,iactva,1,1)
            n2=nstr(isymvb,iactvb,1,2)
            i1=istr(isymva,iactva,1,1)-1
            i2=istr(isymvb,iactvb,1,2)-1
             do iro=1,isympo(0,isymo,iactoa,iactob,1,1,1)
              isymoa=isympo(iro,isymo,iactoa,iactob,1,1,1)
              isymob=isympo(iro,isymo,iactoa,iactob,1,1,2)
              n3=nstr(isymoa,iactoa,1,3)
              n4=nstr(isymob,iactob,1,4)
              i3=istr(isymoa,iactoa,1,3)-1
              i4=istr(isymob,iactob,1,4)-1
               do jj=1,n4
                j=icore(i4+jj)
                 do ii=1,n3
                  i=icore(i3+ii)
                   do bb=1,n2
                    b=icore(i2+bb)
                     do aa=1,n1
                      a=icore(i1+aa)
                      isum=isum+1
      t2(isum)=t2(isum)+ccc*(t1aa(a,i)*c1bb(b,j)-t1ab(a,j)*c1ba(b,i)+
     $                       t1bb(b,j)*c1aa(a,i)-t1ba(b,i)*c1ab(a,j))
       if(locno.gt.0.and.absind(i,-1).ne.locno) t2(isum)=0.d0
c      if(locno.gt.0.and.absind(i,-1).ne.locno) write(6,*) absind(i,-1)
                     enddo
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       endif
             if(densroute) then
              call add(v(1),t2,ile,2,1,c0,1.d0)
              call putlst(ifile,intrec(l-pts)+ire,v,ile)
c       write(6,*) 'ab',ifile,l,pts,intrec(l-pts),ire,(v(i),i=1,ile)
             else
              call scalprod(v,t2,nn,sum)
c       write(6,*) 'v',(v(aa),aa=1,nn)
c       write(6,*) 't',(t2(aa),aa=1,nn)
c       write(6,*) 'ab',sum
              ecc=ecc+sum
             endif
             endif
               endif
             enddo
           enddo
         enddo
       enddo
c     write(6,"('ecc  energy',f16.8)") ecc-eref
C
      return
      end
C
************************************************************************
      subroutine ccit(nstr,nconf,trec,intrec,imed,v,nmax,istr,isympv,
     $isympo,ita,tarec,iwa,isa,isw,wspcb,wspca,nactm,intn,ntcase,vmult,
     $earec,econf,erec,wsmax,denrec,trec2,erec2,tcase,itypa,itypb,
     $imedsyma,imedsymb,l2map,ioffs,spsht,absind,strec,tprtol,ltpr,
     $scspe)
************************************************************************
* This subroutine controls CC iteration                                *
************************************************************************
#include "MRCCCOMMON"
      integer wsmax,nmax,nstr,trec,wspcb(0:wsmax,1),wspca(0:wsmax,1),jj
      integer nactm,imed,ii,k,istr,isympv,isympo,ita,tarec,iwa,j,tcase
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),ioffs
      integer intn(*),ntcase,vmult(*),earec,econf,erec,isw,i,intrec(*)
      integer denrec,trec2,erec2,itypa,itypb,imedsyma(*),imedsymb(*)
      integer l2map,isa(*),iterm,spsht,absind,strec
      real*8 v(*),norm,test,eccold,sum,sum1,sum2,eene,tprtol,scspe
      logical log,lscr,log1,log2,ltpr
C
       if(hess)open(sdfile,status='unknown',access='direct',recl=irecln)
C
c tszemet eleje
      iterm=0
      open(unit=91,file='iterm',status='old',err=7653)
      rewind(91)
      read(91,*) iterm
      close(91)
7653  continue
c     write(6,*) 'iterm',iterm
c tszemet vege
c     write(6,*) 'cfile/ccit'
c     call szemet(cfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
c    $econf,erec)
C Third derivatives
       if(dsroute.or.dtroute) then
        densroute=.true.
        leftroute=.true.
         if(dsroute) then
C DS1 <0|dL/dx [exp(-T) {p+q-} exp(T), dT/dy]|0>
          write(iout,*) 'Calculation of the ' //
     $'<0|dL/dx [exp(-T) {p+q-} exp(T), dT/dy]|0> term...'
          call flush(iout)
          ds1route=.true.
       if(iterm.eq.0.or.iterm.eq.3) !tszemet
     $    call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
          ds1route=.false.
           if(calc.eq.0) return
          call fileini(ptfst)
C DS2 <0|(1+L)[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy]|0>
          write(iout,*) 'Calculation of the ' //
     $'<0|(1+L)[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy]|0> term...'
          call flush(iout)
          ds2route=.true.
       if(iterm.eq.0.or.iterm.eq.1) !tszemet
     $    call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
          ds2route=.false.
         endif
         if(dtroute) then
C DT1 <0|dL/dx [[exp(-T) {p+q-} exp(T), dT/dy], dT/dz]|0>
          write(iout,*) 'Calculation of the ' //
     $'<0|dL/dx [[exp(-T) {p+q-} exp(T), dT/dy], dT/dz]|0> term...'
          call flush(iout)
          dt1route=.true.
       if(iterm.eq.0.or.iterm.eq.4) !tszemet
     $    call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
          dt1route=.false.
          call fileini(ptfst)
C DT2 <0|(1+L)[[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy], dT/dz]|0>
          write(iout,*) 'Calculation of the ' //
     $'<0|(1+L)[[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy], dT/dz]|0>' //
     $'  term...'
          call flush(iout)
          dt2route=.true.
       if(iterm.eq.0.or.iterm.eq.2) !tszemet
     $    call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
          dt2route=.false.
         endif
        densroute=.false.
        leftroute=.false.
        return
       endif
C
       if(ptroute.or.eomgrad) then
        open(t1file,status='unknown',access='direct',recl=irecln)
        open(l2file,status='unknown',access='direct',recl=irecln)
       endif
       if(hess) then
         if(ptroute) then
C Calculate energies from densities
          read(prfile,rec=1) ibuf
          etot=ibuf(3)
          write(iout,128) etot
          call tenergy(wspca,wsmax,v,intrec,denrec,sdfile,ptsh,intn)
          eder=ecc
          write(iout,134) eder
         endif
       endif
       if(left.and.nroot.gt.1.and.isym.ne.1) then
        open(scrfile8,status='unknown',access='direct',recl=irecln)
        call savevec(cfile,scrfile8,trecmax,0,0)
       endif
      irecmax=0
       do iroot=1,nroot
         if(eomgrad.and.osc.and.iroot.eq.3) call mrccend(1)
         if(left.and.iroot.eq.2.and.isym.ne.1)
     $call change(scrfile8,mpfile)
        leftroute=.false.
        multip=vmult(iroot)
         if((nroot.gt.1.and.calc.ne.1.and.(isy1.eq.isy2.or.isym.eq.isy2)
     $).or.eomroute) then
          call savevec(cfile,tfile,trecmax,irecmax,0)
c     write(6,*) 'tfile/ccit',iroot
      call szemet(tfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
           if((.not.eomroute.or.op.eq.1)) !.or.(.not.rest))
     $call schmidt(econf,nmax,tfile,tfile,log)
         endif
         if((calc.eq.0.and.(.not.ptroute)).or.eomroute) then
           if(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy1) then
            call hmat(nconf,nmax,sum,tfile,tfile,0,0,nactmax)
           else
            call hmat(econf,nmax,sum,tfile,tfile,0,0,nactmax)
           endif
          call normate(dsqrt(sum),tfile,tfile)
         endif
        test=1.d0
        ecc=eref
         if(eomroute.and.qcc.eq.0) ecc=gene
        k=0
         do i1=0,nactm
           do i2=0,nactm
             do i3=0,nactm
               do i4=0,nactm
                k=max(k,nconf(i1,i2,i3,i4,2,2))
                k=max(k,nconf(i1,i2,i3,i4,1,2))
                k=max(k,nconf(i1,i2,i3,i4,0,2))
               enddo
             enddo
           enddo
         enddo
         if(mrop.eq.1) k=max(k,nal*nbe*nvirtal*nvirtbe,
     $                       k,nal*nal*nvirtal*nvirtal,
     $                       k,nbe*nbe*nvirtbe*nvirtbe)
      ii=nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal
         if(ptroute.and.calc.ne.0) then
c     write(6,*) 'change',tfile,cfile
          call change(tfile,cfile) !szemet
c     write(6,*) 'ccit elejen'
      call szemet(tfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
      jj=k+ii
      call denerg(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),v(ii+1),v(ii+jj+1),
     $nvirtal,nvirtbe,nal,nbe,nconf,trec,intrec,oo,
     $istr,nir,nstr,isympv,isympo,tfile,wspca,wspcmax,nactmax,intn,
     $imed,v(jj+1),v(jj+nvirtal*nal+1),v(jj+nvirtal*nal+nvirtbe*nbe+1),
     $v(jj+nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),intfile,sum,0,cfile,
     $.true.)
         else 
           if(calc.ne.0.and.(.not.eomroute))
     $call energy(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),v(ii+1),v(ii+k+1),
     $nvirtal,nvirtbe,nal,nbe,nconf,trec,intrec,oo,
     $istr,nir,nstr,isympv,isympo,tfile,wspca,wsmax,nactmax,intn,
     $imed,v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),intfile,sum,0,cfile,0,
     $nconf,icore(iabsmem),dcore(umatmem),v(1),v(nvirtal*nal+1))
         endif
         if(ptroute) then
C <K|exp(-T) dH/dx exp(T)|0> term
          write(iout,*)
           if(calc.eq.1) then
            write(iout,*)
     $'Calculation of the <K|exp(-T) dH/dx exp(T)|0> term...'
           else
            write(iout,*)
     $'Calculation of the <K|dH/dx C|0> - dE/Dx <K|C|0> term...'
           endif
          call flush(iout)
          t1route=.true.
          call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
c     write(6,*) 'meg elek 2',etot
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
c     write(6,*) 'tfile'
      call szemet(tfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
           if(calc.eq.0.and.ptsym(1).eq.isym) then
            call lincomb(scrfile1,tfile,t1file,1.d0,-eder,trecmax)
             if(rest.ne.0) then
              call hmat(nconf,nmax,sum,ptfile,tfile,0,0,nactmax)
              call lincomb(ptfile,tfile,ptfile,1.d0,-sum,trecmax)
             endif
C
c     write(6,*) 't1file'
      call szemet(t1file,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
           else
            call savevec(scrfile1,t1file,trecmax,0,0)
           endif
          t1route=.false.
           if(calc.eq.1) then
C <0|(1+L) exp(-T) dH/dx exp(T)|K> term
            write(iout,*)
            write(iout,*)
     $'Calculation of the <0|(1+L) exp(-T) dH/dx exp(T)|K> term...'
            call flush(iout)
            leftroute=.true.
            l2route=.true.
            call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax
     $,norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
            call savevec(scrfile1,l2file,trecmax,0,0)
c     write(6,*) 'l2file 1'
      call szemet(l2file,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
            leftroute=.false.
            l2route=.false.
C
            eomroute=.true.
            t2route=.true.
            call fileini(ptfst)
           endif
         endif
        lscr=.true.
2018    continue
        write(iout,*)
         if(calc.eq.0)
     $write(iout,*) 'Starting CI iteration for root ',iroot,'...'
         if(calc.eq.1) then
           if((.not.eomroute).and.(.not.leftroute)) then
            write(iout,*) 'Starting CC iteration...'
           else
             if(eomroute) write(iout,*)
     $'Starting right-hand LR-CC iteration for root ',iroot,'...'
             if(leftroute) write(iout,*)
     $'Starting left-hand LR-CC iteration for root ',iroot,'...'
           endif
         endif
         if(lcc) write(iout,*) 'Starting LCC iteration...'
        write(iout,122)
        call flush(iout)
        nit=0
2017   continue
          nit=nit+1
          norm=0.d0
          eccold=ecc
           if(ss3route)
     $call expt(1,0,.false.,nconf,trec,nconf,trec,nstr,nmax,v,nir,
     $isympv,isympo,ita,tarec,nactm,icore(icoupmem),op,isym,isym,
     $scrfile5,nconf,trec,'ln  ',tfile)
c     write(6,*) 'tfile'
      call mrszemet(tfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
          call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
           if(ss3route) then
      call expt(1,scrfile1,.false.,nconf,trec,nconf,trec,nstr,nmax,v,
     $nir,isympv,isympo,ita,tarec,nactm,icore(icoupmem),op,isym,isym,
     $scrfile5,nconf,trec,'exp ',tfile)
            close(scrfile5,status='delete')
            return
           endif
          norm=dsqrt(norm)
           if(calc.eq.0.or.eomroute) then
             if(norm.gt.0.000000005d0) then
              write(iout,131) norm,test
             else
              write(iout,138) norm,test
             endif
           else
             if(norm.gt.0.000000005d0) then
              write(iout,124) norm
             else
              write(iout,137) norm
             endif
           endif
      ii=nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal
         if(ptroute) then
      jj=k+ii
      call denerg(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),v(ii+1),v(ii+jj+1),
     $nvirtal,nvirtbe,nal,nbe,nconf,trec,intrec,oo,
     $istr,nir,nstr,isympv,isympo,tfile,wspca,wspcmax,nactmax,intn,
     $imed,v(jj+1),v(jj+nvirtal*nal+1),v(jj+nvirtal*nal+nvirtbe*nbe+1),
     $v(jj+nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),intfile,sum,0,cfile,
     $.false.)
         else
           if(calc.ne.0.and.(.not.eomroute).and.(.not.leftroute))
     $call energy(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),v(ii+1),v(ii+k+1),
     $nvirtal,nvirtbe,nal,nbe,nconf,trec,intrec,oo,
     $istr,nir,nstr,isympv,isympo,tfile,wspca,wsmax,nactmax,intn,
     $imed,v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),intfile,sum,0,cfile,0,
     $nconf,icore(iabsmem),dcore(umatmem),v(1),v(nvirtal*nal+1))
         endif
          call timer
           if(nit.eq.1) then
            emp2=ecc
       if(op.gt.1.and.(rest.eq.0).and.calc.ne.0.and.mrop.gt.1.and.
     $conver.ne.1.and.(.not.eomroute).and.(.not.leftroute).and.
     $(nactv*nacto.eq.0.or.mrop.eq.maxex).and.ihf.ne.0)!.and.locno.eq.0)
     $call prtenerg('MP2',emp2,.false.,.true.,.false.)
           endif
          write(iout,*)
           if(eomroute.or.leftroute.or.qcc.eq.1) ecc=ecc+gene
           if(zroute) ecc=eene
          sum=dabs(ecc-eccold)
           if(calc.eq.0.or.eomroute.or.leftroute) then
             if(sum.gt.0.000000005d0) then
              write(iout,129) nit,ecc,sum
             else
              write(iout,136) nit,ecc,sum
             endif
           else
             if(sum.gt.0.000000005d0) then
              write(iout,119) nit,ecc,sum
             else
              write(iout,135) nit,ecc,sum
             endif
           endif
          call flush(iout)
          write(iout,122)
c        if(eomcc.and.iroot.eq.1.and.(.not.eomroute).and.
c    $(.not.leftroute)) then
c         norm=dsqrt(norm)
c         sum=100.d0*sum
c        endif
         if((norm.lt.1d-14.or.test.lt.1d-14).and.(calc.eq.0.or.
     $eomroute)) goto 2020
         if((sum.gt.tol.or.norm.gt.tol).and.nit.lt.maxit) 
     $goto 2017
135   format(' Iteration',i3,2x,'CC energy:',f15.8,2x,'Energy decrease:'
     $,1pe13.4)
136   format(' Iteration',i3,2x,'CI energy:',f15.8,2x,'Energy decrease:'
     $,1pe13.4)
119   format(' Iteration',i3,2x,'CC energy:',f15.8,2x,'Energy decrease:'
     $,f13.8)
129   format(' Iteration',i3,2x,'CI energy:',f15.8,2x,'Energy decrease:'
     $,f13.8)
122   format(1x,70('='))
124   format(' Norm of residual vector: ',f14.8)
137   format(' Norm of residual vector: ',1pe14.4)
131   format(' Norm of residual vector: ',f14.8,'      Convergence:',
     $f13.8)
138   format(' Norm of residual vector: ',1pe14.4,'      Convergence:',
     $1pe13.4)
2020  continue
        write(iout,*)
         if((sum.gt.tol.or.norm.gt.tol).and.nit.ge.maxit) then
          write(iout,
     $"(' Convergence not achieved in',i3,' iterations!')") nit
         else
          write(iout,"(' Iteration has converged in',i3,' steps.')") nit
         endif
        write(iout,*)
        write(iout,*) 'Final results:'
         if(iroot.eq.1) then
          call prtenerg(method1,ecc,.true.,.true.,.false.)
         else
          call prtenerg(method2,ecc,.true.,.true.,.false.)
         endif
         if(lscr.and.hess.and.(.not.ptroute)) then
          read(prfile,rec=1) ibuf
          ibuf(3)=ecc-eref
          write(prfile,rec=1) ibuf
         endif
         if(op.gt.1.and.(rest.eq.0).and.calc.ne.0.and.mrop.gt.1.and.
     $conver.ne.1.and.(.not.eomroute).and.(.not.leftroute).and.
     $(nactv*nacto.eq.0.or.mrop.eq.maxex).and.ihf.ne.0)!.and.locno.eq.0)
     $call prtenerg('MP2',emp2,.true.,.false.,.false.)
        call flush(iout)
         if(iroot.eq.1.and..not.leftroute.and.qcc.eq.0) gene=ecc
         if(iroot.gt.1.and.eomroute) eene=ecc
        eex=ecc-gene
         if(iroot.gt.1) then
          write(iout,"(' Excitation energy [eV]:       ',f10.4)") 
     $eex*evtoeh
          write(iout,"(' Excitation energy [cm^-1]:',f12.2)") 
     $eex*cmtoeh
          write(iout,"(' Absorption wavelength [nm]: ',f10.2)") 
     $(10.d0*clight*planck/jtoeh)/eex
         endif
132   format(' Excitation energy:            ',f10.4,'eV',f12.2,'cm-1',
     $f10.2,'nm') 
         if(nroot.gt.1) write(iout,*) 'Spin multiplicity:',multip
c     write(6,*) 'tfile'
        call szemet(tfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
         if(iroot.lt.nroot.or.(eomroute.and.left).or.
     $(nroot.eq.1.and.left)) then
          write(iout,*)
          write(iout,*)
         endif
c      if(sacc.lt.0) then
c       call saccif(nvirtal,nvirtbe,nal,nbe,nconf,trec,nstr,nmax,nir,
c    $isympv,isympo,icore(istrecmem),nactm,norm)
c      endif
C Save lh LR-CC coefficients
         if(leftroute.and.(.not.lscr).and.(.not.zroute).and.(.not.
     $ptroute).and.qcc.eq.0) 
     $call savevec(tfile,lfile,trecmax,0,(iroot-1)*trecmax)
C Construct intermediates for perturbation corrections
       if(pert.gt.0.and.pert.le.3.and..not.leftroute) then
        pertroute=-1
        call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
        pertroute=0
       endif
C Perturbation corrections
       if((pert.gt.0.and.pert.le.2).or.(pert.eq.3.and.leftroute)) then
        write(iout,*)
        write(iout,*) 'Perturbative corrections are calculated...'
        write(iout,122)
         if(pert.eq.3) then
          leftroute=.false.
          eomroute=.false.
          call savevec(cfile,tfile,trecmax,0,0)
         endif
      call pertcorr(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ioffs,scspe)
       endif
C Save rh LR-CC or CI coefficients
         if(calc.eq.0.and.isy1.ne.isy2.and.iroot.eq.1)
     $call savevec(cfile,mpfile,trecmax,0,0)
         if((eomroute.or.calc.eq.0).and.(.not.ptroute)) then
           if(nroot.gt.1) then
             if(diag.eq.1) then
              ii=tfile
             else
              ii=scrfile1
             endif
             do i=1,trecmax
              read(ii,rec=i) ibuf
              write(cfile,rec=irecmax+i) ibuf
             enddo
             if((diag.eq.0.or.diag.eq.2).and.dens.gt.0) 
     $call savevec(scrfile1,tfile,trecmax,0,0)
           else
             if(diag.eq.0.or.diag.eq.2) 
     $call savevec(scrfile1,tfile,trecmax,0,0)
C Fix the phase of wf for wf derivatives
        call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
     $denrec,econf,erec)
             if(calc.eq.0.and.hess) then
              read(tfile,rec=1) ibuf
               if(ibuf(1).lt.0.d0) then
                 do i=1,trecmax
                  read(tfile,rec=i) ibuf
                   do j=1,ibufln
                    ibuf(j)=-ibuf(j)
                   enddo
                  write(tfile,rec=i) ibuf
                 enddo
               endif
             endif
             if(dens.gt.0) call savevec(tfile,cfile,trecmax,0,0)
           endif
         endif
C Print wave function
         if(ltpr.and..not.leftroute) then
          call mpdenom(nconf,trec,nstr,intrec,nmax,v,v(1+nvirtal),
     $v(1+nvirt),v(1+nvirt+nal),v(1+spsht+nbasis/2+nbasis**2/2),nir,
     $isympv,isympo,istr,v,v(1+nbasis/2),v(1+nbasis/2+nbasis**2/4),
     $v(1+spsht),v(1+spsht+nbasis/2),nbasis/2,wspcb,wspca,wsmax,nactm,
     $imed,intn,icore,absind,strec,imem+spsht+nbasis/2+nbasis**2/2,
     $.false.,.true.,tprtol,erec,econf)
         endif
C Calculate constant terms
         if((ptroute.and.lscr).or.(eomgrad.and.leftroute.and.iroot.gt.1
     $.and.(.not.zroute).and.(.not.osc)).or.(eomgrad.and.osc.and.
     $iroot.gt.1.and.eomroute)) then
           if(ptroute) then
            ii=(calc+1)*(naopt-1)*trecmax+1
             if(calc.eq.0.and.(ptfreq.ne.0.d0.or.optrec)) then
               if(fdpci) then
                ii=2*(naopt-1)*trecmax+1
               else
                ii=2*(naopt-1)*trecmax+trecmax+1
               endif
             endif
            call savevec(ptfile,prfile,trecmax,0,ii)
             if(optrec) 
     $call savevec(ptfile,prfile,trecmax,0,2*(naopt-1)*trecmax+1)
           endif
           if(eomgrad.and.iroot.gt.2)
     $call wschange(wspca,wspcb,wsmax,intrec,imedsyma,imedsymb)
          eomroute=.false.
          t2route=.false.
           if(calc.eq.1) then
C <0|(1+L)[exp(-T) H exp(T), dT/dx]|K> term
            write(iout,*)
            write(iout,*)
     $'Calculation of the <0|(1+L)[exp(-T) H exp(T), dT/dx]|K> term...'
            call flush(iout)
            leftroute=.true.
            l3route=.true.
            call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax
     $,norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
             if(eomgrad) call savevec(scrfile1,l2file,trecmax,0,0)
             if(ptroute) call lincomb(scrfile1,l2file,l2file,1.d0,1.d0,
     $trecmax)
c     write(6,*) 'l2file 2'
      call szemet(l2file,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
            l3route=.false. 
C <0|(1+L)[exp(-T) {p+q-} exp(T), dT/dx]|0> term
            write(iout,*)
            write(iout,*)
     $'Calculation of the <0|(1+L)[exp(-T){p+q-}exp(T), dT/dx]|0> term..
     $.'
            call flush(iout)
            densroute=.true.
            d2route=.true.
c     write(6,*) 'D2 route'
            call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax
     $,norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
            call savevec(scrfile1,t1file,drecmax,0,0)
c     write(6,*) 't1file'
      call szemet(t1file,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
            d2route=.false.
            densroute=.false.
             if(ptroute) then
              call fileini(ptfst)
              l1route=.true.
               if(rest.eq.0) call savevec(ptfile,plfile,trecmax,0,0)
             endif
             if(eomgrad) then
              call fileini(leftfst)
               if(isym.ne.1.and.(.not.osc)) then
                call savevec(scrfile8,mpfile,trecmax,0,0)
                close(scrfile8,status='delete')
               endif
              call wschange(wspca,wspcb,wsmax,intrec,imedsyma,imedsymb)
               if(iroot.eq.nroot) close(wsfile,status='delete')
               if(osc) then
                leftroute=.true.
                 if(rest.ne.0.and.abs(rest).lt.3) then
        call savevec(lfile,tfile,trecmax,(iroot-1)*trecmax,0)
        call hmat(econf,nmax,sum,cfile,tfile,(iroot-1)*trecmax,0,nactm)
        call normate(sum,tfile,tfile)
                 else
                  call dfillzero(ibuf,ibufln)
                   if(isym.eq.1) write(tfile,rec=1) ibuf
                 endif
               else
                zroute=.true.
                 if(rest.ne.0.and.abs(rest).lt.3) then
                  call savevec(lfile,tfile,trecmax,0,0)
                 else
                  call dfillzero(ibuf,ibufln)
                  ibuf(1)=1.d0
                  write(tfile,rec=1) ibuf
                  call filezero(tfile,2,trecmax)
                 endif
               endif
             endif
            lscr=.false.
            goto 2018
           endif
         endif
        l1route=.false.
C Save cluster amplitudes
         if((eomcc.or.left).and.iroot.eq.1.and.lscr.and.qcc.eq.0) then
           if(((.not.left).or.nroot.eq.1.or.isym.eq.1).and.pert.ne.3
     $.and.qcc.eq.0) call savevec(cfile,mpfile,trecmax,0,0)
          call savevec(tfile,cfile,trecmax,0,0)
         endif
C Save Z vector
         if(zroute) then
           if(osc) then
            call savevec(tfile,lfile,trecmax,0,nroot*trecmax)
           else
            call savevec(tfile,lfile,trecmax,0,0)
           endif
         endif
C DBOC norm contributions
         if(dboc.eq.1.and.ptroute) then
           if(calc.eq.0) then
            call hmat(econf,nmax,sum,ptfile,ptfile,0,0,nactmax)
            write(dbocfile,"(e28.20)") sum
           else if(calc.eq.1) then
C <0|Lambda dT/dx|0>^2
            sum=0.d0
             if(ptsym(1).eq.1)
     $call hmat(econf,nmax,sum,cfile,ptfile,0,0,nactmax)  !szemet
C <0|dLambda/dx dT/dx|0>
      call hmat(econf,nmax,sum1,plfile,ptfile,0,0,nactmax)  !szemet
C <0|Lambda dT/dx dT/dx|0>
      call expt(1,ptfile,.false.,econf,erec,econf,erec,nstr,nmax,v,nir,
     $isympv,isympo,ita,tarec,nactm,icore(icoupmem),1,ptsym,ptsym,
     $ptfile,nconf,trec,'exp ',scrfile2)
      call hmat(nconf,nmax,sum2,cfile,scrfile3,0,0,nactmax)  !szemet
c           write(6,"(f16.12)") sum**2+sum1-sum2
            write(dbocfile,"(e28.20)") sum**2+sum1-sum2
           endif
         endif
C Calculate density-matrix
         if(dens.gt.0.and.(((.not.lscr).and.(iroot.gt.1.or.
     $(.not.eomgrad))).or.calc.eq.0.or.qcc.eq.1).and.
     $(iroot.gt.1.or.(.not.osc))) then
      write(iout,*)
      write(iout,"(' Calculating reduced density-matrix for root',i2,
     $'...')") iroot
      write(iout,*)
          call flush(iout)
          densroute=.true.
          log1=eomroute
          log2=leftroute
          eomroute=.false.
          leftroute=.true.
           if(eomgrad.and.((.not.osc).or.zroute)) d1route=.true.
          zroute=.false.
           if(ptroute.and.calc.ne.0) then
            d1route=.true.
            ii=2*(naopt-1)*trecmax+trecmax+1
            call savevec(plfile,prfile,trecmax,0,ii)
           endif 
          call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
          densroute=.false.
          eomroute=log1
          leftroute=log2
           if(eomgrad.and.osc.and.(.not.d1route)) then
            zroute=.true.
             if(rest.ne.0.and.abs(rest).lt.3) then
              call savevec(lfile,tfile,trecmax,nroot*trecmax,0)
             else
              call filezero(tfile,1,trecmax)
             endif
            goto 2018
           endif
          d1route=.false.
           if(fdpci) then
            fdpci=.false.
            ptfreq=-ptfreq
             if(rest.ne.0) then
              ii=2*(naopt-1)*trecmax+trecmax+1
              call savevec(prfile,ptfile,trecmax,ii,0)
             else
              call filezero(ptfile,1,trecmax)
             endif
            goto 2018
           endif
         endif
C DBOC antisymmetrized perturbed density for CC
         if(dboc.eq.1.and.ptroute.and.calc.eq.1) then
C <0| (1+Lambda) dT/dx exp(-T) p^+q exp(T)|0>
      call expt(1,cfile,.true.,nconf,trec,econf,erec,nstr,nmax,v,nir,
     $isympv,isympo,ita,earec,nactm,icore(icoupmem),1,1,ptsym,ptfile,
     $econf,erec,'exp ',scrfile2)
          call savevec(scrfile3,l2file,trecmax,0,0)
C
          densroute=.true.
          log1=eomroute
          log2=leftroute
          eomroute=.false.
          leftroute=.true.
          d1route=.true.
          dbroute=.true.
          call step(nstr,nconf,trec,intrec,imed,icore(icoupmem),v,nmax,
     $norm,isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,
     $wsmax,intn,nactmax,ntcase,earec,econf,erec,denrec,trec2,erec2
     $,tcase,itypa,itypb,imedsyma,imedsymb,l2map,ndiis,ioffs,scspe)
          densroute=.false.
          eomroute=log1
          leftroute=log2
          d1route=.false.
          dbroute=.false.
         endif
C
         if(ptroute.and.calc.eq.1) then
          call change(tfile,cfile) !szemet
          return
         endif
         if(eomcc.and.(lscr.or.(.not.hess))) then
           if(.not.osc) call fileini(leftfst)
          eomroute=.true.
         endif
c      if(left.and.lscr.and.(.true.))then
         if(left.and.lscr.and.(iroot.gt.1.or.(.not.eomgrad).or.osc).and.
     $qcc.eq.0) then
C Left-hand LR-CC (or Lambda) calculations
          leftroute=.true.
          eomroute=.false.
          lscr=.false.
           if(rest.ne.0.and.abs(rest).lt.3) then
             if(qcc.eq.0) 
     $call savevec(lfile,tfile,trecmax,(iroot-1)*trecmax,0)
             if(iroot.gt.1) then
        call hmat(econf,nmax,sum,cfile,tfile,(iroot-1)*trecmax,0,nactm)
        call normate(sum,tfile,tfile)
             endif
           else
             if(iroot.eq.1) then
               if(qcc.eq.0) then
                call dfillzero(ibuf,ibufln)
                ibuf(1)=1.d0
                write(tfile,rec=1) ibuf
                call filezero(tfile,2,trecmax)
               endif
             else
              call savevec(scrfile1,tfile,trecmax,0,0)
              call dfillzero(ibuf,ibufln)
               if(isym.eq.1) write(tfile,rec=1) ibuf
             endif
           endif
          goto 2018
         endif
        irecmax=irecmax+trecmax
C
       if(dboc.eq.2.and.calc.eq.1) then
        call savevec(cfile,tfile,trecmax,0,0)
        call expt(1,0,.false.,nconf,trec,nconf,trec,nstr,nmax,v,nir,
     $isympv,isympo,ita,tarec,nactmax,icore(icoupmem),op,isym,isym,
     $tfile,nconf,trec,'exp ',scrfile2)
        call hmat(nconf,nmax,norm,scrfile2,scrfile2,0,0,nactm)
        norm=dsqrt(norm)
c       call normate(norm,scrfile2,scrfile2)
c       write(6,*) 'exp(T)|0>'
c       call szemet(scrfile2,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
c    $denrec,econf,erec)
C
        call expt(-1,lfile,.true.,nconf,trec,nconf,trec,nstr,nmax,v,nir,
     $isympv,isympo,ita,tarec,nactmax,icore(icoupmem),op,isym,isym,
     $tfile,nconf,trec,'exp ',scrfile2)
        call hmat(nconf,nmax,sum,scrfile2,scrfile2,0,0,nactm)
        sum=dsqrt(sum)
        write(iout,"(' N_R=       ',f18.12)") norm
        write(iout,"(' 1/N_L=     ',f18.12)") 1.d0/sum
        write(iout,"(' N_L=       ',f18.12)") sum
        write(iout,"(' 1/N_R=     ',f18.12)") 1.d0/norm
        write(iout,"(' N_R-1/N_L= ',f18.12)") norm-1.d0/sum
        write(iout,"(' N_L-1/N_R= ',f18.12)") sum-1.d0/norm
c       call normate(sum,scrfile2,scrfile2)
c       write(6,*) '<0|(1+L)exp(-T)'
c       call szemet(scrfile2,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
c    $denrec,econf,erec)
c      else
c       write(6,*) 'C vector'
c       call szemet(cfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
c    $denrec,econf,erec)
       endif
C Retrieve non-tot.symmetric spin-cases for higher lh LR-CC roots
         if(nroot.gt.1.and.iroot.eq.1.and.((calc.eq.0.and.isy1.ne.isy2)
     $.or.(left.and.(isym.ne.1.or.eomgrad).and.(.not.osc)))) then
          call wschange(wspca,wspcb,wsmax,intrec,imedsyma,imedsymb)
           if(calc.eq.0) then
            isym=isy2
            ptsh=nimed2
           endif
         endif
       enddo
128   format(' Correlation energy [au]:              ',25f14.8) 
134   format(' Derivative of correlation energy [au]:',25f14.8) 
C
c     write(6,*) 'tfile 1'
c     call szemet(tfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
c    $denrec,econf,erec)
c     call expt(1,0,.false.,nconf,trec,nconf,trec,nstr,nmax,v,nir,
c    $isympv,isympo,ita,tarec,nactmax,icore(icoupmem),op,isym,isym,
c    $tfile,nconf,trec,'exp ',scrfile2)
c     write(6,*) 'tfile 2'
c     call szemet(scrfile2,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
c    $denrec,econf,erec)
c     call savevec(scrfile2,tfile,trecmax,0,0)
C
      return
      end
C
************************************************************************
      subroutine step(nstr,nconf,trec,intrec,imed,icmem,v,nmax,norm,
     $isympv,isympo,ita,tarec,iwa,isa,isw,istr,test,wspcb,wspca,wsmax,
     $intn,nactm,ntcase,earec,econf,erec,denrec,trec2,erec2,tcase,
     $itypa,itypb,imedsyma,imedsymb,l2map,ndmax,ioffs,scspe)
************************************************************************
* This subroutine performs one CC iteration step                       *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,ita(*),istr,nstr,i,k,l,m,n,icmem,ii,jj,l2map
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,1),j
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,1),ic1
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),iii
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),file1
      integer intrec(*),isympv,isympo,isw,iwa(*),file,wsmax,intn(*),isa
      integer iadd0(0:wsmax),iadd1(0:wsmax),nn,iactvb,iactob,ntcase(0:1)
      integer iadd2(0:wsmax),iadd3(0:wsmax),iactv,iacto,iactva,iactoa
      integer n1,n2,n3,n4,nn1,nn2,nn3,nn4,imed,ifi,earec,wspc3(0:wsmax)
      integer nvintnew1,nointnew1,nvirtnew1,noccnew1,nvintold1,nointold1
      integer nvirtold1,noccold1,namp1,ical1,isig11,isave1,nptype,ioffs
      integer nvintnew2,nointnew2,nvirtnew2,noccnew2,nvintold2,nointold2
      integer nvirtold2,noccold2,namp2,ical2,isig12,isave2,nlist
      integer nvintnew3,nointnew3,nvirtnew3,noccnew3,nvintold3,nointold3
      integer nvirtold3,noccold3,namp3,ical3,isig13,isave3,ssym
      integer nvintnew4,nointnew4,nvirtnew4,noccnew4,nvintold4,nointold4
      integer nvirtold4,noccold4,namp4,ical4,isig14,isave4,imedsyma(*)
      integer nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,iadds(0:wsmax)
      integer nvintold1a,nointold1a,nvirtold1a,noccold1a,itypb(*),icl1
      integer nvintnew2a,nointnew2a,nvirtnew2a,noccnew2a,file2,convero
      integer nvintold2a,nointold2a,nvirtold2a,noccold2a,itypa(*)
      integer nvintnew3a,nointnew3a,nvirtnew3a,noccnew3a,imedsymb(*)
      integer nvintold3a,nointold3a,nvirtold3a,noccold3a,ndmax
      integer nvintnew4a,nointnew4a,nvirtnew4a,noccnew4a
      integer nvintold4a,nointold4a,nvirtold4a,noccold4a
      integer wspcb(0:wsmax,13),wspca(0:wsmax,13),tarec,denrec(*),drec
      integer trec2((2*nactm+1)**2,0:nmax),erec2((2*nactm+1)**2,0:nmax)
      integer tcase(2,(2*nactm+1)**2,0:nmax),iterm
      real*8 v(*),norm,sum,c0,c1,denom,e1,chc(2,2),a1,test,sum1,scspe
      real*8 cveco(ndmax)
      character*5 eomcheck
      logical log,llog,log1,log2,log3,log4,ldir,lpar
      lpar=.true.
#if defined (MPI)
       if(rank.ne.0) lpar=.false.
#endif
c       write(6,*) 'step'
C File structure
c      do i=1,4
c       write(6,*) 'prfile',i
c       densroute=.false.
c     call szemet(61,nconf,nmax,nactm,trec,v,(i-1)*trecmax+1,wspca,
c    $wsmax,denrec,econf,erec)
c       densroute=.true.
c      enddo
c     write(6,*) 'mpfile'
c     call szemet(mpfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
c    $econf,erec)
      lamfile=cfile
      ampfile=tfile
       if(calc.eq.0.and.ptroute.and.(.not.t1route).and.(.not.densroute))
     $ampfile=ptfile
       if(leftroute.or.densroute) then
         if(ptroute) then
           if(l1route.or.d1route) lamfile=plfile
           if(dbroute) lamfile=l2file
           if(calc.eq.0) lamfile=ptfile
           if(dsroute.or.dtroute) then
            ampfile=cfile
            lamfile=tfile
             if(ds1route.or.dt1route) lamfile=prfile
             if(ds1route.and.calc.eq.0) ampfile=prfile
           endif
         else
          lamfile=tfile
          ampfile=cfile
           if(calc.eq.0.and..not.osc) ampfile=tfile
           if(osc.and.(l3route.or.d2route)) lamfile=lfile
         endif
       endif
       if(qcc.eq.1) then
        lamfile=lfile
        ampfile=tfile
C QCC, calculate (1+L+L^2/2)|0>
        open(scrfile7,status='unknown',access='direct',recl=irecln)
        call expt(1,0,.false.,nconf,trec,nconf,trec,nstr,nmax,v,
     $nir,isympv,isympo,ita,tarec,nactm,icore(icoupmem),2,isym,isym,
     $lamfile,nconf,trec,'exp ',scrfile7)
       endif
3845  continue
       if(qcc.eq.1.and.leftroute) lamfile=scrfile7
C Symmetries of lambda amplitudes
      j=isym
       if(l1route.or.d1route.or.(ptroute.and.calc.eq.0).or.ds1route) 
     $j=ptsym(1)
       if(dt1route) j=ptsym(3)
       if(calc.eq.1.and.(iroot.eq.1.or.(zroute.and.(.not.osc)).or.
     $(d1route.and.(.not.osc)).or.((l3route.or.d2route).and.osc)).and.
     $eomgrad) j=1
       if(calc.eq.0.and.osc) j=isy2
       do i=-op,0
        imedsyma(i)=j
        imedsymb(i)=j
       enddo
C Initialize scratch file
      sum=0.d0
      call dfillzero(ibuf,ibufln)
      ic1=calc
       if((calc.eq.0.or.eomroute).and.(.not.densroute).and.
     $((.not.ptroute).or.calc.ne.1)) then
        chc(1,1)=ecc-eref
         if(eomroute) chc(1,1)=ecc-gene
         if(nit.eq.1.or.diag.eq.0.or.diag.eq.2) then
          file=tfile
         else
          file=diisfile
         endif
         if(ptroute) file=ampfile
         if((econf(0,0,0,0,0,0).eq.1.and.(calc.ne.0.or.isy1.eq.isy2.or.
     $isym.eq.isy2)).or.(nconf(0,0,0,0,0,0,1).eq.1.and.calc.eq.0.and.
     $isy1.ne.isy2.and.isym.eq.isy1).or.(t1route.and.ptsym(1).eq.1))then
          k=0
           do i1=0,nactm
             do i2=0,nactm
               do i3=0,nactm
                 do i4=0,nactm
                  k=max(k,nconf(i1,i2,i3,i4,2,2,1))
                  k=max(k,nconf(i1,i2,i3,i4,1,2,1))
                  k=max(k,nconf(i1,i2,i3,i4,0,2,1))
                  k=max(k,econf(i1,i2,i3,i4,2,2))
                  k=max(k,econf(i1,i2,i3,i4,1,2))
                  k=max(k,econf(i1,i2,i3,i4,0,2))
                 enddo
               enddo
             enddo
           enddo
         if(mrop.eq.1) k=max(k,nal*nbe*nvirtal*nvirtbe,
     $                       k,nal*nal*nvirtal*nvirtal,
     $                       k,nbe*nbe*nvirtbe*nvirtbe)
      ii=nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal
      jj=0
       if(eomroute) then
        jj=k+ii
        k=0
       endif
       if(calc.eq.0.and.(t1route.or.(isy1.ne.isy2.and.isym.eq.isy1))) 
     $then
        call energy(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal+1),v(ii+jj+k+1),
     $nvirtal,nvirtbe,nal,nbe,nconf,trec,intrec,oo,
     $istr,nir,nstr,isympv,isympo,file,wspca,wspcmax,nactmax,intn,
     $imed,v(jj+1),v(jj+nvirtal*nal+1),v(jj+nvirtal*nal+nvirtbe*nbe+1),
     $v(jj+nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),intfile,c0,ptsh,cfile,
     $0,nconf,icore(iabsmem),dcore(umatmem),v(1),v(nvirtal*nal+1))
       else 
        call energy(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal+1),v(ii+jj+k+1),
     $nvirtal,nvirtbe,nal,nbe,econf,erec,intrec,oo,
     $istr,nir,nstr,isympv,isympo,file,wspca,wspcmax,nactmax,intn,
     $imed,v(jj+1),v(jj+nvirtal*nal+1),v(jj+nvirtal*nal+nvirtbe*nbe+1),
     $v(jj+nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),intfile,c0,0,cfile,0,
     $nconf,icore(iabsmem),dcore(umatmem),v(1),v(nvirtal*nal+1))
       endif
          call dfillzero(ibuf,ibufln)
          ibuf(1)=ecc-eref
          sum=ibuf(1)
c     write(6,*) 'ibuf(1)',ibuf(1)
          read(file,rec=1) ibuf1
          c0=ibuf1(1)
c         write(6,*)'ibuf1 1111', ecc,eref,ibuf1(1)
           if(t1route.and.nconf(0,0,0,0,0,0,1).eq.0) c0=0.d0
         else
          call dfillzero(ibuf,ibufln)
          c0=0.d0
           if(t1route.and.nconf(0,0,0,0,0,0,1).eq.1) then
            read(file,rec=1) ibuf1
            c0=ibuf1(1)
           endif
         endif
       else
        file=tfile
         if((ptroute.and.leftroute).or.(osc.and.l3route).or.
     $(qcc.eq.1.and.leftroute)) file=lamfile
        call dfillzero(ibuf,ibufln)
        ibuf(1)=1.d0
        c0=1.d0
         if(densroute.and.calc.eq.0) then
          read(tfile,rec=1) ibuf1
          c0=ibuf1(1)
           if(ptroute.and.nconf(0,0,0,0,0,0,1).eq.0) c0=0.d0
         endif
         if(leftroute) then
          ibuf(1)=0.d0
           if((iroot.gt.1.and.((.not.zroute).or.osc).and.(.not.d1route)
     $.and.(.not.densroute).and.(.not.l3route)).or.l1route) then
            c0=0.d0
            ic1=0
           endif
           if(d1route.and.((.not.eomgrad).or.osc)) c0=0.d0
           if(eomgrad.and.(l3route.or.d2route).and.(.not.osc)) c0=0.d0
         endif
       endif
       if(ds1route.and.calc.eq.0) then
         if(nconf(0,0,0,0,0,0,nirmap(ptsym(2))).eq.1.and.ptsym(2).eq.1) 
     $then
           if(ptfreq.ne.0.d0.or.optrec) then
            read(prfile,rec=(2*nopt(2)-1)*trecmax+2) ibuf1
           else
            read(prfile,rec=  (nopt(2)-1)*trecmax+2) ibuf1
           endif
          c0=ibuf1(1)
         else
          c0=0.d0
         endif
       endif
      c1=c0
       if(densroute.and.calc.eq.0.and.osc) then
        read(cfile,rec=1) ibuf1
        c1=ibuf1(1)
       endif
       if(dbroute) then
        read(lamfile,rec=1) ibuf1
        c0=-2.d0*ibuf1(1)
       endif
       if(.not.lpar.or.qcc.eq.1) call dfillzero(ibuf,ibufln)
       if(.not.(ds2route.or.dt2route)) write(scrfile1,rec=1) ibuf
      ibuf(1)=0.d0
      k=trecmax
      nn=op
       if(pert.ne.0) then
         if(pertroute.eq.0.and.pert.le.3) nn=op-1
         if(pertroute.gt.0.and.pertroute.le.op+2) nn=pertroute-4
         if(pertroute.gt.op+2) nn=pertroute-4-op
       endif
       if(qcc.eq.1.and.leftroute) nn=qccop
       if(sacc.lt.0) nn=op !PT
       if(sacc.gt.0) nn=2  !Miriam
c      if(sacc.ne.0) nn=4  !test
       if(densroute) then
        k=drecmax
        nn=iimed
       endif
       if(lpar.and.((eomgrad.and.d1route).or.(ptroute.and.(eomroute.or.
     $(d1route.and.(dboc.ne.1.or.calc.ne.1)).or.(calc.eq.0.and.
     $(.not.t1route).and.(.not.densroute))))))
     $then
         if(ptfreq.ne.0.d0.and.ptroute.and.eomroute) then
          call lincomb(t1file,ptfile,scrfile1,1.d0,-ptfreq,trecmax)
         else
          call savevec(t1file,scrfile1,k,0,0)
         endif
       else if(lpar.and.(l1route.or.zroute)) then
        if((zroute.and.osc).or.(ptfreq.ne.0.d0.and.ptroute.and.l1route))
     $then
          sum1=eex
           if(ptfreq.ne.0.d0.and.ptroute.and.l1route) sum1=ptfreq
          call lincomb(l2file,lamfile,scrfile1,1.d0,sum1,trecmax)
         else
          call savevec(l2file,scrfile1,k,0,0)
         endif
       else if(.not.(ds2route.or.dt2route)) then
         do i=2,k
          write(scrfile1,rec=i) ibuf
         enddo
c tszemet eleje
      iterm=0
       else
      iterm=0
      open(unit=91,file='iterm',status='old',err=7653)
      rewind(91)
      read(91,*) iterm
      close(91)
7653  continue
c     write(6,*) 'iterm step',iterm
       if(iterm.ne.0) then
         do i=2,k
          write(scrfile1,rec=i) ibuf
         enddo
       endif
c tszemet vege
       endif
       if(lpar.and.ptroute.and.calc.eq.0.and.(.not.t1route).and.
     $(.not.densroute)) then
        read(scrfile1,rec=1) ibuf
        ibuf(1)=ibuf(1)+sum
        write(scrfile1,rec=1) ibuf
       endif
c     write(6,*) 'densroute',densroute,d2route,l3route
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
C Reading formula tape
      llog=((.not.leftroute).or.(iroot.eq.1.and.nit.eq.1).or.l2route.or.
     $l3route.or.(eomgrad.and.iroot.ne.1.and.nit.eq.1.and.(.not.zroute)
     $.and.(.not.osc)).or.qcc.eq.1).and.(.not.l1route)
      rewind(ftfile)
       if(eomroute.and.calc.ne.0 )             call readlab('EOMCC')
       if(leftroute.and.calc.ne.0)             call readlab('LEFT ')
       if(densroute)                           call readlab('DENS ')
       if(l3route)                             call readlab('DLEFT')
       if(d2route.or.(ds1route.and.calc.eq.1)) call readlab('DDENS')
       if(ds2route.or.dt1route)                call readlab('D2DEN')
       if(dt2route)                            call readlab('D3DEN')
       do i=1,nn
         if(pert.ge.4.and.i.eq.op) pertroute=-1
         if(ptroute.or.eomroute.or.(leftroute.and.iroot.gt.1.and.
     $(((.not.zroute).and.(.not.d1route).and.(.not.l3route)).or.osc)))
     $then
          ifi=ierecmem+i*((nactm+1)**4)*(nmax+1)
         else
          ifi=itrecmem+i*((nactm+1)**4)*(nmax+1)
         endif
         if(densroute) then
          ii=1
          drec=denrec(i)
         else
          ii=ntcase(i)
         endif
       do nptype=1,ii
         if((pertroute.eq.-1.and.i.ne.op).or.
     $      (pertroute.gt. 0.and.i.lt.nn)) then
          nn1=0
          call skip1(nn1,ftfile)
         else
c       write(6,*) 'nptype',i,nptype,nn,ii
         if(.not.densroute) then
           if(ptroute.or.eomroute.or.(leftroute.and.iroot.gt.1.and.
     $(((.not.zroute).and.(.not.l3route)).or.osc)).or.(calc.eq.0.and.
     $isy1.ne.isy2.and.isym.eq.isy2)) then
            drec=erec2(nptype,i)
           else
            drec=trec2(nptype,i)
           endif
c       write(6,*) 'drec',drec,nptype,i,trec2(nptype,i)
         endif
        read(ftfile,*) n1
c       write(6,*) '#',n1
        call ifillzero(iadd0,wsmax+1)
         if((ptroute.and.(eomroute.or.l1route.or.d1route.or.dt2route.or.
     $ds2route.or.(calc.eq.0
     $.and.(.not.t1route).and.(.not.densroute)))).or.(osc.and.(zroute
     $.or.d1route))) call iaddini(econf,nmax,nactm,i,iadd0,tcase,nptype,
     $wspca,wsmax)
         if((.not.osc).and.(zroute.or.(eomgrad.and.d1route)))
     $call iaddini(nconf,nmax,nactm,i,iadd0,tcase,nptype,wspca,wsmax)
c       write(6,*) '#',n1
         do nn1=1,n1
c         write(6,*) 'nn1',nn1
          call readft(nvintnew1,nointnew1,nvirtnew1,noccnew1,nvintold1,
     $nointold1,nvirtold1,noccold1,namp1,ical1,isig11,nlist,isave1,
     $nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,nvintold1a,nointold1a,
     $nvirtold1a,noccold1a,itypa,1,l2map,log1,intn)
          ldir=.true.
           if(densroute) then
            icl1=i+ptsh
c            if(eomgrad.and.osc) icl1=i+nimed2
           else
            icl1=ical1
           endif
           if(isave1.gt.0.and.(llog.or.itypa(ical1).ne.0).and.log1) then
            read(ftfile,*) n2
             call ifillzero(iadd1,wsmax+1)
             do nn2=1,n2
              call readft(nvintnew2,nointnew2,nvirtnew2,noccnew2,
     $nvintold2,nointold2,nvirtold2,noccold2,namp2,ical2,isig12,nlist,
     $isave2,nvintnew2a,nointnew2a,nvirtnew2a,noccnew2a,nvintold2a,
     $nointold2a,nvirtold2a,noccold2a,itypa,2,l2map,log2,intn)
c        write(6,"('readft utan',100i4)"),
c    $nvintnew2,nointnew2,nvirtnew2,noccnew2,
c    $nvintold2,nointold2,nvirtold2,noccold2,namp2,ical2,isig12,nlist,
c    $isave2,nvintnew2a,nointnew2a,nvirtnew2a,noccnew2a,nvintold2a,
c    $nointold2a,nvirtold2a,noccold2a
               if(isave2.eq.0.and.nn2.eq.1) ldir=.false.
               if(isave2.gt.0.and.(llog.or.itypa(ical2).ne.0).and.log2) 
     $then
                read(ftfile,*) n3
                call ifillzero(iadd2,wsmax+1)
                 do nn3=1,n3
                  call readft(nvintnew3,nointnew3,nvirtnew3,noccnew3,
     $nvintold3,nointold3,nvirtold3,noccold3,namp3,ical3,isig13,nlist,
     $isave3,nvintnew3a,nointnew3a,nvirtnew3a,noccnew3a,nvintold3a,
     $nointold3a,nvirtold3a,noccold3a,itypa,3,l2map,log3,intn)
                   if(isave3.gt.0.and.(llog.or.itypa(ical3).ne.0).and.
     $log3) then
                    read(ftfile,*) n4
                    call ifillzero(iadd3,wsmax+1)
                     do nn4=1,n4
                      call readft(nvintnew4,nointnew4,nvirtnew4,noccnew4
     $,nvintold4,nointold4,nvirtold4,noccold4,namp4,ical4,isig14,nlist,
     $isave4,nvintnew4a,nointnew4a,nvirtnew4a,noccnew4a,nvintold4a,
     $nointold4a,nvirtold4a,noccold4a,itypa,4,l2map,log4,intn)
                       if(isave4.gt.0.and.(llog.or.itypa(ical4).ne.0)
     $.and.log4) then
      call conin1(trec,nstr,nmax,icmem,nvintnew4,nointnew4,nvirtnew4,
     $noccnew4,nvintold4,nointold4,nvirtold4,noccold4,namp4,isig14,
     $scrfile4,0,intfile,intrec(nlist),iadd3,iadd3,.true.,v,isave4,
     $intrec(ical4),isympv,isympo,nir,nconf,ita,tarec,iwa,isa,isw,
     $iwa(nir**6+1),file,wspcb(0,ical3),wspca(0,nlist),wspca(0,ical4),
     $wsmax,nvintnew4a,nointnew4a,nvirtnew4a,noccnew4a,nvintold4a,
     $nointold4a,nvirtold4a,noccold4a,nactmax,earec,erec,econf,4,imed,
     $wspca,intrec,itypa(ical4),itypb(ical4),imedsyma(ical4),
     $imedsymb(ical4),ioffs,scspe)
                       else
      call imedret(scrfile4,0,wspcb(0,ical3),intfile,intrec(ical4),
     $isig14,iadd3,v,nmax,2,1,c0,wspcb(0,ical3),wspca(0,ical4),nactmax,
     $0,0,ical4,nconf,trec,econf,erec,nvintnew4a+nvirtnew4a,
     $nointnew4a+noccnew4a,wsmax,4,isave4,itypa(ical4),imedsyma(ical4),
     $scspe)
                       endif
                     enddo
      call conin1(trec,nstr,nmax,icmem,nvintnew3,nointnew3,nvirtnew3,
     $noccnew3,nvintold3,nointold3,nvirtold3,noccold3,namp3,isig13,
     $scrfile3,0,scrfile4,0,iadd2,iadd3,.false.,v,isave3,intrec(ical3),
     $isympv,isympo,nir,nconf,ita,tarec,iwa,isa,isw,iwa(nir**6+1),file,
     $wspcb(0,ical2),wspcb(0,ical3),wspca(0,ical3),wsmax,nvintnew3a,
     $nointnew3a,nvirtnew3a,noccnew3a,nvintold3a,nointold3a,nvirtold3a,
     $noccold3a,nactmax,earec,erec,econf,3,imed,wspca,intrec,
     $itypa(ical3),itypb(ical3),imedsyma(ical3),imedsymb(ical3),ioffs,
     $scspe)
                   else
c      write(6,*) 'imedret 3 elott',ical3
      call imedret(scrfile3,0,wspcb(0,ical2),intfile,intrec(ical3)
     $,isig13,iadd2,v,nmax,2,1,c0,wspcb(0,ical2),wspca(0,ical3),nactmax,
     $0,0,ical3,nconf,trec,econf,erec,nvintnew3a+nvirtnew3a,
     $nointnew3a+noccnew3a,wsmax,3,isave3,itypa(ical3),imedsyma(ical3),
     $scspe)
                   endif
                 enddo
c      write(6,*) 'conini 2 elott',ical2,imedsyma(ical2),imedsymb(ical2)
       if(nvintnew2+nvirtnew2.ne.op.or..not.ldir.or.pertroute.ne.-1)
     $call conin1(trec,nstr,nmax,icmem,nvintnew2,nointnew2,nvirtnew2,
     $noccnew2,nvintold2,nointold2,nvirtold2,noccold2,namp2,isig12,
     $scrfile2,0,scrfile3,0,iadd1,iadd2,.false.,v,isave2,intrec(ical2),
     $isympv,isympo,nir,nconf,ita,tarec,iwa,isa,isw,iwa(nir**6+1),file,
     $wspcb(0,ical1),wspcb(0,ical2),wspca(0,ical2),wsmax,nvintnew2a,
     $nointnew2a,nvirtnew2a,noccnew2a,nvintold2a,nointold2a,nvirtold2a,
     $noccold2a,nactmax,earec,erec,econf,2,imed,wspca,intrec,
     $itypa(ical2),itypb(ical2),imedsyma(ical2),imedsymb(ical2),ioffs,
     $scspe)
               else
c      write(6,*) 'imedret 2 elott',ical2,ical1,wspcb(0,ical1)
      call imedret(scrfile2,0,wspcb(0,ical1),intfile,intrec(ical2)
     $,isig12,iadd1,v,nmax,2,1,c0,wspcb(0,ical1),wspca(0,ical2),nactmax,
     $0,0,ical2,nconf,trec,econf,erec,nvintnew2a+nvirtnew2a,
     $nointnew2a+noccnew2a,wsmax,2,isave2,itypa(ical2),imedsyma(ical2),
     $scspe)
               endif
             enddo
c      write(6,*) 'conini 1 elott',ical1,icl1,imedsyma(ical1)
       if(pertroute.ne.-1.and.(pert.lt.4.or.iabs(namp1).ne.op))
     $call conin1(trec,nstr,nmax,icmem,nvintnew1,nointnew1,nvirtnew1,
     $noccnew1,nvintold1,nointold1,nvirtold1,noccold1,namp1,isig11,
     $scrfile1,drec,scrfile2,0,iadd0,iadd1,.false.,v,isave1,
     $intrec(ical1),isympv,isympo,nir,nconf,ita,tarec,iwa,isa,isw,
     $iwa(nir**6+1),file,wspca(0,icl1),wspcb(0,ical1),wspca(0,ical1),
     $wsmax,nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,nvintold1a,
     $nointold1a,nvirtold1a,noccold1a,nactmax,earec,erec,econf,1,imed,
     $wspca,intrec,itypa(ical1),itypb(ical1),imedsyma(ical1),
     $imedsymb(ical1),ioffs,scspe)
           else
             if(leftroute) then
#if defined (MPI)
       if(rank.eq.0) then
#endif
               if(densroute) then
      call imedret(scrfile1,drec,icore(ifi),intfile,intrec(ical1),isig11
     $,iadd0,v,nmax,2,ic1,c1,wspca(0,icl1),wspca(0,ical1),nactmax,
     $nvirtnew1a,noccnew1a,ical1,nconf,trec,econf,erec,nvintnew1a+
     $nvirtnew1a,nointnew1a+noccnew1a,wsmax,1,isave1,itypa(ical1)
     $,imedsyma(ical1),scspe)
               else
                 if((iroot.eq.1.or.(zroute.and.(.not.osc)).or.(l3route
     $.and.osc)).and.(itypa(ical1).eq.0.or.itypa(ical1).eq.3)) then
      call rospc(wspca(0,ical1),wspc3,nvirtold1a,noccold1a,wsmax)
      call imedret(scrfile1,0,icore(ifi),intfile,intrec(ical1),isig11,
     $iadd0,v,nmax,0,ic1,c0,trec,wspc3,nactmax,nvintnew1a,
     $nointnew1a,ical1,nconf,trec,econf,erec,nvintnew1a+nvirtnew1a,
     $nointnew1a+noccnew1a,wsmax,1,isave1,itypa(ical1),imedsyma(ical1),
     $scspe)
                 endif
                 if(itypa(ical1).ne.0.and.itypa(ical1).ne.3) then
      call ifillzero(iadds,wsmax+1)
      call imedret(scrfile4,0,icore(ifi),intfile,intrec(ical1),isig11
     $,iadds,v,nmax,2,1,c0,wspca(0,ical1),wspca(0,ical1),nactmax,
     $nvirtnew1a,noccnew1a,ical1,nconf,trec,econf,erec,nvintnew1a+
     $nvirtnew1a,nointnew1a+noccnew1a,wsmax,1,isave1,itypa(ical1)
     $,imedsyma(ical1),scspe)
      call anti1(nconf,econf,trec,erec,nstr,nmax,v,nir,isympv,isympo,
     $ita,tarec,earec,nactm,icmem,wspca(0,ical1),nvintnew1,nointnew1,
     $nvirtnew1,noccnew1,nvirtnew1a,noccnew1a,iadd0,iadds)
                 endif
               endif
#if defined (MPI)
       endif
#endif
             else
               if(pert.eq.0.or.log1) then
#if defined (MPI)
       if((rank.eq.0).or.(pertroute.ne.0.and.pert.ne.0.and.log1)) then
#endif
      call imedret(scrfile1,0,icore(ifi),intfile,intrec(ical1),isig11,
     $iadd0,v,nmax,0,ic1,c0,trec,wspca(0,ical1),nactmax,nvirtnew1a,
     $noccnew1a,ical1,nconf,trec,econf,erec,nvintnew1a+nvirtnew1a,
     $nointnew1a+noccnew1a,wsmax,1,isave1,itypa(ical1),imedsyma(ical1),
     $scspe)
#if defined (MPI)
       endif
#endif
               endif
             endif
           endif
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
     $denrec,econf,erec)
         enddo
         endif
        read(ftfile,*)
       enddo
       enddo
c      write(6,*) 'ciklus utan',leftroute
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
       if(qcc.eq.1.and..not.leftroute) then
C QCC, <0|(L+L^2/2)exp(-T)Hexp(T)|0> contribution to the energy
        call hmat(nconf,nmax,gene,scrfile1,scrfile7,0,0,nactm)
c       write(6,"('gene energy',f16.8)") gene
C QCC, <Psi_K|(1+L)exp(-T)Hexp(T)|0> term
        call expt(1,scrfile1,.true.,nconf,trec,nconf,trec,nstr,nmax,v,
     $nir,isympv,isympo,ita,tarec,nactm,icore(icoupmem),1,isym,isym,
     $lamfile,nconf,trec,'exp ',scrfile2)
        call lincomb(scrfile1,scrfile3,scrfile1,1.d0,1.d0,trecmax)
c      write(6,*) 'linco'
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
         if(qccop.lt.op) then
          ii=trecmax
           do k=1,ntcase(qccop+1)
            ii=min(ii,trec2(k,qccop+1)+1)
           enddo
          call filezero(scrfile1,ii,trecmax)
         endif
       endif
c      if(.not.densroute) then
c     call nszemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
c    $denrec,econf,erec)
c      endif
C DBOC
       if(d1route.and.dboc.eq.1.and.calc.eq.1) then
         if(dbroute) then
           if(lpar) then
            call lincomb(t1file,scrfile1,scrfile1,1.d0,-2.d0,drecmax)
           else
            call savevec1(scrfile1,scrfile1,drecmax,0,0,-2.d0)
           endif
         else
          call savevec(scrfile1,scrfile2,drecmax,0,0)
           if(lpar) then
            call lincomb(t1file,scrfile1,scrfile1,1.d0,1.d0,drecmax)
            call lincomb(t1file,scrfile2,t1file,-1.d0,1.d0,drecmax)
           else
            call savevec1(scrfile2,t1file,drecmax,0,0,1.d0)
           endif
         endif
       endif
#if defined (MPI)            
      call psend(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
       if(d1route.and.dboc.eq.1.and.calc.eq.1.and..not.dbroute)
     $call psend(t1file,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
#endif
C Perturbative methods
       if(pert.ge.4) then
        pertroute=-2
      call rfock(v,v(nvirtal+1),v(nvirt+1),v(nvirt+nal+1),v(nbasis+1),
     $intn,intrec,imed,wspca,wsmax,nstr,istr,nir,nmax,nactm)
C
      call coninp(trec,nstr,nmax,icore(icoupmem),v(nbasis+1),isympv,
     $isympo,nir,nconf,ita,tarec,iwa,isa,iwa(nir**6+1),tfile,wspca,
     $wspcb,nactmax,imedsyma,imedsymb,icore(istrecmem),icore(itransmem),
     $icore(iarcmem),wsmax,intrec,ntcase,tcase,v,v(nvirtal+1),
     $v(nvirt+1),v(nvirt+nal+1),sum,sum,nvirtal,nvirtbe,ioffs+nbasis+1,
     $icore(iabsmem),scspe)
c     write(6,*) 'ciklus scrfile1'
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,trec,
     $nconf,trec)
        pertroute=0
       endif
C
       if(pertroute.ne.0.or.t1route.or.l2route.or.l3route) return
       if(densroute) then
        k=0
         do i1=0,nactm
           do i2=0,nactm
             do i3=0,nactm
               do i4=0,nactm
                k=max(k,nconf(i1,i2,i3,i4,2,2,1))
                k=max(k,nconf(i1,i2,i3,i4,1,2,1))
                k=max(k,nconf(i1,i2,i3,i4,0,2,1))
                k=max(k,econf(i1,i2,i3,i4,2,2))
                k=max(k,econf(i1,i2,i3,i4,1,2))
                k=max(k,econf(i1,i2,i3,i4,0,2))
               enddo
             enddo
           enddo
         enddo
        k=max(k,nal*nbe*nvirtal*nvirtbe,
     $        k,nal*nal*nvirtal*nvirtal,
     $        k,nbe*nbe*nvirtbe*nvirtbe)
         if(d2route.or.ds2route) then
       if(eomgrad.and.(.not.osc)) return
      ii=nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal
      jj=k+ii
      eomroute=.true.
      ifi=ptfile
       if(eomgrad) ifi=cfile
       if(ds2route) ifi=prfile
      call energy(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),v(ii+1),v(ii+jj+1),
     $nvirtal,nvirtbe,nal,nbe,econf,erec,denrec,oo,istr,nir,nstr,isympv
     $,isympo,ifi,wspca,wspcmax,nactmax,intn,imed,v(jj+1),
     $v(jj+nvirtal*nal+1),v(jj+nvirtal*nal+nvirtbe*nbe+1),
     $v(jj+nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),scrfile1,c0,ptsh,
     $ampfile,(iroot-1)*trecmax,nconf,icore(iabsmem),dcore(umatmem),
     $v(1),v(nvirtal*nal+1))
      eomroute=.false.
c     write(6,*) 'energy utan'
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
     $denrec,econf,erec)
           if(d2route) return
         else
          sum=c0
          file2=cfile
          iii=1
           if(dsroute.and.calc.eq.0) then
             if(nconf(0,0,0,0,0,0,nirmap(ptsym(1))).eq.1) then
               if(ptfreq.ne.0.d0.or.optrec) then
                read(prfile,rec=2*(nopt(1)-1)*trecmax+2) ibuf1
               else
                read(prfile,rec=  (nopt(1)-1)*trecmax+2) ibuf1
               endif
              sum=ibuf1(1)
             else
              sum=0.d0 
             endif
            file2=prfile
            iii=nirmap(ptsym(2))
           else if(ptroute.and.calc.eq.0) then
             if(econf(0,0,0,0,0,0).eq.1) then
              read(file,rec=1) ibuf1
              sum=ibuf1(1)
             else
              sum=0.d0 
             endif
           endif
           if(dbroute) file2=tfile
           if(qcc.eq.1) file2=ampfile
           if(calc.eq.0.and..not.osc) file2=tfile
        call energy(v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+nvirtbe*nal+k+1),
     $nvirtal,nvirtbe,nal,nbe,nconf,trec(0,0,0,0,0,0,iii),denrec,oo,
     $istr,nir,nstr,isympv,isympo,file2,wspca,wsmax,nactmax,intn,
     $imed,v(1),v(nvirtal*nal+1),v(nvirtal*nal+nvirtbe*nbe+1),
     $v(nvirtal*nal+nvirtbe*nbe+nvirtal*nbe+1),scrfile1,sum,0,cfile,0,
     $nconf,icore(iabsmem),dcore(umatmem),v(1),v(nvirtal*nal+1))
c     write(6,*) 'energy utan'
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
     $denrec,econf,erec)
           if(calc.eq.0.and.ptroute.and..not.ds1route) then
            a1=2.d0
             if(nmr) a1=-2.d0
             if(ptfreq.ne.0.d0) a1=1.d0
             if(ptsym(1).eq.isym) then
              call hmat(nconf,nmax,sum,ptfile,tfile,0,0,nactmax)
           call lincomb(scrfile1,sdfile,scrfile1,a1,-2.d0*sum,drecmax)
             else
               if(a1.ne.1.d0) then
                 do i=1,drecmax
                  read(scrfile1,rec=i) ibuf
                   do j=1,ibufln
                    ibuf(j)=a1*ibuf(j)
                   enddo
                  write(scrfile1,rec=i) ibuf
                 enddo
               endif
             endif
           else if(calc.eq.0.and.ds1route.and.denssym.eq.1) then
             if(ptfreq.eq.0.d0.and..not.optrec) then
              call hmat(nconf(0,0,0,0,0,0,nirmap(ptsym(1))),nmax,sum,
     $prfile,prfile,(nopt(1)-1)*trecmax+1,(nopt(2)-1)*trecmax+1,
     $nactmax)
             else
              call hmat(nconf(0,0,0,0,0,0,nirmap(ptsym(1))),nmax,sum,
     $prfile,prfile,2*(nopt(1)-1)*trecmax+1,(2*nopt(2)-1)*trecmax+1,
     $nactmax)
             endif
            call lincomb(scrfile1,sdfile,scrfile1,1.d0,-sum,drecmax)
           endif
c     write(6,*) 'hmat utan',sum
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
     $denrec,econf,erec)
        call tenergy(wspca,wsmax,v,intrec,denrec,scrfile1,0,intn)
       if(.not.osc.and..not.dbroute.and..not.dsroute.and..not.dtroute) 
     $call prtenerg(' ',ecc,.false.,.false.,.true.)
         if(hess.and.(.not.ptroute)) 
     $call savevec(scrfile1,sdfile,drecmax,0,0)
         endif
C Print densities
c
c     open(99,status='old',access='direct',recl=irecln)
c     call savevec(99,scrfile1,drecmax,0,0)
c
       if(calc.eq.0.and.ptroute.and.ptfreq.ne.0.d0.and..not.ds1route)
     $then
         if(fdpci) then
          call savevec(scrfile1,scrfile3,drecmax,0,0)
          return
         else
          call lincomb(scrfile1,scrfile3,scrfile1,1.d0,1.d0,drecmax)
         endif
       endif
c     write(6,*) 'density elott'
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,
     $denrec,econf,erec)
      call density(v,nbasis/2,nmax,nstr,imed,nir,isympv,isympo,istr,
     $isa,nactm,wspca,wsmax,intn,denrec,icore(iabsmem),icore(iordmem),
     $icore(iordmem+nbasis/2))
C tszemet eleje
c        if(ds2route.or.dt2route.or.
c    $(iterm.ne.0.and.(dsroute.or.dtroute))) then
c     write(6,*) 'majom6',iterm,dsroute
c         call flush(iout)
c         call flush(densfile)
c         i=system("majom6 < CCDENSITIES >> hehe") !tszemet
c        endif
C tszemet vege
        return
       endif
C Spin-adapted CC
       if(sacc.gt.0) then
        call saccif(nvirtal,nvirtbe,nal,nbe,nconf,trec,nstr,nmax,nir,
     $isympv,isympo,icore(istrecmem),nactm,norm)
        return
       endif
C
       if(qcc.eq.1.and.leftroute) lamfile=lfile
      norm=0.d0
       if((calc.eq.0.or.eomroute).and.diag.eq.1.and.(.not.ptroute)) then
         if(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy1) then
          call olsextr(nconf,trec,nstr,nmax,nactm,chc,e1,test,isympv,
     $isympo,ita,tarec,v,norm)
         else 
          call olsextr(econf,erec,nstr,nmax,nactm,chc,e1,test,isympv,
     $isympo,ita,earec,v,norm)
         endif
       else
c         write(6,*) 'c elo'
       call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,i,i,i,econf,erec)
C Calculate new cluster amplitudes and residual norm
        convero=conver
        file2=tfile
         if(leftroute.and.qcc.eq.1) file2=lamfile
        ifi=1
         if((calc.ne.0.and.(.not.eomroute)).or.ptroute) then
          n=1
           if(ptroute) then
            file2=ptfile
             if(ptsym(1).ne.1) n=0
             if(calc.eq.0) then
              n=0
              ifi=0
             endif
           endif
           if(calc.eq.1) then
             if(conver.eq.1) then
              e1=ecc-eref
              file1=cfile
             endif
             if(leftroute) then
               if(ptroute) file2=plfile
              e1=eex
              file1=tfile
              if(qcc.eq.1) file1=lamfile
              conver=1
               if(iroot.gt.1.and.(.not.zroute)) then
                 if(isym.ne.1) n=0
      call hmat(econf,nmax,ecc,cfile,scrfile1,(iroot-1)*trecmax,0,nactm)
               else
                read(scrfile1,rec=1) ibuf
                ecc=ibuf(1)
               endif
               if(zroute.and.osc.and.isym.ne.1) n=0
             endif
           endif
         do i=ifi,op
           do iactv=max(0,i-mrop),min(nactv,i)
             do iacto=max(0,i-mrop),min(nacto,i)
               do i1=0,i
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                     do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                      iactob=iacto-iactoa
                       if(ptroute.or.(leftroute.and.iroot.gt.1.and.
     $(.not.zroute)).or.(zroute.and.osc)) then
                        nn=econf(iactva,iactvb,iactoa,iactob,i1,i)
                       else
                        nn=nconf(iactva,iactvb,iactoa,iactob,i1,i,1)
                       endif
c       write(6,*) 'ex',i,i1,nn
                       if(nn.gt.0) then
                        m=ibufln
                         if(calc.eq.1.and.conver.eq.1.and.(.not.ptroute)
     $.and.(.not.zroute)) then
                           do k=1,nn
                             if(m.eq.ibufln) then
                              m=0
                              n=n+1
                              read(file2,rec=n) ibuf
                              read(scrfile1,rec=n) ibuf1
                              read(mpfile,rec=n) ibuf2
                              read(file1,rec=n) ibuf3
                             endif
                            m=m+1
                            sum=ibuf1(m)-e1*ibuf(m)
                            norm=norm+sum**2
                            v(k)=ibuf3(m)-sum/(ibuf2(m)-e1+1d-8)
                           enddo
                         else
                           if(ptroute.and.calc.eq.0) then
                             do k=1,nn
                               if(m.eq.ibufln) then
                                m=0
                                n=n+1
                                read(file2,rec=n) ibuf
                                read(scrfile1,rec=n) ibuf1
                                read(mpfile,rec=n) ibuf2
                               endif
                              m=m+1
                              sum=ibuf1(m)-(etot+ptfreq)*ibuf(m)
                              norm=norm+sum**2
      v(k)=ibuf(m)-sum/(-ibuf2(m)-(etot+ptfreq)+1d-8)
c     write(6,*) '@ ',v(k),ibuf(m),ibuf1(m),ibuf2(m),sum,etot
                             enddo
                           else
                             do k=1,nn
                               if(m.eq.ibufln) then
                                m=0
                                n=n+1
                                read(file2,rec=n) ibuf
                                read(scrfile1,rec=n) ibuf1
                                read(mpfile,rec=n) ibuf2
                               endif
                              m=m+1
                              norm=norm+ibuf1(m)**2
                              v(k)=(ibuf1(m)+ibuf(m)*ibuf2(m))/ibuf2(m)
C      write(6,*) '@ ',v(k),ibuf(m),ibuf1(m),ibuf2(m)
                             enddo
                           endif
                         endif
       if(ptroute.or.(leftroute.and.iroot.gt.1.and.((.not.zroute).or.osc
     $))) then
        call putlst(scrfile1,erec(iactva,iactvb,iactoa,iactob,i1,i),
     $v(1),nn)
       else
        call putlst(scrfile1,trec(iactva,iactvb,iactoa,iactob,i1,i,1),
     $v(1),nn)
       endif
                       endif
                     enddo
                   enddo
                 enddo
               enddo
           enddo
         enddo
        if(calc.eq.0.and.ptroute.and.isym.eq.ptsym(1)) then
         call hmat(nconf,nmax,sum,scrfile1,tfile,0,0,nactmax)
         call lincomb(scrfile1,tfile,scrfile1,1.d0,-sum,trecmax)
c        write(6,*) 'Norm: ',sum
        endif
C DIIS extrapolation
           if(leftroute) conver=convero
           if(calc.eq.1.and.conver.eq.1) then
            call savevec(cfile,tfile,trecmax,0,0)
            norm=dsqrt(norm)
           endif
C
       if(qcc.eq.1) then
         if(leftroute) then
          leftroute=.false.
         else
          call savevec(scrfile1,scrfile1,trecmax,0,trecmax)
          call savevec(ampfile ,lamfile ,trecmax,0,trecmax)
          leftroute=.true.
          goto 3845
         endif
       endif
          ndit=nit-ifirstdiis+1
c         ndit=-1
c          write(6,*) 'mpfile'
       call szemet(mpfile,nconf,nmax,nactm,trec,v,0,i,i,i,econf,erec)
c          write(6,*) 'diis'
       call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,i,i,i,econf,erec)
           if(ndit.gt.0.and.dsqrt(norm).gt.1.d0*tol) then
c         write(6,*) 'diis',file2
       if(ptroute.or.(leftroute.and.iroot.gt.1.and.((.not.zroute).or.osc
     $))) then
              call diis(dcore(idiismem),dcore(idiismem+2*ndiis**2+1),
     $dcore(idiismem+3*ndiis**2+1),dcore(idiismem+4*ndiis**2+1),ndiis,
     $v,econf,erec,nmax,nactmax,test,file2)
c         write(6,*) 'diis utan 1',dsqrt(norm)
        call szemet(file2,nconf,nmax,nactm,trec,v,0,i,i,i,econf,erec)
       else
              call diis(dcore(idiismem),dcore(idiismem+2*ndiis**2+1),
     $dcore(idiismem+3*ndiis**2+1),dcore(idiismem+4*ndiis**2+1),ndiis,
     $v,nconf,trec,nmax,nactmax,test,file2)
c         write(6,*) 'diis utan 2',dsqrt(norm)
       call szemet(tfile,nconf,nmax,nactm,trec,v,0,i,i,i,econf,erec)
       endif
           else
             do i=1,trecmax
              read(scrfile1,rec=i) ibuf
              write(file2,rec=i) ibuf
             enddo
           endif
           if(qcc.eq.1) call savevec(lamfile,ampfile,trecmax,trecmax,0)
           if(calc.eq.1.and.conver.eq.1) then
            call savevec(tfile,cfile,trecmax,0,0)
            call expt(1,0,.false.,nconf,trec,nconf,trec,nstr,nmax,v,nir,
     $isympv,isympo,ita,tarec,nactm,icmem,op,isym,isym,tfile,nconf,trec,
     $'exp ',scrfile2)
            call savevec(scrfile2,tfile,trecmax,0,0)
           endif
         else
C Davidson diagonalization
           if(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy1) then
            call david(dcore(idiismem),dcore(idiismem+ndiis**2+1),
     $dcore(idiismem+2*ndiis**2+1),dcore(idiismem+3*ndiis**2+1),ndiis,
     $v,nconf,trec,nmax,nactmax,test,norm,file2,cveco)
           else
            call david(dcore(idiismem),dcore(idiismem+ndiis**2+1),
     $dcore(idiismem+2*ndiis**2+1),dcore(idiismem+3*ndiis**2+1),ndiis,
     $v,econf,erec,nmax,nactmax,test,norm,file2,cveco)
           endif
           if(calc.eq.0) ecc=ecc+eref
         endif
       endif
C
c      if(qcc.eq.1) then
c        if(leftroute) then
c         leftroute=.false.
c        else
c         leftroute=.true.
c         goto 3845
c        endif
c      endif
C
       if(calc.eq.0.or.eomroute.or.(leftroute.and.iroot.gt.1.and.
     $((.not.zroute).or.osc)).or.ptroute) then
        ssym=isym
        file1=tfile
         if(ptroute) then
          ssym=ptsym(1)
           if(t2route.or.calc.eq.0) file1=ptfile
           if(l1route) file1=plfile
         endif
         if(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy1) then
          call symmetrize(nconf,trec,nstr,nmax,nir,isympv,isympo,ita,
     $tarec,v,file1,nactmax,ssym) !szemet
         else
          call symmetrize(econf,erec,nstr,nmax,nir,isympv,isympo,ita,
     $earec,v,file1,nactmax,ssym) !szemet
         endif
       else
        call symmetrize(nconf,trec,nstr,nmax,nir,isympv,isympo,ita,tarec
     $,v,tfile,nactmax,1)
       endif
        if(calc.eq.0.and.ptroute.and.isym.eq.ptsym(1)) then
         call hmat(nconf,nmax,sum,ptfile,tfile,0,0,nactmax)
         call lincomb(ptfile,tfile,ptfile,1.d0,-sum,trecmax)
c        write(6,*) 'Norm: ',sum
        endif
c     write(6,*) 'tfile'
      call szemet(tfile,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
c     write(6,*) 'scrfile1'
      call szemet(scrfile1,nconf,nmax,nactm,trec,v,0,wspca,wsmax,denrec,
     $econf,erec)
C Norm of left-hand LR-CC vector
c     write(6,*) 'cfile 2'
       if(leftroute.and.iroot.gt.1.and.(.not.zroute)) then
      call szemet(cfile,nconf,nmax,nactm,trec,v,(iroot-1)*trecmax,wspca,
     $wsmax,denrec,econf,erec)
        call hmat(econf,nmax,sum,cfile,tfile,(iroot-1)*trecmax,0,nactm)
        call normate(sum,tfile,tfile)
        ecc=ecc/sum
c       write(6,*) 'lnorm',sum
       endif
C
      return
      end
C
************************************************************************
      subroutine contract02(wnew,nvn,non,wold,nio,nvo,noo,t,nv,no,
     $v,coupsval,coupsvbe,coupsoal,coupsobe,coupwval,coupwvbe,coupwoal,
     $coupwobe,nvsalo,nvsbeo,nosalo,nosbeo,nvoalo,nvobeo,nooalo,noobeo,
     $nvaal,nvabe,noaal,noabe,nn1,nn2,nval,nsuml,noccnewall)
************************************************************************
* This subroutine evaluates the contractions between cluster amplitudes*
* and intermediates                                                    *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isgnval,isgnvbe,isgnoal,isgnobe
      integer nvn,non,nio,nvo,noo,nv,no,n1,n2,ivstral,ivstrbe,ifvsal
      integer iostral,iostrbe,ivstr,iostr,ivaal,ivabe,ioaal,ioabe,iivobe
      integer iosbe,iosal,ivsbe,ivsal,ivoal,ivobe,iooal,ioobe,iioobe
      integer nvsal,nvsbe,nosal,nosbe,nvoal,nvobe,nooal,noobe,nn1,nn2
      integer i,ii,nvsalo,nvsbeo,nosalo,nosbeo,nvoalo,nvobeo,nooalo
      integer noobeo,nvaal,nvabe,noaal,noabe,ivo,iosbead,iosalad,ivsbead
      integer coupsval(*),coupsoal(*),coupsvbe(*),coupsobe(*),nval,nsuml
      integer coupwval(*),coupwoal(*),coupwvbe(*),coupwobe(*)
      integer ioo,ifooal,ifoobe,ifvoal,ifvobe,ivsalad,ifvsbe,ifosal
      integer ii1,ii2,ii3,ii4,noccnewall
      real*8 wold(nio,nvo,noo),t(nv,no)
#if defined (OMP)
      real*8 wnew(nvn,non,0:xyzsize),v(nsuml,0:xyzsize)
#else
      real*8 wnew(nvn,non),v(nsuml)
#endif
C
      n2=nvsalo*nvsbeo
      n1=n2*nosalo
      thrd=0
C$OMP PARALLEL
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(nvn,non,wold,nio,nvo,noo,t,nv,no,coupsval,coupsvbe)
C$OMP& SHARED(coupsoal,coupsobe,coupwval,coupwvbe,coupwoal,coupwobe)
C$OMP& SHARED(nvsalo,nvsbeo,nosalo,nosbeo,nvoalo,nvobeo,nooalo,noobeo)
C$OMP& SHARED(nvaal,nvabe,noaal,noabe,nn1,nn2,nval,nsuml,n1,n2)
C$OMP& SHARED(xyzsize,noccnewall,wnew,v,mpisize,mpicount)
#if defined (OMP)
      thrd=OMP_GET_THREAD_NUM()
#endif
#if defined (MPI) ||  defined (OMP)
      xyzcount=0
#endif
       do ivaal=1,nvaal
        ifvsal=coupsval(ivaal)
        nvsal=coupsval(nvaal+ivaal)
        ifvoal=coupwval(ivaal)
        nvoal=coupwval(nvaal+ivaal)
         do ivabe=1,nvabe
          ifvsbe=coupsvbe(ivabe)
          nvsbe=coupsvbe(nvabe+ivabe)
          ifvobe=coupwvbe(ivabe)
          nvobe=coupwvbe(nvabe+ivabe)
           do ioaal=1,noaal
            ifosal=coupsoal(ioaal)
            nosal=coupsoal(noaal+ioaal)
            ifooal=coupwoal(ioaal)
            nooal=coupwoal(noaal+ioaal)
             do ioabe=1,noabe
              ii1=coupsobe(ioabe)
              nosbe=coupsobe(noabe+ioabe)
              ifoobe=coupwobe(ioabe)
              noobe=coupwobe(noabe+ioabe)
#if defined (MPI)
             if(mpicount+thrd.eq.xyzcount) then
#elif defined (OMP)
             if(thrd.eq.xyzcount) then
#endif
C Unpack cluster amplitudes
#if defined (OMP)
              call dfillzer1(v(1,thrd),nsuml)
#else
              call dfillzer1(v,nsuml)
#endif
               do iosbe=1,nosbe
                ii1=ii1+1
                iosbead=n1*(coupsobe(ii1)-1)
                ii1=ii1+1
                iostrbe=coupsobe(ii1)
                isgnobe=isign(1,iostrbe)
                iostrbe=(iabs(iostrbe)-1)*nn2
                ii2=ifosal
                 do iosal=1,nosal
                  ii2=ii2+1
                  iosalad=iosbead+n2*(coupsoal(ii2)-1)
                  ii2=ii2+1
                  iostral=coupsoal(ii2)
                  isgnoal=isgnobe*isign(1,iostral)
                  iostr=iostrbe+iabs(iostral)
                  ii3=ifvsbe
                   do ivsbe=1,nvsbe
                    ii3=ii3+1
                    ivsbead=iosalad+nvsalo*(coupsvbe(ii3)-1)
                    ii3=ii3+1
                    ivstrbe=coupsvbe(ii3)
                    isgnvbe=isgnoal*isign(1,ivstrbe)
                    ivstrbe=(iabs(ivstrbe)-1)*nn1
                    ii4=ifvsal
                     do ivsal=1,nvsal
                      ii4=ii4+1
                      ivsalad=ivsbead+coupsval(ii4)
                      ii4=ii4+1
                      ivstral=coupsval(ii4)
#if defined (OMP)
      v(ivsalad,thrd)=
     $           isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral),iostr)
#else
      v(ivsalad)=isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral),iostr)
#endif
                     enddo
                   enddo
                 enddo
               enddo
              ii1=ifvobe
               do ivobe=1,nvobe
                ii1=ii1+1
                iivobe=(coupwvbe(ii1)-1)*nvoalo
                ii1=ii1+1
                ivstrbe=coupwvbe(ii1)
                isgnvbe=isign(1,ivstrbe)
                ivstrbe=(iabs(ivstrbe)-1)*nval
                ii2=ifvoal
                 do ivoal=1,nvoal
                  ii2=ii2+1
                  ivo=iivobe+coupwval(ii2)
                  ii2=ii2+1
                  ivstral=coupwval(ii2)
                  isgnval=isgnvbe*isign(1,ivstral)
                  ivstr=ivstrbe+iabs(ivstral)
                  ii3=ifoobe
                   do ioobe=1,noobe
                    ii3=ii3+1
                    iioobe=(coupwobe(ii3)-1)*nooalo
                    ii3=ii3+1
                    iostrbe=coupwobe(ii3)
                    isgnobe=isgnval*isign(1,iostrbe)
                    iostrbe=(iabs(iostrbe)-1)*noccnewall
                    ii4=ifooal
                     do iooal=1,nooal
                      ii4=ii4+1
                      ioo=iioobe+coupwoal(ii4)
                      ii4=ii4+1
                      iostral=coupwoal(ii4)
                      isgnoal=isgnobe*isign(1,iostral)
#if defined (OMP)
      call matmul5(wnew(ivstr,iostrbe+iabs(iostral),thrd),
     $wold(1,ivo,ioo),v(1,thrd),nsuml,isgnoal)
#else
      call matmul5(wnew(ivstr,iostrbe+iabs(iostral)),
     $wold(1,ivo,ioo),v,nsuml,isgnoal)
#endif
                     enddo
                   enddo
                 enddo
               enddo
#if defined (MPI) || defined (OMP)
             endif
             if(xyzcount.eq.mpisize) then
              xyzcount=0
             else
              xyzcount=xyzcount+1
             endif
#endif
             enddo
           enddo
         enddo
       enddo
C$OMP END PARALLEL
#if defined (OMP)
      call ompred(wnew,nvn*non)
#endif
C
      return
      end
C
************************************************************************
      subroutine contract01(wnew,nin,nvn,non,wold,nio,nvo,noo,t,nv,no,
     $v,coupsval,coupsvbe,coupsoal,coupsobe,coupwval,coupwvbe,coupwoal,
     $coupwobe,nvsalo,nvsbeo,nosalo,nosbeo,nvoalo,nvobeo,nooalo,noobeo,
     $nvaal,nvabe,noaal,noabe,nn1,nn2,nval,nsuml,noccnewall)
************************************************************************
* This subroutine evaluates the contractions between cluster amplitudes*
* and intermediates                                                    *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isgnval,isgnvbe,isgnoal,isgnobe
      integer nin,nvn,non,nio,nvo,noo,nv,no,n1,n2,ivstral,ivstrbe,ifvsal
      integer iostral,iostrbe,ivstr,iostr,ivaal,ivabe,ioaal,ioabe,iivobe
      integer iosbe,iosal,ivsbe,ivsal,ivoal,ivobe,iooal,ioobe,iioobe
      integer nvsal,nvsbe,nosal,nosbe,nvoal,nvobe,nooal,noobe,nn1,nn2
      integer i,ii,nvsalo,nvsbeo,nosalo,nosbeo,nvoalo,nvobeo,nooalo
      integer noobeo,nvaal,nvabe,noaal,noabe,ivo,iosbead,iosalad,ivsbead
      integer coupsval(*),coupsoal(*),coupsvbe(*),coupsobe(*),nval,nsuml
      integer coupwval(*),coupwoal(*),coupwvbe(*),coupwobe(*)
      integer ioo,ifooal,ifoobe,ifvoal,ifvobe,ivsalad,ifvsbe,ifosal
      integer ii1,ii2,ii3,ii4,noccnewall
      real*8 wold(nio,nvo,noo),t(nv,no)
#if defined (OMP)
      real*8 wnew(nin,nvn,non,0:xyzsize),v(nsuml,0:xyzsize)
#else
      real*8 wnew(nin,nvn,non),v(nsuml)
#endif
C
      n2=nvsalo*nvsbeo
      n1=n2*nosalo
C$OMP PARALLEL
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(nin,nvn,non,wold,nio,nvo,noo,t,nv,no,coupsval,coupsvbe)
C$OMP& SHARED(coupsoal,coupsobe,coupwval,coupwvbe,coupwoal,coupwobe)
C$OMP& SHARED(nvsalo,nvsbeo,nosalo,nosbeo,nvoalo,nvobeo,nooalo,noobeo)
C$OMP& SHARED(nvaal,nvabe,noaal,noabe,nn1,nn2,nval,nsuml,n1,n2)
C$OMP& SHARED(xyzsize,noccnewall,wnew,v)
#if defined (OMP)
      thrd=OMP_GET_THREAD_NUM()
      xyzcount=0
#endif
       do ivaal=1,nvaal
        ifvsal=coupsval(ivaal)
        nvsal=coupsval(nvaal+ivaal)
        ifvoal=coupwval(ivaal)
        nvoal=coupwval(nvaal+ivaal)
         do ivabe=1,nvabe
          ifvsbe=coupsvbe(ivabe)
          nvsbe=coupsvbe(nvabe+ivabe)
          ifvobe=coupwvbe(ivabe)
          nvobe=coupwvbe(nvabe+ivabe)
           do ioaal=1,noaal
            ifosal=coupsoal(ioaal)
            nosal=coupsoal(noaal+ioaal)
            ifooal=coupwoal(ioaal)
            nooal=coupwoal(noaal+ioaal)
             do ioabe=1,noabe
              ii1=coupsobe(ioabe)
              nosbe=coupsobe(noabe+ioabe)
              ifoobe=coupwobe(ioabe)
              noobe=coupwobe(noabe+ioabe)
#if defined (OMP)
             if(thrd.eq.xyzcount) then
#endif
C Unpack cluster amplitudes
#if defined (OMP)
              call dfillzer1(v(1,thrd),nsuml)
#else
              call dfillzer1(v,nsuml)
#endif
               do iosbe=1,nosbe
                ii1=ii1+1
                iosbead=n1*(coupsobe(ii1)-1)
                ii1=ii1+1
                iostrbe=coupsobe(ii1)
                isgnobe=isign(1,iostrbe)
                iostrbe=(iabs(iostrbe)-1)*nn2
                ii2=ifosal
                 do iosal=1,nosal
                  ii2=ii2+1
                  iosalad=iosbead+n2*(coupsoal(ii2)-1)
                  ii2=ii2+1
                  iostral=coupsoal(ii2)
                  isgnoal=isgnobe*isign(1,iostral)
                  iostr=iostrbe+iabs(iostral)
                  ii3=ifvsbe
                   do ivsbe=1,nvsbe
                    ii3=ii3+1
                    ivsbead=iosalad+nvsalo*(coupsvbe(ii3)-1)
                    ii3=ii3+1
                    ivstrbe=coupsvbe(ii3)
                    isgnvbe=isgnoal*isign(1,ivstrbe)
                    ivstrbe=(iabs(ivstrbe)-1)*nn1
                    ii4=ifvsal
                     do ivsal=1,nvsal
                      ii4=ii4+1
                      ivsalad=ivsbead+coupsval(ii4)
                      ii4=ii4+1
                      ivstral=coupsval(ii4)
#if defined (OMP)
      v(ivsalad,thrd)=
     $           isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral),iostr)
#else
      v(ivsalad)=isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral),iostr)
#endif
                     enddo
                   enddo
                 enddo
               enddo
              ii1=ifvobe
               do ivobe=1,nvobe
                ii1=ii1+1
                iivobe=(coupwvbe(ii1)-1)*nvoalo
                ii1=ii1+1
                ivstrbe=coupwvbe(ii1)
                isgnvbe=isign(1,ivstrbe)
                ivstrbe=(iabs(ivstrbe)-1)*nval
                ii2=ifvoal
                 do ivoal=1,nvoal
                  ii2=ii2+1
                  ivo=iivobe+coupwval(ii2)
                  ii2=ii2+1
                  ivstral=coupwval(ii2)
                  isgnval=isgnvbe*isign(1,ivstral)
                  ivstr=ivstrbe+iabs(ivstral)
                  ii3=ifoobe
                   do ioobe=1,noobe
                    ii3=ii3+1
                    iioobe=(coupwobe(ii3)-1)*nooalo
                    ii3=ii3+1
                    iostrbe=coupwobe(ii3)
                    isgnobe=isgnval*isign(1,iostrbe)
                    iostrbe=(iabs(iostrbe)-1)*noccnewall
                    ii4=ifooal
                     do iooal=1,nooal
                      ii4=ii4+1
                      ioo=iioobe+coupwoal(ii4)
                      ii4=ii4+1
                      iostral=coupwoal(ii4)
                      isgnoal=isgnobe*isign(1,iostral)
#if defined (OMP)
      call matmul1(wnew(1,ivstr,iostrbe+iabs(iostral),thrd),
     $wold(1,ivo,ioo),v(1,thrd),nin,nsuml,isgnoal)
#else
      call matmul1(wnew(1,ivstr,iostrbe+iabs(iostral)),
     $wold(1,ivo,ioo),v,nin,nsuml,isgnoal)
#endif
                     enddo
                   enddo
                 enddo
               enddo
#if defined (OMP)
             endif
             if(xyzcount.eq.xyzsize) then
              xyzcount=0
             else
              xyzcount=xyzcount+1
             endif
#endif
             enddo
           enddo
         enddo
       enddo
C$OMP END PARALLEL
#if defined (OMP)
      call ompred(wnew,nin*nvn*non)
#endif
C
      return
      end
C
************************************************************************
      subroutine matmul1(v1,mat,v2,n,m,isgn)
************************************************************************
* Vectorized matrix-vector product                                     *
************************************************************************
      implicit none
      integer*1 isgn
      integer m,n,i,j,mm
      real*8 v1(n),mat(*),v2(m),sum
C
      mm=0
       do j=1,m
        sum=v2(j)
         if(sum.ne.0.d0) then
          sum=isgn*sum
           do i=1,n
            v1(i)=v1(i)+mat(mm+i)*sum
           enddo
         endif
        mm=mm+n
       enddo
c      do j=1,m
c       sum=v2(j)
c        if(sum.ne.0.d0) then
c         sum=isgn*sum
c          do i=1,n
c           v1(i)=v1(i)+mat(i,j)*sum
c          enddo
c        endif
c      enddo
c      do i=1,n
c       sum=0.d0
c        do j=1,m
c         sum=sum+mat(i,j)*v2(j)
c        enddo
c       v1(i)=v1(i)+isgn*sum
c      enddo
C
      return
      end
C
************************************************************************
      subroutine matmul11(v1,mat,v2,n,m,isgn)
************************************************************************
* Vectorized matrix-vector product (mat is transposed)                 *
************************************************************************
      implicit none
      integer*1 isgn
      integer m,n,i,j,mm
      real*8 v1(n),mat(*),v2(m),sum
C
       do j=1,m
        sum=v2(j)
        mm=j
         if(sum.ne.0.d0) then
          sum=isgn*sum
           do i=1,n
            v1(i)=v1(i)+mat(mm)*sum
            mm=mm+m
           enddo
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine gcoupl(icmem,nvstral,nvstrbe,nostral,nostrbe,iarc,nmax,
     $nnir,ivstral,ivstrbe,iostral,iostrbe,nactm,iscr,ivrecal,ivrecbe,
     $iorecal,iorecbe,itrva,itrvb,itroa,itrob)
************************************************************************
* This subroutine generates coupling coefficient for excitation        *
* operator strings                                                     *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,nactm,iarc(0:nactm,0:nmax,4),ii,i,j,k,minvo
      integer nvstral(nnir,0:nactm,0:nmax),nvstrbe(nnir,0:nactm,0:nmax)
      integer nostral(nnir,0:nactm,0:nmax),nostrbe(nnir,0:nactm,0:nmax)
      integer icmem(nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,4),ir1,ir2
      integer ivstral(nnir,0:nactm,0:nmax),ivstrbe(nnir,0:nactm,0:nmax)
      integer iostral(nnir,0:nactm,0:nmax),iostrbe(nnir,0:nactm,0:nmax)
      integer iact,iact1,iact2,iscr(*)
      integer ivrecal(nnir,0:nactm,0:nmax),ivrecbe(nnir,0:nactm,0:nmax)
      integer iorecal(nnir,0:nactm,0:nmax),iorecbe(nnir,0:nactm,0:nmax)
      integer itrva(2,0:nactm,0:nmax),itrvb(2,0:nactm,0:nmax)
      integer itroa(2,0:nactm,0:nmax),itrob(2,0:nactm,0:nmax)
      integer n1,n2,n3,nn1,nn2
C
      write(iout,*) 'Calculation of coupling coefficients...'
      minvo=2
C Virtual alpha strings
       if(calc.eq.1.or.dens.gt.0) minvo=minvirtal
       do i=0,minvo
         do j=0,minvirtal
           if(i+j.le.minvirtal2) then
            i1=i+j
            i2=i1-1
             do iact1=max(0,i-mrop2),min(nactva,i)
               do iact2=max(0,j-mrop2),min(nactva,j)
                iact=iact1+iact2
                 if(iact.le.nactva.and.i1-iact.le.mrop2.and.
     $(pert.eq.0.or.i1.lt.op.or.iact.ge.1)) then
                   do ir1=1,nir
                     do ir2=1,nir
                      n1=nvstral(ir1,iact1,i)
                      n2=nvstral(ir2,iact2,j)
                      n3=itrva(2,iact,i1)
                      nn1=n1*i
                      nn2=n2*j
      call getint(strfile,ivrecal(ir1,iact1,i),iscr(1),nn1)
      call getint(strfile,ivrecal(ir2,iact2,j),iscr(nn1+1),nn2)
      call getint(strfile,itrva(1,iact,i1),iscr(nn1+nn2+1),n3)
      call gcoupl1(icmem(ir1,ir2,iact1,iact2,i,j,1),n1,n2,nvirtal,
     $icore(iarc(iact,i1,1)),i,j,iscr(1),iscr(nn1+1),iscr(nn1+nn2+1),
     $icore(iindmem),icore(iucvmem),iscr(nn1+nn2+n3+1))
                     enddo
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
C Virtual beta strings
       if(calc.eq.1.or.dens.gt.0) minvo=minvirtbe
       if(cs.and.nvirtal.eq.nvirtbe.and.minvirtal.eq.minvirtbe.and.
     $nactva.eq.nactvb) then
         do i=0,minvo
           do j=0,minvirtbe
             if(i+j.le.minvirtbe2) then
               do iact1=max(0,i-mrop2),min(nactvb,i)
                 do iact2=max(0,j-mrop2),min(nactvb,j)
                   do ir1=1,nir
                     do ir2=1,nir
                      icmem(ir1,ir2,iact1,iact2,i,j,2)=
     $                icmem(ir1,ir2,iact1,iact2,i,j,1)
                     enddo
                   enddo
                 enddo
               enddo
             endif
           enddo
         enddo
       else
         do i=0,minvo
           do j=0,minvirtbe
             if(i+j.le.minvirtbe2) then
              i1=i+j
              i2=i1-1
               do iact1=max(0,i-mrop2),min(nactvb,i)
                 do iact2=max(0,j-mrop2),min(nactvb,j)
                  iact=iact1+iact2
                   if(iact.le.nactvb.and.i1-iact.le.mrop2.and.
     $(pert.eq.0.or.i1.lt.op.or.iact.ge.1)) then
                     do ir1=1,nir
                       do ir2=1,nir
                        n1=nvstrbe(ir1,iact1,i)
                        n2=nvstrbe(ir2,iact2,j)
                        n3=itrvb(2,iact,i1)
                        nn1=n1*i
                        nn2=n2*j
      call getint(strfile,ivrecbe(ir1,iact1,i),iscr(1),nn1)
      call getint(strfile,ivrecbe(ir2,iact2,j),iscr(nn1+1),nn2)
      call getint(strfile,itrvb(1,iact,i1),iscr(nn1+nn2+1),n3)
      call gcoupl1(icmem(ir1,ir2,iact1,iact2,i,j,2),n1,n2,nvirtbe,
     $icore(iarc(iact,i1,2)),i,j,iscr(1),iscr(nn1+1),iscr(nn1+nn2+1),
     $icore(iindmem),icore(iucvmem),iscr(nn1+nn2+n3+1))
                       enddo
                     enddo
                   endif
                 enddo
               enddo
             endif
           enddo
         enddo
       endif
C Occupied alpha strings
       if(calc.eq.1.or.dens.gt.0) minvo=minoccal
       do i=0,minvo
         do j=0,minoccal
           if(i+j.le.minoccal2) then
            i1=i+j
            i2=i1-1
             do iact1=max(0,i-mrop2),min(nactoa,i)
               do iact2=max(0,j-mrop2),min(nactoa,j)
                iact=iact1+iact2
                 if(iact.le.nactoa.and.i1-iact.le.mrop2) then
                   do ir1=1,nir
                     do ir2=1,nir
                      n1=nostral(ir1,iact1,i)
                      n2=nostral(ir2,iact2,j)
                      n3=itroa(2,iact,i1)
                      nn1=n1*i
                      nn2=n2*j
      call getint(strfile,iorecal(ir1,iact1,i),iscr(1),nn1)
      call getint(strfile,iorecal(ir2,iact2,j),iscr(nn1+1),nn2)
      call getint(strfile,itroa(1,iact,i1),iscr(nn1+nn2+1),n3)
      call gcoupl1(icmem(ir1,ir2,iact1,iact2,i,j,3),n1,n2,nal,
     $icore(iarc(iact,i1,3)),i,j,iscr(1),iscr(nn1+1),iscr(nn1+nn2+1),
     $icore(iindmem),icore(iucvmem),iscr(nn1+nn2+n3+1))
                     enddo
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
C Occupied beta strings
       if(calc.eq.1.or.dens.gt.0) minvo=minoccbe
       if(cs.and.nal.eq.nbe.and.minoccal.eq.minoccbe.and.
     $nactoa.eq.nactob) then
         do i=0,minvo
           do j=0,minoccbe
             if(i+j.le.minoccbe2) then
               do iact1=max(0,i-mrop2),min(nactob,i)
                 do iact2=max(0,j-mrop2),min(nactob,j)
                   do ir1=1,nir
                     do ir2=1,nir
                      icmem(ir1,ir2,iact1,iact2,i,j,4)=
     $                icmem(ir1,ir2,iact1,iact2,i,j,3)
                     enddo
                   enddo
                 enddo
               enddo
             endif
           enddo
         enddo
       else
         do i=0,minvo
           do j=0,minoccbe
             if(i+j.le.minoccbe2) then
              i1=i+j
              i2=i1-1
               do iact1=max(0,i-mrop2),min(nactob,i)
                 do iact2=max(0,j-mrop2),min(nactob,j)
                  iact=iact1+iact2
                   if(iact.le.nactob.and.i1-iact.le.mrop2) then
                     do ir1=1,nir
                       do ir2=1,nir
                      n1=nostrbe(ir1,iact1,i)
                      n2=nostrbe(ir2,iact2,j)
                      n3=itrob(2,iact,i1)
                      nn1=n1*i
                      nn2=n2*j
      call getint(strfile,iorecbe(ir1,iact1,i),iscr(1),nn1)
      call getint(strfile,iorecbe(ir2,iact2,j),iscr(nn1+1),nn2)
      call getint(strfile,itrob(1,iact,i1),iscr(nn1+nn2+1),n3)
      call gcoupl1(icmem(ir1,ir2,iact1,iact2,i,j,4),n1,n2,nbe,
     $icore(iarc(iact,i1,4)),i,j,iscr(1),iscr(nn1+1),iscr(nn1+nn2+1),
     $icore(iindmem),icore(iucvmem),iscr(nn1+nn2+n3+1))
                       enddo
                     enddo
                   endif
                 enddo
               enddo
             endif
           enddo
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine gcoupl1(icmem,nstr1,nstr2,nv,iarc,nex1,nex2,iistr1,
     $iistr2,itr,iind,iucv,coup)
************************************************************************
* This subroutine generates coupling coefficient for excitation        *
* operator strings                                                     *
************************************************************************
#include "MRCCCOMMON"
      integer nstr1,nstr2,coup(*),nex1,nex2,nv,a,ii,isum,icmem
      integer iarc(0:nv,0:nex1+nex2),iistr1(nex1,nstr1)
      integer itr(*),iind(nex1+nex2),iucv(nex2),i,j,k,iistr2(nex2,nstr2)
      logical log
C
      ii=2*nstr2
       do istr2=1,nstr2
        isum=0
        coup(istr2)=ii
         do i=1,nex2
          iucv(i)=iistr2(i,istr2)
         enddo
         do istr1=1,nstr1
           do i=1,nex2
            iind(nex1+i)=iucv(i)
           enddo
           do i=1,nex1
            iind(i)=iistr1(i,istr1)
           enddo
          isig1=1
1011       continue
            log=.false.
             do i=1,i2
              j=i+1
               if(iind(i).gt.iind(j)) then
                log=.true.
                isig1=-isig1
                k=iind(j)
                iind(j)=iind(i)
                iind(i)=k
               endif
             enddo
           if(log) goto 1011
           do i=1,i2
             if(iind(i).eq.iind(i+1)) then
              goto 1012
             endif
           enddo
          istrv=1
           do i=1,i1
            istrv=istrv+iarc(iind(i)-1,i)
           enddo
          isum=isum+1
          ii=ii+1
          coup(ii)=istr1
          ii=ii+1
          coup(ii)=isig1*itr(istrv)
1012      continue
         enddo
        coup(nstr2+istr2)=isum
       enddo
      call getmem(ii,icore(1),icmem)
      call icp(coup,icore(icmem),ii)
C
      return
      end
C
************************************************************************
      subroutine diis(bmat,bvec,invbmat,cvec,ndmax,v,nconf,trec
     $,nmax,nactm,test,file)
************************************************************************
* DIIS extrapolation                                                   *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,nact,nactpl,iact,ii,i,j,ntrecact,file
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer ifi,ndmax,iactv,iacto,iactva,iactoa,iactvb,iactob
      integer ipiv(ndmax),iq,iql
      real*8 bmat(ndmax,ndmax,0:1),bvec(ndmax**2),invbmat(ndmax,ndmax)
      real*8 cvec(ndmax),sum,sum1,v(*),norm,test
C
       if(calc.eq.0.or.(leftroute.and.iroot.gt.1.and.isym.ne.1.and.
     $((.not.zroute).or.osc)).or.(ptroute.and.ptsym(1).ne.1)) then
        ifi=0
       else
        ifi=1       
       endif
       if(qcc.eq.1) then
        iql=1
       else
        iql=0
       endif
      nact=min(ndiis,ndit)
      nactpl=mod(ndit,ndiis)
       if(nactpl.eq.0) nactpl=ndiis
      ntrecact=(iql+1)*(nactpl-1)*trecmax
C Save amplitudes and calculate new error vector
       do iq=0,iql
         do i=ifi+1,trecmax
          read(file,rec=iq*trecmax+i) ibuf
          read(scrfile1,rec=iq*trecmax+i) ibuf1
          write(diisfile,rec=ntrecact+iq*trecmax+i) ibuf1
           do j=1,ibufln
            ibuf(j)=ibuf1(j)-ibuf(j)
           enddo
          write(errfile,rec=ntrecact+iq*trecmax+i) ibuf
         enddo
       enddo
C Update the scalar product matrix (B matrix)
       do iq=0,iql
         do iact=1,nact
          bmat(nactpl,iact,iq)=0.d0
          bmat(iact,nactpl,iq)=0.d0
         enddo
         do i=ifi,op
           do iactv=max(0,i-mrop),min(nactv,i)
             do iacto=max(0,i-mrop),min(nacto,i)
               do i1=0,i
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                    ii=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                     if(ii.gt.0) then
                      call getlst(errfile,iq*trecmax+ntrecact+
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(1),ii)
                      call scalprod(v(1),v(1),ii,sum)
                      bmat(nactpl,nactpl,iq)=bmat(nactpl,nactpl,iq)+sum
                       do iact=1,nact-1
                        call getlst(errfile,iq*trecmax+
     $(iql+1)*(iact-1)*trecmax+
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(ii+1),ii)
                        call scalprod(v(1),v(ii+1),ii,sum)
                        bmat(nactpl,iact,iq)=bmat(nactpl,iact,iq)+sum
                        bmat(iact,nactpl,iq)=bmat(iact,nactpl,iq)+sum
                       enddo
                     endif
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
C Invert B matrix
C Dynminv version
c     ii=0
c      do i=1,nact
c        do j=1,nact
c         ii=ii+1
c         bvec(ii)=bmat(i,j)
c        enddo
c      enddo
c     call dynminv(nact,ndmax,sum,bvec)
c     ii=0
c      do i=1,nact
c        do j=1,nact
c         ii=ii+1
c         invbmat(i,j)=bvec(ii)
c        enddo
c      enddo
C Lapack version
       do j=1,nact
         do i=1,j
          bvec(i+(j-1)*j/2)=bmat(i,j,iq)    
         enddo
       enddo
      call dsptrf('U',nact,bvec,ipiv,invbmat,i)
      call dsptri('U',nact,bvec,ipiv,invbmat,i)
       do j=1,nact
         do i=1,j
          invbmat(i,j)=bvec(i+(j-1)*j/2)
          invbmat(j,i)=invbmat(i,j)
         enddo
       enddo
C Denominator
      sum=0.d0
       do i=1,nact
c     write(6,*) (invbmat(i,j),j=1,nact)
         do j=1,nact
          sum=sum+invbmat(i,j)
         enddo
       enddo
      sum=1.d0/sum
C Coefficients
      test=1.d0
       do i=1,nact
        sum1=0.d0
         do j=1,nact
          sum1=sum1+invbmat(i,j)
         enddo
        cvec(i)=sum*sum1
c     write(6,*) 'sum1',i,sum1,sum
        test=min(test,dabs(cvec(i)))
       enddo
c     write(6,*) 'cvec',cvec
C New amplitudes
      norm=0.d0
         do i=ifi,op
           do iactv=max(0,i-mrop),min(nactv,i)
             do iacto=max(0,i-mrop),min(nacto,i)
               do i1=0,i
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                    ii=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                     if(ii.gt.0) then
                      call dfillzero(v,ii)
                       do iact=1,nact
                        sum=cvec(iact)
      call getlst(diisfile,iq*trecmax+(iql+1)*(iact-1)*trecmax+
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(ii+1),ii)
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
                         do j=1,ii
                          v(j)=v(j)+sum*v(ii+j)
                         enddo
C$OMP END PARALLEL DO
                       enddo
                      call putlst(file,
     $iq*trecmax+trec(iactva,iactvb,iactoa,iactob,i1,i),v(1),ii)
                       if(calc.eq.0) then
                         do j=1,ii
                          norm=norm+v(j)**2
                         enddo
                       endif
                     endif
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
C Norm of new CI vector
       if(calc.eq.0.and.(.not.ptroute)) then
        norm=dsqrt(norm)
        call normate(norm,file,file)
       endif
C
      return
      end
C
************************************************************************
      subroutine scalprod(v1,v2,n,sum)
************************************************************************
* Vectorized scalar product                                            *
************************************************************************
      implicit none
      integer n,i
      real*8 v1(*),v2(*),sum
C
      sum=0.d0
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& REDUCTION(+:sum)
       do i=1,n
        sum=sum+v1(i)*v2(i)
       enddo
C$OMP END PARALLEL DO
C
      return
      end
C
************************************************************************
      subroutine transp2(wnew,wold,nnew,nold,nstr,n1,n2,itin,in,wnew2,
     $wold2,coup1,coup2,ifo,inco,ifn,incn,incs)
************************************************************************
* This subroutine transpose two indices of intermediates               *
************************************************************************
#include "MRCCCOMMON"
      integer nnew,nold,nstr,n1,n2,itin(2),ii,in(2),istr,coup1(*),ifo
      integer nn,jj,in1,in2,iss(2),is1,is2,ic,inco,istro,ilo,iup
      integer ifn,incn,istrn,incs,coup2(*)
      real*8 wnew(*),wold(*),wnew2(n1,n2,nstr),wold2(n2,n1,nstr),sum
C
      in1=in(1)
      in2=in(2)
      iss(in1)=n1
      iss(in2)=n2
      is1=iss(1)
      is2=iss(2)
C$OMP PARALLEL
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(sum,nn,jj,ii,thrd,istro,istrn,ic,istr,i1,i2,ilo,iup)
      call omplim(nstr,ilo,iup)
#if defined (OMP)
      thrd=ilo-1
      istro=ifo+thrd*inco
      istrn=ifn+thrd*incn
      ii=n1*(n1-1)*thrd/2
#else
      istro=ifo
      istrn=ifn
      ii=0
#endif
       if(itin(2).le.0) then
         if(nir.eq.1.and.(.not.mr)) then
           do istr=ilo,iup
             do i1=1,n1
               do i2=1,n2
                wnew2(i1,i2,istr)=wold2(i2,i1,istr)
               enddo
             enddo
           enddo
         else
           if(in1.eq.1) then
             do istr=ilo,iup
              ic=istrn
               do i1=1,n1
                 do i2=1,n2
                  wnew(ic+i2)=wold(istro+(i1-1)*n2+i2)
                 enddo
                ic=ic+incs
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
           else
             do istr=ilo,iup
              ic=istrn
               do i2=1,n2
                 do i1=1,n1
                  wnew(ic+i1)=wold(istro+(i1-1)*n2+i2)
                 enddo
                ic=ic+incs
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
           endif
         endif
       else
         if(in1.eq.1) then
           if(nir.eq.1.and.(.not.mr)) then
             do istr=ilo,iup
               do i1=1,n1
                wnew2(i1,i1,istr)=0.d0
                 do i2=1,i1-1
                  ii=ii+1
                  sum=wold(ii)
                  wnew2(i2,i1,istr)=sum
                  wnew2(i1,i2,istr)=-sum
                 enddo
               enddo
             enddo
           else
             do istr=ilo,iup
              ic=istrn
               do i1=1,n1
                nn=coup1(i1)
                 do i2=1,coup1(n1+i1)
                  nn=nn+1
                  jj=coup1(nn)
                  nn=nn+1
                  ii=coup1(nn)
                  wnew(ic+jj)=isign(1,ii)*wold(istro+iabs(ii))
                 enddo
                ic=ic+incs
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
           endif
         else
           if(nir.eq.1.and.(.not.mr)) then
             do istr=ilo,iup
               do i1=1,n1
                wnew2(i1,i1,istr)=0.d0
                 do i2=1,i1-1
                  ii=ii+1
                  sum=wold(ii)
                  wnew2(i1,i2,istr)=sum
                  wnew2(i2,i1,istr)=-sum
                 enddo
               enddo
             enddo
           else
             do istr=ilo,iup
              ic=istrn
               do i2=1,n2
                nn=coup2(i2)
                 do i1=1,coup2(n2+i2)
                  nn=nn+1
                  jj=coup2(nn)
                  nn=nn+1
                  ii=coup2(nn)
                  wnew(ic+jj)=-isign(1,ii)*wold(istro+iabs(ii))
                 enddo
                ic=ic+incs
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
           endif
         endif
       endif
C$OMP END PARALLEL
C
      return
      end
C
************************************************************************
      subroutine transp3(wnew,wold,nnew,nold,nstr,v,n1,n2,n3,itin,in,v2,
     $coup1,coup2,nn,ifo,inco,ifn,incn,incs,nsumnew)
************************************************************************
* This subroutine transpose three indices of intermediates             *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isg
      integer i,nnew,nold,nstr,n1,n2,n3,itin(4),ii,in1,in2,in3,in(4)
      integer is1,is2,is3,istr,iss(3),coup1(*),coup2(*),ifo,inco,incs
      integer nn,mmm,kk,jj,istro,n23,ic,ifn,incn,istrn
      integer nsumnew,ic1
      real*8 wnew(*),wold(*),v(n3,n2,n1),sum
      real*8 v2(n3,n2,n1,nstr)
C
      n23=n2*n3
      mmm=n1*n23
      in1=in(1)
      in2=in(2)
      in3=in(3)
      iss(in1)=n1
      iss(in2)=n2
      iss(in3)=n3
      is1=iss(1)
      is2=iss(2)
      is3=iss(3)
      istro=ifo
      istrn=ifn
      ic=0
       if(itin(2).le.0.and.itin(3).le.0) then
         if(nir.eq.1.and.(.not.mr)) then
           do istr=1,nstr
             do i1=1,is1
               do i2=1,is2
                 do i3=1,is3
                  ic=ic+1
                  wnew(ic)=
     $v2(iactsumind(in3),iactsumind(in2),iactsumind(in1),istr)
                 enddo
               enddo
             enddo
           enddo
          return
         else
           if(nsumnew.eq.1) then
             do istr=1,nstr
              ic=istrn
               do i1=1,is1
                ic1=ic
                 do i2=1,is2
                   do i3=1,is3
                    ic1=ic1+1
                    wnew(ic1)=wold(istro+
     $iactsumind(in3)+(iactsumind(in2)-1)*n3+(iactsumind(in1)-1)*n23)
                   enddo
                 enddo
                ic=ic+incs
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
            return
           else
             do istr=1,nstr
              ic=istrn
               do i1=1,is1
                 do i2=1,is2
                   do i3=1,is3
                    wnew(ic+i3)=wold(istro+
     $iactsumind(in3)+(iactsumind(in2)-1)*n3+(iactsumind(in1)-1)*n23)
                   enddo
                  ic=ic+incs
                 enddo
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
            return
           endif
         endif
       endif
       if(itin(2).gt.0) then
         if(nir.eq.1.and.(.not.mr)) then
          jj=0
           do istr=1,nstr
             do i1=1,n1
              call dfillzero(v(1,i1,i1),n3) !!!!!!!!!!!!!!!!!!!!!!!!!
               do i2=1,i1-1
                 do i3=1,n3
                  jj=jj+1
                  sum=wold(jj)
                  v(i3,i2,i1)=sum
                  v(i3,i1,i2)=-sum
                 enddo
               enddo
             enddo
             do i1=1,is1
               do i2=1,is2
                 do i3=1,is3
                  ic=ic+1
      wnew(ic)=v(iactsumind(in3),iactsumind(in2),iactsumind(in1))
                 enddo
               enddo
             enddo
           enddo
          return
         else
           if(nsumnew.eq.1) then
             do istr=1,nstr
              call dfillzero(v,mmm) !!!!!!!!!!!!!!!!!!!!!!!!!
               do i1=1,n1
                kk=coup1(i1)
                 do i2=1,coup1(n1+i1)
                  kk=kk+1
                  jj=coup1(kk)
                  kk=kk+1
                  ii=coup1(kk)
                  isg=isign(1,ii)
                  ii=(iabs(ii)-1)*n3
                   do i3=1,n3
                    v(i3,jj,i1)=isg*wold(istro+ii+i3)
                   enddo
                 enddo
               enddo
              ic=istrn
               do i1=1,is1
                ic1=ic
                 do i2=1,is2
                   do i3=1,is3
                    ic1=ic1+1
                    wnew(ic1)=
     $v(iactsumind(in3),iactsumind(in2),iactsumind(in1))
                   enddo
                 enddo
                ic=ic+incs
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
            return
           else
             do istr=1,nstr
              call dfillzero(v,mmm) !!!!!!!!!!!!!!!!!!!!!!!!!
               do i1=1,n1
                kk=coup1(i1)
                 do i2=1,coup1(n1+i1)
                  kk=kk+1
                  jj=coup1(kk)
                  kk=kk+1
                  ii=coup1(kk)
                  isg=isign(1,ii)
                  ii=(iabs(ii)-1)*n3
                   do i3=1,n3
                    v(i3,jj,i1)=isg*wold(istro+ii+i3)
                   enddo
                 enddo
               enddo
              ic=istrn
               do i1=1,is1
                 do i2=1,is2
                   do i3=1,is3
                    wnew(ic+i3)=
     $v(iactsumind(in3),iactsumind(in2),iactsumind(in1))
                   enddo
                  ic=ic+incs
                 enddo
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
            return
           endif
         endif
       endif
       if(itin(3).gt.0) then
         if(nir.eq.1.and.(.not.mr)) then
          jj=0
           do istr=1,nstr
             do i1=1,n1
               do i2=1,n2
                v(i2,i2,i1)=0.d0
                 do i3=1,i2-1
                  jj=jj+1
                  sum=wold(jj)
                  v(i3,i2,i1)=sum
                  v(i2,i3,i1)=-sum
                 enddo
               enddo
             enddo
             do i1=1,is1
               do i2=1,is2
                 do i3=1,is3
                  ic=ic+1
      wnew(ic)=v(iactsumind(in3),iactsumind(in2),iactsumind(in1))
                 enddo
               enddo
             enddo
           enddo
          return
         else
           if(nsumnew.eq.1) then
             do istr=1,nstr
              call dfillzero(v,mmm) !!!!!!!!!!!!!!!!!!!!!!!!!
               do i1=1,n1
                i=(i1-1)*nn
                 do i2=1,n2
                  kk=coup2(i2)
                   do i3=1,coup2(n2+i2)
                    kk=kk+1
                    jj=coup2(kk)
                    kk=kk+1
                    ii=coup2(kk)
                    v(jj,i2,i1)=isign(1,ii)*wold(istro+i+iabs(ii))
                   enddo
                 enddo
               enddo
              ic=istrn
               do i1=1,is1
                ic1=ic
                 do i2=1,is2
                   do i3=1,is3
                    ic1=ic1+1
                    wnew(ic1)=
     $v(iactsumind(in3),iactsumind(in2),iactsumind(in1))
                   enddo
                 enddo
                ic=ic+incs
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
            return
           else
             do istr=1,nstr
              call dfillzero(v,mmm) !!!!!!!!!!!!!!!!!!!!!!!!!
               do i1=1,n1
                i=(i1-1)*nn
                 do i2=1,n2
                  kk=coup2(i2)
                   do i3=1,coup2(n2+i2)
                    kk=kk+1
                    jj=coup2(kk)
                    kk=kk+1
                    ii=coup2(kk)
                    v(jj,i2,i1)=isign(1,ii)*wold(istro+i+iabs(ii))
                   enddo
                 enddo
               enddo
              ic=istrn
               do i1=1,is1
                 do i2=1,is2
                   do i3=1,is3
                    wnew(ic+i3)=
     $v(iactsumind(in3),iactsumind(in2),iactsumind(in1))
                   enddo
                  ic=ic+incs
                 enddo
               enddo
              istro=istro+inco
              istrn=istrn+incn
             enddo
            return
           endif
         endif
       endif
C
      return
      end
C
************************************************************************
      subroutine transp4(wnew,wold,nnew,nold,v,n1,n2,n3,n4,itin,in,v2,
     $coup1,coup2,nn,incs,nsumnew,ifn)
************************************************************************
* This subroutine transpose four indices of intermediates              *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isg,isg1
      integer nnew,nold,nv,no,ii,jj,in1,in2,in3,in4,in(4),itin(4),iss(4)
      integer it1,it2,it3,it4,is1,is2,is3,is4,n1,n2,n3,n4,incs,nsumnew
      integer coup1(*),coup2(*),nn,i,j,pp,kk,mm,ll,ic,ifn
      real*8 wnew(*),wold(*),v(n4,n3,n2,n1),v2(n4,n3,n2,n1),sum
C
      in1=in(1)
      in2=in(2)
      in3=in(3)
      in4=in(4)
      it1=itin(1)
      it2=itin(2)
      it3=itin(3)
      it4=itin(4)
      iss(in1)=n1
      iss(in2)=n2
      iss(in3)=n3
      iss(in4)=n4
      is1=iss(1)
      is2=iss(2)
      is3=iss(3)
      is4=iss(4)
      ic=ifn
      ii=0
       if(it2.lt.0.and.it4.lt.0) then
         if(nir.eq.1.and.(.not.mr)) then
           do i1=1,is1
             do i2=1,is2
               do i3=1,is3
                 do i4=1,is4
                  ii=ii+1
                  wnew(ii)=v2(iactsumind(in4),iactsumind(in3),
     $iactsumind(in2),iactsumind(in1))
                 enddo
               enddo
             enddo
           enddo
          return
         else
           if(nsumnew.eq.1) then
             do i1=1,is1
              ii=ic
               do i2=1,is2
                 do i3=1,is3
                   do i4=1,is4
                    ii=ii+1
                    wnew(ii)=v2(iactsumind(in4),iactsumind(in3),
     $iactsumind(in2),iactsumind(in1))
                   enddo
                 enddo
               enddo
              ic=ic+incs
             enddo
            return
           endif
           if(nsumnew.eq.2) then
             do i1=1,is1
               do i2=1,is2
                ii=ic
                 do i3=1,is3
                   do i4=1,is4
                    ii=ii+1
                    wnew(ii)=v2(iactsumind(in4),iactsumind(in3),
     $iactsumind(in2),iactsumind(in1))
                   enddo
                 enddo
                ic=ic+incs
               enddo
             enddo
            return
           endif
           if(nsumnew.eq.3) then
             do i1=1,is1
               do i2=1,is2
                 do i3=1,is3
                   do i4=1,is4
                    wnew(ic+i4)=v2(iactsumind(in4),iactsumind(in3),
     $iactsumind(in2),iactsumind(in1))
                   enddo
                  ic=ic+incs
                 enddo
               enddo
             enddo
            return
           endif
         endif
       endif
      call dfillzero(v,n1*n2*n3*n4) !!!!!!!!!!!!!!!!!!!!!!!!!
       if(it2.lt.0.and.it4.gt.0) then
         if(nir.eq.1.and.(.not.mr)) then
           do i1=1,n1
             do i2=1,n2
               do i3=1,n3
                 do i4=1,i3-1
                  ii=ii+1
                  sum=wold(ii)
                  v(i4,i3,i2,i1)=sum
                  v(i3,i4,i2,i1)=-sum
                 enddo
               enddo
             enddo
           enddo
         else
           do i1=1,n1
            i=(i1-1)*n2*nn
             do i2=1,n2
              j=i+(i2-1)*nn
               do i3=1,n3
                kk=coup2(i3)
                 do i4=1,coup2(n3+i3)
                  kk=kk+1
                  jj=coup2(kk)
                  kk=kk+1
                  ii=coup2(kk)
                  v(jj,i3,i2,i1)=isign(1,ii)*wold(j+iabs(ii))
                 enddo
               enddo
             enddo
           enddo
         endif
       endif
       if(it2.gt.0.and.it4.lt.0) then
         if(nir.eq.1.and.(.not.mr)) then
           do i1=1,n1
             do i2=1,i1-1
               do i3=1,n3
                 do i4=1,n4
                  ii=ii+1
                  sum=wold(ii)
                  v(i4,i3,i2,i1)=sum
                  v(i4,i3,i1,i2)=-sum
                 enddo
               enddo
             enddo
           enddo
         else
          nn=n3*n4
           do i1=1,n1
            kk=coup1(i1)
             do i2=1,coup1(n1+i1)
              kk=kk+1
              jj=coup1(kk)
              kk=kk+1
              ii=coup1(kk)
              isg=isign(1,ii)
              ii=(iabs(ii)-1)*nn
              i=0
               do i3=1,n3
                 do i4=1,n4
                  i=i+1
                  v(i4,i3,jj,i1)=isg*wold(ii+i)
                 enddo
               enddo
             enddo
           enddo
         endif
       endif
       if(it2.gt.0.and.it4.gt.0) then
         if(nir.eq.1.and.(.not.mr)) then
           do i1=1,n1
             do i2=1,i1-1
               do i3=1,n3
                 do i4=1,i3-1
                  ii=ii+1
                  sum=wold(ii)
                  v(i4,i3,i2,i1)=sum
                  v(i3,i4,i2,i1)=-sum
                  v(i4,i3,i1,i2)=-sum
                  v(i3,i4,i1,i2)=sum
                 enddo
               enddo
             enddo
           enddo
         else
           do i1=1,n1
            kk=coup1(i1)
             do i2=1,coup1(n1+i1)
              kk=kk+1
              jj=coup1(kk)
              kk=kk+1
              ii=coup1(kk)
              isg1=isign(1,ii)
              ii=(iabs(ii)-1)*nn
               do i3=1,n3
                ll=coup2(i3)
                 do i4=1,coup2(n3+i3)
                  ll=ll+1
                  pp=coup2(ll)
                  ll=ll+1
                  mm=coup2(ll)
                  v(pp,i3,jj,i1)=isg1*isign(1,mm)*wold(ii+iabs(mm))
                 enddo
               enddo
             enddo
           enddo
         endif
       endif
       if(nir.eq.1.and.(.not.mr)) then
        ii=0
         do i1=1,is1
           do i2=1,is2
             do i3=1,is3
               do i4=1,is4
                ii=ii+1
                wnew(ii)=
     $v(iactsumind(in4),iactsumind(in3),iactsumind(in2),iactsumind(in1))
               enddo
             enddo
           enddo
         enddo
       else
         if(nsumnew.eq.1) then
           do i1=1,is1
            ii=ic
             do i2=1,is2
               do i3=1,is3
                 do i4=1,is4
                  ii=ii+1
                  wnew(ii)=
     $v(iactsumind(in4),iactsumind(in3),iactsumind(in2),iactsumind(in1))
                 enddo
               enddo
             enddo
            ic=ic+incs
           enddo
          return
         endif
         if(nsumnew.eq.2) then
           do i1=1,is1
             do i2=1,is2
              ii=ic
               do i3=1,is3
                 do i4=1,is4
                  ii=ii+1
                  wnew(ii)=
     $v(iactsumind(in4),iactsumind(in3),iactsumind(in2),iactsumind(in1))
                 enddo
               enddo
              ic=ic+incs
             enddo
           enddo
          return
         endif
         if(nsumnew.eq.3) then
           do i1=1,is1
             do i2=1,is2
               do i3=1,is3
                 do i4=1,is4
                  wnew(ic+i4)=
     $v(iactsumind(in4),iactsumind(in3),iactsumind(in2),iactsumind(in1))
                 enddo
                ic=ic+incs
               enddo
             enddo
           enddo
          return
         endif
       endif
C
      return
      end
C
************************************************************************
      subroutine add(v1,v2,n,it,isig,ss,scspe)
************************************************************************
* Addition of two vectors                                              *
************************************************************************
      implicit none
      integer n,it,isig,i
      real*8 v1(n),v2(n),sum,ss,scspe
C
       if(isig.ne.1.or.it.gt.0) then
         if(iabs(isig).ge.10) then
          isig=isig/10
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
           do i=1,n
            v1(i)=scspe*v1(i)
           enddo
C$OMP END PARALLEL DO
         endif
         if(isig.eq.-1) then
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
           do i=1,n
            v1(i)=-v1(i)
           enddo
C$OMP END PARALLEL DO
         endif
         if(iabs(isig).ne.1.or.it.eq.3) then
           if(it.eq.3) then
            sum=ss
           else
             if(iabs(isig).le.4) then
              sum=1.d0/dble(isig)
             else
              sum=dble(isig)
               if(iabs(isig).eq.5)  sum=dsign(2.d0,sum)
             endif
           endif
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
           do i=1,n
            v1(i)=sum*v1(i)
           enddo
C$OMP END PARALLEL DO
         endif
         if(it.eq.1.or.it.eq.2) then
           if(it.eq.1.or.ss.eq.1.d0) then
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
             do i=1,n
              v1(i)=v1(i)+v2(i)
             enddo
C$OMP END PARALLEL DO
           else if(ss.ne.0.d0) then
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
             do i=1,n
              v1(i)=v1(i)+ss*v2(i)
             enddo
C$OMP END PARALLEL DO
           endif
         endif
       endif
C
      return
      end
C
************************************************************************
      subroutine readsp(wspcb,wspca,nmax,wsmax,intn,nim,imed,intrec,
     $itypa,itypb,l2map)
************************************************************************
* This subroutine reads spin cases for intermediates and cluster       *
* amplitudes                                                           *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,wmax,wsmax,i,j,k,i5,i6,i7,i8,i9,i10,nim,itr,ii
      integer wspcb(0:wsmax,1),wspca(0:wsmax,1),intn(nim),imed(16,1)
      integer intrec(*),itypa(*),itypb(*),l2map(*)
C
      read(gfile,*) (intn(i),i=1,nim)
      i1med=0
       do i=1,iimed
         if(intn(i).le.3) i1med=max(i1med,i)
       enddo
      call ifillzero(wspcb,(wspcmax+1)*nimed3)
      call ifillzero(wspca,(wspcmax+1)*nimed3)
       do i=1,nimed
        read(gfile,*) wmax,itr
        wspcb(0,itr)=wmax
         do j=1,wmax
          read(gfile,*) i1,i2,i3,i4,i5,i6,i7,i8,i9,i10
          wspcb((j-1)*12+1,itr)=i1
          wspcb((j-1)*12+2,itr)=i2
          wspcb((j-1)*12+3,itr)=i3
          wspcb((j-1)*12+4,itr)=i4
          wspcb((j-1)*12+5,itr)=i5
          wspcb((j-1)*12+6,itr)=i6
          wspcb((j-1)*12+7,itr)=i7
          wspcb((j-1)*12+8,itr)=i8
          wspcb((j-1)*12+9,itr)=i9
          wspcb((j-1)*12+10,itr)=i10
         enddo
        read(gfile,*) wmax,itr
        wspca(0,itr)=wmax
         do j=1,wmax
          read(gfile,*) i1,i2,i3,i4,i5,i6,i7,i8,i9,i10
          wspca((j-1)*12+1,itr)=i1
          wspca((j-1)*12+2,itr)=i2
          wspca((j-1)*12+3,itr)=i3
          wspca((j-1)*12+4,itr)=i4
          wspca((j-1)*12+5,itr)=i5
          wspca((j-1)*12+6,itr)=i6
          wspca((j-1)*12+7,itr)=i7
          wspca((j-1)*12+8,itr)=i8
          wspca((j-1)*12+9,itr)=i9
          wspca((j-1)*12+10,itr)=i10
         enddo
       enddo
C Definition of itypa/itypb
C  0: IT
C  1: LIT
C  2: LT
C  3: ITR
C  4: LITR
C  5: LTR1 = LTR
C  6: IC
C  7: LC
C  8: LTR2
C  9: LTR3
C 10: LTR1R2
C 11: LTR2R3
C 12: LTR1R3
C 13: LTR1R2R3
C Read intermediates
       do i=1,nimed
        read(gfile,*) (imed(j,i),j=1,16),intrec(i),itypa(i),itypb(i)
       enddo
       if(calc.eq.0) then
C CI case
C ccimed=eomimed=leftimed,
C densimed=l3imed=d2imed=nimed=nimed2
C
C Numbering of intermediates
C 1,iimed:             integral lists
C iimed+1,ccimed:      <K|H C|0> or <K|H dC/dx|0> mx elements
C ccimed+1,densimed:   (derivative) density matrix elements
C densimed+1,t1imed:   T1, <K|dH/dx C|0>
C nimed2+1,nimed3:     property integrals
        t1imed=nimed
        t2imed=nimed
        l1imed=nimed
        l2imed=nimed
        d1imed=nimed
        ds1imed=nimed
        ds2imed=nimed
        dt1imed=nimed
        dt2imed=nimed
         if(ptroute) t1imed=d2imed+ccimed
         do i=iimed+1,nimed
           if(itypa(i).eq.0) itypa(i)=6
           if(itypa(i).eq.2) itypa(i)=7
         enddo
C T1 intermediates
         call derimed(wspcb,wspca,wsmax,imed,intrec,itypa,itypb,d2imed,
     $t1imed,d2imed)
       else
C CC case
C Numbering of intermediates
C 1,iimed:             integral lists
C iimed+1,ccimed:      CC intermediates
C ccimed+1,eomimed:    right-hand LR-CC intermediates
C eomimed+1,leftimed:  left-hand LR-CC intermediates
C leftimed+1,densimed: density matrix intermediates
C densimed+1,l3imed:   L3,  <0|(1+L)[exp(-T) H exp(T), dT/dx]|K>
C l3imed+1,d2imed:     D2,  <0|(1+L)[exp(-T) {p+q-} exp(T), dT/dx]|0>
C d2imed+1,ds2imed:    DS2, <0|(1+L)[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy]|0>
C ds2imed+1,dt2imed:   DT2, <0|(1+L)[[[exp(-T) {p+q-} exp(T), dT/dx], dT/dy], dT/dz]|0>
C dt2imed+1,t1imed:    T1,  <K|exp(-T) dH/dx exp(T)|0>
C t1imed+1,t2imed:     T2,  <K|[exp(-T) H exp(T), dT/dx]|0>
C t2imed+1,l1imed:     L1,  <0|dL/dx exp(-T) H exp(T)|K>
C l1imed+1,d1imed:     D1,  <0|dL/dx exp(-T) {p+q-} exp(T)|K>
C d1imed+1,ds1imed:    DS1, <0|dL/dx [exp(-T) {p+q-} exp(T), dT/dy]|0>
C ds1imed+1,dt1imed:   DT1, <0|dL/dx [[exp(-T) {p+q-} exp(T), dT/dy], dT/dz]|0>
C dt1imed+1,l2imed:    L2,  <0|(1+L) exp(-T) dH/dx exp(T)|K>
C nimed2+1,nimed3:     property integrals
         if(ptroute) then
          t1imed=nimed+ccimed
          t2imed=nimed+eomimed
          l1imed=nimed+leftimed
          d1imed=nimed+densimed
           if(third) then
            ds1imed=nimed+densimed+d2imed-l3imed
            dt1imed=nimed+densimed+ds2imed-l3imed
           else
            ds1imed=d1imed
            dt1imed=d1imed
           endif
          l2imed=nimed2
         else
          t1imed=nimed
          t2imed=nimed
          l1imed=nimed
          l2imed=nimed
          d1imed=nimed
          ds1imed=nimed
          dt1imed=nimed
         endif
C T1, T2, L1, D1 intermediates
         call derimed(wspcb,wspca,wsmax,imed,intrec,itypa,itypb,dt2imed,
     $d1imed,dt2imed)
C DS1, DT1 intermediates
         call derimed(wspcb,wspca,wsmax,imed,intrec,itypa,itypb,d1imed,
     $dt1imed,d1imed-l3imed)
C L2 intermediates
         if(ptroute) then
          ii=dt1imed
           do i=eomimed+1,leftimed
             if(itypa(i).eq.1) then
              ii=ii+1
              l2map(i-eomimed)=ii
               do j=1,16
                imed(j,ii)=imed(j,i)
               enddo
              intrec(ii)=intrec(i)
              itypa(ii)=itypa(i)
              itypb(ii)=itypb(i)
               do j=0,wsmax
                wspcb(j,ii)=wspcb(j,i)
                wspca(j,ii)=wspca(j,i)
               enddo
             endif
           enddo
         endif
       endif
C Property integrals
       if(.not.hess) then
         do i=1,3*nprop
          call derimed(wspcb,wspca,wsmax,imed,intrec,itypa,itypb,
     $nimed+(i-1)*iimed,nimed+i*iimed,nimed+(i-1)*iimed)
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine derimed(wspcb,wspca,wsmax,imed,intrec,itypa,itypb,ifst,
     $iend,inc)
************************************************************************
* Intermediates in derivative calculation                              *
************************************************************************
#include "MRCCCOMMON"
      integer wmax,wsmax,wspcb(0:wsmax,1),wspca(0:wsmax,1),imed(16,1)
      integer intrec(*),itypa(*),itypb(*),i,j,ifst,iend,inc
C
       do i=ifst+1,iend
         do j=1,16
          imed(j,i)=imed(j,i-inc)
         enddo
        intrec(i)=intrec(i-inc)
        itypa(i)=itypa(i-inc)
        itypb(i)=itypb(i-inc)
         do j=0,wsmax
          wspcb(j,i)=wspcb(j,i-inc)
          wspca(j,i)=wspca(j,i-inc)
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine imedret(file1,irec1,tre1,file2,irec2,isg,iadd,v,nmax,n,
     $ic,c0,wspc1,wspc2,nactm,nact1,nact2,ical,nconf,trec,econf,erec,
     $ivact,ioact,wsmax,ilev1,isave,ityp,isyma,scspe)
************************************************************************
* This subroutine retrieves intermediates                              *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,n,file1,file2,irec1,irec2,isg,i,ic,file3,ical,j
      integer tre1(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax),wsmax,irec3
      integer wspc1(0:1),wspc2(0:1),ire1,ire2,ile1,iw,iadd(0:1),ia1,ia2
      integer nact1,nact2,i5,i6,i7,i8,i9,i10,ivact,ioact,ilev1,ilev
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,*)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,*)
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),isave
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),ityp
      integer isyma
      real*8 v(10),c0,scspe
C
c     write(6,*) 'imedret',wspc1(0),irec2,'   ',ilev1,isyma,denssym
       if(densroute.and.ilev1.eq.1.and.isyma.ne.denssym) return
       if(pertroute.gt.op+2.and.ical.gt.iimed) return
       if(rohfdiag.eq.1.and.ical.ne.-1.or.
     $    rohfdiag.eq.2.and.ical.gt.iimed) return
       if((leftroute.and.
     $isave.gt.0.and.ityp.eq.0.and.ilev1.lt.4.and.(.not.l2route).and.
     $(.not.l3route)).or.(l2route.and.ityp.eq.2.and.isave.gt.0)) then
        ilev=ilev1
        call skip1(ilev,ftfile)
       endif
       if(ilev1.eq.1.and.ityp.eq.0.and.l1route) return
      file3=file2
      irec3=irec2
       if(ical.lt.0) then
         if(ds1route) then
           if(calc.eq.0.and.ptfreq.eq.0.d0.and..not.optrec) then
            irec3=irec2+(nopt(1)-1)*trecmax+1
           else if(calc.eq.0.and.(ptfreq.ne.0.d0.or.optrec)) then
            irec3=irec2+2*(nopt(1)-1)*trecmax+1
           else
            irec3=irec2+(2*nopt(1)-1)*trecmax+1
           endif
         endif
         if(dt1route) irec3=irec2+(2*nopt(3)-1)*trecmax+1
C
         if(rohfdiag.gt.0) then
          file3=scrfile5
          i=1
          irec3=0
         else
          file3=lamfile
          i=iabs(ical)
         endif
C
         if(dsroute.or.dtroute) then
          call tspcase(0,0,i,i,0,0,ivact,ioact,wspc2,wsmax,
     $nconf(0,0,0,0,0,i,nirmap(isyma)),trec(0,0,0,0,0,i,nirmap(isyma)),
     $nmax,nactm)
         else if((iroot.gt.1.and.(((.not.zroute).and.(.not.d1route).and.
     $(.not.osc)).or.(osc.and.(.not.l3route).and.(.not.d2route))))
     $.or.l1route.or.(d1route.and.(.not.eomgrad)).or.
     $(calc.eq.0.and.ptroute.and.densroute).or.
     $(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy2)) then
          call tspcase(0,0,i,i,0,0,ivact,ioact,wspc2,wsmax,
     $econf(0,0,0,0,0,i),erec(0,0,0,0,0,i),nmax,nactm)
         else if(rohfdiag.gt.0) then
          call tspcase(i,i,0,0,ivact,ioact,0,0,wspc2,wsmax,
     $nconf(0,0,0,0,0,i,1),trec(0,0,0,0,0,i,1),nmax,nactm)
         else
          call tspcase(0,0,i,i,0,0,ivact,ioact,wspc2,wsmax,
     $nconf(0,0,0,0,0,i,1),trec(0,0,0,0,0,i,1),nmax,nactm)
         endif
       endif
C      write(6,*) 'imedret',ic,c0
       if(ic.eq.0.and.c0.eq.0.d0) return
       if(n.eq.0) then
         do iw=1,wspc2(0)
          i3=wspc2((iw-1)*12+3)
          i4=wspc2((iw-1)*12+4)
          i9=wspc2((iw-1)*12+9)
          i10=wspc2((iw-1)*12+10)
          ire2=wspc2((iw-1)*12+11)
          ile1=wspc2((iw-1)*12+12)
          ire1=tre1(i9,nact1-i9,i10,nact2-i10,i3)
           if(ile1.gt.0.and.ire1.gt.0) then
            call getlst(file3,irec3+ire2,v(1),ile1)
C       write(6,*) 'ime1',file3,irec3,ire2,ile1,(v(i),i=1,ile1)
             if(ic.eq.0.and.c0.ne.1.d0) call add(v,v,ile1,3,1,c0,scspe)
            call add(v(1),v(1),ile1,0,isg,1.d0,scspe)
            call fwspc(iadd,0,0,i3,i4,0,0,0,0,i9,i10,ia1,ia2)
             if(ia1.gt.0) then
              call getput(file1,irec1+ire1,v(1),ile1)
             else
              call wiadd(iadd,0,0,i3,i4,0,0,0,0,i9,i10,ile1)
              call putlst(file1,irec1+ire1,v(1),ile1)
             endif
           endif
         enddo
       else
C      write(6,*) 'ime ',wspc1(0)
         do iw=1,wspc1(0)
          i1=wspc1((iw-1)*12+1)
          i2=wspc1((iw-1)*12+2)
          i3=wspc1((iw-1)*12+3)
          i4=wspc1((iw-1)*12+4)
          i5=wspc1((iw-1)*12+5)
          i6=wspc1((iw-1)*12+6)
          i7=wspc1((iw-1)*12+7)
          i8=wspc1((iw-1)*12+8)
          i9=wspc1((iw-1)*12+9)
          i10=wspc1((iw-1)*12+10)
          ire1=wspc1((iw-1)*12+11)
          call fwspc(wspc2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,ire2,ile1)
c       if(rohfdiag.gt.0)
c    $ write(6,*) 'ime0',i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,ire2,ile1
           if(ile1.gt.0) then
            call getlst(file3,irec3+ire2,v(1),ile1)
c       if(rohfdiag.gt.0) write(6,"(a4,4i3,100f16.10)") 
c    $'ime2',file3,irec3,ire2,ile1,(v(i),i=1,ile1)
             if(ic.eq.0.and.c0.ne.1.d0) call add(v,v,ile1,3,1,c0,scspe)
            call add(v(1),v(1),ile1,0,isg,1.d0,scspe)
            call fwspc(iadd,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,ia1,ia2)
             if(ia1.gt.0) then
              call getput(file1,irec1+ire1,v(1),ile1)
             else
              call wiadd(iadd,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,ile1)
              call putlst(file1,irec1+ire1,v(1),ile1)
             endif
           endif
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine symini(mosym,mosymvo,nb,noccup,nactd,absind,absinv,
     $iscr,itrans,nfb)
************************************************************************
* This subroutine initializes symmetry variables                       *
************************************************************************
#if defined (Q5Cost)
      use q5cost
      use hdf5
#endif
#include "MRCCCOMMON"
      integer i,j,nb,mosym(nb/2),mosymvo(nb,4),noccup(*),ii,nfb,nactd(*)
      integer absind(nb,-3:0),absinv(nb,-3:0),iscr(nfb),itrans(nfb),jj
      integer kk,iq5err
C Initialize multiplication table
       do i=1,8
         do j=1,8
          mult(i,j)=multpg(i,j)
         enddo
       enddo
C Read symmetry labels
       if(q5inp) then
#if defined (Q5Cost)
      call Q5Cost_MO_get_symmetry(q5file,iscr,iq5err)
       if(iq5err.eq.-1) then
        write(iout,*) 'Unable to read symmetry labels from Q5Cost file!'
        call mrccend(1)
       endif
       do i=1,nfb
         if(itrans(i).ne.0) mosym(itrans(i))=iscr(i)
       enddo
#endif
       else
        read(inp,*) (mosym(i),i=1,nbasis/2)
       endif
c     write(6,*) 'nbasis',nbasis,nocc
c     write(6,*) (mosym(i),i=1,nbasis/2)
       if(ptroute) then
        read(inp,*) (ptsym(i),nopt(i),i=1,npert)   !szemet
c       write(6,*) 'ptsym',(ptsym(i),nopt(i),i=1,npert)   !szemet
       endif
C Read multiplication table for double groups
       if(rel.eq.2) then
        read(inp,*) i
        read(inp,*) nir
         do i=1,nir
          read(inp,*) (mult(i,j),j=1,nir)
         enddo
       endif
      denssym=1
      nir=1
       if(isym.ne.0) then
         do i=1,nbasis/2
          nir=max(nir,mosym(i))
         enddo
         if(nir.gt.2) then
           if(nir.le.4) then
            nir=4
           else
            nir=8
           endif
         endif
         do i=1,nbasis/2
          mosym(nbasis/2+i)=mosym(i)
         enddo
        refsym=1
         do i=1,nbasis/2
           if(iabs(noccup(i)).eq.1) refsym=mult(refsym,mosym(i))
         enddo
         if(refsym.ne.isym.and.eomcc)
     $write(iout,*) 'Spatial symmetry of ground state: ',refsym
C Complex conjugate of irreps
         do ir=1,nir
          nconj(ir)=ir
           do i=1,ir
c           write(6,*) ir,i,mult(ir,i)
             if(mult(ir,i).eq.1) then
              iconj(ir)=i
              iconj(i)=ir
             endif
           enddo
         enddo
c     write(6,"(8i2)") iconj
         if(eomcc) then
          isy1=1
         else
          isy1=mult(iconj(refsym),isy1)
         endif
        isy2=mult(iconj(refsym),isy2)
C      write(6,*) 'isym',isym
        isym=mult(iconj(refsym),isym)
C      write(6,*) 'isym',isym,refsym,iconj(refsym)
         if(ptroute) then
          denssym=1
           do i=1,npert
            denssym=mult(denssym,ptsym(i))
            ptsym(i)=mult(isym,ptsym(i))
            write(iout,"(' Symmetry of perturbation',i2,':',i2)") i,
     $ptsym(i)
           enddo
         else
          ptsym(1)=isym
           if(osc) denssym=mult(iconj(isy1),isy2)
         endif
       else
        iconj(1)=1
        nconj(1)=1
        isym=1
        isy1=1
        isy2=1
         do i=1,npert
          ptsym(i)=1
         enddo
        refsym=1
         do i=1,nbasis
          mosym(i)=1
         enddo
       endif
       if(ptroute) read(inp,*) (i,j=1,nir)  !szemet
C Number of irreps
      call ifillzero(nirmap,nir)
      nirmap(isym)=-1
      nirmap(isy1)=-1
      nirmap(isy2)=-1
      nirmap(denssym)=-1
       do i=1,npert
        nirmap(ptsym(i))=-1
       enddo
       if(eomcc) then
        nirmap(1)=1
       else if(calc.eq.0.and.isy1.ne.isy2) then
        nirmap(isy1)=1
       else
        nirmap(isym)=1
       endif
      nirrep=1
       do i=1,nir
         if(nirmap(i).eq.-1) then
          nirrep=nirrep+1
          nirmap(i)=nirrep
         endif
       enddo
C Orbital symmetries
C Virtual alpha
      ii=0
       do i=1,nbasis/2
         if(noccup(i).le.0.and.nactd(i).eq.1) then
          ii=ii+1
          mosymvo(ii,1)=mosym(i)
         endif
       enddo
       do i=1,nbasis/2
         if(noccup(i).le.0.and.nactd(i).eq.0) then
          ii=ii+1
          mosymvo(ii,1)=mosym(i)
         endif
       enddo
C Virtual beta
      ii=0
       do i=1,nbasis/2
         if((noccup(i).eq.1.or.noccup(i).eq.0).and.nactd(i).eq.1) then
          ii=ii+1
          mosymvo(ii,2)=mosym(i)
         endif
       enddo
       do i=1,nbasis/2
         if((noccup(i).eq.1.or.noccup(i).eq.0).and.nactd(i).eq.0) then
          ii=ii+1
          mosymvo(ii,2)=mosym(i)
         endif
       enddo
C Occupied alpha
      ii=0
       do i=1,nbasis/2
         if(noccup(i).ge.1.and.nactd(i).eq.0) then
          ii=ii+1
          mosymvo(ii,3)=mosym(i)
         endif
       enddo
       do i=1,nbasis/2
         if(noccup(i).ge.1.and.nactd(i).eq.1) then
          ii=ii+1
          mosymvo(ii,3)=mosym(i)
         endif
       enddo
C Occupied beta
      ii=0
       do i=1,nbasis/2
         if((noccup(i).eq.-1.or.noccup(i).eq.2).and.nactd(i).eq.0) then
          ii=ii+1
          mosymvo(ii,4)=mosym(i)
         endif
       enddo
       do i=1,nbasis/2
         if((noccup(i).eq.-1.or.noccup(i).eq.2).and.nactd(i).eq.1) then
          ii=ii+1
          mosymvo(ii,4)=mosym(i)
         endif
       enddo
C Numbering of orbitals
      call ifillzero(absind,nb*4)
C Virtual alpha
      ii=0
       do i=1,nbasis/2
         if(noccup(i).le.0.and.nactd(i).eq.1) then
          ii=ii+1
          absind(ii,-3)=i
         endif
       enddo
       do i=1,nbasis/2
         if(noccup(i).le.0.and.nactd(i).eq.0) then
          ii=ii+1
          absind(ii,-3)=i
         endif
       enddo
C Virtual beta
      ii=0
       do i=1,nbasis/2
         if((noccup(i).eq.1.or.noccup(i).eq.0).and.nactd(i).eq.1) then
          ii=ii+1
          absind(ii,-2)=i
         endif
       enddo
       do i=1,nbasis/2
         if((noccup(i).eq.1.or.noccup(i).eq.0).and.nactd(i).eq.0) then
          ii=ii+1
          absind(ii,-2)=i
         endif
       enddo
C Occupied alpha
      ii=0
       do i=1,nbasis/2
         if(noccup(i).ge.1.and.nactd(i).eq.0) then
          ii=ii+1
          absind(ii,-1)=i
         endif
       enddo
       do i=1,nbasis/2
         if(noccup(i).ge.1.and.nactd(i).eq.1) then
          ii=ii+1
          absind(ii,-1)=i
         endif
       enddo
C Occupied beta
      ii=0
       do i=1,nbasis/2
         if((noccup(i).eq.-1.or.noccup(i).eq.2).and.nactd(i).eq.0) then
          ii=ii+1
          absind(ii,0)=i
         endif
       enddo
       do i=1,nbasis/2
         if((noccup(i).eq.-1.or.noccup(i).eq.2).and.nactd(i).eq.1) then
          ii=ii+1
          absind(ii,0)=i
         endif
       enddo
C Generate the inverse of absind
      call ifillzero(absinv,nb*4)
       do i=-3,0
         do j=1,nbasis/2
           if(absind(j,i).gt.0) absinv(absind(j,i),i)=j
         enddo
       enddo
C Generate symmetry pairs
       do ir=1,nir
        ii=0
        jj=0
        kk=0
         do i=1,nir
           do j=1,nir
             if(mult(i,j).eq.ir) then
              ii=ii+1
              isympair(ir,ii,1)=i
              isympair(ir,ii,2)=j
c        write(6,"(a4,10i2)") 'isym',ir,i,j
             endif
             if(mult(iconj(i),j).eq.ir) then
              jj=jj+1
              csympair(ir,jj,1)=i
              csympair(ir,jj,2)=j
c        write(6,"(a4,10i2)") 'csym',ir,i,j
             endif
             if(mult(i,iconj(j)).eq.ir) then
              kk=kk+1
              dsympair(ir,kk,1)=i
              dsympair(ir,kk,2)=j
             endif
           enddo
         enddo
       enddo
C
      nr5=nir**5
      nr4=nir**4
      nr3=nir**3
      nr2=nir**2
      nrr=-nr3-nr2-nir
C
      return
      end
C
************************************************************************
      subroutine normate(norm,file1,file2)
************************************************************************
* Norm of a CI vector                                                  *
************************************************************************
#include "MRCCCOMMON"
      integer file1,file2,i,j
      real*8 norm
C
      norm=1.d0/norm
       do i=1,trecmax
        read(file1,rec=i) ibuf
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
         do j=1,ibufln
          ibuf(j)=ibuf(j)*norm
         enddo
C$OMP END PARALLEL DO
        write(file2,rec=i) ibuf
       enddo
C
      return
      end
C
************************************************************************
      subroutine hmat(nconf,nmax,sum,file1,file2,irec1,irec2,nactm)
************************************************************************
* Calculate scalar product of two vectors which are read from files    *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,i,m,n,k,file1,file2,irec1,irec2,ii
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactv,iacto,iactva,iactoa,iactvb,iactob
      real*8 sum
C
      n=0
      sum=0.d0
       do i=0,op
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             do i1=0,i
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  ii=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                   if(ii.gt.0) then
                    m=ibufln
                     do k=1,ii
                       if(m.eq.ibufln) then
                        m=0
                        n=n+1
                        read(file1,rec=irec1+n) ibuf
                        read(file2,rec=irec2+n) ibuf1
                       endif
                      m=m+1
                      sum=sum+ibuf1(m)*ibuf(m)
c                     write(6,*) ibuf(m),ibuf1(m)
                     enddo
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine savevec(file1,file2,nrec,irec1,irec2)
************************************************************************
* Copy a vector from file1 to file2                                    *
************************************************************************
#include "MRCCCOMMON"
      integer file1,file2,nrec,irec1,irec2,i
C
       do i=1,nrec
        read (file1,rec=irec1+i) ibuf
        write(file2,rec=irec2+i) ibuf
c       write(6,"(4f16.10)") ibuf(1),ibuf(2),ibuf(3),ibuf(4)
       enddo
C
      return
      end
C
************************************************************************
      subroutine savevec1(file1,file2,nrec,irec1,irec2,s)
************************************************************************
* file2 = s * file1                                                    *
************************************************************************
#include "MRCCCOMMON"
      integer file1,file2,nrec,irec1,irec2,i,j
      real*8 s
C
       if(s.eq.1.d0) then
        call savevec(file1,file2,nrec,irec1,irec2)
       else if(s.eq.-1.d0) then
         do i=1,nrec
          read (file1,rec=irec1+i) ibuf
          call ibfsgn(ibuf)
          write(file2,rec=irec2+i) ibuf
         enddo
       else
         do i=1,nrec
          read (file1,rec=irec1+i) ibuf
           do j=1,ibufln
            ibuf(j)=s*ibuf(j)
           enddo
          write(file2,rec=irec2+i) ibuf
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine lincomb(file1,file2,file3,a1,a2,nrec)
************************************************************************
* Linear combination of to vectors from file1 and file2                *
* "file3=a1*file1+a2*file2"                                            *
************************************************************************
#include "MRCCCOMMON"
      integer file1,file2,file3,i,j,nrec
      real*8 a1,a2
C
       if(a1.eq.1.d0.and.a2.eq.1.d0) then
         do i=1,nrec
          read(file1,rec=i) ibuf1
          read(file2,rec=i) ibuf2
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
           do j=1,ibufln
            ibuf(j)=ibuf1(j)+ibuf2(j)
           enddo
C$OMP END PARALLEL DO
          write(file3,rec=i) ibuf
         enddo
       else
         do i=1,nrec
          read(file1,rec=i) ibuf1
          read(file2,rec=i) ibuf2
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
           do j=1,ibufln
            ibuf(j)=a1*ibuf1(j)+a2*ibuf2(j)
           enddo
C$OMP END PARALLEL DO
          write(file3,rec=i) ibuf
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine initialc(nconf,trec,nstr,nmax,v,nnir,isympv,isympo,n,
     $ita,tarec,nactm,vmult,absinv,nb,itr,iarc,nactd,iscr,mosymvo,nrt)
************************************************************************
* This subroutine generates initial CI coefficients                    *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,ii,n
      integer nmax,nactm,i,j,k,nex,l,mm,vmult(*),jj,froot,lroot
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),nb
      integer nn,iex(16,n),iex2(16),m,ifile,ivstral,ivstrbe,iostral,iei
      integer iactv,iacto,iactva,iactoa,iactvb,iactob,iostrbe,nent,ient
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),nrt
      integer nstr(nnir,0:nactm,0:nmax,4),ita(nnir,nnir,nnir,nnir)
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer nvstral,nvstrbe,nostral,nostrbe,isym1,istg1,isym2,istg2
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nampvirtal,nampvirtbe,nampoccal,nampoccbe,mosymvo(nb,4)
      integer sspc(nmax),vstr(nmax),ostr(nmax),iarc(0:nactm,0:nmax,4)
      integer strva(nmax),strvb(nmax),stroa(nmax),strob(nmax)
      integer absinv(nb,4),itr(2,0:nactm,0:nmax,4),nactd(*),iscr(*)
      real*8 v(*),sum,maxs,coeff,coeffm,vnorm(nrt)
      logical log,log1,lei
C
       if(calc.ne.0.or.rest.ne.0.or.ptroute.or.ss3route) return
      open(eifile,file='fort.57',status='unknown')
c     write(6,*) 'open cfile'
      open(cfile,file='fort.17',status='unknown',access='direct',
     $recl=irecln)
      froot=1
       if(eomcc.and.isym.ne.1) froot=2
      lroot=nroot
       if(calc.eq.0.and.isy1.ne.isy2) then
         if(isym.eq.isy1) then
          lroot=1
         else
          froot=2
         endif
       endif
c     write(6,*) 'nroot',nroot,froot,nroot-froot+1,ntot
       if(nroot.eq.0.or.nroot-froot+1.gt.ntot) then
        write(iout,*) 'Invalid number of roots!'
        call mrccend(1)
       endif
      call dfillzero(ibuf,ibufln)
      write(tfile,rec=1) ibuf
C Find maximal excitation
      read(mpfile,rec=1) ibuf
      maxs=ibuf(1)
      nn=0
       do i=0,op
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             do i1=0,i
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  ii=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                   if(ii.gt.0) then
                    m=ibufln
                     do k=1,ii
                       if(m.eq.ibufln) then
                        m=0
                        nn=nn+1
                        read(mpfile,rec=nn) ibuf
                       endif
                      m=m+1
                      if(ibuf(m).gt.maxs) maxs=ibuf(m)
                     enddo
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
C Check if initial guess is provided
      iei=froot-1
       do iroot=froot,lroot
         if((.not.eomcc).or.iroot.ge.2) then
          read(eifile,*,end=7588) nent
           do ient=1,nent
            read(eifile,*,end=7588) 
     $nex,(sspc(i),i=1,nex),(vstr(i),i=1,nex),(ostr(i),i=1,nex),coeff
           enddo
          iei=iroot
         endif
       enddo
7588  continue
C
      rewind(scrfile6)
      coeffm=0.d0
      maxs=maxs+1.d0
      mm=0
      rewind(eifile)
       do iroot=froot,lroot
         if(((.not.eomcc).or.iroot.ge.2).and.iroot.le.iei) then
          write(iout,"(a32,i3,a3)") ' Reading initial guess from unit',
     $eifile,'...'
          vnorm(iroot)=0.d0
          read(eifile,*) nent
          write(scrfile6,*) nent
           do ient=1,nent
          read(eifile,*)
     $nex,(sspc(i),i=1,nex),(vstr(i),i=1,nex),(ostr(i),i=1,nex),coeff
           if(nex.gt.op) then
            write(iout,*) 'Corrupted initial guess!'
            write(iout,*) 'Invalid excitation level!'
            call mrccend(1)
           endif
          vnorm(iroot)=vnorm(iroot)+coeff**2
C
          nampvirtal=0
          nampvirtbe=0
          iactva=0
          iactvb=0
          iactoa=0
          iactob=0
           do i=1,nex
             if(sspc(i).eq.1) then
              nampvirtal=nampvirtal+1
              strva(nampvirtal)=absinv(vstr(i),1)
              stroa(nampvirtal)=absinv(ostr(i),3)
               if(nactd(vstr(i)).eq.1) iactva=iactva+1
               if(nactd(ostr(i)).eq.1) iactoa=iactoa+1
             else
              nampvirtbe=nampvirtbe+1
              strvb(nampvirtbe)=absinv(vstr(i),2)
              strob(nampvirtbe)=absinv(ostr(i),4)
               if(nactd(vstr(i)).eq.1) iactvb=iactvb+1
               if(nactd(ostr(i)).eq.1) iactob=iactob+1
             endif
           enddo
          nampoccal=nampvirtal
          nampoccbe=nampvirtbe
          call strorder(strva,nampvirtal)
          call strorder(strvb,nampvirtbe)
          call strorder(stroa,nampoccal)
          call strorder(strob,nampoccbe)
          call getint(strfile,itr(1,iactva,nampvirtal,1),iscr,
     $itr(2,iactva,nampvirtal,1))
          call stranal1(strva,nampvirtal,mosymvo(1,1),
     $icore(iarc(iactva,nampvirtal,1)),nvirtal,iscr,isymva,ivstral,mult,
     $nirmax)
          call getint(strfile,itr(1,iactvb,nampvirtbe,2),iscr,
     $itr(2,iactvb,nampvirtbe,2))
          call stranal1(strvb,nampvirtbe,mosymvo(1,2),
     $icore(iarc(iactvb,nampvirtbe,2)),nvirtbe,iscr,isymvb,ivstrbe,mult,
     $nirmax)
          call getint(strfile,itr(1,iactoa,nampoccal,3),iscr,
     $itr(2,iactoa,nampoccal,3))
          call stranal1(stroa,nampoccal,mosymvo(1,3),
     $icore(iarc(iactoa,nampoccal,3)),nal,iscr,isymoa,iostral,mult,
     $nirmax)
          call getint(strfile,itr(1,iactob,nampoccbe,4),iscr,
     $itr(2,iactob,nampoccbe,4))
          call stranal1(strob,nampoccbe,mosymvo(1,4),
     $icore(iarc(iactob,nampoccbe,4)),nbe,iscr,isymob,iostrbe,mult,
     $nirmax)
C
           if(mult(iconj(mult(isymva,isymvb)),mult(isymoa,isymob)).ne.
     $isym)then
            write(iout,*) 'Corrupted initial guess!'
            write(iout,*) 'Invalid symmetry!'
            call mrccend(1)
           endif
C
          nvstral=nstr(isymva,iactva,nampvirtal,1)
          nvstrbe=nstr(isymvb,iactvb,nampvirtbe,2)
          nostral=nstr(isymoa,iactoa,nampoccal,3)
          nostrbe=nstr(isymob,iactob,nampoccbe,4)
          read(tafile,rec=
     $tarec(iactva,iactvb,iactoa,iactob,nampvirtal,nex)) ita
          ii=ita(isymva,isymvb,isymoa,isymob)-1+
     $(iostrbe-1)*nostral*nvstrbe*nvstral+
     $(iostral-1)*nvstrbe*nvstral+(ivstrbe-1)*nvstral+ivstral
          write(scrfile6,*) nex,nampvirtal,nampvirtal,ivstral,ivstrbe,
     $iostral,iostrbe,isymva,isymvb,isymoa,isymob,iactva,iactvb,iactoa,
     $iactob,ii,coeff
           if(coeff.gt.coeffm) then
            coeffm=coeff
            iex( 1,iroot)=nex
            iex( 2,iroot)=nampvirtal
            iex( 3,iroot)=nampvirtal
            iex( 4,iroot)=ivstral
            iex( 5,iroot)=ivstrbe
            iex( 6,iroot)=iostral
            iex( 7,iroot)=iostrbe
            iex( 8,iroot)=isymva
            iex( 9,iroot)=isymvb
            iex(10,iroot)=isymoa
            iex(11,iroot)=isymob
            iex(12,iroot)=iactva
            iex(13,iroot)=iactvb
            iex(14,iroot)=iactoa
            iex(15,iroot)=iactob
            iex(16,iroot)=ii
           endif
          mm=iroot
           enddo
          vnorm(iroot)=dsqrt(vnorm(iroot))
           if(vnorm(iroot).eq.0.d0) then
            write(iout,*) 'Corrupted initial guess!'
            write(iout,*) 'The norm of the trial vector is zero!'
            call mrccend(1)
           endif
         else
        multip=vmult(iroot)
        sum=maxs
C Loop over excitations
         do nex=0,op
           do iactv=max(0,nex-mrop),min(nactv,nex)
             do iacto=max(0,nex-mrop),min(nacto,nex)
               do i1=0,nex
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                    nn=nconf(iactva,iactvb,iactoa,iactob,i1,nex)
               if(nn.gt.0) then
                nampvirtal=i1
                nampvirtbe=nex-nampvirtal
                nampoccal=i1
                nampoccbe=nex-nampoccal
      call getlst(mpfile,
     $trec(iactva,iactvb,iactoa,iactob,i1,nex),v(1),nn)
                ii=0
                 do ir=1,nir
                  isymv=csympair(isym,ir,1)
                  isymo=csympair(isym,ir,2)
                   do irv=1,isympv(0,isymv,iactva,iactvb,nampvirtal,
     $nampvirtbe,1)
      isymva=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,1)
      isymvb=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,2)
                    nvstral=nstr(isymva,iactva,nampvirtal,1)
                    nvstrbe=nstr(isymvb,iactvb,nampvirtbe,2)
                     do iro=1,isympo(0,isymo,iactoa,iactob,nampoccal,
     $nampoccbe,1)
      isymoa=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,1)
      isymob=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,2)
                      nostral=nstr(isymoa,iactoa,nampoccal,3)
                      nostrbe=nstr(isymob,iactob,nampoccbe,4)
C Loop over strings
                       do iostrbe=1,nostrbe
                         do iostral=1,nostral
                           do ivstrbe=1,nvstrbe
                             do ivstral=1,nvstral
                              ii=ii+1
                               if(v(ii).lt.sum.and.
     $(multip.ne.3.or.ivstral.ne.ivstrbe.or.iostral.ne.iostrbe.or.
     $isymva.ne.isymvb.or.isymoa.ne.isymob.or.iactva.ne.iactvb.or.
     $iactoa.ne.iactob.or.nal.ne.nbe.or.nactva.ne.nactvb.or.
     $nactoa.ne.nactob.or.(.not.cs).or.nex-i1.ne.i1)) then
                                iex2(1)=nex
                                iex2(2)=i1
                                iex2(3)=i1
                                iex2(4)=ivstral
                                iex2(5)=ivstrbe
                                iex2(6)=iostral
                                iex2(7)=iostrbe
                                iex2(8)=isymva
                                iex2(9)=isymvb
                                iex2(10)=isymoa
                                iex2(11)=isymob
                                iex2(12)=iactva
                                iex2(13)=iactvb
                                iex2(14)=iactoa
                                iex2(15)=iactob
                                 do k=froot,iroot-1
                                  log=.true.
                                   do l=1,15
                                     if(iex2(l).ne.iex(l,k)) log=.false.
                                   enddo
                                  log1=.true.
                                   if(iex2(1).ne.iex(1,k)) log1=.false.
                                   do l=2,3
                                     if(iex2(l).ne.iex(1,k)-iex(l,k))
     $                                 log1=.false.
                                   enddo
                                   do l=4,14,2
                                     if(iex2(l).ne.iex(l+1,k).or.
     $                               iex2(l+1).ne.iex(l,k)) log1=.false.
                                   enddo
                                   if(log.or.log1) goto 2021
                                 enddo
                                sum=v(ii)
                                 do l=1,15
                                  iex(l,iroot)=iex2(l)
                                 enddo
                                iex(16,iroot)=ii
                                mm=iroot
2021                            continue
                               endif
                             enddo
                           enddo
                         enddo
                       enddo
                     enddo
                   enddo
                 enddo
               endif
             enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
         endif
       enddo
c     write(6,*) 'mm',mm,nsing,ntrip
       if(mm.lt.lroot) then !min(lroot,max(nsing,ntrip,ndoub))) then
        write(iout,*) 'Invalid number of roots!'
        call mrccend(1)
       endif
C Initialize CI vector
      rewind(scrfile6)
      irecmax=(froot-1)*trecmax
       if(nroot.eq.1.or.(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy1)) 
     $then
        ifile=tfile
       else
        call dfillzero(ibuf,ibufln)
        ifile=cfile
         do k=irecmax+1,lroot*trecmax
          write(cfile,rec=k) ibuf
         enddo
       endif
      jj=0
       do iroot=froot,lroot
        lei=((.not.eomcc).or.iroot.ge.2).and.iroot.le.iei
        nent=1
         if(lei) read(scrfile6,*) nent
           do ient=1,nent
            multip=vmult(iroot)
             if(lei) then
              read(scrfile6,*) (iex2(i),i=1,16),coeff
              nex=iex2(1)
              i1=iex2(2)
              i2=iex2(3)
              ivstral=iex2(4)
              ivstrbe=iex2(5)
              iostral=iex2(6)
              iostrbe=iex2(7)
              isymva=iex2(8)
              isymvb=iex2(9)
              isymoa=iex2(10)
              isymob=iex2(11)
              iactva=iex2(12)
              iactvb=iex2(13)
              iactoa=iex2(14)
              iactob=iex2(15)
              ii=iex2(16)
             else
               if(nsing.gt.0.and.multip.eq.3.and.vmult(iroot-1).eq.1)
     $jj=nsing-froot+1
636     continue
               do l=1,16
                iex2(l)=iex(l,iroot-jj)
               enddo      
              nex=iex2(1)
              i1=iex2(2)
              i2=iex2(3)
              ivstral=iex2(4)
              ivstrbe=iex2(5)
              iostral=iex2(6)
              iostrbe=iex2(7)
              isymva=iex2(8)
              isymvb=iex2(9)
              isymoa=iex2(10)
              isymob=iex2(11)
              iactva=iex2(12)
              iactvb=iex2(13)
              iactoa=iex2(14)
              iactob=iex2(15)
              ii=iex2(16)
               if(multip.eq.3.and.ivstral.eq.ivstrbe.and.iostral.eq.
     $iostrbe.and.isymva.eq.isymvb.and.isymoa.eq.isymob.and.iactva.eq.
     $iactvb.and.iactoa.eq.iactob.and.nal.eq.nbe.and.nactva.eq.nactvb
     $.and.nactoa.eq.nactob.and.nex-i1.eq.i1.and.nex-i2.eq.i2) then
                jj=jj-1
                goto 636
               endif
             endif
        log=.true.
         do l=2,3
           if(iex2(l).ne.nex-iex2(l)) log=.false.
         enddo
         do l=4,14,2
           if(iex2(l).ne.iex2(l+1)) log=.false.
         enddo
        nampvirtal=i1
        nampvirtbe=nex-nampvirtal
        nampoccal=i2
        nampoccbe=nex-nampoccal
c       write(6,*) 'elott',isymva,iactva,nampvirtal
        nvstral=nstr(isymva,iactva,nampvirtal,1)
        nvstrbe=nstr(isymvb,iactvb,nampvirtbe,2)
        nostral=nstr(isymoa,iactoa,nampoccal,3)
        nostrbe=nstr(isymob,iactob,nampoccbe,4)
        sum=1.d0
         if(lei) sum=coeff/vnorm(iroot)
         if(.not.(multip.eq.2.or.log.or.nal.ne.nbe.or.nactva.ne.nactvb
     $.or.nactoa.ne.nactob.or.(.not.cs))) sum=sum/dsqrt(2.d0)
        mm=mod(ii,ibufln)
         if(mm.eq.0) mm=ibufln
        k=trec(iactva,iactvb,iactoa,iactob,i1,nex)+(ii-mm)/ibufln
        read(ifile,rec=irecmax+k) ibuf
        ibuf(mm)=sum
        write(ifile,rec=irecmax+k) ibuf
         if(multip.eq.2.or.log.or.nal.ne.nbe.or.
     $nactva.ne.nactvb.or.nactoa.ne.nactob.or.(.not.cs)) goto 3015
C
         if(multip.eq.3) sum=-sum
        read(tafile,rec=
     $tarec(iactvb,iactva,iactob,iactoa,nampvirtbe,nex)) ita
        ii=ita(isymvb,isymva,isymob,isymoa)-1+
     $(iostral-1)*nostrbe*nvstral*nvstrbe+
     $(iostrbe-1)*nvstral*nvstrbe+(ivstral-1)*nvstrbe+ivstrbe
        mm=mod(ii,ibufln)
         if(mm.eq.0) mm=ibufln
        k=trec(iactvb,iactva,iactob,iactoa,nampvirtbe,nex)+
     $(ii-mm)/ibufln
        read(ifile,rec=irecmax+k) ibuf
        ibuf(mm)=sum
        write(ifile,rec=irecmax+k) ibuf
3015    continue
         enddo
c     write(6,*) 'ifile',ifile,iroot
      call szemet(ifile,nconf,nmax,nactm,trec,v,irecmax,i,i,i,nconf,
     $trec)
        irecmax=irecmax+trecmax
       enddo
      close(scrfile6,status='delete')
C
      return
      end
C
************************************************************************
      subroutine transpc(nstr,nmax,nnir,isympv,isympo,ita,tarec,v,vnew,
     $navirtal,navirtbe,naoccal,naoccbe,nex,iactva,iactvb,iactoa,iactob,
     $nactm,ssym)
************************************************************************
* This subroutine transposes CI coefficients                           *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,ii,n
      integer iactva,iactvb,iactoa,iactob,nactm,i,j,k,nex,l,ssym,iii
      integer nmax,jj,n1,n2,kk,ll,m,ita(nnir,nnir,nnir,nnir)
      integer nstr(nnir,0:nactm,0:nmax,4)
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer nvstral,nvstrbe,nostral,nostrbe,navirtal,navirtbe
      integer ivstral,ivstrbe,iostral,iostrbe,naoccal,naoccbe
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      real*8 v(*),vnew(*),sum
C
      read(tafile,rec=tarec(iactvb,iactva,iactob,iactoa,navirtbe,nex)) 
     $ita
      iii=0
       do ir=1,nir
        isymv=csympair(ssym,ir,1)
        isymo=csympair(ssym,ir,2)
         do irv=1,isympv(0,isymv,iactva,iactvb,navirtal,navirtbe,1)
          isymva=isympv(irv,isymv,iactva,iactvb,navirtal,navirtbe,1)
          isymvb=isympv(irv,isymv,iactva,iactvb,navirtal,navirtbe,2)
          nvstral=nstr(isymva,iactva,navirtal,1)
          nvstrbe=nstr(isymvb,iactvb,navirtbe,2)
          n2=nvstral*nvstrbe
           do iro=1,isympo(0,isymo,iactoa,iactob,naoccal,naoccbe,1)
            isymoa=isympo(iro,isymo,iactoa,iactob,naoccal,naoccbe,1)
            isymob=isympo(iro,isymo,iactoa,iactob,naoccal,naoccbe,2)
            nostral=nstr(isymoa,iactoa,naoccal,3)
            nostrbe=nstr(isymob,iactob,naoccbe,4)
            n1=n2*nostrbe
C$OMP PARALLEL
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(iii,n1,n2,nostrbe,nostral,nvstrbe,nvstral,v,vnew,ita)
C$OMP& SHARED(isymvb,isymva,isymob,isymoa,xyzsize)
#if defined (OMP)
      thrd=OMP_GET_THREAD_NUM()
      xyzcount=0
#endif
            ii=iii
            jj=ita(isymvb,isymva,isymob,isymoa)-1
             do iostrbe=1,nostrbe
              kk=jj
               do iostral=1,nostral
#if defined (OMP)
           if(thrd.eq.xyzcount) then
#endif
                 do ivstrbe=1,nvstrbe
                  ll=kk+ivstrbe
                   do ivstral=1,nvstral
                    ii=ii+1
                    vnew(ll)=v(ii)
                    ll=ll+nvstrbe
                   enddo
                 enddo
#if defined (OMP)
           else
            ii=ii+n2
           endif
           if(xyzcount.eq.xyzsize) then
            xyzcount=0
           else
            xyzcount=xyzcount+1
           endif
#endif
                kk=kk+n1
               enddo
              jj=jj+n2
             enddo
C$OMP END PARALLEL
            iii=iii+n1*nostral
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine transpcs(v,vnew,nvstral,nvstrbe,nostral,nostrbe)
************************************************************************
* This subroutine transposes CI coefficients                           *
************************************************************************
#include "MRCCCOMMON"
      integer nvstral,nvstrbe,nostral,nostrbe
      integer ivstral,ivstrbe,iostral,iostrbe
      integer ii,jj,kk,ll,n1,n2,n3
      real*8 v(*),vnew(*)
C
      n2=nvstral*nvstrbe
      n1=n2*nostrbe
C$OMP PARALLEL
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(n1,n2,nostrbe,nostral,nvstrbe,nvstral,v,vnew,xyzsize)
#if defined (OMP)
      thrd=OMP_GET_THREAD_NUM()
      xyzcount=0
      n3=nvstral*nvstrbe
#endif
      ii=0
      jj=0
       do iostrbe=1,nostrbe
        kk=jj
         do iostral=1,nostral
#if defined (OMP)
           if(thrd.eq.xyzcount) then
#endif
           do ivstrbe=1,nvstrbe
            ll=kk+ivstrbe
             do ivstral=1,nvstral
              ii=ii+1
              vnew(ll)=v(ii)
              ll=ll+nvstrbe
             enddo
           enddo
#if defined (OMP)
           else
            ii=ii+n3
           endif
           if(xyzcount.eq.xyzsize) then
            xyzcount=0
           else
            xyzcount=xyzcount+1
           endif
#endif
          kk=kk+n1
         enddo
        jj=jj+n2
       enddo
C$OMP END PARALLEL
C
      return
      end
C
************************************************************************
      subroutine symmetrize(nconf,trec,nstr,nmax,nnir,isympv,
     $isympo,ita,tarec,v,ifile,nactm,ssym)
************************************************************************
* This subroutine transposes CI coefficients                           *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,ii,n
      integer nmax,nactm,i,j,k,nex,l,iactob,ssym,nvirtnewallen
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nstr(nnir,0:nactm,0:nmax,4),ifile,n2,kk,ll,irav,irao
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),jj,n1
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),m,ira
      integer nvstral,nvstrbe,nostral,nostrbe,navirtal,navirtbe
      integer ivstral,ivstrbe,iostral,iostrbe,naoccal,naoccbe
      integer nvirtnewsym,noccnewsym,nvirtnewsyma,nvirtnewsymb
      integer nvirtnewbelen,noccnewsyma,noccnewsymb,noccnewbelen
      integer ita(nnir,nnir,nnir,nnir),iactv,iacto,iactva,iactoa,iactvb
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nampvirtal,nampvirtbe,nampoccal,nampoccbe
      real*8 v(*),sum
C
c      if(calc.ne.0) return !szemet
       if(multip.eq.2.or.nal.ne.nbe.or.nactva.ne.nactvb.or.
     $nactoa.ne.nactob.or.(.not.rhf)) return
       do nex=0,op
         do iactv=max(0,nex-mrop),min(nactv,nex)
           do iacto=max(0,nex-mrop),min(nacto,nex)
             do i1=0,nex
              nampvirtal=i1
              nampvirtbe=nex-nampvirtal
              nampoccal=i1
              nampoccbe=nex-nampoccal
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                    ii=nconf(iactva,iactvb,iactoa,iactob,i1,nex)
             if(ii.gt.0) then
      call getlst(ifile,
     $trec(iactva,iactvb,iactoa,iactob,i1,nex),v(1),ii)
               if(nampvirtal.lt.nampvirtbe.or.(nampvirtal.eq.nampvirtbe
     $.and.iactva.lt.iactvb).or.(nampvirtal.eq.nampvirtbe.and.
     $iactva.eq.iactvb.and.iactoa.lt.iactob)) then       !???
      call transpc(nstr,nmax,nir,isympv,   !???
     $isympo,ita,tarec,v,v(ii+1),nampvirtal,nampvirtbe,nampoccal,
     $nampoccbe,nex,iactva,iactvb,iactoa,iactob,nactmax,ssym)
       if(multip.eq.3) call add(v(ii+1),v(ii+1),ii,0,-1,1.d0,1.d0)
      call putlst(ifile,
     $trec(iactvb,iactva,iactob,iactoa,nampvirtbe,nex),
     $v(ii+1),ii)
               endif
               if(nampvirtal.eq.nampvirtbe.and.iactva.eq.iactvb.and.
     $iactoa.eq.iactob) then
      read(tafile,rec=tarec(iactva,iactvb,iactoa,iactob,nampvirtal,
     $nex)) ita
         do ira=1,nir
      nvirtnewsym=csympair(ssym,ira,1)
      noccnewsym=csympair(ssym,ira,2)
           do irav=1,isympv(0,nvirtnewsym,iactva,iactvb,nampvirtal,
     $nampvirtbe,1)
      nvirtnewsyma=isympv(irav,nvirtnewsym,iactva,iactvb,nampvirtal,
     $nampvirtbe,1)
      nvirtnewsymb=isympv(irav,nvirtnewsym,iactva,iactvb,nampvirtal,
     $nampvirtbe,2)
      nvirtnewallen=nstr(nvirtnewsyma,iactva,nampvirtal,1)
      nvirtnewbelen=nstr(nvirtnewsymb,iactvb,nampvirtbe,2)
      nvirtnewlen=nvirtnewallen*nvirtnewbelen
             do irao=1,isympo(0,noccnewsym,iactoa,iactob,nampoccal,
     $nampoccbe,1)
      noccnewsyma=isympo(irao,noccnewsym,iactoa,iactob,nampoccal,
     $nampoccbe,1)
      noccnewsymb=isympo(irao,noccnewsym,iactoa,iactob,nampoccal,
     $nampoccbe,2)
      noccnewallen=nstr(noccnewsyma,iactoa,nampoccal,3)
      noccnewbelen=nstr(noccnewsymb,iactob,nampoccbe,4)
      noccnewlen=noccnewallen*noccnewbelen
               if(nvirtnewlen*noccnewlen.gt.0.and.(
     $nvirtnewsyma.lt.nvirtnewsymb.or.(nvirtnewsyma.eq.nvirtnewsymb.and.
     $noccnewsyma.lt.noccnewsymb))) then
C
      kk=ita(nvirtnewsyma,nvirtnewsymb,noccnewsyma,noccnewsymb)
      jj=ita(nvirtnewsymb,nvirtnewsyma,noccnewsymb,noccnewsyma)
      call transpcs(v(kk),v(jj),nvirtnewallen,nvirtnewbelen,
     $noccnewallen,noccnewbelen)
       if(multip.eq.3) call add(v(jj),v(jj),nvirtnewlen*noccnewlen,0,-1,
     $1.d0,1.d0)
               endif
             enddo
           enddo
         enddo
      call putlst(ifile,
     $trec(iactva,iactvb,iactoa,iactob,i1,nex),v(1),ii)
               endif
             endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine schmidt(nconf,nmax,file1,file2,log)
************************************************************************
* Schmidt orthogonaliztion of the excited state vector                 *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nconf,i,j,file1,file2,ii,jj,froot
      real*8 sum
      logical log
C
      jj=0
      froot=1
       if((eomroute.and.isym.ne.1).or.(calc.eq.0.and.isy1.ne.isy2)) then
        froot=2
        jj=trecmax
       endif
       do ii=froot,iroot-1
         if(eomroute.and.ii.eq.1) then
          read(file1,rec=1) ibuf
          ibuf(1)=0.d0
          write(file1,rec=1) ibuf
         else
          call hmat(nconf,nmax,sum,cfile,file1,jj,0,nactmax)
           do i=1,trecmax
            read(file1,rec=i) ibuf
            read(cfile,rec=jj+i) ibuf1
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
             do j=1,ibufln
              ibuf(j)=ibuf(j)-sum*ibuf1(j)
             enddo
C$OMP END PARALLEL DO
            write(file1,rec=i) ibuf
           enddo
         endif
        jj=jj+trecmax
       enddo
      call hmat(nconf,nmax,sum,file1,file1,0,0,nactmax)
      sum=dsqrt(sum)
       if(sum.gt.tol) then
        call normate(sum,file1,file2)
        log=.false.
       else
        log=.true.
       endif
C
      return
      end
C
************************************************************************
      subroutine fwspc(wspc,n1,n2,n3,n4,n5,n6,n7,n8,n9,n10,ire,ile)
************************************************************************
* Give back the record number and the length of an intermediate        *
************************************************************************
#include "MRCCCOMMON"
      integer wspc(0:1),n1,n2,n3,n4,n5,n6,n7,n8,n9,n10,ire,ile,i
C
      i=0
9879   continue
        if(wspc(i+11).eq.0) then
         ire=0
         ile=0
         return
        endif
        i=i+1
         if(wspc(i).ne.n1) then
          i=i+11
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n2) then
          i=i+10
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n3) then
          i=i+9
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n4) then
          i=i+8
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n5) then
          i=i+7
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n6) then
          i=i+6
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n7) then
          i=i+5
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n8) then
          i=i+4
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n9) then
          i=i+3
          goto 9879
         endif
        i=i+1
         if(wspc(i).ne.n10) then
          i=i+2
          goto 9879
         endif
        ire=wspc(i+1)
        ile=wspc(i+2)
C
      return
      end
C
************************************************************************
      subroutine wiadd(iadd,n1,n2,n3,n4,n5,n6,n7,n8,n9,n10,ilen)
************************************************************************
* Write in iadd array                                                  *
************************************************************************
      implicit none
      integer iadd(0:12),n1,n2,n3,n4,n5,n6,n7,n8,n9,n10,i,ilen
C
       if(ilen.eq.0) return
      i=iadd(0)
      iadd(0)=i+1
      i=i*12
      iadd(i+1)=n1
      iadd(i+2)=n2
      iadd(i+3)=n3
      iadd(i+4)=n4
      iadd(i+5)=n5
      iadd(i+6)=n6
      iadd(i+7)=n7
      iadd(i+8)=n8
      iadd(i+9)=n9
      iadd(i+10)=n10
      iadd(i+11)=ilen
C
      return
      end
C
************************************************************************
      subroutine szemet(file,nconf,nmax,nactm,trec,v,irec,wspc,wsmax,
     $denrec,econf,erec)
************************************************************************
* Szemet rutin tesztelesre
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,i,k,l,m,n,nn,iw,wsmax,wspc(0:wsmax,13),ii,mm
      integer denrec(*)
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactvb,iactob,iactv,iacto,iactva,iactoa,file,irec
      real*8 v(*),sum,sum1
C
c      if(iroot.ne.2) return
      return
#if defined (MPI)
       if(rank.ne.0) return
#endif
      write(6,*)
      write(6,*) 'szemet',ptsh
      sum=0.d0
      sum1=0.d0
       if(densroute) then
         do i=ptsh+1,ptsh+iimed
          ii=i-ptsh
           if(dens.gt.1.or.nops(ii).eq.2) then
             do iw=1,wspc(0,i)
              write(6,"(i3,11i2,9i4)") ii,(wspc((iw-1)*12+k,i),k=1,12),
     $denrec(ii),denrec(ii)+wspc((iw-1)*12+11,i),drecmax,i
              call getlst(file,denrec(ii)+wspc((iw-1)*12+11,i),v(1),
     $wspc((iw-1)*12+12,i))
              write(6,347) (v(k),k=1,wspc((iw-1)*12+12,i))
               do k=1,wspc((iw-1)*12+12,i)
                sum=sum+v(k)**2
                sum1=max(sum1,dabs(v(k)))
               enddo
             enddo
           endif
         enddo
       else
         do i=0,op
           do iactv=max(0,i-mrop),min(nactv,i)
             do iacto=max(0,i-mrop),min(nacto,i)
               do i1=0,i
                nn=0
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                     if(isym.eq.isy1.or.(eomcc.and.iroot.eq.1)) then
                      nn=nn+nconf(iactva,iactvb,iactoa,iactob,i1,i)
                     else
                      nn=nn+econf(iactva,iactvb,iactoa,iactob,i1,i)
                     endif
                   enddo
                 enddo
                 if(nn.gt.0) write(6,458) i,i1
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                     if(isym.eq.isy1.or.(eomcc.and.iroot.eq.1)) then
                      nn=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= trec(iactva,iactvb,iactoa,iactob,i1,i)
                     else
                      nn=econf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= erec(iactva,iactvb,iactoa,iactob,i1,i)
                     endif
                     if(nn.gt.0) then
                      call getlst(file,irec+mm,v(1),nn)
      write(6,347) (v(k),k=1,nn)
                       if(i.ge.0.or.calc.eq.0.or.eomroute) then
c                      if(i.gt.0.or.calc.eq.0.or.eomroute) then
                         do k=1,nn
                          sum=sum+v(k)**2
                          sum1=max(sum1,dabs(v(k)))
                         enddo
                       endif
                     endif
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       endif
      write(6,*)
      write(6,*) 'Euc norm:',dsqrt(sum)
      write(6,*) 'Max norm:',sum1
      write(6,*)
458   format(20i2)
347   format(4f16.10)
C
      return
      end
C
************************************************************************
      subroutine david(bmat,bvec,invbmat,cvec,ndmax,v,nconf,trec,nmax,
     $nactm,test,norm,file,cveco)
************************************************************************
* Davidson extrapolation                                               *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,nact,nactpl,iact,ii,i,j,ntrecact,file
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer ndmax,iactv,iacto,iactva,iactoa,iactvb,iactob,n,nn,m,k
      real*8 bmat(ndmax,ndmax),bvec(ndmax,ndmax),invbmat(ndmax,ndmax)
      real*8 cvec(ndmax),cveco(*),sum,sum1,v(*),norm,test,norm2,denom
      logical log
C
      nact=min(ndiis,nit)
      nactpl=mod(nit,ndiis)
       if(nactpl.eq.0) nactpl=ndiis
      ntrecact=(nactpl-1)*trecmax
C Save CI coefficients and sigma vector
       do i=1,trecmax
        read(file,rec=i) ibuf
        write(diisfile,rec=ntrecact+i) ibuf
        read(scrfile1,rec=i) ibuf1
        write(errfile,rec=ntrecact+i) ibuf1
       enddo
C Update the scalar product matrix (H matrix)
       do iact=1,nact
        bmat(nactpl,iact)=0.d0
        bmat(iact,nactpl)=0.d0
       enddo
       do i=0,op
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             do i1=0,i
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  ii=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                   if(ii.gt.0) then
                    call getlst(file,
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(1),ii)
                     do iact=1,nact
                      call getlst(errfile,(iact-1)*trecmax+
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(ii+1),ii)
                      call scalprod(v(1),v(ii+1),ii,sum)
                      bmat(nactpl,iact)=bmat(nactpl,iact)+sum
                       if(.not.eomroute.and.iact.ne.nact) 
     $bmat(iact,nactpl)=bmat(iact,nactpl)+sum
                     enddo
                     if(eomroute) then
                      call getlst(scrfile1,
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(1),ii)
                       do iact=1,nact-1
                        call getlst(diisfile,(iact-1)*trecmax+
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(ii+1),ii)
                        call scalprod(v(1),v(ii+1),ii,sum)
                        bmat(iact,nactpl)=bmat(iact,nactpl)+sum
                       enddo
                     endif
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
C Diagonalize small H matrix
       do j=1,nact
         do i=1,nact
          invbmat(i,j)=bmat(i,j)
         enddo
       enddo
C rg version
c     call rg(ndmax,nact,invbmat,cvec,v(1),1,bvec,v(ndmax+1),
c    $v(2*ndmax+1),ii)
C givens version
c     call givens(invbmat,cvec,ndmax,ii,1.d-16,1.d-16,nact)
c      do j=1,nact
c        do i=1,nact
c         bvec(i,j)=invbmat(i,j)
c        enddo
c      enddo
c     call dfillzero(v,nact)
c     ii=1-ii
C tred12 version
c     call tred12(nact,ndmax,invbmat,bvec,cvec,v,-2)
c     call dfillzero(v,nact)
c     ii=0
C dgeev version
      call dgeev('N','V',nact,invbmat,ndmax,cvec,v(1),sum,1,bvec,
     $ndmax,v(ndmax+1),ndmax**2,ii)
       if(ii.ne.0) then
        write(iout,*) 'Fatal error in matrix diagonalization.'
        call mrccend(1)
       endif
      call scalprod(v(1),v(1),nact,sum)
       if(dsqrt(sum).ne.0.d0)
     $write(iout,*) 'Complex root in matrix diagonalization.'
       if(((eomroute.and.op.ne.1).or.diag.eq.2).and.nact.gt.1) then
        call dfillzero(cveco,nact)
        cveco(1)=1.d0
        ii=1
        sum1=0.d0
         do i=1,nact
          call scalprod(cveco,bvec(1,i),nact-1,sum)
          sum=sum**2
           if(sum.gt.sum1) then
            sum1=sum
            ii=i
           endif
         enddo
        ecc=cvec(ii)
       else
        ecc=cvec(1)
        ii=1
         do i=1,nact
           if(cvec(i).lt.ecc) then
            ecc=cvec(i)
            ii=i
           endif
         enddo
       endif
       if(v(ii).ne.0.d0) then
        write(iout,*) 'Desired root is complex.'
        write(iout,*) 'Imaginary part: ',v(ii)
c       call mrccend(1)
       endif
       do i=1,nact
        cvec(i)=bvec(i,ii)
        cveco(i)=cvec(i)
       enddo
      test=dabs(cvec(nactpl))
C Calculate new CI vector
       do n=1,trecmax
        call dfillzero(ibuf,ibufln)
         do iact=1,nact
          read(diisfile,rec=(iact-1)*trecmax+n) ibuf1
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
           do j=1,ibufln
            ibuf(j)=ibuf(j)+cvec(iact)*ibuf1(j)
           enddo
C$OMP END PARALLEL DO
         enddo
        write(scrfile1,rec=n) ibuf
       enddo
C Calculate residual vector and its norm
      norm=0.d0
      norm2=0.d0
      n=0
       do i=0,op
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             do i1=0,i
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  nn=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                   if(nn.gt.0) then
                    m=ibufln
                     do k=1,nn
                       if(m.eq.ibufln) then
                        m=0
                        n=n+1
                        call dfillzero(ibuf1,ibufln)
                         do iact=1,nact
                          read(errfile,rec=(iact-1)*trecmax+n) ibuf3
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
                           do j=1,ibufln
                            ibuf1(j)=ibuf1(j)+cvec(iact)*ibuf3(j)
                           enddo
C$OMP END PARALLEL DO
                         enddo
                        read(scrfile1,rec=n) ibuf
                        read(mpfile,rec=n) ibuf2
                       endif
                      m=m+1
                      denom=ibuf2(m)-ecc
                       if(nit.eq.1.and.dabs(denom).lt.1d-9)
     $denom=1.0  !d20
                      sum=ibuf1(m)-ecc*ibuf(m)
                      norm=norm+sum**2
                      v(k)=sum/denom
c     write(6,*) 'dav',sum,ibuf1(m),ecc,ibuf(m),'   ',norm,denom,v(k)
                      norm2=norm2+ibuf(m)**2
                     enddo
                    call putlst(file,
     $trec(iactva,iactvb,iactoa,iactob,i1,i),v(1),nn)
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
      norm=norm/norm2
C Schmidt orthogonalization
       do iact=1,nact
        ii=(iact-1)*trecmax
        call hmat(nconf,nmax,sum,diisfile,file,ii,0,nactm)
c      write(6,*) 'dav/sum',sum,'  ',file
         do i=1,trecmax
          read(file,rec=i) ibuf
          read(diisfile,rec=ii+i) ibuf1
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
           do j=1,ibufln
            ibuf(j)=ibuf(j)-sum*ibuf1(j)
           enddo
C$OMP END PARALLEL DO
          write(file,rec=i) ibuf
         enddo
       enddo
      call hmat(nconf,nmax,norm2,file,file,0,0,nactmax)
      norm2=dsqrt(norm2)
       if(norm2.lt.tol) then
        norm=0.d0
        return
       endif
      call normate(norm2,file,file)
C Orthogonalize onto the lower roots
       if(iroot.gt.1.and.(.not.eomroute.or.op.eq.1)) then
        call schmidt(nconf,nmax,file,file,log)
         if(log) norm=0.d0
       endif
C
      return
      end
C
************************************************************************
      subroutine expt(isig,file1,ladj,ncon1,tre1,ncon2,tre2,nstr,nmax,v,
     $nnir,isympv,isympo,ita,tarec,nactm,icmem,npow,isym1,isym2,ttfile,
     $ncon3,tre3,func,outpfile)
************************************************************************
* This subroutine generates CI coefficients from cluster amplitudes    *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,ii,nmax,nactm,i,j,k,l,nex1,nex2,nex3,ii1,ii2,ii3,isg
      integer isymv1,isymo1,isymva1,isymvb1,isymoa1,isymob1,irv1,iro1
      integer isymv2,isymo2,isymva2,isymvb2,isymoa2,isymob2,irv2,iro2
      integer isymv3,isymo3,isymva3,isymvb3,isymoa3,isymob3,irv3,iro3
      integer nvstral1,nvstrbe1,nostral1,nostrbe1,ir1,nn,nn1,nn2,nn3
      integer nvstral2,nvstrbe2,nostral2,nostrbe2,ir2,isig,file1,ilo
      integer nvstral3,nvstrbe3,nostral3,nostrbe3,ir3,iup,iup1,isym1
      integer ncon1(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),isym2
      integer tre1(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer ncon2(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer tre2(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer ncon3(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer tre3(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer naval1,naoal1,navbe1,naobe1,ttfile,npow,outpfile
      integer naval2,naoal2,navbe2,naobe2
      integer naval3,naoal3,navbe3,naobe3
      integer iactv1,iacto1,iactva1,iactoa1,iactvb1,iactob1
      integer iactv2,iacto2,iactva2,iactoa2,iactvb2,iactob2
      integer iactv3,iacto3,iactva3,iactoa3,iactvb3,iactob3
      integer nstr(nnir,0:nactm,0:nmax,4),ita(nnir,nnir,nnir,nnir)
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer icmem(nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,4)
      real*8 v(*),sum,lfact
      character*4 func
      logical ladj
C
       if(file1.eq.0) then
        call savevec(ttfile,scrfile1,trecmax,0,0) ! T^n |0>
        call savevec(ttfile,outpfile,trecmax,0,0) ! exp(T) |0>
        ilo=2
       else
        call savevec(file1,scrfile1,trecmax,0,0) ! T^n |vec>
        call savevec(file1,outpfile,trecmax,0,0) ! exp(T) |vec>
        ilo=1
       endif
C
       if(ladj) then
        iup=op
        isg=-1
       else
        iup=op-1
        isg=1
       endif
C
       do i=ilo,npow
        call dfillzero(ibuf,ibufln)
         do j=1,trecmax
          write(scrfile3,rec=j) ibuf
         enddo
C Loop over excitations
       do nex1=ilo-1,iup
         do naval1=0,nex1
          navbe1=nex1-naval1
          naoal1=naval1
          naobe1=nex1-naoal1
             do iactv1=max(0,nex1-mrop),min(nactv,nex1)
               do iactva1=max(0,iactv1-nactvb),min(nactva,naval1,iactv1)
                iactvb1=iactv1-iactva1
                 do iacto1=max(0,nex1-mrop),min(nacto,nex1)
                   do iactoa1=max(0,iacto1-nactob),min(nactoa,naoal1,
     $iacto1)
                    iactob1=iacto1-iactoa1
      nn1=ncon1(iactva1,iactvb1,iactoa1,iactob1,naval1,nex1)
               if(nn1.gt.0.and.(.not.ss3route.or.iactva1.ne.naval1.or.
     $iactvb1.ne.navbe1.or.iactoa1.ne.naoal1.or.iactob1.ne.naobe1)) then
      call getlst(scrfile1,
     $tre1(iactva1,iactvb1,iactoa1,iactob1,naval1,nex1),v(1),nn1)
      iup1=op-nex1
       if(ladj) iup1=op
       do nex2=1,iup1
        nex3=nex1+isg*nex2
         do naval2=0,nex2
          navbe2=nex2-naval2
          naval3=naval1+isg*naval2
          navbe3=navbe1+isg*navbe2
          naoal2=naval2
          naobe2=nex2-naoal2
          naoal3=naoal1+isg*naoal2
          naobe3=naobe1+isg*naobe2
             do iactv2=max(0,nex2-mrop),min(nactv,nex2)
              iactv3=iactv1+isg*iactv2
               do iactva2=max(0,iactv2-nactvb),min(nactva,naval2,iactv2)
                iactvb2=iactv2-iactva2
                iactva3=iactva1+isg*iactva2
                iactvb3=iactvb1+isg*iactvb2
                 do iacto2=max(0,nex2-mrop),min(nacto,nex2)
                  iacto3=iacto1+isg*iacto2
                   do iactoa2=max(0,iacto2-nactob),min(nactoa,naoal2,
     $iacto2)
                    iactob2=iacto2-iactoa2
                    iactoa3=iactoa1+isg*iactoa2
                    iactob3=iactob1+isg*iactob2
       if(iactv3.le.nactv.and.iacto3.le.nacto.and.
     $iactva3.le.nactva.and.iactoa3.le.nactoa.and.nex3.ge.0.and.
     $naval3.ge.0.and.navbe3.ge.0.and.naoal3.ge.0.and.naobe3.ge.0.and.
     $iactv3.ge.0.and.iactva3.ge.0.and.iactvb3.ge.0.and.iacto3.ge.0.and.
     $iactoa3.ge.0.and.iactob3.ge.0.and.iactoa3.le.nactoa.and.
     $iactob3.le.nactob) then
      nn2=ncon2(iactva2,iactvb2,iactoa2,iactob2,naval2,nex2)
      nn3=ncon3(iactva3,iactvb3,iactoa3,iactob3,naval3,nex3)
               if(nn3.gt.0.and.nn2.gt.0.and.
     $(.not.ss3route.or.iactva2.ne.naval2.or.
     $iactvb2.ne.navbe2.or.iactoa2.ne.naoal2.or.iactob2.ne.naobe2)) then
      call getlst(ttfile,tre2(iactva2,iactvb2,iactoa2,iactob2,naval2,
     $nex2),v(nn1+1),nn2)
      call getlst(scrfile3,tre3(iactva3,iactvb3,iactoa3,iactob3,naval3,
     $nex3),v(nn1+nn2+1),nn3)
      read(tafile,rec=tarec(iactva3,iactvb3,iactoa3,iactob3,naval3,
     $nex3)) ita
C
      ii1=1
                 do ir1=1,nir
      isymv1=csympair(isym1,ir1,1)
      isymo1=csympair(isym1,ir1,2)
                   do irv1=1,isympv(0,isymv1,iactva1,iactvb1,naval1,
     $navbe1,1)
      isymva1=isympv(irv1,isymv1,iactva1,iactvb1,naval1,navbe1,1)
      isymvb1=isympv(irv1,isymv1,iactva1,iactvb1,naval1,navbe1,2)
      nvstral1=nstr(isymva1,iactva1,naval1,1)
      nvstrbe1=nstr(isymvb1,iactvb1,navbe1,2)
                     do iro1=1,isympo(0,isymo1,iactoa1,iactob1,naoal1,
     $naobe1,1)
      isymoa1=isympo(iro1,isymo1,iactoa1,iactob1,naoal1,naobe1,1)
      isymob1=isympo(iro1,isymo1,iactoa1,iactob1,naoal1,naobe1,2)
      nostral1=nstr(isymoa1,iactoa1,naoal1,3)
      nostrbe1=nstr(isymob1,iactob1,naobe1,4)
C
      ii2=nn1+1
                 do ir2=1,nir
      isymv2=isympair(isym2,ir2,1)
      isymo2=isympair(isym2,ir2,2)
                   do irv2=1,isympv(0,isymv2,iactva2,iactvb2,naval2,
     $navbe2,1)
      isymva2=isympv(irv2,isymv2,iactva2,iactvb2,naval2,navbe2,1)
      isymvb2=isympv(irv2,isymv2,iactva2,iactvb2,naval2,navbe2,2)
      nvstral2=nstr(isymva2,iactva2,naval2,1)
      nvstrbe2=nstr(isymvb2,iactvb2,navbe2,2)
      isymva3=mult(isymva1,isymva2)
      isymvb3=mult(isymvb1,isymvb2)
      nvstral3=nstr(isymva3,iactva3,naval3,1)
      nvstrbe3=nstr(isymvb3,iactvb3,navbe3,2)
                     do iro2=1,isympo(0,isymo2,iactoa2,iactob2,naoal2,
     $naobe2,1)
      isymoa2=isympo(iro2,isymo2,iactoa2,iactob2,naoal2,naobe2,1)
      isymob2=isympo(iro2,isymo2,iactoa2,iactob2,naoal2,naobe2,2)
      nostral2=nstr(isymoa2,iactoa2,naoal2,3)
      nostrbe2=nstr(isymob2,iactob2,naobe2,4)
      isymoa3=mult(isymoa1,isymoa2)
      isymob3=mult(isymob1,isymob2)
      nostral3=nstr(isymoa3,iactoa3,naoal3,3)
      nostrbe3=nstr(isymob3,iactob3,naobe3,4)
      ii3=nn1+nn2+ita(isymva3,isymvb3,isymoa3,isymob3)
C
       if(ladj) then
        call tvert(v(ii1),v(ii2),v(ii3),
     $icore(icmem(isymva2,isymva3,iactva2,iactva3,naval2,naval3,1)),
     $icore(icmem(isymvb2,isymvb3,iactvb2,iactvb3,navbe2,navbe3,2)),
     $icore(icmem(isymoa2,isymoa3,iactoa2,iactoa3,naoal2,naoal3,3)),
     $icore(icmem(isymob2,isymob3,iactob2,iactob3,naobe2,naobe3,4)),
     $nvstral3,nvstrbe3,nostral3,nostrbe3,
     $nvstral2,nvstrbe2,nostral2,nostrbe2,
     $nvstral1,nvstrbe1,nostral1,nostrbe1,ladj)
       else
        call tvert(v(ii1),v(ii2),v(ii3),
     $icore(icmem(isymva2,isymva1,iactva2,iactva1,naval2,naval1,1)),
     $icore(icmem(isymvb2,isymvb1,iactvb2,iactvb1,navbe2,navbe1,2)),
     $icore(icmem(isymoa2,isymoa1,iactoa2,iactoa1,naoal2,naoal1,3)),
     $icore(icmem(isymob2,isymob1,iactob2,iactob1,naobe2,naobe1,4)),
     $nvstral1,nvstrbe1,nostral1,nostrbe1,
     $nvstral2,nvstrbe2,nostral2,nostrbe2,
     $nvstral3,nvstrbe3,nostral3,nostrbe3,ladj)
       endif
C
      ii2=ii2+nvstral2*nvstrbe2*nostral2*nostrbe2
                     enddo
                   enddo
                 enddo
      ii1=ii1+nvstral1*nvstrbe1*nostral1*nostrbe1
                     enddo
                   enddo
                 enddo
      call putlst(scrfile3,tre3(iactva3,iactvb3,iactoa3,iactob3,naval3,
     $nex3),v(nn1+nn2+1),nn3)
               endif
       endif
                   enddo
                 enddo
               enddo
             enddo
         enddo
       enddo
               endif
                   enddo
                 enddo
               enddo
             enddo
         enddo
       enddo
         if(npow.gt.1) then
          call savevec(scrfile3,scrfile1,trecmax,0,0)
           if(func.eq.'exp ') then
            sum=dble(isig)**i/dexp(lfact(i))
           else if(func.eq.'ln  ') then
            sum=(-1.d0)**(i+1)*dble(isig)**i/dble(i)
           else
            call mrccend(1)
           endif
           do j=1,trecmax
            read(outpfile,rec=j) ibuf
            read(scrfile1,rec=j) ibuf1
              do k=1,ibufln
               ibuf(k)=ibuf(k)+sum*ibuf1(k)
              enddo
             write(outpfile,rec=j) ibuf
           enddo
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine tvert(wold,t,wnew,coupsval,coupsvbe,coupsoal,coupsobe,
     $nvaal,nvabe,noaal,noabe,nvoalo,nvobeo,nooalo,noobeo,nvsalo,nvsbeo,
     $nosalo,nosbeo,ladj)
************************************************************************
* This subroutine evaluates the action of a T vertex on a vector       *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isgnval,isgnvbe,isgnoal,isgnobe
      integer n1,n2,ivstral,ivstrbe,ifvsal,nn1,nn2,ivsalad,ifvsbe,ifosal
      integer iostral,iostrbe,ivstr,iostr,ivaal,ivabe,ioaal,ioabe,iivobe
      integer iosbe,iosal,ivsbe,ivsal,ivoal,ivobe,nooalo,noobeo,ifosbe
      integer nvsal,nvsbe,nosal,nosbe,nvoal,nvobe
      integer i,ii,nvsalo,nvsbeo,nosalo,nosbeo,nvoalo,nvobeo
      integer nvaal,nvabe,noaal,noabe,ivo,iosbead,iosalad,ivsbead
      integer coupsval(*),coupsoal(*),coupsvbe(*),coupsobe(*)
      real*8 wnew(*),wold(*),t(*),sum
      logical ladj
C
      nn2=nvsalo*nvsbeo
      nn1=nn2*nosalo
      n2=nvoalo*nvobeo
      n1=n2*nooalo
      ii=0
       if(ladj) then
         do ioabe=1,noabe
          ifosbe=coupsobe(ioabe)
          nosbe=coupsobe(noabe+ioabe)
           do ioaal=1,noaal
            ifosal=coupsoal(ioaal)
            nosal=coupsoal(noaal+ioaal)
             do ivabe=1,nvabe
              ifvsbe=coupsvbe(ivabe)
              nvsbe=coupsvbe(nvabe+ivabe)
               do ivaal=1,nvaal
                ifvsal=coupsval(ivaal)
                nvsal=coupsval(nvaal+ivaal)
                ii=ii+1
C
                i1=ifosbe
                 do iosbe=1,nosbe
                  i1=i1+1
                  iosbead=n1*(coupsobe(i1)-1)
                  i1=i1+1
                  iostrbe=coupsobe(i1)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=(iabs(iostrbe)-1)*nn1
                  i2=ifosal
                   do iosal=1,nosal
                    i2=i2+1
                    iosalad=iosbead+n2*(coupsoal(i2)-1)
                    i2=i2+1
                    iostral=coupsoal(i2)
                    isgnoal=isgnobe*isign(1,iostral)
                    iostr=iostrbe+(iabs(iostral)-1)*nn2
                    i3=ifvsbe
                     do ivsbe=1,nvsbe
                      i3=i3+1
                      ivsbead=iosalad+nvoalo*(coupsvbe(i3)-1)
                      i3=i3+1
                      ivstrbe=coupsvbe(i3)
                      isgnvbe=isgnoal*isign(1,ivstrbe)
                      ivstrbe=iostr+(iabs(ivstrbe)-1)*nvsalo
                      i4=ifvsal
                       do ivsal=1,nvsal
                        i4=i4+1
                        ivsalad=ivsbead+coupsval(i4)
                        i4=i4+1
                        ivstral=coupsval(i4)
                        isgnval=isgnvbe*isign(1,ivstral)
                        ivstral=ivstrbe+iabs(ivstral)
      wnew(ii)=wnew(ii)+isgnval*t(ivsalad)*wold(ivstral)
                       enddo
                     enddo
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       else
         do ioabe=1,noabe
          ifosbe=coupsobe(ioabe)
          nosbe=coupsobe(noabe+ioabe)
           do ioaal=1,noaal
            ifosal=coupsoal(ioaal)
            nosal=coupsoal(noaal+ioaal)
             do ivabe=1,nvabe
              ifvsbe=coupsvbe(ivabe)
              nvsbe=coupsvbe(nvabe+ivabe)
               do ivaal=1,nvaal
                ifvsal=coupsval(ivaal)
                nvsal=coupsval(nvaal+ivaal)
                ii=ii+1
                sum=wold(ii)
C
                i1=ifosbe
                 do iosbe=1,nosbe
                  i1=i1+1
                  iosbead=n1*(coupsobe(i1)-1)
                  i1=i1+1
                  iostrbe=coupsobe(i1)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=(iabs(iostrbe)-1)*nn1
                  i2=ifosal
                   do iosal=1,nosal
                    i2=i2+1
                    iosalad=iosbead+n2*(coupsoal(i2)-1)
                    i2=i2+1
                    iostral=coupsoal(i2)
                    isgnoal=isgnobe*isign(1,iostral)
                    iostr=iostrbe+(iabs(iostral)-1)*nn2
                    i3=ifvsbe
                     do ivsbe=1,nvsbe
                      i3=i3+1
                      ivsbead=iosalad+nvoalo*(coupsvbe(i3)-1)
                      i3=i3+1
                      ivstrbe=coupsvbe(i3)
                      isgnvbe=isgnoal*isign(1,ivstrbe)
                      ivstrbe=iostr+(iabs(ivstrbe)-1)*nvsalo
                      i4=ifvsal
                       do ivsal=1,nvsal
                        i4=i4+1
                        ivsalad=ivsbead+coupsval(i4)
                        i4=i4+1
                        ivstral=coupsval(i4)
                        isgnval=isgnvbe*isign(1,ivstral)
                        ivstral=ivstrbe+iabs(ivstral)
      wnew(ivstral)=wnew(ivstral)+isgnval*t(ivsalad)*sum
                       enddo
                     enddo
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine unpackt(t1aa,t1bb,t1ab,t1ba,v,nva,nvb,na,nb,nconf,trec,
     $nmax,istr,nnir,nstr,file,nactm,iisym,ire1)
************************************************************************
* This subroutine unpacks symmetry-packed T1 vectors                   *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nva,nvb,na,nb,nmax,a,b,i,j,isum,aa,bb,l,iisym,ire1
      integer file,nactm,istr(nnir,0:nactm,0:nmax,4),k,isymv,isymo
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nstr(nnir,0:nactm,0:nmax,4),ii,jj,n1,n2,n3,n4,nn
      integer iactva,iactvb,iactoa,iactob
      real*8 t1aa(nva,na),t1bb(nvb,nb),t1ab(nva,nb),t1ba(nvb,na),v(*)
C
      call dfillzero(t1aa,nva*na)
      call dfillzero(t1bb,nvb*nb)
      call dfillzero(t1ab,nva*nb)
      call dfillzero(t1ba,nvb*na)
       if(calc.eq.1.and.conver.ne.1) then
C aa
         do iactva=0,min(nactmax,1)
           do iactoa=0,min(nactmax,1)
            nn=nconf(iactva,0,iactoa,0,1,1)
             if(nn.gt.0) then
              call getlst(file,ire1+trec(iactva,0,iactoa,0,1,1),v,nn)
              ii=0
               do ir=1,nir
                isymv=csympair(iisym,ir,1)
                isymo=csympair(iisym,ir,2)
                n1=nstr(isymv,iactva,1,1)
                n2=nstr(isymo,iactoa,1,3)
                i1=istr(isymv,iactva,1,1)-1
                i2=istr(isymo,iactoa,1,3)-1
                 do j=1,n2
                   do i=1,n1
                    ii=ii+1
                    t1aa(icore(i1+i),icore(i2+j))=v(ii)
                   enddo
                 enddo
               enddo
             endif
           enddo
         enddo
C bb
         do iactvb=0,min(nactmax,1)
           do iactob=0,min(nactmax,1)
            nn=nconf(0,iactvb,0,iactob,0,1)
             if(nn.gt.0) then
              call getlst(file,ire1+trec(0,iactvb,0,iactob,0,1),v,nn)
              ii=0
               do ir=1,nir
                isymv=csympair(iisym,ir,1)
                isymo=csympair(iisym,ir,2)
                n1=nstr(isymv,iactvb,1,2)
                n2=nstr(isymo,iactob,1,4)
                i1=istr(isymv,iactvb,1,2)-1
                i2=istr(isymo,iactob,1,4)-1
                 do j=1,n2
                   do i=1,n1
                    ii=ii+1
                    t1bb(icore(i1+i),icore(i2+j))=v(ii)
                   enddo
                 enddo
               enddo
             endif
           enddo
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine nconfig(nvstral,nvstrbe,nostral,nostrbe,nconf,tsp,nmax,
     $nnir,isympv,isympo,ita,tarec,nactm,ii,iisym,trec,trec2,tcase,
     $ntcase,log)
************************************************************************
* This subroutine calculates the number of excitations                 *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,ii,nact,nactm,iisym,nma
      integer nvstral(nnir,0:nactm,0:nmax),nvstrbe(nnir,0:nactm,0:nmax)
      integer nostral(nnir,0:nactm,0:nmax),nostrbe(nnir,0:nactm,0:nmax)
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nampvirtal,nampvirtbe,nampoccal,nampoccbe
      integer tsp(0:2*(nmax+1)**2,0:nmax),nex,i,j,k,m,isum,iactoa
      integer isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,iactob
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer ita(nnir,nnir,nnir,nnir),iactv,iacto,iactva,iactvb
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer tcase(0:2*nactm,0:2*nactm,0:nmax),ntcase(0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec2((2*nactm+1)**2,0:nmax)
      logical log
C
      nma=op
       if(pert.ne.0) nma=op-1
      ntot=0
      call ifillzero(nconf,(nactm+1)**4*(oo+1)**2)
       do i=0,nma
        isum=0
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             if(tcase(iactv,iacto,i).gt.0) then
               do iactva=max(0,iactv-nactvb),min(nactva,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,iacto)
                  iactob=iacto-iactoa
         do j=1,tsp(0,i)
          nampvirtal=tsp(2*j-1,i)
          nampvirtbe=i-nampvirtal
          nampoccal=tsp(2*j,i)
          nampoccbe=i-nampoccal
           if(log) then
            ii=ii+1
            tarec(iactva,iactvb,iactoa,iactob,nampvirtal,i)=ii
           endif
          m=0
           do ir=1,nir
            isymv=csympair(iisym,ir,1)
            isymo=csympair(iisym,ir,2)
             do irv=1,isympv(0,isymv,iactva,iactvb,nampvirtal,nampvirtbe
     $,1)
      isymva=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,1)
      isymvb=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,2)
              k=nvstral(isymva,iactva,nampvirtal)*
     $          nvstrbe(isymvb,iactvb,nampvirtbe)
               do iro=1,isympo(0,isymo,iactoa,iactob,nampoccal,nampoccbe
     $,1)
      isymoa=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,1)
      isymob=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,2)
       if(log) ita(isymva,isymvb,isymoa,isymob)=m+1
      m=m+k*nostral(isymoa,iactoa,nampoccal)*
     $      nostrbe(isymob,iactob,nampoccbe)
               enddo
             enddo
           enddo
           if(log) write(tafile,rec=ii) ita
          nconf(iactva,iactvb,iactoa,iactob,nampvirtal,i)=m
          isum=isum+m
         enddo
               enddo
             enddo
               endif
           enddo
         enddo
         if(log) call nconfout1(i,isum)
        ntot=ntot+isum
       enddo
       if(log) call nconfout2(' Total number of determinants:',ntot)
C Records in amplitude file
      call ifillzero(trec,(oo+1)**2*(nactm+1)**4)
      j=1
       do nex=0,nma     
         do iactv=max(0,nex-mrop),min(nactv,nex)
           do iacto=max(0,nex-mrop),min(nacto,nex)
             do i1=0,nex
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  isum=nconf(iactva,iactvb,iactoa,iactob,i1,nex)
                   if(isum.gt.0) then
                    trec(iactva,iactvb,iactoa,iactob,i1,nex)=j
                    k=mod(isum,ibufln)
                     if(k.ne.0) k=ibufln-k
                    j=j+(isum+k)/ibufln
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
      trecmax=max(trecmax,j-1) !???
       if(.not.log) return
       do i=0,nma
         do k=1,ntcase(i)
          trec2(k,i)=trecmax
         enddo
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             do i1=0,i
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  j=trec(iactva,iactvb,iactoa,iactob,i1,i)
                  isum=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                   if(isum.gt.0) trec2(tcase(iactv,iacto,i),i)=
     $min(trec2(tcase(iactv,iacto,i),i),j-1)
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine ilength(nmax,nstr,imed,nnir,isympv,isympo,nactm,wspc,m,
     $ssym)
************************************************************************
* This subroutine calculates the length of intermediates               *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nactm,m,nmax,n1,n2,wspc(*),imed(*),isymi,isyma
      integer nstr(nnir,0:nactm,0:nmax,4),ssym,nactoccal,nactvirtbe
      integer nvintoldal,nvintoldbe,nointoldal,nointoldbe,nactoccbe
      integer nactvintal,nactointal,nactvintbe,nactointbe,nactvirtal
      integer nvirtoldal,noccoldal,nvirtoldbe,noccoldbe,isympv,isympo
C
      nvintoldal=wspc(1)
      nointoldal=wspc(2)
      nvirtoldal=wspc(3)
      noccoldal=wspc(4)
      nvintoldbe=imed(1)-nvintoldal
      nointoldbe=imed(2)-nointoldal
      nvirtoldbe=imed(3)-nvirtoldal
      noccoldbe=imed(4)-noccoldal
      nactvintal=wspc(5)
      nactointal=wspc(6)
      nactvintbe=wspc(7)
      nactointbe=wspc(8)
      nactvirtal=wspc(9)
      nactoccal=wspc(10)
      nactvirtbe=imed(11)-nactvirtal
      nactoccbe=imed(12)-nactoccal
      m=0
       do ir=1,nir
        isymi=isympair(ssym,ir,1)
        isyma=isympair(ssym,ir,2)
        call slength(nmax,nstr,nnir,isympv,isympo,nactm,n1,isymi,
     $nactvintal,nactvintbe,nvintoldal,nvintoldbe,nactointal,nactointbe,
     $nointoldal,nointoldbe,dsympair)
        call slength(nmax,nstr,nnir,isympv,isympo,nactm,n2,isyma,
     $nactvirtal,nactvirtbe,nvirtoldal,nvirtoldbe,nactoccal,nactoccbe,
     $noccoldal,noccoldbe,csympair)
        m=m+n1*n2
       enddo
C
      return
      end
C
************************************************************************
      subroutine slength(nmax,nstr,nnir,isympv,isympo,nactm,isum,ssym,
     $nn1,nn2,nn3,nn4,nn5,nn6,nn7,nn8,isp)
************************************************************************
* This subroutine calculates the length of indices running over strings*
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nactm,isum,nmax,nn,nn1,nn2,nn3,nn4,nn5,nn6,nn7,nn8
      integer nstr(nnir,0:nactm,0:nmax,4),irao,isymaoa,isymaob,ssym
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer ira,isymav,isymao,irav,isymava,isymavb
      integer isp(nirmax,nirmax,2)
C
      isum=0
       do ira=1,nir
        isymav=isp(ssym,ira,1)
        isymao=isp(ssym,ira,2)
         do irav=1,isympv(0,isymav,nn1,nn2,nn3,nn4,1)
          isymava=isympv(irav,isymav,nn1,nn2,nn3,nn4,1)
          isymavb=isympv(irav,isymav,nn1,nn2,nn3,nn4,2)
          nn=nstr(isymava,nn1,nn3,1)*nstr(isymavb,nn2,nn4,2)
           do irao=1,isympo(0,isymao,nn5,nn6,nn7,nn8,1)
            isymaoa=isympo(irao,isymao,nn5,nn6,nn7,nn8,1)
            isymaob=isympo(irao,isymao,nn5,nn6,nn7,nn8,2)
            isum=isum+nstr(isymaoa,nn5,nn7,3)*nstr(isymaob,nn6,nn8,4)*nn
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine conin1(trec,nstr,nmax,icmem,nvintnew1,nointnew1,
     $nvirtnew1,noccnew1,nvintold1,nointold1,nvirtold1,noccold1,namp1,
     $isig11,file1,irec1,file2,irec2,iadd,iaddo,ladd,v,isave,intrec,
     $isympv,isympo,nnir,nconf,ita,tarec,iwa,isa,isw,iwan,file3,wspc1,
     $wspc2,wspca,wsmax,nvintnewact,nointnewact,nvirtnewact,noccnewact,
     $nvintoldact,nointoldact,nvirtoldact,noccoldact,nactm,earec,
     $erec,econf,ilev,imed,wspci,intrec1,itypa,itypb,inewsym,ioldsym,
     $ioffs,scspe)
************************************************************************
* This subroutine initializes variables for contractions               *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,nactm,file3,wsmax,iadd(0:1),isa(*),isw(*),i,nsym
      integer nstr(nnir,0:nactm,0:nmax,4),wspc3(0:wsmax),ilev,ii,j,file4
      integer wspc1(0:1),wspc2(0:1),wspca(0:1),iaddo(0:1),iaddn(0:wsmax)
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,*)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,*)
      integer nvintnew1,nointnew1,nvirtnew1,noccnew1,nvintold1,nointold1
      integer nvirtold1,noccold1,namp1,isig11,isig12,iadds(0:wsmax)
      integer file1,file2,irec1,irec2,ircold,ircnew,isave,intrec,icmem
      integer isympv,isympo,itypa,itypb,inewsym,ioldsym,nointnewbeact
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax,*)
      integer ita(nnir,nnir,nnir,nnir),iwan(nnir,nnir,nnir,nnir,nnir)
      integer earec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),file5
      integer nointnewalact,iwa(nnir,nnir,nnir,nnir,nnir,nnir),ioffs
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nvintnewact,nointnewact,nvirtnewact,noccnewact,imed(16,1)
      integer nvintoldact,nointoldact,nvirtoldact,noccoldact,intrec1(*)
      integer nvintoldalact,nointoldalact,nvintoldbeact,nointoldbeact
      integer nvirtoldalact,noccoldalact,nvirtoldbeact,noccoldbeact
      integer wspci(0:wsmax,13),ire11,irec3,file6,irec4
      real*8 v(*),scspe
      logical ladd,log
C
      ire11=irec1
      irec4=0
       if(leftroute.and.iroot.gt.1.and.itypa.eq.0.and.namp1.gt.0.and.
     $ilev.eq.1.and.(((.not.zroute).and.(.not.d1route).and.(.not.osc))
     $.or.(osc.and.(.not.l3route).and.(.not.d2route)))) return
C
       if(leftroute.and.ilev.eq.1.and.nvintnew1+nointnew1.gt.0.and.
     $(.not.densroute)) then
        log=.true.
        file5=scrfile4
         do i=0,wsmax
          iadds(i)=iadd(i)
         enddo
        call ifillzero(iadd,wsmax+1)
        ire11=0
       else
        log=.false.
        file5=file1
       endif
       if(leftroute.and.namp1.lt.0.and.namp1.ge.-iimed-op) then
         if(namp1.ge.-op) then
C Contract an L vertex with conventional intermediates at the end
           if(ilev.eq.1) then
            call rospc(iaddo,iaddn,nvirtoldact,noccoldact,wsmax)
            call rospc(wspc2,wspc3,nvirtoldact,noccoldact,wsmax)
            call conini(trec,nstr,nmax,icmem,nvintnew1,nointnew1,
     $nvirtnew1,noccnew1,nvirtold1,noccold1,nvintold1,nointold1,namp1,
     $isig11,file5,ire11,file2,irec2,iadd,iaddn,ladd,v,isave,intrec,
     $isympv,isympo,nnir,nconf,ita,tarec,iwa,isa,isw,iwan,file3,wspc1,
     $wspc3,wspca,wsmax,nvintnewact,nointnewact,nvirtnewact,noccnewact,
     $nvirtoldact,noccoldact,nvintoldact,nointoldact,nactm,earec,
     $erec,econf,itypa,itypb,inewsym,ioldsym,ilev,ioffs,scspe)
           else
C Contract an L vertex with conventional intermediates not at the end
            call conlam(trec,nstr,nmax,icmem,nvintnew1,nointnew1,
     $nvirtnew1,noccnew1,nvintold1,nointold1,nvirtold1,noccold1,namp1,
     $isig11,file5,ire11,file2,irec2,iadd,iaddo,ladd,v,isave,intrec,
     $isympv,isympo,nnir,nconf,ita,tarec,iwa,isa,isw,iwan,file3,wspc1,
     $wspc2,wspca,wsmax,nvintnewact,nointnewact,nvirtnewact,noccnewact,
     $nvintoldact,nointoldact,nvirtoldact,noccoldact,nactm,earec,
     $erec,econf,inewsym,ioldsym,scspe)
           endif
         else
C Contract an integral list with a L-T intermediate
          i=iabs(namp1+op)
           if(l2route) i=i+ptsh
          call conint(nstr,nmax,icmem,nvintnew1,nointnew1,nvirtnew1,
     $noccnew1,nvintold1,nointold1,nvirtold1,noccold1,isig11,
     $file5,ire11,file2,intrec1(i),iadd,iaddo,ladd,v,isave,intrec,
     $isympv,isympo,nnir,ita,iwa,isa,isw,iwan,wspc1,wspc2,wspca,wsmax,
     $nvintnewact,nointnewact,nvirtnewact,noccnewact,nvintoldact,
     $nointoldact,nvirtoldact,noccoldact,nactm,imed(1,i),imed(2,i),
     $imed(3,i),imed(4,i),imed(9,i),imed(10,i),imed(11,i),imed(12,i),
     $wspci(0,i),.false.,nconf,trec,tarec,iwan,log.or.ilev.ne.1,
     $inewsym,ioldsym,ampfile,0,ilev.ne.1,ioffs,irec4,ilev,scspe)
         endif
       else
         if(leftroute.and.namp1.gt.0.and.ilev.eq.1.and.itypa.eq.0)
     $ire11=1
         if(nvintnew1.gt.nvintold1.or.nointnew1.gt.nointold1.or.
     $densroute) then
C Contract a T vertex with a L-T intermediate
          file4=file2
           if(ilev.eq.4) then
            file4=lamfile
             if(ds1route) irec4=(2*nopt(1)-1)*trecmax+1
             if(dt1route) irec4=(2*nopt(3)-1)*trecmax+1
             if(dtroute.or.dsroute) then
      call tspcase(0,0,nvirtold1,noccold1,0,0,nvirtoldact,noccoldact,
     $wspc2,wsmax,nconf(0,0,0,0,0,nvirtold1,nirmap(ioldsym)),
     $trec(0,0,0,0,0,nvirtold1,nirmap(ioldsym)),nmax,nactm)
             elseif((iroot.eq.1.or.(eomgrad.and.(d1route.or.zroute).and.
     $(.not.osc)).or.(osc.and.(l3route.or.d2route))).and.(.not.l1route)
     $.and.((.not.d1route).or.eomgrad)) then
      call tspcase(0,0,nvirtold1,noccold1,0,0,nvirtoldact,noccoldact,
     $wspc2,wsmax,nconf(0,0,0,0,0,nvirtold1,1),
     $trec(0,0,0,0,0,nvirtold1,1),nmax,nactm)
             else
      call tspcase(0,0,nvirtold1,noccold1,0,0,nvirtoldact,noccoldact,
     $wspc2,wsmax,econf(0,0,0,0,0,nvirtold1),
     $erec(0,0,0,0,0,nvirtold1),nmax,nactm)
             endif
           endif
           if((l3route.or.d2route.or.dsroute.or.dtroute).and.
     $(namp1.lt.-iimed-op.or.(ds1route.and.calc.eq.0))) then
             if(eomgrad) then
              irec3=(iroot-1)*trecmax
              namp=iabs(namp1)-iimed-op
              file6=cfile
             else if(dsroute.or.dtroute) then
               do i=1,npert
       if(namp1.lt.-iimed-i*op.and.namp1.ge.-iimed-(i+1)*op) then
        irec3=2*(nopt(i)-1)*trecmax+1
        namp=iabs(namp1)-iimed-i*op
       endif
               enddo
               if(ds1route.and.calc.eq.0) then
                namp=namp1
                 if(ptfreq.eq.0.d0.and..not.optrec) then
                  irec3=  (nopt(2)-1)*trecmax+1
                 else
                  irec3=(2*nopt(2)-1)*trecmax+1
                 endif
               endif
              file6=prfile
             else
              irec3=0
              namp=iabs(namp1)-iimed-op
              file6=ptfile
             endif
            nsym=nirmap(mult(inewsym,iconj(ioldsym)))
C
            call conint(nstr,nmax,icmem,nvintnew1,nointnew1,nvirtnew1,
     $noccnew1,nvintold1,nointold1,nvirtold1,noccold1,isig11,
     $file5,ire11,file4,intrec1,iadd,iaddo,ladd,v,isave,intrec,
     $isympv,isympo,nnir,ita,iwa,isa,isw,iwan,wspc1,wspc2,wspca,wsmax,
     $nvintnewact,nointnewact,nvirtnewact,noccnewact,nvintoldact,
     $nointoldact,nvirtoldact,noccoldact,nactm,nvintold1,nointold1,
     $nvirtold1,noccold1,nvintoldact,nointoldact,nvirtoldact,noccoldact,
     $wspc3,.true.,nconf(0,0,0,0,0,namp,nsym),trec(0,0,0,0,0,namp,nsym),
     $tarec(0,0,0,0,0,namp,nsym),iwan,.true.,inewsym,ioldsym,file6,
     $irec3,ilev.ne.1,ioffs,irec4,ilev,scspe)
           else
            call conint(nstr,nmax,icmem,nvintnew1,nointnew1,nvirtnew1,
     $noccnew1,nvintold1,nointold1,nvirtold1,noccold1,isig11,
     $file5,ire11,file4,intrec1,iadd,iaddo,ladd,v,isave,intrec,
     $isympv,isympo,nnir,ita,iwa,isa,isw,iwan,wspc1,wspc2,wspca,wsmax,
     $nvintnewact,nointnewact,nvirtnewact,noccnewact,nvintoldact,
     $nointoldact,nvirtoldact,noccoldact,nactm,nvintold1,nointold1,
     $nvirtold1,noccold1,nvintoldact,nointoldact,nvirtoldact,noccoldact,
     $wspc3,.true.,nconf(0,0,0,0,0,namp1,1),trec(0,0,0,0,0,namp1,1),
     $tarec(0,0,0,0,0,namp1,1),iwan,.true.,inewsym,ioldsym,ampfile,0,
     $ilev.ne.1,ioffs,irec4,ilev,scspe)
           endif
         else
C Contract a T vertex with a conventional or a L-T-I intermediate
          call conini(trec,nstr,nmax,icmem,nvintnew1,nointnew1,
     $nvirtnew1,noccnew1,nvintold1,nointold1,nvirtold1,noccold1,namp1,
     $isig11,file5,ire11,file2,irec2,iadd,iaddo,ladd,v,isave,intrec,
     $isympv,isympo,nnir,nconf,ita,tarec,iwa,isa,isw,iwan,file3,wspc1,
     $wspc2,wspca,wsmax,nvintnewact,nointnewact,nvirtnewact,noccnewact,
     $nvintoldact,nointoldact,nvirtoldact,noccoldact,nactm,earec,
     $erec,econf,itypa,itypb,inewsym,ioldsym,ilev,ioffs,scspe)
         endif
       endif
       if(log) then
        call anti1(nconf,econf,trec,erec,nstr,nmax,
     $v,nnir,isympv,isympo,ita,tarec,earec,nactm,icmem,wspc1,
     $nvintnew1,nointnew1,nvirtnew1,noccnew1,nvirtnewact,noccnewact,
     $iadds,iadd)
         do i=0,wsmax
          iadd(i)=iadds(i)
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine rospc(iadd,iaddn,nactv,nacto,wsmax)
************************************************************************
* Reorder iadd arrays                                                  *
************************************************************************
      implicit none
      integer wsmax,iadd(0:12),iaddn(0:12),nactv,nacto,i,j
C
      call ifillzero(iaddn,wsmax+1)
      iaddn(0)=iadd(0)
       do j=0,iadd(0)-1
        i=12*j
        iaddn(i+1)=iadd(i+3)
        iaddn(i+2)=iadd(i+4)
        iaddn(i+3)=iadd(i+1)
        iaddn(i+4)=iadd(i+2)
        iaddn(i+5)=iadd(i+9)
        iaddn(i+6)=iadd(i+10)
        iaddn(i+7)=nactv-iadd(i+9)
        iaddn(i+8)=nacto-iadd(i+10)
        iaddn(i+9)=iadd(i+5)
        iaddn(i+10)=iadd(i+6)
        iaddn(i+11)=iadd(i+11)
        iaddn(i+12)=iadd(i+12)
       enddo
C
      return
      end
C
************************************************************************
      subroutine dcp(a,b,n)
************************************************************************
* Copies a to b                                                        *
************************************************************************
      implicit none
      integer n,i,ilo,iup
      real*8 a(*),b(*)
C
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
        do i=1,n
         b(i)=a(i)
        enddo
C$OMP END PARALLEL DO
C
      return
      end
C
************************************************************************
      subroutine wszero(wsmax,wspca,ifi,ila)
************************************************************************
* Zeros redundant spin cases                                           *
************************************************************************
#include "MRCCCOMMON"
      integer n,i,j,k,ii,wsmax,wspca(0:wsmax,13),iw,ifi,ila
C
       do i=ifi+1,ila
        ii=0
         do iw=1,wspca(0,i)
           if(wspca((iw-ii-1)*12+11,i)*wspca((iw-ii-1)*12+12,i).eq.0)
     $then
             do k=iw-ii,wspca(0,i)-ii
               do j=1,12
                wspca((k-1)*12+j,i)=wspca(k*12+j,i)
               enddo
             enddo
            ii=ii+1
           endif
         enddo
        wspca(0,i)=wspca(0,i)-ii
        call ifillzero(wspca(wspca(0,i)*12+1,i),ii*12)
       enddo
C
      return
      end
C
************************************************************************
      subroutine wswrite(is1,is2,is3,wsa,wsb,wsm,ire)
************************************************************************
* Writes in wsfile                                                     *
************************************************************************
#include "MRCCCOMMON"
      integer is1,is2,is3,wsm,wsa(wsm),wsb(wsm),ire,i,iscr(2*wsm+3)
C
      iscr(1)=is1
      iscr(2)=is2
      iscr(3)=is3
       do i=1,wsm
        iscr(3+i)=wsa(i)
       enddo
       do i=1,wsm
        iscr(3+wsm+i)=wsb(i)
       enddo
      write(wsfile,rec=ire) iscr
C
      return
      end
C
************************************************************************
      subroutine wsch(is1,is2,is3,wsa,wsb,wsm,ire)
************************************************************************
* Cahnges the content of wsfile                                        *
************************************************************************
#include "MRCCCOMMON"
      integer is1,is2,is3,wsm,wsa(wsm),wsb(wsm),ire,i,j,iscr(2*wsm+3)
C
      read(wsfile,rec=ire) iscr
      j=is1
      is1=iscr(1)
      iscr(1)=j
      j=is2
      is2=iscr(2)
      iscr(2)=j
      j=is3
      is3=iscr(3)
      iscr(3)=j
       do i=1,wsm
        j=wsa(i)
        wsa(i)=iscr(3+i)
        iscr(3+i)=j
       enddo
       do i=1,wsm
        j=wsb(i)
        wsb(i)=iscr(3+wsm+i)
        iscr(3+wsm+i)=j
       enddo
      write(wsfile,rec=ire) iscr
C
      return
      end
C
************************************************************************
      subroutine icp(a,b,n)
************************************************************************
* Copies a to b                                                        *
************************************************************************
      implicit none
      integer n,i
      integer a(*),b(*)
C
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
       do i=1,n
        b(i)=a(i)
       enddo
C$OMP END PARALLEL DO
C
      return
      end
C
************************************************************************
      subroutine nlength(nmax,nstr,nnir,isympv,isympo,nactm,nn1,nn2,nn3,
     $nn4,nn5,nn6,nn7,nn8,incnew,inewadd,nnewsym,iwan)
************************************************************************
* This subroutine calculates the length of indices running over strings*
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nactm,isum,nmax,nn,nn1,nn2,nn3,nn4,nn5,nn6,nn7,nn8
      integer nstr(nnir,0:nactm,0:nmax,4),irao,isymaoa,isymaob,j1,j2
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer ira,isymav,isymao,irav,isymava,isymavb,incnew(8),inewadd
      integer iwan(nnir,nnir,nnir,nnir,nnir),nnewsym,isymi,isyma
C
      inewadd=1
       do ir=1,nir
        isymi=isympair(nnewsym,ir,1)
        isyma=isympair(nnewsym,ir,2)
        j1=incnew(isymi)
         do ira=1,nir
          isymav=csympair(isyma,ira,1)
          isymao=csympair(isyma,ira,2)
           do irav=1,isympv(0,isymav,nn1,nn2,nn3,nn4,1)
            isymava=isympv(irav,isymav,nn1,nn2,nn3,nn4,1)
            isymavb=isympv(irav,isymav,nn1,nn2,nn3,nn4,2)
            nn=nstr(isymava,nn1,nn3,1)*nstr(isymavb,nn2,nn4,2)
             do irao=1,isympo(0,isymao,nn5,nn6,nn7,nn8,1)
              isymaoa=isympo(irao,isymao,nn5,nn6,nn7,nn8,1)
              isymaob=isympo(irao,isymao,nn5,nn6,nn7,nn8,2)
              j2=nstr(isymaoa,nn5,nn7,3)*nstr(isymaob,nn6,nn8,4)*nn
              iwan(isymi,isymava,isymavb,isymaoa,isymaob)=inewadd
              inewadd=inewadd+j1*j2
             enddo
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine transposition(nmax,nnir,nactm,nstr,icmem,isympv,isympo,
     $iwa,iwan,v,isig12,ntoldlen,ntoldleno,namp1,file2,irec2,ircold,ita,
     $ntnewlen,incnew,noldsym,nnewsym,nvintoldal,nvintoldbe,nointoldal,
     $nointoldbe,nvintoldalact,nvintoldbeact,nointoldalact,nointoldbeact
     $,nvintnewalact,nvintnewbeact,nointnewalact,nointnewbeact,
     $nsumvirtalact,nsumvirtbeact,nsumoccalact,nsumoccbeact,
     $nvirtoldalact,nvirtoldbeact,noccoldalact,noccoldbeact,
     $nvirtnewalact,nvirtnewbeact,noccnewalact,noccnewbeact,incsum,lll,
     $iwa2,incold,nsumvirtal,nsumvirtbe,nsumoccal,nsumoccbe,nvintnewal,
     $nvintnewbe,nointnewal,nointnewbe,nvirtnewal,nvirtnewbe,noccnewal,
     $noccnewbe,nintnew,nintold,nvintold,nointold,nvirtoldal,nvirtoldbe,
     $noccoldal,noccoldbe,lsm,liw,ipt,imm,iadd,lcalc,ioffs,ll4,xyz)
************************************************************************
* This subroutine performs transpositions                              *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,nactm,isum,i,j,k,m,itin(8),itrp,j1,j2,j3,j4,iii
      integer nvintoldal,nvintoldbe,nointoldal,nointoldbe,iscrn(nmax+2)
      integer nstr(nnir,0:nactm,0:nmax,4),albeo(0:4),alben(0:4),nsumnew
      integer icmem(nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,4),in(4),kk
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),namp1
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),file2
      integer ita(nnir,nnir,nnir,nnir),iscro(nmax+2),is1,is2,is3,is4,jj
      integer iwa(nnir,nnir,nnir,nnir,nnir,nnir),ntoldlen,ntoldleno,incn
      integer iwan(nnir,nnir,nnir,nnir,nnir),irec2,ircold,ntnewlen,nmem
      integer isymi,incnew(nnir),incsum(nnir),incold(nnir),ioldadd,ifn
      integer inewadd,ir1,noldsym,isyma,inco,iri,iriv,irio,ira,irav,irao
      integer nintoldsym,nintoldsymv,nintoldsymo,nintoldsymva,isumsym(4)
      integer nintoldsymvb,nintoldsymoa,nintoldsymob,nvirtnewsym,isig12
      integer noccnewsym,nvirtnewsyma,nvirtnewsymb,nvirtnewbelen,itinlen
      integer noccnewsyma,noccnewsymb,noccnewbelen,nsumsym,irs,irsv,irso
      integer nvintoldallen,nvintoldbelen,nointoldallen,nointoldbelen
      integer nsumsymv,nsumsymva,nsumsymvb,nsumvirtallen,nsumvirtbelen
      integer nsumsymo,nsumsymoa,nsumsymob,nsumoccallen,nsumoccbelen,ifo
      integer nintnewsymv,nintnewsymo,nintnewsymva,nintnewsymvb,nnewsym
      integer nintnewsymoa,nintnewsymob,nvintnewallen,nvintnewbelen,ir2
      integer nointnewallen,nointnewbelen,isumact(4),ism1,ism2,ism3,ism4
      integer nvintoldalact,nvintoldbeact,nointoldalact,nointoldbeact
      integer nvintnewalact,nvintnewbeact,nointnewalact,nointnewbeact
      integer nsumvirtalact,nsumvirtbeact,nsumoccalact,nsumoccbeact,ipt
      integer nvirtoldalact,nvirtoldbeact,noccoldalact,noccoldbeact,incs
      integer nvirtnewalact,nvirtnewbeact,noccnewalact,noccnewbeact,iadd
      integer n1,n2,n3,n4,isa1,isa2,isa3,isa4,iwa2(nnir,nnir,nnir),ioffs
      integer nsumvirtal,nsumvirtbe,nsumoccal,nsumoccbe,nvirtoldlen,xyz
      integer noccoldlen,isumind(8),noccoldal,noccoldbe,incint(nnir)
      integer nvintnewal,nvintnewbe,nointnewal,nointnewbe,nvirtnewallen
      integer nvirtnewal,nvirtnewbe,noccnewal,noccnewbe,in2(4),imm(0:1)
      integer nintnew,nintold,nvintold,nointold,nvirtoldal,nvirtoldbe
      integer itrpadd(nnir,nnir),icdc,lcalc,maxcor1
      real*8 v(*)
      logical lll,log1(4),lsm,liw,incore,ll4
c     write(6,*) 'transposition'
      maxcor1=imem+maxcor-ioffs
      nsum=nsumvirtal+nsumvirtbe+nsumoccal+nsumoccbe
C Shall we do transposition?
      call ifillzero(in,4)
      call ifillzero(albeo,5)
      call ifillzero(alben,5)
       if(nintnew.gt.0) then
        isum=0
         do j=1,nointoldbe
          isum=isum+1
          itin(isum)=0
         enddo
         if(nointoldbe.gt.1) itin(isum)=isum-1
         do j=1,nointoldal
          isum=isum+1
          itin(isum)=-1
         enddo
         if(nointoldal.gt.1) itin(isum)=isum-1
         do j=1,nvintoldbe
          isum=isum+1
          itin(isum)=-2
         enddo
         if(nvintoldbe.gt.1) itin(isum)=isum-1
         do j=1,nvintoldal
          isum=isum+1
          itin(isum)=-3
         enddo
         if(nvintoldal.gt.1) itin(isum)=isum-1
C
        isum=0
         do j=1,nsumoccbe
          isum=isum+1
          isumind(isum)=0
         enddo
         if(nsumoccbe.gt.1) isumind(isum)=isum-1
         do j=1,nsumoccal
          isum=isum+1
          isumind(isum)=-1
         enddo
         if(nsumoccal.gt.1) isumind(isum)=isum-1
         do j=1,nsumvirtbe
          isum=isum+1
          isumind(isum)=-2
         enddo
         if(nsumvirtbe.gt.1) isumind(isum)=isum-1
         do j=1,nsumvirtal
          isum=isum+1
          isumind(isum)=-3
         enddo
         if(nsumvirtal.gt.1) isumind(isum)=isum-1
C
         do j=1,nointnewbe
          isum=isum+1
          isumind(isum)=0
         enddo
         if(nointnewbe.gt.1) isumind(isum)=isum-1
         do j=1,nointnewal
          isum=isum+1
          isumind(isum)=-1
         enddo
         if(nointnewal.gt.1) isumind(isum)=isum-1
         do j=1,nvintnewbe
          isum=isum+1
          isumind(isum)=-2
         enddo
         if(nvintnewbe.gt.1) isumind(isum)=isum-1
         do j=1,nvintnewal
          isum=isum+1
          isumind(isum)=-3
         enddo
         if(nvintnewal.gt.1) isumind(isum)=isum-1
        itrp=0
         do i=1,nintold
           if(itin(i).ne.isumind(i)) itrp=nintold
         enddo
       else
        itrp=0
       endif
       if(nintold.gt.1.and.nintnew.gt.0.and.nir.gt.1) itrp=nintold
C Sign of the spin case (not each sp. case of the integrals are stored)
      isig12=1
       if(nintnew.gt.0.and.(nointold.eq.2.or.nvintold.eq.2)) then
         do i=1,nintold-nsum
          alben(i)=isumind(nsum+i)
         enddo
         do i=1,nsum
          alben(nintold-nsum+i)=isumind(i)
         enddo
         do i=1,nintold
          albeo(i)=itin(i)
           if(albeo(i).gt.0) albeo(i)=albeo(i-1)
           if(alben(i).gt.0) alben(i)=alben(i-1)
         enddo
         if(nointold.eq.2) then
          isum=0
           do i=1,nintold
             if(albeo(i).ge.-1) then
              isum=isum+1
              iscro(isum)=mod(albeo(i),2)
             endif
           enddo
          isum=0
           do i=1,nintold
             if(alben(i).ge.-1) then
              isum=isum+1
              iscrn(isum)=mod(alben(i),2)
             endif
           enddo
           if(iscro(1).ne.iscrn(1)) isig12=-isig12
         endif
         if(nvintold.eq.2) then
          isum=0
           do i=1,nintold
             if(albeo(i).lt.-1) then
              isum=isum+1
              iscro(isum)=mod(albeo(i),2)
             endif
           enddo
          isum=0
           do i=1,nintold
             if(alben(i).lt.-1) then
              isum=isum+1
              iscrn(isum)=mod(alben(i),2)
             endif
           enddo
           if(iscro(1).ne.iscrn(1)) isig12=-isig12
         endif
       endif
C Indices to be transposed
       if(itrp.ne.0) then
        nsumnew=nsum
         do i=2,nsum
           if(isumind(i).gt.0) nsumnew=nsumnew-1
         enddo
         do i=2,nintold
          j=isumind(i)
           if(j.gt.0) then
            m=isumind(i-1)
            isumind(i-1)=isumind(i-1)-4
            itrp=itrp-1
             do k=1,nintold
               if(itin(k).eq.m) itin(k)=m-4
             enddo
           endif
         enddo
        m=0
         do i=2,nintold
           if(itin(i-1).lt.-3.and.itin(i).gt.0) m=m+1
          itin(i)=itin(i+m)
         enddo
        m=0
         do i=2,nintold
           if(isumind(i-1).lt.-3.and.isumind(i).gt.0) m=m+1
          isumind(i)=isumind(i+m)
         enddo
         do i=2,itrp
           if(isumind(i).gt.0) isumind(i)=i-1
           if(itin(i).gt.0) itin(i)=i-1
         enddo
C
         do i=1,itrp
          albeo(i)=itin(i)
          alben(i)=isumind(i)
           if(albeo(i).gt.0) albeo(i)=albeo(i-1)
           if(alben(i).gt.0) alben(i)=alben(i-1)
          log1(i)=.true.
         enddo
         do i=nsumnew,1,-1
          j=itrp+1
2015       continue
            j=j-1
           if(log1(j).and.alben(i).eq.albeo(j)) then
            log1(j)=.false.
            in(j)=i
           else
            goto 2015
           endif
         enddo
         do i=itrp,nsumnew+1,-1
          j=itrp+1
2016       continue
            j=j-1
           if(log1(j).and.alben(i).eq.albeo(j)) then
            log1(j)=.false.
            in(j)=i
           else
            goto 2016
           endif
         enddo
       endif
       if(itrp.gt.1) then
        is1=isumind(in(1))
        is2=isumind(in(2))
       endif
       if(itrp.gt.2) is3=isumind(in(3))
       if(itrp.gt.3) is4=isumind(in(4))
C
C Length of new free indices
       do isymi=1,nir
        call slength(nmax,nstr,nnir,isympv,isympo,nactm,incs,isymi,
     $nvintnewalact,nvintnewbeact,nvintnewal,nvintnewbe,nointnewalact,
     $nointnewbeact,nointnewal,nointnewbe,dsympair)
        incnew(isymi)=incs
c     write(6,*) 'incnew',isymi,incs,'   ',nvintnewal,nvintnewbe,
c    $nointnewal,nointnewbe
       enddo
c     write(6,"(a6,2x,100i3)") 'incnew',(incnew(i),i=1,nir)
C Memory addresses of new intermediates
       if(ipt.eq.0)
     $call nlength(nmax,nstr,nnir,isympv,isympo,nactm,nvirtnewalact,
     $nvirtnewbeact,nvirtnewal,nvirtnewbe,noccnewalact,noccnewbeact,
     $noccnewal,noccnewbe,incnew,inewadd,nnewsym,iwan)
       if(lsm) ntnewlen=inewadd-1
c #if defined(OMP)
c       if(lsm.and.ll4) ntnewlen=xyzsiz1*(inewadd-1)
c #endif
C Length of summation indices
       do isymi=1,nir
        call slength(nmax,nstr,nnir,isympv,isympo,nactm,incs,isymi,
     $nsumvirtalact,nsumvirtbeact,nsumvirtal,nsumvirtbe,nsumoccalact,
     $nsumoccbeact,nsumoccal,nsumoccbe,dsympair)
        incsum(isymi)=incs
       enddo
C Length of old fixed indices
       do isymi=1,nir
        call slength(nmax,nstr,nnir,isympv,isympo,nactm,incs,isymi,
     $nvirtoldalact,nvirtoldbeact,nvirtoldal,nvirtoldbe,noccoldalact,
     $noccoldbeact,noccoldal,noccoldbe,csympair)
        incold(isymi)=incs
       enddo
      ntoldlen=ntoldleno !If the intermediate was skipped
C
       if(ipt.gt.0) then
        call fwspd(imm,nvintoldal,nointoldal,nvirtoldal,noccoldal,
     $nvintoldalact,nointoldalact,nvintoldbeact,nointoldbeact,
     $nvirtoldalact,noccoldalact,in,ipt,iii)
         if(iii.ne.0) then
          iadd=-iii
          lcalc=0
          return
         endif
         if(lcalc.eq.1) then
c        if(.false.) then
           if(nvintoldal+nointoldal+nvirtoldal+noccoldal.eq.0.or. 
     $nvintoldbe+nointoldbe+nvirtoldbe+noccoldbe.eq.0) then
            call fwspd(imm,nvintoldbe,nointoldbe,nvirtoldbe,noccoldbe,
     $nvintoldbeact,nointoldbeact,nvintoldalact,nointoldalact,
     $nvirtoldbeact,noccoldbeact,in,ipt,jj)
             if(jj.ne.0) then
              iadd=-jj
              return
             endif
           else if(nintold.eq.2) then
c          else if(.false.) then
            in2(1)=in(2)
            in2(2)=in(1)
            in2(3)=0
            in2(4)=0
            call fwspd(imm,nvintoldal,nointoldal,nvirtoldal,noccoldal,
     $nvintoldalact,nointoldalact,nvintoldbeact,nointoldbeact,
     $nvirtoldalact,noccoldalact,in2,ipt,jj)
             if(jj.ne.0) then
              iadd=-jj
              lcalc=2
              return
             endif
           endif
          lcalc=0
         endif
        call diadd(imm,nvintoldal,nointoldal,nvirtoldal,noccoldal,
     $nvintoldalact,nointoldalact,nvintoldbeact,nointoldbeact,
     $nvirtoldalact,noccoldalact,in,ipt,iadd)
       endif
C Length of old integral indices (free)
       do isymi=1,nir
        call slength(nmax,nstr,nnir,isympv,isympo,nactm,inco,isymi,     
     $nvintoldalact,nvintoldbeact,nvintoldal,nvintoldbe,nointoldalact,
     $nointoldbeact,nointoldal,nointoldbe,dsympair)
        incint(isymi)=inco
       enddo
C Address of old intermediate in case of lambda contracted at the end
       if(leftroute.and.namp1.lt.0.and.namp1.ge.-op) then
        iii=0
         do ir1=1,nir
          isymi=isympair(noldsym,ir1,1)
          isyma=isympair(noldsym,ir1,2)
          itrpadd(isymi,isyma)=iii
          iii=iii+incold(isymi)*incint(isyma)
         enddo
       endif
C Incore or out-of-core algorithm
       if(itrp.gt.1) then
        inewadd=0
         do ir1=1,nir
          nintoldsym=isympair(noldsym,ir1,1)
          isyma=     isympair(noldsym,ir1,2)
          isum=0
           do ir2=1,nir
            isymi=  isympair(nintoldsym,ir2,1)
            nsumsym=isympair(nintoldsym,ir2,2)
            isum=isum+incnew(isymi)*incsum(nsumsym)
           enddo
          inewadd=inewadd+isum*incold(isyma)
         enddo
         if(ntoldlen+inewadd.le.maxcor1) then
          incore=.true.
         else
          incore=.false.
          write(iout,*) 'Warning! Executing out-of-core algorithm!'
         endif
       else
        incore=.true.
       endif
c     write(6,*) 'incore',incore,ntoldlen,inewadd,maxcor1
       if(incore) then
c     write(6,*) 'old',irec2+ircold,itrp
         if(itrp.gt.1) then
          call getlst(file2,irec2+ircold,v,ntoldlen)
c     write(6,"(5f14.8)") (v(i),i=1,ntoldlen)
         else
          call getlst(file2,irec2+ircold,v(xyz*ntnewlen+1),ntoldlen)
c     write(6,"(5f14.8)") (v(xyz*ntnewlen+i),i=1,ntoldlen)
         endif
       endif
C Transposition
      iii=1
      inewadd=1
C Loop over symmetry cases of old intermediates
       do ir1=1,nir
      nintoldsym=isympair(noldsym,ir1,1)
      isyma=     isympair(noldsym,ir1,2)
C Set up increments for old integral indices
        call tlength(nmax,nstr,nnir,isympv,isympo,nactm,inco,nintoldsym,
     $nvintoldalact,nvintoldbeact,nvintoldal,nvintoldbe,nointoldalact,
     $nointoldbeact,nointoldal,nointoldbe,ita,1,0,dsympair)
C Transpose free and fixed labels in case of lambda vertex
         if(leftroute.and.namp1.lt.0.and.namp1.ge.-op) call mxtrans(
     $v(inewadd),incold(isyma),inco,file2,irec2+ircold,
     $itrpadd(isyma,nintoldsym))
C Loop over target indices
               do ir2=1,nir
                isymi=  isympair(nintoldsym,ir2,1)
                nsumsym=isympair(nintoldsym,ir2,2)
       if(.not.lll) iwa2(isymi,nsumsym,isyma)=inewadd
      ioldadd=iii
         do ira=1,nir
      nvirtnewsym=csympair(isyma,ira,1)
      noccnewsym=csympair(isyma,ira,2)
           do irav=1,isympv(0,nvirtnewsym,nvirtoldalact,nvirtoldbeact,
     $nvirtoldal,nvirtoldbe,1)
      nvirtnewsyma=isympv(irav,nvirtnewsym,nvirtoldalact,nvirtoldbeact,
     $nvirtoldal,nvirtoldbe,1)
      nvirtnewallen=nstr(nvirtnewsyma,nvirtoldalact,nvirtoldal,1)
      nvirtnewsymb=isympv(irav,nvirtnewsym,nvirtoldalact,nvirtoldbeact,
     $nvirtoldal,nvirtoldbe,2)
      nvirtnewbelen=nstr(nvirtnewsymb,nvirtoldbeact,nvirtoldbe,2)
      nvirtoldlen=nvirtnewallen*nvirtnewbelen
             do irao=1,isympo(0,noccnewsym,noccoldalact,noccoldbeact,
     $noccoldal,noccoldbe,1)
      noccnewsyma=isympo(irao,noccnewsym,noccoldalact,noccoldbeact,
     $noccoldal,noccoldbe,1)
      noccnewallen=nstr(noccnewsyma,noccoldalact,noccoldal,3)
      noccnewsymb=isympo(irao,noccnewsym,noccoldalact,noccoldbeact,
     $noccoldal,noccoldbe,2)
      noccnewbelen=nstr(noccnewsymb,noccoldbeact,noccoldbe,4)
      noccoldlen=noccnewallen*noccnewbelen
       if(lll) then
         if(liw) then
          iwa(isymi,nvirtnewsyma,nvirtnewsymb,noccnewsyma,
     $noccnewsymb,nsumsym)=inewadd
         else
          iwa(isymi,nsumsym,nvirtnewsyma,nvirtnewsymb,noccnewsyma,
     $noccnewsymb)=inewadd
c     write(6,*) 'iwatr',iwa(1,2,2,1,1,1),loc(iwa(1,2,2,1,1,1))
c     write(6,"(100i2)") isymi,nsumsym,nvirtnewsyma,nvirtnewsymb,
c    $noccnewsyma,noccnewsymb
         endif
       endif
C Increments for new indices
      incs=incnew(isymi)
      incn=incs*incsum(nsumsym)
      j4=incn*nvirtoldlen*noccoldlen
       if(incore.and.itrp.eq.2.and.itin(2).gt.0.and.(nir.gt.1.or.mr)) 
     $call dfillzero(v(ntoldlen+inewadd),j4)
      jj=inewadd+j4
      nmem=ntoldlen+jj
C Loop over summation indices
      kk=0
         do irs=1,nir
      nsumsymv=dsympair(nsumsym,irs,1)
      nsumsymo=dsympair(nsumsym,irs,2)
           do irsv=1,isympv(0,nsumsymv,nsumvirtalact,nsumvirtbeact,
     $nsumvirtal,nsumvirtbe,1)
      nsumsymva=isympv(irsv,nsumsymv,nsumvirtalact,nsumvirtbeact,
     $nsumvirtal,nsumvirtbe,1)
      nsumvirtallen=nstr(nsumsymva,nsumvirtalact,nsumvirtal,1)
      nsumsymvb=isympv(irsv,nsumsymv,nsumvirtalact,nsumvirtbeact,
     $nsumvirtal,nsumvirtbe,2)
      nsumvirtbelen=nstr(nsumsymvb,nsumvirtbeact,nsumvirtbe,2)
      j1=nsumvirtallen*nsumvirtbelen
             do irso=1,isympo(0,nsumsymo,nsumoccalact,nsumoccbeact,
     $nsumoccal,nsumoccbe,1)
      nsumsymoa=isympo(irso,nsumsymo,nsumoccalact,nsumoccbeact,
     $nsumoccal,nsumoccbe,1)
      nsumoccallen=nstr(nsumsymoa,nsumoccalact,nsumoccal,3)
      nsumsymob=isympo(irso,nsumsymo,nsumoccalact,nsumoccbeact,
     $nsumoccal,nsumoccbe,2)
      nsumoccbelen=nstr(nsumsymob,nsumoccbeact,nsumoccbe,4)
      j2=j1*nsumoccallen*nsumoccbelen
C Loop over new integral indices
      ifn=kk
             do iri=1,nir
      nintnewsymv=dsympair(isymi,iri,1)
      nintnewsymo=dsympair(isymi,iri,2)
               do iriv=1,isympv(0,nintnewsymv,nvintnewalact,
     $nvintnewbeact,nvintnewal,nvintnewbe,1)
      nintnewsymva=isympv(iriv,nintnewsymv,nvintnewalact,nvintnewbeact,
     $nvintnewal,nvintnewbe,1)
      nvintnewallen=nstr(nintnewsymva,nvintnewalact,nvintnewal,1)
      nintnewsymvb=isympv(iriv,nintnewsymv,nvintnewalact,nvintnewbeact,
     $nvintnewal,nvintnewbe,2)
      nvintnewbelen=nstr(nintnewsymvb,nvintnewbeact,nvintnewbe,2)
      nintoldsymva=mult(nintnewsymva,nsumsymva)
      nvintoldallen=nstr(nintoldsymva,nvintoldalact,nvintoldal,1)
      nintoldsymvb=mult(nintnewsymvb,nsumsymvb)
      nvintoldbelen=nstr(nintoldsymvb,nvintoldbeact,nvintoldbe,2)
      j3=nvintnewallen*nvintnewbelen
                 do irio=1,isympo(0,nintnewsymo,nointnewalact,
     $nointnewbeact,nointnewal,nointnewbe,1)
      nintnewsymoa=isympo(irio,nintnewsymo,nointnewalact,nointnewbeact,
     $nointnewal,nointnewbe,1)
      nointnewallen=nstr(nintnewsymoa,nointnewalact,nointnewal,3)
      nintnewsymob=isympo(irio,nintnewsymo,nointnewalact,nointnewbeact,
     $nointnewal,nointnewbe,2)
      nointnewbelen=nstr(nintnewsymob,nointnewbeact,nointnewbe,4)
      nintoldsymoa=mult(nintnewsymoa,nsumsymoa)
      nointoldallen=nstr(nintoldsymoa,nointoldalact,nointoldal,3)
      nintoldsymob=mult(nintnewsymob,nsumsymob)
      nointoldbelen=nstr(nintoldsymob,nointoldbeact,nointoldbe,4)
C
       if(itrp.gt.1.and.incore) then
        ifo=ita(nintoldsymva,nintoldsymvb,nintoldsymoa,nintoldsymob)
        nintoldlen=nsumvirtallen*nsumvirtbelen*nsumoccallen*nsumoccbelen
     $*nvintnewallen*nvintnewbelen*nointnewallen*nointnewbelen
        itinlen=nvintoldallen*nvintoldbelen*nointoldallen*nointoldbelen
        isum=0
         if(nsumoccbe.gt.0) then
          isum=isum+1
          isumsym(isum)=nsumsymob
          isumact(isum)=nsumoccbeact
         endif
         if(nsumoccal.gt.0) then
          isum=isum+1
          isumsym(isum)=nsumsymoa
          isumact(isum)=nsumoccalact
         endif
         if(nsumvirtbe.gt.0) then
          isum=isum+1
          isumsym(isum)=nsumsymvb
          isumact(isum)=nsumvirtbeact
         endif
         if(nsumvirtal.gt.0) then
          isum=isum+1
          isumsym(isum)=nsumsymva
          isumact(isum)=nsumvirtalact
         endif
C
         if(nointnewbe.gt.0) then
          isum=isum+1
          isumsym(isum)=nintnewsymob
          isumact(isum)=nointnewbeact
         endif
         if(nointnewal.gt.0) then
          isum=isum+1
          isumsym(isum)=nintnewsymoa
          isumact(isum)=nointnewalact
         endif
         if(nvintnewbe.gt.0) then
          isum=isum+1
          isumsym(isum)=nintnewsymvb
          isumact(isum)=nvintnewbeact
         endif
         if(nvintnewal.gt.0) then
          isum=isum+1
          isumsym(isum)=nintnewsymva
          isumact(isum)=nvintnewalact
         endif
C
        ism1=isumsym(in(1))
        ism2=isumsym(in(2))
        isa1=isumact(in(1))
        isa2=isumact(in(2))
        n1=nstr(ism1,isa1,idint(dble(-is1)/4.d0)+1,mod(is1,4)+4)
        n2=nstr(ism2,isa2,idint(dble(-is2)/4.d0)+1,mod(is2,4)+4)
         if(itrp.eq.2) call transp2(v(ntoldlen+inewadd),v(ioldadd),
     $nintoldlen,itinlen,nvirtoldlen*noccoldlen,n1,n2,itin,in,
     $v(ntoldlen+inewadd),v(ioldadd),
     $icore(icmem(ism2,ism1,isa2,isa1,1,1,mod(is1,4)+4)),
     $icore(icmem(ism1,ism2,isa1,isa2,1,1,mod(is1,4)+4)),
     $ifo,inco,ifn,incn,incs)
         if(itrp.eq.3) then
          ism3=isumsym(in(3))
          isa3=isumact(in(3))
          n3=nstr(ism3,isa3,idint(dble(-is3)/4.d0)+1,mod(is3,4)+4)
          call transp3(v(ntoldlen+inewadd),v(ioldadd),nintoldlen,
     $itinlen,nvirtoldlen*noccoldlen,v(nmem),n1,n2,n3,itin,in,
     $v(ioldadd),icore(icmem(ism2,ism1,isa2,isa1,1,1,mod(is1,4)+4)),
     $           icore(icmem(ism3,ism2,isa3,isa2,1,1,mod(is2,4)+4))
     $,nstr(mult(ism3,ism2),isa2+isa3,2,mod(is2,4)+4),ifo,inco,
     $ifn,incn,incs,nsumnew)
         endif
         if(itrp.eq.4) then
          ism3=isumsym(in(3))
          ism4=isumsym(in(4))
          isa3=isumact(in(3))
          isa4=isumact(in(4))
          n3=nstr(ism3,isa3,idint(dble(-is3)/4.d0)+1,mod(is3,4)+4)
          n4=nstr(ism4,isa4,idint(dble(-is4)/4.d0)+1,mod(is4,4)+4)
          call transp4(v(ntoldlen+inewadd),v(ioldadd+ifo),nintoldlen,
     $itinlen,v(nmem),n1,n2,n3,n4,itin,in,v(ioldadd+ifo),
     $icore(icmem(ism2,ism1,isa2,isa1,1,1,mod(is1,4)+4)),
     $icore(icmem(ism4,ism3,isa4,isa3,1,1,mod(is3,4)+4)),
     $nstr(mult(ism4,ism3),isa3+isa4,2,mod(is3,4)+4),incs,
     $nsumnew,ifn)
         endif
      ifn=ifn+j3*nointnewallen*nointnewbelen
       endif
                 enddo
               enddo
             enddo
           kk=kk+j2*incs
         enddo
             enddo
           enddo
      inewadd=jj
      ioldadd=ioldadd+inco*nvirtoldlen*noccoldlen
               enddo
             enddo
           enddo
         enddo
        iii=iii+incold(isyma)*inco
       enddo
      inewadd=inewadd-1
       if(itrp.gt.1.and.(.not.incore)) then
        call dfillzero(v,inewadd)
        call resolw(nstr,nmax,v(inewadd+1),v,nnir,isympv,isympo,ita,
     $nactm,icmem,nvintnewal,nointnewal,nvintnewbe,nointnewbe,
     $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,nsumvirtal
     $,nsumoccal,nsumvirtbe,nsumoccbe,nsumvirtalact,nsumoccalact,
     $nsumvirtbeact,nsumoccbeact,incold,noldsym,incnew,incsum,file2,
     $irec2+ircold,ntoldlen,maxcor1-inewadd)
        if(mod(nvintnewal*nsumvirtal+nointnewal*nsumoccal+
     $nvintnewbe*nsumvirtbe+nointnewbe*nsumoccbe,2).ne.0) isig12=-isig12
       endif
C Skip old intermediate
       if(itrp.gt.1.or.(leftroute.and.namp1.lt.0.and.namp1.ge.-op)) then
         if((.not.incore).or.(leftroute.and.namp1.lt.0.and.namp1.ge.-op)
     $) then
           do i=xyz*ntnewlen+inewadd,xyz*ntnewlen+1,-1
            v(i)=v(i-xyz*ntnewlen)
           enddo
         else
          isum=ntoldlen-xyz*ntnewlen
           if(xyz*ntnewlen.gt.ntoldlen) then
             do i=xyz*ntnewlen+inewadd,xyz*ntnewlen+1,-1
              v(i)=v(i+isum)
             enddo
           endif
           if(xyz*ntnewlen.lt.ntoldlen) then
             do i=xyz*ntnewlen+1,xyz*ntnewlen+inewadd
              v(i)=v(i+isum)
             enddo
           endif
         endif
        ntoldlen=inewadd
       endif
      call dfillzero(v,xyz*ntnewlen)
c     write(6,*) 'tran'
c     write(6,"(5f14.8)") (v(xyz*ntnewlen+i),i=1,ntoldlen)
C
      return
      end
C
************************************************************************
      subroutine savenew(nmem,ntnewlen,wspca,isave,iadd,nvintnewalact,
     $nointnewalact,nvintnewbeact,nointnewbeact,nvirtnewalact,
     $noccnewalact,intrec,v,iadda,isig11,isig12,irec1,ircnew,file1,
     $lcalc,nampvirtalact,nampvirtbeact,nampoccalact,nampoccbeact,
     $nvirtnewbeact,noccnewbeact,wspc1,nstr,nmax,isympv,isympo,ita,
     $earec,tarec,nampvirtal,nampvirtbe,nampoccal,nampoccbe,nvintnewal,
     $nvintnewbe,nointnewal,nointnewbe,nvirtnewal,nvirtnewbe,noccnewal,
     $noccnewbe,scspe)
************************************************************************
* This subroutine save the new intermediates after the contraction     *
************************************************************************
#include "MRCCCOMMON"
      integer nmem,ntnewlen,wspca,isave,i,j,k,ia1,ia2,iadd,ssym
      integer nvintnewalact,nointnewalact,nvirtnewbeact,noccnewbeact
      integer nvintnewbeact,nointnewbeact,nvirtnewalact,noccnewalact
      integer nampvirtalact,nampvirtbeact,nampoccalact,nampoccbeact
      integer intrec,iadda,isig11,isig12,irec1,ircnew,file1,wspc1
      integer nstr,nmax,isympv,isympo,ita,earec,tarec
      integer nampvirtal,nampvirtbe,nampoccal,nampoccbe
      integer nvintnewal,nvintnewbe,nointnewal,nointnewbe
      integer nvirtnewal,nvirtnewbe,noccnewal,noccnewbe
      real*8 v(*),scspe
      logical lcalc
C
      nmem=ntnewlen+1
       if(isave.eq.2) then
        call fwspc(wspca,nvintnewal,nointnewal,nvirtnewal,noccnewal,
     $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,
     $nvirtnewalact,noccnewalact,j,k)
c     write(6,*) 'save',nvintnewal,nointnewal,nvirtnewal,noccnewal,
c    $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,
c    $nvirtnewalact,noccnewalact,j,k,'    ',intrec
        j=intrec+j
        call add(v(1),v(nmem),ntnewlen,0,isig12,1.d0,scspe)
        call fwspc(iadda,nvintnewal,nointnewal,nvirtnewal,noccnewal,
     $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,
     $nvirtnewalact,noccnewalact,ia1,ia2)
         if(ia1.gt.0) then
          call getput(intfile,j,v(1),ntnewlen)
c     write(6,*) 'save1',intfile,j,(v(i),i=1,ntnewlen)
         else
          call putlst(intfile,j,v(1),ntnewlen)
c     write(6,*) 'save2',intfile,j,(v(i),i=1,ntnewlen)
          call wiadd(iadda,nvintnewal,nointnewal,nvirtnewal,noccnewal,
     $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,
     $nvirtnewalact,noccnewalact,ntnewlen)
         endif
       else
        isig12=isig11*isig12
        call add(v(1),v(nmem),ntnewlen,0,isig12,1.d0,scspe)
        call fwspc(iadd,nvintnewal,nointnewal,nvirtnewal,noccnewal,
     $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,
     $nvirtnewalact,noccnewalact,ia1,ia2)
c     write(6,*) 'savenew',file1,irec1,ircnew,ntnewlen,ia1
         if(ia1.gt.0)  then
          call getput(file1,irec1+ircnew,v(1),ntnewlen)
         else
          call putlst(file1,irec1+ircnew,v(1),ntnewlen)
          call wiadd(iadd,nvintnewal,nointnewal,nvirtnewal,noccnewal,
     $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,
     $nvirtnewalact,noccnewalact,ntnewlen)
         endif
         if(lcalc.and.(nampvirtal.ne.nampvirtbe.or.nampvirtalact.ne.
     $nampvirtbeact.or.nampoccalact.ne.nampoccbeact.or.
     $nvirtnewal.ne.nvirtnewbe.or.nvirtnewalact.ne.nvirtnewbeact.or.
     $noccnewalact.ne.noccnewbeact)) then
        call fwspc(wspc1,nvintnewbe,nointnewbe,nvirtnewbe,noccnewbe,
     $nvintnewbeact,nointnewbeact,nvintnewalact,nointnewalact,
     $nvirtnewbeact,noccnewbeact,ircnew,k)
c      write(6,*) 'fwspc'
           if(multip.eq.3) call add(v(1),v(nmem),ntnewlen,0,-1,1.d0,1d0)
           if((calc.eq.0.and.(isy1.eq.isy2.or.isym.eq.isy2)).or.
     $eomroute.or.(leftroute.and.iroot.gt.1.and.
     $(((.not.zroute).and.(.not.l3route)).or.osc)).or.ptroute) then
            ssym=isym
             if(ptroute) ssym=ptsym(1)
            call transpc(nstr,nmax,nir,isympv,
     $isympo,ita,earec,v,v(nmem),nvirtnewal,nvirtnewbe,noccnewal,
     $noccnewbe,nvirtnewal+nvirtnewbe,nvirtnewalact,nvirtnewbeact,
     $noccnewalact,noccnewbeact,nactmax,ssym)
           else
            call transpc(nstr,nmax,nir,isympv,
     $isympo,ita,tarec,v,v(nmem),nvirtnewal,nvirtnewbe,noccnewal,
     $noccnewbe,nvirtnewal+nvirtnewbe,nvirtnewalact,nvirtnewbeact,
     $noccnewalact,noccnewbeact,nactmax,1)
           endif
c      write(6,*) 'transpc'
          call fwspc(iadd,nvintnewbe,nointnewbe,nvirtnewbe,noccnewbe,
     $nvintnewbeact,nointnewbeact,nvintnewalact,nointnewalact,
     $nvirtnewbeact,noccnewbeact,ia1,ia2)
c     write(6,*) 'savenew',file1,irec1,ircnew,ntnewlen,ia1
           if(ia1.gt.0)  then
            call getput(file1,irec1+ircnew,v(nmem),ntnewlen)
           else
            call putlst(file1,irec1+ircnew,v(nmem),ntnewlen)
            call wiadd(iadd,nvintnewbe,nointnewbe,nvirtnewbe,noccnewbe,
     $nvintnewbeact,nointnewbeact,nvintnewalact,nointnewalact,
     $nvirtnewbeact,noccnewbeact,ntnewlen)
           endif
         endif
       endif
C
      return
      end
C
************************************************************************
      subroutine sumsym(nstr,nmax,icmem,isympv,isympo,nnir,ita,nactm,isa
     $,nsumsym,nsyma,nnsumlen,nsumvirtalact,nsumvirtbeact,nsumvirtallen,
     $nsumvirtbelen,ntampsymva,ntampsymvb,nampvirtalact,nampvirtbeact,
     $nampvirtlen,nsumoccalact,nsumoccbeact,nsumoccallen,nsumoccbelen,
     $ntampsymoa,ntampsymob,nampoccalact,nampoccbeact,nampocclen,
     $ntnewlen,ntoldlen,ntampvirtal,ntampvirtalact,ntampvirtbe,
     $ntampvirtbeact,ntampoccal,ntampoccalact,ntampoccbe,ntampoccbeact,
     $nslen,nsumvirtal,nsumvirtbe,nsumoccal,nsumoccbe,nampvirtal,
     $nampvirtbe,nampoccal,nampoccbe)
************************************************************************
* Symmetry cases of summation indices                                  *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,nactm,isa(*),n4,nsumsym,nsyma,ii,nnsumlen,nslen
      integer nstr(nnir,0:nactm,0:nmax,4),ita(nnir,nnir,nnir,nnir)
      integer icmem(nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,4),ntoldlen
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer irs,irsv,irso,nsumsymv,nsumsymo,nsumsymva,nsumsymvb
      integer nsumvirtalact,nsumvirtbeact,nsumvirtallen,nsumvirtbelen
      integer nampsymva,nampsymvb,ntampsymva,ntampsymvb,nampvirtalact
      integer nampvirtbelen,nampvirtbeact,nampvirtlen,nsumoccalact
      integer nsumoccbeact,nsumsymoa,nsumsymob,nsumoccallen,nsumoccbelen
      integer nampsymoa,nampsymob,ntampsymoa,ntampsymob,nampoccalact
      integer nampoccbelen,nampoccbeact,nampocclen,itadd,ntnewlen
      integer ntampvirtal,ntampvirtalact,ntampvirtbe,ntampvirtbeact
      integer ntampoccal,ntampoccalact,ntampoccbe,ntampoccbeact
      integer nampvirtallen,nampoccallen,nsumvirtal,nsumvirtbe,nsumoccal
      integer nsumoccbe,nampvirtal,nampvirtbe,nampoccal,nampoccbe
C Loop over symmetry cases of summation indices
      nnsumlen=0
      ii=0
      nsyma=0
       do irs=1,nir
      nsumsymv=isympair(nsumsym,irs,1)
      nsumsymo=isympair(nsumsym,irs,2)
         do irsv=1,isympv(0,nsumsymv,nsumvirtalact,nsumvirtbeact,
     $nsumvirtal,nsumvirtbe,1)
      nsumsymva=isympv(irsv,nsumsymv,nsumvirtalact,nsumvirtbeact,
     $nsumvirtal,nsumvirtbe,1)
      nsumvirtallen=nstr(nsumsymva,nsumvirtalact,nsumvirtal,1)
      nsumsymvb=isympv(irsv,nsumsymv,nsumvirtalact,nsumvirtbeact,
     $nsumvirtal,nsumvirtbe,2)
      nsumvirtbelen=nstr(nsumsymvb,nsumvirtbeact,nsumvirtbe,2)
      nampsymva=mult(nsumsymva,ntampsymva)
      nampvirtallen=nstr(nampsymva,nampvirtalact,nampvirtal,1)
      nampsymvb=mult(nsumsymvb,ntampsymvb)
      nampvirtbelen=nstr(nampsymvb,nampvirtbeact,nampvirtbe,2)
      nampvirtlen=nampvirtallen*nampvirtbelen
           do irso=1,isympo(0,nsumsymo,nsumoccalact,nsumoccbeact,
     $nsumoccal,nsumoccbe,1)
      nsumsymoa=isympo(irso,nsumsymo,nsumoccalact,nsumoccbeact,
     $nsumoccal,nsumoccbe,1)
      nsumoccallen=nstr(nsumsymoa,nsumoccalact,nsumoccal,3)
      nsumsymob=isympo(irso,nsumsymo,nsumoccalact,nsumoccbeact,
     $nsumoccal,nsumoccbe,2)
      nsumoccbelen=nstr(nsumsymob,nsumoccbeact,nsumoccbe,4)
      nampsymoa=mult(nsumsymoa,ntampsymoa)
      nampoccallen=nstr(nampsymoa,nampoccalact,nampoccal,3)
      nampsymob=mult(nsumsymob,ntampsymob)
      nampoccbelen=nstr(nampsymob,nampoccbeact,nampoccbe,4)
      nampocclen=nampoccallen*nampoccbelen
      n4=nsumvirtallen*nsumvirtbelen*nsumoccallen*nsumoccbelen
      nnsumlen=nnsumlen+n4
      itadd=ntnewlen+ntoldlen+
     $ita(nampsymva,nampsymvb,nampsymoa,nampsymob)-1
      nsyma=nsyma+1
      ii=ii+1
      isa(ii)=icmem(nsumsymva,ntampsymva,nsumvirtalact,ntampvirtalact,
     $nsumvirtal,ntampvirtal,1)-1
      ii=ii+1
      isa(ii)=icmem(nsumsymvb,ntampsymvb,nsumvirtbeact,ntampvirtbeact,
     $nsumvirtbe,ntampvirtbe,2)-1
      ii=ii+1
      isa(ii)=icmem(nsumsymoa,ntampsymoa,nsumoccalact,ntampoccalact,
     $nsumoccal,ntampoccal,3)-1
      ii=ii+1
      isa(ii)=icmem(nsumsymob,ntampsymob,nsumoccbeact,ntampoccbeact,
     $nsumoccbe,ntampoccbe,4)-1
      ii=ii+1
      isa(ii)=nampvirtallen*nampvirtbelen*nampoccallen*nslen
      ii=ii+1
      isa(ii)=nampvirtallen*nampvirtbelen*nslen
      ii=ii+1
      isa(ii)=nampvirtallen*nslen
      ii=ii+1
      isa(ii)=itadd
      ii=ii+1
      isa(ii)=nsumvirtallen*nsumvirtbelen*nsumoccallen*nslen
      ii=ii+1
      isa(ii)=nsumvirtallen*nsumvirtbelen*nslen
      ii=ii+1
      isa(ii)=nsumvirtallen*nslen
      ii=ii+1
      isa(ii)=n4*nslen
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine tlength(nmax,nstr,nnir,isympv,isympo,nactm,isum,ssym,
     $nn1,nn2,nn3,nn4,nn5,nn6,nn7,nn8,ita,inc,isft,isp)
************************************************************************
* This subroutine calculates the length of indices running over strings*
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nactm,isum,nmax,nn,nn1,nn2,nn3,nn4,nn5,nn6,nn7,nn8
      integer nstr(nnir,0:nactm,0:nmax,4),irao,isymaoa,isymaob,ssym,inc
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer ira,isymav,isymao,irav,isymava,isymavb,isft
      integer ita(nnir,nnir,nnir,nnir),isp(nirmax,nirmax,2)
C
      isum=isft
       do ira=1,nir
        isymav=isp(ssym,ira,1)
        isymao=isp(ssym,ira,2)
         do irav=1,isympv(0,isymav,nn1,nn2,nn3,nn4,1)
          isymava=isympv(irav,isymav,nn1,nn2,nn3,nn4,1)
          isymavb=isympv(irav,isymav,nn1,nn2,nn3,nn4,2)
          nn=nstr(isymava,nn1,nn3,1)*nstr(isymavb,nn2,nn4,2)*inc
           do irao=1,isympo(0,isymao,nn5,nn6,nn7,nn8,1)
            isymaoa=isympo(irao,isymao,nn5,nn6,nn7,nn8,1)
            isymaob=isympo(irao,isymao,nn5,nn6,nn7,nn8,2)
            ita(isymava,isymavb,isymaoa,isymaob)=isum
            isum=isum+nstr(isymaoa,nn5,nn7,3)*nstr(isymaob,nn6,nn8,4)*nn
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine tenergy(wspc,wsmax,v,intrec,denrec,file,its,intn)
************************************************************************
* Calculate test energy and poperties from the density matrix          *
************************************************************************
#include "MRCCCOMMON"
      integer wsmax,wspc,intrec,denrec,ix,its,file,intn,iprop,ii
      real*8 v,dip(3),sum
      character*8 pnm
      character*70 chscr
      logical ldb
C
       if((ptroute.and.mult(isym,ptsym(1)).ne.1).or.dbroute.or.dsroute
     $.or.dtroute) then
        ecc=0.d0
        return
       endif
C Calculate energy
       if(.not.osc) then
        ecc=eref
         if(ptroute) ecc=0.d0
         call tenerg1(wspc,wsmax,v,intrec,denrec,intfile,file,its,intn,
     $dens,ecc)
       endif
C Calculate poperties
       if(dipm) then
         do iprop=1,nprop
          pnm=propnm(iprop)
          chscr='Components of                   '
          ldb=.false.
          ii=ichar(pnm(1:1))
           if(pnm(2:4).eq.'DIP') then
             if(osc) then
              chscr=trim(chscr) // ' transition dipole moment'
             else
              chscr=trim(chscr) // ' dipole moment (unrelaxed)'
             endif
            ldb=.true.
           else if(pnm(3:5).eq.'EDM') then
            chscr=trim(chscr) // ' EDM for atom ' // pnm(1:1)
            ldb=.true.
           else if(ii.ge.49.and.ii.le.57) then
            chscr=trim(chscr) // ' ' // trim(pnm(3:8)) // ' for atom ' 
     $// pnm(1:1)
           else
            chscr=trim(chscr) // ' ' // trim(pnm(3:8))
           endif
           do ix=1,3
             if(osc) then
              dip(ix)=0.d0
             else
              dip(ix)=dipc(ix,iprop)+dipn(ix,iprop)
             endif
            call tenerg1(wspc,wsmax,v,intrec,denrec,dipfile,file,
     $nimed2+(3*(iprop-1)+(ix-1))*iimed,intn,1,dip(ix))
           enddo
          write(iout,*) trim(chscr) // ' [au]: '
          write(iout,"(' x=',f14.8,2x,'y=',f14.8,2x,'z=',f14.8)") 
     $(dip(ix),ix=1,3)
           if(ldb) then
            write(iout,*)
            write(iout,*) trim(chscr) // ' [Debye]: '
            write(iout,"(' x=',f14.8,2x,'y=',f14.8,2x,'z=',f14.8)") 
     $(echesu*angtobohr*dip(ix),ix=1,3)
           endif
          write(iout,*)
           if(osc.and.iroot.gt.1) then
             if(eomgrad) then
               if(d1route) then
                sum=dip(1)*dipn(1,iprop)+dip(2)*dipn(2,iprop)+
     $dip(3)*dipn(3,iprop)
               else
                 do ix=1,3
                  dipn(ix,iprop)=dip(ix)
                 enddo
               endif
             else
              sum=dip(1)**2+dip(2)**2+dip(3)**2
             endif
             if((.not.eomgrad).or.d1route) then
              write(iout,"(' Dipole strength:    ',f14.8)") sum
              sum=2.d0*eex*sum/3.d0
              write(iout,"(' Oscillator strength:',f14.8)") sum
c           write(6,"(' Oscillator strength:',f18.12)") sum
             endif
           endif
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine tenerg1(wspc,wsmax,v,intrec,denrec,file1,file2,its,
     $intn,id,ss)
************************************************************************
* Calculate test energy and poperties from the density matrix          *
************************************************************************
#include "MRCCCOMMON"
      integer wsmax,wspc(0:wsmax,13),ire,ile,i,iw,intrec(*),denrec(*),k
      integer m,n,its,file1,file2,j,intn(*),id
      real*8 v(*),sum,ss
C
       do i=its+1,its+iimed
         if(nops(intn(i-its)).eq.2.or.id.eq.2) then
           do iw=1,wspc(0,i)
            ire=wspc((iw-1)*12+11,i)
            ile=wspc((iw-1)*12+12,i)
             if(2*ile.lt.maxcor) then
              call getlst(file1,intrec(i)+ire,v,ile)
c     write(6,*) 'integ',file1,intrec(i),ire,(v(k),k=1,ile)
              call getlst(file2,denrec(i-its)+ire,v(ile+1),ile)
              call scalprod(v(1),v(ile+1),ile,sum)
c            write(6,"(a5,5i3,f15.10)") 'list ',i-its,
c    $(wspc((iw-1)*12+j,i),j=1,4),sum
             else
              sum=0.d0
              n=0
              m=ibufln
               do k=1,ile
                 if(m.eq.ibufln) then
                  m=0
                  read(file1,rec=intrec(i)+ire+n) ibuf
                  read(file2,rec=denrec(i-its)+ire+n) ibuf1
                  n=n+1
                 endif
                m=m+1
                sum=sum+ibuf1(m)*ibuf(m)
               enddo
             endif
            ss=ss+sum
           enddo
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine intsym(nmax,nnir,nactm,nstr,istr,isympv,isympo,iwa,
     $nsym,isymi,nactvintal,nactvintbe,nactointal,nactointbe,nvintnewal,
     $nvintnewbe,nointnewal,nointnewbe)
************************************************************************
* Symmetry cases for integral lists                                    *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,nactm,isum,ii,iri,iriv,irio,isymiva,isymivb
      integer nstr(nnir,0:nactm,0:nmax,-3:0),isymioa,isymiob,nsym,isymi
      integer istr(nnir,0:nactm,0:nmax,-3:0),nactvintal,nactvintbe
      integer nactointal,nactointbe,isymiv,isymio
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),iwa(*)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer nvintnewal,nvintnewbe,nointnewal,nointnewbe
C
      ii=0
      nsym=0
       do iri=1,nir 
        isymiv=dsympair(isymi,iri,1)
        isymio=dsympair(isymi,iri,2)
C      write(6,"(a13,10i2)") 'isymiv,isymio',isymi,isymiv,isymio
         do iriv=1,isympv(0,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,1)
      isymiva=isympv(iriv,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,1)
      isymivb=isympv(iriv,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,2)
           do irio=1,isympo(0,isymio,nactointal,nactointbe,nointnewal,
     $nointnewbe,1)
      isymioa=isympo(irio,isymio,nactointal,nactointbe,nointnewal,
     $nointnewbe,1)
      isymiob=isympo(irio,isymio,nactointal,nactointbe,nointnewal,
     $nointnewbe,2)
            nsym=nsym+1
             if(nointnewbe.gt.0) then
              ii=ii+1
              iwa(ii)=nstr(isymiob,nactointbe,nointnewbe,0)
              ii=ii+1
              iwa(ii)=istr(isymiob,nactointbe,nointnewbe,0)-1
             endif
             if(nointnewal.gt.0) then
              ii=ii+1
              iwa(ii)=nstr(isymioa,nactointal,nointnewal,-1)
              ii=ii+1
              iwa(ii)=istr(isymioa,nactointal,nointnewal,-1)-1
             endif
             if(nvintnewbe.gt.0) then
              ii=ii+1
              iwa(ii)=nstr(isymivb,nactvintbe,nvintnewbe,-2)
              ii=ii+1
              iwa(ii)=istr(isymivb,nactvintbe,nvintnewbe,-2)-1
             endif
             if(nvintnewal.gt.0) then
              ii=ii+1
              iwa(ii)=nstr(isymiva,nactvintal,nvintnewal,-3)
              ii=ii+1
              iwa(ii)=istr(isymiva,nactvintal,nvintnewal,-3)-1
             endif
           enddo
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine densprt(vint,fa,fb,nbmax,nmax,noccup,lpt,dfile,nstr,
     $imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,denrec,
     $absind,ilist1,ilist2,ipr1,ipr2,ipr3,ipr4,iorda,iordb,spc1,spc2,
     $spc3,spc4,afact,maxinc)
************************************************************************
* This subroutine prints density matrices                              *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nbmax,nactm,isum,i,j,k,l,m,ii,absind(2*nbmax,-3:0)
      integer nmax,irec,nn(4),n1,n2,n3,n4,it1,it2,it3,it4,jj,kk,ilist
      integer is1,is2,is3,is4,ios1,ios2,ios3,ios4,iosumind(4),itin(4,13)
      integer nstr(nnir,0:nactm,0:nmax,-3:0),wsmax,iw,ire,ile,intn(*)
      integer nsym,isc,albe(4),imed(16,1),nstr2,nstr3,intl,denrec(13)
      integer istr(nnir,0:nactm,0:nmax,-3:0),ifi,wspca(0:wsmax,13),ndist
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),iwa(*)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),nstr1
      integer nvintoldal,nvintoldbe,nointoldal,nointoldbe,nstr4,llist
      integer nactvintal,nactointal,nactvintbe,nactointbe,nactvirtal,il2
      integer nactoccal,nactvirtbe,nactoccbe,nactsum(4),ilist1,ilist2
      integer isymi,isyma,iri,ira,isymiv,isymio,iriv,irio,isymiva,ifr
      integer isymivb,isymioa,isymiob,isymav,isymao,irav,isymava,isymavb
      integer irao,isymaoa,isymaob,isumsym(4),istr3,istr4,isumind(8),il1
      integer iorda(*),numzero,spc1,spc2,spc3,spc4,noccup(*),maxinc,il11
      integer nvintnewal,nvintnewbe,nointnewal,nointnewbe,iordb(*),ipr4
      integer nvirtnewal,nvirtnewbe,noccnewal,noccnewbe,ipr1,ipr2,ipr3
      integer idist,kkk,ispc,nspc,naa,nbb,dfile
      real*8 vint(nbmax,nbmax,nbmax,maxinc),fa(nbmax,nbmax),sum
      real*8 afact,fb(nbmax,nbmax)
      logical log,log1,log2,log3,lnm,lpt
      data itin /1,2,0,0, !1
     $           2,1,0,0, !2
     $           1,2,0,0, !3
     $           2,1,4,3, !4
     $           4,3,2,1, !5
     $           3,2,1,4, !6
     $           2,1,4,3, !7
     $           3,2,4,1, !8
     $           3,2,1,4, !9
     $           3,4,2,1, !10
     $           2,1,4,3, !11
     $           2,1,0,0, !12
     $           4,3,2,1/ !13
C
      albe(1:4)=0
      iosumind(1:4)=0
      isumind(1:8)=0
      lnm=.false.
      call dfillzero(fa,nbmax**2)
      nspc=1
       if(col.and.(.not.spatial)) then
        nspc=3
        call dfillzero(fb,nbmax**2)
       endif
       do ispc=1,nspc
        rewind(scrfile8)
        ifr=1
        llist=ilist1
        log=.true.
6898    continue
         if(.not.col) ifr=llist
C 
       do ilist=ifr,llist
       do i=ptsh+1,ptsh+iimed
        intl=intn(i-ptsh)
         if((intl.eq.ilist).and.(nops(intl).eq.2.or.dens.eq.2)) then
          nsum=con(intl)
           if(log) then
            it1=itin(1,intl)
            it2=itin(2,intl)
            it3=itin(3,intl)
            it4=itin(4,intl)
           else
             if(nops(intl).eq.2) then
              it2=itin(1,intl)
              it1=itin(2,intl)
              it3=0
              it4=0
             else
              it3=itin(1,intl)
              it4=itin(2,intl)
              it1=itin(3,intl)
              it2=itin(4,intl)
             endif
           endif
           do iw=1,wspca(0,i)
            nvintnewal=wspca((iw-1)*12+1,i)
            nointnewal=wspca((iw-1)*12+2,i)
            nvirtnewal=wspca((iw-1)*12+3,i)
            noccnewal=wspca((iw-1)*12+4,i)
            nvintnewbe=imed(1,i)-nvintnewal
            nointnewbe=imed(2,i)-nointnewal
            nvirtnewbe=imed(3,i)-nvirtnewal
            noccnewbe=imed(4,i)-noccnewal
            nactvintal=wspca((iw-1)*12+5,i)
            nactointal=wspca((iw-1)*12+6,i)
            nactvintbe=wspca((iw-1)*12+7,i)
            nactointbe=wspca((iw-1)*12+8,i)
            nactvirtal=wspca((iw-1)*12+9,i)
            nactoccal=wspca((iw-1)*12+10,i)
            nactvirtbe=imed(11,i)-nactvirtal
            nactoccbe=imed(12,i)-nactoccal
            ire=denrec(i-ptsh)+wspca((iw-1)*12+11,i)
            ile=wspca((iw-1)*12+12,i)
            naa=nvintnewal+nointnewal+nvirtnewal+noccnewal
            nbb=nvintnewbe+nointnewbe+nvirtnewbe+noccnewbe
             if((col.and.(spatial.or.nops(intl).eq.2.or.(ispc.eq.1.and.
     $naa.gt.0.and.nbb.eq.0).or.(ispc.eq.2.and.naa.eq.0.and.nbb.gt.0)
     $.or.(ispc.eq.3.and.naa*nbb.gt.0))).or.
     $((.not.col).and.log.and.
     $nvintnewal.eq.spc1.and.nointnewal.eq.spc2.and.
     $nvirtnewal.eq.spc3.and.noccnewal .eq.spc4).or.
     $((.not.col).and.(.not.log).and.
     $nvintnewal.eq.spc3.and.nointnewal.eq.spc4.and.
     $nvirtnewal.eq.spc1.and.noccnewal .eq.spc2)) then
C
            read(scrfile1,rec=ire) ibuf
             if(lnm) call ibfsgn(ibuf)
             if(ilist.ge.12) then
              nvintnewal=nvirtnewal
              nointnewal=noccnewal
              nvintnewbe=nvirtnewbe
              nointnewbe=noccnewbe
              nactvintal=nactvirtal
              nactointal=nactoccal
              nactvintbe=nactvirtbe
              nactointbe=nactoccbe
              nvirtnewal=0
              noccnewal=0
              nvirtnewbe=0
              noccnewbe=0
              nactvirtal=0
              nactoccal=0
              nactvirtbe=0
              nactoccbe=0
              nsum=nops(intl)
             endif
            isum=0
             if(noccnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=0
              nactsum(isum)=nactoccbe
             endif
             if(noccnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactoccbe
             endif
             if(noccnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-1
              nactsum(isum)=nactoccal
             endif
             if(noccnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactoccal
             endif
             if(nvirtnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=-2
              nactsum(isum)=nactvirtbe
             endif
             if(nvirtnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvirtbe
             endif
             if(nvirtnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-3
              nactsum(isum)=nactvirtal
             endif
             if(nvirtnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvirtal
             endif
             if(nointnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=0
              nactsum(isum)=nactointbe
             endif
             if(nointnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactointbe
             endif
             if(nointnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-1
              nactsum(isum)=nactointal
             endif
             if(nointnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactointal
             endif
             if(nvintnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=-2
              nactsum(isum)=nactvintbe
             endif
             if(nvintnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvintbe
             endif
             if(nvintnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-3
              nactsum(isum)=nactvintal
             endif
             if(nvintnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvintal
             endif
C
             do j=1,nops(intl)
              iosumind(j)=isumind(j)
             enddo
             do j=2,nops(intl)
               if(iosumind(j).gt.0) iosumind(j)=iosumind(j-1)
             enddo
             do j=1,nops(intl)
              albe(j)=iabs(mod(iosumind(j),2))
             enddo
            log1=albe(it1).eq.albe(it3).and.albe(it2).eq.albe(it4)
            log2=albe(it1).eq.albe(it4).and.albe(it2).eq.albe(it3)
            log3=.false.
             if(ispc.eq.3.and.albe(it1).eq.0.and.nops(intl).eq.4) then
              log3=.true.
              ii=it1
              it1=it2
              it2=ii
              ii=it3
              it3=it4
              it4=ii
             endif
            ios1=iosumind(1)
            ios2=iosumind(2)
            ios3=iosumind(3)
            ios4=iosumind(4)
            is2=isumind(2)
            is3=isumind(3)
            is4=isumind(4)
C
            isum=0
             do ir=1,nir
              isymi=isympair(denssym,ir,1)
              isyma=isympair(denssym,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
                 do irav=1,isympv(0,isymav,nactvirtal,nactvirtbe,
     $nvirtnewal,nvirtnewbe,1)
      isymava=isympv(irav,isymav,nactvirtal,nactvirtbe,nvirtnewal,
     $nvirtnewbe,1)
      isymavb=isympv(irav,isymav,nactvirtal,nactvirtbe,nvirtnewal,
     $nvirtnewbe,2)
                   do irao=1,isympo(0,isymao,nactoccal,nactoccbe,
     $noccnewal,noccnewbe,1)
      isymaoa=isympo(irao,isymao,nactoccal,nactoccbe,noccnewal,noccnewbe
     4,1)
      isymaob=isympo(irao,isymao,nactoccal,nactoccbe,noccnewal,noccnewbe
     $,2)
         if(nsum.lt.4) then
                    ii=0
                     if(noccnewbe.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymaob
                     endif
                     if(noccnewal.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymaoa
                     endif
                     if(nvirtnewbe.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymavb
                     endif
                     if(nvirtnewal.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymava
                     endif
      call intsym(nmax,nnir,nactm,nstr,istr,isympv,isympo,iwa,
     $nsym,isymi,nactvintal,nactvintbe,nactointal,nactointbe,
     $nvintnewal,nvintnewbe,nointnewal,nointnewbe)
         endif
C Two-electron integrals 
                     if(nops(intl).eq.4) then
C One summation index
                       if(nsum.eq.1) then
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        nstr3=nstr(isumsym(3),nactsum(3),1,ios3)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                        istr3=istr(isumsym(3),nactsum(3),1,ios3)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                             do i3=1,nstr3
                              nn(3)=absind(icore(istr3+i3),ios3)
                              jj=0
                               do isc=1,nsym
                                jj=jj+1
                                nstr4=iwa(jj)
                                jj=jj+1
                                istr4=iwa(jj)
                                 do i4=1,nstr4
                                  nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
       endif
                                 enddo
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        nstr3=nstr(isumsym(2),nactsum(3),1,ios3)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                        istr3=istr(isumsym(2),nactsum(3),1,ios3)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn(1)=absind(icore(istr1+2*i1),ios1)
                           do i3=1,nstr3
                            nn(3)=absind(icore(istr3+i3),ios3)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr4=iwa(jj)
                              jj=jj+1
                              istr4=iwa(jj)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(it1.le.2) then
          write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
         else
          write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
         endif
       endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is3.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),2,ios2)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),2,ios2)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                           do i2=1,nstr2
                            nn(3)=absind(icore(istr2+2*i2-1),ios2)
                            nn(2)=absind(icore(istr2+2*i2),ios2)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr4=iwa(jj)
                              jj=jj+1
                              istr4=iwa(jj)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(it1.eq.2.or.it1.eq.3) then
          write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
         else
          write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
         endif
       endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       endif
C Two summation indices
                       if(nsum.eq.2) then
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr3=iwa(jj)
                              jj=jj+1
                              istr3=iwa(jj)
                              jj=jj+1
                              nstr4=iwa(jj)
                              jj=jj+1
                              istr4=iwa(jj)
                               do i3=1,nstr3
                                nn(3)=absind(icore(istr3+i3),ios3)
                                 do i4=1,nstr4
                                  nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
c       write(scrfile8) sum,nn(it3),nn(it4),nn(it1),nn(it2)
       endif
                                 enddo
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn(1)=absind(icore(istr1+2*i1),ios1)
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                            jj=jj+1
                            nstr4=iwa(jj)
                            jj=jj+1
                            istr4=iwa(jj)
                             do i3=1,nstr3
                              nn(3)=absind(icore(istr3+i3),ios3)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
c       write(scrfile8) sum,nn(it3),nn(it4),nn(it1),nn(it2)
         if(it1.le.2) then
          write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
c         write(scrfile8) -sum,nn(it3),nn(it4),nn(it2),nn(it1)
         else
          write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
c         write(scrfile8) -sum,nn(it4),nn(it3),nn(it1),nn(it2)
         endif
       endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.le.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr3=iwa(jj)
                              jj=jj+1
                              istr3=iwa(jj)
                               do i3=1,nstr3
                                nn(4)=absind(icore(istr3+2*i3-1),ios3)
                                nn(3)=absind(icore(istr3+2*i3),ios3)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
c       write(scrfile8) sum,nn(it3),nn(it4),nn(it1),nn(it2)
         if(it1.ge.3) then
          write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
c         write(scrfile8) -sum,nn(it3),nn(it4),nn(it2),nn(it1)
         else
          write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
c         write(scrfile8) -sum,nn(it4),nn(it3),nn(it1),nn(it2)
         endif
       endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn(1)=absind(icore(istr1+2*i1),ios1)
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                             do i3=1,nstr3
                              nn(4)=absind(icore(istr3+2*i3-1),ios3)
                              nn(3)=absind(icore(istr3+2*i3),ios3)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
c       write(scrfile8) sum,nn(it3),nn(it4),nn(it1),nn(it2)
        write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
c       write(scrfile8) -sum,nn(it3),nn(it4),nn(it2),nn(it1)
        write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
c       write(scrfile8) -sum,nn(it4),nn(it3),nn(it1),nn(it2)
        write(scrfile8) sum,nn(it2),nn(it1),nn(it4),nn(it3)
c       write(scrfile8) sum,nn(it4),nn(it3),nn(it2),nn(it1)
       endif
                             enddo
                           enddo
                         enddo
                       endif
                       endif
C Three summation indices
                       if(nsum.eq.3) then
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr2=iwa(jj)
                            jj=jj+1
                            istr2=iwa(jj)
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                            jj=jj+1
                            nstr4=iwa(jj)
                            jj=jj+1
                            istr4=iwa(jj)
                             do i2=1,nstr2
                              nn(2)=absind(icore(istr2+i2),ios2)
                               do i3=1,nstr3
                                nn(3)=absind(icore(istr3+i3),ios3)
                                 do i4=1,nstr4
                                  nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
       endif
                                 enddo
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.le.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr2=iwa(jj)
                            jj=jj+1
                            istr2=iwa(jj)
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                             do i2=1,nstr2
                              nn(2)=absind(icore(istr2+i2),ios2)
                               do i3=1,nstr3
                                nn(4)=absind(icore(istr3+2*i3-1),ios3)
                                nn(3)=absind(icore(istr3+2*i3),ios3)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(it1.ge.3) then
          write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
         else
          write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
         endif
       endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is3.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr2=iwa(jj)
                            jj=jj+1
                            istr2=iwa(jj)
                            jj=jj+1
                            nstr4=iwa(jj)
                            jj=jj+1
                            istr4=iwa(jj)
                             do i2=1,nstr2
                              nn(3)=absind(icore(istr2+2*i2-1),ios2)
                              nn(2)=absind(icore(istr2+2*i2),ios2)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(it1.eq.2.or.it1.eq.3) then
          write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
         else
          write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
         endif
       endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       endif
C Four summation indices
                       if(nsum.eq.4) then
           do iri=1,nir
            isymiv=dsympair(isymi,iri,1)
            isymio=dsympair(isymi,iri,2)
             do iriv=1,isympv(0,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,1)
      isymiva=isympv(iriv,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,1)
      isymivb=isympv(iriv,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,2)
               do irio=1,isympo(0,isymio,nactointal,nactointbe,
     $nointnewal,nointnewbe,1)
      isymioa=isympo(irio,isymio,nactointal,nactointbe,nointnewal,
     $nointnewbe,1)
      isymiob=isympo(irio,isymio,nactointal,nactointbe,nointnewal,
     $nointnewbe,2)
                ii=0
                 if(nointnewbe.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymiob
                 endif
                 if(nointnewal.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymioa
                 endif
                 if(nvintnewbe.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymivb
                 endif
                 if(nvintnewal.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymiva
                 endif
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        nstr3=nstr(isumsym(3),nactsum(3),1,ios3)
                        nstr4=nstr(isumsym(4),nactsum(4),1,ios4)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                        istr3=istr(isumsym(3),nactsum(3),1,ios3)-1
                        istr4=istr(isumsym(4),nactsum(4),1,ios4)-1
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                             do i3=1,nstr3
                              nn(3)=absind(icore(istr3+i3),ios3)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                   if(isum.eq.ibufln) then
                                    ire=ire+1
                                    read(scrfile1,rec=ire) ibuf
                                     if(lnm) call ibfsgn(ibuf)
                                    isum=0
                                   endif
                                  isum=isum+1
                                  sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
       endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        nstr3=nstr(isumsym(2),nactsum(3),2,ios3)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                        istr3=istr(isumsym(2),nactsum(3),2,ios3)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn(1)=absind(icore(istr1+2*i1),ios1)
                           do i3=1,nstr3
                            nn(4)=absind(icore(istr3+2*i3-1),ios3)
                            nn(3)=absind(icore(istr3+2*i3),ios3)
                             if(isum.eq.ibufln) then
                              ire=ire+1
                              read(scrfile1,rec=ire) ibuf
                               if(lnm) call ibfsgn(ibuf)
                              isum=0
                             endif
                            isum=isum+1
                            sum=ibuf(isum)
       if(col) then
         if(log1) write(scrfile8)  sum,nn(it1),nn(it2),nn(it3),nn(it4)
         if(log2) write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
       else
        write(scrfile8) sum,nn(it1),nn(it2),nn(it3),nn(it4)
        write(scrfile8) -sum,nn(it2),nn(it1),nn(it3),nn(it4)
        write(scrfile8) -sum,nn(it1),nn(it2),nn(it4),nn(it3)
        write(scrfile8) sum,nn(it2),nn(it1),nn(it4),nn(it3)
       endif
                           enddo
                         enddo
                       endif
               enddo
             enddo
           enddo
                       endif
                     else
C Fock-matrix elements
C Two summation indices
                     if(nsum.eq.2) then
                      jj=0
                       do isc=1,nsym
                        jj=jj+1
                        nstr1=iwa(jj)
                        jj=jj+1
                        istr1=iwa(jj)
                        jj=jj+1
                        nstr2=iwa(jj)
                        jj=jj+1
                        istr2=iwa(jj)
                         do i1=1,nstr1
                          nn(1)=absind(icore(istr1+i1),ios1)
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                             if(isum.eq.ibufln) then
                              ire=ire+1
                              read(scrfile1,rec=ire) ibuf
                               if(lnm) call ibfsgn(ibuf)
                              isum=0
                             endif
                            isum=isum+1
                            sum=ibuf(isum)
                             if(ispc.eq.nspc) then
                               if(spatial.or.albe(1).eq.1) then
                            fa(nn(it1),nn(it2))=fa(nn(it1),nn(it2))+sum
                               else
                            fb(nn(it1),nn(it2))=fb(nn(it1),nn(it2))+sum
                               endif
                             endif
                             if(col) then
                               if(albe(1).eq.1) then
                                 if(spatial.or.ispc.eq.1) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
      write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
      write(scrfile8) -sum,nn(it1),ii,ii,nn(it2)
                                   enddo
                                 endif
                                 if(spatial.or.ispc.eq.3) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
      write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
                                   enddo
                                 endif
                               else
                                 if(spatial.or.ispc.eq.3) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
       if(ispc.eq.3) then
        write(scrfile8)  sum,ii,nn(it1),ii,nn(it2)
       else
        write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
       endif
                                   enddo
                                 endif
                                 if(spatial.or.ispc.eq.2) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
      write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
      write(scrfile8) -sum,nn(it1),ii,ii,nn(it2)
                                   enddo
                                 endif
                               endif
                             endif
                           enddo
                         enddo
                       enddo
                     else
C One summation index
                      nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                      istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                       do i1=1,nstr1
                        nn(1)=absind(icore(istr1+i1),ios1)
                        jj=0
                         do isc=1,nsym
                          jj=jj+1
                          nstr2=iwa(jj)
                          jj=jj+1
                          istr2=iwa(jj)
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                             if(isum.eq.ibufln) then
                              ire=ire+1
                              read(scrfile1,rec=ire) ibuf
                               if(lnm) call ibfsgn(ibuf)
                              isum=0
                             endif
                            isum=isum+1
                            sum=ibuf(isum)
                             if(ispc.eq.nspc) then
                               if(spatial.or.albe(1).eq.1) then
                            fa(nn(it1),nn(it2))=fa(nn(it1),nn(it2))+sum
                               else
                            fb(nn(it1),nn(it2))=fb(nn(it1),nn(it2))+sum
                               endif
                             endif
                             if(col) then
                               if(albe(1).eq.1) then
                                 if(spatial.or.ispc.eq.1) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
      write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
      write(scrfile8) -sum,nn(it1),ii,ii,nn(it2)
                                   enddo
                                 endif
                                 if(spatial.or.ispc.eq.3) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
      write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
                                   enddo
                                 endif
                               else
                                 if(spatial.or.ispc.eq.3) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
       if(ispc.eq.3) then
        write(scrfile8)  sum,ii,nn(it1),ii,nn(it2)
       else
        write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
       endif
                                   enddo
                                 endif
                                 if(spatial.or.ispc.eq.2) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
      write(scrfile8)  sum,nn(it1),ii,nn(it2),ii
      write(scrfile8) -sum,nn(it1),ii,ii,nn(it2)
                                   enddo
                                 endif
                               endif
                             endif
                           enddo
                         enddo
                       enddo
                     endif
                     endif
                   enddo
                 enddo
               enddo
             enddo
             if(log3) then
              ii=it1
              it1=it2
              it2=ii
              ii=it3
              it3=it4
              it4=ii
             endif
             endif
           enddo
         endif
       enddo
       enddo
C Columbus
       if(col) then
C Contribution of reference determinant
         if(spatial.or.ispc.eq.1) then
           do ii=1,nbmax
             if(noccup(ii).ge.1) then
               do j=1,nbmax
                 if(noccup(j).ge.1) then
                  write(scrfile8) 0.5d0,ii,j,ii,j
                  write(scrfile8)-0.5d0,ii,j,j,ii
                 endif
               enddo
             endif
           enddo
         endif
         if(spatial.or.ispc.eq.2) then
           do ii=1,nbmax
             if(noccup(ii).eq.2.or.noccup(ii).eq.-1) then
               do j=1,nbmax
                 if(noccup(j).eq.2.or.noccup(j).eq.-1) then
                  write(scrfile8) 0.5d0,ii,j,ii,j
                  write(scrfile8)-0.5d0,ii,j,j,ii
                 endif
               enddo
             endif
           enddo
         endif
         if(spatial.or.ispc.eq.3) then
           do ii=1,nbmax
             if(noccup(ii).ge.1) then
               do j=1,nbmax
                 if(noccup(j).eq.2.or.noccup(j).eq.-1) then
                  write(scrfile8) 0.5d0,ii,j,ii,j
                 endif
               enddo
             endif
             if(noccup(ii).eq.2.or.noccup(ii).eq.-1) then
               do j=1,nbmax
                 if(noccup(j).ge.1) then
                  write(scrfile8) 0.5d0,j,ii,j,ii
                 endif
               enddo
             endif
           enddo
         endif
        write(scrfile8) 0.d0,0,0,0,0
C Read densities
        k=mod(nbmax,maxinc)
         if(k.ne.0) then
          kk=k
          k=maxinc-k
         else
          kk=maxinc
         endif
        ndist=(nbmax+k)/maxinc
        il2=0
         do idist=1,ndist
          il1=il2+1
          il11=il1-1
           if(idist.eq.ndist) then
            kkk=kk
           else
            kkk=maxinc
           endif
          il2=il2+kkk
          call dfillzero(vint,maxinc*nbmax**3)
          rewind(scrfile8)
          read(scrfile8) sum,i,k,j,l
           do while(l.ne.0)
             if(i.ge.il1.and.i.le.il2) then
              vint(k,j,l,i-il11)=vint(k,j,l,i-il11)+sum
              vint(l,j,k,i-il11)=vint(l,j,k,i-il11)+sum
             endif
             if(j.ge.il1.and.j.le.il2) then
              vint(l,i,k,j-il11)=vint(l,i,k,j-il11)+sum
              vint(k,i,l,j-il11)=vint(k,i,l,j-il11)+sum
             endif
             if(ispc.le.2) then
               if(k.ge.il1.and.k.le.il2) then
                vint(i,l,j,k-il11)=vint(i,l,j,k-il11)+sum
                vint(j,l,i,k-il11)=vint(j,l,i,k-il11)+sum
               endif
               if(l.ge.il1.and.l.le.il2) then
                vint(i,k,j,l-il11)=vint(i,k,j,l-il11)+sum
                vint(j,k,i,l-il11)=vint(j,k,i,l-il11)+sum
               endif
             endif
            read(scrfile8) sum,i,k,j,l
           enddo
C Print densities
           if(ispc.eq.1) then
             do i=il1,il2
               do k=1,nbmax
                 do j=1,nbmax
                   do l=1,nbmax
                    sum=vint(k,j,l,i-il11)
                     if(sum.ne.0.d0) write(dfile,2004)
     $0.25d0*sum,iorda(i),iorda(k),iorda(j),iorda(l)
                   enddo
                 enddo
               enddo
             enddo
           endif
           if(ispc.eq.2) then
             do i=il1,il2
               do k=1,nbmax
                 do j=1,nbmax
                   do l=1,nbmax
                    sum=vint(k,j,l,i-il11)
                     if(sum.ne.0.d0) write(dfile,2004)
     $0.25d0*sum,iordb(i),iordb(k),iordb(j),iordb(l)
                   enddo
                 enddo
               enddo
             enddo
           endif
           if(ispc.eq.3) then
             do i=il1,il2
               do k=1,nbmax
                 do j=1,nbmax
                   do l=1,nbmax
                    sum=vint(k,j,l,i-il11)
                     if(sum.ne.0.d0) write(dfile,2004)
     $0.5d0*sum,iorda(i),iordb(k),iorda(j),iordb(l)
                   enddo
                 enddo
               enddo
             enddo
           endif
         enddo
         if(.not.spatial) write(dfile,2004) 0.d0,0,0,0,0
C
         if(ispc.eq.nspc) then
           if(.not.osc) then
             if(spatial) then
               do i=1,nbmax
                fa(i,i)=fa(i,i)+dble(iabs(noccup(i)))
               enddo
             else
               do i=1,nbmax
                 if(noccup(i).ge.1) fa(i,i)=fa(i,i)+1.d0
               enddo
             endif
           endif
           do i=1,nbmax
             do j=1,nbmax
              sum=fa(i,j)+fa(j,i)
               if(sum.ne.0.d0)
     $        write(dfile,2004) 0.5d0*sum,iorda(i),iorda(j),0,0
             enddo
           enddo
           if(.not.spatial) then
            write(dfile,2004) 0.d0,0,0,0,0
             do i=1,nbmax
               if(.not.osc.and.(noccup(i).eq.-1.or.noccup(i).eq.2))
     $fb(i,i)=fb(i,i)+1.d0
               do j=1,nbmax
                sum=fb(i,j)+fb(j,i)
                 if(sum.ne.0.d0)
     $        write(dfile,2004) 0.5d0*sum,iordb(i),iordb(j),0,0
               enddo
             enddo
            write(dfile,2004) 0.d0,0,0,0,0
           endif
          return
         endif
       endif
C
       if(log.and.(.not.col)) then
        llist=ilist2
        log=.false.
         if(nmr.or.(dfile.eq.dbocfile.and.(calc.eq.0.or.dboc.eq.1))) 
     $lnm=.true.
        goto 6898
       endif
       enddo !ispc
C ACES2
       if(llist.le.3.or.llist.eq.12) then
        write(dfile,2005) numzero(nbmax**2,fa)
         do i1=1,nbmax
           do i2=1,nbmax
             if(fa(i1,i2).ne.0.d0) write(dfile,2004) 
     $afact*fa(i1,i2),iorda(iactsumind(ipr1)),iorda(iactsumind(ipr2))
c      if(fa(i1,i2).ne.0.d0) write(6,*) afact,fa(i1,i2),
c    $iorda(iactsumind(ipr1)),iorda(iactsumind(ipr2)),
c    $iactsumind(ipr1),iactsumind(ipr2),ipr1,ipr2
           enddo
         enddo
       else
        write(scrfile8) 0.d0,0,0,0,0
        rewind(scrfile6)
        k=mod(nbmax,maxinc)
         if(k.ne.0) then
          kk=k
          k=maxinc-k
         else
          kk=maxinc
         endif
        ndist=(nbmax+k)/maxinc
        il2=0
        isum=0
         do idist=1,ndist
          il1=il2+1
          il11=il1-1
           if(idist.eq.ndist) then
            kkk=kk
           else
            kkk=maxinc
           endif
          il2=il2+kkk
          call dfillzero(vint,maxinc*nbmax**3)
          rewind(scrfile8)
          read(scrfile8) sum,i,j,k,l
           do while(l.ne.0)
             if(i.ge.il1.and.i.le.il2) vint(j,k,l,i-il11)=
     $vint(j,k,l,i-il11)+sum
            read(scrfile8) sum,i,j,k,l
           enddo
          isum=isum+numzero(maxinc*nbmax**3,vint)
          write(scrfile6) vint
         enddo
        write(dfile,2005) isum
        rewind(scrfile6)
        il2=0
         do idist=1,ndist
          il1=il2+1
          il11=il1-1
           if(idist.eq.ndist) then
            kkk=kk
           else
            kkk=maxinc
           endif
          il2=il2+kkk
          read(scrfile6) vint
           if(lpt) then
             do i1=il1,il2
               do i2=1,nbmax
                 do i3=1,nbmax
                   do i4=1,nbmax
                    sum=vint(i2,i3,i4,i1-il11)
                     if(sum.ne.0.d0) write(dfile,2004) afact*sum,
     $iorda(iactsumind(ipr1)),iordb(iactsumind(ipr2)),
     $iorda(iactsumind(ipr3)),iordb(iactsumind(ipr4))
                   enddo
                 enddo
               enddo
             enddo
           else
             do i1=il1,il2
               do i2=1,nbmax
                 do i3=1,nbmax
                   do i4=1,nbmax
                    sum=vint(i2,i3,i4,i1-il11)
                     if(sum.ne.0.d0) write(dfile,2004) afact*sum,
     $iorda(iactsumind(ipr1)),iorda(iactsumind(ipr2)),
     $iordb(iactsumind(ipr3)),iordb(iactsumind(ipr4))
                   enddo
                 enddo
               enddo
             enddo
           endif
         enddo
       endif
2004  format(e28.20,4i4)
c2004  format(f20.8,4i3)
2005  format(2i20)
      close(scrfile6,status='delete')
C
      return
      end
C
************************************************************************
      subroutine density(v,nbmax,nmax,nstr,imed,nnir,isympv,isympo,istr,
     $iwa,nactm,wspca,wsmax,intn,denrec,absind,iorda,iordb)
************************************************************************
* This subroutine prints density matrices                              *
************************************************************************
#include "MRCCCOMMON"
      integer nbmax,nmax,nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,i
      integer wspca,wsmax,intn,denrec,absind,iorda(*),iordb(*),ii,jj
      integer maxbuf,dfile
      real*8 v(*)
      logical os,log
C
      close(scrfile8,status='delete')
c      if(rel.eq.2) return
      jj=0
       if(col.and.(.not.spatial)) jj=nbmax**2
      ii=maxcor-(jj+nbmax**2)
      maxbuf=min(nbmax,(ii-mod(ii,nbmax**3))/nbmax**3)
       if(maxbuf.ne.nbmax) 
     $write(iout,*) 'Warning! Executing out-of-core algorithm!'
      os=(.not.cs).or.(.not.spatial)
C
      open(unit=densfile,file='CCDENSITIES')
      rewind(densfile)
      dfile=densfile
       if(dbroute) then
        dfile=dbocfile
        goto 8746
       endif
C Columbus interface
       if(col) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+jj+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,13,13,1,1,1,1,iorda,iordb,1,1,1,1,0.5d0,maxbuf)
        close(densfile)
        return
       endif
C ACES2 interface
       if(ptroute) write(dfile,*) 1,(ptsym(i),nopt(i),i=1,npert)
       if(dens.gt.1) then
       if(os) then
      write(dfile,2986) 'G(IJ,KL) i,j,k,l'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,5,5,1,2,3,4,iorda,iorda,0,2,0,2,0.5d0,maxbuf)
      write(dfile,2986) 'G(ij,kl) i,j,k,l'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,5,5,1,2,3,4,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
       endif
      write(dfile,2986) 'G(Ij,Kl) i,j,k,l'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,5,5,1,2,3,4,iorda,iordb,0,1,0,1,0.5d0,maxbuf)
C
       if(os) then
      write(dfile,2986) 'G(IJ,KA) i,j,k,a'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,8,10,2,1,4,3,iorda,iorda,1,2,0,1,0.5d0,maxbuf)
      write(dfile,2986) 'G(ij,ka) i,j,k,a'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,8,10,2,1,4,3,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
      write(dfile,2986) 'G(Ij,Ak) i,j,k,a'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,8,10,1,2,3,4,iorda,iordb,1,1,0,0,0.5d0,maxbuf)
       endif
      write(dfile,2986) 'G(Ij,Ka) i,j,k,a'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,8,10,1,2,4,3,iorda,iordb,0,1,0,1,-0.5d0,maxbuf)
C
       if(os) then
      write(dfile,2986) 'G(AB,IJ) a,b,i,j'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,11,13,3,4,1,2,iorda,iorda,2,2,0,0,0.5d0,maxbuf)
      write(dfile,2986) 'G(ab,ij) a,b,i,j'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,11,13,3,4,1,2,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
       endif
      write(dfile,2986) 'G(Ab,Ij) a,b,i,j'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,11,13,3,4,1,2,iorda,iordb,1,1,0,0,0.5d0,maxbuf)
C
       if(os) then
      write(dfile,2986) 'G(aJ,iB) a,j,i,b'
         if(ptroute) then
           if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.false.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,4,1,3,2,iordb,iorda,0,0,1,1,0.5d0,maxbuf)
           else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.false.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,4,1,3,2,iordb,iorda,0,0,1,1,-0.5d0,maxbuf)
           endif
         else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,4,3,1,2,iordb,iorda,0,0,1,1,-0.5d0,maxbuf)
         endif
       endif
      write(dfile,2986) 'G(Aj,Ib) a,j,i,b'
       if(ptroute) then
         if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.false.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,4,1,3,2,iorda,iordb,1,1,0,0,0.5d0,maxbuf)
         else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.false.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,4,1,3,2,iorda,iordb,1,1,0,0,-0.5d0,maxbuf)
         endif
       else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,4,3,1,2,iorda,iordb,1,1,0,0,-0.5d0,maxbuf)
       endif
C
       if(os) then
      write(dfile,2986) 'G(AI,BJ) a,i,b,j'
         if(ptroute) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,3,4,1,iorda,iorda,1,1,1,1,0.5d0,maxbuf)
         else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,1,4,3,iorda,iorda,1,1,1,1,0.5d0,maxbuf)
         endif
      write(dfile,2986) 'G(ai,bj) a,i,b,j'
         if(ptroute) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,3,4,1,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
         else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,1,4,3,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
         endif
       endif
      write(dfile,2986) 'G(Ai,Bj) a,i,b,j'
       if(ptroute) then
        call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,3,4,1,iorda,iordb,1,0,1,0,0.5d0,maxbuf)
       else
        call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,1,4,3,iorda,iordb,1,0,1,0,0.5d0,maxbuf)
       endif
       if(os) then
      write(dfile,2986) 'G(aI,bJ) a,i,b,j'
         if(ptroute) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,3,4,1,iordb,iorda,0,1,0,1,0.5d0,maxbuf)
         else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,6,6,2,1,4,3,iordb,iorda,0,1,0,1,0.5d0,maxbuf)
         endif
       endif
C
       if(os) then
         if(nmr) then
      write(dfile,2986) 'G(AB,CI) a,b,c,i'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,4,3,2,1,iorda,iorda,2,1,1,0,-0.5d0,maxbuf)
      write(dfile,2986) 'G(ab,ci) a,b,c,i'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,4,3,2,1,iordb,iordb,0,0,0,0,-0.5d0,maxbuf)
      write(dfile,2986) 'G(Ab,Ic) a,b,c,i'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,3,4,1,2,iorda,iordb,1,1,0,0,-0.5d0,maxbuf)
         else
      write(dfile,2986) 'G(AB,CI) a,b,c,i'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,4,3,2,1,iorda,iorda,2,1,1,0,0.5d0,maxbuf)
      write(dfile,2986) 'G(ab,ci) a,b,c,i'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,4,3,2,1,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
      write(dfile,2986) 'G(Ab,Ic) a,b,c,i'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,3,4,1,2,iorda,iordb,1,1,0,0,0.5d0,maxbuf)
         endif
       endif
      write(dfile,2986) 'G(Ab,Ci) a,b,c,i'
       if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,3,4,2,1,iorda,iordb,1,0,1,0,0.5d0,maxbuf)
       else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,7,9,3,4,2,1,iorda,iordb,1,0,1,0,-0.5d0,maxbuf)
       endif
C
       if(os) then
      write(dfile,2986) 'G(AB,CD) a,b,c,d'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,4,4,1,2,3,4,iorda,iorda,2,0,2,0,0.5d0,maxbuf)
      write(dfile,2986) 'G(ab,cd) a,b,c,d'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,4,4,1,2,3,4,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
       endif
      write(dfile,2986) 'G(Ab,Cd) a,b,c,d'
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,4,4,1,2,3,4,iorda,iordb,1,0,1,0,0.5d0,maxbuf)
       endif
C
      log=.true.
8746  continue
      write(dfile,2986) 'D(I,J)    , i,j '
       if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,2,2,1,2,3,4,iorda,iorda,0,1,0,1,-0.5d0,maxbuf)
       else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,2,2,1,2,3,4,iorda,iorda,0,1,0,1,0.5d0,maxbuf)
       endif
C
      write(dfile,2986) 'D(A,B)    , a,b '
       if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,1,1,1,2,3,4,iorda,iorda,1,0,1,0,-0.5d0,maxbuf)
       else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,1,1,1,2,3,4,iorda,iorda,1,0,1,0,0.5d0,maxbuf)
       endif
C
      write(dfile,2986) 'D(A,I)    , a,i '
       if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,3,12,1,2,3,4,iorda,iorda,1,1,0,0,-0.5d0,maxbuf)
       else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,3,12,1,2,3,4,iorda,iorda,1,1,0,0,0.5d0,maxbuf)
      endif
C
       if(os) then
      write(dfile,2986) 'D(i,j)    , i,j '
       if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,2,2,1,2,3,4,iordb,iordb,0,0,0,0,-0.5d0,maxbuf)
       else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,2,2,1,2,3,4,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
       endif
C
      write(dfile,2986) 'D(a,b)    , a,b '
       if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,1,1,1,2,3,4,iordb,iordb,0,0,0,0,-0.5d0,maxbuf)
       else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,1,1,1,2,3,4,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
       endif
C
      write(dfile,2986) 'D(a,i)    , a,i '
         if(nmr) then
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,3,12,1,2,3,4,iordb,iordb,0,0,0,0,-0.5d0,maxbuf)
         else
      call densprt(v,v(maxbuf*nbmax**3+1),v(maxbuf*nbmax**3+1),
     $nbmax,nmax,icore(noccmem+1),.true.,dfile,
     $nstr,imed,nnir,isympv,isympo,istr,iwa,nactm,wspca,wsmax,intn,
     $denrec,absind,3,12,1,2,3,4,iordb,iordb,0,0,0,0,0.5d0,maxbuf)
         endif
       endif

      close(densfile)
C
       if(log.and.dboc.eq.1.and.calc.eq.0.and.ptroute) then
        log=.false.
        dfile=dbocfile
        goto 8746
       endif
2986  format(1x,a16)
C
      return
      end
C
************************************************************************
      integer function numzero(n,v)
************************************************************************
* Number of non-zero elements
************************************************************************
      implicit none
      integer n,i,nn
      real*8 v(*)
C
      nn=0
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& REDUCTION(+:nn)
       do i=1,n
         if(v(i).ne.0.d0) nn=nn+1
       enddo
C$OMP END PARALLEL DO
      numzero=nn
      return
      end
C
************************************************************************
      subroutine refener(v,imed,wspca,wsmax,intrec,istr,nnir,nactm,nmax,
     $absind,fa,fb,nbmax,nstr,intn)
************************************************************************
* Hartree-Fock (reference determinant) energy                          *
************************************************************************
#include "MRCCCOMMON"
      integer i,j,l,nactoccal,wsmax,ire,kk,jj,n1,ii,nnir,nactm,nmax
      integer imed(16,1),wspca(0:wsmax,13),intrec(*),nactoccbe,nbmax
      integer istr(nnir,0:nactm,0:nmax,-3:0),absind(2*nbmax,-3:0)
      integer nstr(nnir,0:nactm,0:nmax,-3:0),intn(*),isymi,isyma
      integer isymav,isymao,isymiv,isymio,ira,iri
      real*8 v(*),fa(nbmax,nbmax),fb(nbmax,nbmax)
C
       if(dsroute.or.dtroute) return
c     write(6,*) 'refener'
      eref=0.d0
       if(ptroute.and.mult(ptsym(1),isym).ne.1) goto 128
      j=max(0,1-(nal-nactoa))
       do l=ptsh+1,ptsh+iimed
c     write(6,*) 'intn',l,intn(l-ptsh),ptsh,iimed
         do nactoccal=max(0,1-nal+nactoa),min(1,nactoa)
c3         if(intn(l-ptsh).eq.2.and.imed(10,l).eq.j.and.
           if(intn(l-ptsh).eq.2.and.imed(10,l).eq.nactoccal.and.
     $                         imed(12,l).eq.nactoccal) then
      call fwspc(wspca(0,l),0,1,0,1,0,nactoccal,0,0,0,nactoccal,ire,kk)
            call getlst(intfile,intrec(l)+ire,v(1),kk)
c     write(6,*) (v(i),i=1,kk)
c     write(6,*) nactoccal,nactoccal,intrec(l),ire,kk,l,wspca(0,l)
            jj=0
             do ir=1,nir
              isymi=isympair(insym,ir,1)
              isyma=isympair(insym,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
                 if(isymav.eq.1) then
                   do iri=1,nir
                    isymiv=dsympair(isymi,iri,1)
                    isymio=dsympair(isymi,iri,2)
                     if(isymiv.eq.1.and.isymao.eq.isymio) then
C           write(6,*) isymi
                      n1=nstr(isymio,nactoccal,1,-1)
                      ii=istr(isymio,nactoccal,1,-1)-1
                       do i=1,n1
                        v(nocc**2+icore(ii+i))=v(jj+(i-1)*n1+i)
                       enddo
                      jj=jj+n1**2
                     endif
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
       do i=1,nal
        ii=absind(i,-1)
        eref=eref+fa(ii,ii)+v(nocc**2+i)
c       write(6,*) 'a',fa(ii,ii),v(nocc**2+i)
       enddo
C
      j=max(0,1-(nbe-nactob))
       do l=ptsh+1,ptsh+iimed
         do nactoccbe=max(0,1-nbe+nactob),min(1,nactob)
c3         if(intn(l-ptsh).eq.2.and.imed(10,l).eq.j.and.
           if(intn(l-ptsh).eq.2.and.imed(10,l).eq.nactoccbe.and.
     $                         imed(12,l).eq.nactoccbe) then
            call fwspc(wspca(0,l),0,0,0,0,0,0,0,nactoccbe,0,0,ire,kk)
            call getlst(intfile,intrec(l)+ire,v(1),kk)
            jj=0
            do ir=1,nir
              isymi=isympair(insym,ir,1)
              isyma=isympair(insym,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
                 if(isymav.eq.1) then
                   do iri=1,nir
                    isymiv=dsympair(isymi,iri,1)
                    isymio=dsympair(isymi,iri,2)
                     if(isymiv.eq.1.and.isymao.eq.isymio) then
                      n1=nstr(isymio,nactoccbe,1,0)
                      ii=istr(isymio,nactoccbe,1,0)-1
                       do i=1,n1
                        v(nocc**2+icore(ii+i))=v(jj+(i-1)*n1+i)
                       enddo
                      jj=jj+n1**2
                     endif
                   enddo
                 endif
               enddo
             enddo
           endif
         enddo
       enddo
       do i=1,nbe
        ii=absind(i,0)
        eref=eref+fb(ii,ii)+v(nocc**2+i)
c      write(6,*) 'b',fb(ii,ii),v(nocc**2+i)
       enddo
C
128   continue
      eref=eref/2.d0+nuc
       if(ptroute) then
        write(iout,1006) eref
        eref=0.d0
       else
        write(iout,1005) eref
       endif
1005  format(' Energy of reference determinant [au]: ',f20.12)
1006  format(' Derivative of reference energy  [au]: ',f20.12)
C
      return
      end
C
************************************************************************
      subroutine denerg(t1aa,t1bb,t1ab,t1ba,t2,v,nva,nvb,na,nb,nconf,
     $trec,intrec,nmax,istr,nnir,nstr,isympv,isympo,file,wspca,wsmax,
     $nactm,intn,imed,c1aa,c1bb,c1ab,c1ba,ifile,c0,itsh,file1,log1)
************************************************************************
* This subroutine calculates the derivative of coupled-cluster energy  *
************************************************************************
#include "MRCCCOMMON"
      integer nva,nvb,na,nb,nconf,trec,intrec,nmax,istr,nnir,nstr,isympv
      integer isympo,file,wspca,wsmax,nactm,intn,imed,ifile,itsh,file1
      real*8 t1aa,t1bb,t1ab,t1ba,v,c1aa,c1bb,c1ab,c1ba,t2,c0,eccold
      logical log,log1
C
       if(calc.eq.0) return
       if(mult(ptsym(1),isym).ne.1) then
        ecc=0.d0
        return
       endif
C <0|exp(-T) dH/dx exp(T)|0>
      log=eomroute
      eomroute=.false.
       if(log1) then
      call energy(t1aa,t1bb,t1ab,t1ba,t2,v,nva,nvb,na,nb,nconf,
     $trec,intrec,nmax,istr,nnir,nstr,isympv,isympo,tfile,wspca,wsmax,
     $nactm,intn,imed,t1aa,t1bb,t1ab,t1ba,ifile,c0,ptsh,tfile,0,nconf,
     $icore(iabsmem),dcore(umatmem),t1aa,t1bb)
        eref=ecc
       endif
C <0|[exp(-T) H exp(T), dT/dx]|0>
      eomroute=.true.
      eccold=ecc
      call energy(t1aa,t1bb,t1ab,t1ba,t2,v,nva,nvb,na,nb,nconf,
     $trec,intrec,nmax,istr,nnir,nstr,isympv,isympo,ptfile,wspca,wsmax,
     $nactm,intn,imed,c1aa,c1bb,c1ab,c1ba,ifile,c0,0,tfile,0,nconf,
     $icore(iabsmem),dcore(umatmem),t1aa,t1bb)
c     write(6,*) 'ecc',ecc,eref,0.d0
c     ecc=ecc+eccold-eref
      eomroute=log
C
      return
      end
C
************************************************************************
      subroutine readft(nvintnew1,nointnew1,nvirtnew1,noccnew1,nvintold1
     $,nointold1,nvirtold1,noccold1,namp1,ical1,isig11,nlist,isave1,
     $nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,nvintold1a,nointold1a,
     $nvirtold1a,noccold1a,ityp,ii,l2map,log1,intn)
************************************************************************
* Read formula tape                                                    *
************************************************************************
#include "MRCCCOMMON"
      integer nvintnew1,nointnew1,nvirtnew1,noccnew1,nvintold1,nointold1
      integer nvirtold1,noccold1,namp1,ical1,isig11,isave1,nvintnew1a
      integer nointnew1a,nvirtnew1a,noccnew1a,nvintold1a,nointold1a,ilst
      integer nvirtold1a,noccold1a,ityp(*),nlist,ii,l2map(*),intn(*),ilv
      logical log1
C
      log1=.true.
       if(ii.lt.4) then
        read(ftfile,*) nvintnew1,nointnew1,nvirtnew1,noccnew1,
     $nvintold1,nointold1,nvirtold1,noccold1,namp1,ical1,isig11,isave1,
     $nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,
     $nvintold1a,nointold1a,nvirtold1a,noccold1a
       else
        read(ftfile,*) nvintnew1,nointnew1,nvirtnew1,noccnew1,
     $nvintold1,nointold1,nvirtold1,noccold1,namp1,ical1,isig11,nlist,
     $isave1,nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,
     $nvintold1a,nointold1a,nvirtold1a,noccold1a
       endif
C     write(6,"(a1,12i3,a1,8i3)") 
C    $'#',nvintnew1,nointnew1,nvirtnew1,noccnew1,
C    $nvintold1,nointold1,nvirtold1,noccold1,namp1,ical1,isig11,isave1,
C    $' ',nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,
C    $nvintold1a,nointold1a,nvirtold1a,noccold1a
C
       if(((eomgrad.and.(.not.osc)).and.l3route.and.ii.eq.1.and.
     $(ityp(ical1).eq.0.or.ityp(ical1).eq.3)).or.
     $((pert.ge.1.and.pert.le.3).and.pertroute.eq.0.and.namp1.eq.op).or.
     $(pertroute.gt.0.and.pertroute.le.op+2.and.namp1.ne.pertroute-2)
     $.or.(pertroute.gt.op+2.and.(namp1.ne.pertroute-3-op.or.
     $(nvintold1+nointold1+nvirtold1+noccold1.lt.3.and..not.lfvo).or.
     $(nvintold1+nointold1+nvirtold1+noccold1.gt.2.and.rohfdiag.gt.0)
     $)))then
        log1=.false.
         if(isave1.ne.0) then
          ilv=ii
          call skip1(ilv,ftfile)
         endif
       endif
       if(rohfdiag.eq.1.and.ii.eq.2.and.ical1.le.iimed) ical1=-1
C
       if(ptroute) then
         if(t1route.or.(eomroute.and.ityp(ical1).ne.0))
     $ical1=ical1+nimed
         if(t1route.or.l2route) nlist=nlist+nimed
         if(leftroute) then
           if(l1route) then
             if(ii.eq.1.and.ityp(ical1).eq.0) log1=.false.
             if(ityp(ical1).ne.0.and.(ityp(ical1).ne.2.or.ical1.gt.0))
     $ical1=ical1+nimed
           endif
           if(l2route) then
             if(ityp(ical1).eq.0) ical1=ical1+nimed
             if(ityp(ical1).eq.1) ical1=l2map(ical1-eomimed)
             if(ityp(ical1).eq.2) log1=.false.
           endif
           if(l3route) then
             if(ityp(ical1).eq.3.and.ical1.le.densimed) 
     $ical1=ical1+nimed
           endif
         endif
         if(d1route.and.(ityp(ical1).ne.2.or.ical1.gt.0)) 
     $ical1=ical1+nimed
         if(nmr) then
          ilst=ical1
           if(ii.eq.4) ilst=nlist
           if(ilst.gt.nimed.and.ilst.le.nimed+iimed) then
             if(intn(ilst-nimed).ge.12) isig11=-isig11
           endif
         endif
         if(ds1route.or.dt1route) then
           if(ds1route.and.namp1.lt.-iimed-op) namp1=namp1-op
           if(ical1.gt.0.and.calc.eq.1) ical1=ical1+d1imed-l3imed
         endif
       endif
C      
#if defined (MPI)
       if(rank.ne.0) return
#endif
c      if(log1.and.pertroute.ne.0)
c    $write(6,"(a1,12i3,a1,8i3)") 
c    $'#',nvintnew1,nointnew1,nvirtnew1,noccnew1,
c    $nvintold1,nointold1,nvirtold1,noccold1,namp1,ical1,isig11,isave1,
c    $' ',nvintnew1a,nointnew1a,nvirtnew1a,noccnew1a,
c    $nvintold1a,nointold1a,nvirtold1a,noccold1a
C
      return
      end
C
************************************************************************
      subroutine diag12(itsh,drecm,ii1,ii2,intn,intrec,wspca,denrec,
     $wsmax,imed,ld)
************************************************************************
* Integral lists from diagrams 12 and 13                               *
************************************************************************
#include "MRCCCOMMON"
      integer i,j,ii,jj,isum,itsh,drecm,ii1,ii2,intn(*),intrec(*),wsmax
      integer wspca(0:wsmax,13),denrec(*),imed(16,1),iw,nactvirtal
      integer nactoccal,nactvirtbe,nactoccbe,ire,ile,k
      logical ld
C
       do i=itsh+1,itsh+iimed
         if(intn(i-itsh).eq.ii1) then
           do j=itsh+1,itsh+iimed
            jj=j-itsh
             if(intn(jj).eq.ii2.and.imed(11,i).eq.imed(9,j).and.
     $imed(12,i).eq.imed(10,j)) then
              intrec(i)=intrec(j)
              isum=0
               do iw=1,wspca(0,i)
                nactvirtal=wspca((iw-1)*12+9,i)
                nactoccal=wspca((iw-1)*12+10,i)
                nactvirtbe=imed(11,i)-nactvirtal
                nactoccbe=imed(12,i)-nactoccal
      call fwspc(wspca(0,j),wspca((iw-1)*12+3,i),wspca((iw-1)*12+4,i),0,
     $0,nactvirtal,nactoccal,nactvirtbe,nactoccbe,0,0,ire,ile)
                 if(ire*ile.gt.0) then
                  wspca((iw-1)*12+11,i)=ire
                  wspca((iw-1)*12+12,i)=ile
                  k=mod(ile,ibufln)
                   if(k.ne.0) k=ibufln-k
                  isum=isum+(ile+k)/ibufln
                 endif
               enddo
               if(ld.and.(dens.eq.2.or.(dens.eq.1.and.ii1.eq.12))) then
                denrec(i-itsh)=drecm
                 if(ii2.eq.3.or.intn(jj).eq.intn(jj+1)) then
                  drecm=drecm+intrec(j+1)-intrec(j)
                 else
                  drecm=drecm+isum
                 endif
               endif
             endif
           enddo
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine iaddini(nconf,nmax,nactm,i,iadd,tcase,nptype,wspc,
     $wsmax)
************************************************************************
* Initialize iadd vector                                               *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,nact,nactpl,ii,i,iadd,wsmax,iw,nptype
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactv,iacto,iactva,iactoa,iactvb,iactob,wspc(0:wsmax,13)
      integer tcase(2,(2*nactm+1)**2,0:nmax)
C
       if(densroute) then
        ii=i+ptsh 
c         write(6,*) 'iaddini',ii,wspc(0,ii)
         do iw=1,wspc(0,ii)
          call wiadd(iadd,wspc((iw-1)*12+1,ii),wspc((iw-1)*12+2,ii),
     $wspc((iw-1)*12+3,ii),wspc((iw-1)*12+4,ii),wspc((iw-1)*12+5,ii),
     $wspc((iw-1)*12+6,ii),wspc((iw-1)*12+7,ii),wspc((iw-1)*12+8,ii),
     $wspc((iw-1)*12+9,ii),wspc((iw-1)*12+10,ii),wspc((iw-1)*12+12,ii))
         enddo
       else
        iactv=tcase(1,nptype,i)
        iacto=tcase(2,nptype,i)
         do i1=0,i
           do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
            iactvb=iactv-iactva
             do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
              iactob=iacto-iactoa
              ii=nconf(iactva,iactvb,iactoa,iactob,i1,i)
               if(ii.gt.0) then
                call wiadd(iadd,0,0,i1,i1,0,0,0,0,iactva,iactoa,ii)
               endif
             enddo
           enddo
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine change(file1,file2)
************************************************************************
* Change the content of file1 and  file2 (szemet)                      *
************************************************************************
#include "MRCCCOMMON"
      integer file1,file2,i
C
       do i=1,trecmax
        read(file1,rec=i) ibuf1
        read(file2,rec=i) ibuf2
        write(file2,rec=i) ibuf1
        write(file1,rec=i) ibuf2
       enddo
C
      return
      end
C
************************************************************************
      subroutine imedlen(hsym,rsym,lsym,csym,ifi,ila,pts,itypa,itypb,
     $wspca,wspcb,wsmax,imed,nmax,nnir,isympv,isympo,nactm,irec,intrec,
     $nstr,denrec,irecpt,intn,imedsyma,imedsymb,psym2,psym3)
************************************************************************
* Length of intermediates after contraction                            *
************************************************************************
#include "MRCCCOMMON"
      integer hsym,rsym,lsym,csym,imsym(0:13),itypa(*),itypb(*),nmax,pts
      integer nnir,iw,nstr,imed(16,1),irecpt,ifi,ila,imedsym,psym2,psym3
      integer isympv,isympo,nactm,i,j,k,l,m,ii,irec,intrec(*),wsmax
      integer wspca(0:wsmax,13),wspcb(0:wsmax,13),denrec(*),tsym
      integer intn(*),imedsyma(*),imedsymb(*)
C
C Definition of itypa/itypb
C  0: IT
C  1: LIT
C  2: LT
C  3: ITR
C  4: LITR
C  5: LTR1 = LTR
C  6: IC
C  7: LC
C  8: LTR2
C  9: LTR3
C 10: LTR1R2
C 11: LTR2R3
C 12: LTR1R3
C 13: LTR1R2R3
      tsym=1
      imsym(0)=mult(hsym,tsym)
      imsym(1)=mult(lsym,mult(hsym,tsym))
      imsym(2)=mult(lsym,tsym)
      imsym(3)=mult(hsym,mult(tsym,rsym))
      imsym(4)=mult(mult(lsym,hsym),mult(tsym,rsym))
      imsym(5)=mult(lsym,mult(tsym,rsym))
      imsym(6)=mult(hsym,csym)
      imsym(7)=mult(lsym,csym)
      imsym(8)=mult(lsym,mult(tsym,psym2))
      imsym(9)=mult(lsym,mult(tsym,psym3))
      imsym(10)=mult(lsym,mult(tsym,mult(rsym,psym2)))
      imsym(11)=mult(lsym,mult(tsym,mult(psym2,psym3)))
      imsym(12)=mult(lsym,mult(tsym,mult(rsym,psym3)))
      imsym(13)=mult(lsym,mult(tsym,mult(rsym,mult(psym2,psym3))))
C
       do i=ifi+1,ila
        imedsym=imsym(itypa(i))
        imedsyma(i)=imedsym
        ii=0
         if(i-pts.gt.0.and.i-pts.le.iimed) ii=intn(i-pts)
         if(ii.ne.12.and.ii.ne.13) then
          j=1
           do iw=1,wspca(0,i)
            call ilength(nmax,nstr,imed(1,i),nnir,isympv,isympo,nactm,
     $wspca((iw-1)*12+1,i),m,imedsym)
            wspca((iw-1)*12+11,i)=j
            wspca((iw-1)*12+12,i)=m
            k=mod(m,ibufln)
             if(k.ne.0) k=ibufln-k
            j=j+(m+k)/ibufln
c      write(6,*) 'inti',i,ii,'  ',
c    $(wspca((iw-1)*12+l,i),l=1,10),'  ',
c    $(wspca((iw-1)*12+l,i),l=11,12),'   ',imed(1,i),imed(2,i)
c    $,'  ',intrec(i),irec,'   ',imedsym
           enddo
           if(intrec(i).ne.0) then
            intrec(i)=irec
            irec=irec+j-1
             if(ii.ne.0.and.(dens.eq.2.or.(dens.eq.1.and.ii.le.3))) then
              denrec(i-pts)=intrec(i)-irecpt
              drecmax=irec-irecpt
c      write(6,*) 'drecmax',i-pts,intrec(i)-irecpt,drecmax
             endif
           endif
         endif
C
        imedsym=imsym(itypb(i))
        imedsymb(i)=imedsym
        j=1
         do iw=1,wspcb(0,i)
          call ilength(nmax,nstr,imed(5,i),nnir,isympv,isympo,nactm,
     $wspcb((iw-1)*12+1,i),m,imedsym)
          wspcb((iw-1)*12+11,i)=j
          wspcb((iw-1)*12+12,i)=m
c      write(6,*) 'wspcb',i,ii,'  ',
c    $(wspcb((iw-1)*12+l,i),l=1,10),'  ',(wspcb((iw-1)*12+l,i),l=11,12)
          k=mod(m,ibufln)
           if(k.ne.0) k=ibufln-k
          j=j+(m+k)/ibufln
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine fileini(ifst)
************************************************************************
* Initialize intermediate files                                        *
************************************************************************
#include "MRCCCOMMON"
      integer i,j,k,ii,jj,ifst
C
      call dfillzero(ibuf,ibufln)
      j=mod(maxrec,recmax)
      k=mod(ifst+1,recmax)
      ii=(ifst+1-k)/recmax
      jj=intfile+ii
       if(ii.eq.nfile) then
         do i=k,j
          write(jj,rec=i) ibuf
         enddo
       else
         do i=k,recmax
          write(jj,rec=i) ibuf
         enddo
        jj=jj+1
         do k=ii+1,nfile-1
           do i=1,recmax
            write(jj,rec=i) ibuf
           enddo
          jj=jj+1
         enddo
         do i=1,j
          write(jj,rec=i) ibuf
         enddo
       endif
C
      return
      end
C
************************************************************************
      subroutine readlab(lab)
************************************************************************
* Find labels in formula file                                          *
************************************************************************
#include "MRCCCOMMON"
      character*5 lab,eomcheck
C
      eomcheck='     '
       do while(eomcheck.ne.lab)
        read(ftfile,'(a5)') eomcheck
       enddo
C
      return
      end
C
************************************************************************
      subroutine ibfsgn(v)
************************************************************************
* Invert the sign of the IO buffer                                     *
************************************************************************
#include "MRCCCOMMON"
      integer i
      real*8 v(*)
C
       do i=1,ibufln
        v(i)=-v(i)
       enddo
C
      return
      end
C
************************************************************************
      subroutine flskip(nex,file,nrts,irts)
************************************************************************
* Initialize restart files                                             *
************************************************************************
#include "MRCCCOMMON"
      integer nex,file,nrts,ii,jj,kk,i,irts(*)
C
       if((trecmax.le.nex.and.abs(rest).le.2).or.
     $    (trecmax.lt.nex.and.abs(rest).ge.3)) return
       if(abs(rest).eq.3.or.abs(rest).eq.4) then
        open(eifile,file='fort.57',status='unknown')
        read(eifile,*) (irts(i),i=1,nrts)
        close(eifile)
       else
         do i=1,nrts
          irts(i)=i
         enddo
       endif
      call dfillzero(ibuf1,ibufln)
      ii=nrts*trecmax
      kk=nrts
       do iroot=1,nrts
        jj=irts(kk)*nex
        kk=kk-1
         do i=1,trecmax-nex
          write(file,rec=ii) ibuf1
          ii=ii-1
         enddo
         do i=1,nex
          read(file,rec=jj) ibuf
          write(file,rec=ii) ibuf
          ii=ii-1
          jj=jj-1
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine fopen(file,name)
************************************************************************
* Initialize files                                                     *
************************************************************************
#include "MRCCCOMMON"
      integer file
      character*7 name
C
      open(file,file=name,status='unknown')
      close(file,status='delete')
      open(file,file=name,status='unknown',access='direct',recl=irecln)
C
      return
      end
C
************************************************************************
      subroutine wschange(wspca,wspcb,wsmax,intrec,imedsyma,imedsymb)
************************************************************************
* Cahnges the content of wsfile                                        *
************************************************************************
#include "MRCCCOMMON"
      integer i,ii,jj,wsmax,wspca(0:wsmax,13),wspcb(0:wsmax,13)
      integer intrec(*),imedsyma(*),imedsymb(*),il1,il2
C
c     write(6,*) 'wschange'
       if(calc.eq.0) then
        il1=iimed
        il2=ccimed
       else
        il1=eomimed
        il2=nimed
       endif
       do i=il1+1,il2
        call wsch(intrec(i),imedsyma(i),imedsymb(i),wspca(0,i),
     $wspcb(0,i),wsmax+1,i-il1)
       enddo
C
      return
      end
C
************************************************************************
      subroutine intwrt(vint,fa,fb,maxinc,nbmax,nmax,nstr,intrec,imed,
     $nnir,isympv,isympo,istr,iwa,nactm,wspcb,wspca,wsmax,intn,absind,
     $lasym,idsym,itsh,il1,il2,il11,idist,ndist,ispc,nspc,bmed,ldp,ifile
     $,noccup,lfock,ha,hb)
************************************************************************
* This subroutine builds integral lists and writes them to files       *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nbmax,nactm,isum,i,j,ii,absind(2*nbmax,-3:0),itsh
      integer nmax,irec,nn(4),it1,it2,it3,it4,jj,nvirtoldal,noccoldal
      integer is2,is3,is4,ios1,ios2,ios3,ios4,iosumind(4),itin(4,11),mmm
      integer nstr(nnir,0:nactm,0:nmax,-3:0),wsmax,iw,ire,intn(*),ifile
      integer intrec(*),nsym,isc,albe(4),imed(16,1),nstr2,nstr3,intl
      integer istr(nnir,0:nactm,0:nmax,-3:0),ispc,vspc(4,4),nbb,idsym
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),iwa(*)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2),nstr1
      integer nvintoldal,nvintoldbe,nointoldal,nointoldbe,nstr4,bmed
      integer nactvintal,nactointal,nactvintbe,nactointbe,nactvirtal
      integer nactoccal,nactvirtbe,nactoccbe,nactsum(4),noccup(*)
      integer isymi,isyma,iri,ira,isymiv,isymio,iriv,irio,isymiva,ndist
      integer isymivb,isymioa,isymiob,isymav,isymao,irav,isymava,isymavb
      integer irao,isymaoa,isymaob,isumsym(4),istr3,istr4,isumind(8)
      integer wspcb(0:wsmax,13),wspca(0:wsmax,13),maxinc,nspc
      integer nvintnewal,nvintnewbe,nointnewal,nointnewbe,nn1,nn2,idist
      integer nvirtnewal,nvirtnewbe,noccnewal,noccnewbe,il1,il11,il2,naa
      real*8 vint(nbmax,nbmax,nbmax,maxinc),sum
      real*8 fa(nbmax,nbmax),fb(nbmax,nbmax)
      real*8 ha(nbmax,nbmax),hb(nbmax,nbmax)
      logical log,log1,log2,lasym,ldp,lrr,lnv,lre,lfock
      data vspc /1,1,1,1, 0,0,0,0, 1,0,1,0, 0,1,0,1/
      data itin /1,2,0,0,  !1
     $           1,2,0,0,  !2
     $           1,2,0,0,  !3
     $           1,2,3,4,  !4
     $           1,2,3,4,  !5
     $           1,4,3,2,  !6
     $           1,2,3,4,  !7
     $           1,4,2,3,  !8
     $           1,4,3,2,  !9
     $           1,2,4,3,  !10
     $           1,2,3,4/  !11
      write(iout,*) 'Sorting integrals...'
      call flush(iout)
C Check if we have virtual indices
      lnv=.false.
       do i=il1,il2
         if(noccup(i).lt.2) lnv=.true.
       enddo
C Diagrams 1-11
       do i=itsh+1,itsh+bmed
        intl=intn(i-itsh)
         if(intl.le.11) then
c      write(6,*) 'integ',i,intl,ifile
          nsum=con(intl)
          it1=itin(1,intl)
          it2=itin(2,intl)
          it3=itin(3,intl)
          it4=itin(4,intl)
           do iw=1,wspca(0,i)
            nvintnewal=wspca((iw-1)*12+1,i)
            nointnewal=wspca((iw-1)*12+2,i)
            nvirtnewal=wspca((iw-1)*12+3,i)
            noccnewal=wspca((iw-1)*12+4,i)
            nvintnewbe=imed(1,i)-nvintnewal
            nointnewbe=imed(2,i)-nointnewal
            nvirtnewbe=imed(3,i)-nvirtnewal
            noccnewbe=imed(4,i)-noccnewal
            nactvintal=wspca((iw-1)*12+5,i)
            nactointal=wspca((iw-1)*12+6,i)
            nactvintbe=wspca((iw-1)*12+7,i)
            nactointbe=wspca((iw-1)*12+8,i)
            nactvirtal=wspca((iw-1)*12+9,i)
            nactoccal=wspca((iw-1)*12+10,i)
            nactvirtbe=imed(11,i)-nactvirtal
            nactoccbe=imed(12,i)-nactoccal
            ire=intrec(i)+wspca((iw-1)*12+11,i)
            naa=nvintnewal+nointnewal+nvirtnewal+noccnewal
            nbb=nvintnewbe+nointnewbe+nvirtnewbe+noccnewbe
c     write(6,*) 'spin',nvintnewal,nointnewal
            isum=0
             if(noccnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=0
              nactsum(isum)=nactoccbe
             endif
             if(noccnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactoccbe
             endif
             if(noccnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-1
              nactsum(isum)=nactoccal
             endif
             if(noccnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactoccal
             endif
             if(nvirtnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=-2
              nactsum(isum)=nactvirtbe
             endif
             if(nvirtnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvirtbe
             endif
             if(nvirtnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-3
              nactsum(isum)=nactvirtal
             endif
             if(nvirtnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvirtal
             endif
             if(nointnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=0
              nactsum(isum)=nactointbe
             endif
             if(nointnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactointbe
             endif
             if(nointnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-1
              nactsum(isum)=nactointal
             endif
             if(nointnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactointal
             endif
             if(nvintnewbe.gt.0) then
              isum=isum+1
              isumind(isum)=-2
              nactsum(isum)=nactvintbe
             endif
             if(nvintnewbe.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvintbe
             endif
             if(nvintnewal.gt.0) then
              isum=isum+1
              isumind(isum)=-3
              nactsum(isum)=nactvintal
             endif
             if(nvintnewal.gt.1) then
              isum=isum+1
              isumind(isum)=isum-1
              nactsum(isum)=nactvintal
             endif
C
             do j=1,nops(intl)
              iosumind(j)=isumind(j)
             enddo
             do j=2,nops(intl)
               if(iosumind(j).gt.0) iosumind(j)=iosumind(j-1)
             enddo
             do j=1,nops(intl)
              albe(j)=iabs(mod(iosumind(j),2))
             enddo
c         write(6,*) intl,' @albe',(albe(j),j=1,nops(intl)),lasym,ispc
             if(nops(intl).eq.4) then
              log1=albe(1).eq.albe(it3).and.albe(it2).eq.albe(it4).and.
     $(spatial.or.(albe(1).eq.vspc(1,ispc).and.albe(it2).eq.vspc(2,ispc)
     $.and.albe(it3).eq.vspc(3,ispc).and.albe(it4).eq.vspc(4,ispc)))
              log2=(albe(1).eq.albe(it4).and.albe(it2).eq.albe(it3).and.
     $(spatial.or.(albe(1).eq.vspc(1,ispc).and.albe(it2).eq.vspc(2,ispc)
     $.and.albe(it4).eq.vspc(3,ispc).and.albe(it3).eq.vspc(4,ispc))))
     $.and.(lasym.or.ispc.ge.3)
             else
              log1=.true.
              log2=.true.
             endif
C
             if((spatial.or.nops(intl).eq.2.or.(ispc.eq.1.and.naa.gt.0
     $.and.nbb.eq.0).or.(ispc.eq.2.and.naa.eq.0.and.nbb.gt.0).or.(ispc
     $.gt.2.and.naa*nbb.gt.0.and.(log1.or.log2))).and.(intl.ne.4.or.
     $lnv)) then
c      if(intl.eq.6) write(6,"(a4,1x,100i2)") 'intl',
c    $      nvintnewal,nointnewal,nvirtnewal,noccnewal,nvintnewbe,
c    $      nointnewbe,nvirtnewbe,noccnewbe,nactvintal,nactointal,
c    $      nactvintbe,nactointbe,nactvirtal,nactoccal,nactvirtbe,
c    $      nactoccbe,ire,naa,nbb
            read(ifile,rec=ire) ibuf
            lrr=.false.
            lre=.false.
            ios1=iosumind(1)
            ios2=iosumind(2)
            ios3=iosumind(3)
            ios4=iosumind(4)
            is2=isumind(2)
            is3=isumind(3)
            is4=isumind(4)
C
            isum=0
             do ir=1,nir
              isymi=isympair(idsym,ir,1)
              isyma=isympair(idsym,ir,2)
               do ira=1,nir
                isymav=csympair(isyma,ira,1)
                isymao=csympair(isyma,ira,2)
C      write(6,"(a13,10i2)") 'isymav,isymao',isyma,isymav,isymao
                 do irav=1,isympv(0,isymav,nactvirtal,nactvirtbe,
     $nvirtnewal,nvirtnewbe,1)
      isymava=isympv(irav,isymav,nactvirtal,nactvirtbe,nvirtnewal,
     $nvirtnewbe,1)
      isymavb=isympv(irav,isymav,nactvirtal,nactvirtbe,nvirtnewal,
     $nvirtnewbe,2)
                   do irao=1,isympo(0,isymao,nactoccal,nactoccbe,
     $noccnewal,noccnewbe,1)
      isymaoa=isympo(irao,isymao,nactoccal,nactoccbe,noccnewal,noccnewbe
     $,1)
      isymaob=isympo(irao,isymao,nactoccal,nactoccbe,noccnewal,noccnewbe
     $,2)
         if(nsum.lt.4) then
                    ii=0
                     if(noccnewbe.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymaob
                     endif
                     if(noccnewal.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymaoa
                     endif
                     if(nvirtnewbe.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymavb
                     endif
                     if(nvirtnewal.gt.0) then
                      ii=ii+1
                      isumsym(ii)=isymava
                     endif
C      write(6,"(a13,10i2)") 'intsym elott ',isymi
      call intsym(nmax,nnir,nactm,nstr,istr,isympv,isympo,iwa,
     $nsym,isymi,nactvintal,nactvintbe,nactointal,nactointbe,
     $nvintnewal,nvintnewbe,nointnewal,nointnewbe)
         endif
C Two-electron integrals 
                     if(nops(intl).eq.4) then
C One summation index
                       if(nsum.eq.1) then
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        nstr3=nstr(isumsym(3),nactsum(3),1,ios3)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                        istr3=istr(isumsym(3),nactsum(3),1,ios3)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                             do i3=1,nstr3
                              nn(3)=absind(icore(istr3+i3),ios3)
                              jj=0
                               do isc=1,nsym
                                jj=jj+1
                                nstr4=iwa(jj)
                                jj=jj+1
                                istr4=iwa(jj)
                                 do i4=1,nstr4
                                  nn(4)=absind(icore(istr4+i4),ios4)
                                  isum=isum+1
                                   if(log) then
                                    sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                    ibuf(isum)=sum
                                    lrr=.true.
                                   endif
                                   if(isum.eq.ibufln) then
                                     if(lrr) write(ifile,rec=ire) ibuf
                                    ire=ire+1
                                    lre=.true.
                                    lrr=.false.
                                    isum=0
                                   endif
                                 enddo
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        nstr3=nstr(isumsym(2),nactsum(3),1,ios3)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                        istr3=istr(isumsym(2),nactsum(3),1,ios3)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn1=absind(icore(istr1+2*i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                           do i3=1,nstr3
                            nn(3)=absind(icore(istr3+i3),ios3)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr4=iwa(jj)
                              jj=jj+1
                              istr4=iwa(jj)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                 if(isum.eq.ibufln) then
                                   if(lrr) write(ifile,rec=ire) ibuf
                                  ire=ire+1
                                  lre=.true.
                                  lrr=.false.
                                  isum=0
                                 endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is3.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),2,ios2)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),2,ios2)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                           do i2=1,nstr2
                            nn(3)=absind(icore(istr2+2*i2-1),ios2)
                            nn(2)=absind(icore(istr2+2*i2),ios2)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr4=iwa(jj)
                              jj=jj+1
                              istr4=iwa(jj)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                 if(isum.eq.ibufln) then
                                   if(lrr) write(ifile,rec=ire) ibuf
                                  ire=ire+1
                                  lre=.true.
                                  lrr=.false.
                                  isum=0
                                 endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       endif
C Two summation indices
                       if(nsum.eq.2) then
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr3=iwa(jj)
                              jj=jj+1
                              istr3=iwa(jj)
                              jj=jj+1
                              nstr4=iwa(jj)
                              jj=jj+1
                              istr4=iwa(jj)
                               do i3=1,nstr3
                                nn(3)=absind(icore(istr3+i3),ios3)
                                 do i4=1,nstr4
                                  nn(4)=absind(icore(istr4+i4),ios4)
                                  isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                   if(isum.eq.ibufln) then
                                     if(lrr) write(ifile,rec=ire) ibuf
                                    ire=ire+1
                                    lre=.true.
                                    lrr=.false.
                                    isum=0
                                   endif
                                 enddo
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn1=absind(icore(istr1+2*i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                            jj=jj+1
                            nstr4=iwa(jj)
                            jj=jj+1
                            istr4=iwa(jj)
                             do i3=1,nstr3
                              nn(3)=absind(icore(istr3+i3),ios3)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                 if(isum.eq.ibufln) then
                                   if(lrr) write(ifile,rec=ire) ibuf
                                  ire=ire+1
                                  lre=.true.
                                  lrr=.false.
                                  isum=0
                                 endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.le.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                            jj=0
                             do isc=1,nsym
                              jj=jj+1
                              nstr3=iwa(jj)
                              jj=jj+1
                              istr3=iwa(jj)
                               do i3=1,nstr3
                                nn(4)=absind(icore(istr3+2*i3-1),ios3)
                                nn(3)=absind(icore(istr3+2*i3),ios3)
                                isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                 if(isum.eq.ibufln) then
                                   if(lrr) write(ifile,rec=ire) ibuf
                                  ire=ire+1
                                  lre=.true.
                                  lrr=.false.
                                  isum=0
                                 endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn1=absind(icore(istr1+2*i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                             do i3=1,nstr3
                              nn(4)=absind(icore(istr3+2*i3-1),ios3)
                              nn(3)=absind(icore(istr3+2*i3),ios3)
                              isum=isum+1
                                 if(log) then
                                  sum=0.d0
      sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
       if(lasym) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                               if(isum.eq.ibufln) then
                                 if(lrr) write(ifile,rec=ire) ibuf
                                ire=ire+1
                                lre=.true.
                                lrr=.false.
                                isum=0
                               endif
                             enddo
                           enddo
                         enddo
                       endif
                       endif
C Three summation indices
                       if(nsum.eq.3) then
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr2=iwa(jj)
                            jj=jj+1
                            istr2=iwa(jj)
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                            jj=jj+1
                            nstr4=iwa(jj)
                            jj=jj+1
                            istr4=iwa(jj)
                             do i2=1,nstr2
                              nn(2)=absind(icore(istr2+i2),ios2)
                               do i3=1,nstr3
                                nn(3)=absind(icore(istr3+i3),ios3)
                                 do i4=1,nstr4
                                  nn(4)=absind(icore(istr4+i4),ios4)
                                  isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                   if(isum.eq.ibufln) then
                                     if(lrr) write(ifile,rec=ire) ibuf
                                    ire=ire+1
                                    lre=.true.
                                    lrr=.false.
                                    isum=0
                                   endif
                                 enddo
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.le.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr2=iwa(jj)
                            jj=jj+1
                            istr2=iwa(jj)
                            jj=jj+1
                            nstr3=iwa(jj)
                            jj=jj+1
                            istr3=iwa(jj)
                             do i2=1,nstr2
                              nn(2)=absind(icore(istr2+i2),ios2)
                               do i3=1,nstr3
                                nn(4)=absind(icore(istr3+2*i3-1),ios3)
                                nn(3)=absind(icore(istr3+2*i3),ios3)
                                isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                 if(isum.eq.ibufln) then
                                   if(lrr) write(ifile,rec=ire) ibuf
                                  ire=ire+1
                                  lre=.true.
                                  lrr=.false.
                                  isum=0
                                 endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is3.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                          jj=0
                           do isc=1,nsym
                            jj=jj+1
                            nstr2=iwa(jj)
                            jj=jj+1
                            istr2=iwa(jj)
                            jj=jj+1
                            nstr4=iwa(jj)
                            jj=jj+1
                            istr4=iwa(jj)
                             do i2=1,nstr2
                              nn(3)=absind(icore(istr2+2*i2-1),ios2)
                              nn(2)=absind(icore(istr2+2*i2),ios2)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                 if(isum.eq.ibufln) then
                                   if(lrr) write(ifile,rec=ire) ibuf
                                  ire=ire+1
                                  lre=.true.
                                  lrr=.false.
                                  isum=0
                                 endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       endif
C Four summation indices
                       if(nsum.eq.4) then
           do iri=1,nir
            isymiv=dsympair(isymi,iri,1)
            isymio=dsympair(isymi,iri,2)
             do iriv=1,isympv(0,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,1)
      isymiva=isympv(iriv,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,1)
      isymivb=isympv(iriv,isymiv,nactvintal,nactvintbe,nvintnewal,
     $nvintnewbe,2)
               do irio=1,isympo(0,isymio,nactointal,nactointbe,
     $nointnewal,nointnewbe,1)
      isymioa=isympo(irio,isymio,nactointal,nactointbe,nointnewal,
     $nointnewbe,1)
      isymiob=isympo(irio,isymio,nactointal,nactointbe,nointnewal,
     $nointnewbe,2)
                ii=0
                 if(nointnewbe.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymiob
                 endif
                 if(nointnewal.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymioa
                 endif
                 if(nvintnewbe.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymivb
                 endif
                 if(nvintnewal.gt.0) then
                  ii=ii+1
                  isumsym(ii)=isymiva
                 endif
                       if(is2.le.0.and.is4.le.0.and.is3.le.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                        nstr2=nstr(isumsym(2),nactsum(2),1,ios2)
                        nstr3=nstr(isumsym(3),nactsum(3),1,ios3)
                        nstr4=nstr(isumsym(4),nactsum(4),1,ios4)
                        istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
                        istr2=istr(isumsym(2),nactsum(2),1,ios2)-1
                        istr3=istr(isumsym(3),nactsum(3),1,ios3)-1
                        istr4=istr(isumsym(4),nactsum(4),1,ios4)-1
                         do i1=1,nstr1
                          nn1=absind(icore(istr1+i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                           do i2=1,nstr2
                            nn(2)=absind(icore(istr2+i2),ios2)
                             do i3=1,nstr3
                              nn(3)=absind(icore(istr3+i3),ios3)
                               do i4=1,nstr4
                                nn(4)=absind(icore(istr4+i4),ios4)
                                isum=isum+1
                                 if(log) then
                                  sum=0.d0
      if(log1) sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
      if(log2) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                                 if(isum.eq.ibufln) then
                                   if(lrr) write(ifile,rec=ire) ibuf
                                  ire=ire+1
                                  lre=.true.
                                  lrr=.false.
                                  isum=0
                                 endif
                               enddo
                             enddo
                           enddo
                         enddo
                       endif
                       if(is2.gt.0.and.is4.gt.0) then
                        nstr1=nstr(isumsym(1),nactsum(1),2,ios1)
                        nstr3=nstr(isumsym(2),nactsum(3),2,ios3)
                        istr1=istr(isumsym(1),nactsum(1),2,ios1)-1
                        istr3=istr(isumsym(2),nactsum(3),2,ios3)-1
                         do i1=1,nstr1
                          nn(2)=absind(icore(istr1+2*i1-1),ios1)
                          nn1=absind(icore(istr1+2*i1),ios1)
                           if(nn1.ge.il1.and.nn1.le.il2) then
                            log=.true.
                            nn1=nn1-il11
                           else
                            log=.false.
                           endif
                           do i3=1,nstr3
                            nn(4)=absind(icore(istr3+2*i3-1),ios3)
                            nn(3)=absind(icore(istr3+2*i3),ios3)
                            isum=isum+1
                                 if(log) then
                                  sum=0.d0
      sum=sum+vint(nn(it2),nn(it3),nn(it4),nn1)
       if(lasym) sum=sum-vint(nn(it2),nn(it4),nn(it3),nn1)
                                     if(lre) then
                                      lre=.false.
                                      read(ifile,rec=ire) ibuf
                                     endif
                                  ibuf(isum)=sum
                                  lrr=.true.
                                 endif
                             if(isum.eq.ibufln) then
                               if(lrr) write(ifile,rec=ire) ibuf
                              ire=ire+1
                              lre=.true.
                              lrr=.false.
                              isum=0
                             endif
                           enddo
                         enddo
                       endif
               enddo
             enddo
           enddo
                       endif
                     else
C Fock-matrix elements
C Two summation indices
                    lrr=.true.
                     if(nsum.eq.2) then
                      jj=0
                       do isc=1,nsym
                        jj=jj+1
                        nstr1=iwa(jj)
                        jj=jj+1
                        istr1=iwa(jj)
                        jj=jj+1
                        nstr2=iwa(jj)
                        jj=jj+1
                        istr2=iwa(jj)
                         do i1=1,nstr1
                          mmm=absind(icore(istr1+i1),ios1)
                           if(mmm.ge.il1.and.mmm.le.il2) then
                            log=ldp
                            nn1=mmm-il11
                           else
                            log=.false.
                           endif
                           do i2=1,nstr2
                            nn2=absind(icore(istr2+i2),ios2)
                            isum=isum+1
                            sum=0.d0
                             if(idist.eq.ndist.and.ispc.eq.nspc) then
                               if(albe(1).eq.1) then
                                sum=fa(mmm,nn2)
                               else
                                sum=fb(mmm,nn2)
                               endif
                             endif
                             if(log) then
                               if(albe(1).eq.1) then
                                 if(spatial.or.ispc.eq.1) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
      sum=sum+vint(ii,nn2,ii,nn1)
       if(lasym) sum=sum-vint(ii,ii,nn2,nn1)
                                   enddo
                                 endif
                                 if(spatial.or.ispc.eq.3) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
                                    sum=sum+vint(ii,nn2,ii,nn1)
                                   enddo
                                 endif
                               else
                                 if(spatial.or.ispc.eq.4) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
                                    sum=sum+vint(ii,nn2,ii,nn1)
                                   enddo
                                 endif
                                 if(spatial.or.ispc.eq.2) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
      sum=sum+vint(ii,nn2,ii,nn1)
       if(lasym) sum=sum-vint(ii,ii,nn2,nn1)
                                   enddo
                                 endif
                               endif
                             endif
                            ibuf(isum)=ibuf(isum)+sum
                             if(idist.eq.ndist.and.ispc.eq.nspc.and.
     $lfock) then !Reconstruct core Hamiltonian
                              sum=ibuf(isum)
                               if(albe(1).eq.1) then
                                sum=sum-fa(mmm,nn2)
                                ibuf(isum)=fa(mmm,nn2)
                                ha(mmm,nn2)=fa(mmm,nn2)-sum
                                ha(nn2,mmm)=ha(mmm,nn2)
                               else
                                sum=sum-fb(mmm,nn2)
                                ibuf(isum)=fb(mmm,nn2)
                                hb(mmm,nn2)=fb(mmm,nn2)-sum
                                hb(nn2,mmm)=hb(mmm,nn2)
                               endif
                             endif
                             if(isum.eq.ibufln) then
                              write(ifile,rec=ire) ibuf
                              ire=ire+1
                              read(ifile,rec=ire) ibuf
                              isum=0
                             endif
                           enddo
                         enddo
                       enddo
                     else
C One summation index
                      nstr1=nstr(isumsym(1),nactsum(1),1,ios1)
                      istr1=istr(isumsym(1),nactsum(1),1,ios1)-1
C         write(6,"(a3,10i3)") 'ios',ios1,ios2,isumsym(1),nstr1
                       do i1=1,nstr1
                        mmm=absind(icore(istr1+i1),ios1)
C         write(6,"(a3,10i3)") 'mmm',i1,mmm,icore(istr1+i1)
                         if(mmm.ge.il1.and.mmm.le.il2) then
                          log=ldp
                          nn1=mmm-il11
                         else
                          log=.false.
                         endif
                        jj=0
                         do isc=1,nsym
                          jj=jj+1
                          nstr2=iwa(jj)
                          jj=jj+1
                          istr2=iwa(jj)
                           do i2=1,nstr2
                            nn2=absind(icore(istr2+i2),ios2)
                            isum=isum+1
C         write(6,"(a4,10i3)") 'isum',isum
                            sum=0.d0
                             if(idist.eq.ndist.and.ispc.eq.nspc) then
                               if(albe(1).eq.1) then
                                sum=fa(mmm,nn2)
                               else
                                sum=fb(mmm,nn2)
                               endif
                             endif
C         write(6,*) 'sum1',sum,fa(mmm,nn2),mmm,nn2,albe(1)
                             if(log) then
                               if(albe(1).eq.1) then
                                 if(spatial.or.ispc.eq.1) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
      sum=sum+vint(ii,nn2,ii,nn1)
       if(lasym) sum=sum-vint(ii,ii,nn2,nn1)
C         write(6,*) 'sum2',sum
                                   enddo
                                 endif
c     if(dabs(sum).gt.1d-6) write(6,"(a4,e12.6)") 'sum1',sum
                                 if(spatial.or.ispc.eq.3) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
                                    sum=sum+vint(ii,nn2,ii,nn1)
                                   enddo
                                 endif
                               else
                                 if(spatial.or.ispc.eq.4) then
                                   do i3=1,nal
                                    ii=absind(i3,-1)
                                    sum=sum+vint(ii,nn2,ii,nn1)
                                   enddo
                                 endif
c     if(dabs(sum).gt.1d-6) write(6,"(a4,e12.6)") 'sum2',sum
                                 if(spatial.or.ispc.eq.2) then
                                   do i3=1,nbe
                                    ii=absind(i3,0)
      sum=sum+vint(ii,nn2,ii,nn1)
       if(lasym) sum=sum-vint(ii,ii,nn2,nn1)
                                   enddo
                                 endif
                               endif
                             endif
                            ibuf(isum)=ibuf(isum)+sum
                             if(idist.eq.ndist.and.ispc.eq.nspc.and.
     $lfock) then !Reconstruct core Hamiltonian
                              sum=ibuf(isum)
                               if(albe(1).eq.1) then
                                sum=sum-fa(mmm,nn2)
                                ibuf(isum)=fa(mmm,nn2)
                                ha(mmm,nn2)=fa(mmm,nn2)-sum
                                ha(nn2,mmm)=ha(mmm,nn2)
                               else
                                sum=sum-fb(mmm,nn2)
                                ibuf(isum)=fb(mmm,nn2)
                                hb(mmm,nn2)=fb(mmm,nn2)-sum
                                hb(nn2,mmm)=hb(mmm,nn2)
                               endif
                             endif
                             if(isum.eq.ibufln) then
                              write(ifile,rec=ire) ibuf
                              ire=ire+1
                              read(ifile,rec=ire) ibuf
                              isum=0
                             endif
                           enddo
                         enddo
                       enddo
                     endif
                     endif
                   enddo
                 enddo
               enddo
             enddo
             if(isum.gt.0.and.lrr) write(ifile,rec=ire) ibuf
             endif
           enddo !wspc
         endif !intl
       enddo !bmed
C
      return
      end
C
************************************************************************
      subroutine olsextr(econf,erec,nstr,nmax,nactm,chc,e1,test,isympv,
     $isympo,ita,earec,v,norm)
************************************************************************
* Extrapolate CI vector by 2x2 matrix                                  *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,nstr,isympv,isympo,ita,earec,n,i,k,nn,m
      integer iactv,iacto,iactva,iactvb,iactoa,iactob
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      real*8 a1,a2,chc(2,2),e1,sum,test,v(*),norm,norm2,c0,denom
      logical log
       if(nit.eq.1) then
C Calculate new CI energy and save sigma vector
        call hmat(econf,nmax,ecc,tfile,scrfile1,0,0,nactmax)
        call savevec(scrfile1,errfile,trecmax,0,0)
        test=1.d0
       else
C Build CHC matrix
        call hmat(econf,nmax,chc(1,2),tfile,scrfile1,0,0,nactmax)
         if(eomroute) then
          call hmat(econf,nmax,chc(2,1),errfile,diisfile,0,0,nactmax)
         else
          chc(2,1)=chc(1,2)
         endif
        call hmat(econf,nmax,chc(2,2),diisfile,scrfile1,0,0,nactmax)
C Diagonalize CHC matrix
        sum=chc(1,1)+chc(2,2)
        e1=sum**2-4.d0*(chc(1,1)*chc(2,2)-chc(1,2)*chc(2,1))
         if(e1.lt.0.d0) then
          write(iout,*) 'Fatal error in matrix diagonalization'
          call mrccend(1)
         endif
        ecc=(sum-dsqrt(e1))*0.5d0
        a1=1.d0
        a2=chc(2,1)/(ecc-chc(2,2))
C Normalization of the corresponding eigenvector
        sum=dsqrt(a1**2+a2**2)
        a1=a1/sum
        a2=a2/sum
        test=dabs(a2)
C Build new C and HC vector
        call lincomb(tfile,diisfile,tfile,a1,a2,trecmax)
        call lincomb(errfile,scrfile1,errfile,a1,a2,trecmax)
      call symmetrize(econf,erec,nstr,nmax,nir,isympv, !szemet
     $isympo,ita,earec,v,tfile,nactmax,isym)                !szemet
      call symmetrize(econf,erec,nstr,nmax,nir,isympv, !szemet
     $isympo,ita,earec,v,errfile,nactmax,isym)              !szemet
       endif
C Calculate residual vector and residual norm
      n=0
      norm2=0.d0
      e1=0.d0
       do i=0,op
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             do i1=0,i
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  nn=econf(iactva,iactvb,iactoa,iactob,i1,i)
                   if(nn.gt.0) then
                    m=ibufln
                     do k=1,nn
                       if(m.eq.ibufln) then
                        m=0
                        n=n+1
                        read(tfile,rec=n) ibuf
                        read(errfile,rec=n) ibuf1
                        read(mpfile,rec=n) ibuf2
                       endif
                      m=m+1
                      c0=ibuf(m)
                      sum=ibuf1(m)-ecc*c0
                      norm=norm+sum*sum
                      denom=ibuf2(m)-ecc
                       if(nit.eq.1.and.dabs(denom).lt.1d-9) 
     $denom=1.0d20
                      norm2=norm2+c0*c0/denom
                      sum=sum/denom
                      e1=e1+sum*c0
                      v(k)=sum
                     enddo
                    call putlst(scrfile1,
     $erec(iactva,iactvb,iactoa,iactob,i1,i),v(1),nn)
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
      e1=e1/norm2
C Calculate correction vector
      n=0
      norm2=0.d0
       do i=0,op
         do iactv=max(0,i-mrop),min(nactv,i)
           do iacto=max(0,i-mrop),min(nacto,i)
             do i1=0,i
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  nn=econf(iactva,iactvb,iactoa,iactob,i1,i)
                   if(nn.gt.0) then
                    m=ibufln
                     do k=1,nn
                       if(m.eq.ibufln) then
                        m=0
                        n=n+1
                        read(tfile,rec=n) ibuf
                        read(scrfile1,rec=n) ibuf1
                        read(mpfile,rec=n) ibuf2
                       endif
                      m=m+1
                      c0=ibuf(m)
                      denom=ibuf2(m)-ecc
                       if(nit.eq.1.and.dabs(denom).lt.1d-9) 
     $denom=1.0d20
                      c0=-(ibuf1(m)-e1*c0/denom)
                      norm2=norm2+c0*c0
                      v(k)=c0
                     enddo
                    call putlst(scrfile1,
     $erec(iactva,iactvb,iactoa,iactob,i1,i),v(1),nn)
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
      norm2=dsqrt(norm2)
       if(norm2.lt.tol) then
        norm=0.d0
        return
       endif
       if(eomroute) then
        call normate(norm2,scrfile1,diisfile)
       else
        ecc=ecc+eref
        call schmidt(econf,nmax,scrfile1,diisfile,log)
       endif
      call symmetrize(econf,erec,nstr,nmax,nir,isympv,  !szemet
     $isympo,ita,earec,v,diisfile,nactmax,isym)
C
      return
      end
C
************************************************************************
      subroutine conini(trec,nstr,nmax,icmem,nvintnew1,nointnew1,
     $nvirtnew1,noccnew1,nvintold1,nointold1,nvirtold1,noccold1,namp1,
     $isig11,file1,irec1,file2,irec2,iadd,iaddo,ladd,v,isave,intrec,
     $isympv,isympo,nnir,nconf,ita,tarec,iwa,isa,isw,iwan,file3,wspc1,
     $wspc2,wspca,wsmax,nvintnewact,nointnewact,nvirtnewact,noccnewact,
     $nvintoldact,nointoldact,nvirtoldact,noccoldact,nactm,earec,erec,
     $econf,itypa,itypb,nnewsym,noldsym,ilev,ioffs,scspe)
************************************************************************
* This subroutine initializes variables for contractions and performs  *
* transpositions if it is necessary                                    *
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nnir,nactm,i,j,k,m,iamprec,ii,irec3,ilev,nn,ioffs
      integer nstr(nnir,0:nactm,0:nmax,4),isa(*),n1,n2,n3,n4,nmem,wsmax
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),file3
      integer icmem(nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,4),inewadd
      integer nvintnew1,nointnew1,nvirtnew1,noccnew1,nvintold1,nointold1
      integer nvirtold1,noccold1,namp1,isig11,isig12,iadda(0:wsmax)
      integer file1,file2,irec1,irec2,ircold,ircnew,isave,intrec,nsyma
      integer iadd(0:1),ntoldlen,namplen,ia1,ia2,ntoldleno,file4
      integer nvintoldal,nvintoldbe,nsymw,nointoldal,nointoldbe,isw(*)
      integer nvirtoldbelen,noccoldbelen,incsum(nnir),incold(nnir)
      integer nsumvirtallen,nsumvirtbelen,nsumoccallen,nsumoccbelen,jj
      integer nvirtnewbelen,noccnewbelen,nampvirtlen,kk,ir1,isymi,isyma
      integer nampocclen,ntampvirtal,ntampvirtbe,ntampoccal,ntampoccbe
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer ira,nvirtnewsym,noccnewsym,irav,nvirtnewsyma,nvirtnewsymb
      integer irao,noccnewsyma,noccnewsymb,nsumsym,ntampsym,noldsym
      integer ntampsymv,ntampsymo,irtv,ntampsymva,ntampsymvb,noccoldlen
      integer nvirtoldsyma,nvirtoldsymb,nvirtoldsym,irto,itypa,itypb
      integer ntampsymoa,ntampsymob,noccoldsyma,irt,nvirtoldlen
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer ita(nnir,nnir,nnir,nnir),noccoldsymb,noccoldsym,ntnewlen
      integer iwa(nnir,nnir,nnir,nnir,nnir,nnir),incnew(nnir),ioldadd
      integer iwan(nnir,nnir,nnir,nnir,nnir),nampsym,j1,j2,j3,j4,n
      integer wspc1(0:1),wspc2(0:1),wspca(0:1),iw,iaddo(0:1),nnewsym
      integer nvintnewact,nointnewact,nvirtnewact,noccnewact
      integer nvintoldact,nointoldact,nvirtoldact,noccoldact
      integer nvintoldalact,nointoldalact,nvintoldbeact,nointoldbeact
      integer nvirtoldalact,noccoldalact,nvirtoldbeact,noccoldbeact
      integer nampvirtactmax,nampoccactmax,nampvirtactmin,nampoccactmin
      integer ntampvirtact,ntampoccact,nsumvirtact,nsumoccact
      integer nampvirtact,nampoccact,nampvirtalact,nampvirtbeact
      integer nampoccalact,nampoccbeact,nsumvirtalact,nsumvirtbeact
      integer ntampvirtalact,ntampvirtbeact,nvintnewalact,nvintnewbeact
      integer nvirtnewalact,nvirtnewbeact,noccnewalact,noccnewbeact
      integer nsumoccalact,ntampoccalact,nsumoccbeact,ntampoccbeact
      integer earec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nointnewalact,nointnewbeact,isgnlt,nvirtnewallen
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nsumvirtal,nsumvirtbe,nsumoccal,nsumoccbe,xyzomp
      integer nampvirtal,nampvirtbe,nampoccal,nampoccbe
      integer nvintnewal,nvintnewbe,nointnewal,nointnewbe
      integer nvirtnewal,nvirtnewbe,noccnewal,noccnewbe
      integer nsumvirt,nsumocc,nvirtoldal,noccoldal,nvirtoldbe,noccoldbe
c
      integer nvintnew,nointnew,nintnew,nvirtnew,noccnew,nvintold
      integer nointold,nintold,nvirtold,noccold,l
c
      real*8 v(*),scspe
      logical log,lcalc,lcalcn,lcalcs,lcalcsn,ladd,let
c      write(6,*) 'conini'
c      write(6,*) '@    ',nvintnew1,
c    $nointnew1,nvirtnew1,noccnew1,nvintold1,nointold1,nvirtold1,
c    $noccold1,namp1,'        ',file1,file2,file3
C Initialize variables
#if defined (OMP)
       xyzomp=xyzsiz1
#else
       xyzomp=1
#endif
       if(isave.eq.2)  call ifillzero(iadda,wsmax+1)
      nvintnew=nvintnew1
      nointnew=nointnew1
      nintnew=nvintnew+nointnew
      nvirtnew=nvirtnew1
      noccnew=noccnew1
C
      nvintold=nvintold1
      nointold=nointold1
      nintold=nvintold+nointold
      nvirtold=nvirtold1
      noccold=noccold1
C
      let=leftroute.and.(namp1.gt.0.or.namp1.lt.-iimed-op).and.
     $(itypb.eq.1.or.itypb.eq.4).and.(itypa.eq.1.or.itypa.eq.4)
      lcalc=((calc.ne.1.or.(calc.eq.1.and.nintnew.eq.0))
     $.and.(.not.let) !(let.and.nvirtnew+noccnew.eq.0))
     $.and.multip.ne.2.and.nal.eq.nbe.and.nactva.eq.nactvb.and.
     $nactoa.eq.nactob.and.rhf)
c szemet eleje
c     lcalc=.false.
c szemet vege
      lcalcn=(.not.lcalc)
C
      isgnlt=1
       if(let) isgnlt=-1
      namp=iabs(namp1)
      file4=file3
      irec3=0
       if(ptroute) then
         if(eomroute.and.namp1.lt.0) file4=ptfile
         if(leftroute) then
           if(namp1.gt.0) then
            file4=ampfile
           else if(namp1.ge.-op) then
            file4=lamfile
           else
            file4=ptfile
            namp=namp-iimed-op
           endif
         endif
       else
         if((eomroute.or.leftroute).and.namp1.gt.0) then
           if(qcc.eq.1) then
            file4=ampfile
           else
            file4=cfile
           endif
         endif
         if((eomgrad.and.l3route).and.namp1.lt.-iimed-op) then
          namp=iabs(namp1)-iimed-op
          irec3=(iroot-1)*trecmax
          file4=cfile
         endif
       endif
      nampsym=mult(nnewsym,noldsym)
C
c     write(6,*) 'nampsym',nnewsym,nampsym,noldsym
      nsumvirt=nvintold-nvintnew
      nsumocc=nointold-nointnew
      nsum=nsumvirt+nsumocc
      ntampvirtact=iabs(nvirtnewact-nvirtoldact)
      ntampoccact=iabs(noccnewact-noccoldact)
      nampvirtactmax=min(nactv,nsumvirt+ntampvirtact)
      nampoccactmax=min(nacto,nsumocc+ntampoccact)
      nampvirtactmin=max(namp-mrop,ntampvirtact+nvintoldact-nvintnewact)
      nampoccactmin=max(namp-mrop,ntampoccact+nointoldact-nointnewact)
       if(lc3) then !c3
        nampvirtactmax=nampvirtactmin
        nampoccactmax=nampoccactmin
       endif
C Loop over spin cases of intermediates
       do iw=1,wspc2(0)
        nvintoldal=wspc2((iw-1)*12+1)
        nointoldal=wspc2((iw-1)*12+2)
        nvirtoldal=wspc2((iw-1)*12+3)
        noccoldal=wspc2((iw-1)*12+4)
        nvintoldalact=wspc2((iw-1)*12+5)
        nointoldalact=wspc2((iw-1)*12+6)
        nvintoldbeact=wspc2((iw-1)*12+7)
        nointoldbeact=wspc2((iw-1)*12+8)
        nvirtoldalact=wspc2((iw-1)*12+9)
        noccoldalact=wspc2((iw-1)*12+10)
        nvirtoldbeact=nvirtoldact-nvirtoldalact
        noccoldbeact=noccoldact-noccoldalact
        ircold=wspc2((iw-1)*12+11)
        ntoldlen=wspc2((iw-1)*12+12)
        ntoldleno=ntoldlen
        nvintoldbe=nvintold-nvintoldal
        nointoldbe=nointold-nointoldal
        nvirtoldbe=nvirtold-nvirtoldal
        noccoldbe=noccold-noccoldal
         if(ladd) then
          ia1=1
         else
      call fwspc(iaddo,nvintoldal,nointoldal,nvirtoldal,noccoldal,
     $nvintoldalact,nointoldalact,nvintoldbeact,nointoldbeact,
     $nvirtoldalact,noccoldalact,ia1,ia2)
         endif
c      if(rohfdiag.gt.0) write(6,*) 'con',
c    $nvintoldal,nointoldal,nvirtoldal,noccoldal,
c    $nvintoldalact,nointoldalact,nvintoldbeact,nointoldbeact,
c    $nvirtoldalact,noccoldalact,ia1
         if(ia1.gt.0) then
         do nampvirtal=0,namp
          nampvirtbe=namp-nampvirtal
          nampoccal=nampvirtal
          nampoccbe=namp-nampoccal
             do nampvirtact=nampvirtactmin,nampvirtactmax
              nsumvirtact=nampvirtact-ntampvirtact
               do nampoccact=nampoccactmin,nampoccactmax
                nsumoccact=nampoccact-ntampoccact
                 do nampvirtalact=max(0,nampvirtact-nactvb),
     $min(nactva,nampvirtact,nampvirtal)
                  nampvirtbeact=nampvirtact-nampvirtalact
                   do nampoccalact=max(0,nampoccact-nactob),
     $min(nactoa,nampoccact,nampoccal)
                    nampoccbeact=nampoccact-nampoccalact
       if((namp1.gt.0.or.(leftroute.and.(iroot.eq.1.or.(zroute.and.
     $(.not.osc)).or.(l3route.and.osc.and.namp1.lt.0.and.namp1.ge.-op))
     $.and.(.not.l1route).and.namp1.ge.-op)).and.(calc.ne.0
     $.or.t1route.or.(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy1)))then
        iamprec=trec(nampvirtalact,nampvirtbeact,
     $nampoccalact,nampoccbeact,nampvirtal,namp)
      namplen=nconf(nampvirtalact,nampvirtbeact,nampoccalact,
     $nampoccbeact,nampvirtal,namp)
c     write(6,*) 't iamprec',iamprec
       else
        iamprec=erec(nampvirtalact,nampvirtbeact,
     $nampoccalact,nampoccbeact,nampvirtal,namp)
      namplen=econf(nampvirtalact,nampvirtbeact,nampoccalact,
     $nampoccbeact,nampvirtal,namp)
c     write(6,*) 'e iamprec',iamprec
       endif
                     if(iamprec.gt.0.and.
     $(lcalcn.or.nampvirtal.lt.nampvirtbe.or.(nampvirtal.eq.nampvirtbe
     $.and.nampvirtalact.lt.nampvirtbeact).or.(nampvirtal.eq.nampvirtbe
     $.and.nampvirtalact.eq.nampvirtbeact.and.nampoccalact.le.
     $nampoccbeact))) then
       do nsumvirtal=max(0,isign(nvirtoldal+nampvirtal,isgnlt)-minvirtal
     $,nsumvirt-min(nvintoldbe,nampvirtbe)),
     $min(nvintoldal,nsumvirt,nampvirtal,
     $minvirtbe-isign(nvirtoldbe+nampvirtbe,isgnlt)+nsumvirt)
        ntampvirtal=nampvirtal-nsumvirtal
        nsumvirtbe=nsumvirt-nsumvirtal
        ntampvirtbe=nampvirtbe-nsumvirtbe
        nvintnewal=nvintoldal-nsumvirtal
        nvintnewbe=nvintoldbe-nsumvirtbe
        nvirtnewal=nvirtoldal+isign(ntampvirtal,isgnlt)
        nvirtnewbe=nvirtoldbe+isign(ntampvirtbe,isgnlt)
         do nsumvirtalact=max(0,nsumvirtact-min(nsumvirtbe,nvintoldbeact
     $,nampvirtbeact),nvintoldalact-nvintnewal),min(nsumvirtal,
     $nvintoldalact,nsumvirtact,nampvirtalact,nactva,
     $nvintnewbe-nvintoldbeact+nsumvirtact)
          nsumvirtbeact=nsumvirtact-nsumvirtalact
          ntampvirtalact=nampvirtalact-nsumvirtalact
          ntampvirtbeact=nampvirtbeact-nsumvirtbeact
          nvintnewalact=nvintoldalact-nsumvirtalact
          nvintnewbeact=nvintoldbeact-nsumvirtbeact
          nvirtnewalact=nvirtoldalact+isign(ntampvirtalact,isgnlt)
          nvirtnewbeact=nvirtoldbeact+isign(ntampvirtbeact,isgnlt)
         if(nvirtnewbe.ge.0.and.nvirtnewbeact.ge.0.and.
     $nvintnewalact.le.nvintnewal.and.nvintnewbeact.le.nvintnewbe.and.
     $nvirtnewalact.le.nvirtnewal.and.nvirtnewbeact.le.nvirtnewbe.and.
     $ntampvirtalact.le.ntampvirtal.and.ntampvirtbeact.le.ntampvirtbe) 
     $then
           do nsumoccal=max(0,isign(noccoldal+nampoccal,isgnlt)-minoccal
     $,nsumocc-min(nointoldbe,nampoccbe)),
     $min(nointoldal,nsumocc,nampoccal,
     $minoccbe-isign(noccoldbe+nampoccbe,isgnlt)+nsumocc)
            ntampoccal=nampoccal-nsumoccal
            nsumoccbe=nsumocc-nsumoccal
            ntampoccbe=nampoccbe-nsumoccbe
            nointnewal=nointoldal-nsumoccal
            nointnewbe=nointoldbe-nsumoccbe
            noccnewal=noccoldal+isign(ntampoccal,isgnlt)
            noccnewbe=noccoldbe+isign(ntampoccbe,isgnlt)
             do nsumoccalact=max(0,nampoccalact-ntampoccal,
     $nsumoccact-min(nsumoccbe,nointoldbeact,nampoccbeact),
     $nointoldalact-nointnewal),min(nsumoccal,nointoldalact,nsumoccact,
     $nampoccalact,nactoa,ntampoccbe-nampoccbeact+nsumoccact,
     $nointnewbe-nointoldbeact+nsumoccact)
              nsumoccbeact=nsumoccact-nsumoccalact
              ntampoccalact=nampoccalact-nsumoccalact
              ntampoccbeact=nampoccbeact-nsumoccbeact
              nointnewalact=nointoldalact-nsumoccalact
              nointnewbeact=nointoldbeact-nsumoccbeact
              noccnewalact=noccoldalact+isign(ntampoccalact,isgnlt)
              noccnewbeact=noccoldbeact+isign(ntampoccbeact,isgnlt)
      call fwspc(wspc1,nvintnewal,nointnewal,nvirtnewal,noccnewal,
     $nvintnewalact,nointnewalact,nvintnewbeact,nointnewbeact,
     $nvirtnewalact,noccnewalact,ircnew,ntnewlen)
C
             if(ircnew.gt.0.and.noccnewbe.ge.0.and.noccnewbeact.ge.0
     $.and.(lcalcn.or.nampvirtal.ne.nampvirtbe.or.nampvirtalact.ne.
     $nampvirtbeact.or.nampoccalact.ne.nampoccbeact.or.
     $nvirtnewal.lt.nvirtnewbe.or.(nvirtnewal.eq.nvirtnewbe.and.
     $nvirtnewalact.lt.nvirtnewbeact).or.(nvirtnewal.eq.nvirtnewbe.and.
     $nvirtnewalact.eq.nvirtnewbeact.and.noccnewalact.le.noccnewbeact))
     $) then
      lcalcs=lcalc.and.nampvirtal.eq.nampvirtbe.and.nampvirtalact.eq.
     $nampvirtbeact.and.nampoccalact.eq.nampoccbeact.and.
     $nvirtnewal.eq.nvirtnewbe.and.nvirtnewalact.eq.nvirtnewbeact.and.
     $noccnewalact.eq.noccnewbeact
c     lcalcs=.false. !szemet
      lcalcsn=.not.lcalcs
C Transposition of old intermediate
      call transposition(nmax,nnir,nactm,nstr,icmem,isympv,isympo,iwa,
     $iwan,v,isig12,ntoldlen,ntoldleno,namp1,file2,irec2,ircold,ita,
     $ntnewlen,incnew,noldsym,nnewsym,nvintoldal,nvintoldbe,nointoldal,
     $nointoldbe,nvintoldalact,nvintoldbeact,nointoldalact,nointoldbeact
     $,nvintnewalact,nvintnewbeact,nointnewalact,nointnewbeact,
     $nsumvirtalact,nsumvirtbeact,nsumoccalact,nsumoccbeact,
     $nvirtoldalact,nvirtoldbeact,noccoldalact,noccoldbeact,
     $nvirtnewalact,nvirtnewbeact,noccnewalact,noccnewbeact,incsum,
     $.true.,iwa,incold,nsumvirtal,nsumvirtbe,nsumoccal,nsumoccbe,
     $nvintnewal,nvintnewbe,nointnewal,nointnewbe,nvirtnewal,nvirtnewbe,
     $noccnewal,noccnewbe,nintnew,nintold,nvintold,nointold,nvirtoldal,
     $nvirtoldbe,noccoldal,noccoldbe,.true.,.not.let,0,i,i,0,ioffs,
     $.false.,xyzomp)
C Addresses of summation indices
       do ir=1,nir
        call tlength(nmax,nstr,nnir,isympv,isympo,nactm,jj,ir,
     $nsumvirtalact,nsumvirtbeact,nsumvirtal,nsumvirtbe,
     $nsumoccalact,nsumoccbeact,nsumoccal,nsumoccbe,isa,1,0,dsympair)
       enddo
c      if(rohfdiag.gt.0) write(6,*) 'ol2',(v(xyzomp*ntnewlen+k),k=1,ntoldlen)
C Read amplitudes
       if((namp1.gt.0.or.(leftroute.and.(iroot.eq.1.or.(zroute.and.
     $(.not.osc)).or.(l3route.and.osc.and.namp1.lt.0.and.namp1.ge.-op))
     $.and.(.not.l1route).and.namp1.ge.-op)).and.(calc.ne.0
     $.or.t1route.or.(calc.eq.0.and.isy1.ne.isy2.and.isym.eq.isy1)))then
        read(tafile,rec=tarec(nampvirtalact,nampvirtbeact,nampoccalact,
     $nampoccbeact,nampvirtal,namp)) ita
       else
        read(tafile,rec=earec(nampvirtalact,nampvirtbeact,nampoccalact,
     $nampoccbeact,nampvirtal,namp)) ita
       endif
      call getlst(file4,irec3+iamprec,v(xyzomp*ntnewlen+ntoldlen+1),
     $namplen)
c     write(6,*) 'file4',irec3,file4,iamprec
c     write(6,*) 'amp',(v(xyzomp*ntnewlen+ntoldlen+k),k=1,namplen)
c     if(rohfdiag.gt.0) write(6,*) 'amp',
c    $(v(xyzomp*ntnewlen+ntoldlen+k),k=1,namplen)
      nmem=xyzomp*ntnewlen+ntoldlen+namplen+1
       if(let) then
C Loop over symmetry cases of cluster amplitudes
       do ir=1,nir
        nsumsym=isympair(nampsym,ir,1)
        ntampsym=isympair(nampsym,ir,2)
         do irt=1,nir
          ntampsymv=isympair(ntampsym,irt,1)
          ntampsymo=isympair(ntampsym,irt,2)
           do irtv=1,isympv(0,ntampsymv,ntampvirtalact,ntampvirtbeact,
     $ntampvirtal,ntampvirtbe,1)
            ntampsymva=isympv(irtv,ntampsymv,ntampvirtalact,
     $ntampvirtbeact,ntampvirtal,ntampvirtbe,1)
            ntampsymvb=isympv(irtv,ntampsymv,ntampvirtalact,
     $ntampvirtbeact,ntampvirtal,ntampvirtbe,2)
             do irto=1,isympo(0,ntampsymo,ntampoccalact,ntampoccbeact,
     $ntampoccal,ntampoccbe,1)
              ntampsymoa=isympo(irto,ntampsymo,ntampoccalact,
     $ntampoccbeact,ntampoccal,ntampoccbe,1)
              ntampsymob=isympo(irto,ntampsymo,ntampoccalact,
     $ntampoccbeact,ntampoccal,ntampoccbe,2)
C Loop over symmetry cases of summation indices
      call sumsym(nstr,nmax,icmem,isympv,isympo,nnir,ita,nactm,isa,
     $nsumsym,nsyma,nsumlen,nsumvirtalact,nsumvirtbeact,nsumvirtallen,
     $nsumvirtbelen,ntampsymva,ntampsymvb,nampvirtalact,nampvirtbeact,
     $nampvirtlen,nsumoccalact,nsumoccbeact,nsumoccallen,nsumoccbelen,
     $ntampsymoa,ntampsymob,nampoccalact,nampoccbeact,nampocclen,
     $xyzomp*ntnewlen,ntoldlen,ntampvirtal,ntampvirtalact,ntampvirtbe,
     $ntampvirtbeact,ntampoccal,ntampoccalact,ntampoccbe,ntampoccbeact,1
     $,nsumvirtal,nsumvirtbe,nsumoccal,nsumoccbe,
     $nampvirtal,nampvirtbe,nampoccal,nampoccbe)
      nsumlen=incsum(nsumsym)
               if(nsumlen.gt.0) then
C Loop over symmetry cases of new intermediate
      nsymw=0
      ii=0
       do ir1=1,nir
      isymi=isympair(nnewsym,ir1,1)
      isyma=isympair(nnewsym,ir1,2)
         do ira=1,nir
      nvirtnewsym=isympair(isyma,ira,1)
      noccnewsym=isympair(isyma,ira,2)
           do irav=1,isympv(0,nvirtnewsym,nvirtnewalact,nvirtnewbeact,
     $nvirtnewal,nvirtnewbe,1)
      nvirtnewsyma=isympv(irav,nvirtnewsym,nvirtnewalact,nvirtnewbeact,
     $nvirtnewal,nvirtnewbe,1)
      nvirtnewallen=nstr(nvirtnewsyma,nvirtnewalact,nvirtnewal,1)
      nvirtnewsymb=isympv(irav,nvirtnewsym,nvirtnewalact,nvirtnewbeact,
     $nvirtnewal,nvirtnewbe,2)
      nvirtnewbelen=nstr(nvirtnewsymb,nvirtnewbeact,nvirtnewbe,2)
      nvirtnewlen=nvirtnewallen*nvirtnewbelen
      nvirtoldsyma=mult(nvirtnewsyma,ntampsymva)
      nvirtoldallen=nstr(nvirtoldsyma,nvirtoldalact,nvirtoldal,1)
      nvirtoldsymb=mult(nvirtnewsymb,ntampsymvb)
      nvirtoldbelen=nstr(nvirtoldsymb,nvirtoldbeact,nvirtoldbe,2)
      nvirtoldsym=mult(nvirtoldsyma,nvirtoldsymb)
      nvirtoldlen=nvirtoldallen*nvirtoldbelen
             do irao=1,isympo(0,noccnewsym,noccnewalact,noccnewbeact,
     $noccnewal,noccnewbe,1)
      noccnewsyma=isympo(irao,noccnewsym,noccnewalact,noccnewbeact,
     $noccnewal,noccnewbe,1)
      noccnewallen=nstr(noccnewsyma,noccnewalact,noccnewal,3)
      noccnewsymb=isympo(irao,noccnewsym,noccnewalact,noccnewbeact,
     $noccnewal,noccnewbe,2)
      noccnewbelen=nstr(noccnewsymb,noccnewbeact,noccnewbe,4)
      noccnewlen=noccnewallen*noccnewbelen
      noccoldsyma=mult(noccnewsyma,ntampsymoa)
      noccoldallen=nstr(noccoldsyma,noccoldalact,noccoldal,3)
      noccoldsymb=mult(noccnewsymb,ntampsymob)
      noccoldbelen=nstr(noccoldsymb,noccoldbeact,noccoldbe,4)
      noccoldsym=mult(noccoldsyma,noccoldsymb)
      noccoldlen=noccoldallen*noccoldbelen
C
      nintnewlen=incnew(isymi)
      nintoldlen=nintnewlen*nsumlen
               if(nintnewlen.gt.0.and.nintoldlen.gt.0.and.(lcalcsn.or.
     $nvirtnewsyma.lt.nvirtnewsymb.or.(nvirtnewsyma.eq.nvirtnewsymb.and.
     $noccnewsyma.le.noccnewsymb))) then
      nsymw=nsymw+1
      ioldadd=xyzomp*ntnewlen+iwa(isymi,nsumsym,nvirtoldsyma,
     $nvirtoldsymb,noccoldsyma,noccoldsymb)
      inewadd=iwan(isymi,nvirtnewsyma,nvirtnewsymb,noccnewsyma,
     $noccnewsymb)
      ii=ii+1
      isw(ii)=inewadd
      ii=ii+1
      isw(ii)=noccnewallen*nvirtnewbelen*nvirtnewallen*nintnewlen
      ii=ii+1
      isw(ii)=nvirtnewbelen*nvirtnewallen*nintnewlen
      ii=ii+1
      isw(ii)=nvirtnewallen*nintnewlen
      ii=ii+1
      isw(ii)=nintnewlen
      ii=ii+1
      isw(ii)=ioldadd
      ii=ii+1
      isw(ii)=noccoldallen*nvirtoldbelen*nvirtoldallen*nintoldlen
      ii=ii+1
      isw(ii)=nvirtoldbelen*nvirtoldallen*nintoldlen
      ii=ii+1
      isw(ii)=nvirtoldallen*nintoldlen
      ii=ii+1
      isw(ii)=nintoldlen
      ii=ii+1
       if(let) then
        isw(ii)=icmem(nvirtnewsyma,ntampsymva,nvirtnewalact,
     $ntampvirtalact,nvirtnewal,ntampvirtal,1)-1
        ii=ii+1
        isw(ii)=icmem(nvirtnewsymb,ntampsymvb,nvirtnewbeact,
     $ntampvirtbeact,nvirtnewbe,ntampvirtbe,2)-1
        ii=ii+1
        isw(ii)=icmem(noccnewsyma,ntampsymoa,noccnewalact,ntampoccalact,
     $noccnewal,ntampoccal,3)-1
        ii=ii+1
        isw(ii)=icmem(noccnewsymb,ntampsymob,noccnewbeact,ntampoccbeact,
     $noccnewbe,ntampoccbe,4)-1
       else
        isw(ii)=icmem(nvirtoldsyma,ntampsymva,nvirtoldalact,
     $ntampvirtalact,nvirtoldal,ntampvirtal,1)-1
        ii=ii+1
        isw(ii)=icmem(nvirtoldsymb,ntampsymvb,nvirtoldbeact,
     $ntampvirtbeact,nvirtoldbe,ntampvirtbe,2)-1
        ii=ii+1
        isw(ii)=icmem(noccoldsyma,ntampsymoa,noccoldalact,ntampoccalact,
     $noccoldal,ntampoccal,3)-1
        ii=ii+1
        isw(ii)=icmem(noccoldsymb,ntampsymob,noccoldbeact,ntampoccbeact,
     $noccoldbe,ntampoccbe,4)-1
       endif
               endif
             enddo
           enddo
         enddo
       enddo 
C Contraction
                 if(ilev.eq.1) then
                  call contract31(v,v,v(nmem),isa,isw,
     $nstr(ntampsymva,ntampvirtalact,ntampvirtal,1),
     $nstr(ntampsymvb,ntampvirtbeact,ntampvirtbe,2),
     $nstr(ntampsymoa,ntampoccalact,ntampoccal,3),
     $nstr(ntampsymob,ntampoccbeact,ntampoccbe,4),nsyma,nsymw,
     $nsumlen,ntnewlen)
                 else
                  call contract3(v,v,v(nmem),isa,isw,
     $nstr(ntampsymva,ntampvirtalact,ntampvirtal,1),
     $nstr(ntampsymvb,ntampvirtbeact,ntampvirtbe,2),
     $nstr(ntampsymoa,ntampoccalact,ntampoccal,3),
     $nstr(ntampsymob,ntampoccbeact,ntampoccbe,4),nsyma,nsymw,
     $nsumlen,ntnewlen)
                 endif
               endif
             enddo
           enddo
         enddo
       enddo
#if defined (OMP)
      call ompred(v,ntnewlen)
#endif
       else
C Contraction
        nn=1
#if defined (OMP)
        nn=0
         do ii=1,nir
          nn=max(nn,incsum(ii))
         enddo
#endif
         if(nir.gt.1) then
           if(nintnew.eq.0) then
          call contract12(v,v(xyzomp*ntnewlen+1),
     $v(xyzomp*ntnewlen+ntoldlen),v(nmem),
     $isa,isw,nstr(1,ntampvirtalact,ntampvirtal,1),
     $nstr(1,ntampvirtbeact,ntampvirtbe,2),
     $nstr(1,ntampoccalact,ntampoccal,3),
     $nstr(1,ntampoccbeact,ntampoccbe,4),
     $icmem(1,1,nsumvirtalact,ntampvirtalact,nsumvirtal,ntampvirtal,1),
     $icmem(1,1,nsumvirtbeact,ntampvirtbeact,nsumvirtbe,ntampvirtbe,2),
     $icmem(1,1,nsumoccalact,ntampoccalact,nsumoccal,ntampoccal,3),
     $icmem(1,1,nsumoccbeact,ntampoccbeact,nsumoccbe,ntampoccbe,4),
     $nstr(1,nsumvirtalact,nsumvirtal,1),
     $nstr(1,nsumvirtbeact,nsumvirtbe,2),
     $nstr(1,nsumoccalact,nsumoccal,3),
     $nstr(1,nampvirtalact,nampvirtal,1),
     $nstr(1,nampvirtbeact,nampvirtbe,2),
     $nstr(1,nampoccalact,nampoccal,3),nampsym,
     $isympv(0,1,nsumvirtalact,nsumvirtbeact,nsumvirtal,nsumvirtbe,1),
     $isympv(0,1,nsumvirtalact,nsumvirtbeact,nsumvirtal,nsumvirtbe,2),
     $icmem(1,1,nvirtoldalact,ntampvirtalact,nvirtoldal,ntampvirtal,1),
     $icmem(1,1,nvirtoldbeact,ntampvirtbeact,nvirtoldbe,ntampvirtbe,2),
     $icmem(1,1,noccoldalact,ntampoccalact,noccoldal,ntampoccal,3),
     $icmem(1,1,noccoldbeact,ntampoccbeact,noccoldbe,ntampoccbe,4),
     $nstr(1,nvirtnewalact,nvirtnewal,1),
     $nstr(1,nvirtnewbeact,nvirtnewbe,2),
     $nstr(1,noccnewalact,noccnewal,3),
     $nstr(1,nvirtoldalact,nvirtoldal,1),
     $nstr(1,nvirtoldbeact,nvirtoldbe,2),
     $nstr(1,noccoldalact,noccoldal,3),
     $nnir,ita,nnewsym,incnew,iwa,iwan,incsum,lcalcsn,nn,ntnewlen)
           else
          call contract11(v,v(xyzomp*ntnewlen+1),
     $v(xyzomp*ntnewlen+ntoldlen),v(nmem),
     $isa,isw,nstr(1,ntampvirtalact,ntampvirtal,1),
     $nstr(1,ntampvirtbeact,ntampvirtbe,2),
     $nstr(1,ntampoccalact,ntampoccal,3),
     $nstr(1,ntampoccbeact,ntampoccbe,4),
     $icmem(1,1,nsumvirtalact,ntampvirtalact,nsumvirtal,ntampvirtal,1),
     $icmem(1,1,nsumvirtbeact,ntampvirtbeact,nsumvirtbe,ntampvirtbe,2),
     $icmem(1,1,nsumoccalact,ntampoccalact,nsumoccal,ntampoccal,3),
     $icmem(1,1,nsumoccbeact,ntampoccbeact,nsumoccbe,ntampoccbe,4),
     $nstr(1,nsumvirtalact,nsumvirtal,1),
     $nstr(1,nsumvirtbeact,nsumvirtbe,2),
     $nstr(1,nsumoccalact,nsumoccal,3),
     $nstr(1,nampvirtalact,nampvirtal,1),
     $nstr(1,nampvirtbeact,nampvirtbe,2),
     $nstr(1,nampoccalact,nampoccal,3),nampsym,
     $isympv(0,1,nsumvirtalact,nsumvirtbeact,nsumvirtal,nsumvirtbe,1),
     $isympv(0,1,nsumvirtalact,nsumvirtbeact,nsumvirtal,nsumvirtbe,2),
     $icmem(1,1,nvirtoldalact,ntampvirtalact,nvirtoldal,ntampvirtal,1),
     $icmem(1,1,nvirtoldbeact,ntampvirtbeact,nvirtoldbe,ntampvirtbe,2),
     $icmem(1,1,noccoldalact,ntampoccalact,noccoldal,ntampoccal,3),
     $icmem(1,1,noccoldbeact,ntampoccbeact,noccoldbe,ntampoccbe,4),
     $nstr(1,nvirtnewalact,nvirtnewal,1),
     $nstr(1,nvirtnewbeact,nvirtnewbe,2),
     $nstr(1,noccnewalact,noccnewal,3),
     $nstr(1,nvirtoldalact,nvirtoldal,1),
     $nstr(1,nvirtoldbeact,nvirtoldbe,2),
     $nstr(1,noccoldalact,noccoldal,3),
     $nnir,ita,nnewsym,incnew,iwa,iwan,incsum,nn,ntnewlen)
           endif
         else
          nvirtnewallen=nstr(1,nvirtnewalact,nvirtnewal,1)
          nvirtnewbelen=nstr(1,nvirtnewbeact,nvirtnewbe,2)
          noccnewallen=nstr(1,noccnewalact,noccnewal,3)
          noccnewbelen=nstr(1,noccnewbeact,noccnewbe,4)
          nvirtnewlen=nvirtnewallen*nvirtnewbelen
          noccnewlen=noccnewallen*noccnewbelen
          nvirtoldallen=nstr(1,nvirtoldalact,nvirtoldal,1)
          nvirtoldbelen=nstr(1,nvirtoldbeact,nvirtoldbe,2)
          noccoldallen=nstr(1,noccoldalact,noccoldal,3)
          noccoldbelen=nstr(1,noccoldbeact,noccoldbe,4)
          nvirtoldlen=nvirtoldallen*nvirtoldbelen
          noccoldlen=noccoldallen*noccoldbelen
          nampvirtlen=nstr(1,nampvirtalact,nampvirtal,1)*
     $nstr(1,nampvirtbeact,nampvirtbe,2)
          nampocclen=nstr(1,nampoccalact,nampoccal,3)*
     $nstr(1,nampoccbeact,nampoccbe,4)
          nsumvirtallen=nstr(1,nsumvirtalact,nsumvirtal,1)
          nsumvirtbelen=nstr(1,nsumvirtbeact,nsumvirtbe,2)
          nsumoccallen=nstr(1,nsumoccalact,nsumoccal,3)
          nsumoccbelen=nstr(1,nsumoccbeact,nsumoccbe,4)
          nsumlen=nsumvirtallen*nsumvirtbelen*nsumoccallen*nsumoccbelen
          nintnewlen=incnew(1)
          nintoldlen=nintnewlen*nsumlen
C
           if(nintnew.eq.0) then
            call contract02(v,nvirtnewlen,noccnewlen,
     $v(xyzomp*ntnewlen+1),nintoldlen,nvirtoldlen,noccoldlen,
     $v(xyzomp*ntnewlen+ntoldlen+1),nampvirtlen,nampocclen,v(nmem),
     $icore(icmem(1,1,nsumvirtalact,ntampvirtalact,nsumvirtal,
     $ntampvirtal,1)),icore(icmem(1,1,nsumvirtbeact,ntampvirtbeact,
     $nsumvirtbe,ntampvirtbe,2)),icore(icmem(1,1,nsumoccalact,
     $ntampoccalact,nsumoccal,ntampoccal,3)),icore(icmem(1,1,
     $nsumoccbeact,ntampoccbeact,nsumoccbe,ntampoccbe,4)),icore(icmem(1,
     $1,nvirtoldalact,ntampvirtalact,nvirtoldal,ntampvirtal,1)),
     $icore(icmem(1,1,nvirtoldbeact,ntampvirtbeact,nvirtoldbe,
     $ntampvirtbe,2)),icore(icmem(1,1,noccoldalact,ntampoccalact,
     $noccoldal,ntampoccal,3)),icore(icmem(1,1,noccoldbeact,
     $ntampoccbeact,noccoldbe,ntampoccbe,4)),
     $nsumvirtallen,nsumvirtbelen,nsumoccallen,nsumoccbelen,
     $nvirtoldallen,nvirtoldbelen,noccoldallen,noccoldbelen,
     $nstr(1,ntampvirtalact,ntampvirtal,1),
     $nstr(1,ntampvirtbeact,ntampvirtbe,2),
     $nstr(1,ntampoccalact,ntampoccal,3),
     $nstr(1,ntampoccbeact,ntampoccbe,4),
     $nstr(1,nampvirtalact,nampvirtal,1),
     $nstr(1,nampoccalact,nampoccal,3),nvirtnewallen,nsumlen,
     $noccnewallen)
           else
            call contract01(v,nintnewlen,nvirtnewlen,noccnewlen,
     $v(xyzomp*ntnewlen+1),nintoldlen,nvirtoldlen,noccoldlen,
     $v(xyzomp*ntnewlen+ntoldlen+1),nampvirtlen,nampocclen,v(nmem),
     $icore(icmem(1,1,nsumvirtalact,ntampvirtalact,nsumvirtal,
     $ntampvirtal,1)),icore(icmem(1,1,nsumvirtbeact,ntampvirtbeact,
     $nsumvirtbe,ntampvirtbe,2)),icore(icmem(1,1,nsumoccalact,
     $ntampoccalact,nsumoccal,ntampoccal,3)),icore(icmem(1,1,
     $nsumoccbeact,ntampoccbeact,nsumoccbe,ntampoccbe,4)),icore(icmem(1,
     $1,nvirtoldalact,ntampvirtalact,nvirtoldal,ntampvirtal,1)),
     $icore(icmem(1,1,nvirtoldbeact,ntampvirtbeact,nvirtoldbe,
     $ntampvirtbe,2)),icore(icmem(1,1,noccoldalact,ntampoccalact,
     $noccoldal,ntampoccal,3)),icore(icmem(1,1,noccoldbeact,
     $ntampoccbeact,noccoldbe,ntampoccbe,4)),
     $nsumvirtallen,nsumvirtbelen,nsumoccallen,nsumoccbelen,
     $nvirtoldallen,nvirtoldbelen,noccoldallen,noccoldbelen,
     $nstr(1,ntampvirtalact,ntampvirtal,1),
     $nstr(1,ntampvirtbeact,ntampvirtbe,2),
     $nstr(1,ntampoccalact,ntampoccal,3),
     $nstr(1,ntampoccbeact,ntampoccbe,4),
     $nstr(1,nampvirtalact,nampvirtal,1),
     $nstr(1,nampoccalact,nampoccal,3),nvirtnewallen,nsumlen,
     $noccnewallen)
           endif
         endif
       endif
C Transpose CI coefficients
       if(lcalcs) then
         do ir1=1,nir
      isymi=csympair(nnewsym,ir1,1)
      isyma=csympair(nnewsym,ir1,2)
           do ira=1,nir
      nvirtnewsym=isympair(isyma,ira,1)
      noccnewsym=isympair(isyma,ira,2)
             do irav=1,isympv(0,nvirtnewsym,nvirtnewalact,nvirtnewbeact,
     $nvirtnewal,nvirtnewbe,1)
      nvirtnewsyma=isympv(irav,nvirtnewsym,nvirtnewalact,nvirtnewbeact,
     $nvirtnewal,nvirtnewbe,1)
      nvirtnewallen=nstr(nvirtnewsyma,nvirtnewalact,nvirtnewal,1)
      nvirtnewsymb=isympv(irav,nvirtnewsym,nvirtnewalact,nvirtnewbeact,
     $nvirtnewal,nvirtnewbe,2)
      nvirtnewbelen=nstr(nvirtnewsymb,nvirtnewbeact,nvirtnewbe,2)
      nvirtnewlen=nvirtnewallen*nvirtnewbelen
               do irao=1,isympo(0,noccnewsym,noccnewalact,noccnewbeact,
     $noccnewal,noccnewbe,1)
      noccnewsyma=isympo(irao,noccnewsym,noccnewalact,noccnewbeact,
     $noccnewal,noccnewbe,1)
      noccnewallen=nstr(noccnewsyma,noccnewalact,noccnewal,3)
      noccnewsymb=isympo(irao,noccnewsym,noccnewalact,noccnewbeact,
     $noccnewal,noccnewbe,2)
      noccnewbelen=nstr(noccnewsymb,noccnewbeact,noccnewbe,4)
      noccnewlen=noccnewallen*noccnewbelen
                 if(nvirtnewlen*noccnewlen.gt.0.and.(
     $nvirtnewsyma.lt.nvirtnewsymb.or.(nvirtnewsyma.eq.nvirtnewsymb.and.
     $noccnewsyma.lt.noccnewsymb))) then
C
      inewadd=iwan(isymi,nvirtnewsyma,nvirtnewsymb,noccnewsyma,
     $noccnewsymb)
      ii=iwan(isymi,nvirtnewsymb,nvirtnewsyma,noccnewsymb,noccnewsyma)
      call transpcs(v(inewadd),v(ii),nvirtnewallen,nvirtnewbelen,
     $noccnewallen,noccnewbelen)
       if(multip.eq.3) call add(v(ii),v(ii),nvirtnewlen*noccnewlen,0,-1,
     $1.d0,1.d0)
                 endif
               enddo
             enddo
           enddo
         enddo
       endif
C Sign of intermediate
        if(let) then
         if(mod(nsumvirtbe*ntampvirtal+nsumoccbe*ntampoccal+
     $nvirtnewal*ntampvirtbe+noccnewal*ntampoccbe+
     $nvirtnewal*ntampvirtal+noccnewal*ntampoccal+
     $nvirtnewbe*ntampvirtbe+noccnewbe*ntampoccbe,2).ne.0)
     $isig12=-isig12
        else
         if(mod(nsumvirtbe*ntampvirtal+nsumoccbe*ntampoccal+
     $nvirtoldbe*ntampvirtal+noccoldbe*ntampoccal,2).ne.0)
     $isig12=-isig12
        endif
c     write(6,*) 'new',irec1+ircnew,isig12
c     write(6,"(4f14.8)") (v(i),i=1,ntnewlen)
C Save intermediate
      call savenew(nmem,ntnewlen,wspca,isave,iadd,nvintnewalact,
     $nointnewalact,nvintnewbeact,nointnewbeact,nvirtnewalact,
     $noccnewalact,intrec,v,iadda,isig11,isig12,irec1,ircnew,file1,
     $lcalc,nampvirtalact,nampvirtbeact,nampoccalact,nampoccbeact,
     $nvirtnewbeact,noccnewbeact,wspc1,nstr,nmax,isympv,isympo,ita,
     $earec,tarec,nampvirtal,nampvirtbe,nampoccal,nampoccbe,nvintnewal,
     $nvintnewbe,nointnewal,nointnewbe,nvirtnewal,nvirtnewbe,noccnewal,
     $noccnewbe,scspe)
             endif
             enddo
           enddo
         endif
         enddo
       enddo
             endif
           enddo
         enddo
               enddo
             enddo
         enddo
         endif !ia1.gt.0
       enddo !iw
       if(isave.eq.2) then
        call imedret(file1,irec1,wspc1,intfile,intrec,isig11,iadd,v,
     $nmax,2,1,1.d0,wspc1,wspca,nactmax,0,0,1,nconf,trec,econf,erec,i,i,
     $wsmax,0,0,1,nnewsym,scspe)
#if defined (MPI)
         if(ilev.eq.1) call imedsync(intfile,intrec,wspca,v)
#endif
       endif
C
      return
      end
C
************************************************************************
      subroutine matmul5(s,v1,v2,n,isgn)
************************************************************************
* Vectorized scalar product                                            *
************************************************************************
      implicit none
      integer*1 isgn
      integer n,i
      real*8 s,v1(*),v2(*)
C
      if(isgn.gt.0) then
       do i=1,n
        s=s+v1(i)*v2(i)
       enddo
      else
       do i=1,n
        s=s-v1(i)*v2(i)
       enddo
      endif
C
      return
      end
C
************************************************************************
      subroutine contract12(wnew,wold,t,v,isa,isw,nsttva,nsttvb,nsttoa,
     $nsttob,icsva,icsvb,icsoa,icsob,nstsva,nstsvb,nstsoa,nstava,nstavb,
     $nstaoa,nampsym,isymp1,isymp2,icnva,icnvb,icnoa,icnob,nstnva,
     $nstnvb,nstnoa,nstova,nstovb,nstooa,nnir,ita,nnewsym,incnew,iwa,
     $iwan,incsum,lcalcsn,nn,ntnewlen)
************************************************************************
* This subroutine evaluates the contractions between cluster amplitudes*
* and intermediates                                                    *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isgnval,isgnvbe,isgnoal,isgnobe
      integer ivstral,ivstrbe,iostral,iostrbe,ivstr,iostr,iivobe,nn1,n3
      integer iosbe,iosal,ivsbe,ivsal,ivoal,ivobe,iooal,ioobe,iioobe,nn
      integer nvoal,nvobe,nooal,noobe,ivsalad,ifvsal,ivsbead,ifvsbe
      integer ivo,ioo,ifooal,ifoobe,ifvoal,ifvobe,iosalad,ifosal,nnir
      integer nv,no,n1,n2,isw(*),ivaal,ivabe,ioaal,ioabe,nsymw
      integer nvsal,nvsbe,nosal,nosbe,isc,nvaa,nvab,noaa,noab,nsumoa
      integer i,ii,nosbeo,nvaal,nvabe,noaal,noabe,nava,naoa,nsumob
      integer coupsval,coupsvbe,coupsoal,coupsobe,nin,nvn,non,nampoa
      integer coupwval,coupwoal,coupwvbe,coupwobe,nn2,nn3,nampob,navo
      integer nvoa,nvna,iosbead,no1,no3,icsob(nnir,nnir),ita(*),nsvo
      integer icsva(nnir,nnir),icsvb(nnir,nnir),icsoa(nnir,nnir)
      integer icnob(nnir,nnir),nsumvb,nsumss,incsum(nnir),ntnewlen
      integer icnva(nnir,nnir),icnvb(nnir,nnir),icnoa(nnir,nnir)
      integer nsttva(nnir),nsttvb(nnir),nsttoa(nnir),nsttob(nnir)
      integer nstsva(nnir),nstsvb(nnir),nstsoa(nnir),noccnewall
      integer nstava(nnir),nstavb(nnir),nstaoa(nnir),noccoldall
      integer nstnva(nnir),nstnvb(nnir),nstnoa(nnir)
      integer nstova(nnir),nstovb(nnir),nstooa(nnir)
      integer isa(*),isymp1(0:nnir,nnir),isymp2(0:nnir,nnir)
      real*8 wold(*),t(*)
      integer nsumsym,nampsym,nsyma1,nsyma2,irs
      integer nosalad,nostr,nampvb,nnr,ii1,ii2,ii3,ii4,nsuml
      integer nsumsymva,nsumsymvb,nsumoccallen,nampoccallen,nnn,nivobe
      integer nampsymva,nampsymvb,ntampsymva,ntampsymvb,nsumsymoa,irss
      integer nampsymoa,ntampsymoa,ntampsymob,nsumsymob,nvstrbe
      integer isymi,isyma,nnewsym,incnew(*),nvirtnewsym
      integer noccnewsym,nvirtnewsyma,nvirtnewsymb,nvirtnewalact
      integer nvirtoldsyma,nvirtoldsymb,noccoldsymb
      integer noccnewsyma,noccnewsymb,noccoldsyma
      integer iwan(nnir**5),iwa(nnir**6),nsymt1,nsymt2,isumsym(nnir),iss
      logical lcalcsn,log
#if defined (OMP)
      real*8 wnew(ntnewlen,0:xyzsize),v(nn,0:xyzsize)
#else
      real*8 wnew(ntnewlen),v(nn)
#endif
C
      nnr=nrr-nr4+1
      nnn=nnr-nr5
      iss=0
       do i=1,nir
         if(incsum(i).gt.0) then
          iss=iss+1
          isumsym(iss)=i
         endif
       enddo
       if(iss.eq.0) return
      thrd=0
C
C$OMP PARALLEL
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(wold,t,isa,isw,nsttva,nsttvb,nsttoa,nsttob,icsva)
C$OMP& SHARED(icsvb,icsoa,icsob,nstsva,nstsvb,nstsoa,nstava,nstavb)
C$OMP& SHARED(nstaoa,nampsym,isymp1,isymp2,icnva,icnvb,icnoa,icnob)
C$OMP& SHARED(nstnva,nstnvb,nstnoa,nstova,nstovb,nstooa,nnir,ita)
C$OMP& SHARED(nnewsym,incnew,iwa,iwan,incsum,lcalcsn,isumsym,nnr,nnn)
C$OMP& SHARED(nir,nrr,nr2,nr3,nr4,nr5,mult,icore,iss,ntnewlen,iconj)
C$OMP& SHARED(xyzsize,wnew,v,mpisize,mpicount)
#if defined (OMP)
      thrd=OMP_GET_THREAD_NUM()
#endif
#if defined (MPI) || defined (OMP)
      xyzcount=0
#endif
       if(lcalcsn) then
       do ntampsymob=1,nir
        noabe=nsttob(ntampsymob)
         do ioabe=1,noabe
          noab=noabe+ioabe
           do ntampsymoa=1,nir  
            nsymt1=mult(ntampsymoa,ntampsymob)
            noaal=nsttoa(ntampsymoa)
             do ioaal=1,noaal
              noaa=noaal+ioaal
               do ntampsymvb=1,nir  
                nsymt2=iconj(mult(ntampsymvb,nsymt1))
                nvabe=nsttvb(ntampsymvb)
                 do ivabe=1,nvabe
                  nvab=nvabe+ivabe
                   do irss=1,iss  
                    nsumsym=isumsym(irss)
                    ntampsymva=iconj(mult(mult(nsumsym,nsymt2),nampsym))
                    nsuml=incsum(nsumsym)
                    nvaal=nsttva(ntampsymva)
                     do ivaal=1,nvaal
#if defined (MPI)
             if(mpicount+thrd.eq.xyzcount) then 
#elif defined (OMP)
             if(thrd.eq.xyzcount) then
#endif
              nvaa=nvaal+ivaal
C Unpack cluster amplitudes
#if defined (OMP)
              v(1:nsuml,thrd)=0.d0
#else
              v(1:nsuml)=0.d0
#endif
               do nsumsymob=1,nir
                nsyma1=mult(nsumsym,nsumsymob)
                coupsobe=icsob(nsumsymob,ntampsymob)-1
                nsumob=nsumsymob*nr3+nrr
                nampob=mult(nsumsymob,ntampsymob)*nr3+nrr
                ii1=coupsobe+icore(coupsobe+ioabe)
                 do iosbe=1,icore(coupsobe+noab)
                  ii1=ii1+1
                  iosbead=icore(ii1)-1
                  ii1=ii1+1
                  iostrbe=icore(ii1)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=iabs(iostrbe)-1
                   do nsumsymoa=1,nir
                    nampsymoa=mult(nsumsymoa,ntampsymoa)
                    nsyma2=mult(nsumsymoa,nsyma1)
                    nsumoccallen=nstsoa(nsumsymoa)
                    nampoccallen=nstaoa(nampsymoa)
                    navo=nampoccallen*iostrbe
                    nsvo=nsumoccallen*iosbead
                    coupsoal=icsoa(nsumsymoa,ntampsymoa)-1
                    nsumoa=nsumob+nsumsymoa*nr2
                    nampoa=nampob+nampsymoa*nr2
                    ii2=coupsoal+icore(coupsoal+ioaal)
                     do iosal=1,icore(coupsoal+noaa)
                      ii2=ii2+1
                      iosalad=nsvo+icore(ii2)-1
                      ii2=ii2+1
                      iostral=icore(ii2)
                      isgnoal=isgnobe*isign(1,iostral)
                      iostr=navo+iabs(iostral)-1
                       do irs=1,isymp1(0,nsyma2)
                        nsumsymva=isymp1(irs,nsyma2)
                        nsumsymvb=isymp2(irs,nsyma2)
                        nampsymva=mult(nsumsymva,ntampsymva)
                        nampsymvb=mult(nsumsymvb,ntampsymvb)
                        n3=nstsva(nsumsymva)
                        nn3=nstava(nampsymva)
                        coupsval=icsva(nsumsymva,ntampsymva)-1
                        coupsvbe=icsvb(nsumsymvb,ntampsymvb)-1
                        nosalad=isa(nsumoa+nsumsymvb*nir+nsumsymva)+
     $n3*(nstsvb(nsumsymvb)*iosalad-1)
                        nostr=ita(nampoa+nampsymvb*nir+nampsymva)+
     $nn3*(nstavb(nampsymvb)*iostr-1)
                        ifvsal=coupsval+icore(coupsval+ivaal)
                        nvsal=icore(coupsval+nvaa)
                        ii3=coupsvbe+icore(coupsvbe+ivabe)
                         do ivsbe=1,icore(coupsvbe+nvab)
                          ii3=ii3+1
                          ivsbead=nosalad+n3*icore(ii3)
                          ii3=ii3+1
                          ivstrbe=icore(ii3)
                          isgnvbe=isgnoal*isign(1,ivstrbe)
                          ivstrbe=nostr+iabs(ivstrbe)*nn3
                          ii4=ifvsal
                           do ivsal=1,nvsal
                            ii4=ii4+1
                            ivsalad=ivsbead+icore(ii4)
                            ii4=ii4+1
                            ivstral=icore(ii4)
#if defined (OMP)
                            v(ivsalad,thrd)=
     $isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral))
#else
                            v(ivsalad)=
     $isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral))
#endif
                           enddo
                         enddo
                       enddo
                     enddo
                   enddo
                 enddo
               enddo
C Loop over symmetry cases of new (old) intermediates
              nsumss=nsumsym*nr5+nnn
               do noccoldsymb=1,nir
                noccnewsymb=mult(noccoldsymb,ntampsymob)
                nsyma1=mult(noccnewsymb,nnewsym)
                coupwobe=icnob(noccoldsymb,ntampsymob)-1
                nampob=noccnewsymb*nr4+nnr
                nsumob=noccoldsymb*nr4+nsumss
                ii3=coupwobe+icore(coupwobe+ioabe)
                 do ioobe=1,icore(coupwobe+noab)
                  ii3=ii3+1
                  iioobe=icore(ii3)-1
                  ii3=ii3+1
                  iostrbe=icore(ii3)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=iabs(iostrbe)-1
                   do noccoldsyma=1,nir
                    noccnewsyma=mult(noccoldsyma,ntampsymoa)
                    nsyma2=mult(noccnewsyma,nsyma1)
                    noccoldall=nstooa(noccoldsyma)
                    noccnewall=nstnoa(noccnewsyma)
                    coupwoal=icnoa(noccoldsyma,ntampsymoa)-1
                    nampoa=nampob+noccnewsyma*nr3
                    nsumoa=nsumob+noccoldsyma*nr3
                    ii4=coupwoal+icore(coupwoal+ioaal)
                    navo=iostrbe*noccnewall
                    nsvo=iioobe*noccoldall
                     do iooal=1,icore(coupwoal+noaa)
                      ii4=ii4+1
                      ioo=nsvo+icore(ii4)-1
                      ii4=ii4+1
                      iostral=icore(ii4)
                      isgnoal=isgnobe*isign(1,iostral)
                      iostral=navo+iabs(iostral)-1
                       do nvirtoldsymb=1,nir
                        nvirtnewsymb=mult(nvirtoldsymb,ntampsymvb)
                        nvirtnewsyma=mult(nvirtnewsymb,nsyma2)
                       nvirtoldsyma=mult(nvirtnewsyma,iconj(ntampsymva))
                        coupwvbe=icnvb(nvirtoldsymb,ntampsymvb)-1
                        coupwval=icnva(nvirtoldsyma,ntampsymva)-1
                        nn3=nstnva(nvirtnewsyma)
                        no3=nstova(nvirtoldsyma)*nsuml
                        nampvb=iwan(nampoa+nvirtnewsymb*nr2+
     $nvirtnewsyma*nir)+(iostral*nstnvb(nvirtnewsymb)-1)*nn3-1
                        nsumvb=iwa(nsumoa+nvirtoldsymb*nr2+nvirtoldsyma
     $*nir)+ioo*nstovb(nvirtoldsymb)*no3-nsuml
                        ii1=coupwvbe+icore(coupwvbe+ivabe)
                         do ivobe=1,icore(coupwvbe+nvab)
                          ii1=ii1+1
                          iivobe=icore(ii1)-1
                          ii1=ii1+1
                          ivstrbe=icore(ii1)
                          isgnvbe=isgnoal*isign(1,ivstrbe)
                          nivobe=nsumvb+iivobe*no3
                          nvstrbe=nampvb+iabs(ivstrbe)*nn3
                          ii2=coupwval+icore(coupwval+ivaal)
                           do ivoal=1,icore(coupwval+nvaa)
                            ii2=ii2+1
                            ivo=nivobe+icore(ii2)*nsuml
                            ii2=ii2+1
                            ivstral=icore(ii2)
                            isgnval=isgnvbe*isign(1,ivstral)
#if defined (OMP)
                            call matmul5(wnew(nvstrbe+
     $iabs(ivstral),thrd),wold(ivo),v(1,thrd),nsuml,isgnval)
#else
                            call matmul5(wnew(nvstrbe+
     $iabs(ivstral)),wold(ivo),v,nsuml,isgnval)
#endif
                           enddo
                         enddo
                       enddo 
                     enddo
                   enddo
                 enddo
               enddo
#if defined (MPI) || defined (OMP)
             endif
             if(xyzcount.eq.mpisize) then                           
              xyzcount=0                           
             else                                                      
              xyzcount=xyzcount+1                                      
             endif
#endif
             enddo
           enddo
         enddo
       enddo
             enddo
           enddo
         enddo
       enddo
       else
       do ntampsymob=1,nir
        noabe=nsttob(ntampsymob)
         do ioabe=1,noabe
          noab=noabe+ioabe
           do ntampsymoa=1,nir  
            nsymt1=mult(ntampsymoa,ntampsymob)
            noaal=nsttoa(ntampsymoa)
             do ioaal=1,noaal
              noaa=noaal+ioaal
               do ntampsymvb=1,nir  
                nsymt2=mult(ntampsymvb,nsymt1)
                nvabe=nsttvb(ntampsymvb)
                 do ivabe=1,nvabe
                  nvab=nvabe+ivabe
                   do irss=1,iss  
                    nsumsym=isumsym(irss)
                    ntampsymva=mult(mult(nsumsym,nsymt2),nampsym)
                    nsuml=incsum(nsumsym)
                    nvaal=nsttva(ntampsymva)
                     do ivaal=1,nvaal
#if defined (MPI)
             if(mpicount+thrd.eq.xyzcount) then 
#elif defined (OMP)
             if(thrd.eq.xyzcount) then
#endif
              nvaa=nvaal+ivaal
C Unpack cluster amplitudes
#if defined (OMP)
              v(1:nsuml,thrd)=0.d0
#else
              v(1:nsuml)=0.d0
#endif
               do nsumsymob=1,nir
                nsyma1=mult(nsumsym,nsumsymob)
                coupsobe=icsob(nsumsymob,ntampsymob)-1
                nsumob=nsumsymob*nr3+nrr
                nampob=mult(nsumsymob,ntampsymob)*nr3+nrr
                ii1=coupsobe+icore(coupsobe+ioabe)
                 do iosbe=1,icore(coupsobe+noab)
                  ii1=ii1+1
                  iosbead=icore(ii1)-1
                  ii1=ii1+1
                  iostrbe=icore(ii1)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=iabs(iostrbe)-1
                   do nsumsymoa=1,nir
                    nampsymoa=mult(nsumsymoa,ntampsymoa)
                    nsyma2=mult(nsumsymoa,nsyma1)
                    nsumoccallen=nstsoa(nsumsymoa)
                    nampoccallen=nstaoa(nampsymoa)
                    navo=nampoccallen*iostrbe
                    nsvo=nsumoccallen*iosbead
                    coupsoal=icsoa(nsumsymoa,ntampsymoa)-1
                    nsumoa=nsumob+nsumsymoa*nr2
                    nampoa=nampob+nampsymoa*nr2
                    ii2=coupsoal+icore(coupsoal+ioaal)
                     do iosal=1,icore(coupsoal+noaa)
                      ii2=ii2+1
                      iosalad=nsvo+icore(ii2)-1
                      ii2=ii2+1
                      iostral=icore(ii2)
                      isgnoal=isgnobe*isign(1,iostral)
                      iostr=navo+iabs(iostral)-1
                       do irs=1,isymp1(0,nsyma2)
                        nsumsymva=isymp1(irs,nsyma2)
                        nsumsymvb=isymp2(irs,nsyma2)
                        nampsymva=mult(nsumsymva,ntampsymva)
                        nampsymvb=mult(nsumsymvb,ntampsymvb)
                        n3=nstsva(nsumsymva)
                        nn3=nstava(nampsymva)
                        coupsval=icsva(nsumsymva,ntampsymva)-1
                        coupsvbe=icsvb(nsumsymvb,ntampsymvb)-1
                        nosalad=isa(nsumoa+nsumsymvb*nir+nsumsymva)+
     $n3*(nstsvb(nsumsymvb)*iosalad-1)
                        nostr=ita(nampoa+nampsymvb*nir+nampsymva)+
     $nn3*(nstavb(nampsymvb)*iostr-1)
                        ifvsal=coupsval+icore(coupsval+ivaal)
                        nvsal=icore(coupsval+nvaa)
                        ii3=coupsvbe+icore(coupsvbe+ivabe)
                         do ivsbe=1,icore(coupsvbe+nvab)
                          ii3=ii3+1
                          ivsbead=nosalad+n3*icore(ii3)
                          ii3=ii3+1
                          ivstrbe=icore(ii3)
                          isgnvbe=isgnoal*isign(1,ivstrbe)
                          ivstrbe=nostr+iabs(ivstrbe)*nn3
                          ii4=ifvsal
                           do ivsal=1,nvsal
                            ii4=ii4+1
                            ivsalad=ivsbead+icore(ii4)
                            ii4=ii4+1
                            ivstral=icore(ii4)
#if defined (OMP)
                            v(ivsalad,thrd)=
     $isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral))
#else
                            v(ivsalad)=
     $isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral))
#endif
                           enddo
                         enddo
                       enddo
                     enddo
                   enddo
                 enddo
               enddo
C Loop over symmetry cases of new (old) intermediates
              nsumss=nsumsym*nr5+nnn
               do noccoldsymb=1,nir
                noccnewsymb=mult(noccoldsymb,ntampsymob)
                nsyma1=mult(noccnewsymb,nnewsym)
                coupwobe=icnob(noccoldsymb,ntampsymob)-1
                nampob=noccnewsymb*nr4+nnr
                nsumob=noccoldsymb*nr4+nsumss
                ii3=coupwobe+icore(coupwobe+ioabe)
                 do ioobe=1,icore(coupwobe+noab)
                  ii3=ii3+1
                  iioobe=icore(ii3)-1
                  ii3=ii3+1
                  iostrbe=icore(ii3)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=iabs(iostrbe)-1
                   do noccoldsyma=1,nir
                    noccnewsyma=mult(noccoldsyma,ntampsymoa)
                    log=noccnewsyma.le.noccnewsymb
                    nsyma2=mult(noccnewsyma,nsyma1)
                    noccoldall=nstooa(noccoldsyma)
                    noccnewall=nstnoa(noccnewsyma)
                    coupwoal=icnoa(noccoldsyma,ntampsymoa)-1
                    nampoa=nampob+noccnewsyma*nr3
                    nsumoa=nsumob+noccoldsyma*nr3
                    ii4=coupwoal+icore(coupwoal+ioaal)
                    navo=iostrbe*noccnewall
                    nsvo=iioobe*noccoldall
                     do iooal=1,icore(coupwoal+noaa)
                      ii4=ii4+1
                      ioo=nsvo+icore(ii4)-1
                      ii4=ii4+1
                      iostral=icore(ii4)
                      isgnoal=isgnobe*isign(1,iostral)
                      iostral=navo+iabs(iostral)-1
                       do nvirtoldsymb=1,nir
                        nvirtnewsymb=mult(nvirtoldsymb,ntampsymvb)
                        nvirtnewsyma=mult(nvirtnewsymb,nsyma2)
                         if(nvirtnewsyma.lt.nvirtnewsymb.or.
     $(nvirtnewsyma.eq.nvirtnewsymb.and.log)) then
                        nvirtoldsyma=mult(nvirtnewsyma,ntampsymva)
                        coupwvbe=icnvb(nvirtoldsymb,ntampsymvb)-1
                        coupwval=icnva(nvirtoldsyma,ntampsymva)-1
                        nn3=nstnva(nvirtnewsyma)
                        no3=nstova(nvirtoldsyma)*nsuml
                        nampvb=iwan(nampoa+nvirtnewsymb*nr2+
     $nvirtnewsyma*nir)+(iostral*nstnvb(nvirtnewsymb)-1)*nn3-1
                        nsumvb=iwa(nsumoa+nvirtoldsymb*nr2+nvirtoldsyma
     $*nir)+ioo*nstovb(nvirtoldsymb)*no3-nsuml
                        ii1=coupwvbe+icore(coupwvbe+ivabe)
                         do ivobe=1,icore(coupwvbe+nvab)
                          ii1=ii1+1
                          iivobe=icore(ii1)-1
                          ii1=ii1+1
                          ivstrbe=icore(ii1)
                          isgnvbe=isgnoal*isign(1,ivstrbe)
                          nivobe=nsumvb+iivobe*no3
                          nvstrbe=nampvb+iabs(ivstrbe)*nn3
                          ii2=coupwval+icore(coupwval+ivaal)
                           do ivoal=1,icore(coupwval+nvaa)
                            ii2=ii2+1
                            ivo=nivobe+icore(ii2)*nsuml
                            ii2=ii2+1
                            ivstral=icore(ii2)
                            isgnval=isgnvbe*isign(1,ivstral)
#if defined (OMP)
                            call matmul5(wnew(nvstrbe+
     $iabs(ivstral),thrd),wold(ivo),v(1,thrd),nsuml,isgnval)
#else
                            call matmul5(wnew(nvstrbe+
     $iabs(ivstral)),wold(ivo),v,nsuml,isgnval)
#endif
                           enddo
                         enddo
                         endif
                       enddo 
                     enddo
                   enddo
                 enddo
               enddo
#if defined (MPI) || defined (OMP)
             endif
             if(xyzcount.eq.mpisize) then
              xyzcount=0                         
             else                              
              xyzcount=xyzcount+1
             endif
#endif
             enddo
           enddo
         enddo
       enddo
             enddo
           enddo
         enddo
       enddo
       endif
C$OMP END PARALLEL
#if defined (OMP)
      call ompred(wnew,ntnewlen)
#endif
C
      return
      end
C
************************************************************************
      subroutine contract11(wnew,wold,t,v,isa,isw,nsttva,nsttvb,nsttoa,
     $nsttob,icsva,icsvb,icsoa,icsob,nstsva,nstsvb,nstsoa,nstava,nstavb,
     $nstaoa,nampsym,isymp1,isymp2,icnva,icnvb,icnoa,icnob,nstnva,
     $nstnvb,nstnoa,nstova,nstovb,nstooa,nnir,ita,nnewsym,incnew,iwa,
     $iwan,incsum,nn,ntnewlen)
************************************************************************
* This subroutine evaluates the contractions between cluster amplitudes*
* and intermediates                                                    *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isgnval,isgnvbe,isgnoal,isgnobe
      integer ivstral,ivstrbe,iostral,iostrbe,ivstr,iostr,iivobe,nn1,n3
      integer iosbe,iosal,ivsbe,ivsal,ivoal,ivobe,iooal,ioobe,iioobe,nn
      integer nvoal,nvobe,nooal,noobe,ivsalad,ifvsal,ivsbead,ifvsbe
      integer ivo,ioo,ifooal,ifoobe,ifvoal,ifvobe,iosalad,ifosal,nnir
      integer nv,no,n1,n2,isw(*),ivaal,ivabe,ioaal,ioabe,nsymw,ntnewlen
      integer nvsal,nvsbe,nosal,nosbe,isc,nvaa,nvab,noaa,noab,nsumoa
      integer i,ii,nosbeo,nvaal,nvabe,noaal,noabe,nava,naoa,nsumob
      integer coupsval,coupsvbe,coupsoal,coupsobe,nin,nvn,non,nampoa
      integer coupwval,coupwoal,coupwvbe,coupwobe,nn2,nn3,nn4,nampob
      integer nvoa,nvna,iosbead,no1,no2,no3,no4,icsob(nnir,nnir),ita(*)
      integer icsva(nnir,nnir),icsvb(nnir,nnir),icsoa(nnir,nnir),navo
      integer icnob(nnir,nnir),nsumvb,nsumss,incsum(nnir),nsvo,nsuml
      integer icnva(nnir,nnir),icnvb(nnir,nnir),icnoa(nnir,nnir)
      integer nsttva(nnir),nsttvb(nnir),nsttoa(nnir),nsttob(nnir)
      integer nstsva(nnir),nstsvb(nnir),nstsoa(nnir),ii1,ii2,ii3,ii4
      integer nstava(nnir),nstavb(nnir),nstaoa(nnir),noccoldall
      integer nstnva(nnir),nstnvb(nnir),nstnoa(nnir),noccnewall
      integer nstova(nnir),nstovb(nnir),nstooa(nnir)
      integer isa(*),isymp1(0:nnir,nnir),isymp2(0:nnir,nnir)
      real*8 wold(*),t(*)
      integer nsumsym,nampsym,nsyma1,nsyma2,nsyma3,irs
      integer nosalad,nostr,nampvb,nnr
      integer nsumsymva,nsumsymvb,nsumoccallen,nampoccallen,nnn,nivobe
      integer nampsymva,nampsymvb,ntampsymva,ntampsymvb,nsumsymoa,irss
      integer nampsymoa,ntampsymoa,ntampsymob,nsumsymob,nvstrbe
      integer isymi,isyma,nnewsym,incnew(*),nvirtnewsym
      integer noccnewsym,nvirtnewsyma,nvirtnewsymb,nvirtnewalact
      integer nvirtnewbelen,nvirtoldsyma,nvirtoldsymb,noccoldsymb
      integer nvirtoldbelen,noccnewsyma,noccnewsymb,noccoldsyma
      integer iwan(nnir**5),iwa(nnir**6),nsymt1,nsymt2,isumsym(nnir),iss
#if defined (OMP)
      real*8 wnew(ntnewlen,0:xyzsize),v(nn,0:xyzsize)
#else
      real*8 wnew(ntnewlen),v(nn)
#endif
C
      nnr=nrr-nr4
      nnn=nnr-nr5
      iss=0
       do i=1,nir
         if(incsum(i).gt.0) then
          iss=iss+1
          isumsym(iss)=i
         endif
       enddo
       if(iss.eq.0) return
C
C$OMP PARALLEL
C$OMP& DEFAULT(PRIVATE)
C$OMP& SHARED(wold,t,isa,isw,nsttva,nsttvb,nsttoa,nsttob,icsva)
C$OMP& SHARED(icsvb,icsoa,icsob,nstsva,nstsvb,nstsoa,nstava,nstavb)
C$OMP& SHARED(nstaoa,nampsym,isymp1,isymp2,icnva,icnvb,icnoa,icnob)
C$OMP& SHARED(nstnva,nstnvb,nstnoa,nstova,nstovb,nstooa,nnir,ita)
C$OMP& SHARED(nnewsym,incnew,iwa,iwan,incsum,isumsym,nnr,nnn)
C$OMP& SHARED(nir,nrr,nr2,nr3,nr4,nr5,mult,icore,iss,ntnewlen,iconj)
C$OMP& SHARED(xyzsize,wnew,v)
#if defined (OMP)
      thrd=OMP_GET_THREAD_NUM()
      xyzcount=0
#endif
       do ntampsymob=1,nir
        noabe=nsttob(ntampsymob)
         do ioabe=1,noabe
          noab=noabe+ioabe
           do ntampsymoa=1,nir  
            nsymt1=mult(ntampsymoa,ntampsymob)
            noaal=nsttoa(ntampsymoa)
             do ioaal=1,noaal
              noaa=noaal+ioaal
               do ntampsymvb=1,nir  
                nsymt2=iconj(mult(ntampsymvb,nsymt1))
                nvabe=nsttvb(ntampsymvb)
                 do ivabe=1,nvabe
                  nvab=nvabe+ivabe
                   do irss=1,iss  
                    nsumsym=isumsym(irss)
                    ntampsymva=iconj(mult(mult(nsumsym,nsymt2),nampsym))
                    nsuml=incsum(nsumsym)
                    nvaal=nsttva(ntampsymva)
                     do ivaal=1,nvaal
#if defined (OMP)
             if(thrd.eq.xyzcount) then 
#endif
              nvaa=nvaal+ivaal
C Unpack cluster amplitudes
#if defined (OMP)
              v(1:nsuml,thrd)=0.d0
#else
              v(1:nsuml)=0.d0
#endif
               do nsumsymob=1,nir
                nsyma1=mult(nsumsym,nsumsymob)
                coupsobe=icsob(nsumsymob,ntampsymob)-1
                nsumob=nsumsymob*nr3+nrr
                nampob=mult(nsumsymob,ntampsymob)*nr3+nrr
                ii1=coupsobe+icore(coupsobe+ioabe)
                 do iosbe=1,icore(coupsobe+noab)
                  ii1=ii1+1
                  iosbead=icore(ii1)-1
                  ii1=ii1+1
                  iostrbe=icore(ii1)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=iabs(iostrbe)-1
                   do nsumsymoa=1,nir
                    nampsymoa=mult(nsumsymoa,ntampsymoa)
                    nsyma2=mult(nsumsymoa,nsyma1)
                    nsumoccallen=nstsoa(nsumsymoa)
                    nampoccallen=nstaoa(nampsymoa)
                    navo=nampoccallen*iostrbe
                    nsvo=nsumoccallen*iosbead
                    coupsoal=icsoa(nsumsymoa,ntampsymoa)-1
                    nsumoa=nsumob+nsumsymoa*nr2
                    nampoa=nampob+nampsymoa*nr2
                    ii2=coupsoal+icore(coupsoal+ioaal)
                     do iosal=1,icore(coupsoal+noaa)
                      ii2=ii2+1
                      iosalad=nsvo+icore(ii2)-1
                      ii2=ii2+1
                      iostral=icore(ii2)
                      isgnoal=isgnobe*isign(1,iostral)
                      iostr=navo+iabs(iostral)-1
                       do irs=1,isymp1(0,nsyma2)
                        nsumsymva=isymp1(irs,nsyma2)
                        nsumsymvb=isymp2(irs,nsyma2)
                        nampsymva=mult(nsumsymva,ntampsymva)
                        nampsymvb=mult(nsumsymvb,ntampsymvb)
                        n3=nstsva(nsumsymva)
                        nn3=nstava(nampsymva)
                        coupsval=icsva(nsumsymva,ntampsymva)-1
                        coupsvbe=icsvb(nsumsymvb,ntampsymvb)-1
                        nosalad=isa(nsumoa+nsumsymvb*nir+nsumsymva)+
     $n3*(nstsvb(nsumsymvb)*iosalad-1)
                        nostr=ita(nampoa+nampsymvb*nir+nampsymva)+
     $nn3*(nstavb(nampsymvb)*iostr-1)
                        ifvsal=coupsval+icore(coupsval+ivaal)
                        nvsal=icore(coupsval+nvaa)
                        ii3=coupsvbe+icore(coupsvbe+ivabe)
                         do ivsbe=1,icore(coupsvbe+nvab)
                          ii3=ii3+1
                          ivsbead=nosalad+n3*icore(ii3)
                          ii3=ii3+1
                          ivstrbe=icore(ii3)
                          isgnvbe=isgnoal*isign(1,ivstrbe)
                          ivstrbe=nostr+iabs(ivstrbe)*nn3
                          ii4=ifvsal
                           do ivsal=1,nvsal
                            ii4=ii4+1
                            ivsalad=ivsbead+icore(ii4)
                            ii4=ii4+1
                            ivstral=icore(ii4)
#if defined (OMP)
                            v(ivsalad,thrd)=
     $isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral))
#else
                            v(ivsalad)=
     $isgnvbe*isign(1,ivstral)*t(ivstrbe+iabs(ivstral))
#endif
                           enddo
                         enddo
                       enddo
                     enddo
                   enddo
                 enddo
               enddo
C Loop over symmetry cases of new (old) intermediates
              nsumss=nsumsym*nr5+nnn
               do noccoldsymb=1,nir
                noccnewsymb=mult(noccoldsymb,ntampsymob)
                nsyma1=mult(noccnewsymb,nnewsym)
                coupwobe=icnob(noccoldsymb,ntampsymob)-1
                nampob=noccnewsymb*nr4+nnr
                nsumob=noccoldsymb*nr4+nsumss
                ii3=coupwobe+icore(coupwobe+ioabe)
                 do ioobe=1,icore(coupwobe+noab)
                  ii3=ii3+1
                  iioobe=icore(ii3)-1
                  ii3=ii3+1
                  iostrbe=icore(ii3)
                  isgnobe=isign(1,iostrbe)
                  iostrbe=iabs(iostrbe)-1
                   do noccoldsyma=1,nir
                    noccnewsyma=mult(noccoldsyma,ntampsymoa)
                    nsyma2=mult(iconj(noccnewsyma),nsyma1)
                    noccoldall=nstooa(noccoldsyma)
                    noccnewall=nstnoa(noccnewsyma)
                    coupwoal=icnoa(noccoldsyma,ntampsymoa)-1
                    nampoa=nampob+noccnewsyma*nr3
                    nsumoa=nsumob+noccoldsyma*nr3
                    ii4=coupwoal+icore(coupwoal+ioaal)
                     do iooal=1,icore(coupwoal+noaa)
                      ii4=ii4+1
                      ioo=icore(ii4)-1
                      ii4=ii4+1
                      iostral=icore(ii4)
                      isgnoal=isgnobe*isign(1,iostral)
                      iostral=iabs(iostral)-1
                       do nvirtoldsymb=1,nir
                        nvirtnewsymb=mult(nvirtoldsymb,ntampsymvb)
                        nsyma3=mult(nvirtnewsymb,nsyma2)
                        nvirtoldbelen=nstovb(nvirtoldsymb)
                        nvirtnewbelen=nstnvb(nvirtnewsymb)
                        coupwvbe=icnvb(nvirtoldsymb,ntampsymvb)-1
                        nampvb=nampoa+nvirtnewsymb*nr2
                        nsumvb=nsumoa+nvirtoldsymb*nr2
                        ii1=coupwvbe+icore(coupwvbe+ivabe)
                         do ivobe=1,icore(coupwvbe+nvab)
                          ii1=ii1+1
                          iivobe=icore(ii1)-1
                          ii1=ii1+1
                          ivstrbe=icore(ii1)
                          isgnvbe=isgnoal*isign(1,ivstrbe)
                           do nvirtoldsyma=1,nir
                            nvirtnewsyma=mult(nvirtoldsyma,ntampsymva)
                            isymi=mult(nvirtnewsyma,nsyma3)
                            coupwval=icnva(nvirtoldsyma,ntampsymva)-1
                            nn4=incnew(isymi)
                            nn3=nstnva(nvirtnewsyma)*nn4
                            nn2=nvirtnewbelen*nn3
                            no4=nn4*nsuml
                            no3=nstova(nvirtoldsyma)*no4
                            no2=nvirtoldbelen*no3
                            nivobe=iwa(nsumvb+nvirtoldsyma*nir+isymi)+
     $iioobe*noccoldall*no2+ioo*no2+iivobe*no3
                            nvstrbe=iwan(nampvb+nvirtnewsyma*nir+isymi)+
     $iostrbe*noccnewall*nn2+iostral*nn2+(iabs(ivstrbe)-1)*nn3
                            ii2=coupwval+icore(coupwval+ivaal)
                             do ivoal=1,icore(coupwval+nvaa)
                              ii2=ii2+1
                              ivo=nivobe+(icore(ii2)-1)*no4
                              ii2=ii2+1
                              ivstral=icore(ii2)
                              isgnval=isgnvbe*isign(1,ivstral)
#if defined (OMP)
                              call matmul1(wnew(nvstrbe+
     $(iabs(ivstral)-1)*nn4,thrd),wold(ivo),v(1,thrd),nn4,nsuml,isgnval)
#else
                              call matmul1(wnew(nvstrbe+
     $(iabs(ivstral)-1)*nn4),wold(ivo),v,nn4,nsuml,isgnval)
#endif
                             enddo
                           enddo
                         enddo
                       enddo 
                     enddo
                   enddo
                 enddo
               enddo
#if defined (OMP)
             endif
             if(xyzcount.eq.xyzsize) then
              xyzcount=0
             else
              xyzcount=xyzcount+1
             endif
#endif
             enddo
           enddo
         enddo
       enddo
             enddo
           enddo
         enddo
       enddo
C$OMP END PARALLEL
#if defined (OMP)
      call ompred(wnew,ntnewlen)
#endif
c#if defined (MPI) && defined (OMP)
c      call dcommunicate3(wnew,ntnewlen,wnew(ntnewlen+1,0),
c     $wnew(ntnewlen+mpibfl+1,0))
c#elif defined (MPI)
c      call dcommunicate3(wnew,ntnewlen,wnew(ntnewlen+1),
c     $wnew(ntnewlen+mpibfl+1))
c#endif
C
      return
      end
C
C*****PARALLEL CODE: MPI*****BEGIN
#if defined (MPI)
************************************************************************
      subroutine psend(file,nconf,nmax,nactm,trec,v,irec,wspc,wsmax,
     $denrec,econf,erec)
************************************************************************
* Synchronizing a file an all nodes
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,i,k,l,m,n,nn,iw,wsmax,wspc(0:wsmax,13),ii,mm
      integer denrec(*)
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactvb,iactob,iactv,iacto,iactva,iactoa,file,irec
      real*8 v(*)
C
       if(densroute) then
         do i=ptsh+1,ptsh+iimed
          ii=i-ptsh
           do iw=1,wspc(0,i)
            nn=wspc((iw-1)*12+12,i)
            mm=denrec(ii)+wspc((iw-1)*12+11,i)
            call getlst(file,mm,v(1),nn)
            call dcommunicate3(v,nn,v(nn+1),v(nn+mpibfl+1))
            call putlst(file,mm,v(1),nn)
           enddo
         enddo
       else
         do i=0,op
           do iactv=max(0,i-mrop),min(nactv,i)
             do iacto=max(0,i-mrop),min(nacto,i)
               do i1=0,i
                nn=0
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                     if(isym.eq.isy1.or.(eomcc.and.iroot.eq.1).or.
     $zroute.or.(eomgrad.and.l3route)) then
                      nn=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= trec(iactva,iactvb,iactoa,iactob,i1,i)
                     else
                      nn=econf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= erec(iactva,iactvb,iactoa,iactob,i1,i)
                     endif
                     if(nn.gt.0) then
                      call getlst(file,irec+mm,v(1),nn)
                      call dcommunicate3(v,nn,v(nn+1),v(nn+mpibfl+1))
                      call putlst(file,irec+mm,v(1),nn)
                     endif
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       endif
C
      return
      end 
C
************************************************************************
      subroutine imedsync(file,irec,wspc,v)
************************************************************************
* Synchronize intermediates in files                                   *
************************************************************************
#include "MRCCCOMMON"
      integer file,irec,wspc(0:1),iw,ire,ile
      real*8 v(*)
C
       do iw=1,wspc(0)
        ire=wspc((iw-1)*12+11)
        ile=wspc((iw-1)*12+12)
        call getlst(file,irec+ire,v,ile)
        call dcommunicate3(v,ile,v(ile+1),v(ile+mpibfl+1))
        call putlst(file,irec+ire,v,ile)
       enddo
C
      return
      end
C
#endif     
C*****PARALLEL CODE: MPI*****END
************************************************************************
      subroutine acrmet(icc2)
************************************************************************
* Determines the acronym for the method
************************************************************************
#include "MRCCCOMMON"
      integer i,lb,le,opr,icc2
      character*128 beg,end
      character*1 str
C
       if(icc2.ge.1.and.icc2.le.3) then
        opr=mrop-1
       else if(qcc.eq.1) then
        opr=qccop
       else
        opr=mrop
       endif
      write(str,'(i1)') opr
       if(opr.eq.1) then
        method1='S'
       else if(opr.eq.2) then
        method1='SD'
       else if(opr.eq.3) then
        method1='SDT'
       else if(opr.eq.4) then
        method1='SDTQ'
       else if(opr.eq.5) then
        method1='SDTQP'
       else
        method1='(' // str // ')'
       endif
       if(calc.eq.1) then
        method1='CC' // method1
       else
        method1='CI' // method1
       endif
       if(qcc.eq.1) method1='Q' // method1
       if(lcc) method1='L' // method1
       if(mr.and.op.ne.maxex.and.nactv*nacto.ne.0) 
     $method1='MR' // method1
       if(ssmrcc.gt.0) then
        method1='SS' // method1
         if(ss1route) method1='CAS'
       endif
      method2=method1
       if(icc2.gt.0) then
         if(icc2.le.3.and.op.eq.6) method2='CC(5)'
         if(op.eq.3) then
          str='T'
         else if(op.eq.4) then
          str='Q'
         else if(op.eq.5) then
          str='P'
         else
          write(str,'(i1)') op
         endif
         if(icc2.eq.1) then
          end='[' // str // ']'
         else if(icc2.eq.2) then
          end='(' // str // ')'
         else if(icc2.eq.3) then
          end='(' // str // ')_L'
         else if(icc2.eq.4) then
          end='-1a'
         else if(icc2.eq.5) then
          end='-1b'
         else if(icc2.eq.6) then
          method2='CC'
          write(end,'(i1)') op
         else if(icc2.eq.7) then
          end='-3'
         endif
        call trimloc(method2,end)
         if(icc2.ge.4) method1=method2
       endif
       if(calc.eq.1.and.nroot.gt.1) method2='LR-' // method2
C
      beg=' ' // method2
       if((dens.eq.1.or.dens.eq.2).and..not.hess.and..not.osc) then
        end=' analytic gradient calculation '
       else if((dens.eq.1.or.dens.eq.2).and.hess.and..not.third) then
        end=' analytic second derivative calculation '
       else if((dens.eq.1.or.dens.eq.2).and.third) then
        end=' analytic third derivative calculation '
       else if((dens.eq.1.or.dens.eq.2).and.osc) then
        end=' transition moment calculation '
       else
        end=' calculation '
       endif 
      call trimloc(beg,end)
      write(iout,"(a72)") beg
C
      return
      end 
C
************************************************************************
      subroutine prtenerg(meth,ene,log1,log2,log3)
************************************************************************
* Print energies                                                       *
************************************************************************
#include "MRCCCOMMON"
      integer is1,is2
      real*8 ene
      character*9 c9
      character*128 beg,end
      character*(*) meth
      logical log1,log2,log3
C
       if(log1) then
        beg=' Total ' // meth
        end=' energy [au]:'
        call trimloc(beg,end)
        write(iout,"(a31,f22.12)") beg,ene
       endif
       if(log3) then
        write(iout,122) ene
122   format(' Total energy from RDM [au]:   ',f22.12)
        backspace(ifcfile)
        read(ifcfile,"(a9,a15)") c9,beg
       endif
       if(log3.or.(log2.and..not.leftroute.and..not.ptroute)) then
        is2=iroot
         if(iroot.eq.1) then
          is1=isy1
         else
          is1=isy2
           if(isy1.ne.isy2) is2=iroot-1
         endif
         if(.not.log3) beg=meth
        if(locno.gt.0) write(ifcfile,7596) 
     $'ENERGY  ','REF            ',mult(is1,refsym),is2,
     $icore(multmem+iroot-1),eref,0.d0,0.d0
        write(ifcfile,7596) 
     $'ENERGY  ',beg,mult(is1,refsym),is2,icore(multmem+iroot-1),ene,
     $tim-timold,wct-wctold
        timold=tim
        wctold=wct
       endif
7596  format(a8,1x,a15,1x,3(i2,1x),1pe23.15,2(1pe15.8))
      call flush(iout)
C
      return
      end 
C
************************************************************************
      subroutine mrrefdet(nva,nvb,noa,nob,nvstral,nvstrbe,nostral,
     $nostrbe,istrva,istrvb,istroa,istrob,t,nbmax,absind,noccup,nref)
************************************************************************
* This subroutine generates occupation strings for reference dets.     *
************************************************************************
#include "MRCCCOMMON"
      integer nva,nvb,noa,nob,nvstral,nvstrbe,nostral,nostrbe,ii,nbmax
      integer i,j,ivstral,ivstrbe,iostral,iostrbe,absind(2*nbmax,-3:0)
      integer istrva(nva,nvstral),istrvb(nvb,nvstrbe),noccup(*),nref
      integer istroa(noa,nostral),istrob(nob,nostrbe),occ(nbmax)
      real*8 t(*)
C
       do i=1,nbmax
        occ(i)=noccup(i)
       enddo
      ii=0
       do iostrbe=1,nostrbe
         do i=1,nob
          j=absind(istrob(i,iostrbe),0)
           if(occ(j).eq.2) occ(j)=1
           if(occ(j).eq.-1) occ(j)=0
         enddo
         do iostral=1,nostral
           do i=1,noa
            j=absind(istroa(i,iostral),-1)
             if(occ(j).eq.2) occ(j)=-1
             if(occ(j).eq.1) occ(j)=0
           enddo
           do ivstrbe=1,nvstrbe
             do i=1,nvb
              j=absind(istrvb(i,ivstrbe),-2)
               if(occ(j).eq.0) occ(j)=-1
               if(occ(j).eq.1) occ(j)=2
             enddo
             do ivstral=1,nvstral
               do i=1,nva
                j=absind(istrva(i,ivstral),-3)
                 if(occ(j).eq.0) occ(j)=1
                 if(occ(j).eq.-1) occ(j)=2
               enddo
              ii=ii+1
               if(dabs(t(ii)).gt.tol) then
                write(scfile,"(1pe28.20,10000i3)") t(ii),occ
                nref=nref+1
               endif
               do i=1,nva
                j=absind(istrva(i,ivstral),-3)
                 if(occ(j).eq.1) occ(j)=0
                 if(occ(j).eq.2) occ(j)=-1
               enddo
             enddo
             do i=1,nvb
              j=absind(istrvb(i,ivstrbe),-2)
               if(occ(j).eq.-1) occ(j)=0
               if(occ(j).eq.2) occ(j)=1
             enddo
           enddo
           do i=1,noa
            j=absind(istroa(i,iostral),-1)
             if(occ(j).eq.-1) occ(j)=2
             if(occ(j).eq.0) occ(j)=1
           enddo
         enddo
         do i=1,nob
          j=absind(istrob(i,iostrbe),0)
           if(occ(j).eq.1) occ(j)=2
           if(occ(j).eq.0) occ(j)=-1
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine cconv(nconf,trec,nstr,nmax,f,nnir,isympv,isympo,nbmax,
     $nactm,noccup,absind,irec,ioffs,roccup,nactd,jconf,jrec,mosym,
     $iarcrec,itr,tarec,ita,jstr,absinv,mosymvo,coef)
************************************************************************
* Converts CI coefficients corresponding to different Fermi-vacua      *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isign,isign1
      integer nnir,nmax,nactm,i,j,k,nex,ii,jj,nn,ssym,absind,roccup(*)
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),ioffs
      integer jconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax),jn
      integer n1,n2,n3,n4,ire,ile,nbmax,l,kk,nactd(*),jampvirtal,jex
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer jrec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactv,iacto,iactva,iactoa,iactvb,iactob,noccup(nbmax)
      integer nstr(nnir,0:nactm,0:nmax,4),nva,nvb,noa,nob,jampvirtbe
      integer isympv(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isympo(0:nnir,nnir,0:nactm,0:nactm,0:nmax,0:nmax,2)
      integer isymv,isymo,isymva,isymvb,isymoa,isymob,irv,iro,iob(nactm)
      integer nn1,nn2,nn3,nn4,iva(nactm),ivb(nactm),ioa(nactm),mosym(*)
      integer nactvintal,nactointal,nactvintbe,nactointbe,nactvirtal
      integer nactoccal,nactvirtbe,nactoccbe,irec(nnir,0:nactm,0:nmax,4)
      integer nampvirtal,nampvirtbe,nampoccal,nampoccbe,intadd,jmem
      integer dbladd,jmva,jmvb,jmoa,jmob,jtva,jtvb,jtoa,jtob
      integer jactva,jactvb,jactoa,jactob,iarcrec(0:nactm,0:nmax,4)
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer itr(2,0:nactm,0:nmax,4),ita(nnir,nnir,nnir,nnir)
      integer jstr(nnir,0:nactm,0:nmax,4),absinv(2*nbmax,-3:0)
      integer mosymvo(2*nbmax,4)
      real*8 f(*),coef
c     write(6,*) 'nactm',nactm,nmax
C Operator string generating the ref det from the absolute Fermi-vacuum
      nva=0
      nvb=0
      noa=0
      nob=0
       do i=1,nbmax
         if(nactd(i).eq.1.and.noccup(i).ne.roccup(i)) then
           if((noccup(i).eq.1.or.noccup(i).eq.2).and.
     $        (roccup(i).eq.-1.or.roccup(i).eq.0)) then
            nva=nva+1
            iva(nva)=i
           endif
           if((noccup(i).eq.-1.or.noccup(i).eq.2).and.
     $        (roccup(i).eq.0.or.roccup(i).eq.1)) then
            nvb=nvb+1
            ivb(nvb)=i
           endif
           if((noccup(i).eq.-1.or.noccup(i).eq.0).and.
     $        (roccup(i).eq.1.or.roccup(i).eq.2)) then
            noa=noa+1
            ioa(noa)=i
           endif
           if((noccup(i).eq.0.or.noccup(i).eq.1).and.
     $        (roccup(i).eq.-1.or.roccup(i).eq.2)) then
            nob=nob+1
            iob(nob)=i
           endif
         endif
       enddo
C Sign of the string
       do i=1,nbmax
        noccup(i)=roccup(i)
       enddo
      isign=1
       do i=1,nob
         do j=nbmax,iob(i)+1,-1
           if(iabs(noccup(j)).eq.1) isign=-isign
         enddo
         if(noccup(iob(i)).eq.2) then
          noccup(iob(i))=1
          isign=-isign
         endif
         if(noccup(iob(i)).eq.-1) noccup(iob(i))=0
       enddo
       do i=1,noa
         do j=nbmax,ioa(i)+1,-1
           if(iabs(noccup(j)).eq.1) isign=-isign
         enddo
         if(noccup(ioa(i)).eq.2) noccup(ioa(i))=-1
         if(noccup(ioa(i)).eq.1) noccup(ioa(i))=0
       enddo
       do i=1,nvb
         do j=nbmax,ivb(i)+1,-1
           if(iabs(noccup(j)).eq.1) isign=-isign
         enddo
         if(noccup(ivb(i)).eq.1) then
          noccup(ivb(i))=2
          isign=-isign
         endif
         if(noccup(ivb(i)).eq.0) noccup(ivb(i))=-1
       enddo
       do i=1,nva
         do j=nbmax,iva(i)+1,-1
           if(iabs(noccup(j)).eq.1) isign=-isign
         enddo
         if(noccup(iva(i)).eq.-1) noccup(iva(i))=2
         if(noccup(iva(i)).eq.0) noccup(iva(i))=1
       enddo
c
c     write(6,*) (noccup(i),i=1,nbmax)
c     write(6,*) (roccup(i),i=1,nbmax)
c     write(6,*) isign
c     write(6,*) nva,'    ',(iva(i),i=1,nva)
c     write(6,*) nvb,'    ',(ivb(i),i=1,nvb)
c     write(6,*) noa,'    ',(ioa(i),i=1,noa)
c     write(6,*) nob,'    ',(iob(i),i=1,nob)
C Read important arrays of the ref det
      rewind(scrfile6)
      write(scrfile6) tarec
      open(stfile,status='unknown',access='direct',recl=irecln)
      rewind(snfile)
      read(snfile) jconf
      read(snfile) jrec
      read(snfile) iarcrec
      read(snfile) itr
      read(snfile) tarec
      read(snfile) jstr
      read(snfile) absinv
      read(snfile) mosymvo
      open(tmfile,status='unknown',access='direct',recl=nir**4*iintln)
      open(tfile,status='unknown',access='direct',recl=irecln)
      call filezero(scrfile5,1,trecmax)
C Loop over excitations
      ssym=isym
       if(calc.eq.1) ssym=1
       do nex=0,mrop
         do iactv=max(0,nex-mrop),min(nactv,nex)
           do iacto=max(0,nex-mrop),min(nacto,nex)
             do i1=0,nex
               do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                iactvb=iactv-iactva
                 do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                  iactob=iacto-iactoa
                  nn=nconf(iactva,iactvb,iactoa,iactob,i1,nex)
c                  if(nn.gt.0) then
                   if(nn.gt.0.and.(iactva.ne.i1.or.iactvb.ne.
     $nex-i1.or.iactoa.ne.i1.or.iactob.ne.nex-i1)) then
                    nampvirtal=i1
                    nampvirtbe=nex-nampvirtal
                    nampoccal=i1
                    nampoccbe=nex-nampoccal
                    call dfillzero(f(1),nn)
C
               do jactva=max(0,iactva-noa),min(nactva,iactva+nva)
                 do jactvb=max(0,iactvb-nob),min(nactvb,iactvb+nvb)
                  jampvirtal=nampvirtal-iactva+jactva
                  jampvirtbe=nampvirtbe-iactvb+jactvb
                  jactoa=jampvirtal-nampoccal+iactoa
                  jactob=jampvirtbe-nampoccbe+iactob
                  jex=jampvirtal+jampvirtbe
       if(jex.le.op.and.jampvirtal.ge.0.and.jampvirtbe.ge.0.and.
     $jampvirtal.le.min(nvirtal,nal).and.jampvirtbe.le.min(nvirtbe,nbe)
     $.and.jactoa.ge.max(0,iactoa-nva).and.
     $jactoa.le.min(nactoa,iactoa+noa).and.jactob.ge.max(0,iactob-nvb)
     $.and.jactob.le.min(nactob,iactob+nob)) then
        jn=jconf(jactva,jactvb,jactoa,jactob,jampvirtal,jex)
         if(jn.gt.0) then
          isign1=1
c          if(mod(jampvirtbe*jampvirtal,2).eq.1) isign1=-isign1
           if(mod(nampvirtbe*nampvirtal,2).eq.1) isign1=-isign1
           if(mod((jampvirtal-1)*jampvirtal/2+
     $            (jampvirtbe-1)*jampvirtbe/2,2).eq.1) isign1=-isign1
           if(mod((nampvirtal-1)*nampvirtal/2+
     $            (nampvirtbe-1)*nampvirtbe/2,2).eq.1) isign1=-isign1
          call getlst(cfile,
     $jrec(jactva,jactvb,jactoa,jactob,jampvirtal,jex),f(nn+1),jn)
c     write(6,*) 'jex',jex,jampvirtal,jampvirtbe,jactva,jactvb,jactoa,
c    $jactob,'   ',jn
C
      jmem=intadd(ioffs+jn+nn)
      jmva=jmem
      jmem=jmem+(nvirtal+1)*(jampvirtal+1)
      call getint(stfile,iarcrec(jactva,jampvirtal,1),icore(jmva),
     $(nvirtal+1)*(jampvirtal+1))
      jmvb=jmem
      jmem=jmem+(nvirtbe+1)*(jampvirtbe+1)
      call getint(stfile,iarcrec(jactvb,jampvirtbe,2),icore(jmvb),
     $(nvirtbe+1)*(jampvirtbe+1))
      jmoa=jmem
      jmem=jmem+(nal+1)*(jampvirtal+1)
      call getint(stfile,iarcrec(jactoa,jampvirtal,3),icore(jmoa),
     $(nal+1)*(jampvirtal+1))
      jmob=jmem
      jmem=jmem+(nbe+1)*(jampvirtbe+1)
      call getint(stfile,iarcrec(jactob,jampvirtbe,4),icore(jmob),
     $(nbe+1)*(jampvirtbe+1))
      jtva=jmem
      jmem=jmem+itr(2,jactva,jampvirtal,1)
      call getint(stfile,itr(1,jactva,jampvirtal,1),icore(jtva),
     $itr(2,jactva,jampvirtal,1))
      jtvb=jmem
      jmem=jmem+itr(2,jactvb,jampvirtbe,2)
      call getint(stfile,itr(1,jactvb,jampvirtbe,2),icore(jtvb),
     $itr(2,jactvb,jampvirtbe,2))
      jtoa=jmem
      jmem=jmem+itr(2,jactoa,jampvirtal,3)
      call getint(stfile,itr(1,jactoa,jampvirtal,3),icore(jtoa),
     $itr(2,jactoa,jampvirtal,3))
      jtob=jmem
      jmem=jmem+itr(2,jactob,jampvirtbe,4)
      call getint(stfile,itr(1,jactob,jampvirtbe,4),icore(jtob),
     $itr(2,jactob,jampvirtbe,4))
      read(tmfile,rec=tarec(jactva,jactvb,jactoa,jactob,jampvirtal,jex))
     $ita
C
              ii=1
               do ir=1,nir
                isymv=csympair(ssym,ir,1)
                isymo=csympair(ssym,ir,2)
                 do irv=1,isympv(0,isymv,iactva,iactvb,nampvirtal,
     $nampvirtbe,1)
      isymva=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,1)
      isymvb=isympv(irv,isymv,iactva,iactvb,nampvirtal,nampvirtbe,2)
                  n1=nstr(isymva,iactva,nampvirtal,1)
                  n2=nstr(isymvb,iactvb,nampvirtbe,2)
                  k=n1*n2
                   do iro=1,isympo(0,isymo,iactoa,iactob,nampoccal,
     $nampoccbe,1)
      isymoa=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,1)
      isymob=isympo(iro,isymo,iactoa,iactob,nampoccal,nampoccbe,2)
                    n3=nstr(isymoa,iactoa,nampoccal,3)
                    n4=nstr(isymob,iactob,nampoccbe,4)
c     write(6,*) 'nex',nex,nampvirtal,nampvirtbe,iactva,iactvb,iactoa,
c    $iactob,'   ',nn
      call strread(nn1,nn2,nn3,nn4,n1,n2,n3,n4,nampvirtal,nampvirtbe,
     $nampoccal,nampoccbe,isymva,isymvb,isymoa,isymob,iactva,iactvb,
     $iactoa,iactob,nnir,nactm,nmax,irec,jj,dbladd(jmem))
      call mrconv(nampvirtal,nampvirtbe,nampoccal,nampoccbe,n1,n2,n3,
     $n4,icore(nn1),icore(nn2),icore(nn3),icore(nn4),f(ii),nbmax,
     $absind,noccup,nva,nvb,noa,nob,iva,ivb,ioa,iob,f(nn+1),iactva,
     $iactvb,iactoa,iactob,jactva,jactvb,jactoa,jactob,
     $icore(jmva),icore(jmvb),icore(jmoa),icore(jmob),icore(jtva),
     $icore(jtvb),icore(jtoa),icore(jtob),jampvirtal,jampvirtbe,
     $jampvirtal,jampvirtbe,ita,isign1,jstr,nir,nactm,nmax,absinv,
     $mosymvo,roccup)
                    ii=ii+n3*n4*k
                   enddo
                 enddo
               enddo
C
         endif
       endif
                 enddo
               enddo
C
              call add(f,f,nn,3,1,1.d0/coef,1.d0)
              call putlst(scrfile5,
     $trec(iactva,iactvb,iactoa,iactob,i1,nex),f(1),nn)
                   endif
                 enddo
               enddo
             enddo
           enddo
         enddo
       enddo
C
      rewind(scrfile6)
      read(scrfile6) tarec
      close(scrfile6,status='delete')
      close(tmfile)
C
      return
      end
C
************************************************************************
      subroutine savemr(nnir,nmax,nactm,nconf,trec,iarcrec,itr,tarec,
     $nstr,absind,nb,absinv,mosymvo)
************************************************************************
* Save important arrays corresponding to the abs Fermi-vacuum          *
************************************************************************
#include "MRCCCOMMON"
      integer nnir,nmax,nactm,nb,i,j
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iarcrec(0:nactm,0:nmax,4),itr(2,0:nactm,0:nmax,4)
      integer tarec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer nstr(nnir,0:nactm,0:nmax,4),absind(nb,-3:0)
      integer absinv(nb,-3:0),mosymvo(nb,4)
c     write(6,*) 'savemr'
c     write(6,*) 'nactm',nactm,nmax
C Save data
      open(stfile,status='unknown',access='direct',recl=irecln)
      call savevec(strfile,stfile,istrc-1,0,0)
      close(stfile)
      rewind(snfile)
      write(snfile) nconf
      write(snfile) trec
      write(snfile) iarcrec
      write(snfile) itr
      write(snfile) tarec
      write(snfile) nstr
      write(snfile) absinv
      write(snfile) mosymvo

C
      return
      end
C
************************************************************************
      subroutine mrconv(nva,nvb,noa,nob,nvstral,nvstrbe,nostral,nostrbe,
     $istrva,istrvb,istroa,istrob,tnew,nbmax,absind,noccup,jva,jvb,joa,
     $job,iva,ivb,ioa,iob,told,iactva,iactvb,iactoa,iactob,jactva,
     $jactvb,jactoa,jactob,irva,irvb,iroa,irob,itrva,itrvb,itroa,
     $itrob,jvstral,jvstrbe,jostral,jostrbe,ita,isign,jstr,nnir,nactm,
     $nmax,absinv,mosymvo,roccup)
************************************************************************
* Converts CI coefficients corresponding to different Fermi-vacua      *
************************************************************************
#include "MRCCCOMMON"
      integer*1 isign,isgva,isgvb,isgoa,isgob
      integer nva,nvb,noa,nob,nvstral,nvstrbe,nostral,nostrbe,ii,nbmax
      integer i,j,ivstral,ivstrbe,iostral,iostrbe,absind(2*nbmax,-3:0)
      integer istrva(nva,nvstral),istrvb(nvb,nvstrbe),noccup(*)
      integer istroa(noa,nostral),istrob(nob,nostrbe),isymva,isymvb
      integer jva,jvb,joa,job,iva(*),ivb(*),ioa(*),iob(*),isymoa,isymob
      integer iiva(jva),iivb(jvb),iioa(joa),iiob(job),iaddbe,ita(*)
      integer nnva,nnvb,nnoa,nnob,jjva,jjvb,jjoa,jjob,nn1,nn2,nn3,nn4
      integer iactva,iactvb,iactoa,iactob,jactva,jactvb,jactoa,jactob
      integer ivsa(nva+jva),ivsb(nvb+jvb),iosa(noa+joa),iosb(nob+job)
      integer iiosa(noa+joa),iiosb(nob+job),irva,irvb,iroa,irob
      integer isva,isoa,isvb,isob,itrva,itroa,itrvb,itrob,imoa,imob
      integer jvstral,jvstrbe,jostral,jostrbe,isadbe,nactm,nmax,nnir
      integer jstr(nnir,0:nactm,0:nmax,4),absinv(2*nbmax,-3:0)
      integer mosymvo(2*nbmax,-3:0),roccup(*)
      real*8 tnew(*),told(*)
      logical log,lll
C
      ii=0
       do iostrbe=1,nostrbe
        call costro(jjvb,jvb,iivb,ivb,nob,iactob,iosb,absind(1,0),
     $istrob(1,iostrbe),nnob,imob,isgob,'b',nbasis,noccup)
        isgob=isign*isgob
c        if(mod(jva*(jvb+jjvb),2).eq.1) isgob=-isgob
         do iostral=1,nostral
          call costro(jjva,jva,iiva,iva,noa,iactoa,iosa,absind(1,-1),
     $istroa(1,iostral),nnoa,imoa,isgoa,'a',nbasis,noccup)
          isgoa=isgob*isgoa
c          if(mod(nnob*(jva+jjva),2).eq.1) isgoa=-isgoa
           do ivstrbe=1,nvstrbe
            call costrv(jjob,job,iiob,iob,nvb,iactvb,ivsb,absind(1,-2),
     $istrvb(1,ivstrbe),nnvb,jjvb,iivb,jactvb,lll,iosb,iiosb,nnob,
     $iactob-imob,mult,nirmax,isymvb,isymob,irvb,irob,nvirtbe,nbe,
     $isvb,isob,itrvb,itrob,isgvb,jactob,absinv(1,-2),absinv(1,0),
     $mosymvo(1,-2),mosymvo(1,0),'b',nbasis,noccup,roccup,
     $max(nvb+jvb,nob+job))
             if(lll) then
              isgvb=isgoa*isgvb
c              if(mod(jjvb*(jjva+nnob+nnoa)+job*(joa+jjva+nnob+nnoa+
c    $jjvb)+jjob*(jjvb+nnoa),2).eq.1) isgvb=-isgvb
              isadbe=isymob*nr3+isymvb*nir+nrr
              nn4=jstr(isymvb,jactvb,jvstrbe,2)
               do ivstral=1,nvstral
            call costrv(jjoa,joa,iioa,ioa,nva,iactva,ivsa,absind(1,-3),
     $istrva(1,ivstral),nnva,jjva,iiva,jactva,lll,iosa,iiosa,nnoa,
     $iactoa-imoa,mult,nirmax,isymva,isymoa,irva,iroa,nvirtal,nal,
     $isva,isoa,itrva,itroa,isgva,jactoa,absinv(1,-3),absinv(1,-1),
     $mosymvo(1,-3),mosymvo(1,-1),'a',nbasis,noccup,roccup,
     $max(nva+jva,noa+joa))
                ii=ii+1
                 if(lll) then
                  isgva=isgvb*isgva
c                  if(mod(joa*(nnvb+jjvb+nnoa+jjob+nnob+jjva)+
c    $jjoa*(nnvb+jjvb)+jjva*(nnvb+jjvb+jjoa+nnoa+jjob+nnob),2).eq.1) 
c    $isgva=-isgva
                  nn3=jstr(isymva,jactva,jvstral,1)
                  nn2=nn4*nn3
                  nn1=nn2*jstr(isymoa,jactoa,jostral,3)
                  tnew(ii)=isgva*told(ita(isadbe+isymoa*nr2+isymva)+
     $(isob-1)*nn1+(isoa-1)*nn2+(isvb-1)*nn3+isva-1)
                   do i=1,nva
                     if(noccup(absind(istrva(i,ivstral),-3)).eq.2)
     $noccup(absind(istrva(i,ivstral),-3))=-1
                     if(noccup(absind(istrva(i,ivstral),-3)).eq.1) 
     $noccup(absind(istrva(i,ivstral),-3))=0
                   enddo
C
                   do i=1,jvstral
                     if(roccup(ivsa(i)).eq.2) roccup(ivsa(i))=-1
                     if(roccup(ivsa(i)).eq.1) roccup(ivsa(i))=0
                   enddo
                   do i=1,jostral
                     if(roccup(iiosa(i)).eq.-1) roccup(iiosa(i))=2
                     if(roccup(iiosa(i)).eq.0) roccup(iiosa(i))=1
                   enddo
                 endif
C
               enddo
               do i=1,nvb
                 if(noccup(absind(istrvb(i,ivstrbe),-2)).eq.2)
     $noccup(absind(istrvb(i,ivstrbe),-2))=1
                 if(noccup(absind(istrvb(i,ivstrbe),-2)).eq.-1) 
     $noccup(absind(istrvb(i,ivstrbe),-2))=0
               enddo
C
               do i=1,jvstrbe
                 if(roccup(ivsb(i)).eq.2) roccup(ivsb(i))=1
                 if(roccup(ivsb(i)).eq.-1) roccup(ivsb(i))=0
               enddo
               do i=1,jostrbe
                 if(roccup(iiosb(i)).eq.1) roccup(iiosb(i))=2
                 if(roccup(iiosb(i)).eq.0) roccup(iiosb(i))=-1
               enddo
             else
              ii=ii+nvstral
             endif
C
           enddo
           do i=1,noa
             if(noccup(absind(istroa(i,iostral),-1)).eq.-1) 
     $noccup(absind(istroa(i,iostral),-1))=2
             if(noccup(absind(istroa(i,iostral),-1)).eq.0) 
     $noccup(absind(istroa(i,iostral),-1))=1
           enddo
         enddo
         do i=1,nob
           if(noccup(absind(istrob(i,iostrbe),0)).eq.1) 
     $noccup(absind(istrob(i,iostrbe),0))=2
           if(noccup(absind(istrob(i,iostrbe),0)).eq.0) 
     $noccup(absind(istrob(i,iostrbe),0))=-1
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine costro(jjvb,jvb,iivb,ivb,nob,iactob,iosb,absind,istrob,
     $nnob,jj,isgob,sp,nbasis,noccup)
************************************************************************
* Compare excitation strings and the strings generating the ref det    *
************************************************************************
      implicit none
      integer*1 isgob
      integer jjvb,jvb,iivb(*),ivb(*),nob,iactob,iosb(*),absind(*)
      integer istrob(*),nnob,i,j,k,jj,kk,nbasis,noccup(*)
      logical log
      character*1 sp
C
      isgob=1
      jjvb=jvb
       do i=1,jvb
        iivb(i)=ivb(i)
       enddo
       do i=1,nob-iactob
        iosb(i)=absind(istrob(i))
       enddo
      jj=0
       do i=nob-iactob+1,nob
        kk=absind(istrob(i))
        log=.false.
        j=0
         do while(.not.log.and.j.lt.jjvb)
          j=j+1
           if(iivb(j).eq.kk) then
            log=.true.
c            if(mod(jjvb-j,2).eq.1) isgob=-isgob
            jjvb=jjvb-1
             do k=j,jjvb
              iivb(k)=iivb(k+1)
             enddo
           endif
         enddo
         if(log) then
          jj=jj+1
c          if(mod(nob-iactob+i-jj,2).eq.1) isgob=-isgob
         else
          iosb(i-jj)=kk
         endif
       enddo
      nnob=nob-jj
C
       do i=1,nob
         do j=nbasis/2,absind(istrob(i))+1,-1
           if(iabs(noccup(j)).eq.1) isgob=-isgob
         enddo
         if(sp.eq.'b') then
           if(noccup(absind(istrob(i))).eq.2) then
            noccup(absind(istrob(i)))=1
            isgob=-isgob
           endif
       if(noccup(absind(istrob(i))).eq.-1) noccup(absind(istrob(i)))=0
         else
       if(noccup(absind(istrob(i))).eq.2) noccup(absind(istrob(i)))=-1
       if(noccup(absind(istrob(i))).eq.1) noccup(absind(istrob(i)))=0
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine costrv(jjvb,jvb,iivb,ivb,nob,iactob,iosb,absind,istrob,
     $nnob,jjvb2,iivb2,jactvb,lll,iiosb,iiiosb,nnnob,iiactob,mult,
     $nirmax,isymvb,isymob,irvb,irob,nvi,noc,isvb,isob,itrvb,itrob,
     $isgvb,jactob,ainvvb,ainvob,msymvb,msymob,sp,nbasis,noccup,roccup,
     $nsc)
************************************************************************
* Compare excitation strings and the strings generating the ref det    *
************************************************************************
      implicit none
      integer*1 isgvb
      integer jjvb,jvb,iivb(*),ivb(*),nob,iactob,iosb(*),absind(*),nsc
      integer istrob(*),nnob,i,j,k,jj,kk,jjvb2,iivb2(*),jactvb,isymvb
      integer iiosb(*),iiiosb(*),nnnob,iiactob,nfvb,nfob,isymob,nbasis
      integer nirmax,mult(nirmax,nirmax),irvb,irob,nvi,noc,isvb,isob
      integer itrvb,itrob,jactob,ainvvb(*),ainvob(*),msymvb(*),msymob(*)
      integer noccup(*),roccup(*),iscr(nsc)
      logical log,lll
      character*1 sp
C
      isgvb=1
      lll=.true.
      jjvb=jvb
       do i=1,jjvb2
        iosb(i)=iivb2(i)
       enddo
       do i=1,jvb
        iivb(i)=ivb(i)
       enddo
      jj=0
       do i=1,iactob
        kk=absind(istrob(i))
        log=.false.
        j=0
         do while(.not.log.and.j.lt.jjvb)
          j=j+1
           if(iivb(j).eq.kk) then
            log=.true.
c            if(mod(jjvb-j,2).eq.1) isgvb=-isgvb
            jjvb=jjvb-1
             do k=j,jjvb
              iivb(k)=iivb(k+1)
             enddo
           endif
         enddo
         if(log) then
          jj=jj+1
c          if(mod(i-jj,2).eq.1) isgvb=-isgvb
         else
          iosb(jjvb2+i-jj)=kk
         endif
       enddo
      nnob=nob-jj
       do i=iactob+1,nob
        iosb(jjvb2+i-jj)=absind(istrob(i))
       enddo
       if(jjvb2+iactob-jj.ne.jactvb) then
        lll=.false.
        return
       endif
C Virtual beta strings in iosb
      log=.true.
       do while(log)
        log=.false.
         do i=1,jactvb-1
           if(iosb(i).gt.iosb(i+1)) then
c           isgvb=-isgvb
            k=iosb(i)
            iosb(i)=iosb(i+1)
            iosb(i+1)=k
            log=.true.
           endif
         enddo
       enddo
      nfvb=nob-iactob+jactvb
       do i=1,nfvb
        iscr(i)=ainvvb(iosb(i))
       enddo
      call stranal1(iscr  ,nfvb,msymvb,irvb,nvi,itrvb,isymvb,isvb,mult,
     $nirmax)
C Occupied beta strings in iiiosb
       do i=1,nnnob
        iiiosb(i)=iiosb(i)
       enddo
       do i=1,jjvb
        iiiosb(nnnob+i)=iivb(i)
       enddo
       if(jjvb+iiactob.ne.jactob) then
        lll=.false.
        return
       endif
      log=.true.
       do while(log)
        log=.false.
         do i=nnnob-iiactob+1,nnnob-iiactob+jactob-1
           if(iiiosb(i).gt.iiiosb(i+1)) then
c           isgvb=-isgvb
            k=iiiosb(i)
            iiiosb(i)=iiiosb(i+1)
            iiiosb(i+1)=k
            log=.true.
           endif
         enddo
       enddo
      nfob=nnnob+jjvb
       do i=1,nfob
        iscr(i)=ainvob(iiiosb(i))
       enddo
      call stranal1(iscr,nfob,msymob,irob,noc,itrob,isymob,isob,mult,
     $nirmax)
C Sign of occ  be excitations wrt the abs Fermi-vacuum
       do i=1,nfob
         do j=nbasis/2,iiiosb(i)+1,-1
           if(iabs(roccup(j)).eq.1) isgvb=-isgvb
         enddo
         if(sp.eq.'b') then
           if(roccup(iiiosb(i)).eq.2) then
            roccup(iiiosb(i))=1
            isgvb=-isgvb
           endif
           if(roccup(iiiosb(i)).eq.-1) roccup(iiiosb(i))=0
         else
           if(roccup(iiiosb(i)).eq.2) roccup(iiiosb(i))=-1
           if(roccup(iiiosb(i)).eq.1) roccup(iiiosb(i))=0
         endif
       enddo
C Sign of virt be excitations wrt the abs Fermi-vacuum
       do i=1,nfvb
         do j=nbasis/2,iosb(i)+1,-1
           if(iabs(roccup(j)).eq.1) isgvb=-isgvb
         enddo
         if(sp.eq.'b') then
           if(roccup(iosb(i)).eq.1) then
            roccup(iosb(i))=2
            isgvb=-isgvb
           endif
           if(roccup(iosb(i)).eq.0) roccup(iosb(i))=-1
         else
           if(roccup(iosb(i)).eq.-1) roccup(iosb(i))=2
           if(roccup(iosb(i)).eq.0) roccup(iosb(i))=1
         endif
       enddo
C Sign of excitations wrt the current Fermi-vacuum
       do i=1,nob
         do j=nbasis/2,absind(istrob(i))+1,-1
           if(iabs(noccup(j)).eq.1) isgvb=-isgvb
         enddo
         if(sp.eq.'b') then
           if(noccup(absind(istrob(i))).eq.1) then
            noccup(absind(istrob(i)))=2
            isgvb=-isgvb
           endif
       if(noccup(absind(istrob(i))).eq.0) noccup(absind(istrob(i)))=-1
         else
       if(noccup(absind(istrob(i))).eq.-1) noccup(absind(istrob(i)))=2
       if(noccup(absind(istrob(i))).eq.0) noccup(absind(istrob(i)))=1
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine mrszemet(file,nconf,nmax,nactm,trec,v,irec,wspc,wsmax,
     $denrec,econf,erec)
************************************************************************
* Szemet rutin tesztelesre
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,i,k,l,m,n,nn,iw,wsmax,wspc(0:wsmax,13),ii,mm
      integer denrec(*)
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactvb,iactob,iactv,iacto,iactva,iactoa,file,irec
      real*8 v(*),sum,sum1
C
      return
#if defined (MPI)
       if(rank.ne.0) return
#endif
      write(6,*)
      write(6,*) 'szemet'
      sum=0.d0
      sum1=0.d0
       if(densroute) then
         do i=ptsh+1,ptsh+iimed
          ii=i-ptsh
           if(dens.gt.1.or.nops(ii).eq.2) then
             do iw=1,wspc(0,i)
              write(6,"(i3,11i2,9i4)") ii,(wspc((iw-1)*12+k,i),k=1,12),
     $denrec(ii),denrec(ii)+wspc((iw-1)*12+11,i),drecmax,i
              call getlst(file,denrec(ii)+wspc((iw-1)*12+11,i),v(1),
     $wspc((iw-1)*12+12,i))
              write(6,347) (v(k),k=1,wspc((iw-1)*12+12,i))
               do k=1,wspc((iw-1)*12+12,i)
                sum=sum+v(k)**2
                sum1=max(sum1,dabs(v(k)))
               enddo
             enddo
           endif
         enddo
       else
         do i=0,op
           do iactv=max(0,i-mrop),min(nactv,i)
             do iacto=max(0,i-mrop),min(nacto,i)
               do i1=0,i
                nn=0
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                     if(isym.eq.isy1.or.(eomcc.and.iroot.eq.1)) then
                      nn=nn+nconf(iactva,iactvb,iactoa,iactob,i1,i)
                     else
                      nn=nn+econf(iactva,iactvb,iactoa,iactob,i1,i)
                     endif
                   enddo
                 enddo
                 if(nn.gt.0) write(6,458) i,i1
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                     if(isym.eq.isy1.or.(eomcc.and.iroot.eq.1)) then
                      nn=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= trec(iactva,iactvb,iactoa,iactob,i1,i)
                     else
                      nn=econf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= erec(iactva,iactvb,iactoa,iactob,i1,i)
                     endif
c     write(6,*) 'nnn',i,i1,iactva,iactvb,iactoa,iactob,nn
                     if(nn.gt.0) then
                      call getlst(file,irec+mm,v(1),nn)
      write(6,347) (v(k),k=1,nn)
                       if(i.ge.0.or.calc.eq.0.or.eomroute) then
c                      if(i.gt.0.or.calc.eq.0.or.eomroute) then
                         do k=1,nn
                          sum=sum+v(k)**2
                          sum1=max(sum1,dabs(v(k)))
                         enddo
                       endif
                     endif
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       endif
      write(6,*)
      write(6,*) 'Euc norm:',dsqrt(sum)
      write(6,*) 'Max norm:',sum1
      write(6,*)
458   format(20i2)
347   format(4f16.10)
C
      return
      end
C
#if defined (Q5Cost)
************************************************************************
      subroutine get_occ_num(q5file,occ_num,iq5err,nb)
************************************************************************
* Reads occupation vector form Q5Cost file
************************************************************************
      use q5cost
      use hdf5
      implicit none
      integer q5file,iq5err,nb
      real*8 occ_num(nb)
C
      call Q5Cost_MO_get_occ_num(q5file,occ_num,iq5err)
C
      return
      end
C
#endif
************************************************************************
      subroutine freeze(i1,i2,i3,i4,itrans,nuc,sum,hmat,lll,nbmax)
************************************************************************
* Freeze orbitals in the case of Q5Cost interface
************************************************************************
      implicit none
      integer i1,i2,i3,i4,itrans(*),nbmax
      real*8 nuc,sum,hmat(nbmax,nbmax)
      logical lll
C
      i1=itrans(i1)
      i2=itrans(i2)
      i3=itrans(i3)
      i4=itrans(i4)
C
      lll=.false.
c     read(nlist,*) sum,i1,i2,i3,i4   ! in (11|22) format
       if(i1.eq.0.or.i2.eq.0.or.i3.eq.0.or.i4.eq.0) then
         if(i1.eq.0.and.i2.eq.0.and.i3.eq.0.and.i4.eq.0) then
           if(i1.eq.i2.and.i3.eq.i4) then
            nuc=nuc+2.d0*sum
             if(i2.ne.i3) nuc=nuc+2.d0*sum
           endif
           if(i1.eq.i4.and.i2.eq.i3) then
            nuc=nuc-sum
             if(i1.ne.i2) nuc=nuc-sum
           endif
           if(i2.eq.i4.and.i1.eq.i3.and.i1.ne.i2) then
            nuc=nuc-2.d0*sum
           endif
         else
           if(i1.ne.0.and.i2.ne.0.and.i3.eq.0.and.i4.eq.0.and.i3.eq.i4)
     $then
            hmat(i1,i2)=hmat(i1,i2)+2.d0*sum
             if(i1.ne.i2) hmat(i2,i1)=hmat(i2,i1)+2.d0*sum
           endif
           if(i1.eq.0.and.i2.eq.0.and.i3.ne.0.and.i4.ne.0.and.i1.eq.i2) 
     $then
            hmat(i3,i4)=hmat(i3,i4)+2.d0*sum
             if(i3.ne.i4) hmat(i4,i3)=hmat(i4,i3)+2.d0*sum
           endif
           if(i1.ne.0.and.i2.eq.0.and.i3.eq.0.and.i4.ne.0.and.i2.eq.i3) 
     $then
            hmat(i1,i4)=hmat(i1,i4)-sum
             if(i1.ne.i4) hmat(i4,i1)=hmat(i4,i1)-sum
           endif
           if(i1.ne.0.and.i2.eq.0.and.i3.ne.0.and.i4.eq.0.and.i2.eq.i4) 
     $then
            hmat(i1,i3)=hmat(i1,i3)-sum
             if(i1.ne.i3) hmat(i3,i1)=hmat(i3,i1)-sum
           endif
           if(i1.eq.0.and.i2.ne.0.and.i3.eq.0.and.i4.ne.0.and.i1.eq.i3) 
     $then
            hmat(i2,i4)=hmat(i2,i4)-sum
             if(i2.ne.i4) hmat(i4,i2)=hmat(i4,i2)-sum
           endif
           if(i1.eq.0.and.i2.ne.0.and.i3.ne.0.and.i4.eq.0.and.i1.eq.i4) 
     $then
            hmat(i2,i3)=hmat(i2,i3)-sum
             if(i2.ne.i3) hmat(i3,i2)=hmat(i3,i2)-sum
           endif
         endif
       else
        lll=.true.
       endif
C
      return
      end
C
************************************************************************
      subroutine nconfout1(i,isum)
************************************************************************
* Prints the excitation level and the number of excitations            *
************************************************************************
#include "MRCCCOMMON"
      integer i,isum
      real*8 dsum
C
       if(i.gt.9) then
        write(iout,*) 'Number of',i,'-fold excitations: ',isum
       else
        dsum=dble(isum)
         if(dsum.lt.10.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i2)") i,isum
         else if(dsum.lt.100.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i3)") i,isum
         else if(dsum.lt.1000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i4)") i,isum
         else if(dsum.lt.10000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i5)") i,isum
         else if(dsum.lt.100000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i6)") i,isum
         else if(dsum.lt.1000000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i7)") i,isum
         else if(dsum.lt.10000000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i8)") i,isum
         else if(dsum.lt.100000000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i9)") i,isum
         else if(dsum.lt.1000000000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i10)")i,isum
         else if(dsum.lt.10000000000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i11)")i,isum
         else if(dsum.lt.100000000000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i12)")i,isum
         else if(dsum.lt.1000000000000.d0) then
          write(iout,"(' Number of',i2,'-fold excitations:',i13)")i,isum
         else
          write(iout,"(' Number of',i2,'-fold excitations:',i14)")i,isum
         endif
       endif
C
      return
      end
C
************************************************************************
      subroutine nconfout2(chrt,isum)
************************************************************************
* Prints the excitation level and the number of excitations            *
************************************************************************
#include "MRCCCOMMON"
      integer isum
      character*30 chrt
      real*8 dsum
C
      dsum=dble(isum)
       if(dsum.lt.10.d0) then
        write(iout,"(a30,i2)") chrt,isum
       else if(dsum.lt.100.d0) then
        write(iout,"(a30,i3)") chrt,isum
       else if(dsum.lt.1000.d0) then
        write(iout,"(a30,i4)") chrt,isum
       else if(dsum.lt.10000.d0) then
        write(iout,"(a30,i5)") chrt,isum
       else if(dsum.lt.100000.d0) then
        write(iout,"(a30,i6)") chrt,isum
       else if(dsum.lt.1000000.d0) then
        write(iout,"(a30,i7)") chrt,isum
       else if(dsum.lt.10000000.d0) then
        write(iout,"(a30,i8)") chrt,isum
       else if(dsum.lt.100000000.d0) then
        write(iout,"(a30,i9)") chrt,isum
       else if(dsum.lt.1000000000.d0) then
        write(iout,"(a30,i10)") chrt,isum
       else if(dsum.lt.10000000000.d0) then
        write(iout,"(a30,i11)") chrt,isum
       else if(dsum.lt.100000000000.d0) then
        write(iout,"(a30,i12)") chrt,isum
       else if(dsum.lt.1000000000000.d0) then
        write(iout,"(a30,i13)") chrt,isum
       else
        write(iout,"(a30,i14)") chrt,isum
       endif
C
      return
      end
C
************************************************************************
      subroutine nszemet(file,nconf,nmax,nactm,trec,v,irec,wspc,wsmax,
     $denrec,econf,erec)
************************************************************************
* Szemet rutin tesztelesre
************************************************************************
#include "MRCCCOMMON"
      integer nmax,nactm,i,k,l,m,n,nn,iw,wsmax,wspc(0:wsmax,13),ii,mm
      integer denrec(*)
      integer nconf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer trec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer econf(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer erec(0:nactm,0:nactm,0:nactm,0:nactm,0:nmax,0:nmax)
      integer iactvb,iactob,iactv,iacto,iactva,iactoa,file,irec
      real*8 v(*),sum,sum1
C
c      if(iroot.ne.2) return
c     return
#if defined (MPI)
       if(rank.ne.0) return
#endif
      write(6,*)
      write(6,*) 'szemet',ptsh
      sum=0.d0
      sum1=0.d0
       if(densroute) then
         do i=ptsh+1,ptsh+iimed
          ii=i-ptsh
           if(dens.gt.1.or.nops(ii).eq.2) then
             do iw=1,wspc(0,i)
              write(6,"(i3,11i2,9i4)") ii,(wspc((iw-1)*12+k,i),k=1,12),
     $denrec(ii),denrec(ii)+wspc((iw-1)*12+11,i),drecmax,i
              call getlst(file,denrec(ii)+wspc((iw-1)*12+11,i),v(1),
     $wspc((iw-1)*12+12,i))
              write(6,347) (v(k),k=1,wspc((iw-1)*12+12,i))
               do k=1,wspc((iw-1)*12+12,i)
                sum=sum+v(k)**2
                sum1=max(sum1,dabs(v(k)))
               enddo
             enddo
           endif
         enddo
       else
         do i=0,op
           do iactv=max(0,i-mrop),min(nactv,i)
             do iacto=max(0,i-mrop),min(nacto,i)
               do i1=0,i
                nn=0
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                     if(isym.eq.isy1.or.(eomcc.and.iroot.eq.1)) then
                      nn=nn+nconf(iactva,iactvb,iactoa,iactob,i1,i)
                     else
                      nn=nn+econf(iactva,iactvb,iactoa,iactob,i1,i)
                     endif
                   enddo
                 enddo
                 if(nn.gt.0) write(6,458) i,i1
                 do iactva=max(0,iactv-nactvb),min(nactva,i1,iactv)
                  iactvb=iactv-iactva
                   do iactoa=max(0,iacto-nactob),min(nactoa,i1,iacto)
                    iactob=iacto-iactoa
                     if(isym.eq.isy1.or.(eomcc.and.iroot.eq.1)) then
                      nn=nconf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= trec(iactva,iactvb,iactoa,iactob,i1,i)
                     else
                      nn=econf(iactva,iactvb,iactoa,iactob,i1,i)
                      mm= erec(iactva,iactvb,iactoa,iactob,i1,i)
                     endif
                     if(nn.gt.0) then
                      call getlst(file,irec+mm,v(1),nn)
                       if(i.eq.1) then
                        call dfillzero(v(1),nn)
                        call putlst(file,irec+mm,v(1),nn)
                       endif
                       if(i.ge.0.or.calc.eq.0.or.eomroute) then
c                      if(i.gt.0.or.calc.eq.0.or.eomroute) then
                         do k=1,nn
                          sum=sum+v(k)**2
                          sum1=max(sum1,dabs(v(k)))
                         enddo
                       endif
                     endif
                   enddo
                 enddo
               enddo
             enddo
           enddo
         enddo
       endif
      write(6,*)
      write(6,*) 'Euc norm:',dsqrt(sum)
      write(6,*) 'Max norm:',sum1
      write(6,*)
458   format(20i2)
347   format(4f16.10)
C
      return
      end
C
************************************************************************
      subroutine strorder(str,n)
************************************************************************
* Arranges intger sequences into ascending order
************************************************************************
#include "MRCCCOMMON"
      integer str(*),n,i,j
      logical log
C
      log=.true.
       do while(log)
        log=.false.
         do i=1,n-1
           if(str(i).gt.str(i+1)) then
            log=.true.
            j=str(i)
            str(i)=str(i+1)
            str(i+1)=j
           else if(str(i).eq.str(i+1)) then
            write(iout,*) 'Corrupted initial guess!'
            write(iout,*) 'Invalid excitation operator!'
            call mrccend(1)
           endif
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine npropdet
************************************************************************
* Determine the number of properties 
************************************************************************
#include "MRCCCOMMON"
      integer iprop
      logical ll
      character*32 chscr
C
      nprop=1
       if(dens.eq.0) return
       if(rel.eq.2) then
        nprop=0
        inquire(file='MDPROP',exist=ll)
         if(ll) then
          open(mrconeefile,file='MDPROP',form='UNFORMATTED')
           do
            read(mrconeefile,end=8653) chscr
             if(chscr(25:25).eq.'X'.or.chscr(25:25).eq.'Y'.or.
     $          chscr(25:25).eq.'Z') then
              ll=.true.
               do iprop=1,nprop
                 if(propnm(iprop).eq.chscr(26:32)) ll=.false.
               enddo
               if(ll) then
                nprop=nprop+1
                propnm(nprop)=chscr(26:32)
               endif
             endif
           enddo
8653      continue
          close(mrconeefile)
           if(nprop.gt.npropmax) then
            write(iout,*) 'Too many properties!'
            call mrccend(1)
           endif
         endif
       endif
C
      return
      end
C
************************************************************************
      subroutine omplim(n,ilo,iup)
************************************************************************
* Upper and lower limits for loops in the case of OMP
************************************************************************
#include "MRCCCOMMON"
      integer n,ilo,iup,m,rr
C
#if defined (OMP)
      m=(n-mod(n,xyzsiz1))/xyzsiz1
      rr=omp_get_thread_num()
       if(rr.eq.xyzsize) then
        iup=n
       else
        iup=(rr+1)*m
       endif
      ilo=rr*m+1
#else
      ilo=1
      iup=n
#endif
C
      return
      end
C
