***********************************************************************
      PROGRAM MAIN
************************************************************************
* Entry point of SCF program                                           *
* Author: Istvan Ladjanszki                                            *
* Budapest University of Technology and Economics                      *
* Mail: ladjanszki@mail.bme.hu                                         *
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
      character*4 route
      character*8 embed,dual
      character*32 dft,pcm
C
      integer*4 istat,chdir
      integer ios,error,parent,ierror
      logical done,lll
      character*7 c7
      character*8 c8
      character*16 c16
      character*64 c64
      character*256 files
C
      rank=0
      mpisiz1=1
#if defined (MPI)
      call mrccini_mpi
      tag=0
c      call MPI_INIT(mpierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD,rank,mpierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD,mpisiz1,mpierr)
      call MPI_COMM_GET_PARENT(parent,ierror)
c       if(parent.ne.MPI_COMM_NULL) then
c        close(iout)
c         if(rank.eq.0) open(unit=iout,file='mrcc.out',position='APPEND')
c       endif
      write(c8,'(i8)') rank
      c16='mrccdir.' // trim(adjustl(c8))
#ifdef WINTEL
      call ishell('mkdir ' // c16)
#else
      call ishell('mkdir -p ' // c16)
#endif
      if(master_thread) then
         files='fort.55 MINP KEYWD VARS'
     $// ' OEINT SYMTRA SCHOL SROOT fort.11 pids'
         inquire(file='TEDAT',exist=lll)
          if(lll) files=trim(files) // ' TEDAT*'
         inquire(file='MOLDEN',exist=lll)
          if(lll) files=trim(files) // ' MOLDEN*'
         inquire(file='DFTGRID',exist=lll)
          if(lll) files=trim(files) // ' DFTGRID'
         inquire(file='HUZPROJ',exist=lll)
          if(lll) files=trim(files) // ' HUZPROJ'
         inquire(file='S12MATold',exist=lll)
          if(lll) files=trim(files) // ' S12MATold'
         inquire(file='ROUTE',exist=lll)
          if(lll) files=trim(files) // ' ROUTE'
         inquire(file='DAO',exist=lll)
          if(lll) files=trim(files) // ' DAO'
         inquire(file='MOCOEF',exist=lll)
          if(lll) files=trim(files) // ' MOCOEF'
         inquire(file='MOCOEF_A',exist=lll)
          if(lll) files=trim(files) // ' MOCOEF_A'
         inquire(file='MOCOEF_AB',exist=lll)
          if(lll) files=trim(files) // ' MOCOEF_AB'
         inquire(file='FOCK',exist=lll)
          if(lll) files=trim(files) // ' FOCK'
         inquire(file='SCHINFO',exist=lll)
          if(lll) files=trim(files) // ' SCHINFO'
         inquire(file='SCFDENSMOCOEF',exist=lll)
          if(lll) files=trim(files) // ' SCFDENSMOCOEF'
         call getkey('scfiguess',9,c7,7)
         inquire(file='SCFDENSITIES',exist=lll)
          if(lll.or.trim(c7).eq.'sad')
     $files=trim(files) // ' SCFDENSITIES*'
         call ishell('cp ' // trim(files) // ' ' // c16 //
#ifdef WINTEL
     $         '\ 2>NUL')
         call ishell('dir /b ' // trim(files) // '>' //
     $         trim(adjustl(c16)) // '\files')
#else
     $         ' 2> /dev/null')
         call ishell('ls -1 ' // trim(files) // ' > ' //
     $         trim(adjustl(c16)) // '/files')
#endif
      end if
      istat=chdir(c16)
      call bcast_file('files',MPI_COMM_WORLD)
c send files fort.1* fort.5* and MINP to other tasks
      open(scrfile2, file = 'files')
      done = .false.
      do while(.not. done)
c        if(master_thread) read(scrfile2, *, iostat = ios) c64
         read(scrfile2, *, iostat = ios) c64
c        call MPI_Bcast(ios, 1, MPI_INTEGER, master_rank,
c    $         MPI_COMM_WORLD, error)
         if(ios .eq. 0) then
c           call MPI_Bcast(c64, 64, MPI_CHARACTER,
c    $            master_rank, MPI_COMM_WORLD, error)
c           if(.not.master_thread) write(scrfile2, *) c64
            call bcast_file(c64, MPI_COMM_WORLD)
         else
c         write(6,*) 'hehe',rank
            done = .true.
         end if
      end do
      close(scrfile2)
      mpisize=mpisiz1-1
#else
      call mrccini
#endif
      CALL SCFSETUP(dft,route,embed,dual,pcm) !SETTING UP VARIABLES
      CALL SCF(                               !CALLING SCF ROUTINE
     & DCORE(C_PTR)
     &,DCORE(P_PTR)
     &,DCORE(FOCK_PTR)
     &,DCORE(EIGENVALUE_PTR)
     &,ICORE(INDEXIRREP_PTR)
     &,ICORE(MAPPING_PTR)
     &,DCORE(SORIG_PTR)
     &,DCORE(BB_PTR)
     &,DCORE(QMAT_PTR)
     &,DCORE(RMAT_PTR)
     &,DCORE(IMEM)
     &,DCORE(IMEM)
     &,DCORE(IMEM+  nbasis**2)
     &,DCORE(IMEM+2*nbasis**2)
     &,DCORE(IMEM+3*nbasis**2)
     &,DCORE(IMEM+4*nbasis**2)
     &,ICORE(IINTPOS)
     &,ICORE(INATRANGE)
     &,DCORE(OLDQMAT_PTR)
     &,DCORE(OLDG_PTR)
     &,DCORE(SYMTRA_PTR)
     &,DCORE(SYMDENS_PTR)
     &,DCORE(SYMDENS2_PTR)
     &,DCORE(SYMQMAT_PTR)
     &,DCORE(SYMFOCK_PTR)
     &,DCORE(SYMFOCK2_PTR)
     &,DCORE(IMEM)
     &,DCORE(IMEM+nbasis**2)
     &,ICORE(MOSYM_PTR)
     &,ICORE(ALPRMAP_PTR)
     &,ICORE(BEPRMAP_PTR)
     &,ICORE(DENSMAP_PTR)
     &,DCORE(RS_PTR)
     &,ICORE(fdmind_ptr)
     &,dft,route,embed,dual,pcm)
#if defined (MPI)
c      if(master_thread) then
        call system('mv iface ..')
        call system('mv SCFDENSITIES ..')
        call system('mv MOCOEF ..')
        call system('mv FOCK* ..')
        call system('mv VARS ..')
        call system('mv KEYWD ..')
        call system('mv fort.55 ..')
         if(rank.eq.0) call system('mv MOLDEN ..')
         if(trim(embed).ne.'off') then
          call system('mv SCFDENSITIES_* ..')
          call system('mv MOCOEF_* ..')
          call system('mv OEINT ..')
          inquire(file='SCFDENSMOCOEF',exist=lll)
           if(lll) call system('mv SCFDENSMOCOEF ..')
          inquire(file='HUZPROJ',exist=lll)
           if(lll) call system('mv HUZPROJ ..')
         endif
         inquire(file='GRAD',exist=lll)
         if(trim(pcm).ne.'off'.and.lll) call system('mv GRAD ..')
        istat=chdir('..')
        call system('rm -rf ROUTE ' // c16)
c      endif
#endif
      call mrccend(0)
      END

************************************************************************
      SUBROUTINE SCF(
C ARRAY ARGUMENTS
     & C
     &,P
     &,FOCK
     &,EIGENVALUE
     &,INDEXIRREP
     &,MAPPING      
     &,SORIG
     &,BB
     &,QMAT
     &,RMAT
     &,R8HEAP
     &,I4HEAP
     &,R8HEAP1n
     &,R8HEAP2n
     &,R8HEAP3n
     &,R8HEAP4n
     &,INTPOS
     &,NATRANGE
     &,OLDQMAT
     &,OLDG
     &,SYMTRA
     &,SYMDENS
     &,SYMDENS2
     &,SYMQMAT
     &,SYMFOCK
     &,SYMFOCK2
     &,CPR
     &,CPR2
     &,MOSYM
     &,ALPRMAP
     &,BEPRMAP
     &,DENSMAP
     &,RS
     &,fdmind
     &,dft,route,embed,dual,pcm)
************************************************************************
* main subroutine for SCF calculations                                 *
************************************************************************
      use mcscf, only: mcscf_calc, build_dens, qscf_init, mcscf_energy,
     & orbitener, ip2, nact, check_grad, grad_max_norm,orbital_energies
C PREPROCESSOR INSTRUCTIONS
#include "MRCCCOMMON"
#include "SCFCOMMON"
C VARIABLES
C ARRAYS
      REAL*8 C(sqrsize2)                                                !MO COEFFITIENS
      REAL*8 P(sqrsize2)                                                !DENSITY MATRIX
      REAL*8 FOCK(sqrsize2)                                             !THE FOCKIANS 
      REAL*8 EIGENVALUE(*)                                              !EIGEVALUES CALCULATED BY DSYEV ROUTINE
      INTEGER INDEXIRREP(*)                                             !WHICH INDEX TO WHICH IRREP
      INTEGER MAPPING(*)                                                !THE ADDRESS CONVERSION ARRAY
      REAL*8 SORIG(sqrsize)                                             !ORIGINAL S MATRIX
      REAL*8 BB(EXTSTEP**2)                                             !THE DIIS SCALAR PRODUCT MATRIX  
      REAL*8 QMAT(*)
      REAL*8 RMAT(*)     
      REAL*8 R8HEAP(sqrsize2)
      real*8 r8heap1n(*),r8heap2n(*),r8heap3n(*),r8heap4n(*)  !MEMORY ABOVE STATIC VARIABLES
      INTEGER*4 I4HEAP(*)                                               !MEMORY ABOVE STATIC VARIABLES
C DIRECT SCF
      INTEGER INTPOS(3,(NBASIS+1)*NBASIS/2)                             !ARRAY FOR READING TEDAT FILE
      INTEGER NATRANGE(2,NATOMS,NBSET)                                  !ARRAY FOR READING TEDAT FILE
c difference fock building
      real*8 oldg(*)
      real*8 oldqmat(sqrsize)
c ao initial guess
c non symmetry adapted arrays
      real*8 symtra(nbasis,nbasis)                                      !symmetry transformation matrix    
      real*8 symdens(nbasis,nbasis)                                     !full density matrix (alpha or closed)
      real*8 symdens2(nbasis,nbasis)                                    !full density matrix (beta)
      real*8 symqmat(nbasis,nbasis)
      real*8 symfock(nbasis,nbasis)                                     !full fock matrix (alpha or closed)
      real*8 symfock2(nbasis,nbasis)                                    !full fock matrix (beta) 
c semicanonical rohf
c density minimalisation
      integer densmap(scfmaxit)
c printing mo coefficient matrix
      real*8 cpr(nbasis,nbasis) ! Equivalent to r8heap
      real*8 cpr2(nbasis,nbasis) ! Equivalent to r8heap1n
      integer mosym(nbasis)
      integer alprmap(nbasis)
      integer beprmap(nbasis)
c%%% kitenni common blockba
      integer doccperir(nirmax)
      integer soccperir(nirmax)
      integer virtperir(nirmax) 
C SMALL ARRAYS
      INTEGER SQROFFSET(NIR),ltroffset(nir)                             !OFFSET FOR TWO DIMENSION ARRAYS 
      REAL*8 DEVPARR(2)
      INTEGER CONTROL(8)                                                !ARRAY STORING INFO ABOUT WHAT WE READING 
      INTEGER OFFSET(NIR)                                               !OFFSET FOR ONE DIMENSION ARRAYS 
      integer orbused(nirmax)
c%%% arrays for molden printer (put out to subroutine)
      character*4 molden
      real*8 occupation
C SCALARS
      INTEGER AC                                                        !THE ADDRESS CONVERTER FUNCTION 
      REAL*8 TEMP                                                       !TEMPORARY STORING THE VALUES OF THE INTEGRALS
      REAL*8 ENER                                                       !ENERGY
      INTEGER STEP                                                      !HOW MANY STEPS THE ALGORITHM DID YET
      REAL*8 SUM
      REAL*8 DEVENER                                                    !DIFFERENCE FROM PREV STEP ENERGY
      REAL*8 OLDENER                                                    !THE ENERGY IN THE PERVIOUS STEP
      REAL*8 DENSITY                                                    !TEMPORARY STORES ONE ELEMENT OF DENSITY MATRIX 
      REAL*8 DDOT                                                       !VALUE OF DDOT FUNCTION
      REAL*8 DNRM2,itol
      real*8 exc,chfx,fhfx,rs(sqrsize*2),s2,lshift,trab,gap,excrad_fin
      real*8 clrhfx,flrhfx,csrhfx,fsrhfx,omega,fomega,erse
      INTEGER ERROR                                                     !GLOBAL ERROR HANDLING
      INTEGER I,J,K,Q,T,M,N,A,B,D,U,V,O,L                               !VARIABLES FOR HANDLING ARRAYS             
      INTEGER II,JJ,KK,ll
      integer itemp,intalloc
      integer npos
      integer pivot
      integer r8heapsize
      integer symvar,fdmind(*),ncoreir(nirmax)
      integer actirrep,lfin,dhyb,nfr,nc,ncorenew,nn,nbfroz,mmbond,ncent
      character*1 symchar
      character*4 symchar4,irlab(nir),route,mark,c4,localcc
      logical noswapped,kscorr,hfroute,lwdfn,lrest,llg,lhuzi,lscfdamp
      logical lcont,lanycc
      character*4 schroute !HB
      character*6 core
      character*8 scflshift,embed,cscr,dual,cbfgstol,scfguessdens
      character*13 rohfcore
      character*16 ccalc,scfdamp,c16
      character*32 dft,pcm
      real*8 bfgstol
      integer ieigval, iocc_num
c MEMORY COMMON BLOCK
      integer imem1
      common/memcom/ imem1
C Quadratic SCF variables
      double precision trust_rad, gn, scf_grad_norm
      integer dblalloc, qnewton_step
      logical posdef, qscf_reject
      qnewton_step=0
      trust_rad = 0.2d0
      posdef = .false.
      gn = 1.0d6
      qscf_reject=.false.
      schroute='    ' !HB
      if(route.eq.'sch ') then
       open(scrfile1,file='SCHINFO',form='unformatted')
        read(scrfile1)
        read(scrfile1) schroute
       close(scrfile1)
      endif !HB
C INITIALIZING VARIABLES
      call getkey('symm',4,symchar4,4)
      call getkey('calc',4,ccalc,16)
      call getkey('scfdamp',7,scfdamp,16)
      call getkey('core',4,core,6)
      call getvar('irlab     ',irlab)
      call getvar('lrest     ',lrest)
      call getvar('nbf       ',nbf)
      call getvar('chfx      ',chfx)
      call getvar('fhfx      ',fhfx)
      call getvar('clrhfx    ',clrhfx)
      call getvar('flrhfx    ',flrhfx)
      call getvar('csrhfx    ',csrhfx)
      call getvar('fsrhfx    ',fsrhfx)
      call getvar('omega     ',omega)
      call getvar('fomega    ',fomega)
      call getvar('ncore     ',ncore)
      call getkey('itol',4,c4,4)
      call getkey('bfgstol',7,cbfgstol,8)
      call getkey('molden',6,molden,4)
#if defined (MPI)
       if(rank.ne.0) molden='off '
#endif
      read(cbfgstol,*) bfgstol
      call getkey('localcc',7,localcc,4)
      call getkey('rohfcore',8,rohfcore,13)
      call getkey('scfguessdens',12,scfguessdens,8)
      read(c4,*) i
      itol=10.d0**(-i)
      lrest=lrest.and.route.ne.'em2 '.and.route.ne.'em3 '.and.
     $route.ne.'sch '
       if(core.eq.'corr  ') ncore=0
      gap=0.d0
      bb=0.d0
      lscfdamp=scfdamp.ne.'off             '
      ncoreir(1:nir)=0
c     write(6,*) 'szemet!!!szemet!!!szemet!!!szemet!!!szemet!!!'
!!! start HB
C     In case of the Huzinaga QM/MM+embedding 2nd SCF run, 
C     the eignvalues of the boundary frozen orbitals change their sign,
C     hence huzord routine should make different warnings.
      nbfroz=0
      if(qmreg.eq.'0       '.and.route.eq.'em3 ') then
       call getvar('mmbond    ',mmbond)
       do i=1,mmbond
        write(cscr,'(i8)') i
        open(scrfile1,file='MOCOEF.' // trim(adjustl(cscr)),
     $form='unformatted')
         read(scrfile1) j
        close(scrfile1)
        nbfroz=nbfroz+j
       enddo
      endif
!!! end HB
      oldener=0.d0
      ener=0.d0
       if(.not.lrest) nbf(5)=nbf(1)
      devparr=1.d0
      lfin=0
       if(ldual) then
        call getkey('excrad_fin',10,c16,16)
        read(c16,*) excrad_fin
         if(excrad_fin.gt.1d-2*itol) lfin=2
       endif
      exc=0.d0
      kscorr=.false.
      hfroute=.false.
       if(trim(dft).ne.'off'.and.(ccalc.ne.'scf             '.or.
     $chfx.ne.fhfx.or.clrhfx.ne.flrhfx.or.csrhfx.ne.fsrhfx).and.
     $trim(ccalc).ne.'cis')then
        call getvar('dhyb      ',dhyb)
        kscorr=(dhyb.eq.0.or.chfx.ne.fhfx.or.clrhfx.ne.flrhfx.or.
     $csrhfx.ne.fsrhfx).and.route.ne.'em1 '.and.route.ne.'em2 '.and.
     $route.ne.'emft'.and.route.ne.'sch '
       endif
      call getkey('scflshift',9,scflshift,8)
      lshift=0.d0
       if(scflshift.ne.'off     ') read(scflshift,*) lshift
      lhuzi=route.eq.'em3 '.and.embed.eq.'huzinaga'
      nfr=0
       if(lhuzi) then
        nfr=nfroz
        open(scrfile1,file='HUZPROJ',form='unformatted')
        call rtdmx(r8heap,i4heap,rs,scrfile1,nbf(5),nbf(5))
        close(scrfile1)
       endif
C Shall we continue the SCF iteration?
      step=1
      diisrecyet=0
      lwdfn=.false.
      lcont=.false.
      inquire(file='RESTART',exist=lcont)
       if(lcont) then
        open(unit=scrfile1,file='RESTART',form='unformatted')
        read(scrfile1) step,diisrecyet,lwdfn,lfin
        read(scrfile1) bb
        read(scrfile1) gap
        close(scrfile1,status='delete')
        INITGUESS=_RESTART_
       endif
C Initialize arrays to zero
      select case(scftype)
        case(_RHF_)
           if(ldiff) call dfillzero(oldg,sqrsize)
          call dfillzero(p,sqrsize)
        case(_ROHFSTD_,_MCSCF_)
           if(ldiff) then
            call dfillzero(oldg,sqrsize*2)
            CALL DFILLZERO(OLDQMAT,SQRSIZE)
           endif
          call dfillzero(p,sqrsize*2)
        case(_ROHFSCN_)
           if(ldiff) then
            call dfillzero(oldg,sqrsize*2)
            CALL DFILLZERO(OLDQMAT,SQRSIZE)
           endif
          call dfillzero(p,sqrsize*2)
        case(_UHF_)
           if(ldiff) call dfillzero(oldg,sqrsize*2)
          call dfillzero(p,sqrsize*2)
      end select    
      ERROR=0                                                           !PROGRAM WIDE ERROR CODE
      call getvar('natrange  ',natrange)                                !get which basis function belongs to which atom
C CALCULATING OFFSETS FOR ARRAYS
      offset(1)=1
      sqroffset(1)=1
      ltroffset(1)=1
       do i=2,nir
        n=nfunc(i-1)
        offset(i)=offset(i-1)+n
        sqroffset(i)=sqroffset(i-1)+n*n
        ltroffset(i)=ltroffset(i-1)+(n+1)*n/2
       enddo
      DO T=1,NIR                                                        !WHICH BASIS FUNCTION BELONGS TO WHICH SYMMETRY BLOCK
        DO I=OFFSET(T),OFFSET(T)+NFUNC(T)
          INDEXIRREP(I)=T
        ENDDO
      ENDDO
c open tedat file for communication with integral prog
      open(tedatfile,file='TEDAT',form='UNFORMATTED')     
c reading integral batch sizes from tedat file
       if(trim(scfalg).eq.'disk') then
        rewind(tedatfile)
        read(tedatfile) npos,intpos
       endif
c reading symmetry transformation matrix from disk
       if(lsa) call symtra_reader(symtra,r8heap,i4heap)
C READING ONE ELECTRON QUANTITIES (INTEGRALS)
      open(oeintfile,file='OEINT',form='unformatted')
      call readone(sorig,oeintfile,symtra,nbasis,r8heap,offset,lsa)
      close(oeintfile)
C Calculate Cholesky deco of S
       if(ndao.eq.0) then
        open(scrfile1,file='SCHOL',form='unformatted')
         do t=1,nir
          n=nfunc(t)
           if(n.gt.0) then
             do i=1,n
               do j=1,i
               r8heap(i+(j-1)*(2*n-j)/2)=sorig(sqroffset(t)-1+(i-1)*n+j)
               enddo
             enddo
            call dpptrf('L',n,r8heap,error)
            write(scrfile1) r8heap(1:(n+1)*n/2)
           endif
         enddo
        close(scrfile1)
       endif
c%%% itt ezt szebben is meg lehet oldani
c calculating scratch array size
      R8HEAPSIZE=0                                                      !SIZE OF HEAP IN REAL*8 WORDS
      DO I=1,NIR
        IF(NFUNC(I).EQ.0) CYCLE
        CALL DSYEV(
     &    'V',
     &    'U',
     &    NFUNC(I),
     &    C(SQROFFSET(I)),
     &    NFUNC(I),
     &    EIGENVALUE(OFFSET(I)),
     &    R8HEAP,
     &    -1,
     &    ERROR)
          R8HEAPSIZE=max(R8HEAPSIZE,ceiling(R8HEAP(1)))
      ENDDO
      IF(MAXCOR-(IMEM-IMEM1).LE.R8HEAPSIZE) R8HEAPSIZE=3*nbasis
      IF(MAXCOR-(IMEM-IMEM1).LE.R8HEAPSIZE) THEN
        WRITE(*,*) ' @SCF: NOT ENOUGH MEMORY FOR DIAGONALISATION OF S'
        WRITE(*,*) '       ALLOCATE MORE MEMORY IN MINP!'
        call mrccend(1)
      ENDIF
C Construct projector for Huzinaga equations
!!! start HB
       if(qmreg.eq.'0       '.and.route.ne.'em3 '.and.route.ne.'em2 ') 
     $then
!!! end HB
        i=intalloc((nal+nbe)*natoms)
        j=intalloc((nal+nbe)*natoms)
        call huzinaga(nbasis,rs,sorig,c,scrfile1,minpfile,icore(iimem),
     $dcore(imem),iout,nfroz,nal,nbe,natoms,icore(i),icore(j))
        call intdealloc(i)
       endif
C CREATING INITIAL GUESS FOR SCF ITERATION
      SELECT CASE (INITGUESS)
        CASE(_CORE_)                                                    !CORE HAMILTONIAN TYPE GUESS
         call readh(r8heap,oeintfile,symtra,nbasis,offset,lsa)
          SELECT CASE (SCFTYPE)
            CASE(_RHF_)
              CALL DCOPY(SQRSIZE,r8heap,1,FOCK,1)
            CASE(_UHF_)
              CALL DCOPY(SQRSIZE,r8heap,1,FOCK,1)
              CALL DCOPY(SQRSIZE,r8heap,1,FOCK(SQRSIZE+1),1)
            CASE(_ROHFSTD_,_ROHFSCN_)
              CALL DCOPY(SQRSIZE,r8heap,1,FOCK,1)
          END SELECT
        CASE(_AO_)                                                      !MRCC INTEG DIAGONAL DENSITY GUESS
          SELECT CASE (SCFTYPE)
            CASE(_RHF_)
              CALL DFILLZERO(SYMDENS,NBASIS**2)                
              CALL RHF_AO_GUESS(SYMDENS,NBASIS,SCRFILE1,INITGUESS,
     $r8heap,r8heap(nbasis+1),R8HEAP1N,NATRANGE,NATOMS,qmreg,nangmax,
     $nbset) !PICK UP MRCC/INTEG INITIAL GUESS FROM DISK
              call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
            CASE(_UHF_)
              CALL DFILLZERO(SYMDENS,NBASIS**2)                
              CALL DFILLZERO(SYMDENS2,NBASIS**2)                
              CALL UHF_AO_GUESS(SYMDENS,SYMDENS2,NBASIS,SCRFILE1,
     $INITGUESS,r8heap,r8heap(nbasis+1),R8HEAP1N,NATRANGE,NATOMS,qmreg,
     $nangmax,nbset)
              call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
              call mxts(SYMDENS2,SYMTRA,R8HEAP,nbasis,P(SQRSIZE+1),
     $OFFSET,lsa)
            CASE(_ROHFSTD_,_ROHFSCN_)
              CALL DFILLZERO(SYMDENS,NBASIS**2)                
              CALL DFILLZERO(SYMDENS2,NBASIS**2)                
              CALL ROHF_AO_GUESS(SYMDENS,SYMDENS2,NBASIS,SCRFILE1,
     $INITGUESS,r8heap,r8heap(nbasis+1),R8HEAP1N,NATRANGE,NATOMS,qmreg,
     $nangmax,nbset)
              call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
              call mxts(SYMDENS2,SYMTRA,R8HEAP,nbasis,P(SQRSIZE+1),
     $OFFSET,lsa)
          END SELECT   
        CASE(_SAD_)                                                     !MRCC INTEG SAD GUESS
         CALL DFILLZERO(SYMDENS,NBASIS**2)
         CALL RHF_AO_GUESS(SYMDENS,NBASIS,SCRFILE1,INITGUESS,r8heap,
     $r8heap(nbasis+1),R8HEAP1N,NATRANGE,NATOMS,qmreg,nangmax,nbset)
         call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
          if(scftype.eq._RHF_) then
           call purify(p,p(sqrsize+1),nbasis,nal,nbe,c,r8heap,r8heap1n,
     $nooccfl,orbperir,orbperir(nir+1),nir,nfunc,sqrsize,offset,
     $sqroffset,indexirrep,mapping,2,scftype,scrfile1,symtra,lsa,nfuns,
     $ndao)
          else
           call purify(p,p(sqrsize+1),nbasis,nal,nbe,c,r8heap,r8heap1n,
     $nooccfl,orbperir,orbperir(nir+1),nir,nfunc,sqrsize,offset,
     $sqroffset,indexirrep,mapping,1,scftype,scrfile1,symtra,lsa,nfuns,
     $ndao)
            if(scftype.eq._UHF_) call dcopy(sqrsize,c,1,c(sqrsize+1),1)
          endif
        CASE(_RESTART_)                                                 !RESTARTING FROM STATE STORED ON DISK
          if(lrest) then
           open(scrfile1,file='SROOT',form='unformatted')
           read(scrfile1)
           call roeint(r8heap,i4heap,symdens,scrfile1,nbasis)
           close(scrfile1)
           open(scrfile1,file='S12MATold',form='unformatted')
           call rtdmx(r8heap1n,r8heap1n,r8heap,scrfile1,nbasis,nbf(5))
           close(scrfile1)
           call dsymm('l','u',nbasis,nbf(5),1.d0,symdens,nbasis,
     $r8heap,nbasis,0.d0,r8heap1n,nbasis)
           call dsymm('l','u',nbasis,nbf(5),1.d0,symdens,nbasis,
     $r8heap1n,nbasis,0.d0,symfock,nbasis)
          endif
          if(ldual.and.route.eq.'em1 ') then
           open(scrfile1,file='MOCOEF_AB',form='unformatted')
           call readmo(r8heap1n,r8heap1n,rs,scrfile1,nbf(5),nbf(5))
           close(scrfile1,status='delete')
           call dgemm('n','n',nbasis,nal,nbf(5),1.d0,symfock,nbasis,
     $rs,nbf(5),0.d0,c,nbasis)
           call getvar('nfroz     ',i)
           call schmidt(nbasis,i,c,sorig,r8heap)
           call dsyrk('u','n',nbasis,i,1.d0,c,nbasis,0.d0,rs,nbasis)
           call filllo(rs,nbasis)
           call dsymm('l','u',nbasis,nbasis,1.d0,rs,nbasis,
     $sorig,nbasis,0.d0,r8heap,nbasis)
           call dscal(sqrsize,2.d0,rs,1)
c          open(scrfile1,file='SCFDENSITIES_B',form='unformatted')
c          call woeint(r8heap1n,r8heap1n,rs,scrfile1,0.d0,nbasis)
c          close(scrfile1)
           open(scrfile1,file='HUZPROJ',form='unformatted')
           call wtdmx(r8heap1n,r8heap1n,r8heap,scrfile1,0.d0,nbasis,
     $nbasis)
           close(scrfile1)
           call dgemm('n','n',nbasis,nal-i,nbasis,1.d0,r8heap,nbasis,
     $c(i*nbasis+1),nbasis,0.d0,r8heap1n,nbasis)
           call daxpy(nbasis*(nal-i),-1.d0,r8heap1n,1,c(i*nbasis+1),1)
           call schmidt(nbasis,nal-i,c(i*nbasis+1),sorig,r8heap1n)
           call dsyrk('u','n',nbasis,nal-i,2.d0,c(i*nbasis+1),nbasis,
     $0.d0,p,nbasis)
           call filllo(p,nbasis)
           open(scrfile1,file='SCFDENSITIES_A',form='unformatted')
           call woeint(r8heap1n,r8heap1n,p,scrfile1,0.d0,nbasis)
           close(scrfile1)
           call daxpy(sqrsize,1.d0,rs,1,p,1)
            if(dual.ne.'e2      ') then
             open(scrfile1,file='MOCOEF_A',form='unformatted')
             call readmo(r8heap2n,r8heap2n,r8heap1n,scrfile1,nbf(5),
     $nbf(5))
             close(scrfile1,status='delete')
             call dgemm('n','n',nbasis,nal-i,nbf(5),1.d0,symfock,nbasis,
     $r8heap1n(i*nbf(5)+1),nbf(5),0.d0,rs,nbasis)
             call dgemm('n','n',nbasis,nal-i,nbasis,1.d0,r8heap,nbasis,
     $rs,nbasis,0.d0,r8heap1n,nbasis)
             call daxpy(nbasis*(nal-i),-1.d0,r8heap1n,1,rs,1)
             call schmidt(nbasis,nal-i,rs,sorig,r8heap1n)
             call dsyrk('u','n',nbasis,nal-i,2.d0,rs,nbasis,0.d0,
     $r8heap1n,nbasis)
             call filllo(r8heap1n,nbasis)
             open(scrfile1,file='SCFDENSITIES_At',form='unformatted')
             call woeint(r8heap2n,r8heap2n,r8heap1n,scrfile1,0d0,nbasis)
             close(scrfile1)
            endif
           goto 7642
          endif
        OPEN(UNIT=scfdensityFILE,FILE='SCFDENSITIES',FORM='UNFORMATTED')
         REWIND(scfdensityFILE)
          SELECT CASE (SCFTYPE)
            CASE (_RHF_)
             call roeint(r8heap,i4heap,symdens,scfdensityFILE,nbf(5))
              if(lrest) then
               call dsymm('r','u',nbasis,nbf(5),1.d0,symdens,nbf(5),
     $symfock,nbasis,0.d0,r8heap,nbasis)
               call dgemm('n','t',nbasis,nbasis,nbf(5),1.d0,r8heap,
     $nbasis,symfock,nbasis,0.d0,symdens,nbasis)
              endif
             call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
             if(schroute.eq.'rest') then !HB
              open(scrfile1,file='SCFDENSMOCOEF',form='unformatted')
               call roeint(r8heap,i4heap,p,scrfile1,nbasis)
              close(scrfile1)
             endif !HB
            CASE (_UHF_,_ROHFSTD_,_ROHFSCN_,_MCSCF_)
             call roeint(r8heap,i4heap,symdens ,scfdensityFILE,nbf(5))
             call roeint(r8heap,i4heap,symdens2,scfdensityFILE,nbf(5))
              if(lrest) then
               call dsymm('r','u',nbasis,nbf(5),1.d0,symdens,nbf(5),
     $symfock,nbasis,0.d0,r8heap,nbasis)
               call dgemm('n','t',nbasis,nbasis,nbf(5),1.d0,r8heap,
     $nbasis,symfock,nbasis,0.d0,symdens,nbasis)
               call dsymm('r','u',nbasis,nbf(5),1.d0,symdens2,nbf(5),
     $symfock,nbasis,0.d0,r8heap,nbasis)
               call dgemm('n','t',nbasis,nbasis,nbf(5),1.d0,r8heap,
     $nbasis,symfock,nbasis,0.d0,symdens2,nbasis)
              endif
             call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
             call mxts(SYMDENS2,SYMTRA,R8HEAP,nbasis,P(SQRSIZE+1),
     $OFFSET,lsa)
              if((scftype.eq._ROHFSCN_.and.scfguessdens.ne.'rohfstd ')
     $  .or.(scfguessdens.eq.'rohfscn '.or.scfguessdens.eq.'uhf     ')) 
     $  then
               call dcopy(sqrsize,p,1,r8heap,1)
               call daxpy(sqrsize,1.d0,p(sqrsize+1:2*sqrsize),1,
     $                                 p(1:sqrsize),1)
               p(sqrsize+1:2*sqrsize)=r8heap(1:sqrsize)-
     $         p(sqrsize+1:2*sqrsize)
              endif
          END SELECT    
         close(scfdensityFILE)
        CASE(_MO_) !Restart from MO coefficients from MOCOEF file
          SELECT CASE (SCFTYPE)
            CASE(_RHF_)
              open(scrfile1,file='MOCOEF',form='unformatted')
              call rtdmx(r8heap1n,r8heap1n,r8heap,scrfile1,nbasis,
     $nbasis)
              if(route.eq.'sch ') then
               call dsymm('l','l',nbasis,nal,1.d0,sorig,nbasis, !HB
     $r8heap,nbasis,0.d0,r8heap1n,nbasis)
               call dgemm('t','n',nal,nal,nbasis,1.d0,r8heap,
     $nbasis,r8heap1n,nbasis,0.d0,r8heap2n,nal)
               call invsqrt(r8heap2n,nal,r8heap3n,iout,i,1d-12,1)
               if(i.ne.0) then
                write(iout,*)
     $'Fatal error at the calculation of inverse square root!'
                call mrccend(1)
               endif
               call dsymm('r','l',nbasis,nal,1.d0,r8heap2n,nal,
     $r8heap,nbasis,0.d0,r8heap3n,nbasis) 
               call dcopy(sqrsize,r8heap3n,1,r8heap,1) !HB
              endif
               if(nir.eq.1) call dcopy(sqrsize,r8heap,1,c,1)
              call dsyrk('u','n',nbasis,nal,2.d0,r8heap,nbasis,0.d0,
     $symdens,nbasis)
              call filllo(symdens,nbasis)
              close(scrfile1)
              call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
               if(route.eq.'sch ') then
                call dsyrk('u','n',nbasis,nfroz,2.d0,c,nbasis,0.d0,
     $p(sqrsize+1),nbasis)
                call filllo(p(sqrsize+1),nbasis)
                open(scrfile1,file='SCFDENSMOCOEF',form='unformatted') !HB
                 call woeint(r8heap,i4heap,p,scrfile1,itol,nbasis) !HB
                close(scrfile1) !HB
               endif
            CASE(_UHF_)
              open(scrfile1,file='MOCOEF',form='unformatted')
              call rtdmx(r8heap1n,r8heap1n,r8heap,scrfile1,nbasis,
     $nbasis)
               if(nir.eq.1) call dcopy(sqrsize,r8heap,1,c,1)
              call dsyrk('u','n',nbasis,nal,1.d0,r8heap,nbasis,0.d0,
     $symdens,nbasis)
              call filllo(symdens,nbasis)
              call rtdmx(r8heap1n,r8heap1n,r8heap,scrfile1,nbasis,
     $nbasis)
               if(nir.eq.1) call dcopy(sqrsize,r8heap,1,c(sqrsize+1),1)
              call dsyrk('u','n',nbasis,nal,1.d0,r8heap,nbasis,0.d0,
     $symdens2,nbasis)
              call filllo(symdens2,nbasis)
              close(scrfile1)
              call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
              call mxts(SYMDENS2,SYMTRA,R8HEAP,nbasis,P(SQRSIZE+1),
     $OFFSET,lsa)
            CASE(_ROHFSTD_,_ROHFSCN_,_MCSCF_)
              open(scrfile1,file='MOCOEF',form='unformatted')
              call rtdmx(r8heap1n,r8heap1n,r8heap,scrfile1,nbasis,
     $nbasis)
               if(nir.eq.1) then
                call dcopy(sqrsize,r8heap,1,c,1)
               else
                call dgemm('t', 'n', nbasis, nbasis, nbasis, 1.0d0,
     &               symtra, nbasis, r8heap, nbasis, 0.0d0, symfock,
     &               nbasis)
                open(inp,status='old',iostat=error)
                rewind(inp)
                read(inp,*) i,j,k
                read(inp,*) (mapping(i), i = 1, nbasis)
                close(inp)
                call sort_mo(symfock, symdens, offset, mapping)
                call mx_symm_compr(symdens, c, offset)
               endif
               if(scftype.eq._MCSCF_) then
                 call build_dens(c, p, sqrsize, sqroffset) 
                 close(scrfile1)
               else
                 call dsyrk('u','n',nbasis,nbe,2.d0,r8heap,nbasis,0.d0,
     $symdens,nbasis)
                 call filllo(symdens,nbasis)
                 call dsyrk('u','n',nbasis,nal-nbe,1.d0,
     $r8heap(nbe*nbasis+1),nbasis,0.d0,symdens2,nbasis)
                 call filllo(symdens2,nbasis)
                 close(scrfile1)
                 call mxts(SYMDENS,SYMTRA,R8HEAP,nbasis,P,OFFSET,lsa)
                 call mxts(SYMDENS2,SYMTRA,R8HEAP,nbasis,P(SQRSIZE+1),
     $OFFSET,lsa)
                 CALL DAXPY(SQRSIZE,1.D0,P(SQRSIZE+1),1,P,1)
               endif
          END SELECT
      END SELECT
7642  continue
C Purify the density matrix
c      if(lrest) then
       if(initguess.eq._RESTART_) then
         select case(scftype)
          case(_RHF_)
           call purify(p,p(sqrsize+1),nbasis,nal-nfr,nbe-nfr,c,r8heap,
     $r8heap1n,nooccfl,orbperir,orbperir(nir+1),nir,nfunc,sqrsize,
     $offset,sqroffset,indexirrep,mapping,2,1,scrfile1,symtra,lsa,nfuns,
     $ndao)
            if(lhuzi) then
             call dcopy(sqrsize,c,1,r8heap,1)
             call dcopy((nal-nfroz)*nbasis,r8heap,1,c(nfr*nbasis+1),1)
            endif
          case(_UHF_)
           call purify(p,p(sqrsize+1),nbasis,nal,nbe,c,r8heap,r8heap1n,
     $nooccfl,orbperir,orbperir,nir,nfunc,sqrsize,offset,sqroffset,
     $indexirrep,mapping,1,1,scrfile1,symtra,lsa,nfuns,ndao)
           call purify(p(sqrsize+1),p,nbasis,nbe,nbe,c(sqrsize+1),
     $r8heap,r8heap1n,nooccfl,orbperir(nir+1),orbperir,nir,nfunc,
     $sqrsize,offset,sqroffset,indexirrep,mapping,1,1,scrfile1,symtra,
     $lsa,nfuns,ndao)
          case(_ROHFSTD_,_ROHFSCN_,_MCSCF_)
           call daxpy(sqrsize,-1.d0,p(sqrsize+1),1,p,1)
           call purify(p,p(sqrsize+1),nbasis,nbe,nbe,c,r8heap,r8heap1n,
     $nooccfl,orbperir,orbperir,nir,nfunc,sqrsize,offset,sqroffset,
     $indexirrep,mapping,2,1,scrfile1,symtra,lsa,nfuns,ndao)
           call purify(p(sqrsize+1),p,nbasis,nal-nbe,nbe,r8heap,
     $r8heap1n,r8heap2n,nooccfl,orbperir(nir+1),orbperir,nir,nfunc,
     $sqrsize,offset,sqroffset,indexirrep,mapping,1,1,scrfile1,symtra,
     $lsa,nfuns,ndao)
           call daxpy(sqrsize,1.d0,p(sqrsize+1),1,p,1)
            do i=1,nir
             c(sqroffset(i)+orbperir(i)*nfunc(i):
     $ sqroffset(i)+orbperir(i)*nfunc(i)+orbperir(nir+i)*nfunc(i))=
     $  r8heap(sqroffset(i):sqroffset(i)+orbperir(nir+i)*nfunc(i))
            enddo
         endselect
C Purify projector for dual basis set embedding calculation
         if(ldual.and.route.eq.'em3 ') then
          open(scrfile1,file='HUZPROJ',form='unformatted')
          call rtdmx(r8heap,i4heap,rs,scrfile1,nbasis,nbasis)
          close(scrfile1,status='delete')
         endif
       endif
C Save initial density matrix
      open(sdfile,status='unknown',form='unformatted')
      open(scfile,status='unknown',form='unformatted')
       if(.not.lcont) then
         if(ldiff) write(scfile) p
        write(sdfile) p
       endif
       call qscf_init(qscf)
C-----------------------------------------------------------------------
C MAIN ITERATION
C-----------------------------------------------------------------------
1234  continue
      DO
      IF(VERBLEVEL.GE.2.and..not.hfroute) THEN
        write(iout,"(1X,70('='))")
        write(iout,"(' ITERATION STEP',I4)") STEP
        call timer()                                                    !calling combin.f/timer
        write(iout,*)
      ENDIF      
       if(.not.lscfdamp.and..not.lhuzi.and.qscf.eq.'off     '.and.
     $.not.ldual.and.route.ne.'sch ') then
         if(step.le.3.and.gap.le.0.2d0) then
           if(trim(dft).ne.'off') then
            scfdamp='0.7d0           ' 
c          else
c           scfdamp='0.3d0           ' 
           endif
         else
          scfdamp='off             '
         endif
       endif
C
       if(step .eq. 1 .and. initguess .eq. _SAD_ .and. 
     &   scftype .eq. _MCSCF_) then
         call dscal(sqrsize, 2.0d0, p, 1)
       endif
      if(qscf .ne. 'off     ' .and. qscf .ne. 'bfgs    ') then
        if((step.eq.1.and.(initguess.ne._SAD_.and.initguess.ne._MO_)))
     &     continue
        if((step.eq.1.and.(initguess.eq._SAD_.or.initguess.eq._MO_)).or.
     &     (step.eq.2.and.(initguess.ne._SAD_.and.initguess.ne._MO_)))
     &     then
          ener = mcscf_energy(chfx, nuc, npos, offset, sqroffset, lfin,
     &           nfr, nc, ncorenew, exc, devparr, dft, embed, scfdamp, 
     &           route, lwdfn,clrhfx,csrhfx,omega,pcm)
          call orbital_energies(eigenvalue, offset, sqroffset, r8heap,
     &         r8heapsize, route)
          goto 72826
        elseif((step.eq.2.and.(initguess.eq._SAD_.or.initguess.eq._MO_))
     &         .or.step.ge.3) then
          call mcscf_calc(sqroffset, offset, ener, oldener,posdef,
     &         trust_rad, npos, chfx, nuc, qscf, gn, lfin, nfr, nc,
     &         ncorenew, exc, devparr, dft, embed, scfdamp, route,
     &         lwdfn, pepsilon, qscf_reject, itol, step,clrhfx,csrhfx,
     &         omega,pcm)
          call orbital_energies(eigenvalue, offset, sqroffset, r8heap,
     &         r8heapsize, route)
          goto 72826
        endif
      elseif(qscf.eq.'bfgs    '.and.step.ne.1.and.qnewton_step.ne.0)then
        if(qnewton_step.eq.1) then
          write(iout,'(30X,A)') "Starting BFGS"
          write(iout,*)
          ener = mcscf_energy(chfx, nuc, npos, offset, sqroffset, lfin,
     &           nfr, nc, ncorenew, exc, devparr, dft, embed, scfdamp, 
     &           route, lwdfn, clrhfx,csrhfx,omega,pcm)
          call orbital_energies(eigenvalue, offset, sqroffset, r8heap,
     &         r8heapsize, route)
        endif
        call mcscf_calc(sqroffset, offset, ener, oldener,posdef,
     &       trust_rad, npos, chfx, nuc, qscf, gn, lfin, nfr, nc,
     &       ncorenew, exc, devparr, dft, embed, scfdamp, route,
     &       lwdfn, pepsilon, qscf_reject, itol, step, clrhfx,csrhfx,
     &       omega,pcm)
        call orbital_energies(eigenvalue, offset, sqroffset, r8heap,
     &       r8heapsize, route)
        qnewton_step = qnewton_step + 1
        goto 72826
      endif
C BUILDING FOCK MATRIX
      IF ((STEP.NE.1).OR.(DENSITYIGUESSFL)) THEN
        SELECT CASE (SCFTYPE)
          CASE(_RHF_)                                                   !RESTRICTED HARTREE-FOCK CALCULATION
             if(ldiff) then
              rewind(scfile)
              read(scfile) p
             endif
            call mxto(symdens,symtra,r8heap,nbasis,p,offset,lsa)
             if(ldiff) then
              rewind(sdfile)
              read(sdfile) p
             endif
            CALL FOCK_BUILD(
     &        SYMDENS,
     &        SYMDENS2,
     &        SYMFOCK,
     &        SYMFOCK2,
     &        SYMQMAT,
     &        INDEXIRREP,
     &        OFFSET,
     &        SQROFFSET,
     &        NPOS,
     &        INTPOS,
     &        STEP,c(nfr*nbasis+1),lfin,exc,dft,chfx,lwdfn,embed,
     &        scfdamp,route,nfr,nc,ncorenew,devparr,symtra,0,clrhfx,
     &        csrhfx,omega,rs,.false.,1,1,pcm)
            call mxts(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
c%%% egyszeru kulonbsegi felepito
             if(ldiff) then
              call daxpy(sqrsize,1.d0,oldg,1,fock,1)                    !sum up difference and prev fock matrix
              call dcopy(sqrsize,fock,1,oldg,1)                         !saving actual fock matrix for using in next iter.
             endif
c            if(embed.eq.'fdm     '.and.route.eq.'em3 ') then
c             call dcopy(sqrsize,p,1,symdens,1)
c             call fdmdens(nbasis,natoms,natrange,fdmind,symdens,p)
c            endif
            call readh(r8heap,oeintfile,symtra,nbasis,offset,lsa)
             if(trim(dft).eq.'off'.and.route.ne.'emft'.and.
     $trim(pcm).eq.'off') then
              ener=nuc+0.5d0*ddot(sqrsize,p,1,fock  ,1)+
     $                       ddot(sqrsize,p,1,r8heap,1)
             else
              ener=nuc+exc+ddot(sqrsize,p,1,r8heap,1)
c     write(6,*) nuc,exc,ddot(sqrsize,p,1,r8heap,1)
             endif
c            if(embed.eq.'fdm     '.and.route.eq.'em3 ') then
c             open(unit=scrfile2,file='SCFDENSITIES',form='unformatted')
c             rewind(scrfile2)
c             call roeint(r8heap,i4heap,p,scrfile2,nbasis)
c             close(scrfile2)
c            endif
C Construct h^AinB for embedding
             if(route.eq.'em2 ') then
              open(scrfile1,file='FOCK',form='unformatted')
              call roeint(r8heap1n,r8heap1n,r8heap,scrfile1,nbasis)
               if(ldual.and.trim(dual).eq.'e1') then
                call getvar('ncorenew  ',ncore)
               else
                read(scrfile1) ncore
                 if(embed.eq.'huzinaga') then
                   if(core.eq.'corr  ') ncore=0
                  ncore=ncore+nfroz
                 endif
               endif
              close(scrfile1)
              call daxpy(sqrsize,-1.d0,fock,1,r8heap,1)
C Overwrite one-electron integrals
              call readh(r8heap3n,oeintfile,symtra,nbasis,offset,lsa)
              open(oeintfile,file='OEINT',form='unformatted')
              read(oeintfile)
              call woeint(r8heap1n,r8heap1n,r8heap,oeintfile,itol,
     $nbasis)
              close(oeintfile)
               if(embed.ne.'fdm     ') then
                call ishell('cp VARS VARS.old')
                open(varsfile,file='VARS.new',form='unformatted')
                 if(embed.ne.'huzinaga') then
                  write(varsfile) 'nal       ',iintln,nal
                  write(varsfile) 'nbe       ',iintln,nbe
                  write(varsfile) 'nelec     ',iintln,nelec
                 endif
                write(varsfile) 'ncore     ',iintln,ncore
                close(varsfile)
                call ishell('cat VARS.new VARS.old > VARS')
                call ishell('rm -f VARS.new VARS.old')
               endif
C Calculate energy correction
              call daxpy(sqrsize,-1.d0,r8heap3n,1,r8heap,1)
              call getvar('edftab    ',temp)
c        write(6,*) ddot(sqrsize,p,1,symfock,1)
c     write(6,"(10f20.12)") -ener,temp,-ddot(sqrsize,p,1,r8heap,1)
              ener=temp-ddot(sqrsize,p,1,r8heap,1)-ener
c     write(6,"(10f20.12)") ener
               if(ldual.and.(trim(dual).eq.'e1'.or.trim(dual).eq.'e2'))
     $then
                call daxpy(sqrsize,1.d0,r8heap3n,1,fock,1)
                open(scrfile1,file='SCFDENSITIES',form='unformatted')
                read(scrfile1)
                call roeint(r8heap2n,r8heap2n,r8heap1n,scrfile1,nbasis)
                close(scrfile1)
                call daxpy(sqrsize,-1.d0,p,1,r8heap1n,1)
c     write(6,"(10f20.12)") ddot(sqrsize,r8heap1n,1,fock,1),
c    $ddot(sqrsize,r8heap1n,1,r8heap,1),ener
                ener=ener-ddot(sqrsize,r8heap1n,1,fock,1)
     $                   -ddot(sqrsize,r8heap1n,1,r8heap,1)
c     write(6,"(10f20.12)") ener
               endif
              open(varsfile,file='VARS',form='unformatted',
     $position='append')
              write(varsfile) 'edftbcor  ',ifltln,ener
              close(varsfile)
c              if(trim(dual).eq.'e1') then
c               open(scrfile1,file='EMBPOT',form='unformatted')
c              call woeint(r8heap1n,r8heap1n,r8heap,scrfile1,0d0,nbasis)
c               close(scrfile1)
c              endif
              return
c             call mrccend(0)
             endif
            call daxpy(sqrsize,1.d0,r8heap,1,fock,1)                    !adding up core Hamiltonian
C Project out frozen orbitals if Huzinaga eq. is solved
             if(lhuzi) then
              call huzproj(nbasis,fock,rs,dcore(imem))
             else if(route.eq.'sch ') then
              call daxpy(sqrsize,1.d0,r8heap,1,fock(sqrsize+1),1)
             endif
CCC start HB
             if(qmreg.eq.'0       '.and.route.ne.'em3 '.and.
     $route.ne.'em2 ') then
CCC end HB
              open(scrfile1,file='HUZPROJ',form='unformatted')
              read(scrfile1)
              read(scrfile1)
              call woeint(r8heap,i4heap,fock,scrfile1,0.d0,nbasis)
              close(scrfile1)
              call huzproj(nbasis,fock,rs,dcore(imem))
             endif
          CASE(_UHF_)                                                   !UNRESTRICTED HARTREE-FOCK CALCULATION
             if(ldiff) then
              rewind(scfile)
              read(scfile) p
             endif
            call mxto(symdens ,symtra,r8heap,nbasis,p,offset,lsa)
            call mxto(symdens2,symtra,r8heap,nbasis,p(sqrsize+1),
     $offset,lsa)
             if(ldiff) then
              rewind(sdfile)
              read(sdfile) p
             endif
            call fock_build(
     &        symdens,
     &        symdens2,
     &        symfock,
     &        symfock2,
     &        symqmat,
     &        indexirrep,
     &        offset,
     &        sqroffset,
     &        npos,
     &        intpos,
     &        step,c(nfr*nbasis+1),lfin,exc,dft,chfx,lwdfn,embed,
     &        scfdamp,route,nfr,nc,ncorenew,devparr,symtra,0,clrhfx,
     &        csrhfx,omega,rs,.false.,1,1,pcm)
            call mxts(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
            call mxts(symfock2,symtra,r8heap,nbasis,fock(sqrsize+1),
     $offset,lsa)
c%%% egyszeru kulonbsegi felepito
             if(ldiff) then
              call daxpy(2*sqrsize,1.d0,oldg,1,fock,1)                  !adding up prev and actual part  
              call dcopy(2*sqrsize,fock,1,oldg,1)                       !saving alpha and beta fock for next iteration
             endif
            call readh(r8heap,oeintfile,symtra,nbasis,offset,lsa)
             if(trim(dft).eq.'off'.and.trim(pcm).eq.'off') then
              ener=nuc+
     $             0.5d0*ddot(sqrsize,p           ,1,fock           ,1)+
     $             0.5d0*ddot(sqrsize,p(sqrsize+1),1,fock(sqrsize+1),1)+
     $                   ddot(sqrsize,p           ,1,r8heap         ,1)+
     $                   ddot(sqrsize,p(sqrsize+1),1,r8heap         ,1)
             else
              ener=nuc+exc+ddot(sqrsize,p           ,1,r8heap,1)+
     $                     ddot(sqrsize,p(sqrsize+1),1,r8heap,1)
             endif
            call daxpy(sqrsize,1.d0,r8heap,1,fock,1)                    !adding core Hamiltonian to alpha fock matrix
            call daxpy(sqrsize,1.d0,r8heap,1,fock(sqrsize+1),1)         !adding core Hamiltonian to beta fock matrix
C Project out frozen orbitals if Huzinaga eq. is solved
CCC start HB
             if(qmreg.eq.'0       '.and.route.ne.'em2 '.and.
     $route.ne.'em3 ') then
CCC end HB
              open(scrfile1,file='HUZPROJ',form='unformatted')
              read(scrfile1)
              read(scrfile1)
              call woeint(r8heap,i4heap,fock,scrfile1,0.d0,nbasis)
              call woeint(r8heap,i4heap,fock(sqrsize+1),scrfile1,0.d0,
     $nbasis)
              close(scrfile1)
              call huzproj(nbasis,fock,rs,dcore(imem))
              call huzproj(nbasis,fock(sqrsize+1),rs,dcore(imem))
             endif
          CASE(_ROHFSTD_,_ROHFSCN_)
             if(ldiff) then
              rewind(scfile)
              read(scfile) p
             endif
            call mxto(symdens ,symtra,r8heap,nbasis,p,offset,lsa)
            call mxto(symdens2,symtra,r8heap,nbasis,p(sqrsize+1),
     $offset,lsa)
             if(ldiff) then
              rewind(sdfile)
              read(sdfile) p
             endif
            call fock_build(
     &        symdens,
     &        symdens2,
     &        symfock,
     &        symfock,
     &        symqmat,
     &        indexirrep,
     &        offset,
     &        sqroffset,
     &        npos,
     &        intpos,
     &        step,c(nfr*nbasis+1),lfin,exc,dft,chfx,lwdfn,embed,
     &        scfdamp,route,nfr,nc,ncorenew,devparr,symtra,0,clrhfx,
     &        csrhfx,omega,rs,.false.,1,1,pcm)
            call mxts(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
            call mxts(symqmat,symtra,r8heap,nbasis,qmat,offset,lsa)
             if(trim(dft).ne.'off') then
               if(lsa) then
                call daxpy(nbasis**2,-1.d0,rs,1,rs(nbasis**2+1),1)
                call mxts(rs(nbasis**2+1),symtra,r8heap,nbasis,rs,
     $offset,lsa)
               else
                rs(1:nbasis**2)=-rs(1:nbasis**2)
                call daxpy(nbasis**2,1.d0,rs(nbasis**2+1),1,rs,1)
               endif
             endif
c%%% eredeti kulonbsegi felepito
             if(ldiff) then
              CALL DAXPY(SQRSIZE,1.D0,OLDG,1,FOCK,1)                    !ADDING UP PREV AND ACTUAL PART  
              CALL DAXPY(SQRSIZE,1.D0,OLDQMAT,1,QMAT,1)                 !ADDING UP PREV AND ACTUAL PART   
              CALL DCOPY(SQRSIZE,FOCK,1,OLDG,1)
              CALL DCOPY(SQRSIZE,QMAT,1,OLDQMAT,1)
             endif
            call r_build(rmat,sorig,p,qmat,sqroffset,r8heap,rs,dft)
            call readh(r8heap,oeintfile,symtra,nbasis,offset,lsa)
             if(trim(dft).eq.'off'.and.trim(pcm).eq.'off') then
              ener=nuc+0.5d0* ddot(sqrsize,p           ,1,fock  ,1)+
     $                        ddot(sqrsize,p           ,1,r8heap,1)-
     $                 0.25d0*ddot(sqrsize,p(sqrsize+1),1,qmat  ,1)
             else
              ener=nuc+exc+ddot(sqrsize,p           ,1,r8heap,1)-
     $              0.25d0*ddot(sqrsize,p(sqrsize+1),1,qmat  ,1)
             endif
            CALL DAXPY(SQRSIZE, 1.D0,r8heap,1,FOCK,1)
            if(qscf.eq.'bfgs    '.or.verblevel.ge.3) then
              call dcopy(sqrsize,fock,1,r8heap,1)
            endif
            CALL DAXPY(SQRSIZE,-1.D0,QMAT  ,1,FOCK,1)
            CALL DAXPY(SQRSIZE,0.5D0,RMAT  ,1,FOCK,1)
        END SELECT   
      ENDIF 
      if((qscf.eq.'bfgs    '.or.(qscf.eq.'off     '.and.verblevel.ge.3))
     $   .and.scftype.ne._MCSCF_) then
        if(scftype .lt. 3) then
          scf_grad_norm=check_grad(fock, c, r8heap, sqroffset, 
     $       r8heap1n, r8heap2n, scftype)
        else
          scf_grad_norm=check_grad(r8heap, c, qmat, sqroffset, 
     $       r8heap1n, r8heap2n, scftype)
        endif
        write(iout,"(1X,'Gradient norm: ',ES15.4E2)") 
     $    scf_grad_norm
        if(qscf.eq.'bfgs    '.and.qnewton_step.eq.0.and.
     $     scf_grad_norm.lt.bfgstol) then
          qnewton_step=1
          goto 72826
        endif
      endif
c      if(qscf.eq.'bfgs    '.and.qnewton_step.eq.0) then
c        if(scftype .lt. 3) then
c          if(bfgs_check_grad(fock, c, r8heap, sqroffset, 
c     $       r8heap1n, r8heap2n, scftype, bfgstol)) then
c            qnewton_step=1
c            goto 72826
c          endif
c        else
c          if(bfgs_check_grad(r8heap, c, qmat, sqroffset, 
c     $       r8heap1n, r8heap2n, scftype, bfgstol)) then
c            qnewton_step=1
c            goto 72826
c          endif
c        endif
c      endif
       if(hfroute) then
        write(iout,"(' Reference energy:            ',F24.16,' [AU]')")
     &ener
        if (lanycc(ccalc)) then !NP
          call uppercase(ccalc,c16,16) 
          write(iout,*)
     $'Printing Fock-matrix built from KS orbitals for ',trim(c16),
     $' calculation.'
          call fockprint(fockfile,scftype,symfock,symtra,r8heap,i4heap,
     $fock,offset,lsa,nbasis,itol,eigenvalue,symfock2,sqrsize)
        endif
        call timer
        write(iout,*)
        write(iout,*) 'Calculating rSE correction...'
        call diagfock(scftype,nir,nfunc,sqrsize,sqroffset,orbperir,
     $nbasis,r8heapsize,offset,r8heap2n,fock,c,eigenvalue,.true.,r8heap,
     $erse,ncoreir,localcc)
        write(iout,"(' rSE correction:              ',F24.16,' [AU]')")
     &erse
        call timer
        open(varsfile,file='VARS',form='unformatted',position='append')
        write(varsfile) 'eref      ',ifltln,ener
        write(varsfile) 'erse      ',ifltln,erse
        close(varsfile)
        open(unit=ifcfile,file='iface',status='old',position='append')
        write(ifcfile,7596) 'ENERGY  ','HFKS           ',1,1,1,ener,
     &  tim-timold,wct-wctold
        close(ifcfile)
        return
c        if(trim(ccalc).ne.'mp2') return
       endif
       if(((qscf.ne.'off     '.and.qscf.ne.'bfgs    ').or.
     $     (qscf.eq.'bfgs    '.and.qnewton_step.gt.1))
     $    .and.(step.ne.1.or.INITGUESS.eq._SAD_)) goto 72826
C SC Huzinaga projection
       if(route.eq.'sch ') then
        open(scrfile1,file='HUZPROJ',form='unformatted')
        call woeint(r8heap,i4heap,fock,scrfile1,itol,nbasis)
        call woeint(r8heap,i4heap,fock(sqrsize+1),scrfile1,itol,nbasis)
        close(scrfile1)
        call dsymm('l','u',nbasis,nbasis,0.5d0,p(sqrsize+1),nbasis,
     $sorig,nbasis,0.d0,rs,nbasis)
        call huzproj(nbasis,fock,rs,r8heap)
        call dcopy(nbasis**2,p,1,r8heap,1)
        call daxpy(sqrsize,-1.d0,p(sqrsize+1),1,r8heap,1)
        call dsymm('l','u',nbasis,nbasis,0.5d0,r8heap,nbasis,sorig,
     $nbasis,0.d0,rs(sqrsize+1),nbasis)
        call huzproj(nbasis,fock(sqrsize+1),rs(sqrsize+1),r8heap)
       endif
C ACCELERATING CONVERGENCE USING DIIS
      IF((DIISFL).AND.
     &   (STEP.GE.DIISSTART).AND.
c%%% ez amiatt kell, mert a corfe guessbol nem lehet extrapolalni az elso lepesben!!
     &   (STEP.GT.1).AND.
     &   (STEP.LE.DIISEND).AND.
     &   (MOD(STEP-DIISSTART,DIISSTEP).EQ.0).AND.lfin.ne.2) THEN
        IF(VERBLEVEL.GE.3) THEN                                         !diis will run if this point is reached
          write(iout,*) 'DIIS is running in this iteration step.'
        ENDIF
         if(scftype.eq._UHF_.or.route.eq.'sch ') then
           if(route.eq.'sch ')
     $call dcopy(nbasis**2,p,1,p(sqrsize+1),1)
          call diis_errvec(p,sorig,r8heap(3*sqrsize+1),fock,r8heap,
     $r8heap(2*sqrsize+1),sqroffset,ltroffset,2,scrfile1,c)
          diisrecyet=diisrecyet+1
           if(verblevel.ge.2) then
            write(iout,
     &"(' RMS of [F,P]:                                ',f25.14)")
     &dnrm2(2*ltrsize,r8heap,1)/dsqrt(dble(ltrsize))
           endif
          call ltrpack(fock,fock,nir,sqroffset,ltroffset,nfunc,'p')
          call ltrpack(fock(sqrsize+1),fock(ltrsize+1),nir,sqroffset,
     $ltroffset,nfunc,'p')
          call diis(diisrecyet,2*ltrsize,fock,r8heap,extstep,diisfile,
     $errfile,ifltln,bb,r8heap2n)
          call ltrpack(fock(sqrsize+1),fock(ltrsize+1),nir,sqroffset,
     $ltroffset,nfunc,'u')
          call ltrpack(fock,fock,nir,sqroffset,ltroffset,nfunc,'u')
         else
          call diis_errvec(p,sorig,r8heap(2*sqrsize+1),fock,r8heap,
     $r8heap(sqrsize+1),sqroffset,ltroffset,1,scrfile1,c)
           if(verblevel.ge.2) then
            write(iout,
     &"(' RMS of [F,P]:                                ',f25.14)")
     &dnrm2(ltrsize,r8heap,1)/dsqrt(dble(ltrsize))
           endif
          diisrecyet=diisrecyet+1
          call ltrpack(fock,fock,nir,sqroffset,ltroffset,nfunc,'p')
          call diis(diisrecyet,ltrsize,fock,r8heap,extstep,diisfile,
     $errfile,ifltln,bb,r8heap1n)
          call ltrpack(fock,fock,nir,sqroffset,ltroffset,nfunc,'u')
         endif
      END IF      
C SC Huzinaga projection
c      if(route.eq.'sch ') then
c       call dsyrk('u','n',nbasis,nfroz,2.d0,c,nbasis,0.d0,p(sqrsize+1),
c    $nbasis)
c       call dsyrk('u','n',nbasis,nal-nfroz,2.d0,c(nfroz*nbasis+1),
c    $nbasis,0.d0,p,nbasis)
c       call filllo(p(sqrsize+1),nbasis)
c       call filllo(p,nbasis)
c       call daxpy(sqrsize,1.d0,p(sqrsize+1),1,p,1)
c      endif
C Density-based SCF
       if(ldens) then
        rewind(sdfile)
        write(sdfile) p
        open(scrfile1,file='SROOT',form='unformatted')
        call readone(r8heap,scrfile1,symtra,nbasis,r8heap1n,offset,lsa)
        call readone(r8heap1n,scrfile1,symtra,nbasis,r8heap2n,offset,
     $lsa)
        close(scrfile1)
        call densopt(nbasis,p,fock,sorig,r8heap,r8heap1n,r8heap2n,
     $r8heap3n,r8heap4n,r8heap4n(nbasis**2+1),r8heap4n(2*nbasis**2+1),
     $scfmaxit,pepsilon,nelec/2,iout,verblevel,2.d0,natoms,natrange,
     $fdmind,route)
        goto 4567
       endif
C Solve pseudo-eigenvalue equation
c      if(route.eq.'sch '.and.step.le.10) then
c       rewind(888)
c       write(888) c(1:nfroz*nbasis)
c      endif
       if(step.le.8.and.gap.le.0.2d0.and.scflshift.eq.'off     ') then
        call pseig(r8heap,r8heap1n,0.1d0,step,c,fock,eigenvalue,
     $r8heapsize,offset,sqroffset,sorig,p,scrfile1,route)
       else
        call pseig(r8heap,r8heap1n,lshift,step,c,fock,eigenvalue,
     $r8heapsize,offset,sqroffset,sorig,p,scrfile1,route)
       endif
C Move frozen orbitals to the beginning in the case of Huzinaga eqs
       if(qmreg.eq.'0       '.or.lhuzi) then
         if(scftype.eq._UHF_) then
           do q=1,2
            call huzord(nbasis,c((q-1)*nbasis**2+1),rs(sqrsize+1),
     $eigenvalue((q-1)*nbasis+1),dcore(imem),dcore(imem+nbasis**2),
     $dcore(imem+2*nbasis**2),iout,nfroz,sorig,nbfroz,qmreg,route,
     $nal,nbe,rs(sqrsize+1),schroute,'A') ! HB
           enddo
         else
          call huzord(nbasis,c,rs,eigenvalue,dcore(imem),
     $dcore(imem+nbasis**2),dcore(imem+2*nbasis**2),iout,nfroz,sorig,
     $nbfroz,qmreg,route,nal,nbe,rs(sqrsize+1),schroute,'A') ! HB
         endif
       else if(route.eq.'sch ') then
c     write(6,*) 'eig1'
c     write(6,"(17f9.5)") eigenvalue(1:nbasis)
c     write(6,*) 'c1'
c        do i=1,nbasis
c         write(6,"(i3,10000f9.5)") i,c((i-1)*nbasis+1:i*nbasis)
c        enddo
        call huzord(nbasis,c,rs,eigenvalue,r8heap,r8heap1n,r8heap2n,
     $iout,nfroz,sorig,nbfroz,qmreg,route,nal,nbe,rs(sqrsize+1),
     $schroute,'A') !HB
c     write(6,*) 'eig2',nal,nfroz,nbfroz
c     write(6,"(17f9.5)") eigenvalue(nbasis+1:2*nbasis)
c     write(6,*) 'c2'
c        do i=1,nbasis
c         write(6,"(i3,10000f9.5)")
c    $i,c(sqrsize+(i-1)*nbasis+1:sqrsize+i*nbasis)
c        enddo
        call huzord(nbasis,c(sqrsize+1),rs,eigenvalue(nbasis+1),
     $r8heap,r8heap1n,r8heap2n,iout,nfroz,sorig,nbfroz,qmreg,route,
     $nal,nbe,rs(sqrsize+1),schroute,'B') !HB
        call dcopy(nfroz*nbasis,c(sqrsize+1),1,c,1) !HB
      call dcopy(nfroz,eigenvalue(nbasis+1),1,eigenvalue,1) !HB
c      if(route.eq.'sch '.and.step.le.10) then
c       rewind(888)
c       read(888) c(1:nfroz*nbasis)
c      endif
c     write(6,*) 'cf'
c        do i=1,nbasis
c         write(6,"(i3,10000f9.5)") i,c((i-1)*nbasis+1:i*nbasis)
c        enddo
       endif
72826 continue
C HANDLING THE EIGENVALUES
      SELECT CASE (scftype)
        CASE (_RHF_)
          do i=1,nfroz
           mapping(i)=i
          enddo
          CALL QSORTD(              
     &      MAPPING(nfroz+1),
     &      NBASIS-nfroz,
     &      EIGENVALUE(nfroz+1))          
          do i=nfroz+1,nbasis
           mapping(i)=mapping(i)+nfroz
          enddo
          IF(NOOCCFL) THEN
            CALL IFILLZERO(ORBPERIR,2*nir)
            DO I=1,NDOCC                                                !FILL THE ORBPER IR ARRAY              
              ORBPERIR(INDEXIRREP(MAPPING(I)))=
     &        ORBPERIR(INDEXIRREP(MAPPING(I)))+1
            ENDDO
          ENDIF
         gap=eigenvalue(mapping(min(nbasis,nal+1)))-
     $       eigenvalue(mapping(nal))
        CASE (_UHF_)
          DO Q=1,2                                                      !SORTING THE EIGENVALUES                     
           do i=1,nfroz
            mapping((q-1)*nbasis+i)=i
           enddo
            CALL QSORTD(              
     &        MAPPING(nfroz+(Q-1)*nbasis+1),
     &        NBASIS-nfroz,
     &        EIGENVALUE(nfroz+(Q-1)*nbasis+1))          
           do i=nfroz+1,nbasis
            mapping((q-1)*nbasis+i)=mapping((q-1)*nbasis+i)+nfroz
           enddo
          ENDDO
          IF(NOOCCFL) THEN
            CALL IFILLZERO(ORBPERIR,2*nir)
            DO Q=1,2
              DO I=1,NOCCSP(Q)                                          !FILL THE ORBPER IR ARRAY                
                ORBPERIR(INDEXIRREP(MAPPING(I+(Q-1)*nbasis))
     &            +(Q-1)*nir)=
     &          ORBPERIR(INDEXIRREP(MAPPING(I+(Q-1)*nbasis))
     &            +(Q-1)*nir)+1
              ENDDO
            ENDDO        
          ENDIF
         gap=min(eigenvalue(mapping(min(nbasis,nal+1)))-
     $eigenvalue(mapping(nal)),
     $eigenvalue(nbasis+mapping(nbasis+min(nbasis,nbe+1)))-
     $eigenvalue(nbasis+mapping(nbasis+nbe)))
        CASE (_ROHFSTD_,_ROHFSCN_)
          CALL QSORTD(MAPPING,NBASIS,EIGENVALUE)                        !SORTING THE EIGENVALUES 
           if(rohfcore.eq.'standard     ') then
            ncoreir(1:nir)=0
            do i=1,ncore
             ncoreir(INDEXIRREP(MAPPING(I)))=
     &       ncoreir(INDEXIRREP(MAPPING(I)))+1
            enddo
          endif
          IF(NOOCCFL) THEN
            CALL IFILLZERO(ORBPERIR,2*nir)
            DO I=1,NDOCC                                                !EIGENVALUES FOR THE DOUBLY OCCUPIED PART             
              ORBPERIR(INDEXIRREP(MAPPING(I)))=
     &        ORBPERIR(INDEXIRREP(MAPPING(I)))+1
            ENDDO
            DO I=1,NSOCC                                                !EIGENVALUES FOR THE SINGLE OCCUPIED PART           
              ORBPERIR(INDEXIRREP(MAPPING(I+NDOCC))+nir)=
     &        ORBPERIR(INDEXIRREP(MAPPING(I+NDOCC))+nir)+1
            ENDDO  
          ENDIF
         gap=eigenvalue(mapping(min(nbasis,nal+1)))-
     $       eigenvalue(mapping(nal))
      END SELECT
      if(qscf.ne.'off     '.and.nooccfl) call qscf_init(qscf)
C SAVING THE OLD DENSITY MATRIX BEFORE CREATING NEW
c      if(route.eq.'sch '.and.step.gt.1)
c    $call daxpy(sqrsize,1.d0,p(sqrsize+1),1,p,1)
      if(qscf.eq.'off     ') then
        rewind(sdfile)
        write(sdfile) p
      endif
C Quadratic SCF
c72826 continue
c      write(*,*) 'ener exact: ', ener
C CALCULATING THE NEW DENSITY MATRIX TO P
      if(qscf .eq. 'off     ' .or. 
     &   (step.eq.1 .and. initguess .ne. _SAD_) .or. 
     &   (qscf.eq.'bfgs    '.and.qnewton_step.le.1)) then
        SELECT CASE (scftype)
        CASE (_RHF_)
          DO I=1,NIR
            IF(NFUNC(I).EQ.0) CYCLE
           call dsyrk('u','n',nfunc(i),orbperir(i)-nfr,2.d0,
     $c(nfr*nbasis+sqroffset(i)),nfunc(i),0.d0,p(sqroffset(i)),nfunc(i))
           call filllo(p(sqroffset(i)),nfunc(i))
          ENDDO
          if(route.eq.'sch ') then
           call dsyrk('u','n',nbasis,nfroz,2.d0,c,nbasis,0.d0,
     $p(sqrsize+1),nbasis)
           call filllo(p(sqrsize+1),nbasis)
         endif
        CASE (_UHF_)
          DO Q=1,2
            DO I=1,NIR
              IF(NFUNC(I).EQ.0) CYCLE
             call dsyrk('u','n',nfunc(i),orbperir(i+(q-1)*nir)-nfr,1.d0,
     $c(nfr*nbasis+sqroffset(i)+(q-1)*sqrsize),nfunc(i),0.d0,
     $p(sqroffset(i)+(q-1)*sqrsize),nfunc(i))
             call filllo(p(sqroffset(i)+(q-1)*sqrsize),nfunc(i))
            ENDDO
          ENDDO      
        CASE (_ROHFSTD_,_ROHFSCN_)
          DO I=1,NIR                                                    !CALCULATING THE CLOSED DENSITY MATRIX
            IF(NFUNC(I).EQ.0) CYCLE
           call dsyrk('u','n',nfunc(i),orbperir(i)-nfr,2.d0,
     $c(nfr*nbasis+sqroffset(i)),nfunc(i),0.d0,p(sqroffset(i)),nfunc(i))
           call filllo(p(sqroffset(i)),nfunc(i))
          ENDDO
          DO I=1,NIR                                                    !CALCULATING THE OPEN DENSITY MATRIX
            IF(NFUNC(I).EQ.0) CYCLE
           call dsyrk('u','n',nfunc(i),orbperir(i+nir)-nfr,1.d0,
     $c(nfr*nbasis+sqroffset(i)+orbperir(i)*nfunc(i)),nfunc(i),0.d0,
     $p(sqroffset(i)+sqrsize),nfunc(i))
           call filllo(p(sqroffset(i)+sqrsize),nfunc(i))
          ENDDO
          call daxpy(sqrsize,1.d0,p(sqrsize+1),1,p,1)                   !ADDING UP OPEN AND CLOSED PART TO TOTAL DENSITY
        END SELECT
      endif
c      if(embed.eq.'fdm     '.and.route.eq.'em3 ') then
c       call emftdens(nbasis,natoms,minpfile,natrange,fdmind,iout,
c    $p,symdens,c,nocc,c,.false.,.true.)
c       call dcopy(sqrsize,p,1,symfock,1)
c       call dcopy(sqrsize,symdens,1,p,1)
c       call dscal(sqrsize,trab/ddot(sqrsize,p,1,sorig,1),p,1)
c       symdens=0.d0
c       call envdens(nbasis,natoms,natrange,fdmind,symfock,symdens)
c       call dscal(sqrsize,
c    $(dble(nelec)-trab)/ddot(sqrsize,symdens,1,sorig,1),symdens,1)
c       call daxpy(sqrsize,1.d0,symdens,1,p,1)
c
c       call emftdens(nbasis,natoms,minpfile,natrange,fdmind,iout,
c    $p,symdens,c,nocc,c,.false.,.true.)
c       call dcopy(sqrsize,symdens,1,p,1)
c       call dscal(sqrsize,trab/ddot(sqrsize,p,1,sorig,1),p,1)
c       rewind(999)
c       read(999) symfock
c       call envdens(nbasis,natoms,natrange,fdmind,symfock,p)
c       call dscal(sqrsize,0.5d0,p,1)
c       call mcweeny(p,sorig,nbasis,nelec/2,r8heap,r8heap1n,r8heap2n,
c    $pepsilon,iout,verblevel,scfmaxit)
c       call dscal(sqrsize,2.d0,p,1)
c      endif
4567  continue
C Damping the density matrix
       if(scfdamp.ne.'off             ') then
        read(scfdamp,*) temp
        rewind(sdfile)
        read(sdfile) r8heap
         if(scftype.eq._RHF_) then
          call dscal(sqrsize,(1.d0-temp),p,1)
          call daxpy(sqrsize,temp,r8heap,1,p,1)
          call purify(p,p(sqrsize+1),nbasis,nal-nfr,nbe-nfr,r8heap,
     $r8heap1n,r8heap2n,nooccfl,orbperir,orbperir(nir+1),nir,nfunc,
     $sqrsize,offset,sqroffset,indexirrep,mapping,2,1,scrfile1,symtra,
     $lsa,nfuns,ndao)
         else
          call dscal(2*sqrsize,(1.d0-temp),p,1)
          call daxpy(2*sqrsize,temp,r8heap,1,p,1)
           if(scftype.eq._UHF_) then
            call purify(p,p(sqrsize+1),nbasis,nal,nbe,r8heap,r8heap1n,
     $r8heap2n,nooccfl,orbperir,orbperir,nir,nfunc,sqrsize,offset,
     $sqroffset,indexirrep,mapping,1,1,scrfile1,symtra,lsa,nfuns,ndao)
            call purify(p(sqrsize+1),p,nbasis,nbe,nbe,r8heap,r8heap1n,
     $r8heap2n,nooccfl,orbperir(nir+1),orbperir,nir,nfunc,sqrsize,
     $offset,sqroffset,indexirrep,mapping,1,1,scrfile1,symtra,lsa,nfuns,
     $ndao)
           else
            call daxpy(sqrsize,-1.d0,p(sqrsize+1),1,p,1)
            call purify(p,p(sqrsize+1),nbasis,nbe,nbe,r8heap,r8heap1n,
     $r8heap2n,nooccfl,orbperir,orbperir,nir,nfunc,sqrsize,offset,
     $sqroffset,indexirrep,mapping,2,1,scrfile1,symtra,lsa,nfuns,ndao)
            call purify(p(sqrsize+1),p,nbasis,nal-nbe,nbe,r8heap,
     $r8heap1n,r8heap2n,nooccfl,orbperir(nir+1),orbperir,nir,nfunc,
     $sqrsize,offset,sqroffset,indexirrep,mapping,1,1,scrfile1,symtra,
     $lsa,nfuns,ndao)
            call daxpy(sqrsize,1.d0,p(sqrsize+1),1,p,1)
           endif
         endif
       endif
C Save density matrix for restart
      open(unit=scrfile2,file='SCFDENSITIES',form='unformatted')
      rewind(scrfile2)
      call mxto(symdens,symtra,r8heap,nbasis,p,offset,lsa)
      call woeint(r8heap,i4heap,symdens,scrfile2,itol,nbasis)
       if(scftype.ne._RHF_) then
        call mxto(symdens2,symtra,r8heap,nbasis,p(sqrsize+1),offset,lsa)
        call woeint(r8heap,i4heap,symdens2,scrfile2,itol,nbasis)
       endif
      close(scrfile2)
C Remove linear dependency from Fock matrix in the case of dual-basis
       if(trim(dual).eq.'on')
     $call lindep(fock,scftype,nfunc,nfuns,nir,ndao,r8heap,r8heap1n,
     $scrfile3,sqrsize,sqroffset)
C CALCULATING DIFFERENCE DENSITY MATRIX
      SELECT CASE (scftype)
        CASE (_RHF_)
          rewind(sdfile)
          read(sdfile) r8heap
C%%% sima kulonbsegi felepito
          call dscal(sqrsize,-1.d0,r8heap,1)                            !mult difference with 1.d0  
          call daxpy(sqrsize,1.d0,p,1,r8heap,1)                         !adding up  
          devparr(1)=dnrm2(sqrsize,r8heap,1)/dsqrt(dble(sqrsize))
          devparr(2)=0.d0
          if(verblevel.ge.2) then
           write(iout,
     &"(' RMS of difference density:                   ',f25.14)")
     &        devparr(1)
          endif  
          if(ldual) then
           ener=ener+ddot(sqrsize,r8heap,1,fock,1)
c     write(6,"(10f20.12)") ddot(sqrsize,r8heap,1,fock,1)
            if((trim(dual).eq.'e1'.or.trim(dual).eq.'e2').and.
     $route.eq.'em1 ') then
             open(scrfile1,file='HUZPROJ',form='unformatted')
             call rtdmx(r8heap,i4heap,rs,scrfile1,nbasis,nbasis)
             close(scrfile1)
             call getvar('nfroz     ',i)
             call dgemm('n','n',nbasis,nal,nbasis,1.d0,rs,nbasis,
     $c,nbasis,0.d0,r8heap1n,nbasis)
             call daxpy(nbasis*nal,-1.d0,r8heap1n,1,c,1)
             call dsyrk('u','n',nbasis,nal,2.d0,c,nbasis,0.d0,p,nbasis)
             call filllo(p,nbasis)
             call purify(p,p(sqrsize+1),nbasis,nal-i,nbe-i,c,r8heap,
     $r8heap1n,.false.,nal-i,nbe-i,nir,nfunc,sqrsize,offset,sqroffset,
     $indexirrep,mapping,2,1,scrfile1,symtra,lsa,nfuns,ndao)
             open(scrfile1,file='SCFDENSITIES_A',form='unformatted',
     $position='append')
             call woeint(r8heap1n,r8heap1n,p,scrfile1,0.d0,nbasis)
             close(scrfile1)
            endif
          endif
        CASE (_UHF_)
c%%% sima kulonbsegi felepito
          rewind(sdfile)
          read(sdfile) r8heap
          call dscal(2*sqrsize,-1.d0,r8heap,1)                          !mult difference with 1.d0 
          call daxpy(2*sqrsize,1.d0,p,1,r8heap,1)                       !adding up 
          devparr(1)=dnrm2(sqrsize,r8heap,1)/dsqrt(dble(sqrsize))
          devparr(2)=dnrm2(sqrsize,r8heap(sqrsize+1),1)/
     $dsqrt(dble(sqrsize))
          if(verblevel.ge.2) then
           write(iout,
     &"(' RMS of alpha difference density:             ',f25.14)")
     &        devparr(1)
           write(iout,
     &"(' RMS of beta  difference density:             ',f25.14)")
     &        devparr(2) 
          endif  
          if(ldual) ener=ener+ddot(2*sqrsize,r8heap,1,fock,1)
        CASE (_ROHFSTD_,_ROHFSCN_)
          rewind(sdfile)
          read(sdfile) r8heap
c%%% sima kulonbsegi felepito
          call dscal(2*sqrsize,-1.d0,r8heap,1)                          !mult difference with 1.d0
          call daxpy(2*sqrsize,1.d0,p,1,r8heap,1)                       !adding up
          devparr(1)=dnrm2(sqrsize,r8heap,1)/dsqrt(dble(sqrsize))
          devparr(2)=dnrm2(sqrsize,r8heap(sqrsize+1),1)/
     $dsqrt(dble(sqrsize))
          if(verblevel.ge.2) then
           write(iout,
     &"(' RMS of total difference density:             ',f25.14)")
     &        devparr(1)
           write(iout,
     &"(' RMS of open-shell difference density:        ',f25.14)")
     &        devparr(2)
          endif   
          if(ldual) ener=ener+ddot(sqrsize,r8heap           ,1,fock,1)+
     $                  0.5d0*ddot(sqrsize,r8heap(sqrsize+1),1,qmat,1)
        case(_MCSCF_)
          if(step .gt. 1) then
            rewind(sdfile)
            read(sdfile) r8heap(1:sqrsize)
            call daxpy(sqrsize,-1.d0,p,1,r8heap,1)
            devparr(1)=dnrm2(sqrsize,r8heap,1)/dsqrt(dble(sqrsize))
            read(sdfile) r8heap(1:nact**2)
            call daxpy(nact*nact,-1.d0,dcore(ip2),1,r8heap,1)
            devparr(2)=dnrm2(nact**2,r8heap,1)/dsqrt(dble(nact**2))
            if(verblevel.ge.2) then
              write(iout,
     &"(' RMS of occupied difference density:          ',f25.14)")
     &        devparr(1)
              write(iout,
     &"(' RMS of active difference density:            ',f25.14)")
     &        devparr(2)
            endif   
          endif
      end select
       if(verblevel.ge.2) write(iout,"(a10,f12.8)") ' Gap [au]:',gap
       if(ldiff) then
        rewind(scfile)
        write(scfile) r8heap !Save difference density
        rewind(sdfile)
        write(sdfile) p !Save full density
       endif
c PRINTING OUT RESULT IN EVERY ITERATION
      IF(VERBLEVEL.GE.2) THEN
         if(scftype.eq._MCSCF_) then
          write(iout,
     &"(' *** MCSCF ENERGY IN STEP',I4,' IS       ',F24.16,' [AU]')")
     &STEP,ENER
         else
          call occprinter('f',irlab)
          write(iout,*)
           if(trim(dft).eq.'off') then
            write(iout,
     &"(' ***HARTREE-FOCK ENERGY IN STEP',I4,' IS ',F24.16,' [AU]')")
     &STEP,ENER
           else
            write(iout,
     &"(' ***KOHN-SHAM ENERGY IN STEP',I4,' IS    ',F24.16,' [AU]')")
     &STEP,ENER
           endif
         endif
      ENDIF
c iface file printout code
      open(unit=ifcfile,file='iface',status='unknown')
      call getvar('selfenergy',temp)
      write(ifcfile,"(68a)")
     &'#property method        sym st mul        value' //
     &'             CPU(sec)       Wall(sec)'
      write(ifcfile,7596) 'SELFENER','MM             ',1,1,1,temp,
     &  tim-timold,wct-wctold
      write(ifcfile,7596) 'ENERGY  ','SCF            ',1,1,1,ener,
     &tim-timold,wct-wctold
      close(ifcfile)
7596  format(a8,1x,a15,1x,3(i2,1x),1pe23.15,2(1pe15.8))
      DEVENER=OLDENER-ENER                                              !CALCULATING THE DEVIATION OF ENERGY
      OLDENER=ENER                                                      !SAVING THE VALUE OF THE ENERGY FOR THE NEXT STEP
C DETERMINE IF THE ALGORITHM CONVERGED OR NOT
      call getkey('scfmaxit',8,c4,4)
      read(c4,*) i
      scfmaxit=min(scfmaxit,i)
      IF((
     &  (DABS(DEVPARR(1)) .LE. PEPSILON) .AND.                          
     &  (DABS(DEVPARR(2)) .LE. PEPSILON) .AND.                          
     &  (DABS(DEVENER) .LE. ENEREPSILON) .AND.
     &  (qscf.eq.'off     '.or.grad_max_norm.lt.enerepsilon*0.1d0).AND.
     &  (.not. qscf_reject)) .OR.
     &  (SCFMAXIT .LE. STEP).or.lfin.eq.2.or.ldual) then
        if(lfin.eq.1) then
         lfin=2
          if(chfx.eq.0.d0) exit
         write(iout,*)
         write(iout,*) 'The SCF iteration has converged.'
         write(iout,*) 'An extra iteration will be performed to ' //
     $'calculate accurate SCF energy.'
         write(iout,*)
        else
         EXIT
        endif
      endif
      STEP=STEP+1                                                       !INCREASING THE STEP COUNTER
C Saving restart information
      open(unit=scrfile1,file='RESTART',form='unformatted')
      write(scrfile1) step,diisrecyet,lwdfn,lfin
      write(scrfile1) bb
      write(scrfile1) gap
      close(scrfile1)
      CALL FLUSH(6)                                                     !FORCE PRINT TO TERMINAL IN EACH ITERATION
      ENDDO
C-----------------------------------------------------------------------
C MAIN ITERATION END
C-----------------------------------------------------------------------
C PRINTING OUT STEP COUNT AND ENERGY IF TEST MODE (VERBOSITY=1)
      if(qscf .ne. 'off     ') then
        if(scftype .eq. _MCSCF_) then
          ieigval = dblalloc(nbasis) ! For sorting MOs
          iocc_num = dblalloc(nbasis) ! Occupation number
        else
          ieigval = dblalloc(0)
          iocc_num = dblalloc(0)
        endif
        call orbitener(c, eigenvalue, dcore(ieigval), dcore(iocc_num),
     &       sqroffset, offset, r8heap, lfin, exc, dft, chfx, lwdfn,
     &       embed, scfdamp, route, nfr, nc, ncorenew, devparr, npos,
     &       r8heapsize, mapping, nooccfl, clrhfx, csrhfx, omega, pcm)
      endif
9999  IF(VERBLEVEL.EQ.1) THEN
        call occprinter('r',irlab)
        write(iout,"(I4)") STEP                                         !NUMBER OF FULL SETEPS TO CONVERGENCE  
        write(iout,"(F24.16)") ENER                                     !FINAL ENERGY
      ENDIF
C PRETTY PRINTING FINAL RESULTS
      IF(VERBLEVEL.GE.2) THEN
        write(iout,"(1X,70('='))")
        IF(STEP.LT.SCFMAXIT) THEN
          write(iout,*) 
          write(iout,"(' SUCCESS...')")
          write(iout,"(' THE SCF ITERATION HAS CONVERGED!')")
        ELSE
          write(iout,*) 
          write(iout,"(' THE SCF ITERATION HAS NOT CONVERGED,')")
          write(iout,"(' IN MAXIMAL NUMBER OF STEPS SET BY USER!')")
        ENDIF
        write(iout,*) 
         if(scftype.eq._MCSCF_) then
          write(iout,
     &"(' ***FINAL MCSCF ENERGY:       ',F24.16,' [AU]')")ENER
         else
          call occprinter('l',irlab)
          write(iout,*) 
           if(trim(dft).eq.'off') then
            write(iout,
     &"(' ***FINAL HARTREE-FOCK ENERGY:',F24.16,' [AU]')")ENER
           else
            write(iout,
     &"(' ***FINAL KOHN-SHAM ENERGY:   ',F24.16,' [AU]')")ENER
           endif
         endif
         if(.not.kscorr) then
          open(varsfile,file='VARS',form='unformatted',
     $position='append')
           if(route.eq.'em1 ') then
            write(varsfile) 'edftab    ',ifltln,ener
           else
            write(varsfile) 'eref      ',ifltln,ener
           endif
          close(varsfile)
         endif
      endif
C Remove linear dependency
      call lindep(fock,scftype,nfunc,nfuns,nir,ndao,r8heap,r8heap1n,
     $scrfile3,sqrsize,sqroffset)
C Canonicalize orbitals in the case of SCL embedding
       if(.false.) then!embed.eq.'scl     ') then
        open(scrfile1,file='SROOT',form='unformatted')
        call roeint(r8heap2n,r8heap2n,r8heap  ,scrfile1,nbasis)
        call roeint(r8heap2n,r8heap2n,r8heap1n,scrfile1,nbasis)
        close(scrfile1)
        call fragloc(nbasis,p,r8heap4n,r8heap4n(4*nbasis**2+1),r8heap1n,
     $r8heap,r8heap2n,r8heap4n(5*nbasis**2+1),natoms,minpfile,
     $icore(inatrange),nal,nc,2.d0,nn,
     $verblevel,r8heap3n,.true.,ncorenew,r8heap4n(nbasis**2+1),nbf(4),
     $r8heap4n(2*nbasis**2+1),r8heap4n(3*nbasis**2+1),scrfile1)
        nn=nc
        nc=nal-nc
        call getkey('core',4,core,6)
         if(core.eq.'corr  ') ncorenew=0
        ncorenew=ncorenew+nc
        call ishell('cp VARS VARS.old')
        open(varsfile,file='VARS.new',form='unformatted')
        write(varsfile) 'ncore     ',iintln,ncorenew
        close(varsfile)
        call ishell('cat VARS.new VARS.old > VARS')
        call ishell('rm -f VARS.new VARS.old')
         if(nc.gt.0) then
        call dsymm ('l','l',nbasis,nc,1.d0,fock,nbasis,
     $r8heap2n(nbasis*nn+1),nbasis,0.d0,r8heap1n,nbasis)
        call dgemm('t','n',nc,nc,nbasis,1.d0,r8heap2n(nbasis*nn+1),
     $nbasis,r8heap1n,nbasis,0.d0,r8heap,nc)
        call dsyev('V','U',nc,r8heap,nc,eigenvalue,r8heap1n,3*nc,error)
        call dgemm('n','n',nbasis,nc,nc,1.d0,r8heap2n(nbasis*nn+1),
     $nbasis,r8heap,nc,0.d0,c,nbasis)
         endif
        call dsymm ('l','l',nbasis,nn,1.d0,fock,nbasis,r8heap2n,nbasis,
     $0.d0,r8heap1n,nbasis)
        call dgemm('t','n',nn,nn,nbasis,1.d0,r8heap2n,nbasis,r8heap1n,
     $nbasis,0.d0,r8heap,nn)
        call dsyev('V','U',nn,r8heap,nn,eigenvalue(nc+1),r8heap1n,3*nn,
     $error)
        call dgemm('n','n',nbasis,nn,nn,1.d0,r8heap2n,nbasis,r8heap,nn,
     $0.d0,c(nbasis*nc+1),nbasis)
         do i=1,nal
          mapping(i)=i
         enddo
        nfroz=nc
       endif
      if(VERBLEVEL.GE.2) then
C Calculate <S^2>, Szabo & Ostlund Eq. 2.271
        if(scftype.eq._UHF_) then
         s2=dble(nal-nbe)/2.d0
         s2=s2*(s2+1.d0)+nbe
          do i=1,nir
            if(orbperir(i)*orbperir(i+nir)*nfunc(i).eq.0) cycle
           call dgemm('n','n',nfunc(i),orbperir(i),nfunc(i),1.d0,
     $sorig(sqroffset(i)),nfunc(i),c(sqroffset(i)),nfunc(i),0.d0,r8heap,
     $nfunc(i))
           call dgemm('t','n',orbperir(i+nir),orbperir(i),nfunc(i),
     $1.d0,c(sqroffset(i)+sqrsize),nfunc(i),r8heap,nfunc(i),0.d0,
     $r8heap1n,orbperir(i+nir))
           s2=s2-ddot(orbperir(i+nir)*orbperir(i),r8heap1n,1,r8heap1n,1)
          enddo
         write(iout,*)
         write(iout,"(' Expectation value of S^2:',f8.4)") s2
         write(iout,"(' Average multiplicity:    ',f8.4)") 
     $dsqrt(1.d0+4.d0*s2)
        endif
C Print orbital energies
        select case (scftype)
        case (_UHF_)
         q=2
        case default
         q=1
        end select
c      do i=1,nal
c       write(*,"(i3,72f10.6)") i,(c((i-1)*nbasis+j),j=1,nbasis)
c      enddo
        if(qmreg.eq.'0       '.or.lhuzi.or.embed.eq.'scl     '.or.
     $route.eq.'sch ') then
         write(iout,*)
         write(iout,*) 'Orbital energies [au]:'
         write(iout,*) '     Irrep         Alpha          Beta'
         if(qmreg.eq.'0       '.or.lhuzi.or.embed.eq.'scl     ') then !HB
          do i=1,nfroz
           write(iout,"(i5,3x,a4,2f15.6,a20)") i,'A   ',!irlab(mosym(mapping(I))),
     $EIGENVALUE(MAPPING(I)),
     $EIGENVALUE(MAPPING(I+(Q-1)*nbasis)+(Q-1)*nbasis),
     $'    (frozen orbital)'
          enddo
         else if(route.eq.'sch ') then
          do i=1,nfroz
           write(*,"(i5,3x,a4,2f15.6,a32)") i,'A   ',!irlab(mosym(mapping(I))),
     $EIGENVALUE(MAPPING(I)),
     $EIGENVALUE(MAPPING(I+(Q-1)*nbasis)+(Q-1)*nbasis),
     $'    (orbital of the environment)'
          enddo
         endif
         do i=nfroz+1,nbasis-ndao
          write(*,"(i5,3x,a4,2f15.6)") i,'A   ',!irlab(mosym(mapping(I))),
     $EIGENVALUE(MAPPING(I)),
     $EIGENVALUE(MAPPING(I+(Q-1)*nbasis)+(Q-1)*nbasis)
           if(i.eq.ndocc) write(iout,*)
         enddo
        endif
      endif
C CALCULATING SEMICANONICAL ORBITALS FOR CORRELATION CALCULATIONS
      if(scftype.eq._ROHFSCN_) then
c Save restricted orbitals for open-shell local correlation calculations
        if (localcc.ne.'off ') then
          call make_alprmap(nir,nirmax,doccperir,orbperir,soccperir,
     &virtperir,nfunc,nbasis,mosym,offset,alprmap,ndocc,eigenvalue,
     &nsocc,nvirt,.true.)
          call moto(cpr ,symtra,r8heap2n,nbasis,c           ,offset,lsa)
          call reorder(cpr ,eigenvalue,nbasis,alprmap,r8heap2n,r8heap2n)
          open(unit=mocoeffile,file='MOCOEF',form='unformatted')
            call wrtmo(r8heap2n,r8heap2n,cpr ,mocoeffile,itol,nbasis,
     $nbasis)
          close(mocoeffile)
c Write moldenfile with restricted orbitals
          if (molden.eq.'on  ') call molden_rohfstd(nbasis,mapping,
     $     ndocc,nsocc,cpr,eigenvalue,moldenfile)
        endif
        do q=1,nir                                                   !save rohf order occupations
          doccperir(q)=orbperir(q)
          soccperir(q)=orbperir(q+nir)
          virtperir(q)=nfunc(q)-(doccperir(q)+soccperir(q))
        enddo
        do q=1,nir                                                   !modify orbperir array to uhf order
          itemp=orbperir(q+nir)
          orbperir(q+nir)=orbperir(q)
          orbperir(q)=orbperir(q)+itemp
        enddo
        call dcopy(sqrsize,c,1,c(sqrsize+1),1)
c calculate density matrix
        do q=1,2
          do i=1,nir
            if(nfunc(i).gt.0) then
             call dsyrk('u','n',nfunc(i),orbperir(i+(q-1)*nir),1.d0,
     $c(sqroffset(i)+(q-1)*sqrsize),nfunc(i),0.d0,
     $p(sqroffset(i)+(q-1)*sqrsize),nfunc(i))
             call filllo(p(sqroffset(i)+(q-1)*sqrsize),nfunc(i))
            endif
          enddo
        enddo        
        call mxto(symdens ,symtra,r8heap,nbasis,p           ,offset,lsa)
        call mxto(symdens2,symtra,r8heap,nbasis,p(sqrsize+1),offset,lsa)
c BUILD FOCK
        write(iout,*)
        scftype=_UHF_
        call fock_build(
     &    symdens,
     &    symdens2,
     &    symfock,
     &    symfock2,
     &    symqmat,
     &    indexirrep,
     &    offset,
     &    sqroffset,
     &    npos,
     &    intpos,
     &    step,c(nfr*nbasis+1),lfin,exc,dft,chfx,lwdfn,embed,scfdamp,
     &    route,nfr,nc,ncorenew,devparr,symtra,0,clrhfx,csrhfx,omega,rs,
     &    .false.,1,1,pcm)
        scftype=_ROHFSCN_
        call mxts(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
        call mxts(symfock2,symtra,r8heap,nbasis,fock(sqrsize+1),
     $offset,lsa)
        call readh(r8heap,oeintfile,symtra,nbasis,offset,lsa)
         if(trim(dft).eq.'off'.and.trim(pcm).eq.'off') then
          ener=nuc+
     $         0.5d0*ddot(sqrsize,p           ,1,fock           ,1)+
     $         0.5d0*ddot(sqrsize,p(sqrsize+1),1,fock(sqrsize+1),1)+
     $               ddot(sqrsize,p           ,1,r8heap         ,1)+
     $               ddot(sqrsize,p(sqrsize+1),1,r8heap         ,1)
         else
          ener=nuc+exc+ddot(sqrsize,p           ,1,r8heap,1)+
     $                 ddot(sqrsize,p(sqrsize+1),1,r8heap,1)
         endif
        call daxpy(sqrsize,1.d0,r8heap,1,fock           ,1)
        call daxpy(sqrsize,1.d0,r8heap,1,fock(sqrsize+1),1)
        open(unit=fockfile,file='FOCK',form='unformatted')
        call mxto(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
        call mxto(symfock2,symtra,r8heap,nbasis,fock(sqrsize+1),
     $offset,lsa)
        call woeint(r8heap,i4heap,symfock ,fockfile,itol,nbasis)
        call woeint(r8heap,i4heap,symfock2,fockfile,itol,nbasis)
        close(fockfile)
C Transform Fock-matrix to MO basis and diagonalize
        call diagfock(2,nir,nfunc,sqrsize,sqroffset,orbperir,nbasis,
     $r8heapsize,offset,r8heap,fock,c,eigenvalue,.false.,fock,erse,
     $ncoreir,localcc)
C CALCULATE SEMICANONICAL COEFFICIENTS
       call dfillzero(r8heap,2*sqrsize)
c alpha
        do i=1,nir
          if(nfunc(i).eq.0) cycle
          call dgemm(                                                   !occ-occ block  
     &      'n',
     &      'n',
     &      orbperir(i),
     &      orbperir(i), 
     &      orbperir(i), 
     &      1.d0,
     &      c(sqroffset(i)),
     &      nfunc(i), 
     &      fock(sqroffset(i)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqroffset(i)),
     &      nfunc(i))
          call dgemm(                                                   !occ-virt block  
     &      'n',
     &      'n',
     &      orbperir(i),
     &      nfunc(i)-orbperir(i), 
     &      nfunc(i)-orbperir(i), 
     &      1.d0,
     &      c(sqroffset(i)+orbperir(i)*nfunc(i)),
     &      nfunc(i), 
     &      fock(sqroffset(i)+orbperir(i)*(nfunc(i)+1)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqroffset(i)+orbperir(i)*nfunc(i)),           
     &      nfunc(i))
          call dgemm(                                                   !virt-occ block  
     &      'n',
     &      'n',
     &      nfunc(i)-orbperir(i),
     &      orbperir(i), 
     &      orbperir(i), 
     &      1.d0,
     &      c(sqroffset(i)+orbperir(i)),
     &      nfunc(i), 
     &      fock(sqroffset(i)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqroffset(i)+orbperir(i)),
     &      nfunc(i))
          call dgemm(                                                   !virt-virt block  
     &      'n',
     &      'n',
     &      nfunc(i)-orbperir(i),
     &      nfunc(i)-orbperir(i), 
     &      nfunc(i)-orbperir(i), 
     &      1.d0,
     &      c(sqroffset(i)+orbperir(i)*(nfunc(i)+1)),
     &      nfunc(i), 
     &      fock(sqroffset(i)+orbperir(i)*(nfunc(i)+1)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqroffset(i)+orbperir(i)*(nfunc(i)+1)),
     &      nfunc(i))
        enddo
c beta
        do i=1,nir                                                      !occ-occ block
          if(nfunc(i).eq.0) cycle
          call dgemm(
     &      'n',
     &      'n',
     &      orbperir(i+nir),
     &      orbperir(i+nir), 
     &      orbperir(i+nir), 
     &      1.d0,
     &      c(sqrsize+sqroffset(i)),
     &      nfunc(i), 
     &      fock(sqrsize+sqroffset(i)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqrsize+sqroffset(i)),
     &      nfunc(i))
          call dgemm(                                                   !occ-virt block  
     &      'n',
     &      'n',
     &      orbperir(i+nir),
     &      nfunc(i)-orbperir(i+nir), 
     &      nfunc(i)-orbperir(i+nir), 
     &      1.d0,
     &      c(sqrsize+sqroffset(i)+orbperir(i+nir)*nfunc(i)),
     &      nfunc(i), 
     &      fock(sqrsize+
     &        sqroffset(i)+
     &        orbperir(i+nir)*(nfunc(i)+1)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqrsize+sqroffset(i)+orbperir(i+nir)*nfunc(i)),
     &      nfunc(i))
          call dgemm(                                                   !virt-occ block  
     &      'n',
     &      'n',
     &      nfunc(i)-orbperir(i+nir),
     &      orbperir(i+nir), 
     &      orbperir(i+nir), 
     &      1.d0,
     &      c(sqrsize+sqroffset(i)+orbperir(i+nir)),
     &      nfunc(i), 
     &      fock(sqrsize+sqroffset(i)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqrsize+sqroffset(i)+orbperir(i+nir)),
     &      nfunc(i))
          call dgemm(                                                   !virt-virt block  
     &      'n',
     &      'n',
     &      nfunc(i)-orbperir(i+nir),
     &      nfunc(i)-orbperir(i+nir), 
     &      nfunc(i)-orbperir(i+nir), 
     &      1.d0,
     &      c(sqrsize+sqroffset(i)+orbperir(i+nir)*(nfunc(i)+1)),
     &      nfunc(i), 
     &      fock(sqrsize+
     &        sqroffset(i)+
     &        orbperir(i+nir)*(nfunc(i)+1)),
     &      nfunc(i), 
     &      0.d0,
     &      r8heap(sqrsize+sqroffset(i)+orbperir(i+nir)*(nfunc(i)+1)),
     &      nfunc(i))
        enddo
      call dcopy(2*sqrsize,r8heap,1,c,1)    
#if defined (MPI)
      call MPI_Bcast(c,2*sqrsize,MPI_DOUBLE_PRECISION,0,
     $MPI_COMM_WORLD,i)
#endif
C CALCULATING HARTREE-FOCK ENERGY FROM SEMICANONICAL ORBITALS
c calculate new p
        do q=1,2
          do i=1,nir
            if(nfunc(i).gt.0) then
             call dsyrk('u','n',nfunc(i),orbperir(i+(q-1)*nir),1.d0,
     $c(sqroffset(i)+(q-1)*sqrsize),nfunc(i),0.d0,
     $p(sqroffset(i)+(q-1)*sqrsize),nfunc(i))
             call filllo(p(sqroffset(i)+(q-1)*sqrsize),nfunc(i))
            endif
          enddo
        enddo
c calc energy
        do q=1,2                                                        !sorting the eigenvalues                     
          call qsortd(              
     &      mapping((q-1)*nbasis+1),
     &      nbasis,
     &      eigenvalue((q-1)*nbasis+1))          
        enddo 
c        ener=nuc                                                        !adding the nuclear repulsion     
c        do q=1,2
c          do i=1,noccsp(q)                                              !adding the mo energes            
c            ener=ener+0.5d0*                                            !for alpha and beta
c     &      eigenvalue(mapping(i+(q-1)*nbasis)+(q-1)*nbasis)
c          enddo
c        enddo
c        call readh(r8heap,oeintfile,symtra,nbasis,offset,lsa)
c        ener=ener+0.5d0*ddot(sqrsize,p,1,r8heap,1)                      !adding 0.5d0*tr(ph)
c        ener=ener+0.5d0*ddot(sqrsize,p(sqrsize+1),1,r8heap,1)           !for alpha and beta  
         if(trim(dft).eq.'off') then
          write(iout,
     &"(' ***SEMICANONICAL ROHF ENERGY:',F24.16,' [AU]')") ener 
         else
          write(iout,
     &"(' ***SEMICANONICAL ROKS ENERGY:',F24.16,' [AU]')") ener 
         endif
      endif 
C PRINTING OUT CONVERGED MO COEFF MATRIX AND MOLDEN FILE and densities
      open(unit=scrfile2,file='SCFDENSITIES',form='unformatted')
      rewind(scrfile2)
      SELECT CASE (scftype)
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        CASE (_RHF_,_MCSCF_)
          if(qmreg.ne.'0       '.and..not.lhuzi.and.embed.ne.'scl     '
     &.and.route.ne.'sch ') then
            if(scftype .eq. _MCSCF_) then
              call qsortd(mapping, nbasis, dcore(ieigval))
            else
              call qsortd(mapping,nbasis,eigenvalue)!sorting MO's by energy
            endif
          endif
!generate mosym array
         pivot=1
          do i=1,nir
            do j=1,nfunc(i)
              mosym(pivot)=i
              pivot=pivot+1
            enddo
          enddo
c modify fort.55 according to scf symmetry
          open(inp,status='old',iostat=error)
          rewind(inp)
          write(inp,"(4i15)") nbasis,nelec,ncore,nbf(3)
          write(inp,"(100000i2)") (mosym(mapping(j)),j=1,nbasis)
          write(inp,"(a7)") ' 150000'
          write(inp,"(e28.20)")nuc
          close(inp)
           if(VERBLEVEL.GE.3.and.qmreg.ne.'0       '.and..not.lhuzi.and.
     $embed.ne.'scl     '.and.route.ne.'sch ')then
            write(iout,*)
            write(iout,*) 'Orbital energies [au]:'
            write(iout,*) '     Irrep         Alpha          Beta'
             do i=nfroz+1,nbasis-ndao
              write(iout,"(i5,3x,a4,2f15.6)")i,irlab(mosym(mapping(I))),
     $EIGENVALUE(mapping(I)),EIGENVALUE(mapping(I))
               if(i.eq.ndocc) write(iout,*)
               if(scftype.eq._MCSCF_.and.i.eq.ndocc+nact) write(iout,*)
             enddo
           endif

c modify symm variable in KEYWD according to scf symmtery
          if(symmfl.and.symchar4.eq.'    ') then
            symvar=1
            write(symchar,"(i1)") symvar
            call changekey('symm',4,symchar,1)
          endif
C
          call moto(cpr,symtra,r8heap1n,nbasis,c,offset,lsa)
          call reorder(cpr,eigenvalue,nbasis,mapping,r8heap1n,r8heap1n)
          open(unit=mocoeffile,file='MOCOEF',form='unformatted')
          call wrtmo(r8heap1n,r8heap1n,cpr,mocoeffile,itol,nbasis,
     $nbasis)
          close(mocoeffile) 
c printing out molden file
          select case (molden)
            case ('off ') 
            case ('    ') 
            case ('on  ') 
              open(unit=moldenfile,file='MOLDEN.perm')
              read(moldenfile,*) (mapping(q),q=1,nbasis)
              close(moldenfile)
              open(unit=moldenfile,file='MOLDEN')
              mark='    '
              do while (mark.ne.'[MO]')
               read(moldenfile,"(4a)")mark
              enddo
              do i=1,nbasis
                if(scftype .eq. _MCSCF_) then
                  occupation = dcore(iocc_num+mapping(i)-1)
                else
                  if(i.le.ndocc) then
                    occupation=2.d0
                  else
                    occupation=0.d0
                  endif
                endif
                write(moldenfile,"(' Ene=',f14.4)") 
     $                min(eigenvalue(i),1.d7) ! NP
                write(moldenfile,"(' Spin= Alpha')")
                write(moldenfile,"(' Occup=',f14.4)") occupation
                do j=1,nbasis
                  write(moldenfile,"(I4,f18.10)") j,cpr(mapping(j),i)
                enddo
              enddo 
              close(moldenfile) 
            case default 
              call unknown('molden',6)
          end select       
C Save density matrix
            call mxto(symdens,symtra,r8heap,nbasis,p,offset,lsa)
            call woeint(r8heap,i4heap,SYMDENS,scrfile2,itol,nbasis)
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        CASE (_UHF_)
c calculate double and single occupied orbital numbers
          do q=1,nir                                                 !save rohf order occupations  
            doccperir(q)=orbperir(q+nir)
            soccperir(q)=orbperir(q)-orbperir(q+nir)
            virtperir(q)=nfunc(q)-(doccperir(q)+soccperir(q))
          enddo 
          pivot=1                                                       !generate mosym array        
          do i=1,nir
            do j=1,nfunc(i)
              mosym(pivot)=i
              pivot=pivot+1
            enddo
          enddo 
c calculate printing order of orbitals
c sorting alpha orbitals
          pivot=0
          do i=1,nir                                                    !filling docc part
            do j=offset(i),offset(i)+doccperir(i)-1
              pivot=pivot+1
              alprmap(pivot)=j
            enddo 
          enddo
          do i=1,nir                                                    !filling socc part
            do j=offset(i)+doccperir(i),
     &        offset(i)+doccperir(i)+soccperir(i)-1
              pivot=pivot+1
              alprmap(pivot)=j
            enddo 
          enddo
          do i=1,nir                                                    !filling virt part
            do j=offset(i)+doccperir(i)+soccperir(i),
     &        offset(i)+doccperir(i)+soccperir(i)+virtperir(i)-1
              pivot=pivot+1
              alprmap(pivot)=j
            enddo 
          enddo
          do                                                            !sorting in docc block
            noswapped=.true.
            do i=nfroz+1,ndocc-1
              if(eigenvalue(alprmap(i)).gt.
     &         eigenvalue(alprmap(i+1))) then
                itemp=alprmap(i)
                alprmap(i)=alprmap(i+1)
                alprmap(i+1)=itemp
                noswapped=.false.
              endif
            enddo
            if(noswapped) exit
          enddo
          do                                                            !sorting in socc block
            noswapped=.true.
            do i=ndocc+1,ndocc+nsocc-1
              if(eigenvalue(alprmap(i)).gt.
     &         eigenvalue(alprmap(i+1))) then
                itemp=alprmap(i)
                alprmap(i)=alprmap(i+1)
                alprmap(i+1)=itemp
                noswapped=.false.
              endif
            enddo
            if(noswapped) exit
          enddo
          do                                                            !sorting in docc block
            noswapped=.true.
            do i=ndocc+nsocc+1,ndocc+nsocc+nvirt-1
              if(eigenvalue(alprmap(i)).gt.
     &         eigenvalue(alprmap(i+1))) then
                itemp=alprmap(i)
                alprmap(i)=alprmap(i+1)
                alprmap(i+1)=itemp
                noswapped=.false.
              endif
            enddo
            if(noswapped) exit
          enddo
c sorting beta orbitals
          call ifillzero(orbused,nir)
          do i=1,nbasis
            actirrep=mosym(alprmap(i))
            beprmap(i)=offset(actirrep)+orbused(actirrep)
            orbused(actirrep)=orbused(actirrep)+1
          enddo
c modify fort.55 according to scf symmetry
          open(inp,status='old',iostat=error)
          rewind(inp)
          write(inp,"(4i15)") nbasis,nelec,ncore,nbf(3)
          write(inp,"(100000i2)") (mosym(alprmap(j)),j=1,nbasis)
          write(inp,"(a7)") ' 150000'
          write(inp,"(e28.20)")nuc
          close(inp)   
           if(VERBLEVEL.GE.3.and.qmreg.ne.'0       '.and..not.lhuzi.and.
     $embed.ne.'scl     '.and.route.ne.'sch ') then
            write(iout,*)
            write(iout,*) 'Orbital energies [au]:'
            write(iout,*) '     Irrep         Alpha          Beta'
             do i=nfroz+1,nbasis-ndao
              write(iout,"(i5,3x,a4,2f15.6)")i,irlab(mosym(alprmap(I))),
     $EIGENVALUE(alprmap(I)),
     $EIGENVALUE(nbasis+beprmap(i))
               if(i.eq.ndocc) write(iout,*)
               if(nsocc.ne.0.and.i.eq.ndocc+nsocc) write(iout,*)
             enddo
           endif
c modify symm variable in KEYWD according to scf symmtery
          if(symmfl.and.symchar4.eq.'    ') then
            symvar=1
            do i=1,noccsp(1)
              symvar=multpg(symvar,mosym(alprmap(i)))
            enddo
            do i=1,noccsp(2)
              symvar=multpg(symvar,mosym(alprmap(i)))
            enddo
            write(symchar,"(i1)") symvar
            call changekey('symm',4,symchar,1) 
          endif   
C
          call moto(cpr ,symtra,r8heap2n,nbasis,c           ,offset,lsa)
          call moto(cpr2,symtra,r8heap2n,nbasis,c(sqrsize+1),offset,lsa)
          call reorder(cpr ,eigenvalue,nbasis,alprmap,r8heap2n,r8heap2n)
          call reorder(cpr2,eigenvalue(nbasis+1),nbasis,beprmap,
     $r8heap2n,r8heap2n)
          open(unit=mocoeffile,file='MOCOEF',form='unformatted')
          call wrtmo(r8heap2n,r8heap2n,cpr ,mocoeffile,itol,nbasis,
     $nbasis)
          call wrtmo(r8heap2n,r8heap2n,cpr2,mocoeffile,itol,nbasis,
     $nbasis)
          close(mocoeffile)
c printing out molden file
          select case (molden)
            case ('off ') 
            case ('    ') 
            case ('on  ') 
              open(unit=moldenfile,file='MOLDEN.perm')
              read(moldenfile,*) (mapping(q),q=1,nbasis)
              close(moldenfile)
              open(unit=moldenfile,file='MOLDEN')
              mark='    '
              do while (mark.ne.'[MO]')
               read(moldenfile,"(4a)")mark
              enddo
              do i=1,nbasis                                             !alpha electrons        
                if(i.le.noccsp(1)) then
                  occupation=1.d0
                else
                  occupation=0.d0
                endif
                write(moldenfile,"(' Ene=',f14.4)") 
     $                min(eigenvalue(i),1.d7) !NP
                write(moldenfile,"(' Spin= Alpha')")
                write(moldenfile,"(' Occup=',f14.4)") occupation
                do j=1,nbasis
                  write(moldenfile,"(I4,f18.10)") j,cpr(mapping(j),i)
                enddo
              enddo       
              do i=1,nbasis                                             !beta electrons        
                if(i.le.noccsp(2)) then
                  occupation=1.d0
                else
                  occupation=0.d0
                endif
                write(moldenfile,"(' Ene=',f14.4)") 
     $                min(eigenvalue(nbasis+i),1.d7) !NP
                write(moldenfile,"(' Spin= Beta')")
                write(moldenfile,"(' Occup=',f14.4)") occupation
                do j=1,nbasis
                  write(moldenfile,"(I4,f18.10)") j,cpr2(mapping(j),i)
                enddo
              enddo        
              close(moldenfile)
            case default 
              call unknown('molden',6)
          end select       
C Save density matrix
        call mxto(symdens,symtra,r8heap,nbasis,p,offset,lsa)
        call woeint(r8heap,i4heap,SYMDENS,scrfile2,itol,nbasis)
        call mxto(symdens2,symtra,r8heap,nbasis,p(sqrsize+1),offset,lsa)
        call woeint(r8heap,i4heap,SYMDENS2,scrfile2,itol,nbasis)
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        CASE (_ROHFSTD_)
c         call qsortd(mapping,nbasis,eigenvalue)                        !sorting MO's by energy
c sorting alpha orbitals
          call make_alprmap(nir,nirmax,doccperir,orbperir,soccperir,
     &virtperir,nfunc,nbasis,mosym,offset,alprmap,ndocc,eigenvalue,
     &nsocc,nvirt,.true.)
c sorting beta orbitals
          call ifillzero(orbused,nir)
          do i=1,nbasis
            actirrep=mosym(alprmap(i))
            beprmap(i)=offset(actirrep)+orbused(actirrep)
            orbused(actirrep)=orbused(actirrep)+1
          enddo
c modify fort.55 according to scf symmetry
          open(inp,status='old',iostat=error)
          rewind(inp)
          write(inp,"(4i15)") nbasis,nelec,ncore,nbf(3)
          write(inp,"(100000i2)") (mosym(alprmap(j)),j=1,nbasis)
          write(inp,"(a7)") ' 150000'
          write(inp,"(e28.20)")nuc
          close(inp)   
           if(VERBLEVEL.GE.3.and.qmreg.ne.'0       '.and..not.lhuzi.and.
     $embed.ne.'scl     '.and.route.ne.'sch ') then
            write(iout,*)
            write(iout,*) 'Orbital energies [au]:'
            write(iout,*) '     Irrep         Alpha          Beta'
             do i=nfroz+1,nbasis-ndao
              write(iout,"(i5,3x,a4,2f15.6)")i,irlab(mosym(alprmap(I))),
     $EIGENVALUE(alprmap(I)),EIGENVALUE(alprmap(I))
               if(i.eq.ndocc) write(iout,*)
               if(nsocc.ne.0.and.i.eq.ndocc+nsocc) write(iout,*)
             enddo
           endif
c modify symm variable in KEYWD according to scf symmtery
          if(symmfl.and.symchar4.eq.'    ') then
            symvar=1
            do i=1,noccsp(1)
              symvar=multpg(symvar,mosym(alprmap(i)))
            enddo
            do i=1,noccsp(2)
              symvar=multpg(symvar,mosym(alprmap(i)))
            enddo
            write(symchar,"(i1)") symvar
            call changekey('symm',4,symchar,1) 
          endif   
          call moto(cpr,symtra,r8heap1n,nbasis,c,offset,lsa)
          call reorder(cpr ,eigenvalue,nbasis,alprmap,r8heap1n,r8heap1n)
          open(unit=mocoeffile,file='MOCOEF',form='unformatted')
          call wrtmo(r8heap1n,r8heap1n,cpr,mocoeffile,itol,nbasis,
     $nbasis)
          close(mocoeffile)
c printing out molden file
          select case (molden)
            case ('off ') 
            case ('    ') 
            case ('on  ') 
             call molden_rohfstd(nbasis,mapping,ndocc,nsocc,cpr,
     $        eigenvalue,moldenfile)
            case default 
              call unknown('molden',4)
          end select       
C Save density matrix
        call mxto(symdens,symtra,r8heap,nbasis,p,offset,lsa)
        call woeint(r8heap,i4heap,SYMDENS,scrfile2,itol,nbasis)
        call mxto(symdens2,symtra,r8heap,nbasis,p(sqrsize+1),offset,lsa)
        call woeint(r8heap,i4heap,SYMDENS2,scrfile2,itol,nbasis)
cxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
        CASE (_ROHFSCN_)
c sorting alpha orbitals
          call make_alprmap(nir,nirmax,doccperir,orbperir,soccperir,
     &virtperir,nfunc,nbasis,mosym,offset,alprmap,ndocc,eigenvalue,
     &nsocc,nvirt,.false.)
c sorting beta orbitals
          call ifillzero(orbused,nir)
          do i=1,nbasis
            actirrep=mosym(alprmap(i))
            beprmap(i)=offset(actirrep)+orbused(actirrep)
            orbused(actirrep)=orbused(actirrep)+1
          enddo
c modify fort.55 according to scf symmetry
          open(inp,status='old',iostat=error)
          rewind(inp)
          write(inp,"(4i15)") nbasis,nelec,ncore,nbf(3)
          write(inp,"(100000i2)") (mosym(alprmap(j)),j=1,nbasis)
          write(inp,"(a7)") ' 150000'
          write(inp,"(e28.20)")nuc
          close(inp)   
           if(VERBLEVEL.GE.3.and.qmreg.ne.'0       '.and..not.lhuzi.and.
     $embed.ne.'scl     '.and.route.ne.'sch ') then
            write(iout,*)
            write(iout,*) 'Orbital energies [au]:'
            write(iout,*) '     Irrep         Alpha          Beta'
             do i=nfroz+1,nbasis-ndao
              write(iout,"(i5,3x,a4,2f15.6)")i,irlab(mosym(alprmap(I))),
     $EIGENVALUE(alprmap(I)),
     $EIGENVALUE(nbasis+beprmap(i))
               if(i.eq.ndocc) write(iout,*)
               if(nsocc.ne.0.and.i.eq.ndocc+nsocc) write(iout,*)
             enddo
           endif
c modify symm variable in KEYWD according to scf symmtery
          if(symmfl.and.symchar4.eq.'    ') then
            symvar=1
            do i=1,noccsp(1)
              symvar=multpg(symvar,mosym(alprmap(i)))
            enddo
            do i=1,noccsp(2)
              symvar=multpg(symvar,mosym(alprmap(i)))
            enddo
            write(symchar,"(i1)") symvar
            call changekey('symm',4,symchar,1) 
          endif  
c transform wavefunction to non symmetry basis
          call moto(cpr ,symtra,r8heap2n,nbasis,c           ,offset,lsa)
          call moto(cpr2,symtra,r8heap2n,nbasis,c(sqrsize+1),offset,lsa)
          call reorder(cpr ,eigenvalue,nbasis,alprmap,r8heap2n,r8heap2n)
          call reorder(cpr2,eigenvalue(nbasis+1),nbasis,beprmap,
     $r8heap2n,r8heap2n)
          if (localcc.eq.'off ') then
            open(unit=mocoeffile,file='MOCOEF',form='unformatted')
              call wrtmo(r8heap2n,r8heap2n,cpr ,mocoeffile,itol,nbasis,
     $          nbasis)
              call wrtmo(r8heap2n,r8heap2n,cpr2,mocoeffile,itol,nbasis,
     $          nbasis)
            close(mocoeffile)
          endif
c printing out molden file
          select case (molden)
            case ('off ') 
            case ('    ') 
            case ('on  ') 
             if (localcc.eq.'off ') then
              open(unit=moldenfile,file='MOLDEN.perm')
              read(moldenfile,*) (mapping(q),q=1,nbasis)
              close(moldenfile)
              open(unit=moldenfile,file='MOLDEN')
              mark='    '
              do while (mark.ne.'[MO]')
               read(moldenfile,"(4a)")mark
              enddo
              do i=1,nbasis                                             !alpha electrons        
                if(i.le.noccsp(1)) then
                  occupation=1.d0
                else
                  occupation=0.d0
                endif
                write(moldenfile,"(' Ene=',f14.4)") 
     $                min(eigenvalue(i),1.d7) !NP
                write(moldenfile,"(' Spin= Alpha')")
                write(moldenfile,"(' Occup=',f14.4)") occupation
                do j=1,nbasis
                  write(moldenfile,"(I4,f18.10)") j,cpr(mapping(j),i)
                enddo
              enddo       
              do i=1,nbasis                                             !beta electrons        
                if(i.le.noccsp(2)) then
                  occupation=1.d0
                else
                  occupation=0.d0
                endif
                write(moldenfile,"(' Ene=',f14.4)") 
     $                min(eigenvalue(nbasis+i),1.d7) !NP
                write(moldenfile,"(' Spin= Beta')")
                write(moldenfile,"(' Occup=',f14.4)") occupation
                do j=1,nbasis
                  write(moldenfile,"(I4,f18.10)") j,cpr2(mapping(j),i)
                enddo
              enddo        
              close(moldenfile)
             endif !localcc.eq.off
            case default 
              call unknown('molden',4)
          end select        
c SB oslcc write off-diagonal AO Fock-matrix for local correlation calcs
        if (localcc.ne.'off ') call wrtodfock(fockfile,oeintfile,
     &scrfile1,r8heap2n,symfock,symfock2,nbasis,cpr,cpr2,eigenvalue,
     &i4heap,itol,symtra,c,offset,lsa,beprmap,sqrsize)
C Save density matrix
        call mxto(symdens,symtra,r8heap,nbasis,p,offset,lsa)
        call woeint(r8heap,i4heap,SYMDENS,scrfile2,itol,nbasis)
        call mxto(symdens2,symtra,r8heap,nbasis,p(sqrsize+1),offset,lsa)
        call woeint(r8heap,i4heap,SYMDENS2,scrfile2,itol,nbasis)
      END SELECT        
      close(scrfile2)
C PRINT OUT FOCK MATRIX and orbital energies FOR CORREL. CALCULATIONS
          call fockprint(fockfile,scftype,symfock,symtra,r8heap,i4heap,
     $fock,offset,lsa,nbasis,itol,eigenvalue,symfock2,sqrsize)
C Calculate PCM contribution to Cartesian gradient
#if defined (PCM)
       if(trim(pcm).ne.'off') then
        call getkey('dens',4,c4,4)
         if(trim(c4).ne.'0') then
          call getvar('ncent     ',ncent)
          i=dblalloc(3*ncent)
          call pcm_core(pcm,temp,verblevel,iout,dcore,icore,imem,nbasis,
     $r8heap,r8heap,symdens,symdens2,scftype,1,dcore(i))
          open(scrfile2,file='GRAD',status='unknown',form='unformatted')
          write(scrfile2) dcore(i:i+3*ncent-1)
          close(scrfile2)
          call dbldealloc(i)
         endif
       endif
#endif
C SHUTTING DOWN PROGRAM
      CLOSE(TEDATFILE)                                                  !TWO ELECTRON INTEGRAL DATA FILE
      open(diisfile,status='unknown')
      open(errfile ,status='unknown')
      close(diisfile,status='delete')
      close(errfile ,status='delete')
      close(sdfile  ,status='delete')
      close(scfile  ,status='delete')
C Calculate reference energy for correlated calculations with KS orbs
       if(kscorr.and..not.hfroute) then
        write(iout,*)
        write(iout,*) 'Calculating reference energy with Kohn-Sham ' //
     $'orbitals...'
        hfroute=.true.
         if(dhyb.eq.0.and.chfx.eq.fhfx.and.clrhfx.eq.flrhfx.and.
     $csrhfx.eq.fsrhfx) then
          dft='off                             '
          chfx=-1.d0
         else
          chfx=fhfx
          clrhfx=flrhfx
          csrhfx=fsrhfx
          omega=fomega
         endif
        lfin=2
        goto 1234
       endif
C
      open(unit=scrfile1,file='RESTART',status='unknown')
      close(scrfile1,status='delete')
C
      IF(VERBLEVEL.GE.2) THEN
        write(iout,*)
        write(iout,"(' RETURNING FROM SCF ALGORITHM')")
        write(iout,"(1X,70('='))")
      ENDIF
      CALL FLUSH(6)                                                     !FORCE BUFFER PRINT TO TERMINAL 
      RETURN                                                            !BYE-BYE :)
      END
************************************************************************
      SUBROUTINE OCCPRINTER(FMT,irlab)
************************************************************************
* PRINTING OUT OCCUPATION FORMATTED OR RAW
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
c
      character*1 fmt
      character*4 irlab(*)
      INTEGER Q
C
      SELECT CASE (FMT)
        CASE('f','F')
          SELECT CASE (SCFTYPE)
            CASE (_RHF_)
              write(iout,"(' ALPHA OCC:',8I4)")
     &          (ORBPERIR(Q),Q=1,NIR)
              write(iout,"(' BETA  OCC:',8I4)") 
     &          (ORBPERIR(Q),Q=1,NIR)
            CASE (_UHF_)
              write(iout,"(' ALPHA OCC:',8I4)") 
     &          (ORBPERIR(Q),Q=1,NIR)
              write(iout,"(' BETA  OCC:',8I4)") 
     &          (ORBPERIR(nir+Q),Q=1,NIR)
            CASE (_ROHFSTD_,_ROHFSCN_)
              write(iout,"(' ALPHA OCC:',8I4)") 
     &          (ORBPERIR(Q)+ORBPERIR(Q+nir),Q=1,NIR)
              write(iout,"(' BETA  OCC:',8I4)") 
     &          (ORBPERIR(Q),Q=1,NIR)
          END SELECT             
        CASE('r','R')
          SELECT CASE (SCFTYPE)
            CASE (_RHF_)
              write(iout,"(8I4)")
     &          (ORBPERIR(Q),Q=1,nir)
              write(iout,"(8I4)") 
     &          (ORBPERIR(Q),Q=1,nir)
            CASE (_UHF_)
              write(iout,"(8I4)") 
     &          (ORBPERIR(Q),Q=1,nir)
              write(iout,"(8I4)") 
     &          (ORBPERIR(Q),Q=nir+1,2*nir)
            CASE (_ROHFSTD_,_ROHFSCN_)
              write(iout,"(8I4)") 
     &          (ORBPERIR(Q)+ORBPERIR(Q+nir),Q=1,nir)
              write(iout,"(8I4)") 
     &          (ORBPERIR(Q),Q=1,nir)
          END SELECT              
        CASE('l','L')
         write(iout,"(19x,64a4)") (irlab(q),q=1,nir)
          SELECT CASE (SCFTYPE)
            CASE (_RHF_)
              write(iout,"(' FINAL ALPHA OCC:',8I4)")
     &          (ORBPERIR(Q),Q=1,NIR)
              write(iout,"(' FINAL BETA  OCC:',8I4)") 
     &          (ORBPERIR(Q),Q=1,NIR)
            CASE (_UHF_)
              write(iout,"(' FINAL ALPHA OCC:',8I4)") 
     &          (ORBPERIR(Q),Q=1,NIR)
              write(iout,"(' FINAL BETA  OCC:',8I4)") 
     &          (ORBPERIR(nir+Q),Q=1,NIR)
            CASE (_ROHFSTD_,_ROHFSCN_)
              write(iout,"(' FINAL ALPHA OCC:',8I4)") 
     &          (ORBPERIR(Q)+ORBPERIR(Q+nir),Q=1,NIR)
              write(iout,"(' FINAL BETA  OCC:',8I4)") 
     &          (ORBPERIR(Q),Q=1,NIR)
          END SELECT              
      END SELECT
C
      RETURN
      END

************************************************************************
      logical function emptystr(str)
************************************************************************
* function to test if a given string is only filled with space
************************************************************************
      implicit none
c    
      character*(*) str
      integer q
      integer emptychr
c
      emptystr=.false.
      emptychr=0
      do q=1,len(str)
        if(str(q:q).eq.' ') emptychr=emptychr+1
      enddo
      if(emptychr.eq.len(str)) then
        emptystr=.true.
        return
      endif
c
      return
      end
   
************************************************************************
      subroutine occparser(occstr)
************************************************************************
* subroutine to fill the orbperir array from user input occstr
************************************************************************   
#include "MRCCCOMMON"
#include "SCFCOMMON"
c arguments
      character occstr*(*)
c variables
      integer q
      character tempstr*(len(occstr))
      integer ii,jj
c
      ii=0
      jj=1
      do q=1,len(occstr)
        select case (occstr(q:q))
          case (' ')                                                    !skipping whitespace

          case ('0','1','2','3','4','5','6','7','8','9')                !numeric char to temp string
            ii=ii+1
            tempstr(ii:ii)=occstr(q:q)

          case (',')                                                    !start of new irrep
            read (tempstr(1:ii),*) orbperir(jj)
            ii=0
            jj=jj+1

          case ('/') 
            read (tempstr(1:ii),*) orbperir(jj)
            ii=0
            jj=nir+1

          case default
            write(*,*) ' @occparser: ERROR'
            write(*,*) '             unknown character in occupation'
            write(*,*) '             string in MINP file'
            write(*,*) '             please consult the MRCC manual'
            write(*,*) '             for proper format'
            write(*,*) '             program terminated'
            call mrccend(1)
        end select       
      enddo
      read (tempstr(1:ii),*) orbperir(jj)
      if(scftype.eq.1) then
        do ii=1,nir
         orbperir(ii+nir)=orbperir(ii)
        enddo
      endif
c
      return
      end

************************************************************************
      subroutine actparser(occstr)
************************************************************************
* subroutine to fill the nactperir and actoffset arrays from user input
************************************************************************   
      use mcscf
      use common_mod, only : nelec
c#include "MRCCCOMMON"
c#include "SCFCOMMON"
c arguments
      character occstr*(*)
c variables
      integer q
      character tempstr*(len(occstr))
      integer ii,jj
c
c     write(*,*) occstr
      ii=0
      jj=1
      do q=1,len(occstr)
        select case (occstr(q:q))
          case (' ')                                                    !skipping whitespace

          case ('0','1','2','3','4','5','6','7','8','9')                !numeric char to temp string
            ii=ii+1
            tempstr(ii:ii)=occstr(q:q)

          case (',')                                                    !start of new irrep
            read (tempstr(1:ii),*) nactperir(jj)
            ii=0
            jj=jj+1

          case ('/') 
            read (tempstr(1:ii),*) nactperir(jj)
            ii=0
            jj=nir+1

          case default
            write(*,*) ' @actparser: ERROR'
            write(*,*) '             unknown character in occupation'
            write(*,*) '             string in MINP file'
            write(*,*) '             please consult the MRCC manual'
            write(*,*) '             for proper format'
            write(*,*) '             program terminated'
            call mrccend(1)
        end select       
      enddo
      read (tempstr(1:ii),*) nactperir(jj)

      nact = 0
      sqrasize = 0
      nactel = 0
      do ii = 1, nir
        nactel = nactel + orbperir(ii)
        nact = nact + nactperir(ii)
        sqrasize = sqrasize + nactperir(ii)**2
      enddo
      nactel = nelec - 2*nactel
      actoffset(1) = 1
      do ii = 2, nir
        actoffset(ii) = actoffset(ii-1) + nactperir(ii-1)
c       write(*,*) 'actoffset', ii, actoffset(ii)
      enddo
c
      return
      end

************************************************************************
      subroutine mx_basis_tr(mx,symtra,r8heap,mode,lsize)
************************************************************************
* subroutine to symmetrise matrices with transformation
* matrix from symtra file (running in destructive mode)
************************************************************************
      implicit none
c arguments
      real*8 mx(lsize**2)                                               !non compressed input/output matrix
      real*8 symtra(lsize**2)                                           !symmetry transformation matrix
      real*8 r8heap(*)                                                  !workspace
      character*2 mode
      integer lsize                                                     !linear size of matrices
c variables
      character*1 lmx,rmx
c program
      select case (mode)
        case ('ts','TS','Ts','tS') 
          lmx='t' 
          rmx='n'
        case ('to','TO','To','tO') 
          lmx='n' 
          rmx='t'
        case default
          write(*,*) ' @mx_basis_tr: ERROR'
          write(*,*) '               unknown transformation mode'
          write(*,*) '               last argument of subroutine'
          return
      end select      
c multiply from right
      call dgemm(
     &  'n',
     &  rmx,
     &  lsize,
     &  lsize, 
     &  lsize, 
     &  1.d0,
     &  mx,
     &  lsize, 
     &  symtra,
     &  lsize, 
     &  0.d0,
     &  r8heap,
     &  lsize)
c multiply from left
      call dgemm(
     &  lmx,
     &  'n',
     &  lsize,
     &  lsize, 
     &  lsize, 
     &  1.d0,
     &  symtra,
     &  lsize, 
     &  r8heap,
     &  lsize, 
     &  0.d0,
     &  mx,
     &  lsize)    
c
      return
      end

************************************************************************
      subroutine mx_symm_extr(full_mx,compr_mx,offset)
************************************************************************
* subroutine to extract a matrix from blockdiagonal storage format
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
c arguments
      real*8 full_mx(nbasis,nbasis)
      real*8 compr_mx(sqrsize)
      integer offset(*)
c scalar variables
      integer pivot
      integer ii,jj,kk
c program
      call dfillzero(full_mx,nbasis**2)
      pivot=1
      do kk=1,nir
        if(nfunc(kk).eq.0) cycle
        do jj=1,nfunc(kk)
          do ii=1,nfunc(kk)
            full_mx(offset(kk)-1+ii,offset(kk)-1+jj)=compr_mx(pivot)
            pivot=pivot+1
          enddo
        enddo
      enddo           
c     
      return
      end
 
************************************************************************
      subroutine mx_symm_compr(full_mx,compr_mx,offset)
************************************************************************
* subroutine to comprass a matrix into blockdiagonal storage format
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
c arguments
      real*8 full_mx(nbasis,nbasis)
      real*8 compr_mx(sqrsize)
      integer offset(*)
c scalar variables
      integer pivot
      integer ii,jj,kk
c program
      pivot=1
      do kk=1,nir
        if(nfunc(kk).eq.0) cycle
        do jj=1,nfunc(kk)
          do ii=1,nfunc(kk)
            compr_mx(pivot)=full_mx(offset(kk)-1+ii,offset(kk)-1+jj)
            pivot=pivot+1
          enddo
        enddo
      enddo           
c     
      return
      end

************************************************************************
      subroutine sort_mo(full, compr, offset, mapping)
************************************************************************
* sort mo orbitals according to mapping
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"

      double precision full(nbasis, nbasis), compr(nbasis, nbasis)
      integer offset(*), mapping(*)
      integer k(nirmax), i, irr

      k = 1
      do i = 1, nbasis
        irr = mapping(i)
        compr(1:nbasis,offset(irr)+k(irr)-1) = full(1:nbasis, i)
        k(irr) = k(irr) + 1
      enddo

      end subroutine

************************************************************************
      subroutine rhf_ao_guess(p,nbasis,scrfile1,initguess,alphaiguess,
     $betaiguess,r8heap,natrange,natoms,qmreg,nangmax,nbset)
************************************************************************
* subroutine to pick up mrcc-integ initial diagonal density (rhf)
************************************************************************ 
      implicit none
c arguments
      real*8 p(nbasis,nbasis),r8heap(*)
      integer nbasis,initguess,natrange,natoms,nangmax,nbset
      integer scrfile1
c variables
      real*8 alphaiguess(nbasis)
      real*8 betaiguess(nbasis)
      integer i
      character*8 qmreg
c program     
      open(unit=scrfile1,form='unformatted')                            !mrcc integ program initial guess    
      rewind(scrfile1)
      read(scrfile1) (alphaiguess(i),i=1,nbasis)                        !reading alpha spinorb guess    
      read(scrfile1) (betaiguess(i),i=1,nbasis)                         !reading beta spinorb guess    
      close(scrfile1) 
c
      do i=1,nbasis
        p(i,i)=alphaiguess(i)+betaiguess(i)
      enddo
C SAD guess
       if(initguess.eq._SAD_) then
        call sadscfiguess(natoms,scrfile1,r8heap(24*natoms+1),p,p,
     $nbasis,natrange,'rhf  ',r8heap,r8heap(natoms+1),
     $r8heap(3*natoms+1),r8heap(23*natoms+1),qmreg,nangmax,nbset,
     $alphaiguess,betaiguess)
        return
       endif
c
      return
      end

************************************************************************
      subroutine uhf_ao_guess(pa,pb,nbasis,scrfile1,initguess,
     $alphaiguess,betaiguess,r8heap,natrange,natoms,qmreg,nangmax,nbset)
************************************************************************
* SUBROUTINE TO PICK UP MRCC-INTEG INITIAL DIAGONAL DENSITY (uhf)
************************************************************************ 
      implicit none
c arguments
      real*8 pa(nbasis,nbasis),r8heap(*)
      real*8 pb(nbasis,nbasis)
      integer nbasis,initguess,natrange,natoms,nangmax,nbset
      integer scrfile1
c variables
      real*8 alphaiguess(nbasis)
      real*8 betaiguess(nbasis)
      integer i
      character*8 qmreg
c      
      open(unit=scrfile1,form='unformatted')                            !mrcc integ program initial guess    
      rewind(scrfile1)
      read(scrfile1) (alphaiguess(i),i=1,nbasis)                        !reading alpha spinorb guess    
      read(scrfile1) (betaiguess(i),i=1,nbasis)                         !reading beta spinorb guess    
      close(scrfile1) 
c
      do i=1,nbasis
        pa(i,i)=alphaiguess(i)
        pb(i,i)=betaiguess(i) 
      enddo
C SAD guess
       if(initguess.eq._SAD_) then
        call sadscfiguess(natoms,scrfile1,r8heap(24*natoms+1),pa,pb,
     $nbasis,natrange,'uhf  ',r8heap,r8heap(natoms+1),
     $r8heap(3*natoms+1),r8heap(23*natoms+1),qmreg,nangmax,nbset,
     $alphaiguess,betaiguess)
        return
       endif
c
      return
      end
 
************************************************************************
      subroutine rohf_ao_guess(pt,po,nbasis,scrfile1,initguess,
     $alphaiguess,betaiguess,r8heap,natrange,natoms,qmreg,nangmax,nbset)
************************************************************************
* subroutine to pick up mrcc-integ initial diagonal density (rohf)
************************************************************************ 
      implicit none
c arguments
      real*8 pt(nbasis,nbasis),r8heap(*)
      real*8 po(nbasis,nbasis)
      integer nbasis,initguess,natrange,natoms,nangmax,nbset
      integer scrfile1
c variables
      real*8 alphaiguess(nbasis)
      real*8 betaiguess(nbasis)
      integer i
      real*8 alphasum
      real*8 betasum
      character*8 qmreg
c      
      open(unit=scrfile1,form='unformatted')                            !mrcc integ program initial guess    
      rewind(scrfile1)
      read(scrfile1) (alphaiguess(i),i=1,nbasis)                        !reading alpha spinorb guess    
      read(scrfile1) (betaiguess(i),i=1,nbasis)                         !reading beta spinorb guess    
      close(scrfile1) 
c
      alphasum=0.d0
      betasum=0.d0
      do i=1,nbasis
        alphasum=alphasum+alphaiguess(i)
        betasum=betasum+betaiguess(i)
      enddo      
c
      do i=1,nbasis
        pt(i,i)=alphaiguess(i)+betaiguess(i)
      enddo
c
      if(alphasum.gt.betasum) then                                      !filling open density
        do i=1,nbasis
          po(i,i)=alphaiguess(i)-betaiguess(i)  
        enddo
      else
        do i=1,nbasis
          po(i,i)=betaiguess(i)-alphaiguess(i)  
        enddo
      endif
C SAD guess
       if(initguess.eq._SAD_) then
        call sadscfiguess(natoms,scrfile1,r8heap(24*natoms+1),pt,po,
     $nbasis,natrange,'rohf ',r8heap,r8heap(natoms+1),
     $r8heap(3*natoms+1),r8heap(23*natoms+1),qmreg,nangmax,nbset,
     $alphaiguess,betaiguess)
        return
       endif
c
      return
      end
************************************************************************
      subroutine sadscfiguess(natoms,scrfile1,work,pa,pb,nbasis,
     $natrange,scftype,atnum,atsymbol,basname,atnumt,qmreg,nangmax,
     $nbset,alphaiguess,betaiguess)
************************************************************************
* Superposition of atomic densites initial guess for SCF
************************************************************************
      implicit none
      integer natoms,atnum(natoms),iatoms,scrfile1,nbasis,mu,nu,nbf,ii,i
      integer natrange(2,natoms),ich,charge,atnumt(natoms),nangmax,nbset
      integer nang(natoms,nbset),ncontr(0:nangmax,natoms,nbset)
      real*8 work(*),pa(nbasis,nbasis),pb(nbasis,nbasis)
      real*8 alphaiguess(*),betaiguess(*)
      character*1 bname1(20)
      character*2 ch2,atsymbol(natoms)
      character*4 cval
      character*5 scftype
      character*8 qmreg
      character*20 basname(natoms),bname
      character*40 grfile,c40
      logical llg,cartg
      equivalence(bname,bname1)
C
      call getvar('atnum     ',atnum)
      call getvar('atnumt    ',atnumt)
      call getvar('atsymbol  ',atsymbol)
      call getvar('basname   ',basname)
      call getvar('nang      ',nang)
      call getvar('ncontr    ',ncontr)
      call getvar('cartg     ',cartg)
      charge=0
      call getkey('charge',6,cval,4)
      read(cval,*) charge
       do iatoms=1,natoms
         if(atnum(iatoms).gt.0.or.(qmreg.eq.'0       '.and.
     $atnumt(iatoms).gt.0)) then
          call getgrfile(grfile,atsymbol(iatoms),basname(iatoms),charge,
     $ich,natoms)
          inquire(file=grfile,exist=llg)
           if(llg) then
            nbf=natrange(2,iatoms)-natrange(1,iatoms)
            open(unit=scrfile1,file=grfile,form='unformatted')
            call roeint(work(nbf**2+1),work(nbf**2+1),work,scrfile1,nbf)
             if(natoms.gt.1)
     $      call denssym(nbf,work,nang(iatoms,1),ncontr(0,iatoms,1),
     $cartg,alphaiguess(natrange(1,iatoms)+1),atnum(iatoms))
            ii=0
             do mu=1,nbf
               do nu=1,nbf
                ii=ii+1
                pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)=work(ii)
               enddo
             enddo
            call roeint(work(nbf**2+1),work(nbf**2+1),work,scrfile1,nbf)
             if(natoms.gt.1)
     $      call denssym(nbf,work,nang(iatoms,1),ncontr(0,iatoms,1),
     $cartg,betaiguess(natrange(1,iatoms)+1),atnum(iatoms))
            ii=0
             if(scftype.eq.'rhf  ') then
               do mu=1,nbf
                 do nu=1,nbf
                  ii=ii+1
      pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)=
     $pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)+work(ii)
                 enddo
               enddo
             else if(scftype.eq.'uhf  ') then
               do mu=1,nbf
                 do nu=1,nbf
                  ii=ii+1
      pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)=
     $0.5d0*(pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)+work(ii))
      pb(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)=
     $pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)
c     pb(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)=work(ii)
                 enddo
               enddo
             else
               do mu=1,nbf
                 do nu=1,nbf
                  ii=ii+1
      pb(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)=
     $pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)-work(ii)
      pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)=
     $pa(natrange(1,iatoms)+mu,natrange(1,iatoms)+nu)+work(ii)
                 enddo
               enddo
             endif
            close(scrfile1)
           endif
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine denssym(nbf,dens,nang,ncontr,cartg,alphaiguess,iatnum)
************************************************************************
* Symmetrize atomic densities
************************************************************************
      implicit none
      integer nbf,nang,ncontr(0:*),iang,icontr,nspher,ispher,ibf,jcontr
      integer jbf,iatnum
      real*8 dens(nbf,nbf),tmp,alphaiguess(nbf),fac
      parameter(fac=0.5d0)
      logical cartg
C
      ibf=0
       do iang=0,nang
        nspher=2*iang+1
         if(cartg) nspher=(iang+1)*(iang+2)/2
        dens(ibf+1:ibf+ncontr(iang)*nspher,
     $       ibf+ncontr(iang)*nspher+1:nbf)=0.d0
        dens(ibf+ncontr(iang)*nspher+1:nbf,
     $       ibf+1:ibf+ncontr(iang)*nspher)=0.d0
         do icontr=1,ncontr(iang)
           if(iang.gt.0) then
            jbf=ibf
             do jcontr=icontr,ncontr(iang)
              tmp=0.d0
               do ispher=1,nspher
                tmp=tmp+dens(ibf+ispher,jbf+ispher)
               enddo
              tmp=tmp/dble(nspher)
               do ispher=1,nspher
                dens(ibf+ispher,jbf+ispher)=tmp
                dens(jbf+ispher,ibf+ispher)=tmp
               enddo
              jbf=jbf+nspher
             enddo
             if(iang.gt.1) then
               do ispher=1,nspher
                ibf=ibf+1
                dens(ibf+1:nbf,ibf)=0.d0
                dens(ibf,ibf+1:nbf)=0.d0
               enddo
             else
              ibf=ibf+nspher
             endif
           else
            ibf=ibf+1
           endif
         enddo
       enddo
C
c      if(iatnum.ne.1.and.iatnum.ne.5.and.iatnum.ne.6.and.iatnum.ne.11)
       if(iatnum.ne.5.and.iatnum.ne.6.and.iatnum.ne.11) return
      tmp=0.d0
       do ibf=1,nbf
        tmp=tmp+(dens(ibf,ibf)-alphaiguess(ibf))**2
       enddo
      tmp=dsqrt(tmp)/sum(alphaiguess)
       if(tmp.le.1.d0) then
        dens=fac*dens
         do ibf=1,nbf
          dens(ibf,ibf)=dens(ibf,ibf)+(1.d0-fac)*alphaiguess(ibf)
         enddo
       endif
C
      return
      end
C
************************************************************************
      SUBROUTINE ERRORHANDLER(ERRORCODE,TYPE)
************************************************************************
* subroutine to handle errors in scf program
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
      INTEGER ERRORCODE
      INTEGER TYPE
      SELECT CASE (TYPE)
      CASE (_DSYEV_) 
        IF(ERRORCODE.NE.0) THEN
          WRITE(*,*)'DSYEV ERROR',ERRORCODE
          write(*,*) 'PROGRAM ABORTED'
          call mrccend(1)
        ENDIF
      CASE (_FILE_)
        IF(ERRORCODE.NE.0) THEN
          WRITE(*,*) 'FILE OPENING ERROR',ERRORCODE
          write(*,*) 'PROGRAM ABORTED'
          call mrccend(1)
        ENDIF
      CASE (_CONV_)
        IF(ERRORCODE.GE.SCFMAXIT) THEN
          WRITE(*,*) 'SCF ALGORITHM NOT CONVERGED IN',SCFMAXIT,'STEPS'
          WRITE(*,*) 'PROGRAM ABORTED'
        END IF
      CASE (_TF_)
        WRITE(*,*) 'UNKNOWN TRANSITION FUNCTION IN NEURAL NETWORK'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)
      CASE (_DTF_)
        WRITE(*,*) 'UNKNOWN TRANSITION FUNCTION IN LEARNING'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)
      CASE (_FLAG_CONFLICT_)
        WRITE(*,*) 'CONFLICT BETWEEN FLAGS CONTROLS FOCK BUILDING'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)
      CASE (_FOCK_BUILD_)
        WRITE(*,*) 'UNKNOWN WAY, TO BUILD FOCK MATRIX'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)
      CASE (_OPEN_SHELL_NEURAL_NET_)
        WRITE(*,*) 
     &  'OPEN SHELL CALCULATION WITH NEURAL NETWORK NOT AVAILABLE'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)    
      CASE (_OPEN_SHELL_TENSOR_)
        WRITE(*,*) 
     &'OPEN SHELL CALCULATION WITH TENSOR DECOMPOSITION NOT AVAILABLE'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)     
      CASE (_SYM_TENSOR_)
        WRITE(*,*) 
     &'TENSORDECOMPOSITION ONLY AVAILABLE WITH WHOLE MATRICES'
        WRITE(*,*) 'SWITCH OFF SYMMETRY FLAG'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)   
      CASE (_CALCULATION_WAY_)
        WRITE(*,*) 'UNKNOWN WAY, TO BUILD FOCK MATRIX'
        WRITE(*,*) 'IN MINP FILE VARIABLE CALC SHALL BE'
        WRITE(*,*) 'RHF, UHF OR ROHF'
        WRITE(*,*) 'PLEASE CHECK VALUE'
        WRITE(*,*) 'PROGRAM ABORTED'
        call mrccend(1)
      CASE DEFAULT
        IF(ERRORCODE.NE.0) THEN
          WRITE(*,*) 'UNHANDLED ERROR',ERRORCODE
          WRITE(*,*) 'PROGRAM ABORTED'
          call mrccend(1)
        ENDIF
      END SELECT
      RETURN
      END
************************************************************************
      subroutine diis_errvec(p,sorig,temp_arr,fock,diiserrvec,s,
     $sqroffset,ltroffset,nmat,ifile,c)
************************************************************************
* Calculate DIIS error vector
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"     
      integer sqroffset(*),ltroffset(*),nmat,error,i,q,ifile
      real*8 p(*),sorig(*),temp_arr(*),fock(*),diiserrvec(*),s(*),dnrm2
      real*8 c(*)
C
      open(ifile,file='SCHOL',form='unformatted')
       if(ndao.eq.0) then
         do i=1,nir
           if(nfunc(i).gt.0) then
            call rspmx(s,nfunc(i),ifile)
             do q=1,nmat
              call dsymm('l','l',nfunc(i),nfunc(i),1.d0,
     $fock(sqroffset(i)+(q-1)*sqrsize),nfunc(i),
     $p(sqroffset(i)+(q-1)*sqrsize),nfunc(i),0.d0,
     $diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfunc(i))
              call dtrmm('r','l','n','n',nfunc(i),nfunc(i),1.d0,
     $s,nfunc(i),diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfunc(i))
              call dtrsm('l','l','n','n',nfunc(i),nfunc(i),1.d0,
     $s,nfunc(i),diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfunc(i))
              call amat(diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfunc(i))
              call ltrp(diiserrvec(sqroffset(i)+(q-1)*ltrsize),
     $diiserrvec(ltroffset(i)+(q-1)*ltrsize),nfunc(i))
             enddo
           endif
         enddo
       else
         do i=1,nir
           if(nfunc(i).gt.0) then
            read(ifile) s(1:nfunc(i)*nfuns(i))
             if(lnos) then
              open(oeintfile,file='OEINT',form='unformatted')
              call roeint(diiserrvec,diiserrvec,c,oeintfile,nfunc(i)) ! MO coeffs are overwritten by S !!!
              close(oeintfile)
             endif
             do q=1,nmat
               if(nfuns(i).gt.0) then
                call dsymm('l','l',nfunc(i),nfunc(i),1.d0,
     $fock(sqroffset(i)+(q-1)*sqrsize),nfunc(i),
     $p(sqroffset(i)+(q-1)*sqrsize),nfunc(i),0.d0,temp_arr,nfunc(i))
                 if(lnos) then
                  call dsymm('r','l',nfunc(i),nfunc(i),1.d0,
     $c(sqroffset(i)),nfunc(i),temp_arr,nfunc(i),
     $0.d0,diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfunc(i))
                 else
                  call dsymm('r','l',nfunc(i),nfunc(i),1.d0,
     $sorig(sqroffset(i)),nfunc(i),temp_arr,nfunc(i),
     $0.d0,diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfunc(i))
                 endif
                call amat(diiserrvec(sqroffset(i)+(q-1)*ltrsize),
     $nfunc(i))
                call dgemm('n','n',nfunc(i),nfuns(i),nfunc(i),1.d0,
     $diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfunc(i),s,nfunc(i),0.d0,
     $temp_arr,nfunc(i))
                call dgemm('t','n',nfuns(i),nfuns(i),nfunc(i),1.d0,
     $s,nfunc(i),temp_arr,nfunc(i),0.d0,
     $diiserrvec(sqroffset(i)+(q-1)*ltrsize),nfuns(i))
                call ltrp(diiserrvec(sqroffset(i)+(q-1)*ltrsize),
     $diiserrvec(ltroffset(i)+(q-1)*ltrsize),nfuns(i))
               endif
              diiserrvec(
     $ltroffset(i)+(q-1)*ltrsize+(nfuns(i)+1)*nfuns(i)/2:
     $ltroffset(i)+(q-1)*ltrsize+(nfunc(i)+1)*nfunc(i)/2-1)=0.d0
             enddo
           endif
         enddo
       endif
      close(ifile)
C
      return
      end
C
************************************************************************
      SUBROUTINE SCFSETUP(dft,route,embed,dual,pcm)
************************************************************************
* Subroutine for the scf routine to read user specified basic variables
************************************************************************
      use mcscf, only: qscf_alloc, qscf_init
C PREPROCESSOR DIRECTIVES
#include "MRCCCOMMON"
#include "SCFCOMMON"
C VARIABLES
      INTEGER I,T,Q,J,U
      INTEGER ERROR
      INTEGER HEADER(6)
      INTEGER INTADD
      INTEGER DBLADD
      INTEGER MAPVEC
      INTEGER ORBINFO
      INTEGER MAPINFO
      INTEGER DBLALLOC
      INTEGER INTALLOC
      integer nprimmax,igexp
      logical emptystr
      integer imem1
      common/memcom/ imem1
C ARRAYS
      CHARACTER*4 DIISVAL,c4
      CHARACTER*4 SYMMVAL
      INTEGER SYMMINT
      CHARACTER*4 EXTSTEPVAL
      INTEGER EXTSTEPINT
      CHARACTER*4 SCFTOLVAL,scfdtol
      INTEGER SCFTOLINT
      CHARACTER*4 SCFMAXITVAL
      CHARACTER*256 OCCVAL, actval
      INTEGER DELARR(32)
      INTEGER SLASH
      CHARACTER*256 STRTEMP
      CHARACTER*4 SPINMULTVAL
      INTEGER SPINMULT
      CHARACTER*4 NELECVAL
      CHARACTER*5 scftypeval
      CHARACTER*4 VERBLEVELVAL
      CHARACTER*7 IGUESSVAL
      character*4 diisstartval
      character*4 diisendval
      character*4 diisstepval,route
      character*13 rohftypeval
      character*8 embed,grdens,dual,cpssp
      character*32 dft,pcm
      real*8 temp
      logical llg
c Seminumerical method
      integer inang,inprim,inshrange,inangmin
C Read keywords
      call getkey('dfbasis_scf',11,dfbasis_scf,20)
      call getkey('dft',3,dft,32)
      call getkey('qscf',4,qscf,8)
      call getkey('dual',4,dual,8)
      call getkey('pssp',4,cpssp,8)
      call getkey('pcm',3,pcm,32)
      call getvar('natoms    ',natoms)
      call getvar('nangmax   ',nangmax)
      call getvar('nbset     ',nbset)
      OPEN(MINPFILE,FILE='MINP',STATUS='OLD')                           !OPEN MINP FILE FOR GETKEYM CALLS
      call getkeym('qmreg',5,qmreg,8)
      error=0
C VERBOSITY
      call getkey('verbosity',9,verblevelval,4)
      read (verblevelval, '(i4)') verblevel
C SCFALG
      call getkey('scfalg',6,scfalg,8)
       if(verblevel.ge.3) then
         if(trim(scfalg).eq.'disk') then
          write(iout,"(' @scfsetup: integrals taken from disk')")
          write(iout,"('            mrcc/integ binary format')")
         else
          write(iout,"(' @scfsetup: integrals calculated directly')")
          write(iout,"('            mrcc/integ direct run')")
         endif
       endif        
C SYMM
      call getvar('nir       ',nir)
      CALL GETKEY('symm',4,SYMMVAL,4)
       if(symmval.eq.'    ') then
        SYMMFL=nir.gt.1
       else
        READ(SYMMVAL,'(I4)') SYMMINT
         IF(SYMMINT.EQ.0) THEN
          SYMMFL=.FALSE.
         ELSE
          SYMMFL=nir.gt.1
         ENDIF 
       endif
       if(verblevel.ge.3) then
         IF(SYMMFL) THEN
          write(iout,"(' @scfsetup: calc on blockdiagonal matrices')")
          write(iout,"('            using symmetry adapted basis')")
         ELSE
          write(iout,"(' @scfsetup: calculating on full matrices')")
          write(iout,"('            not using symmetry adapted basis')")
         ENDIF
       endif
C GET DATA FROM OTHER FILES ACCORDING TO INPUT METHOD SET
      open(inp,status='old',iostat=error)
      call errorhandler(error,_FILE_)
      rewind(inp)
      read(inp,*) nbasis,nelec,ncore
      read(inp,*)
      read(inp,*)
      read(inp,*) nuc
      close(inp)
      call getvar('ndao      ',ndao)
      if(symmfl) then                                               !pick up nir and nfunc in bin run
        call getvar('nfunc     ',nfunc)
        call getvar('nfuns     ',nfuns)
      else
        nfunc(1)=nbasis
        nfuns(1)=nbasis-ndao
        nir=1
      endif
C SCFDIIS
      CALL GETKEY('scfdiis',7,DIISVAL,4)
      SELECT CASE (DIISVAL)
        CASE ('on  ') 
          DIISFL=.TRUE.
          if(verblevel.ge.3) then
            write(iout,"(' @scfsetup: diis switched on')")
          endif          
        CASE ('off ') 
          DIISFL=.FALSE.
          if(verblevel.ge.3) then
            write(iout,"(' @scfsetup: diis switched off')")
          endif          
      END SELECT
C SCFEXT
      CALL GETKEY('scfext',6,EXTSTEPVAL,4)                             !max number of prev steps used for extrapolation
      READ (EXTSTEPVAL, '(I4)') EXTSTEP
      if(verblevel.ge.3) then
        write
     &(iout,"(' @scfsetup: number of steps to extrapolate from',i4)")
     &    extstep
      endif          
C SCFTOL
      CALL GETKEY('scftol',6,SCFTOLVAL,4)                               !TOLERATION IN ENERGY AND DENSITY MATRIX NORM  
      READ (SCFTOLVAL, '(I4)') SCFTOLINT
      ENEREPSILON=10.D0**DBLE(-SCFTOLINT)
      call getkey('scfdtol',7,scfdtol,4)
      READ (scfdtol, '(I4)') SCFTOLINT
      PEPSILON=10.D0**DBLE(-SCFTOLINT)
      if(verblevel.ge.3) then
        write(iout,
     &"(' @scfsetup: tolerance in energy deviation',e16.6)") enerepsilon
        write(iout,
     &"('            tolerance in density deviation',e16.6)") pepsilon
      endif          
c SCFMAXIT
      CALL GETKEY('scfmaxit',8,SCFMAXITVAL,4)                           !MAXIMUM NUMBER OF ITERATIONS  
      READ (SCFMAXITVAL, '(I4)') SCFMAXIT
      if(verblevel.ge.3) then
        write(iout,"(' @scfsetup: maximum number of iterations:',i4)")
     &    scfmaxit
      endif          
c SCFTYPE
      CALL GETKEY('scftype',7,scftypeval,5)                             !WAY OF CALCULATION DEPENDING ON ELECTRON SHELL     
      CALL GETKEY('rohftype',8,rohftypeval,13)                          !standard/semicanonical rohf       
      SELECT CASE (scftypeval)
        CASE ('rhf  ') 
          scftype=_RHF_
          if(verblevel.ge.3) then
           write(iout,"(' @scfsetup: restricted closed shell hf calc')")
          endif          
        CASE ('uhf  ') 
          scftype=_UHF_
          if(verblevel.ge.3) then
            write(iout,"(' @scfsetup: unrestricted hf calc')")
          endif          
        CASE ('rohf ') 
          SELECT CASE (rohftypeval)
            CASE ('semicanonical') 
              scftype=_ROHFSCN_
              if(verblevel.ge.3) then
               write(iout,
     $"(' @scfsetup: restricted open shell hf calc')")
               write(iout,"('            semicanonical orbitals')")
              endif          
            CASE ('standard     ') 
              scftype=_ROHFSTD_
              if(verblevel.ge.3) then
               write(iout,
     $"(' @scfsetup: restricted open shell hf calc')")
               write(iout,"('            standard orbitals')")
              endif          
          END SELECT               
        CASE('mcscf')
          scftype=_MCSCF_
          if(verblevel.ge.3) then
           write(iout,
     $"(' @scfsetup: Multiconfigurational Self-Consistent Field')")
          endif          
      END SELECT           
C SCFIGUESS
      CALL GETKEY('scfiguess',9,IGUESSVAL,7)                            !SETTING THE INITIAL GUESS VARIABLE      
      SELECT CASE (IGUESSVAL)
       case ('core   ') 
         INITGUESS=_CORE_
         DENSITYIGUESSFL=.FALSE.
         if(verblevel.ge.3) then
           write(iout,
     $"(' @scfsetup: starting scf from core hamiltonian')")
         endif       
       case ('ao     ') 
         INITGUESS=_AO_
         DENSITYIGUESSFL=.TRUE.
         if(verblevel.ge.3) then
          write(iout,
     $"(' @scfsetup: starting scf from diagonal ao guess')")
         endif       
       case ('restart') 
         INITGUESS=_RESTART_
         DENSITYIGUESSFL=.TRUE.   
         if(verblevel.ge.3) then
           write(iout,"(
     $' @scfsetup: restarting scf from SCFDENSITIES file')")
         endif
       case ('sad    ')
         INITGUESS=_SAD_
         DENSITYIGUESSFL=.TRUE.
         if(verblevel.ge.3) then
          write(iout,*)
     $ '@scfsetup: starting scf from superposition of atomic densities'
         endif
       case ('mo     ') 
         INITGUESS=_MO_
         DENSITYIGUESSFL=.TRUE.   
         if(verblevel.ge.3) then
          write(iout,"(
     $' @scfsetup: restarting scf from MOCOEF file')")
         endif
      END SELECT   
cc%%% uj elektron tul. beolvaso
C OCC 
      if(scftype .eq. _MCSCF_) then
       call getkey('docc',4,occval,256)                                 !get occupation string from minp
      else
       call getkey('occ',3,occval,256)                                  !get occupation string from minp
      endif
      call ifillzero(orbperir,2*nir)
      nooccfl=emptystr(occval)                                         !if string is empty no occupation forced
      if(nooccfl) then
        if(verblevel.ge.3) then
          write(iout,"(' @scfsetup: occupation set:')")
          write(iout,"('            from initial orbitals')")
        endif
      else
        call occparser(occval) 
        if(verblevel.ge.3) then
          write(iout,"(' @scfsetup: occupation set:')")
          write(iout,"('            by user in MINP')")
        endif 
      endif
      if(scftype .eq. _MCSCF_) then
c Active orbitals for MCSCF calculation
        call getkey('mact',4,actval,256)
        call actparser(actval)
      endif
C MULT
      call getkey('mult',4,spinmultval,4)                               !spin multiplicity       
      read (spinmultval, '(i4)') spinmult
c examine compatibility of mult, occ and nelec
      call getvar('nal       ',nal)
      call getvar('nbe       ',nbe)
      nelec=nal+nbe
      call getkey('embed',5,embed,8)
      call getkey('grdens',6,grdens,8)
      route='    '
      ldual=.false.
       if(trim(grdens).ne.'off') then
        route='den1'
         if(trim(dft).eq.'off') route='den2'
       endif
      nfroz=0
      inquire(file='ROUTE',exist=llg)
       if(llg) then
        open(scrfile1,file='ROUTE')
        read(scrfile1,*,end=9747) route
        route=adjustl(route)
9747    close(scrfile1,status='delete')
       endif
       if(embed.ne.'off     '.and.(llg.or.embed.eq.'emft    '.or.
     $embed.eq.'scl     '.or.dual.ne.'off     ')) then
         if(route.eq.'em1b') then
          route='em1 '
          ldual=.true.
         else if(route.eq.'em2b') then
          route='em2 '
          ldual=.true.
         else if(route.eq.'em3b') then
          route='em3 '
          ldual=.true.
         endif
         if(embed.eq.'emft    '.or.embed.eq.'scl     ') then
           if(dual.eq.'on      '.and.route.ne.'sml ') ldual=.true.
          route='emft'
         endif
         if(route.eq.'em1 '.or.route.eq.'em2 '.or.route.eq.'emft'.or.
     $      route.eq.'sml '.or.route.eq.'sch ') then
          call getkeym('embed',5,embed,8)
          read(minpfile,*)
          read(minpfile,*) dft
          dft=adjustl(dft)
          call lowercase(dft,dft,32)
          call removed3(dft) !HB
           if(trim(dft).eq.'hf') dft='off                             '
           if(route.eq.'sch ') call getvar('nfroz     ',nfroz)
         endif
         if(route.eq.'em2 '.or.route.eq.'em3 ') then
           if(route.eq.'em2 ') then
             if(embed.ne.'fdm     ') call getvar('nfroz     ',nfroz)
            scfmaxit=1
            nal=nal-nfroz
            nbe=nbe-nfroz
            nelec=nal+nbe
           endif
           if(route.eq.'em3 ') then
             if(embed.eq.'huzinaga') call getvar('nfroz     ',nfroz)
            call getvar('edftbcor  ',temp)
            nuc=nuc+temp
           endif
         endif
       endif
      ldual=ldual.or.(dual.eq.'on      '.and.route.ne.'sml '.and.
     $(embed.eq.'off     '.or.route.eq.'em1 '))
      nocc=max(nal,nbe)
c setting up electron related variables
c number of alpha and beta electrons
      if(nooccfl) then
        noccsp(1)=(nelec+spinmult-1)/2
        noccsp(2)=nelec-noccsp(1)        
        if(noccsp(1).lt.noccsp(2)) then                                 !make sure number of alpha electrons are larger  
          u=noccsp(1)
          noccsp(1)=noccsp(2)
          noccsp(2)=u
        end if
      else
        noccsp(1)=0
        do q=1,nir
          noccsp(1)=noccsp(1)+orbperir(q)
        enddo
        if(scftype.ne._MCSCF_) then
          noccsp(2)=0
          do q=1,nir
            noccsp(2)=noccsp(2)+orbperir(q+nir)
          enddo 
        else
          noccsp(2)=noccsp(1)
        endif
        if(noccsp(1).lt.noccsp(2)) then                                 !make sure number of alpha electrons are larger  
          u=noccsp(1)
          noccsp(1)=noccsp(2)
          noccsp(2)=u
          do i=1,nir
            u=orbperir(q)
            orbperir(q)=orbperir(q+nir)
            orbperir(q+nir)=u
          enddo
        end if 
      endif
      ndocc=noccsp(2)                                                   !number of doubly occupied orbitals  
      nsocc=noccsp(1)-noccsp(2)                                         !number of singly occupied orbitals  
      nvirt=nbasis-(ndocc+nsocc)                                        !number of virtual orbitals
c setting up the orbperir array according to calculation type
       if(scftype.ge.3) then
         do q=1,nir
           u=orbperir(q)
           orbperir(q)=orbperir(q+nir)
           orbperir(q+nir)=u-orbperir(q)
         enddo
       endif
c print out starting occupation if set
       if(.not.nooccfl) then
        write(iout,"(' @scfsetup: the forced occuapation is')")
        call occprinter('f',c4)
       endif 
C DIISSTART
      call getkey('scfdiis_start',13,diisstartval,4)
      read (diisstartval, '(i4)') diisstart
       if(verblevel.ge.3) then                                          !printing out starting step
        write(iout,"(' @scfsetup: diis runs from iteration:',i4)")
     &    diisstart
       endif
C DIISEND
      call getkey('scfdiis_end',11,diisendval,4)
      read (diisendval, '(i4)') diisend
      if(verblevel.ge.3) then                                           !printing out last step
        write(iout,"(' @scfsetup: diis runs to iteration:',i4)")
     &    diisend
      endif  
c DIISSTEP
      call getkey('scfdiis_step',12,diisstepval,4)
      read (diisstepval, '(i4)') diisstep
      if(verblevel.ge.3) then                                           !printing out last step
        if(diisstep.eq.1) then
          write(iout,"(' @scfsetup: diis runs in every iteration')")
        else
          write(iout,
     &"(' @scfsetup: diis runs in every',i4,' iteration')") diisstep
        endif
      endif     
C
c setting up QSCF variables if possible
      if(.not. nooccfl) call qscf_init(qscf)
      ldens=.false.!embed.eq.'fdm     '.and.route.eq.'em3 '
      ldiff=dfbasis_scf.eq.'none                '.and..not.ldens.and.
     $trim(dft).eq.'off'.and.route.ne.'den1'.and.route.ne.'den2'.and.
     $qscf.eq.'off     '.and.trim(pcm).eq.'off'
      lsa=symmfl.or.ldiff.or.embed.eq.'coulomb '!.and. ... ?????
c array for storing which basis function belongs to which atom
      call getvar('natoms    ',natoms)
      call getvar('nangmax   ',nangmax)
      call getvar('nbset     ',nbset)
      sqrsize=0
      ltrsize=0
       do i=1,nir
        sqrsize=sqrsize+nfunc(i)**2
        ltrsize=ltrsize+(nfunc(i)+1)*nfunc(i)/2
       enddo
       if(scftype.eq._RHF_.and.route.ne.'sch ') then
        sqrsize2=sqrsize
       else
        sqrsize2=2*sqrsize
       endif
C Initialize PCM calculation
#if defined (PCM)
       if(trim(pcm).ne.'off')
     $call pcmini(pcm,verblevel,natoms,iout,minpfile)
#endif
C MEMORY ALLOCATION
      CALL MEMALLOC
C ALLOCATING ARRAYS
      lnos=7*nbasis**2.gt.maxcor-(imem-imem1).and..not.lsa.and.
     $qmreg.ne.'0       '.and.(.not.ldual.or.trim(dual).eq.'on').and.
     $scftype.eq._RHF_.and..not.ldens.and.embed.eq.'off     '
       if(lnos.and.verblevel.ge.3) write(iout,*)
     $'Warning! Out-of-core algorithms will be executed!'
c allocations independent from program configuration
      symdens_ptr=    dblalloc(nbasis**2) ! Do not change order! 1
       if(scftype.eq._RHF_.and.route.ne.'sch ') then
        symdens2_ptr= dblalloc(0)
       else
        symdens2_ptr= dblalloc(nbasis**2)
       endif
      symfock_ptr=    dblalloc(nbasis**2) ! Do not change order! 2
       if(scftype.eq._RHF_.and.route.ne.'sch ') then
        symfock2_ptr= dblalloc(0)
       else
        symfock2_ptr= dblalloc(nbasis**2)
       endif
      BB_PTR=         DBLALLOC(EXTSTEP**2)
      mosym_ptr=      intalloc(nbasis)
      alprmap_ptr=    intalloc(nbasis)
      beprmap_ptr=    intalloc(nbasis)
      densmap_ptr=    intalloc(scfmaxit)
      INATRANGE=      INTALLOC(2*NATOMS*NBSET) 
      call getvar('natrange  ',icore(inatrange))
       if(trim(scfalg).eq.'disk') then
        IINTPOS=      INTALLOC(3*(NBASIS+1)*NBASIS/2)
       else
        IINTPOS=      INTALLOC(0)
       endif
c allocations dependent from program configuration
      q=1
       if(route.eq.'sch ') q=2
      SELECT CASE(scftype)
        CASE (_RHF_, _MCSCF_)
          symqmat_ptr=    dblalloc(0)
          oldqmat_ptr=    dblalloc(0)
          EIGENVALUE_PTR= INTALLOC(nbasis*q)
          INDEXIRREP_PTR= INTALLOC(nbasis)
          MAPPING_PTR=    INTALLOC(nbasis*q)
          QMAT_PTR=       DBLALLOC(0)
          RMAT_PTR=       DBLALLOC(0)
        CASE (_UHF_)
          symqmat_ptr=    dblalloc(0)
          oldqmat_ptr=    dblalloc(0)
          EIGENVALUE_PTR= INTALLOC(nbasis*2)
          INDEXIRREP_PTR= INTALLOC(nbasis)
          MAPPING_PTR=    INTALLOC(nbasis*2)
          QMAT_PTR=       DBLALLOC(0)
          RMAT_PTR=       DBLALLOC(0)
        CASE (_ROHFSTD_)
          symqmat_ptr=    dblalloc(nbasis**2)
          EIGENVALUE_PTR= INTALLOC(nbasis)
          INDEXIRREP_PTR= INTALLOC(nbasis)
          MAPPING_PTR=    INTALLOC(nbasis)
        CASE (_ROHFSCN_)
          symqmat_ptr=    dblalloc(nbasis**2)
          EIGENVALUE_PTR= INTALLOC(nbasis*2)
          INDEXIRREP_PTR= INTALLOC(nbasis)
          MAPPING_PTR=    INTALLOC(nbasis*2)
      END SELECT 
C Memory allocations for direct DF-HF calculations
       if(trim(dfbasis_scf).ne.'none') then!.and.trim(scfalg).ne.'disk') then
        call getvar('nbf       ',nbf)
        dfnbasis=nbf(2)
       endif
c Memory allocation for QSCF methods
       if(qscf.ne.'off     ')
     &   call qscf_alloc(qscf,ndocc,nsocc,nvirt,nooccfl,nal,nbe)
c Memory allocation for seminumeric methods
       if(cpssp.ne.'off     ') then
         call getvar('nprimmax  ',nprimmax)
         iprimext=dblalloc(nprimmax*(nangmax+1)*natoms)
         inprimrange=intalloc(2*(nangmax+1)*natoms)
         inshrange=intalloc(2*(nangmax+1)*natoms*nbset)
         inprim=intalloc((nangmax+1)*natoms*nbset)
         inang=intalloc(natoms*nbset)
         inangmin=intalloc(natoms*nbset)
         igexp=dblalloc((nangmax+1)*nprimmax*natoms*nbset)
         call getvar('gexp      ',dcore(igexp))
         call getvar('nang      ',icore(inang))
         call getvar('nprim     ',icore(inprim))
         call getvar('nangmin   ',icore(inangmin))
         call calc_primext(dcore(iprimext),nprimmax,nangmax,natoms,
     &        icore(inangmin),icore(inang),icore(inprim),dcore(igexp))
         call mknprimrange(icore(inangmin),icore(inang),nangmax,
     &        icore(inprimrange),icore(inprim),natoms,nbsn)
         call dbldealloc(inshrange)
       else
         inprimrange=1
         iprimext=1
         nbsn=0
       endif
c Arrays not needed for Fock-matrix construction
C Equivalent matrices if(.not.lsa)
C p               symdens
C p(sqrsize+1)    symdens2
C fock            symfock
C fock(sqrsize+1) symfock2
C qmat            symqmat
C Do not allocate memory after this point!
      C_PTR=                   DBLALLOC(SQRSIZE2) ! Must be first! 3
       if(scftype.eq._MCSCF_) dcore(c_ptr:c_ptr+sqrsize2-1)=0.d0
       if(.not.lnos) SORIG_PTR=DBLALLOC(SQRSIZE)  ! 4
       if(lsa) then
        symtra_ptr=       dblalloc(nbasis**2)
        P_PTR=            DBLALLOC(SQRSIZE2)
        FOCK_PTR=         DBLALLOC(SQRSIZE2)
       else
        symtra_ptr=       dblalloc(0)
        P_PTR=            symdens_ptr
        FOCK_PTR=         symfock_ptr
       endif
       if(ldiff) then
        oldg_ptr=         dblalloc(sqrsize2)
       else
        oldg_ptr=         dblalloc(0)
       endif
       if(scftype.eq._ROHFSTD_.or.scftype.eq._ROHFSCN_) then
        RMAT_PTR=         DBLALLOC(SQRSIZE)
         if(lsa) then
          QMAT_PTR=       DBLALLOC(SQRSIZE)
         else
          QMAT_PTR=       symqmat_ptr
         endif
         if(ldiff) then
          oldqmat_ptr=    dblalloc(sqrsize)
         else
          oldqmat_ptr=    dblalloc(0)
         endif
       endif
C Variables for QM/MM calculations
        if(qmreg.eq.'0       '.or.embed.eq.'huzinaga'.or.
     $route.eq.'sch '.or.(scftype.ge.3.and.trim(dft).ne.'off')) then
         rs_ptr=dblalloc(2*nbasis**2)
        else
         rs_ptr=imem
        endif
        if(embed.eq.'fdm     ') fdmind_ptr=intalloc(natoms)
      CLOSE(MINPFILE)
C Check memory for scratch arrays
       if(scftype.eq._RHF_.and.route.ne.'sch ') then
        i=dblalloc(3*sqrsize) ! r8heap r8heap1n r8heap2n ! 5, 6, 7
       else
        i=dblalloc(4*sqrsize) ! r8heap r8heap1n r8heap2n r8heap3n
       endif
      call dbldealloc(i)
C
       if(lnos) SORIG_PTR=imem+2*nbasis**2
C 
      RETURN
      END
C
************************************************************************
      SUBROUTINE SYMTRA_READER(SYMTRA,R8HEAP,I4HEAP)
************************************************************************
* SUBROUTINE TO PICK UP SYMMETRY TRANSFORMATION MATRIX FROM DISK
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
      REAL*8 SYMTRA(NBASIS,NBASIS)
      REAL*8 R8HEAP(*)
      INTEGER*4 I4HEAP(*)
C
      OPEN(UNIT=SYMTRAFILE,FILE='SYMTRA',STATUS='OLD',
     &  FORM='UNFORMATTED')
      call rtdmx(r8heap,i4heap,symtra,symtrafile,nbasis,nbasis)
      CLOSE(SYMTRAFILE)
C
      RETURN
      END
C
************************************************************************
      subroutine r_build(rmat,s,pt,qmat,sqroffset,scr,rs,dft)
************************************************************************
* Build R matrix for ROHF: S*D*Q + Q*D*S
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
      integer sqroffset(*),i,j
      real*8 rmat(*),s(*),pt(*),qmat(*),scr(*),rs(*)
      character(len=32) dft
C
       do i=1,nir
         if(nfunc(i).gt.0) then
          call dsymm('l','l',nfunc(i),nfunc(i),1.d0,s(sqroffset(i)),
     $nfunc(i),pt(sqroffset(i)),nfunc(i),0.d0,scr,nfunc(i))
          call dsyr2k('u','n',nfunc(i),nfunc(i),1.d0,scr,nfunc(i),
     $qmat(sqroffset(i)),nfunc(i),0.d0,rmat(sqroffset(i)),nfunc(i))
           if(trim(dft).ne.'off') then
            call dsymm('l','l',nfunc(i),nfunc(i),1.d0,s(sqroffset(i)),
     $nfunc(i),pt(sqrsize+sqroffset(i)),nfunc(i),0.d0,rs(sqrsize+1),
     $nfunc(i))
            call daxpy(nfunc(i)**2,-0.5d0,rs(sqrsize+1),1,scr,1)
             do j=1,nfunc(i)
              scr((j-1)*nfunc(i)+j)=scr((j-1)*nfunc(i)+j)-1.d0
             enddo
            call dsymm('r','l',nfunc(i),nfunc(i),1.d0,rs(sqroffset(i)),
     $nfunc(i),rs(sqrsize+1),nfunc(i),0.d0,scr(nfunc(i)**2+1),nfunc(i))
            call dsyr2k('u','n',nfunc(i),nfunc(i),1.d0,scr,nfunc(i),
     $scr(nfunc(i)**2+1),nfunc(i),1.d0,rmat(sqroffset(i)),nfunc(i))
           endif
          call filllo(rmat(sqroffset(i)),nfunc(i))
         endif
       enddo
C
      return
      end
C
************************************************************************
      SUBROUTINE FOCK_BUILD(PA,PB,FOCKA,FOCKB,QMAT,INDEXIRREP,OFFSET,
     $SQROFFSET,npos,intpos,step,cmat,lfin,exc,dft,cchfx,lwdfn,embed,
     $scfdamp,route,nfr,nc,ncorenew,devparr,symtra,nact,cclrhfx,ccsrhfx,
     $omega,rs,qscf_hess,ica,icb,pcm)
************************************************************************
* CONSTRUCTION OF THE FOCK-MATRIX
************************************************************************
#if defined (LIBXC)
      use xc_f03_lib_m
#endif
#include "MRCCCOMMON"
#include "SCFCOMMON"
#if defined (LIBXC)
      type(xc_f03_func_t) :: xc_func
      type(xc_f03_func_info_t) :: xc_info
      integer*4 func_id
#endif
C ARRAYS
      REAL*8 PA(NBASIS,NBASIS),cmat(*),devparr(2),cchfx,rs(*)
      REAL*8 PB(NBASIS,NBASIS),symtra(nbasis,nbasis)
      REAL*8 QMAT(NBASIS,NBASIS)
      REAL*8 FOCKA(NBASIS,NBASIS)
      REAL*8 FOCKB(NBASIS,NBASIS)
      integer nact
      INTEGER INDEXIRREP(*),nfr,nalf,nbef
      INTEGER INTPOS(3,(nbasis+1)*nbasis/2)
      INTEGER TEINTF(10)
      INTEGER OFFSET(*)
      INTEGER SQROFFSET(*)
C SCALARS
      INTEGER T,Q
      INTEGER I,J,K,L
      integer*2 ii2,kk2
      INTEGER NPOS
      INTEGER IPOS
      INTEGER IMEM1
      INTEGER STEP    
      INTEGER NINTEG
      INTEGER NNINTEG
      INTEGER IPOSLO
      INTEGER IP
      INTEGER MAXM
      integer ii,intalloc,dblalloc,imoa,imob,icmo,icpr,iroute,imemold,n
      integer ii4core,ix,nos,id,iimoa,iimob,iss,isi,nmobasis_ptr,locfit
      integer nmoat_ptr,moat_ptr,ijpvt,natdom_ptr,naoat_ptr,aoat_ptr
      integer dfnmobasis_ptr,moadd_ptr,atmo_ptr,lfin,atind_ptr
      integer natmo_ptr,hailen,nc,ncorenew,idaa,icaa,lsexc,atdom_ptr
      integer ica,icb  !memory address of MO coefficients for QSCF Hessian construcion
      character*4 route
      character*5 cscftype
      character*7 scfiguess
      character*8 embed,cpssp
      character*16 scfdamp,c16
      character*32 dft,cdft,pcm
      real*8 temp,exc,chfx,dtol,excl,trpfa,trpfb,ddot,excrad,excrad_fin
      real*8 chfxold,clrhfx,csrhfx,omega,cclrhfx,ccsrhfx,chfxa,clrhfxa
      real*8 csrhfxa,epol
      logical lbeta,lscale,lwdfn,llc,sclroute,linv,lmcl,lfdm,lpssp,lexc
      logical qscf_hess
      COMMON/MEMCOM/ IMEM1
C
      call getkey('pssp',4,cpssp,8)
      if(cpssp.eq.'off     ') then
        lpssp = .false.
      else
        lpssp=.true. ! integ.f
      endif
      lscale=.false.
      llc=.false.
      lsexc=0
      sclroute=.false.
      iroute=2
      lfdm=trim(embed).eq.'fdm'.and.(route.eq.'em2 '.or.route.eq.'em3 ')
      call getkey('scfiguess',9,scfiguess,7)
      chfx=cchfx
      clrhfx=cclrhfx
      csrhfx=ccsrhfx
      chfxa=0.d0
      clrhfxa=0.d0
      csrhfxa=0.d0
       if(route.eq.'em1 '.or.route.eq.'em2 '.or.route.eq.'emft'.or.
     $(route.eq.'sml '.and.trim(embed).ne.'off').or.route.eq.'sch ')then
        chfx=0.d0
        clrhfx=0.d0
        csrhfx=0.d0
         if(trim(dft).eq.'bhlyp') then
          chfx=-0.5d0
         else if(trim(dft).eq.'b3lyp') then
          chfx=-0.2d0
         else if(trim(dft).eq.'b3pw91') then
          chfx=-0.2d0
         else if(trim(dft).eq.'b3lyp3') then
          chfx=-0.2d0
         else if(trim(dft).eq.'b97') then
          chfx=-0.1943d0
         else if(trim(dft).eq.'pbe0') then
          chfx=-0.25d0
         else if(trim(dft).eq.'b2plyp') then
          chfx=-0.53d0
         else if(trim(dft).eq.'b2gpplyp') then
          chfx=-0.65d0
         else if(trim(dft).eq.'dsdpbep86') then
          chfx=-0.70d0
         else if(trim(dft).eq.'xyg3') then
          chfx=-0.20d0
         else if(trim(dft).eq.'scan0-2') then
          chfx=-0.793701d0
         else if(trim(dft).eq.'drpa75') then
          chfx=-0.75d0
         else if(trim(dft).eq.'scs-drpa75') then
          chfx=-0.75d0
         else if(trim(dft).eq.'m06-2x') then
          chfx=-0.54d0
         else if(trim(dft).eq.'m06-hf') then
          chfx=-1.d0
         else if(trim(dft).eq.'m08-hx') then
          chfx=-0.5223d0
         else if(trim(dft).eq.'m08-so') then
          chfx=-0.5679d0
         else if(trim(dft).eq.'dsdpbehb95') then
          chfx=-0.66d0
         else if(trim(dft).eq.'scan0') then
          chfx=-0.25d0
         else if(trim(dft).eq.'off') then
          chfx=-1.d0
         else if(trim(dft).eq.'cam-b3lyp') then
          chfx=-0.19d0
          clrhfx=-0.46d0
         else if(trim(dft).eq.'m11') then
          chfx=-1.d0
          csrhfx=0.572d0
         else if(trim(dft).eq.'mn12-sx') then
          csrhfx=-0.25d0
         else if(trim(dft).eq.'mn15') then
          chfx=-0.44d0
         else if(trim(dft).eq.'wb97') then
          clrhfx=-1.d0
         else if(trim(dft).eq.'wb97x') then
          chfx=-0.157706d0
          clrhfx=-0.842294d0
         else if(trim(dft).eq.'wb97x-v') then
          chfx=-0.167d0
          clrhfx=-0.833d0
         else if(trim(dft).eq.'wb97m-v') then
          chfx=-0.15d0
          clrhfx=-0.85d0
         else if(trim(dft).eq.'hse06') then
          csrhfx=-0.25d0
         else if(trim(dft).eq.'lc-wpbe') then
          csrhfx=-1.d0
         else if(trim(dft).eq.'user') then
          open(minpfile,file='MINP')
          call getkeym('embed',5,embed,8)
          read(minpfile,*)
          read(minpfile,*)
          read(minpfile,*) n
           do i=1,n
            read(minpfile,*) temp,cdft
            cdft=adjustl(cdft)
            call lowercase(cdft,cdft,32)
             if(trim(cdft).eq.'hfx') then
              chfx=-temp
             else if(trim(cdft).eq.'lrhfx') then
              clrhfx=-temp
             else if(trim(cdft).eq.'srhfx') then
              csrhfx=-temp
             endif
           enddo
          close(minpfile)
#if defined (LIBXC)
         else if(xc_f03_functional_get_number(dft).gt.0) then
          func_id=xc_f03_functional_get_number(dft)
          call xc_f03_func_init(xc_func,func_id,XC_UNPOLARIZED)
          xc_info=xc_f03_func_get_info(xc_func)
          chfx=xc_f03_hyb_exx_coef(xc_func)
          call xc_f03_func_end(xc_func)
          chfx=-chfx
#endif
         endif
         if(route.eq.'emft') then
           if(chfx.eq.0.d0) then
            call getvar('chfx      ',chfx) !No HFx in low-level method
           else
            call getvar('chfx      ',temp) !HFx in low-level method
             if(temp.ne.0.d0) then
              lsexc=1 !HFx in both the high- and the low-level method
             else
              lsexc=2 !HFx only in the low-level method
c             chfx=0.d0
             endif
           endif
         endif
         if(route.eq.'sch ') then
          call getvar('chfx      ',chfxa)
          call getvar('clrhfx    ',clrhfxa)
          call getvar('csrhfx    ',csrhfxa)
         endif
       endif
      chfxold=chfx
       if(lpssp) chfx=0.d0
      lexc=chfx.ne.0.d0.or.clrhfx.ne.0.d0.or.csrhfx.ne.0.d0.or.
     $chfxa.ne.0.d0.or.clrhfxa.ne.0.d0.or.csrhfxa.ne.0.d0.or.lsexc.gt.0
C Clean up memory for exchange, do not perform memory operation before
       if(dfbasis_scf.ne.'none                ') then
        call getvar('nbf       ',nbf)
        dfnbasis=nbf(2)
       endif
      imemold=imem
      lmcl=(lexc.or.lsexc.gt.0).and.
     $dfbasis_scf.ne.'none                '.and.
     $nbasis*max(nal,nbe)*dfnbasis.gt.maxcor-(imem-imem1)
       if(lmcl.and.qscf_hess) then
         write(*,'(1X,A)') 'Not enough memory for the Hessian'
         call mrccend(1)
       elseif(lmcl) then
         if(verblevel.ge.3) write(iout,*) 'Cleaning up memory...'
        open(unit=scrfile6,file='SCFSCR',form='unformatted')
        write(scrfile6) dcore(c_ptr:imem-1)
        close(scrfile6)
        call dbldealloc(c_ptr)
       endif
C
       if(route.eq.'emft'.or.route.eq.'sch '.or.lfdm) then
        idaa=dblalloc(nbasis**2)
        icaa=dblalloc(nbasis**2)
       else
        idaa=imem
        icaa=imem
       endif
       if(scftype.eq.1) then
        cscftype='rhf  '
       else if(scftype.eq.2) then
        cscftype='uhf  '
       else
        cscftype='rohf '
       endif
C Cholesky-decompose density matrix
      if(scftype .eq. _MCSCF_ .or. 
     &   (scftype .eq. _RHF_ .and. qscf_hess)) then
        if(nact .eq. 0) then
          nalf = 0
          do i = 1, nir
            nalf = nalf + orbperir(i)
          enddo
          nalf = nalf - nfr
          nbef = nalf
        else
          nalf = nact
          nbef = nact
        endif
      elseif(scftype .ge. 3 .and. qscf_hess) then
        nalf = nact
        nbef = nact
      else
        nalf=nal-nfr
        nbef=nbe-nfr
      endif
      if(qscf_hess) then
        nalf=2*nalf
        nbef=2*nbef
      endif
      nc=0
      imoa=imem
      imob=imem
      ix=imem
       if(dfbasis_scf.ne.'none                '.or.trim(dft).ne.'off'
     $.or.route.eq.'den1'.or.route.eq.'den2'.or.lpssp) then
        llc=(nir.eq.1.and.(step.gt.1.or.scfiguess.eq.'sad    '.or.
     $scfiguess.eq.'mo     '.or.scfiguess.eq.'restart').and.
     $.not.ldens.and.scftype.le.2.and.scfdamp.eq.'off             ').or.
     $route.eq.'sch '
         if(lmcl.and.llc) then
          call dcopy(nbasis*nalf,cmat,1,focka,1)    
           if(scftype.ge.2)
     $    call dcopy(nbasis*nbef,cmat(sqrsize+1),1,fockb,1)
         endif
         if(dfbasis_scf.ne.'none                ') then
          ix=dblalloc(dfnbasis)
          call dfillzero(dcore(ix),dfnbasis)
         endif
        nos=max(nalf,nbef)-min(nalf,nbef)
        nocc=max(nalf,nbef)
         if(route.eq.'emft'.or.route.eq.'sch '.or.lfdm) nocc=nbasis!schszemet
        dtol=pepsilon/dfloat(nbasis*nocc)
        if(qscf.ne.'off     ') dtol=min(dtol,1.0d-8/dfloat(nbasis*nocc))
         if(scftype.ge.3 .and. .not. qscf_hess) nbef=nos
         if(qscf_hess) then
           imoa=ica
           if(scftype.ge.2) then
             imob=icb
           else
             imob=ica
           endif
         else
           imoa=dblalloc(nocc*nbasis)
           imob=imoa
           if(scftype.ge.2) imob=dblalloc(nocc*nbasis)
         endif
        icmo=dblalloc(nbasis**2)
        ijpvt=intalloc(nbasis)
         if(scftype.ge.3 .and. .not. qscf_hess) then
          nbef=nos
          call daxpy(nbasis**2,-1.d0,pb,1,pa,1)
         endif
        if(.not.qscf_hess) then
         if(lmcl.and.llc) then
          call denschol(nbasis,nalf,pa,dcore(icmo),dcore(imoa),
     $dcore(imem),icore(ijpvt),llc,focka,scftype,i,'    ')
           if(scftype.ge.2)
     $    call denschol(nbasis,nbef,pb,dcore(icmo),dcore(imob),
     $dcore(imem),icore(ijpvt),llc,fockb,scftype,i,'    ')
         else
          call denschol(nbasis,nalf,pa,dcore(icmo),dcore(imoa),
     $dcore(imem),icore(ijpvt),llc,cmat,scftype,i,'    ')
           if(scftype.ge.2)
     $    call denschol(nbasis,nbef,pb,dcore(icmo),dcore(imob),
     $dcore(imem),icore(ijpvt),llc,cmat(sqrsize+1),scftype,i,'    ')
         endif
        endif
         if(scftype.ge.3 .and. .not. qscf_hess) then
          call daxpy(nbasis**2,1.d0,pb,1,pa,1)
          ii=0
           do j=1,nbasis
             do i=1,nbef
              dcore(imoa+(j-1)*nalf+nbe+i-1)=dcore(imob+ii)
              ii=ii+1
             enddo
           enddo
         endif
         if(route.eq.'sch ') then
          call moatransp(nalf,nbasis,dcore(imoa),dcore(icaa),nfroz)
          call motransp(nalf,nbasis,dcore(imoa),dcore(icaa),.true.)
         else if(route.eq.'emft'.or.lfdm) then
           if(embed.eq.'scl     ') then
            open(scrfile1,file='SROOT',form='unformatted')
            iss=dblalloc(nbasis**2)
            call roeint(dcore(imem),dcore(imem),dcore(iss),scrfile1,
     $nbasis)
             if(.true.) then
              call motransp(nalf,nbasis,dcore(imoa),dcore(icaa),.true.)
              call dscal(nbasis*nalf,1.d0/dsqrt(2.d0),dcore(icaa),1)
              call spade(nbasis,nalf,nc,dcore(icaa),dcore(idaa),
     $dcore(imem+nalf+1),dcore(imem),dcore(iss),natoms,minpfile,
     $icore(inatrange),i,verblevel,ncorenew)
             else
              isi=dblalloc(nbasis**2)
              call roeint(dcore(imem),dcore(imem),dcore(isi),scrfile1,
     $nbasis)
              call fragloc(nbasis,pa,dcore(imem+nbasis+nbasis**2),
     $dcore(imem),dcore(isi),dcore(iss),dcore(icaa),dcore(idaa),natoms,
     $minpfile,icore(inatrange),nalf,nc,2.d0,i,verblevel,
     $dcore(imem+nbasis),.true.,ncorenew,dcore(imem+nbasis+2*nbasis**2),
     $nbf(4),dcore(imem+nbasis+3*nbasis**2),
     $dcore(imem+nbasis+4*nbasis**2),scrfile2)
             endif
            close(scrfile1)
            call dbldealloc(isi)
            call dscal(nbasis*nalf,dsqrt(2.d0),dcore(icaa),1)
c     write(6,*) 'cca'
c     write(6,"(13f10.6)") (dcore(icaa+i),i=0,nbasis*nc-1)
           else
            call emftdens(nbasis,natoms,minpfile,icore(inatrange),
     $icore(ijpvt),iout,pa,dcore(idaa),dcore(icaa),nalf,dcore(imoa),
     $.true.,.false.)
            call denschol(nbasis,nalf,dcore(idaa),dcore(icmo),
     $dcore(icaa),dcore(imem),icore(ijpvt),.false.,dcore(icaa),scftype,
     $nc,route)
           endif
          write(iout,
     $"(' Number of orbitals in embedded subsystem:',i5)") nc
          write(iout,*)
           if(lfdm) then
            call dcopy(nbasis**2,dcore(idaa),1,pa,1)    
            ii=0
             do j=1,nbasis
               do i=1,nc
                dcore(imoa+ii)=dcore(icaa+(i-1)*nbasis+j-1)
                ii=ii+1
               enddo
             enddo
            nalf=nc
            nc=0
           else
            nc=nalf-nc
           endif
         endif
        call dbldealloc(icmo)
         if(scftype.eq.2) then
          id=dblalloc(nbasis**2)
          call dcopy(nbasis**2,pa,1,dcore(id),1)    
          call daxpy(nbasis**2,1.d0,pb,1,dcore(id),1)
         endif
       endif
C Local exchange?
      call getkey('excrad',6,c16,16)
      read(c16,*) excrad
      call getkey('excrad_fin',10,c16,16)
      read(c16,*) excrad_fin
       if(lfin.eq.2) then
        excrad=excrad_fin
       else
        lfin=0
       endif
      locfit=0
       if(excrad.gt.0.d0.and.lexc) then
        locfit=1
         if(trim(scfalg).eq.'locfit2') locfit=2
       endif
C
      iimoa=imoa
      iimob=imob
       if(route.eq.'emft'.or.route.eq.'sch ') then
        iimoa=dblalloc(nbasis**2)
       endif
      nmoat_ptr=imem
      moat_ptr=imem
      dfnmobasis_ptr=imem
      moadd_ptr=imem
      atmo_ptr=imem
      natmo_ptr=imem
      nmobasis_ptr=imem
      natdom_ptr=imem
      atdom_ptr=imem
      naoat_ptr=imem
      aoat_ptr=imem
      atind_ptr=imem
       if(dfbasis_scf.ne.'none                '.and.(step.gt.1.or.
     $scfiguess.eq.'restart'.or.scfiguess.eq.'sad    '.or.
     $scfiguess.eq.'mo     ')) then
        moadd_ptr=     intalloc(nocc)
        nmobasis_ptr  =intalloc(nocc)
        dfnmobasis_ptr=intalloc(nocc)
         if(excrad.gt.0.d0) then
          nmoat_ptr=     intalloc(natoms)
          moat_ptr=      intalloc(nocc*natoms)
          atmo_ptr=      intalloc(nocc*natoms)
          natmo_ptr=     intalloc(nocc)
           if(locfit.ge.2) then
            natdom_ptr=  intalloc(nocc)
            atdom_ptr=   intalloc(nocc*natoms)
            naoat_ptr=   intalloc(2*natoms)
            aoat_ptr=    intalloc(nocc*natoms)
            atind_ptr=   intalloc(natoms*nocc)
           endif
         endif
       endif
C Initialize Fock matrix
      focka=0.d0
       if(scftype.eq.2) then
        fockb=0.d0
       else if(scftype.ge.3) then
        qmat=0.d0
       endif
1235  continue
      IF(trim(scfalg).ne.'disk'.or.(trim(dfbasis_scf).ne.'none'
     $.and.step.eq.1.and.scfiguess.ne.'restart'
     $.and.scfiguess.ne.'sad    '.and.scfiguess.ne.'mo     '
     $)) THEN
C INTEGRAL-DIRECT FOCK-MATRIX CONSTRUCTION
C Density-fitting algorithm
       if(dfbasis_scf.ne.'none                '.and.(step.gt.1.or.
     $scfiguess.eq.'restart'.or.scfiguess.eq.'sad    '.or.
     $scfiguess.eq.'mo     ')) then
        lscale=.true.
         if(scftype.eq.2) then
           if(.not. qscf_hess) then
            chfx=2.d0*chfx
            clrhfx=2.d0*clrhfx
            csrhfx=2.d0*csrhfx
           endif
          if(.not. qscf_hess) 
     $      write(iout,*) 'Constructing alpha Fock-matrix...'
          call df_direct_fock(focka,fockb,dcore(id),nbasis,dfnbasis,
     $pepsilon,nalf,dcore(iimoa),step,iout,icore(inatrange),oeintfile,
     $natoms,dcore,icore,imem,icore(nmoat_ptr),icore(moat_ptr),
     $icore(dfnmobasis_ptr),icore(moadd_ptr),icore(atmo_ptr),
     $icore(natmo_ptr),scrfile3,iimem,scrfile4,lfin,dcore(imoa),
     $dcore(ix),1,chfx,varsfile,nbset,scrfile3,maxcor,tedatfile,lwdfn,
     $minpfile,irecln,sclroute,route,hailen,linv,nc,lsexc,ncorenew,
     $dcore(icaa),devparr,excrad,excrad_fin,llc,cscftype,scfiguess,
     $locfit,icore(nmobasis_ptr),icore(natdom_ptr),icore(atdom_ptr),
     $icore(naoat_ptr),icore(aoat_ptr),icore(atind_ptr),clrhfx,csrhfx,
     $omega,qscf_hess)
           if(lexc) then!.and.nbef.gt.0) then
             if(.not. qscf_hess) 
     $         write(iout,*) 'Constructing beta Fock-matrix...'
            call df_direct_fock(fockb,focka,dcore(id),nbasis,dfnbasis,
     $pepsilon,nbef,dcore(iimob),step,iout,icore(inatrange),oeintfile,
     $natoms,dcore,icore,imem,icore(nmoat_ptr),icore(moat_ptr),
     $icore(dfnmobasis_ptr),icore(moadd_ptr),icore(atmo_ptr),
     $icore(natmo_ptr),scrfile3,iimem,scrfile4,lfin,dcore(imob),
     $dcore(ix),2,chfx,varsfile,nbset,scrfile3,maxcor,tedatfile,lwdfn,
     $minpfile,irecln,sclroute,route,hailen,linv,nc,lsexc,ncorenew,
     $dcore(icaa),devparr,excrad,excrad_fin,llc,cscftype,scfiguess,
     $locfit,icore(nmobasis_ptr),icore(natdom_ptr),icore(atdom_ptr),
     $icore(naoat_ptr),icore(aoat_ptr),icore(atind_ptr),clrhfx,csrhfx,
     $omega,qscf_hess)
           endif
         else if(scftype.ge.3) then
          if(.not.qscf_hess) write(iout,*) 'Constructing Fock-matrix...'
          if(.not.qscf_hess) call df_direct_fock(focka,qmat,pa,nbasis,
     $dfnbasis,pepsilon,nalf,dcore(iimoa),step,iout,icore(inatrange),
     $oeintfile,natoms,dcore,icore,imem,icore(nmoat_ptr),
     $icore(moat_ptr),icore(dfnmobasis_ptr),icore(moadd_ptr),
     $icore(atmo_ptr),icore(natmo_ptr),scrfile3,iimem,scrfile4,lfin,
     $dcore(imoa),dcore(ix),1,chfx,varsfile,nbset,scrfile3,maxcor,
     $tedatfile,lwdfn,minpfile,irecln,sclroute,route,hailen,linv,nc,
     $lsexc,ncorenew,dcore(icaa),devparr,excrad,excrad_fin,llc,cscftype,
     $scfiguess,locfit,icore(nmobasis_ptr),icore(natdom_ptr),
     $icore(atdom_ptr),icore(naoat_ptr),icore(aoat_ptr),
     $icore(atind_ptr),clrhfx,csrhfx,omega,qscf_hess)
           if(lexc) then
            if(.not.qscf_hess)write(iout,*) 'Constructing Q matrix...'
            call df_direct_fock(qmat,focka,pb,nbasis,dfnbasis,
     $pepsilon,nbef,dcore(iimob),step,iout,icore(inatrange),oeintfile,
     $natoms,dcore,icore,imem,icore(nmoat_ptr),icore(moat_ptr),
     $icore(dfnmobasis_ptr),icore(moadd_ptr),icore(atmo_ptr),
     $icore(natmo_ptr),scrfile3,iimem,scrfile4,lfin,dcore(imob),
     $dcore(ix),2,-chfx,varsfile,nbset,scrfile3,maxcor,tedatfile,lwdfn,
     $minpfile,irecln,sclroute,route,hailen,linv,nc,lsexc,ncorenew,
     $dcore(icaa),devparr,excrad,excrad_fin,llc,cscftype,scfiguess,
     $locfit,icore(nmobasis_ptr),icore(natdom_ptr),icore(atdom_ptr),
     $icore(naoat_ptr),icore(aoat_ptr),icore(atind_ptr),-clrhfx,-csrhfx,
     $omega,qscf_hess)
           else
            call daxpy(nbasis**2,1.d0,qmat,1,focka,1)
            qmat=0.d0
           endif
         else
          if(.not.qscf_hess) write(iout,*) 'Constructing Fock-matrix...'
          call df_direct_fock(focka,fockb,pa,nbasis,dfnbasis,
     $pepsilon,nalf,dcore(iimoa),step,iout,icore(inatrange),oeintfile,
     $natoms,dcore,icore,imem,icore(nmoat_ptr),icore(moat_ptr),
     $icore(dfnmobasis_ptr),icore(moadd_ptr),icore(atmo_ptr),
     $icore(natmo_ptr),scrfile3,iimem,scrfile4,lfin,dcore(imoa),
     $dcore(ix),0,chfx,varsfile,nbset,scrfile3,maxcor,tedatfile,lwdfn,
     $minpfile,irecln,sclroute,route,hailen,linv,nc,lsexc,ncorenew,
     $dcore(icaa),devparr,excrad,excrad_fin,llc,cscftype,scfiguess,
     $locfit,icore(nmobasis_ptr),icore(natdom_ptr),icore(atdom_ptr),
     $icore(naoat_ptr),icore(aoat_ptr),icore(atind_ptr),clrhfx,csrhfx,
     $omega,qscf_hess)
         endif
         if(qscf_hess) return
       else
C Conventional direct SCF, no density-fitting
        call direct_fock_build(pa,pb,focka,fockb,qmat,step,cscftype,
     $iroute,0,1,dcore,dcore,dcore,.false.,dcore,dcore,dcore,dcore,ii,
     $ii,ii,ii,ii,dcore,.false.,dcore,0,chfx,iout,varsfile,
     $icore,dcore,nbset,oeintfile,nocc,scrfile3,scrfile4,maxcor,
     $imem,tedatfile,dfnbasis,nbasis,0,dcore,minpfile,.false.,1,dcore,
     $irecln,1,.false.,0,0,0,devparr(1)+devparr(2),pa,1,dcore,0,0,
     $i,i,i,i,i,i,i,i,clrhfx,csrhfx,omega,.false.,dcore,dcore,dcore,i,
     $qscf_hess,.false.,dcore,.false.)
       endif
      ELSE
C CONVENTIONAL FOCK-MATRIX CONSTRUCTION
        call intopenrsq(teintf)
C
       if(dfbasis_scf.ne.'none                ') then
        lscale=.true.
        nocc=max(nalf,nbef)
        icpr=dblalloc(nbasis)
        ii=3*dfnbasis
        ii=(ii+mod(ii,2))/2
        ii4core=dblalloc(ii)
        maxm=maxcor-(imem-imem1)
         if(scftype.eq.2) then
          write(iout,*) 'Constructing alpha Fock-matrix...'
          chfx=2.d0*chfx
          call df_disk_fock(focka,fockb,dcore(id),dcore(id),nbasis,
     $dfnbasis,npos,ipos,dcore(imem),dcore(ix),dcore(ix),dcore(icpr),
     $dcore(ii4core),intpos,teintf,nalf,nbef,dcore(imoa),dcore(imob),
     $step,maxm,iout,icore(inatrange),dcore(imem),oeintfile,natoms,dft,
     $chfx,scftype,dtol,.false.,lbeta,'f')
           if(lbeta.and.dabs(chfx).gt.dtol.and.nbef.gt.0) then
            call timer
            write(iout,*) 'Constructing beta Fock-matrix...'
            call df_disk_fock(fockb,focka,pb,pb,nbasis,dfnbasis,npos,
     $ipos,dcore(imem),dcore(ix),dcore(ix),dcore(icpr),dcore(ii4core),
     $intpos,teintf,nbef,nalf,dcore(imob),dcore(imoa),step,maxm,iout,
     $icore(inatrange),dcore(imem),oeintfile,natoms,dft,chfx,scftype,
     $dtol,.true.,lbeta,'f')
           endif
         else if(scftype.ge.3) then
          write(iout,*) 'Constructing Fock-matrix...'
          call df_disk_fock(focka,qmat,pa,pa,nbasis,dfnbasis,npos,ipos,
     $dcore(imem),dcore(ix),dcore(ix),dcore(icpr),dcore(ii4core),intpos,
     $teintf,nalf,nbef,dcore(imoa),dcore(imob),step,maxm,iout,
     $icore(inatrange),dcore(imem),oeintfile,natoms,dft,chfx,scftype,
     $dtol,.false.,lbeta,'f')
           if(lbeta.and.dabs(chfx).gt.dtol.and.nos.gt.0) then
            call timer
            write(iout,*) 'Constructing Q matrix...'
            call df_disk_fock(qmat,focka,pb,pb,nbasis,dfnbasis,npos,
     $ipos,dcore(imem),dcore(ix),dcore(ix),dcore(icpr),dcore(ii4core),
     $intpos,teintf,nbef,nalf,dcore(imob),dcore(imoa),step,maxm,iout,
     $icore(inatrange),dcore(imem),oeintfile,natoms,dft,-chfx,scftype,
     $dtol,.true.,lbeta,'f')
           endif
         else
          write(iout,*) 'Constructing Fock-matrix...'
          call df_disk_fock(focka,fockb,pa,pa,nbasis,dfnbasis,npos,ipos,
     $dcore(imem),dcore(ix),dcore(ix),dcore(icpr),dcore(ii4core),intpos,
     $teintf,nalf,nbef,dcore(imoa),dcore(imob),step,maxm,iout,
     $icore(inatrange),dcore(imem),oeintfile,natoms,dft,chfx,scftype,
     $dtol,.false.,lbeta,'f')
         endif
        call timer
        write(iout,*)
        call dbldealloc(icpr)
       else
C
        IPOS=0
        MAXM=IFLTLN*MIN(MAXCOR-(IMEM-IMEM1),20*nbasis*(nbasis+1)/2)
c       MAXM=IFLTLN*MIN(MAXCOR-(IMEM-IMEM1),20*INTPOS(3,NPOS))
        DO 
         NNINTEG=0
         IPOSLO=IPOS+1
          DO WHILE(IPOS.LT.NPOS.AND.12*NNINTEG.LT.MAXM)
           IPOS=IPOS+1
           NNINTEG=NNINTEG+INTPOS(3,IPOS)
          ENDDO
          IF(12*NNINTEG.GT.MAXM) THEN
           NNINTEG=NNINTEG-INTPOS(3,IPOS)
           IPOS=IPOS-1
          ENDIF
         CALL INTREADSQ(dcore(imem),NNINTEG,TEINTF)
         NNINTEG=0
          DO IP=IPOSLO,IPOS
            ii2   =INTPOS(1,IP)
            kk2   =INTPOS(2,IP)
            NINTEG=INTPOS(3,IP)
C BUILDING FOCK PART FROM READ BATCH
            SELECT CASE (scftype)
              CASE (_RHF_, _MCSCF_)
                CALL RHFFOCK(
     &            FOCKA,
     &            PA,
     &            NBASIS,
     &            dcore(imem),
     &            ii2,
     &            kk2,
     &            NINTEG,
     &            NNINTEG,chfx)
              CASE (_UHF_)
                CALL UHFFOCK(
     &            FOCKA,
     &            FOCKB,
     &            PA,
     &            PB,
     &            NBASIS,
     &            dcore(imem),
     &            ii2,
     &            kk2,
     &            NINTEG,
     &            NNINTEG,chfx)
              CASE (_ROHFSTD_,_ROHFSCN_)
                if(qscf_hess) then
                  CALL rohf_qmat_hessian(
     &              FOCKA,
     &              QMAT,
     &              PA,
     &              PB,
     &              NBASIS,
     &              dcore(imem),
     &              ii2,
     &              kk2,
     &              NINTEG,
     &              NNINTEG,chfx)
                else
                  CALL ROHFFOCK(
     &              FOCKA,
     &              QMAT,
     &              PA,
     &              PB,
     &              NBASIS,
     &              dcore(imem),
     &              ii2,
     &              kk2,
     &              NINTEG,
     &              NNINTEG,chfx)
                endif
            END SELECT 
            NNINTEG=NNINTEG+6*NINTEG
          ENDDO
          IF(IPOS.EQ.NPOS) EXIT
        ENDDO
C     CLOSE(TEINTFILE)
       endif
      CALL INTCLOSE(TEINTF)
      ENDIF
C Additional exchange in the case of embedding
       if(lsexc.eq.1) then
        lsexc=0
        call getvar('chfx      ',temp)
        chfx=temp-chfx
        sclroute=.true.
         if(dabs(chfx).gt.1d-18) goto 1235
       endif
       if((route.ne.'emft'.and.route.ne.'sch ').or.lfdm)
     $call dbldealloc(nmoat_ptr)
C Scale diagonal Fock matrix elements in the case of DF
       if(lscale) then
         do i=1,nbasis
          focka(i,i)=0.5d0*focka(i,i)
         enddo
         if(scftype.eq.2) then
           do i=1,nbasis
            fockb(i,i)=0.5d0*fockb(i,i)
           enddo
         else if(scftype.ge.3) then
           do i=1,nbasis
            qmat(i,i)=0.5d0*qmat(i,i)
           enddo
         endif
       endif
C SYMMETRISING FOCK AFTER BUILD
      SELECT CASE (scftype)
        CASE (_RHF_,_MCSCF_)
          call mxsym(focka,nbasis)
        CASE (_UHF_)
          call mxsym(focka,nbasis)
          call mxsym(fockb,nbasis)
        CASE (_ROHFSTD_,_ROHFSCN_)
          call mxsym(focka,nbasis)
c%%% meg kell keresni a programban, hogy az a kettes hol i
c    veszik el valami mas helyen......
          call mxsym(qmat,nbasis)
          call dscal(nbasis**2,2.d0,qmat,1)
      END SELECT  
C SCH exchange for subsystem A
       if(route.eq.'sch ') then
         if(sclroute) then
          call daxpy(sqrsize,1.d0,fockb,1,focka,1)
         else
          nc=nfroz
          call dcopy(nbasis**2,focka,1,fockb,1)
          call daxpy(sqrsize,-1.d0,pb,1,pa,1)
          chfx=chfxa-chfx
          clrhfx=clrhfxa-clrhfx
          csrhfx=csrhfxa-csrhfx
           if(dabs(chfx)+dabs(clrhfx)+dabs(csrhfx).gt.1d-14) then
            focka=0.d0
            sclroute=.true.
            goto 1235
           endif
         endif
       endif
C PS exchange
       if(lpssp) then
        chfx=chfxold
        call dft_core(nbasis,nalf,nbef,focka,fockb,dcore(imoa),
     $dcore(imob),scrfile5,dcore,iout,exc,dft,minpfile,scftype,ifltln,
     $maxcor,imem,imem1,icore,verblevel,0,dcore,route,pa,pb,1,1,chfx,
     $lpssp)
       endif
C DFT contribution
      exc=0.d0
       if(trim(dft).ne.'off'.or.route.eq.'emft'.or.route.eq.'den2'.or.
     $route.eq.'sch '.or.trim(pcm).ne.'off') then
        trpfa=0.d0
        trpfb=0.d0
         if(trim(dft).ne.'off'.or.route.eq.'emft'.or.route.eq.'sch '.or.
     $trim(pcm).ne.'off') then
C Calculate Tr(PF)
          trpfa=0.5d0*ddot(nbasis**2,pa,1,focka,1)
           if(scftype.eq.2.or.route.eq.'sch ') then
            trpfb=0.5d0*ddot(nbasis**2,pb,1,fockb,1)
             if(route.eq.'sch ') then
              call dcopy(nbasis**2,focka,1,rs,1)
              call dcopy(nbasis**2,fockb,1,rs(sqrsize+1),1)
              focka=0.d0
              fockb=0.d0
             endif
           else
            trpfb=0.d0
           endif
         endif
         if(trim(dft).ne.'off'.or.route.eq.'emft'.or.route.eq.'den2'.or.
     $route.eq.'sch ') then
c      write(6,"(24f6.3)") focka
c      write(6,*)
c      write(6,"(24f8.4)") pa
c      write(6,*)
c      write(6,"(9f8.4)") (dcore(imoa+i-1),i=1,nalf*nbasis)
           if(embed.eq.'coulomb ') then
            call mx_symm_extr(dcore(imem+nbasis**2),cmat,offset)
            call dgemm('n','n',nbasis,nbasis,nbasis,1.d0,symtra,nbasis,
     $dcore(imem+nbasis**2),nbasis,0.d0,dcore(imem),nbasis)
            call denschol(nbasis,orbperir(1),dcore,dcore,dcore(imoa),
     $dcore,icore,.true.,dcore(imem),scftype,i,'    ')
            call dft_core(nbasis,orbperir(1),nbef,focka,fockb,
     $dcore(imoa),dcore(imob),scrfile5,dcore,iout,exc,dft,minpfile,
     $scftype,ifltln,maxcor,imem,imem1,icore,verblevel,0,dcore,route,pa,
     $pb,1,1,chfx,.false.)
            call mx_symm_extr(dcore(imem+nbasis**2),cmat,offset)
            call dgemm('n','n',nbasis,nbasis,nbasis,1.d0,symtra,nbasis,
     $dcore(imem+nbasis**2),nbasis,0.d0,dcore(imem),nbasis)
            call denschol(nbasis,orbperir(2),dcore,dcore,dcore(imoa),
     $dcore,icore,.true.,dcore(imem+nfunc(1)*nbasis),scftype,i,'    ')
            call dft_core(nbasis,orbperir(2),nbef,focka,fockb,
     $dcore(imoa),dcore(imob),scrfile5,dcore,iout,exc,dft,minpfile,
     $scftype,ifltln,maxcor,imem,imem1,icore,verblevel,0,dcore,'coul',
     $pa,pb,1,1,chfx,.false.)
c      write(6,*)
c      write(6,"(9f8.4)") (dcore(imoa+i-1),i=1,nalf*nbasis)
C Calculate exchange-correlation energy and matrix
c     write(6,*) 'dft1',nalf,nbef
           else
             if(scftype.ge.3) then
              ii=0
               do j=1,nbasis
                 do i=1,nbe
                  dcore(imoa+(j-1)*nal+i-1)=
     $            dcore(imoa+(j-1)*nal+i-1)/dsqrt(2.d0)
                  dcore(imob+ii)=dcore(imoa+(j-1)*nal+i-1)
                  ii=ii+1
                 enddo
               enddo
              rs(1:2*nbasis**2)=0.d0
              call dft_core(nbasis,nal,nbe,rs,rs(nbasis**2+1),
     $dcore(imoa),dcore(imob),scrfile5,dcore,iout,exc,dft,minpfile,
     $scftype,ifltln,maxcor,imem,imem1,icore,verblevel,0,dcore,route,pa,
     $pb,1,1,chfx,.false.)
c      write(6,*) 'focka'
c      write(6,"(7f9.5)") focka
c      write(6,*) 'rsa'
c      write(6,"(7f9.5)") rs(1:nbasis**2)
c      write(6,*) 'rsb'
c      write(6,"(7f9.5)") rs(nbasis**2+1:2*nbasis**2)
              call daxpy(nbasis**2,0.5d0,rs             ,1,focka,1)
              call daxpy(nbasis**2,0.5d0,rs(nbasis**2+1),1,focka,1)
             else
              call dft_core(nbasis,nalf,nbef,focka,fockb,dcore(imoa),
     $dcore(imob),scrfile5,dcore,iout,exc,dft,minpfile,scftype,ifltln,
     $maxcor,imem,imem1,icore,verblevel,0,dcore,route,pa,pb,1,1,chfx,
     $.false.)
             endif
           endif
           if((route.eq.'emft'.or.route.eq.'sch ').and.nc.lt.nalf) then
             if(route.eq.'sch ') call dcopy(nbasis**2,focka,1,fockb,1)
            ii=0
             do j=1,nbasis
               do i=1,nalf-nc
                dcore(imoa+ii)=dcore(icaa+(i-1)*nbasis+j-1)
                ii=ii+1
               enddo
             enddo
            call dft_core(nbasis,nalf-nc,nbef-nc,focka,fockb,
     $dcore(imoa),dcore(imob),scrfile5,dcore,iout,exc,dft,minpfile,
     $scftype,ifltln,maxcor,imem,imem1,icore,verblevel,0,dcore,'scl1',
     $pa,pb,1,1,chfx,.false.)
           endif
         endif
C Add Tr(PF) to energy
#if defined (MPI)
        dcore(imem  )=trpfa
        dcore(imem+1)=trpfb
        call mpi_allreduce(dcore(imem),dcore(imem+2),2,
     $MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,MPIERR)
        trpfa=dcore(imem+2)
        trpfb=dcore(imem+3)
#endif
         if(verblevel.ge.3) write(iout,
     $"(' Coulomb energy + HF exchange [au]:',f20.12)") trpfa+trpfb
        exc=exc+trpfa+trpfb
       endif
       if(route.eq.'sch ') then
        call daxpy(sqrsize,1.d0,pb,1,pa,1)
        call daxpy(sqrsize,1.d0,rs,1,focka,1)
        call daxpy(sqrsize,1.d0,rs(sqrsize+1),1,fockb,1)
       endif
#if defined (MPI)
      call symreduce(focka,dcore(imem),nbasis)
       if(scftype.eq.2) call symreduce(fockb,dcore(imem),nbasis)
       if(scftype.ge.3) then
        call symreduce(qmat,dcore(imem),nbasis)
         if(trim(dft).ne.'off') then
          call symreduce(rs             ,dcore(imem),nbasis)
          call symreduce(rs(nbasis**2+1),dcore(imem),nbasis)
         endif
       endif
#endif
C Calculate solvent contribution
#if defined (PCM)
       if(trim(pcm).ne.'off') then
        call pcm_core(pcm,epol,verblevel,iout,dcore,icore,imem,nbasis,
     $focka,fockb,pa,pb,scftype,0,dcore)
        exc=exc+epol
       endif
#endif
C Release memory
      call dbldealloc(imemold)
       if(lmcl) then
         if(verblevel.ge.3) write(iout,*) 'Restoring memory...'
        open(unit=scrfile6,file='SCFSCR',form='unformatted')
        read(scrfile6) dcore(c_ptr:imem-1)
        close(scrfile6,status='delete')
       endif
c      write(6,*) 'focka scf'
c      write(6,"(850f12.8)") focka
C
      RETURN
      END  

************************************************************************
      subroutine mxsym(mx,lsize)
************************************************************************
* symmetrising a matrix
************************************************************************
      implicit none
c arguments
      integer lsize
      real*8 mx(lsize,lsize)
c variables
      integer i,j
      real*8 temp
c
      do i=1,lsize
        do j=1,i-1
         temp=(mx(i,j)+mx(j,i))/2.d0
         mx(i,j)=temp
         mx(j,i)=temp
        enddo
      enddo
c
      return
      end  
C
************************************************************************
      subroutine df_disk_fock(focka,fockb,p,p2,nbasis,dfnbasis,npos,
     $ipos,hai,x,x2,cpr,i4core,intpos,teintf,nal,nbe,moa,mob,step,
     $maxmem,iout,natrange,work,oeintfile,natoms,dft,chfx,scftype,dtol,
     $lqmat,lbeta,job)
************************************************************************
* DF-HF Fock-matrix construction, integrals on disk
************************************************************************
      implicit none
      integer nbasis,dfnbasis,intpos(3,*),npos,ipos,iout,natrange,ihai2
      integer i,j,k,l,n,kk,teintf(10),nn,ii,jpvt(nbasis),nal,nbe,step
      integer maxmem,nblock,iblock,nbl,nbll,oeintfile,natoms,scftype
      real*8 focka(nbasis,nbasis),fockb(nbasis,nbasis),p(nbasis,nbasis)
      real*8 hai(*),cpr(nbasis),moa(nal,nbasis)
      real*8 ddot,pp,pr,work(*),chfx,temp,ss,dtol,x(dfnbasis)
      real*8 mob(nbe,nbasis),p2(nbasis,nbasis),x2(dfnbasis),pp2
      integer*4 i4core(*),ssi(2)
      character*16 dft
      character*1 job
      logical lqmat,lbeta, lq
      equivalence(ss,ssi)
      lbeta=.true.
C Prescreening values
       do i=1,nbasis
        ss=0.d0
         do ii=1,nal
          ss=max(ss,dabs(moa(ii,i)))
         enddo
        cpr(i)=ss
       enddo
C Memory
       if(dabs(chfx).gt.dtol) then
         if(dfnbasis*nbasis.gt.maxmem) then
          write(iout,*)
     $'Insufficient memory for Fock-matrix construction!'
          call mrccend(1)
         endif
        i=mod(maxmem,dfnbasis*nbasis)
        nbl=min(nal,(maxmem-i)/(dfnbasis*nbasis))
        nbll=mod(nal,nbl)
        nblock=(nal-nbll)/nbl
         if(nbll.ne.0) then
          nblock=nblock+1
         else
          nbll=nbl
         endif
         if(job .ne. 'm') then
           write(iout,"(' Number of integral batches:',i5)") nblock
           write(iout,"(' Occupied indices per batch:',i5)") nbl
         endif
       else
        nblock=1
        nbl=nal
        nbll=nal
       endif
C UHF beta Fock matrix or ROHF Q matrix
       if(lqmat) then
        if(job .eq. 'm') then
          i=(nal/2)/nbl+1
          do iblock=1,i-1
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,
     $           i4core,intpos,teintf,nal,moa((iblock-1)*nbl+1,1),
     $           dtol,nbl,chfx,job,nbl,1,0)
          enddo
          j = nal/2-(i-1)*nbl
          if(j. ne. 0) then
            ihai2 = dfnbasis*nbasis*j+1
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai(ihai2),
     $           cpr,i4core,intpos,teintf,nal,moa((i-1)*nbl+1,1),
     $           dtol,nbl,chfx,job,j,nbl-j,nbl-j)
          else
c we do not process the i-th batch in this step, therefore the next loop
c should start at i not i+1
            i = i - 1
          endif
          do iblock=i+1,nblock-1
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,
     $           i4core,intpos,teintf,nal,moa((iblock-1)*nbl+1,1),dtol,
     $           nbl,-chfx,job,nbl,1,0)
          enddo
          if(nblock .ge. 2) then
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,
     $           i4core,intpos,teintf,nal,moa((nblock-1)*nbl+1,1),dtol,
     $           nbll,-chfx,job,nbll,1,0)
          endif
        elseif(job .eq. 'f') then
          do iblock=1,nblock-1
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,
     $           i4core,intpos,teintf,nal,moa((iblock-1)*nbl+1,1),dtol,
     $           nbl,chfx,job,nbl,1,0)
          enddo
          call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,i4core,
     $         intpos,teintf,nal,moa((nblock-1)*nbl+1,1),dtol,nbll,chfx,
     $         job,nbll,1,0)
        endif
       else
C Fock-matrices
C First step of the Coulomb + exchange part
        if(job .eq. 'm' .and. nbl .gt. nal/2) then
          ihai2 = dfnbasis*nbasis*nal/2+1
          call dffirst(focka,p,p2,nbasis,dfnbasis,npos,ipos,hai,
     $hai(ihai2),x,x2,cpr,i4core,intpos,teintf,nal,moa,dtol,nbl,chfx,
     $scftype,job,nal/2,nbl-nal/2,nbl-nal/2)
        else
          call dffirst(focka,p,p2,nbasis,dfnbasis,npos,ipos,hai,hai,x,
     $x2,cpr,i4core,intpos,teintf,nal,moa,dtol,nbl,chfx,scftype,job,
     $nbl,1,0)
        endif
C Further steps of the exchange part
        if(job .eq. 'm') then
          i=(nal/2)/nbl+1
          do iblock=2,i-1
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,
     $           i4core,intpos,teintf,nal,moa((iblock-1)*nbl+1,1),
     $           dtol,nbl,chfx,job,nbl,1,0)
          enddo
          if(i .gt. 1) then
            j = nal/2-(i-1)*nbl
            if(j .ne. 0) then
              ihai2 = dfnbasis*nbasis*j+1
              call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai(ihai2),
     $             cpr,i4core,intpos,teintf,nal,moa((i-1)*nbl+1,1),
     $             dtol,nbl,chfx,job,j,nbl-j,nbl-j)
            else
c we do not process the i-th batch in this step, therefore the next loop
c should start at i not i+1
              i = i - 1
            endif
          endif
          do iblock=i+1,nblock-1
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,
     $           i4core,intpos,teintf,nal,moa((iblock-1)*nbl+1,1),dtol,
     $           nbl,-chfx,job,nbl,1,0)
          enddo
        elseif(job .eq. 'f') then
          do iblock=2,nblock-1
            call dfmid(focka,nbasis,dfnbasis,npos,ipos,hai,hai,cpr,
     $           i4core,intpos,teintf,nal,moa((iblock-1)*nbl+1,1),dtol,
     $           nbl,chfx,job,nbl,1,0)
          enddo
        endif
        call intclose(teintf)
        call intopenrsq(teintf)
         if(nblock.gt.1) then
C Second step of the Coulomb part and last step of the exchange part
           if(job .eq. 'm') then
             lq = scftype.eq.2 .or. scftype .eq. 0 .or. scftype .ge. 3
             call dflast(focka,fockb,p,p2,nbasis,dfnbasis,npos,ipos,hai,
     $            hai,x,x2,cpr,i4core,intpos,teintf,nal,
     $            moa((nblock-1)*nbl+1,1),dtol,nbll,-chfx,scftype,
     $            .true.,lq,job,nbll,1,0)
           elseif(job .eq. 'f') then
             call dflast(focka,fockb,p,p2,nbasis,dfnbasis,npos,ipos,hai,
     $            hai,x,x2,cpr,i4core,intpos,teintf,nal,
     $            moa((nblock-1)*nbl+1,1),dtol,nbll,chfx,scftype,
     $            .true.,scftype.eq.2,job,nbll,1,0)
           endif
         else if(nblock.eq.1.and.
     &           (scftype.ge.2.or.(scftype.eq.0.and.job.eq.'m'))) then
C Second step of the Coulomb part and beta exchange part if nblock=1
           do i=1,nbasis
            ss=0.d0
             do ii=1,nbe
              ss=max(ss,dabs(mob(ii,i)))
             enddo
            cpr(i)=ss
           enddo
          if(job .eq. 'm') then
            ihai2 = dfnbasis*nbasis*nbe/2+1
            lq = scftype .eq. 2 .or. scftype .eq. 0 .or. scftype .ge. 3
            call dflast(fockb,focka,p2,p,nbasis,dfnbasis,npos,ipos,hai,
     $           hai(ihai2),x2,x,cpr,i4core,intpos,teintf,nbe,mob(1,1),
     $           dtol,nbe,chfx,scftype,lq,.true.,job,nbe/2,nbe/2,nbe/2)
          elseif(job.eq.'f') then
            call dflast(fockb,focka,p2,p,nbasis,dfnbasis,npos,ipos,hai,
     $           hai,x2,x,cpr,i4core,intpos,teintf,nbe,mob(1,1),dtol,
     $           nbe,chfx,scftype,scftype.eq.2,.true.,job,nbe,1,0)
          endif
          lbeta=.false.
         else
C Second step of the Coulomb part if entire hai is kept in memory
           do ipos=1,npos
            i=intpos(1,ipos)
            j=intpos(2,ipos)
            n=intpos(3,ipos)
            call intreadsq(i4core,n,teintf)
            pp=0.d0
            pp2 = 0.0d0
             do kk=0,n-1
              ssi(1)=i4core(3*kk+1)
              ssi(2)=i4core(3*kk+2)
              k     =i4core(3*kk+3)
              pp=pp+ss*x(k)
              if(job .eq. 'm' .and. (scftype.eq.0.or.scftype.ge.3)) then
                pp2 = pp2 + ss * x2(k)
              endif
             enddo
            focka(i,j)=focka(i,j)+pp
             if(scftype.eq.2) fockb(i,j)=fockb(i,j)+pp
             if((scftype.eq.0.or.scftype.ge.3).and.job.eq.'m') 
     &          fockb(i,j)=fockb(i,j)+pp2
           enddo
         endif
       endif
C
       if(scftype.ge.2 .or. scftype.eq.0) then
        call intclose(teintf)
        call intopenrsq(teintf)
       endif
C
      return
      end
C
************************************************************************
      subroutine dffirst(fock,p,p2,nbasis,dfnbasis,npos,ipos,hai,hai2,x,
     $x2,cpr,i4core,intpos,teintf,nocc,mo,dtol,nbl,chfx,scftype,job,
     $ldhai,ldhai2,n_neg)
************************************************************************
* DF-HF Fock-matrix construction, step 1
************************************************************************
      implicit none
      integer nbasis,dfnbasis,intpos(3,*),npos,ipos,nbl,n_neg,ldhai
      integer i,j,k,l,n,kk,teintf(10),nn,ii,nocc,scftype,ldhai2
      real*8 fock(nbasis,nbasis),p(nbasis,nbasis),ss,dtol,chfx
      real*8 hai(ldhai,dfnbasis,nbasis),cpr(nbasis),mo(nocc,nbasis)
      real*8 pp,pr,x(dfnbasis), hai2(ldhai2,dfnbasis,nbasis)
      real*8 p2(nbasis,nbasis), x2(dfnbasis), pp2
      integer*4 i4core(*),ssi(2)
      character*1 job
      equivalence(ss,ssi)
C Coulomb + exchange part
      pp2 = 0.0d0
      call dfillzero(x,dfnbasis)
      if(job .eq. 'm' .and. (scftype .eq. 0 .or. scftype .ge. 3)) 
     &  call dfillzero(x2,dfnbasis)
      if(dabs(chfx).gt.dtol) then
C We have exchange
        if(job.eq.'f' .or. 
     $    (job.eq.'m' .and. (n_neg.eq.0.or.n_neg.eq.nbl))) then
          call dfillzero(hai,nbl*nbasis*dfnbasis)
          do ipos=1,npos
            i=intpos(1,ipos)
            j=intpos(2,ipos)
            n=intpos(3,ipos)
            call intreadsq(i4core,n,teintf)
            pp=p(i,j)
            if(job .eq.'m'.and.(scftype.eq.0.or.scftype.ge.3))
     &        pp2 = p2(i, j)
            if(max(dabs(pp),dabs(pp2),cpr(i),cpr(j)).gt.dtol) then
              if(i.ne.j) then
                do kk=0,n-1
                  ssi(1)=i4core(3*kk+1)
                  ssi(2)=i4core(3*kk+2)
                  k     =i4core(3*kk+3)
                  x(k)=x(k)+ss*pp
                  if(job .eq.'m'.and.(scftype.eq.0.or.scftype.ge.3))then
                    x2(k) = x2(k) + ss*pp2
                  endif
                  pr=dabs(ss)
                  if(pr*cpr(i).gt.dtol) then
                    do ii=1,nbl
                      hai(ii,k,j)=hai(ii,k,j)+ss*mo(ii,i)
                    enddo
                  endif
                  if(pr*cpr(j).gt.dtol) then
                    do ii=1,nbl
                      hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,j)
                    enddo
                  endif
                enddo
              else
                pp=0.5d0*pp
                pp2 = 0.5d0*pp2
                do kk=0,n-1
                  ssi(1)=i4core(3*kk+1)
                  ssi(2)=i4core(3*kk+2)
                  k     =i4core(3*kk+3)
                  x(k)=x(k)+ss*pp
                  if(job .eq.'m'.and.(scftype.eq.0.or.scftype.ge.3))then
                    x2(k) = x2(k) + ss*pp2
                  endif
                  if(dabs(ss)*cpr(i).gt.dtol) then
                    do ii=1,nbl
                      hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,i)
                    enddo
                  endif
                enddo
              endif
            endif
          enddo
C Second step of the exchange part
          if(n_neg .eq. nbl) then
            call dsyrk('u','t',nbasis,nbl*dfnbasis,-chfx,hai,
     $           nbl*dfnbasis,1.d0,fock,nbasis)
          else
            call dsyrk('u','t',nbasis,nbl*dfnbasis,chfx,hai,
     $           nbl*dfnbasis,1.d0,fock,nbasis)
          endif

        elseif(job.eq.'m' .and. n_neg.ne.0 .and. n_neg.ne.nbl) then
          call dfillzero(hai,ldhai*nbasis*dfnbasis)
          call dfillzero(hai2,ldhai2*nbasis*dfnbasis)
          do ipos=1,npos
            i=intpos(1,ipos)
            j=intpos(2,ipos)
            n=intpos(3,ipos)
            call intreadsq(i4core,n,teintf)
            pp=p(i,j)
            if(scftype .eq. 0 .or. scftype .ge. 3) pp2 = p2(i, j)
            if(max(dabs(pp),dabs(pp2),cpr(i),cpr(j)).gt.dtol) then
              if(i.ne.j) then
                do kk=0,n-1
                  ssi(1)=i4core(3*kk+1)
                  ssi(2)=i4core(3*kk+2)
                  k     =i4core(3*kk+3)
                  x(k)=x(k)+ss*pp
                  if(scftype .eq. 0 .or. scftype .ge. 3)
     &              x2(k) = x2(k) + ss*pp2
                  pr=dabs(ss)
                  if(pr*cpr(i).gt.dtol) then
                    do ii=1,ldhai
                      hai(ii,k,j)=hai(ii,k,j)+ss*mo(ii,i)
                    enddo
                  endif
                  if(pr*cpr(j).gt.dtol) then
                    do ii=1,ldhai
                      hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,j)
                    enddo
                  endif
                  if(pr*cpr(i).gt.dtol) then
                    do ii=ldhai+1, nbl
                      hai2(ii-ldhai,k,j)=hai2(ii-ldhai,k,j)+ss*mo(ii,i)
                    enddo
                  endif
                  if(pr*cpr(j).gt.dtol) then
                    do ii=ldhai+1,nbl
                      hai2(ii-ldhai,k,i)=hai2(ii-ldhai,k,i)+ss*mo(ii,j)
                    enddo
                  endif
                enddo
              else
                pp=0.5d0*pp
                pp2=0.5d0*pp2
                do kk=0,n-1
                  ssi(1)=i4core(3*kk+1)
                  ssi(2)=i4core(3*kk+2)
                  k     =i4core(3*kk+3)
                  x(k)=x(k)+ss*pp
                  if(scftype.eq.0.or.scftype.ge.3) x2(k)=x2(k)+ss*pp2
                  if(dabs(ss)*cpr(i).gt.dtol) then
                    do ii=1,ldhai
                      hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,i)
                    enddo
                  endif
                  if(dabs(ss)*cpr(i).gt.dtol) then
                    do ii=ldhai+1,nbl
                      hai2(ii-ldhai,k,i)=hai2(ii-ldhai,k,i)+ss*mo(ii,i)
                    enddo
                  endif
                enddo
              endif
            endif
          enddo
C Second step of the exchange part
          call dsyrk('u','t',nbasis,ldhai*dfnbasis,chfx,hai,
     $ldhai*dfnbasis,1.d0,fock,nbasis)
          call dsyrk('u','t',nbasis,ldhai2*dfnbasis,-chfx,hai2,
     $ldhai2*dfnbasis,1.d0,fock,nbasis)
        endif
      else
C No exchange
        do ipos=1,npos
          i=intpos(1,ipos)
          j=intpos(2,ipos)
          n=intpos(3,ipos)
          call intreadsq(i4core,n,teintf)
          pp=p(i,j)
          if(job.eq.'m'.and.(scftype.eq.0.or.scftype.ge.3)) pp2=p2(i, j)
          if(max(dabs(pp),dabs(pp2)).gt.dtol) then
            if(i.eq.j) then
              pp=0.5d0*pp
              pp2=0.5d0*pp2
            endif
            do kk=0,n-1
              ssi(1)=i4core(3*kk+1)
              ssi(2)=i4core(3*kk+2)
              k     =i4core(3*kk+3)
              x(k)=x(k)+ss*pp
              if(job.eq.'m'.and.(scftype.eq.0.or.scftype.ge.3)) then
                x2(k) = x2(k) + ss*pp2
              endif
            enddo
          endif
        enddo
      endif
      if(job .eq. 'f') then
        call dscal(dfnbasis,4.d0,x,1)
      elseif(job .eq. 'm') then
        call dscal(dfnbasis,8.d0,x,1)
      endif
C
      return
      end
C
************************************************************************
      subroutine dfmid(fock,nbasis,dfnbasis,npos,ipos,hai,hai2,cpr,
     $i4core,intpos,teintf,nocc,mo,dtol,nbl,chfx,job,ldhai,ldhai2,n_neg)
************************************************************************
* DF-HF Fock-matrix construction, middle steps
************************************************************************
      implicit none
      integer nbasis,dfnbasis,intpos(3,*),npos,ipos,nbl,ldhai,ldhai2
      integer i,j,k,l,n,kk,teintf(10),nn,ii,nocc,n_neg
      real*8 fock(nbasis,nbasis),ss,dtol,chfx
      real*8 hai(ldhai,dfnbasis,nbasis),cpr(nbasis),mo(nocc,nbasis)
      real*8 pp,pr,hai2(ldhai2,dfnbasis,nbasis)
      character*1 job
      integer*4 i4core(*),ssi(2)
      equivalence(ss,ssi)
C Exchange part only
      call intclose(teintf)
      call intopenrsq(teintf)
      if(job.eq.'f' .or. 
     $  (job.eq.'m' .and. (n_neg.eq.0.or.n_neg.eq.nbl))) then
        call dfillzero(hai,nbl*nbasis*dfnbasis)
        do ipos=1,npos
          i=intpos(1,ipos)
          j=intpos(2,ipos)
          n=intpos(3,ipos)
          call intreadsq(i4core,n,teintf)
          if(max(cpr(i),cpr(j)).gt.dtol) then
            if(i.ne.j) then
              do kk=0,n-1
                ssi(1)=i4core(3*kk+1)
                ssi(2)=i4core(3*kk+2)
                k     =i4core(3*kk+3)
                pr=dabs(ss)
                if(pr*cpr(i).gt.dtol) then
                  do ii=1,nbl
                    hai(ii,k,j)=hai(ii,k,j)+ss*mo(ii,i)
                  enddo
                endif
                if(pr*cpr(j).gt.dtol) then
                  do ii=1,nbl
                    hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,j)
                  enddo
                endif
              enddo
            else
              do kk=0,n-1
                ssi(1)=i4core(3*kk+1)
                ssi(2)=i4core(3*kk+2)
                k     =i4core(3*kk+3)
                if(dabs(ss)*cpr(i).gt.dtol) then
                  do ii=1,nbl
                    hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,i)
                  enddo
                endif
              enddo
            endif
          endif
        enddo
C Second step of the exchange part
        call dsyrk('u','t',nbasis,nbl*dfnbasis,chfx,hai,nbl*dfnbasis,
     $1.d0,fock,nbasis)
      elseif(job.eq.'m' .and. n_neg.ne.0 .and. n_neg.ne.nbl) then
        call dfillzero(hai,ldhai*nbasis*dfnbasis)
        call dfillzero(hai2,ldhai2*nbasis*dfnbasis)
        do ipos=1,npos
          i=intpos(1,ipos)
          j=intpos(2,ipos)
          n=intpos(3,ipos)
          call intreadsq(i4core,n,teintf)
          if(max(cpr(i),cpr(j)).gt.dtol) then
            if(i.ne.j) then
              do kk=0,n-1
                ssi(1)=i4core(3*kk+1)
                ssi(2)=i4core(3*kk+2)
                k     =i4core(3*kk+3)
                pr=dabs(ss)
                if(pr*cpr(i).gt.dtol) then
                  do ii=1,ldhai
                    hai(ii,k,j)=hai(ii,k,j)+ss*mo(ii,i)
                  enddo
                endif
                if(pr*cpr(j).gt.dtol) then
                  do ii=1,ldhai
                    hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,j)
                  enddo
                endif
                if(pr*cpr(i).gt.dtol) then
                  do ii=ldhai+1, nbl
                    hai2(ii-ldhai,k,j)=hai2(ii-ldhai,k,j)+ss*mo(ii,i)
                  enddo
                endif
                if(pr*cpr(j).gt.dtol) then
                  do ii=ldhai+1,nbl
                    hai2(ii-ldhai,k,i)=hai2(ii-ldhai,k,i)+ss*mo(ii,j)
                  enddo
                endif
              enddo
            else
              do kk=0,n-1
                ssi(1)=i4core(3*kk+1)
                ssi(2)=i4core(3*kk+2)
                k     =i4core(3*kk+3)
                if(dabs(ss)*cpr(i).gt.dtol) then
                  do ii=1,ldhai
                    hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,i)
                  enddo
                endif
                if(dabs(ss)*cpr(i).gt.dtol) then
                  do ii=ldhai+1,nbl
                    hai2(ii-ldhai,k,i)=hai2(ii-ldhai,k,i)+ss*mo(ii,i)
                  enddo
                endif
              enddo
            endif
          endif
        enddo
C Second step of the exchange part
        call dsyrk('u','t',nbasis,ldhai*dfnbasis,chfx,hai,
     $       ldhai*dfnbasis,1.d0,fock,nbasis)
        call dsyrk('u','t',nbasis,ldhai2*dfnbasis,-chfx,hai2,
     $       ldhai2*dfnbasis,1.d0,fock,nbasis)

      endif

      return
      end
C
************************************************************************
      subroutine dflast(focka,fockb,p,p2,nbasis,dfnbasis,npos,ipos,hai,
     $hai2,x,x2,cpr,i4core,intpos,teintf,nocc,mo,dtol,nbl,chfx,scftype,
     $lq,lb,job,ldhai,ldhai2,n_neg)
************************************************************************
* DF-HF Fock-matrix construction, last step
************************************************************************
      implicit none
      integer nbasis,dfnbasis,intpos(3,*),npos,ipos,nbl,scftype,ldhai
      integer i,j,k,l,n,kk,teintf(10),nn,ii,nocc,ldhai2,n_neg
      real*8 focka(nbasis,nbasis),fockb(nbasis,nbasis),p(nbasis,nbasis)
      real*8 hai(ldhai,dfnbasis,nbasis),cpr(nbasis),mo(nocc,nbasis)
      real*8 pp,pr,ss,x(*),dtol,chfx,hai2(ldhai2,dfnbasis,nbasis)
      real*8 x2(dfnbasis), p2(nbasis,nbasis), pp2
      logical lq,lb
      character*1 job
      integer*4 i4core(*),ssi(2)
      equivalence(ss,ssi)
C Coulomb + exchange part
      if(job.eq.'f' .or. 
     $  (job.eq.'m' .and. (n_neg.eq.0.or.n_neg.eq.nbl))) then
        call dfillzero(hai,nbl*nbasis*dfnbasis)
        do ipos=1,npos
          i=intpos(1,ipos)
          j=intpos(2,ipos)
          n=intpos(3,ipos)
          call intreadsq(i4core,n,teintf)
          pp=0.d0
          pp2 = 0.0d0
          if(i.ne.j) then
            do kk=0,n-1
              ssi(1)=i4core(3*kk+1)
              ssi(2)=i4core(3*kk+2)
              k     =i4core(3*kk+3)
              pp=pp+ss*x(k)
              if(job.eq.'m'.and.(scftype.eq.0.or.scftype.ge.3)) then
                pp2 = pp2 + ss * x2(k)
              endif
              pr=dabs(ss)
              if(pr*cpr(i).gt.dtol) then
                do ii=1,nbl
                  hai(ii,k,j)=hai(ii,k,j)+ss*mo(ii,i)
                enddo
              endif
              if(pr*cpr(j).gt.dtol) then
                do ii=1,nbl
                  hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,j)
                enddo
              endif
            enddo
          else
            do kk=0,n-1
              ssi(1)=i4core(3*kk+1)
              ssi(2)=i4core(3*kk+2)
              k     =i4core(3*kk+3)
              pp=pp+ss*x(k)
              if(job.eq.'m'.and.(scftype.eq.0.or.scftype.ge.3)) then
                pp2 = pp2 + ss * x2(k)
              endif
              if(dabs(ss)*cpr(i).gt.dtol) then
                do ii=1,nbl
                  hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,i)
                enddo
              endif
            enddo
          endif
          if(job.eq.'m'.and.(scftype.eq.0.or.scftype.ge.3)) then
            focka(i, j) = focka(i, j) + pp
            fockb(i, j) = fockb(i, j) + pp2
          else
            if(lq) focka(i,j)=focka(i,j)+pp
            if(lb) fockb(i,j)=fockb(i,j)+pp
          endif
        enddo
C Second step of the exchange part
        if(lq) then
          if(nbl.gt.0) call dsyrk('u','t',nbasis,nbl*dfnbasis,chfx,hai,
     $nbl*dfnbasis,1.d0,focka,nbasis)
        else
          if(nbl.gt.0) call dsyrk('u','t',nbasis,nbl*dfnbasis,-chfx,hai,
     $nbl*dfnbasis,1.d0,focka,nbasis)
        endif
      elseif(job.eq.'m' .and. n_neg.ne.0 .and. n_neg.ne.nbl) then
        call dfillzero(hai,ldhai*nbasis*dfnbasis)
        call dfillzero(hai2,ldhai2*nbasis*dfnbasis)
        do ipos=1,npos
          i=intpos(1,ipos)
          j=intpos(2,ipos)
          n=intpos(3,ipos)
          call intreadsq(i4core,n,teintf)
          pp=0.d0
          pp2 = 0.0d0
          if(i.ne.j) then
            do kk=0,n-1
              ssi(1)=i4core(3*kk+1)
              ssi(2)=i4core(3*kk+2)
              k     =i4core(3*kk+3)
              pp=pp+ss*x(k)
              if(scftype .eq. 0 .or. scftype .ge. 3) then
                pp2 = pp2 + ss * x2(k)
              endif
              pr=dabs(ss)
              if(pr*cpr(i).gt.dtol) then
                do ii=1,ldhai
                  hai(ii,k,j)=hai(ii,k,j)+ss*mo(ii,i)
                enddo
              endif
              if(pr*cpr(j).gt.dtol) then
                do ii=1,ldhai
                  hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,j)
                enddo
              endif
              if(pr*cpr(i).gt.dtol) then
                do ii=ldhai+1, nbl
                  hai2(ii-ldhai,k,j)=hai2(ii-ldhai,k,j)+ss*mo(ii,i)
                enddo
              endif
              if(pr*cpr(j).gt.dtol) then
                do ii=ldhai+1,nbl
                  hai2(ii-ldhai,k,i)=hai2(ii-ldhai,k,i)+ss*mo(ii,j)
                enddo
              endif
            enddo
          else
            do kk=0,n-1
              ssi(1)=i4core(3*kk+1)
              ssi(2)=i4core(3*kk+2)
              k     =i4core(3*kk+3)
              pp=pp+ss*x(k)
              if(job.eq.'m'.and.(scftype.eq.0.or.scftype.ge.3)) then
                pp2 = pp2 + ss * x2(k)
              endif
              if(dabs(ss)*cpr(i).gt.dtol) then
                do ii=1,ldhai
                  hai(ii,k,i)=hai(ii,k,i)+ss*mo(ii,i)
                enddo
              endif
              if(dabs(ss)*cpr(i).gt.dtol) then
                do ii=ldhai+1,nbl
                  hai2(ii-ldhai,k,i)=hai2(ii-ldhai,k,i)+ss*mo(ii,i)
                enddo
              endif
            enddo
          endif
          if(job.eq.'m'.and.(scftype.eq.0.or.scftype.ge.3)) then
            focka(i, j) = focka(i, j) + pp
            fockb(i, j) = fockb(i, j) + pp2
          else
            if(lq) focka(i,j)=focka(i,j)+pp
            if(lb) fockb(i,j)=fockb(i,j)+pp
          endif
        enddo
C Second step of the exchange part
        if(lq) then
          if(nbl.gt.0) then 
            call dsyrk('u','t',nbasis,ldhai*dfnbasis,chfx,hai,
     $           ldhai*dfnbasis,1.d0,focka,nbasis)
            call dsyrk('u','t',nbasis,ldhai2*dfnbasis,-chfx,hai2,
     $           ldhai2*dfnbasis,1.d0,focka,nbasis)
          endif
        else
          if(nbl.gt.0) call dsyrk('u','t',nbasis,nbl*dfnbasis,-chfx,hai,
     $nbl*dfnbasis,1.d0,focka,nbasis)
        endif
      endif
C
      return
      end
************************************************************************
      subroutine df_direct_fock(focka,fockb,p,nbasis,dfnbasis,scftol,
     $nocc,mo,step,iout,natrange,oeintfile,natoms,dcore,icore,imem,
     $nmoat,moat,dfnmobasis,moadd,atmo,natmo,ifile,iimem,scrfile4,lfin,
     $moa,x,ialpha,chfx,varsfile,nbset,scrfile3,maxcor,tedatfile,lwdfn,
     $minpfile,irecln,sclroute,route,hailen,linv,nc,lsexc,ncorenew,caa,
     $devparr,excrad,excrad_fin,llc,scftype,scfiguess,locfit,nmobasis,
     $natdom,atdom,naoat,aoat,atind,clrhfx,csrhfx,omega,qscf_hess)
************************************************************************
* Integral-direct Fock-matrix construction for DF-HF
************************************************************************
      implicit none
      integer nbasis,dfnbasis,iout,imem,ifile,iimem,katoms,lfin
      integer i,j,k,l,n,kk,nn,ii,nocc,step,ierr,scrfile4,ialpha,idfatdom
      integer oeintfile,natoms,is,iv,dfnmobasis(nocc),moadd,hailen,ist
      integer dblalloc,intalloc,icore(*),iipra,natmo(*),idfatind,locfit
      integer isa,ivi,iai,iind,atmo,nmoat(natoms),moat(natoms,nocc)
      integer iover,iiold,icmo,idfnmobasis_old,minpfile,nmobasis(nocc)
      integer naoat(natoms,2),aoat(natoms,nocc),atind,llocfit
      integer varsfile,nbset,scrfile3,maxcor,tedatfile,irecln,idfnatdom
      integer nc,ncore,ncorenew,incorb,inco,ncc1,ncc2,iatdom,lsexc
      integer natdom(nocc),atdom(natoms,nocc),idist,iatoms
      integer natrange(2,natoms,*),nbatdom
      real*8 focka(nbasis,nbasis),p(nbasis,nbasis),temp,ss,ctol,chfx
      real*8 mo(nbasis,nocc),dcore(*),devparr(2),bpcompo,itol
      real*8 scftol,excrad,ddot,pr,moa(nocc,nbasis),clrhfx,csrhfx,omega
      real*8 fockb(nbasis,nbasis),x(dfnbasis),caa(nbasis,nocc-nc)
      real*8 excrad_fin,bpc(5),chargetol
      character*4 cscr4,route
      character*5 scftype
      character*7 scfiguess,scfmodom
      character*16 orbloco,c16
      logical linv,lwdfn,sclroute,llc,qscf_hess
#if defined (MPI)
      include 'mpif.h'
#endif
C Read thresholds
c     write(6,*) 'fock1',chfx
c     write(6,"(13f10.6)") focka
      llocfit=locfit
      call getkey('itol',4,cscr4,4)
      read(cscr4,*) i
      itol=10.d0**(-i)
      ctol=min(itol,scftol/dfloat(dfnbasis*nocc))
       if(sclroute) then
        ncc1=0
        ncc2=nc
         if(route.eq.'emft'.or.route.eq.'sch ')
     $call dcopy(nbasis*(nocc-nc),caa,1,mo,1)
        goto 1236
       endif
      ncc1=0
      ncc2=0
C Initialize MO coefficient matrix
       if(route.eq.'emft'.and.lsexc.eq.0) then
        ncc1=0
        ncc2=nc
         if(route.eq.'emft') call dcopy(nbasis*(nocc-nc),caa,1,mo,1)
       elseif(.not. qscf_hess) then
        open(scrfile3,file='MOA',form='unformatted')
        write(scrfile3) moa
        close(scrfile3)
        call dcopy(nbasis*nocc,moa,1,dcore(imem),1)
        ii=imem
         do j=1,nbasis
          mo(j,1:nocc)=dcore(ii:ii+nocc-1)
          ii=ii+nocc
         enddo
       endif
C No local fitting
      linv=.false.
       do i=1,max(nocc,nocc-nc)
        nmobasis(i)=nbasis
        dfnmobasis(i)=dfnbasis
       enddo
C Local fitting domains
       if(nocc.gt.0.and.excrad.gt.0.d0.and.(chfx.ne.0.d0.or.lfin.eq.2))
     $then
        call getvar('ncore     ',ncore)
         if(.not.llc) ncore=0
        icmo=dblalloc(nbasis**2)
c Lowdin charge criterion for initial fitting domains 
        chargetol=0.1d0
        if (scftype.ne.'rhf  ') chargetol=chargetol/2.d0
C Read S matrix
        is=dblalloc(nbasis**2)
        open(unit=oeintfile,file='OEINT',status='old',
     $form='unformatted')
        call roeint(dcore(imem),dcore(imem),dcore(is),oeintfile,nbasis)
C Initial guess for localization
        ierr=1
         if(lwdfn.and.step.ge.2) then
          iover=dblalloc(nbasis*nocc)
          iiold=intalloc(nocc)
           if(ialpha.le.1) then
            open(scrfile3,file='OLDMO',form='unformatted')
           else
            open(scrfile3,file='OLDMOb',form='unformatted')
           endif
          call rtdmx(dcore(imem+nbasis*nocc),dcore(imem+nbasis*nocc),
     $dcore(imem),scrfile3,nbasis,nocc)
          close(scrfile3)
          call dsymm('l','l',nbasis,nocc,1.d0,dcore(is),nbasis,
     $dcore(imem),nbasis,0.d0,dcore(iover),nbasis)
          call dgemm('t','n',nocc,nocc,nbasis,1.d0,mo,nbasis,
     $dcore(iover),nbasis,0.d0,dcore(icmo),nocc)
          call dsyrk('u','t',nocc,nocc,1.d0,dcore(icmo),nocc,0.d0,
     $dcore(imem),nocc) !Mocskos Intel compiler
          call filllo(dcore(imem),nocc)
          call invsqrt(dcore(imem),nocc,dcore(imem+nbasis*nocc),iout,
     $ierr,0.9d0,1)
           if(ierr.eq.0) then
            call dsymm('r','l',nocc,nocc,1.d0,dcore(imem),nocc,
     $dcore(icmo),nocc,0.d0,dcore(imem+nbasis*nocc),nocc)
            call dgemm('n','n',nbasis,nocc,nocc,1.d0,mo,nbasis,
     $dcore(imem+nbasis*nocc),nocc,0.d0,dcore(imem),nbasis)
            call dcopy(nbasis*nocc,dcore(imem),1,mo,1)
           endif
         endif
C Pipek-Mezey localization
        iv=dblalloc(nbasis*nocc)
        write(iout,*)
        write(iout,*) 'Pipek-Mezey localization...'
C For Boys localization, orbloco=boys molden=off
c         open(scrfile3,file='MOCOEF',form='unformatted')
c         call wrtmo(dcore(imem),dcore(imem),mo,scrfile3,0.,nbasis,nocc)
c         close(scrfile3)
c         call ishell('orbloc')
c         open(scrfile3,file='MOCOEF',form='unformatted')
c         call rtdmx(dcore(imem),dcore(imem),mo,scrfile3,nbasis,nocc)
c         close(scrfile3)
        call pmll(nocc,nbasis,natoms,natrange,dcore(is),mo,dcore(iv),
     $dcore(imem),ierr.ne.0,ifile,step,devparr(1)+devparr(2),iout)
#if defined (MPI)
        call MPI_Bcast(mo,nocc*nbasis,MPI_DOUBLE_PRECISION,0,
     $MPI_COMM_WORLD,i)
#endif
        call timer
C Check overlap with old MOs
         if(ierr.eq.0) then
          call dgemm('t','n',nocc,nocc,nbasis,1.d0,mo,nbasis,
     $dcore(iover),nbasis,0.d0,dcore(imem),nocc)
          call chkover(dcore(imem),mo,dcore(icmo),nbasis,nocc,
     $icore(iiold))
         endif
        close(oeintfile)
C Lowdin charges or Boughton-Pulay algorithm
        isa=dblalloc(nbasis**2)
        ivi=dblalloc(nbasis)
        iai=dblalloc(nbasis)
        iind=intalloc(natoms)
         if(ialpha.le.1) then
          open(scrfile3,file='OLDMO',form='unformatted')
         else
          open(scrfile3,file='OLDMOb',form='unformatted')
         endif
        call wrtmo(dcore(imem),dcore(imem),mo,scrfile3,ctol,nbasis,nocc)
        close(scrfile3)
        ist=6
         if(scfiguess.eq.'mo     '.or.scfiguess.eq.'restart') 
     $ ist=idnint(dble(natoms)/5.d0)
         if(excrad.gt.0.d0.and.(chfx.ne.0.d0.or.lfin.eq.2)) then
           if(locfit.ge.2) then
cnp            open(minpfile,file='MINP')
cnp          call getkeym('scfmodom',8,scfmodom,7)
cnp            if (scfmodom.eq.'       ') scfmodom='bpcompl'
cnp            close(minpfile)
              scfmodom='werner '
cnp              open(unit=oeintfile,file='OEINT',status='old',
cnp     $form='unformatted')
cnp              call roeint(dcore(imem),dcore(imem),dcore(is),oeintfile,
cnp     $nbasis)
cnp              close(oeintfile)
cnp              call dsymm('l','l',nbasis,nocc,1.d0,dcore(is),nbasis,mo,
cnp     $nbasis,0.d0,dcore(iv),nbasis)
            if(scfmodom.eq.'werner '.or.scfmodom.eq.'both   ') then ! Werner-like MO domain construction
c            write(iout,*)
c            write(iout,*)'MO domain criterion: ',min(1.d-6,scftol)
c            if(.false.) then
              naoat=0
              natdom=0
              bpc(3)=2.d0
              bpc(4)=0.d0
              bpc(5)=0.d0
               do i=1,nocc
                 do iatoms=1,natoms
                   if(0.5d0*sum(mo(natrange(1,iatoms,1)+1:
     $natrange(2,iatoms,1),i)**2).gt.min(1d-7,0.1d0*scftol)) then! scftol=1.d-6 by default
                    naoat(iatoms,1)=naoat(iatoms,1)+1
                    aoat(iatoms,naoat(iatoms,1))=i
                    natdom(i)=natdom(i)+1
                    atdom(natdom(i),i)=iatoms
                   endif
                 enddo
cnp              call bpcompleteness(natdom(i),atdom(1,i),dcore(is),
cnp     $dcore(iv),natrange,dcore(isa),dcore(ivi),dcore(iai),bpc(1),
cnp     $dcore(imem),0,0.d0,nbasis,i,.false.,mo,nbatdom)
cnp              call bpcompleteness(natdom(i),atdom(1,i),dcore(is),
cnp     $dcore(iv),natrange,dcore(isa),dcore(ivi),dcore(iai),bpc(2),
cnp     $dcore(imem),0,0.d0,nbasis,i,.true.,mo,nbatdom)
cnp                 write(6,"(2i5,4x,2es16.7,4x,1000i5)") 
cnp     $i,natdom(i),bpc(1)/2.d0,bpc(2)/2.d0,atdom(1:natdom(i),i)
cnp                 bpc(3)=min(bpc(3),bpc(2))
cnp                 bpc(4)=max(bpc(4),bpc(2))
cnp                 bpc(5)=bpc(5)+bpc(2)
               enddo
cnp              write(6,*)
cnp              write(6,"(a23,i6,f10.1,i6,3es16.7)")
cnp     $'Werner min/avg/max atom',
cnp     $minval(natdom(1:nocc)),dble(sum(natdom(1:nocc),nocc))/dble(nocc),
cnp     $maxval(natdom(1:nocc))!,bpc(3)/2.d0,bpc(4)/2.d0,bpc(5)/dble(2*nocc)
            endif
            if(scfmodom.eq.'bpcompl'.or.scfmodom.eq.'both   ') then ! BP MO domain construction
              call timer
              call getkey('bpcompo',7,c16,16)
              read(c16,*) bpcompo
              write(iout,*)
              write(iout,*)'MO domain criterion ',scfmodom,bpcompo
              bpcompo=2.d0*bpcompo
              open(unit=oeintfile,file='OEINT',status='old',
     $form='unformatted')
              call roeint(dcore(imem),dcore(imem),dcore(is),oeintfile,
     $nbasis)
              close(oeintfile)
              call dsymm('l','l',nbasis,nocc,1.d0,dcore(is),nbasis,mo,
     $nbasis,0.d0,dcore(iv),nbasis)
              idist=dblalloc(natoms**2)
              call bopu(nbasis,nocc,natoms,natrange,mo,dcore(iv),
     $icore(iind),dcore(imem),dcore(is),dcore(isa),dcore(ivi),
     $dcore(iai),atdom,naoat,aoat,natdom,bpcompo,bpcompo,nocc,
     $max(30*step,5*ist),'nbp ',icore(iimem),natrange,nbasis,mo,
     $dcore(idist),0,0.d0,0.0d0,.false.,iout,0.05d0)
              call timer
              call dbldealloc(idist)
            endif
c project MOs onto their AO domain 
cnp             if (scfmodom.eq.'bpcompl'.or.scfmodom.eq.'werner '.or.
cnp      $          scfmodom.eq.'both   ') then
cnp               bpc(1)=2.d0
cnp               bpc(2)=0.d0
cnp               bpc(5)=0.d0
cnp              call dfillzero(dcore(icmo),nbasis*nocc)
cnp              do i=1,nocc
cnp c              call bpcompleteness(natdom(i),atdom(1,i),dcore(is),
cnp c     $dcore(iv),natrange,dcore(isa),dcore(ivi),dcore(iai),bpc(3),
cnp c     $dcore(imem),0,0.d0,nbasis,i,.false.,mo,nbatdom)
cnp               call bpcompleteness(natdom(i),atdom(1,i),dcore(is),
cnp      $dcore(iv),natrange,dcore(isa),dcore(ivi),dcore(iai),bpc(4),
cnp      $dcore(imem),0,0.d0,nbasis,i,.true.,mo,nbatdom)
cnp              write(*,'("truncated/projected completeness",i7,2es16.7)'),
cnp      $i,bpc(3)/2.d0,bpc(4)/2.d0
cnp                  bpc(1)=min(bpc(4),bpc(1))
cnp                  bpc(2)=max(bpc(4),bpc(2))
cnp                  bpc(5)=bpc(5)+bpc(4)
cnp               call normalize(nbatdom,1,dcore(iai),dcore(ivi),dcore(is),
cnp      $.true.,2.d0,.true.)
cnp c map back the projected, normalized MO coeffs to the full basis mo
cnp              ii=0
cnp               do katoms=1,natdom(i)
cnp                iatoms=atdom(katoms,i)
cnp                 do nn=natrange(1,iatoms,1)+1,natrange(2,iatoms,1)
cnp                  ii=ii+1
cnp                  dcore(icmo+(i-1)*nbasis+nn-1)=dcore(iai+ii-1)
cnp                 enddo !nn
cnp               enddo! iiatoms
cnp              enddo
cnp               write(6,*)
cnp               write(6,"(a22,i6,f10.1,i6,3es16.7)")
cnp      $'final min/avg/max atom',
cnp      $minval(natdom(1:nocc)),dble(sum(natdom(1:nocc),nocc))/dble(nocc),
cnp      $maxval(natdom(1:nocc)),bpc(1)/2.d0,bpc(2)/2.d0,bpc(5)/dble(2*nocc)
cnp             endif
c
           endif
          open(ifile,file='SROOT',form='UNFORMATTED')
          call roeint(dcore(imem),dcore(imem),dcore(isa),ifile,nbasis)
          close(ifile)
          call dsymm('l','l',nbasis,nocc,1.d0,dcore(isa),nbasis,mo,
     $nbasis,0.d0,dcore(iv),nbasis)
c         call bopu(nbasis,nocc,natoms,natrange,dcore(iv),dcore(iv),
c    $icore(iind),dcore(imem),dcore(isa),dcore(isa),dcore(ivi),
c    $dcore(iai),atdom,naoat,aoat,natdom,0.0000001d0,0.1d0,nocc,natoms,
c    $'lowd',icore(iimem),natrange,nbasis,dcore(iv),dcore(imem),0,0.d0,
c    $0.0d0,.false.,iout,0.05d0)
          call bopu(nbasis,nocc,natoms,natrange,dcore(iv),dcore(iv),
     $icore(iind),dcore(imem),dcore(isa),dcore(isa),dcore(ivi),
     $dcore(iai),atmo,nmoat,moat,natmo,chargetol,chargetol,nocc,
     $max(2*step,ist),'lowd',icore(iimem),natrange,nbasis,dcore(iv),
     $dcore(imem),0,0.d0,0.0d0,.false.,iout,0.05d0)
C Construct domains
          iipra=dblalloc(natoms**2)
          idfnmobasis_old=intalloc(nocc)
          iatdom=intalloc(natoms)
          idfatdom=intalloc(natoms*nocc)
          idfatind=intalloc(natoms*nocc)
          idfnatdom=intalloc(nocc)
          call locdom(nbasis,nocc,natoms,natrange,atmo,nmoat,moat,natmo,
     $excrad,icore(iatdom),dcore(iipra),dfnmobasis,moadd,hailen,
     $dfnbasis,icore(idfnmobasis_old),linv,scrfile4,step,
     $icore(iimem+natoms),iout,scftype,lwdfn,mo,icore(idfatdom),
     $icore(idfnatdom),icore(iimem),icore(idfatind),2,
     $ialpha,llocfit,nmobasis,natdom,atdom,naoat,aoat,atind,scftol)
cnp           if (scfmodom.eq.'bpcompl'.or.scfmodom.eq.'werner '.or.
cnp      $          scfmodom.eq.'both   ') then
cnp c           write(*,*) 'project on MO domain + normalize'
cnp c           call dcopy(nbasis*nocc,dcore(icmo),1,mo,1)
cnp           endif
         endif
        call dbldealloc(icmo)
       endif ! Local fitting domains
1236  continue
       if(lfin.ne.2.and.dabs(excrad-excrad_fin).gt.1d-2*itol) then
         do i=1,nocc
           if(dfnmobasis(i).lt.dfnbasis) lfin=1
         enddo
       endif
C Fock-matrix construction
c     write(6,*) 'p0'
c     write(6,"(7f10.5)") p
c       call dgemm('n','t',nbasis,nbasis,nocc,1.d0,mo,nbasis,mo,nbasis,
c    $0.d0,p,nbasis)
      call direct_fock_build(p,p,focka,fockb,fockb,step,scftype,2,0,1,
     $dcore,dcore,mo(1,ncc1+1),.true.,dcore,dcore,dcore,dcore,hailen,
     $nmoat,moat,moadd,dfnmobasis,ctol,linv,x,ialpha,chfx,
     $iout,varsfile,icore,dcore,nbset,oeintfile,max(1,nocc-ncc2),
     $scrfile3,scrfile4,maxcor,imem,tedatfile,dfnbasis,nbasis,0,
     $dcore,minpfile,.false.,1,dcore,irecln,1,sclroute,0,0,0,
     $devparr(1)+devparr(2),p,1,dcore,0,llocfit,nmobasis,natdom,
     $atdom,naoat,aoat,atind,i,i,clrhfx,csrhfx,omega,.false.,dcore,
     $dcore,dcore,i,qscf_hess,.false.,dcore,.false.)
C Restore moa
       if(((route.ne.'emft'.and.route.ne.'sch ').or.lsexc.gt.0).and.
     $     .not.qscf_hess) then
        open(scrfile3,file='MOA',form='unformatted')
        read(scrfile3) moa
        close(scrfile3,status='delete')
       endif
c     write(6,*) 'fock2',chfx
c     write(6,"(13f10.6)") focka
C
      return
      end
C
C***********************************************************************
      subroutine chkover(over,mo,cmo,nbasis,nocc,iold)
C***********************************************************************
C Check the overlap with old MOs and reorder new MOs accordingly
C***********************************************************************
      implicit none
      integer nbasis,nocc,i,j,jj,iold(nocc)
      real*8 over(nocc,nocc),cmo(nbasis,nocc),mo(nbasis,nocc),maxd
c     write(6,"(23f7.3)") over
C
      call ifillzero(iold,nocc)
      call dcopy(nbasis*nocc,mo,1,cmo,1)
      maxd=0.d0
       do i=1,nocc
        jj=1
         do while(iold(jj).ne.0)
          jj=jj+1
         enddo
         do j=jj+1,nocc
           if(dabs(over(i,j)).gt.dabs(over(i,jj)).and.iold(j).eq.0)then
            jj=j
           endif
         enddo
        iold(jj)=i
         if(i.ne.jj) call dcopy(nbasis,cmo(1,i),1,mo(1,jj),1)
        maxd=max(maxd,2.d0-dabs(over(i,jj)))
       enddo
C
      return
      end
C
C***********************************************************************
      subroutine reordch(nbasis,nocc,cmo,mo,jpvt)
C***********************************************************************
C Reorder Cholesky vectors
C***********************************************************************
      implicit none
      integer nbasis,nocc,i,j,jpvt(nbasis)
      real*8 mo(nbasis,nocc),cmo(nbasis,nbasis)
C
         do i=1,nbasis
           do j=i,nbasis
            cmo(j,i)=cmo(i,j)
             if(i.ne.j) cmo(i,j)=0.d0
           enddo
         enddo
         do j=1,nocc
           do i=1,nbasis
            mo(jpvt(i),j)=cmo(i,j)
           enddo
         enddo
C
      return
      end
C
C***********************************************************************
      subroutine huzinaga(nbasis,rs,s,c,scrfile1,minpfile,natrange,work,
     $iout,nfroz,nal,nbe,natoms,aotomo,marking)
C***********************************************************************
C Construct projector for Huzinaga equations
C***********************************************************************
      implicit none
      integer nbasis,i,j,k,mmbond,imbond,scrfile1,nc,ii,imo,minpfile
      integer natoms,iatoms,at1,at2,natrange(2,*),nfroz,mu,iout
      integer flag1(natoms),flag2(natoms),scrint1a(natoms),locmin
      integer natomsm,flag1m(natoms),flag2m(natoms),scrinta,scrintb
      integer nsatom,isatom(natoms),nal,nbe,nbf_trumo(nal+nbe)
      integer naotomo(nal+nbe),aotomo((nal+nbe),natoms)
      integer marking(nal+nbe,natoms)
      real*8 rs(*),s(nbasis,nbasis),c(nbasis,nbasis)
      real*8 x(natoms),y(natoms),z(natoms)
      real*8 work(nbasis,*)
      character*2 c2(natoms),c2m(natoms)
      character*8 cscr
C
      call getvar('natrange  ',natrange)
      call getvar('mmbond    ',mmbond)
      call dfillzero(c,nbasis**2)
C
      nfroz=0
      nsatom=0
      open(minpfile,file='MINP')
       do imbond=1,mmbond
        nsatom=0
        call getkeym('geom',4,cscr,4)
        read(minpfile,*) natoms
        read(minpfile,*)
         do iatoms=1,natoms
          read(minpfile,*) c2(iatoms),
     $                      x(iatoms),
     $                      y(iatoms),
     $                      z(iatoms),
     $                  flag1(iatoms),
     $                  flag2(iatoms)
           if(flag1(iatoms).eq.imbond) then
            nsatom=nsatom+1
            isatom(flag2(iatoms))=iatoms
           endif
         enddo
        write(cscr,'(i8)') imbond
        open(scrfile1,file='MOCOEF.' // trim(adjustl(cscr)),
     $form='unformatted')
         read(scrfile1) nc
         do imo=1,nc
          nfroz=nfroz+1
          marking(imo,:)=0
          read(scrfile1) nbf_trumo(imo)
          read(scrfile1) naotomo(imo)
          read(scrfile1) (marking(imo,ii), ii=1,naotomo(imo))
C Sort flags and at the same time the aotomo array to avoid the mixing of AOs
C Note: this is only important when the model system is smaller than the current system
C       e.q. trunc=nsatom
          k=0
          do iatoms=1,natoms
           do j=1,naotomo(imo)
            if(flag1(iatoms).eq.imbond) then
             if(flag2(iatoms).eq.marking(imo,j)) then
              k=k+1
              aotomo(imo,k)=iatoms
             endif
            endif
           enddo
          enddo
          k=0
          do i=1,naotomo(imo)
           do iatoms=1,natoms
            if(aotomo(imo,i).eq.iatoms) then
             k=k+1
             scrint1a(k)=flag2(iatoms)
            endif
           enddo
          enddo
          do i=1,naotomo(imo)-1
           locmin=i-1+minloc(scrint1a(i:naotomo(imo)),1)
           scrinta=scrint1a(i)
           scrintb=aotomo(imo,i)
           scrint1a(i)=scrint1a(locmin)
           aotomo(imo,i)=aotomo(imo,locmin)
           scrint1a(locmin)=scrinta
           aotomo(imo,locmin)=scrintb
          enddo
          read(scrfile1) (rs(i),i=1,nbf_trumo(imo))
          ii=0
          do i=1,naotomo(imo)
           do mu=natrange(1,aotomo(imo,i))+1,natrange(2,aotomo(imo,i))
            ii=ii+1
            c(mu,nfroz)=rs(ii)
           enddo
          enddo
         enddo
        close(scrfile1)
       enddo
      close(minpfile)
C Calculate overlap matrix of frozen MOs
      call dsymm('l','l',nbasis,nfroz,1.d0,s,nbasis,c,nbasis,0.d0,work,
     $nbasis)
      call dgemm('t','n',nfroz,nfroz,nbasis,1.d0,c,nbasis,work,nbasis,
     $0.d0,rs,nfroz)
C Calculate the inverse square root of the overlap matrix
      call invsqrt(rs,nfroz,work,iout,i,1d-12,1)
       if(i.ne.0) then
        write(iout,*) 
     $'Fatal error at the calculation of inverse square root!'
        call mrccend(1)
       endif
C C*S^(-1/2)
      call dsymm('r','l',nbasis,nfroz,1.d0,rs,nfroz,c,nbasis,0.d0,work,
     $nbasis)
C Construct projector R (C*S(-1/2)*S(-1/2)*C')
      call dsyrk('u','n',nbasis,nfroz,1.d0,work,nbasis,0.d0,c,nbasis)
      call filllo(c,nbasis)
      open(scrfile1,file='HUZPROJ',form='unformatted')
      write(scrfile1) nfroz
      call woeint(work,work,c,scrfile1,0.d0,nbasis)
      close(scrfile1)
C Construct RS
      call dsymm('l','u',nbasis,nbasis,1.d0,c,nbasis,s,nbasis,0.d0,rs,
     $nbasis)
C
      return
      end
C
************************************************************************
      subroutine huzproj(nbasis,fock,rs,work)
************************************************************************
* Huzinaga's projector
************************************************************************
      implicit none
      integer nbasis
      real*8 fock(nbasis,nbasis),rs(nbasis,nbasis),work(nbasis,nbasis)
C
C      write(6,*) 'rs'
C      write(6,"(11f10.5)") rs(1:nbasis,1:nbasis)
      call dcopy(nbasis**2,fock,1,work,1)
      call dsyr2k('u','t',nbasis,nbasis,-1.d0,rs,nbasis,work,nbasis,
     $1.d0,fock,nbasis)
      call filllo(fock,nbasis)
c     call dsymm('l','u',nbasis,nbasis,1.d0,work,nbasis,rs,nbasis,0.d0,
c    $work(1,nbasis+1),nbasis)
c     call dgemm('t','n',nbasis,nbasis,nbasis,1.d0,rs,nbasis,
c    $work(1,nbasis+1),nbasis,1.d0,fock,nbasis)
c
c      write(6,*) 'fock new'
c      write(6,"(11f10.5)") fock
C
      return
      end
C
************************************************************************
      subroutine huzord(nbasis,c,rs,eig,work,scrs,scre,iout,nfroz,s,
     $nbfroz,qmreg,route,nal,nbe,huzproja,schroute,subsys) ! HB
************************************************************************
* Move frozen orbitals to the beginning in the case of Huzinaga eqs
************************************************************************
      implicit none
      character*1 subsys
      integer nbasis,i,ii,jj,nfroz,iout,nbfroz ! HB
      integer k,l,sloop,eloop,q,nal,nbe,scrfile1
      real*8 c(nbasis,nbasis),rs(nbasis,nbasis),work(nbasis,nbasis)
      real*8 eig(nbasis),scre(nbasis),ddot
      real*8 s(nbasis,nbasis),itol
      real*8 huzproja(nbasis,nbasis)
      real*8 tmp,maxlap,minlap,scrs(nbasis)
      character*4 route
      character*4 schroute
      character*8 cscr,qmreg
! Sort orbitals of the environment
      call dgemm('n','n',nbasis,nbasis,nbasis,1.d0,rs,nbasis,c,nbasis,
     $0.d0,work(1,nbasis+1),nbasis)
      call dsymm('l','u',nbasis,nbasis,1.d0,s,nbasis,work(1,nbasis+1),
     $nbasis,0.d0,work,nbasis)
      tmp=0.0d0
      scre=0.0d0
      scrs=0.0d0
      do i=1,nbasis
       scre(i)=ddot(nbasis,work(1,i),1,c(1,i),1)
      enddo
      do i=1,nbasis
       ii=maxloc(scre(i:nbasis),1)+i-1
       tmp=eig(i)
       eig(i)=eig(ii)
       eig(ii)=tmp
       scrs(1:nbasis)=c(1:nbasis,i)
       c(1:nbasis,i)=c(1:nbasis,ii)
       c(1:nbasis,ii)=scrs(1:nbasis)
       tmp=scre(i)
       scre(i)=scre(ii)
       scre(ii)=tmp
      enddo
      do q=1,2
       if(q.eq.1) then
        sloop=1
        eloop=nfroz
       else 
        sloop=nfroz+1
        eloop=nbasis
       endif
       do i=sloop,eloop
        if(subsys.eq.'A') then
         if(q.eq.1) ii=maxloc(eig(i:eloop),1)+i-1
         if(q.eq.2) ii=minloc(eig(i:eloop),1)+i-1
        else
         if(q.eq.1) ii=minloc(eig(i:eloop),1)+i-1
         if(q.eq.2) ii=maxloc(eig(i:eloop),1)+i-1
        endif
        tmp=eig(i)
        eig(i)=eig(ii)
        eig(ii)=tmp
        scrs(1:nbasis)=c(1:nbasis,i)
        c(1:nbasis,i)=c(1:nbasis,ii)
        c(1:nbasis,ii)=scrs(1:nbasis)
        tmp=scre(i)
        scre(i)=scre(ii)
        scre(ii)=tmp 
       enddo 
      enddo
c      write(6,'(a)') 'Reordered orbitals:'
c      write(6,'(a)') '(projector contains the environment subsystem)'
c      write(6,'(a,i,a,i)') 'nfroz = ',nfroz,' nocc = ',(nal+nbe)/2
c      do i=1,nbasis
c       if(scre(i).gt.0.1d0.and.i.gt.nfroz) then
c        write(6,'(a,i4,a,f20.15,a,f10.5,a)')
c     $'MO = ',i,' overlap = ',scre(i),
c     $' eig = ',eig(i),' INTRUDER STATE !'
c       else
c       write(6,'(a,i4,a,f20.15,a,f10.5)') 
c     $'MO = ',i,' overlap = ',scre(i),
c     $' eig = ',eig(i)
c       endif
c       if(i.eq.nfroz) write(6,*)
c       if(i.eq.(nal+nbe)/2) write(6,*)
c      enddo
c      write(6,*)
c      write(6,'(a)') 'Environment orbital with the least overlap:'
      i=minloc(scre(1:nfroz),1)
      minlap=scre(i)
c      write(6,'(a,i4,a,f20.15,a,f10.5)')
c     $'MO = ',i,' overlap = ',scre(i),' eig = ',eig(i)
c      write(6,'(a)') 'Non-environmental 
c     $orbital with the largest overlap:'
      i=maxloc(scre(nfroz+1:nbasis),1)+nfroz
      maxlap=scre(i)
c      write(6,'(a,i4,a,f20.15,a,f10.5)')
c     $'MO = ',i,' overlap = ',scre(i),
c     $' eig = ',eig(i)
      if(nfroz.ne.0.and.nfroz.ne.((nal+nbe)/2)) then
       if(maxlap.gt.0.1d0) then
        write(6,'(a)') 'Warning! Intruder states are detected!'
        write(6,'(a)') 'This can cause convergence problems.'
        write(6,'(a,f10.5)') 'The largest overlap amongst 
     $intruder states: ',maxlap
       endif
       tmp=maxlap-minlap
       if(abs(tmp).lt.0.1d0) then
        write(6,*)
        write(6,'(a)') 'Warning! Non-environmental orbitals critically
     $ overlap with the projector.'
        write(6,'(a)') 'This can cause convergence problems.'
        write(6,'(a,f10.5)') 'Difference of orbital overlaps = ',
     $  abs(tmp)
        write(6,*)
        if(schroute.ne.'rest') schroute='term'
       endif
      endif
! sort the rest of the occupied orbitals
      if(route.eq.'sch') then
       call dgemm('n','n',nbasis,nbasis,nbasis,1.d0,huzproja,
     $nbasis,c,nbasis,
     $0.d0,work(1,nbasis+1),nbasis)
       call dsymm('l','u',nbasis,nbasis,1.d0,s,nbasis,work(1,nbasis+1),
     $nbasis,0.d0,work,nbasis)
       tmp=0.0d0
       scre=0.0d0
       scrs=0.0d0
       tmp=0.0d0
       do i=nfroz+1,nbasis
        scre(i)=ddot(nbasis,work(1,i),1,c(1,i),1)
       enddo
       do i=nfroz+1,nbasis
        ii=maxloc(scre(i:nbasis),1)+i-1
        tmp=eig(i)
        eig(i)=eig(ii)
        eig(ii)=tmp
        scrs(1:nbasis)=c(1:nbasis,i)
        c(1:nbasis,i)=c(1:nbasis,ii)
        c(1:nbasis,ii)=scrs(1:nbasis)
        tmp=scre(i)
        scre(i)=scre(ii)
        scre(ii)=tmp
       enddo
       do q=1,2
        if(q.eq.1) then
         sloop=nfroz+1
         eloop=(nal+nbe)/2
        else 
         sloop=(nal+nbe)/2+1
         eloop=nbasis
        endif
        do i=sloop,eloop
         if(subsys.eq.'A') then
          ii=minloc(eig(i:eloop),1)+i-1
         else
          ii=maxloc(eig(i:eloop),1)+i-1
         endif
         tmp=eig(i)
         eig(i)=eig(ii)
         eig(ii)=tmp
         scrs(1:nbasis)=c(1:nbasis,i)
         c(1:nbasis,i)=c(1:nbasis,ii)
         c(1:nbasis,ii)=scrs(1:nbasis)
         tmp=scre(i)
         scre(i)=scre(ii)
         scre(ii)=tmp
        enddo 
       enddo
c       write(6,'(a)') 'Reordered orbitals:'
c       write(6,'(a)') '(projector contains the active subsystem)'
c       write(6,'(a,i,a,i)') 'nfroz = ',nfroz,' nocc = ',(nal+nbe)/2
c       do i=1,nbasis
c        if((scre(i).gt.0.1d0).and.
c     $((i.gt.(nal+nbe)/2).or.(i.lt.nfroz))) then
c         write(6,'(a,i4,a,f20.15,a,f10.5,a)')
c     $'MO = ',i,' overlap = ',scre(i),
c     $' eig = ',eig(i),' INTRUDER STATE !'
c        else
c         write(6,'(a,i4,a,f20.15,a,f10.5)') 
c     $'MO = ',i,' overlap = ',scre(i),
c     $' eig = ',eig(i)
c        endif
c        if(i.eq.nfroz) write(6,*)
c        if(i.eq.(nal+nbe)/2) write(6,*)
c       enddo
c       write(6,*)
c       write(6,'(a)') 'Active orbital with the least overlap:'
       i=minloc(scre(nfroz+1:(nal+nbe)/2),1)+nfroz
       minlap=scre(i)
c       write(6,'(a,i4,a,f20.15,a,f10.5)')
c     $'MO = ',i,' overlap = ',scre(i),' eig = ',eig(i)
c       write(6,'(a)') 'Unoccupied orbital with the largest overlap:'
       i=maxloc(scre((nal+nbe)/2+1:nbasis),1)+(nal+nbe)/2
       maxlap=scre(i)
c       write(6,'(a,i4,a,f20.15,a,f10.5)')
c     $'MO = ',i,' overlap = ',scre(i),
c     $' eig = ',eig(i)
       if(nfroz.ne.0.and.nfroz.ne.((nal+nbe)/2)) then
        if(maxlap.gt.0.1d0) then
         write(6,'(a)') 'Warning! Intruder states are detected!' 
         write(6,'(a)') 'This can cause convergence problems.'
         write(6,'(a,f10.5)') 'The largest overlap amongst 
     $intruder states: ',maxlap
        endif
        tmp=maxlap-minlap
        if(abs(tmp).lt.0.1d0) then
         write(6,*)
         write(6,'(a)') 'Warning! Unoccupied orbitals critically
     $ overlap with the projector.'
         write(6,'(a)') 'This can cause convergence problems.'
         write(6,'(a,f10.5)') 'Difference of orbital overlaps = ',
     $abs(tmp)
         write(6,*)
         if(schroute.ne.'rest') schroute='term'
        endif
       endif
      endif
!!!
CCC start HB
C     Huzinaga QM/MM+embedding 2nd SCF run (3rd scf call)
      if(qmreg.eq.'0       '.and.route.eq.'em3 ') then
       do i=1,nbfroz
         if(eig(i).gt.0.d0) then
          write(cscr,'(i8)') i
          write(iout,*) 'Warning! The orbital energy of frozen boundary 
     $orbital '// trim(adjustl(cscr)) // ' is positive!'
         endif
       enddo
      endif
C     Huzinaga QM/MM or embedding or Huzinaga QM/MM+embedding 1st SCF run
      if(subsys.eq.'A') then
      do i=nbfroz+1,nfroz
       if(eig(i).lt.0.d0) then
        write(cscr,'(i8)') i
        write(iout,*) 'Warning! The orbital energy of frozen orbital '
     $// trim(adjustl(cscr)) // ' is negative!'
       endif
      enddo
      else if(subsys.eq.'B') then
       do i=nfroz+1,nal
       if(eig(i).lt.0.d0) then
        write(cscr,'(i8)') i
        write(iout,*) 'Warning! The orbital energy of frozen orbital '
     $// trim(adjustl(cscr)) // ' is negative!'
       endif
      enddo
      endif 
CCC end HB
C
      return
      end
C
************************************************************************
      subroutine schmidt(n,m,c,s,work)
************************************************************************
* Gram-Schmidt orthonormalization in metric
************************************************************************
      implicit none
      integer n,m,i
      integer*4 ii
      equivalence(i,ii)
      real*8 c(n,m),s(n,n),work(2*n*m)
C
       if(m.eq.0) return
      ii=0
      call dsymm('l','l',n,m,1.d0,s,n,c,n,0.d0,work(m*m+1),n)
      call dgemm('t','n',m,m,n,1.d0,c,n,work(m*m+1),n,0.d0,work,m)
      call dpotrf('l',m,work,m,ii)
       if(ii.ne.0) goto 9876
      call dtrtri('l','n',m,work,m,ii)
       if(ii.ne.0) goto 9876
      call dtrmm('r','l','t','n',n,m,1.d0,work,m,c,n)
C
      return
9876  write(6,*) 'Fatal error at the Schmidt orthogonalization!'
      call mrccend(1)
      end
C
************************************************************************
      subroutine readone(mat,ifile,symtra,nbasis,r8heap,offset,lsa)
************************************************************************
* Read and compress one-electron integrals
************************************************************************
      implicit none
      integer ifile,nbasis,offset,ii
      real*8 mat(nbasis,nbasis),symtra(nbasis,nbasis),r8heap(*)
      logical lsa
C
       if(lsa) then
        ii=nbasis*nbasis+1
        call roeint(r8heap(ii),r8heap(ii),r8heap,ifile,nbasis)
        call mxts(r8heap,symtra,r8heap(ii),nbasis,mat,offset,lsa)
       else
        call roeint(r8heap,r8heap,mat,ifile,nbasis)
       endif
C
      return
      end
C
************************************************************************
      subroutine mxts(mat1,symtra,r8heap,nbasis,mat2,offset,lsa)
************************************************************************
* Transform one-electron quantities to symmetry basis
************************************************************************
      implicit none
      integer nbasis,offset
      real*8 mat1(nbasis,nbasis),mat2(nbasis,nbasis)
      real*8 symtra(nbasis,nbasis),r8heap(*)
      logical lsa
C
       if(.not.lsa) return
      call mx_basis_tr(mat1,symtra,r8heap,'TS',nbasis)
      call mx_symm_compr(mat1,mat2,offset)
C
      return
      end
C
************************************************************************
      subroutine mxto(mat1,symtra,r8heap,nbasis,mat2,offset,lsa)
************************************************************************
* Transform one-electron quantities to symmetry basis
************************************************************************
      implicit none
      integer nbasis,offset
      real*8 mat1(nbasis,nbasis),mat2(nbasis,nbasis)
      real*8 symtra(nbasis,nbasis),r8heap(*)
      logical lsa
C
       if(.not.lsa) return
      call mx_symm_extr(mat1,mat2,offset)
      call mx_basis_tr(mat1,symtra,r8heap,'TO',nbasis)
C
      return
      end
C
************************************************************************
      subroutine moto(mat1,symtra,r8heap,nbasis,mat2,offset,lsa)
************************************************************************
* Transform one-electron quantities to symmetry basis
************************************************************************
      implicit none
      integer nbasis,offset
      real*8 mat1(nbasis,nbasis),mat2(nbasis,nbasis)
      real*8 symtra(nbasis,nbasis),r8heap(*)
      logical lsa
C
       if(lsa) then
        call mx_symm_extr(r8heap,mat2,offset)
        call dgemm('n','n',nbasis,nbasis,nbasis,1.d0,symtra,nbasis,
     $r8heap,nbasis,0.d0,mat1,nbasis)
       else
        call dcopy(nbasis*nbasis,mat2,1,mat1,1) !Do not touch
       endif
C
      return
      end
C
************************************************************************
      subroutine purify(pa,pb,nbasis,nal,nbe,c,scr1,scr2,nooccfl,
     $orbperira,orbperirb,nir,nfunc,sqrsize,offset,sqroffset,indexirrep,
     $mapping,nf,scftype,scrfile1,symtra,lsa,nfuns,ndao)
************************************************************************
* Purify density matrix
************************************************************************
      implicit none
      integer nb,nal,nbe,i,nir,offset(nir),sqroffset(nir),orbperira(nir)
      integer nfunc(nir),sqrsize,nbasis,iisyev,indexirrep(nbasis),nf,ne
      integer mapping(nbasis),scftype,nfa,nfb,orbperirb(nir),scrfile1
      integer nfuns(nir),ndao
      real*8 pa(sqrsize),c(sqrsize),scr1(sqrsize)
      real*8 scr2(sqrsize),ddot,pb(sqrsize),symtra
      logical nooccfl,lsa
      integer*4 isyev
      equivalence(isyev,iisyev)
#if defined (MPI)
      include 'mpif.h'
#endif
C
      call lindep(pa,1,nfunc,nfuns,nir,ndao,scr1,scr2,scrfile1,sqrsize,
     $sqroffset)
      open(scrfile1,file='SROOT',form='unformatted')
      call readone(scr1,scrfile1,symtra,nbasis,scr2,offset,lsa)
C
       do i=1,nir
        nb=nfunc(i)
         if(nb.gt.0) then
          call dsymm('l','l',nb,nb,1.d0,pa(sqroffset(i)),nb,
     $scr1(sqroffset(i)),nb,0.d0,scr2,nb)
          call dsymm('l','l',nb,nb,-1.d0,scr1(sqroffset(i)),nb,scr2,nb,
     $0.d0,c(sqroffset(i)),nb)
          call dsyev('V','U',nb,c(sqroffset(i)),nb,scr1(offset(i)),
     $scr2,3*nb*nb,isyev)
           if(isyev.ne.0) call mrccend(1)
         endif
       enddo
c     write(6,*) 'puri'
c     write(6,"(5f14.10)") scr1(1:nbasis)
C
       if(nooccfl) then
        call qsortd(mapping,nbasis,scr1)
        orbperira=0
         if(scftype.ge.3) then
           do i=1,nbe
            orbperira(indexirrep(mapping(i)))=
     $      orbperira(indexirrep(mapping(i)))+1
           enddo
           do i=nbe+1,nal
            orbperirb(indexirrep(mapping(i)))=
     $      orbperirb(indexirrep(mapping(i)))+1
           enddo
         else
           do i=1,nal
            orbperira(indexirrep(mapping(i)))=
     $      orbperira(indexirrep(mapping(i)))+1
           enddo
           if(scftype.ne.1) then
            orbperirb=0
             do i=1,nbe
              orbperirb(indexirrep(mapping(i)))=
     $        orbperirb(indexirrep(mapping(i)))+1
             enddo
           endif
         endif
       endif
C
      call readone(scr1,scrfile1,symtra,nbasis,scr2,offset,lsa)
      close(scrfile1)
      nfa=nf
      nfb=nf
       if(scftype.ge.3) then
        nfa=2
        nfb=1
       endif
       do i=1,nir
        nb=nfunc(i)
        ne=orbperira(i)
         if(nb.gt.0) then
          call dsymm('l','u',nb,nb,1.d0,scr1(sqroffset(i)),nb,
     $c(sqroffset(i)),nb,0.d0,scr2,nb)
          call dcopy(nb*nb,scr2,1,c(sqroffset(i)),1)
         endif
         if(nb.gt.0.and.ne.gt.0) then
          call dsyrk('u','n',nb,ne,dble(nfa),c(sqroffset(i)),nb,0.d0,
     $pa(sqroffset(i)),nb)
          call filllo(pa(sqroffset(i)),nb)
c         call dscal(nb*nb,dble(nfa*ne)/ddot(nb*nb,pa(sqroffset(i)),1,
c    $s(sqroffset(i)),1),pa(sqroffset(i)),1)
         else
          pa(sqroffset(i):sqroffset(i)+nb*nb-1)=0.d0
         endif
         if(scftype.ne.1) then
          ne=orbperirb(i)
           if(nb.gt.0.and.ne.gt.0) then
             if(scftype.eq.2) then
              call dsyrk('u','n',nb,ne,1.d0,c(sqroffset(i)),nb,0.d0,
     $pb(sqroffset(i)),nb)
             else
              call dsyrk('u','n',nb,ne,dble(nfb),
     $c(sqroffset(i)+orbperira(i)*nb),nb,0.d0,pb(sqroffset(i)),nb)
             endif
            call filllo(pb(sqroffset(i)),nb)
c           call dscal(nb*nb,dble(nfb*ne)/ddot(nb*nb,pb(sqroffset(i)),1,
c    $s(sqroffset(i)),1),pb(sqroffset(i)),1)
           else
            pb(sqroffset(i):sqroffset(i)+nb*nb-1)=0.d0
           endif
         endif
       enddo
       if(scftype.ge.3) call daxpy(sqrsize,1.d0,pb,1,pa,1)
#if defined (MPI)
      call MPI_Bcast(c,sqrsize,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD,i)
#endif
C
      return
      end 
C
************************************************************************
      subroutine fdmorb(nbasis,nb,no,natoms,sold,s,dold,d,fold,f,cold,
     $c,eig,scr1,scr2,scr3,minpfile,scrfile1,natrange,coord,verbosity,
     $cks,nocc)
************************************************************************
* Construct orbitals in the case of FDM embedding
************************************************************************
      implicit none
      integer nbasis,nb,nv,no,natoms,ind(natoms),natrange(2,natoms),i
      integer minpfile,scrfile1,natomsn,verbosity,nsp,nocc
      real*8 sold(nbasis,nbasis),s(nb,nb),fold(nbasis,nbasis),f(nb,nb)
      real*8 dold(nbasis,nbasis),d(nb,nb),cold(nbasis,nbasis),c(nb,nb)
      real*8 scr1(nb,nb),scr2(nb,nb),scr3(nb,nb),eig(nb),coord(3,natoms)
      real*8 lshift,cks(nbasis,nbasis)
      parameter(lshift=1000000.d0)
      character*2 atsymbol(natoms)
C Read atoms of embedded subsystem
      open(minpfile,file='MINP')
      call embedat(natoms,minpfile,ind,6)
      close(minpfile)
C Compress matrices
      call subsmat(natoms,nbasis,nb,fold,f,ind,natrange)
      call subsmat(natoms,nbasis,nb,dold,d,ind,natrange)
      call subsmat(natoms,nbasis,nb,sold,s,ind,natrange)
C Construct PAOs
      call dsymm('l','l',nb,nb,-0.5d0,d,nb,s,nb,0.d0,c,nb)
       do i=1,nb
        c(i,i)=c(i,i)+1.d0
       enddo
C Remove linearly dependent PAOs and orthogonalize
      nv=nb-no
      call dsymm('l','l',nb,nb,1.d0,s,nb,c,nb,0.d0,scr1,nb)
      call dgemm('t','n',nb,nb,nb,1.d0,c,nb,scr1,nb,0.d0,scr2,nb)
      call dsyev('V','U',nb,scr2,nb,eig,scr3,3*nb**2,i)
       do i=no+1,nb
        call dscal(nb,1.d0/dsqrt(eig(i)),scr2(1,i),1)
       enddo
      call dgemm('n','n',nb,nv,nb,1.d0,c,nb,scr2(1,no+1),nb,0.d0,
     $scr1(1,no+1),nb)
C Compress MO coefficients
      call subsvec(natoms,nbasis,nb,no,cold,scr1,ind,natrange)
C Canonicalize orbitals
      call dsymm('l','u',nb,nb,1.d0,f,nb,scr1,nb,0.d0,scr3,nb)
      call dgemm('t','n',nb,nb,nb,1.d0,scr1,nb,scr3,nb,0.d0,scr2,nb)
      call dsyev('V','U',no,scr2,nb,eig,scr3,3*nb**2,i)
      call dsyev('V','U',nv,scr2(no+1,no+1),nb,eig(no+1),scr3,3*nb**2,i)
      call dgemm('n','n',nb,no,no,1.d0,scr1,nb,scr2,nb,0.d0,c,nb)
      call dgemm('n','n',nb,nv,nv,1.d0,scr1(1,no+1),nb,scr2(no+1,no+1),
     $nb,0.d0,c(1,no+1),nb)
C Remove spurious occupied orbitals
      nsp=0
      i=no+1
       do while(i.le.nb.and.eig(i).lt.0.d0)
        i=i+1
        nsp=nsp+1
       enddo
       if(nsp.gt.0) then
         if(verbosity.ge.3) then
          write(6,*)
          write(6,*) 'Number of spurious occupied orbitals:',nsp
          write(6,*)
     $'Original orbital energies in embedded subsystem [au]:'
          write(6,"(7f10.6)") eig
         endif
        call dsyrk('u','n',nb,nsp,1.d0,c(1,no+1),nb,0.d0,scr1,nb)
        call dsymm('l','u',nb,nb,1.d0,scr1,nb,s,nb,0.d0,scr2,nb)
        call dsymm('l','u',nb,nb,lshift,s,nb,scr2,nb,1.d0,f,nb)
        call dcopy(nb*nsp,c(1,no+1),1,scr1,1)
         do i=1,nv-nsp
          c(1:nb,no+i)=c(1:nb,no+nsp+i)
         enddo
        call dcopy(nb*nsp,scr1,1,c(1,nb-nsp+1),1)
        call dcopy(nsp,eig(no+1),1,scr1,1)
         do i=1,nv-nsp
          eig(no+i)=eig(no+nsp+i)
         enddo
        call dcopy(nsp,scr1,1,eig(nb-nsp+1),1)
         do i=nb-nsp+1,nb
          eig(i)=eig(i)+lshift
         enddo
       endif
C Save new MO coefficients and Fock matrix
      open(scrfile1,file='MOCOEF',form='unformatted')
      call wrtmo(scr1,scr1,c,scrfile1,0.d0,nb,nb)
      close(scrfile1)
      open(scrfile1,file='FOCK',form='unformatted')
      call woeint(scr1,scr1,f,scrfile1,0.d0,nb)
      write(scrfile1) (eig(i),i=1,nb)
      close(scrfile1)
C Save coordinates
      call getvar('atsymbol  ',atsymbol)
      call getvar('coord     ',coord)
      natomsn=0
       do i=1,natoms
         if(ind(i).gt.0) then
          natomsn=natomsn+1
          atsymbol(natomsn)=atsymbol(i)
          coord(1:3,natomsn)=coord(1:3,i)
         endif
       enddo
      open(scrfile1,file='FDM',form='unformatted')
      write(scrfile1) natomsn,2*no
      write(scrfile1) atsymbol(1:natomsn)
      write(scrfile1) coord(1:3,1:natomsn)
      close(scrfile1)
C
       if(verbosity.ge.3) then
        write(6,*)
        write(6,*) 'Orbital energies in embedded subsystem [au]:'
        write(6,"(7f10.6)") eig
       endif
c szemet
c     call subsmat(natoms,nbasis,nb,sold,s,ind,natrange)
c     call dsymm('l','u',nb,nb,1.d0,s,nb,c,nb,0.d0,scr1,nb)
c     call dgemm('t','n',nb,nb,nb,1.d0,c,nb,scr1,nb,0.d0,d,nb)
c     write(6,*) 'd'
c      do i=1,nb
c       write(6,"(1000f10.6)") d(i,1:nb)
c      enddo
c     write(6,*) 'c'
c      do i=1,nb
c       write(6,"(1000f10.6)") c(i,1:nb)
c      enddo
C
      return
      end
C
************************************************************************
      subroutine subsmat(natoms,nbasis,nb,mold,mnew,ind,natrange)
************************************************************************
* Compress matrices to embedded subsystem
************************************************************************
      implicit none
      integer nbasis,nb,natoms,ind(natoms),natrange(2,natoms),i,j,ii,jj
      integer iatoms,jatoms
      real*8 mold(nbasis,nbasis),mnew(nb,nb)
C
      ii=0
       do iatoms=1,natoms
         if(ind(iatoms).eq.1) then
           do i=natrange(1,iatoms)+1,natrange(2,iatoms)
            ii=ii+1
            jj=0
             do jatoms=1,natoms
               if(ind(jatoms).eq.1) then
                 do j=natrange(1,jatoms)+1,natrange(2,jatoms)
                  jj=jj+1
                  mnew(ii,jj)=mold(i,j)
                 enddo
               endif
             enddo
           enddo
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine subsvec(natoms,nbasis,nb,n,vold,vnew,ind,natrange)
************************************************************************
* Compress matrices to embedded subsystem
************************************************************************
      implicit none
      integer nbasis,nb,natoms,ind(natoms),natrange(2,natoms),i,ii,n
      integer iatoms
      real*8 vold(nbasis,n),vnew(nb,n)
C
      ii=0
       do iatoms=1,natoms
         if(ind(iatoms).eq.1) then
           do i=natrange(1,iatoms)+1,natrange(2,iatoms)
            ii=ii+1
            vnew(ii,1:n)=vold(i,1:n)
           enddo
         endif
       enddo
C
      return
      end
C
************************************************************************
      subroutine pseig(r8heap,r8heap1n,lshift,step,c,fock,eigenvalue,
     $r8heapsize,offset,sqroffset,s,p,ifile,route)
************************************************************************
* Solve pseudo-eigenvalue equation
************************************************************************
#include "MRCCCOMMON"
#include "SCFCOMMON"
      integer i,j,step,q,error,r8heapsize,offset(nir),ifile
      integer sqroffset(nir),nq
      integer*4 error4
      real*8 r8heap(*),r8heap1n(*),lshift,c(*),fock(*),eigenvalue(*)
      real*8 s(*),p(*),fac
      equivalence(error,error4)
      character*4 route
C
      nq=0
       if(scftype.eq._UHF_.or.route.eq.'sch ') nq=1
      call dcopy((nq+1)*sqrsize,fock,1,c,1)
      fac=-0.5d0*dble(nq+1)
       if(route.eq.'sch ') fac=-0.5d0
C Level-shifting
       if(lshift.gt.0.d0.and.step.gt.1) then
         if(lnos) then
          open(oeintfile,file='OEINT',form='unformatted')
          call roeint(r8heap,r8heap,s,oeintfile,nfunc(1)) ! r8heap2n is overwritten by S !!!
          close(oeintfile)
         endif
         do q=0,nq
           do i=1,nir
             if(nfunc(i).gt.0) then
              call dsymm('l','l',nfunc(i),nfunc(i),fac,
     $p(q*sqrsize+sqroffset(i)),nfunc(i),s(sqroffset(i)),nfunc(i),0.d0,
     $r8heap1n,nfunc(i))
               do j=1,nfunc(i)
                r8heap1n((j-1)*nfunc(i)+j)=1.d0+
     $          r8heap1n((j-1)*nfunc(i)+j)
               enddo
              call dsymm('l','l',nfunc(i),nfunc(i),lshift,
     $s(sqroffset(i)),nfunc(i),r8heap1n,nfunc(i),1.d0,
     $c(q*sqrsize+sqroffset(i)),nfunc(i))
             endif
           enddo
         enddo
       endif
      error=0
C Solve generalized eigenvalue problem
      open(ifile,file='SCHOL',form='unformatted')
       if(ndao.eq.0) then
         do i=1,nir
           if(nfunc(i).gt.0) then
            call rspmx(r8heap,nfunc(i),ifile)
             do q=0,nq
              call dsygst(1,'L',nfunc(i),c(q*sqrsize+sqroffset(i)),
     $nfunc(i),r8heap,nfunc(i),error)
              call dsyev('V','L',nfunc(i),c(q*sqrsize+sqroffset(i)),
     $nfunc(i),eigenvalue(q*nbasis+offset(i)),r8heap1n,r8heapsize,error)
              call dtrsm('L','L','T','N',nfunc(i),nfunc(i),1.d0,
     $r8heap,nfunc(i),c(q*sqrsize+sqroffset(i)),nfunc(i))
               if(error4.ne.0) then
                write(iout,*) 'Fatal error at diagonalization!'
                call mrccend(1)
               endif
             enddo
           endif
         enddo
       else
         do i=1,nir
           if(nfunc(i).gt.0) then
            read(ifile) r8heap(1:nfunc(i)*nfuns(i))
             do q=0,nq
               if(nfuns(i).gt.0) then
                call dsymm('l','l',nfunc(i),nfuns(i),1.d0,
     $c(q*sqrsize+sqroffset(i)),nfunc(i),r8heap,nfunc(i),0.d0,
     $r8heap1n,nfunc(i))
                call dgemm('t','n',nfuns(i),nfuns(i),nfunc(i),1.d0,
     $r8heap,nfunc(i),r8heap1n,nfunc(i),0.d0,
     $c(q*sqrsize+sqroffset(i)),nfuns(i))
                call dsyev('V','L',nfuns(i),c(q*sqrsize+sqroffset(i)),
     $nfuns(i),eigenvalue(q*nbasis+offset(i)),r8heap1n,r8heapsize,error)
                 if(error4.ne.0) then
                  write(iout,*) 'Fatal error at diagonalization!'
                  call mrccend(1)
                 endif
                call dgemm('n','n',nfunc(i),nfuns(i),nfuns(i),1.d0,
     $r8heap,nfunc(i),c(q*sqrsize+sqroffset(i)),nfuns(i),0.d0,
     $r8heap1n,nfunc(i))
                call dcopy(nfunc(i)*nfuns(i),r8heap1n,1,
     $c(q*sqrsize+sqroffset(i)),1)
               endif
              eigenvalue(q*nbasis+offset(i)+nfuns(i):
     $                   q*nbasis+offset(i)+nfunc(i)-1)=1d30
              c(q*sqrsize+sqroffset(i)+nfunc(i)*nfuns(i):
     $          q*sqrsize+sqroffset(i)+nfunc(i)*nfunc(i)-1)=0.d0
             enddo
           endif
         enddo
       endif
      close(ifile)
C Restore orbital energies in the case of level-shifting
       if(lshift.gt.0.d0.and.step.gt.1) then
         do q=0,nq
           do i=1,nir
             do j=orbperir(i+q*nir),nfunc(i)-1
              eigenvalue(offset(i)+q*nbasis+j)=
     $        eigenvalue(offset(i)+q*nbasis+j)-lshift
             enddo
           enddo
         enddo
         if(scftype.eq._ROHFSTD_.or.scftype.eq._ROHFSCN_) then
           do i=1,nir
             do j=orbperir(i),orbperir(i)+orbperir(i+nir)-1
              eigenvalue(offset(i)+j)=
     $        eigenvalue(offset(i)+j)+0.5d0*lshift
             enddo
           enddo
         endif
       endif
#if defined (MPI)
      call MPI_Bcast(c,(nq+1)*sqrsize,MPI_DOUBLE_PRECISION,0,
     $MPI_COMM_WORLD,i)
#endif
C
      return
      end
C
************************************************************************
      subroutine mcweeny(p,s,nb,nelec,ps,ps2,ps3,tol,iout,verbosity,
     $maxit)
************************************************************************
* McWeeny purification of density matrix
************************************************************************
      implicit none
      integer nb,nelec,i,nit,verbosity,iout,maxit
      real*8 p(nb,nb),s(nb,nb),ps(nb,nb),ps2(nb,nb),ps3(nb,nb),tol,ddot
      real*8 norm,dnrm2,tmp
C McWeeny purification
       if(verbosity.ge.3) then
        write(iout,*)
        write(iout,*) 'McWeeny purification of density matrix'
        write(iout,*) 'Iter.       Norm'
       endif
      norm=1.d0
      nit=0
       do while(norm.gt.tol.and.nit.le.maxit)
        nit=nit+1
        call dsymm('l','l',nb,nb,1.d0,p,nb,s,nb,0.d0,ps,nb)
c     ps2=ps
c     call dgeev('N','N',nb,ps2,nb,ps3,ps3(1,2),ps2,nb,ps2,nb,
c    $ps3(1,3),4*nb**2,i)
c       write(6,*) 'eig'
c       write(6,"(9f9.5)") ps3(1:nb,1)
c       write(6,*) 'P'
c       write(6,"(9f9.5)") p
c       write(6,*) 'PS'
c       write(6,"(9f9.5)") ps
        call dgemm('n','n',nb,nb,nb,1.d0,ps,nb,ps,nb,0.d0,ps2,nb)
        ps3=ps-ps2
        norm=dnrm2(nb*nb,ps3,1)
        ps3=3.d0*ps-2.d0*ps2
        call dsymm('r','l',nb,nb,1.d0,p,nb,ps3,nb,0.d0,ps,nb)
        p=ps
        call symmat(p,nb)
        call dscal(nb*nb,dble(nelec)/ddot(nb*nb,p,1,s,1),p,1)
         if(verbosity.ge.3) write(iout,"(i4,f20.15)") nit,norm
       enddo
C Reconstruct P
c     write(6,*) 'P'
c     write(6,"(7f9.5)") p
c     call dsymm('l','l',nb,nb,1.d0,p,nb,s,nb,0.d0,ps,nb)
c     call dgemm('n','n',nb,nb,nb,1.d0,ps ,nb,ps,nb,0.d0,ps2,nb)
C
      return
      end 
C
************************************************************************
      subroutine mcweeny_orth(p,nb,ne,p2,p3,tol,maxit)
************************************************************************
* McWeeny purification of density matrix, orthogonal basis
************************************************************************
      implicit none
      integer nb,ne,i,nit,maxit
      real*8 p(nb,nb),p2(nb,nb),p3(nb,nb),tol,ddot,norm,dnrm2,tr
C McWeeny purification
      norm=1.d0
      nit=0
       do while(norm.gt.tol.and.nit.le.maxit)
        nit=nit+1
        call dsymm('l','l',nb,nb,1.d0,p,nb,p,nb,0.d0,p2,nb)
        call dcopy(nb*nb,p2,1,p3,1)
        call daxpy(nb*nb,-1.d0,p,1,p3,1)
        norm=dnrm2(nb*nb,p3,1)
        call dsymm('l','l',nb,nb,-2.d0,p,nb,p2,nb,0.d0,p3,nb)
        call daxpy(nb*nb,3.d0,p2,1,p3,1)
        call dcopy(nb*nb,p3,1,p,1)
        call symmat(p,nb)
        tr=0.d0
         do i=1,nb
          tr=tr+p(i,i)
         enddo
        call dscal(nb*nb,dble(ne)/tr,p,1)
c       write(6,"(i4,f20.15)") nit,norm
       enddo
C
      return
      end 
C
************************************************************************
      subroutine densopt(nb,p,f,s,sr,si,g0,g1,h,pf,fp,maxit,tol,ne,iout,
     $verbosity,fac,natoms,natrange,ind,route)
************************************************************************
* Optimization of density
************************************************************************
      implicit none
      integer nb,nit,maxit,ne,iout,verbosity
      real*8 p(nb,nb),f(nb,nb),s(nb,nb),sr(nb,nb),si(nb,nb),norm,dnrm2
      real*8 g0(nb,nb),g1(nb,nb),h(nb,nb),pf(nb,nb),fp(nb,nb),ee
      real*8 lambda,gamma,tol,ddot,b,c,d,r1,r2,omega,e1,e2,fac
      logical quadratic
      integer natoms,natrange(2,natoms),ind(natoms)
      character(len=4) route
C Orthogonalize density and Fock
      call dscal(nb*nb,1.d0/fac,p,1)
      call dsymm('l','l',nb,nb,1.d0,p,nb,sr,nb,0.d0,g0,nb)
      call dsymm('l','l',nb,nb,1.d0,sr,nb,g0,nb,0.d0,p,nb)
      call dsymm('l','l',nb,nb,1.d0,f,nb,si,nb,0.d0,g0,nb)
      call dsymm('l','l',nb,nb,1.d0,si,nb,g0,nb,0.d0,f,nb)
C Conjugate gradient iteration
       if(verbosity.ge.3) then
        write(iout,*)
        write(iout,*) 'Conjugate gradient minimization'
        write(iout,*) 'Iter.            Norm                   Tr(PF)'
       endif
      call omegagr(nb,p,f,g0,pf,fp)
       if(route.eq.'em3 ')
     $call cutdens(nb,natoms,natrange,ind,g0,pf,fp,si,sr)
      call dcopy(nb*nb,g0,1,h,1)
       do nit=1,maxit/2
        b=-ddot(nb*nb,h,1,g0,1)
        call dsymm('l','l',nb,nb,1.d0,h,nb,h,nb,0.d0,pf,nb)
        c=3.d0*ddot(nb*nb,pf,1,f,1)
        call dsymm('l','l',nb,nb,1.d0,pf,nb,f,nb,0.d0,fp,nb)
        c=c-2.d0*ddot(nb*nb,p,1,fp,1)
        call dsymm('l','l',nb,nb,1.d0,h,nb,pf,nb,0.d0,fp,nb)
        d=-2.d0*ddot(nb*nb,fp,1,f,1)
        call dsymm('r','l',nb,nb,1.d0,p,nb,pf,nb,1.d0,fp,nb)
        c=c-2.d0*ddot(nb*nb,fp,1,f,1)
        call dsymm('l','l',nb,nb,1.d0,h,nb,f,nb,0.d0,pf,nb)
        call dsymm('l','l',nb,nb,1.d0,p,nb,pf,nb,0.d0,fp,nb)
        c=c-2.d0*ddot(nb*nb,h,1,fp,1)
         if(quadratic(3.d0*d,2.d0*c,b,r1,r2)) then
          call dcopy(nb*nb,p,1,g1,1)
          call daxpy(nb*nb,r1,h,1,g1,1)
          e1=omega(nb,g1,f,pf,fp)
          call dcopy(nb*nb,p,1,g1,1)
          call daxpy(nb*nb,r2,h,1,g1,1)
          e2=omega(nb,g1,f,pf,fp)
           if(e1.lt.e2) then
            lambda=r1
            ee=e1
           else
            lambda=r2
            ee=e2
           endif
         else
          lambda=0.001d0
         endif
c       lambda=min(lambda,0.1d0)
        call daxpy(nb*nb,lambda,h,1,p,1)
         if(route.eq.'em3 ') then
          call mcweeny_fdm(p,g1,nb,ne,pf,fp,tol,maxit,natoms,natrange,
     $ind,si,sr)
         else
          call mcweeny_orth(p,nb,ne,pf,fp,tol,maxit)
         endif
        call omegagr(nb,p,f,g1,pf,fp)
         if(route.eq.'em3 ')
     $call cutdens(nb,natoms,natrange,ind,g1,pf,fp,si,sr)
        norm=ddot(nb*nb,g0,1,g0,1)
        call daxpy(nb*nb,-1.d0,g1,1,g0,1)
        gamma=-ddot(nb*nb,g0,1,g1,1)
         if(verbosity.ge.3) write(iout,"(i4,2f25.15)") nit,norm,ee
         if(norm.lt.0.01d0*tol.or.dabs(gamma).lt.0.01d0*tol) exit
        gamma=gamma/norm
        call dscal(nb*nb,gamma,h,1)
        call daxpy(nb*nb,1.d0,g1,1,h,1)
        call dcopy(nb*nb,g1,1,g0,1)
       enddo
      write(iout,
     &"(' Gradient:                                    ',f25.14)")
     &dnrm2(nb*nb,g0,1)
C Transform back density and Fock
      call dscal(nb*nb,fac,p,1)
      call dsymm('l','l',nb,nb,1.d0,p,nb,si,nb,0.d0,g0,nb)
      call dsymm('l','l',nb,nb,1.d0,si,nb,g0,nb,0.d0,p,nb)
      call dsymm('l','l',nb,nb,1.d0,f,nb,sr,nb,0.d0,g0,nb)
      call dsymm('l','l',nb,nb,1.d0,sr,nb,g0,nb,0.d0,f,nb)
C
      return
      end 
C
************************************************************************
      subroutine omegagr(nb,p,f,g,pf,fp)
************************************************************************
* Calculate (preconditioned) negative gradient of omega wrt density
************************************************************************
      implicit none
      integer nb,m,n
      real*8 p(nb,nb),f(nb,nb),g(nb,nb),pf(nb,nb),fp(nb,nb),mu,ddot,d
C Gradient
      call dsymm('l','l',nb,nb, 1.d0,p,nb,f ,nb,0.d0,pf,nb)
      call dsymm('l','l',nb,nb, 1.d0,f,nb,p ,nb,0.d0,fp,nb)
      call dsymm('l','l',nb,nb,-2.d0,p,nb,pf,nb,0.d0,g, nb)
      call dsymm('l','l',nb,nb,-2.d0,p,nb,fp,nb,1.d0,g, nb)
      call dsymm('r','l',nb,nb,-2.d0,p,nb,fp,nb,1.d0,g, nb)
      call daxpy(nb*nb,3.d0,pf,1,g,1)
      call daxpy(nb*nb,3.d0,fp,1,g,1)
C Preconditioning ???
      mu=0.d0
       do m=1,nb
c        do n=1,m
c         d=(3.d0-2.d0*p(m,m))*f(n,n)+(3.d0-2.d0*p(n,n))*f(m,m)
c    $-4.d0*(pf(m,m)+pf(n,n))
c          if(dabs(d).gt.1d-8) g(m,n)=g(m,n)/d
c         g(n,m)=g(m,n)
c        enddo
        mu=mu+g(m,m)
       enddo
C Make the gradient traceless
      mu=-mu/dble(nb)
       do m=1,nb
        g(m,m)=g(m,m)+mu
       enddo
      call dscal(nb*nb,-1.d0,g,1)
C
      return
      end
C
************************************************************************
      real*8 function omega(nb,p,f,p2,p3)
************************************************************************
* Calculate gradient of energy wrt density
************************************************************************
      implicit none
      integer nb,i
      real*8 p(nb,nb),f(nb,nb),p2(nb,nb),p3(nb,nb),mu,ddot
C
      call dsymm('l','l',nb,nb,1.d0,p,nb,f,nb,0.d0,p2,nb)
      call dsymm('l','l',nb,nb, 1.d0,p,nb,p ,nb,0.d0,p2,nb)
      call dsymm('l','l',nb,nb,-2.d0,p,nb,p2,nb,0.d0,p3,nb)
      call daxpy(nb*nb,3.d0,p2,1,p3,1)
      omega=ddot(nb*nb,p3,1,f,1)
C
      return
      end
C
************************************************************************
      subroutine cutdens(nb,natoms,natrange,ind,p,d1,d2,si,sr)
************************************************************************
* Construct density matrix for embedded subsystem in orthogonal basis
************************************************************************
      implicit none
      integer nb,natoms
      integer natrange(2,natoms),ind(natoms)
      real*8 p(nb,nb),d1(nb,nb),d2(nb,nb),si(nb,nb),sr(nb,nb)
C
      call dsymm('l','l',nb,nb,1.d0,p ,nb,si,nb,0.d0,d1,nb)
      call dsymm('l','l',nb,nb,1.d0,si,nb,d1,nb,0.d0,d2,nb)
      call fdmdens(nb,natoms,natrange,ind,d2,d1)
      call dsymm('l','l',nb,nb,1.d0,d1,nb,sr,nb,0.d0,d2,nb)
      call dsymm('l','l',nb,nb,1.d0,sr,nb,d2,nb,0.d0,p ,nb)
C
      return
      end
C
************************************************************************
      subroutine mcweeny_fdm(p,po,nb,ne,p2,p3,tol,maxit,natoms,natrange,
     $ind,si,sr)
************************************************************************
* McWeeny purification of active-space density matrix
************************************************************************
      implicit none
      integer nb,ne,i,nit,maxit,natoms,natrange(2,natoms),ind(natoms)
      real*8 p(nb,nb),p2(nb,nb),p3(nb,nb),tol,ddot,norm,dnrm2,tr
      real*8 si(nb,nb),sr(nb,nb),po(nb,nb)
C
      call dsymm('l','l',nb,nb,1.d0,p ,nb,si,nb,0.d0,p2,nb)
      call dsymm('l','l',nb,nb,1.d0,si,nb,p2,nb,0.d0,p3,nb)
      call fdmdens(nb,natoms,natrange,ind,p3,p2)
      call dcopy(nb*nb,p3,1,po,1)
      call daxpy(nb*nb,-1.d0,p2,1,po,1)
C McWeeny purification
      norm=1.d0
      nit=0
       do while(norm.gt.tol.and.nit.le.maxit)
        nit=nit+1
        call dsymm('l','l',nb,nb,1.d0,p,nb,p,nb,0.d0,p2,nb)
        call dcopy(nb*nb,p2,1,p3,1)
        call daxpy(nb*nb,-1.d0,p,1,p3,1)
        norm=dnrm2(nb*nb,p3,1)
        call dsymm('l','l',nb,nb,-2.d0,p,nb,p2,nb,0.d0,p3,nb)
        call daxpy(nb*nb,3.d0,p2,1,p3,1)
        call dcopy(nb*nb,p3,1,p,1)
        call dsymm('l','l',nb,nb,1.d0,p ,nb,si,nb,0.d0,p2,nb)
        call dsymm('l','l',nb,nb,1.d0,si,nb,p2,nb,0.d0,p ,nb)
        call fdmdens(nb,natoms,natrange,ind,p,p2)
        call dcopy(nb*nb,po,1,p,1)
        call daxpy(nb*nb,1.d0,p2,1,p,1)
        call dsymm('l','l',nb,nb,1.d0,p ,nb,sr,nb,0.d0,p2,nb)
        call dsymm('l','l',nb,nb,1.d0,sr,nb,p2,nb,0.d0,p ,nb)
        call symmat(p,nb)
        tr=0.d0
         do i=1,nb
          tr=tr+p(i,i)
         enddo
        call dscal(nb*nb,dble(ne)/tr,p,1)
c       write(6,"(i4,3f20.15)") nit,norm,tr
       enddo
C
      return
      end 
C
************************************************************************
      subroutine reorder(c,e,nb,map,sc,se)
************************************************************************
* Reorder MO coefficients
************************************************************************
      implicit none
      integer nb,map(nb),i
      real*8 c(nb,nb),e(nb),sc(nb,nb),se(nb)
C
      call dcopy(nb*nb,c,1,sc,1)
       do i=1,nb
        c(1:nb,i)=sc(1:nb,map(i))
       enddo
      call dcopy(nb,e,1,se,1)
       do i=1,nb
        e(i)=se(map(i))
       enddo
C
      return
      end 
C
************************************************************************
      subroutine readh(r8heap,ifile,symtra,nbasis,offset,lsa)
************************************************************************
* Read core Hamiltonian
************************************************************************
      implicit none
      integer ifile,nbasis,offset
      real*8 r8heap(*),symtra
      logical lsa
C
      open(ifile,file='OEINT',form='unformatted')
      read(ifile)
      call readone(r8heap,ifile,symtra,nbasis,r8heap(nbasis**2+1),
     $offset,lsa)
      close(ifile)
C
      return
      end
C
************************************************************************
      subroutine amat(a,n)
************************************************************************
* A = A - A^T
************************************************************************
      implicit none
      integer n,i,j
      real*8 a(n,n)
C
       do i=1,n
        a(i,i)=0.d0
         do j=i+1,n
          a(i,j)=a(i,j)-a(j,i)
          a(j,i)=-a(i,j)!0.d0
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine ltrp(a,b,n)
************************************************************************
* Pack lower triangle matrix (Lapack format), a and b can be identical
************************************************************************
      implicit none
      integer n,i,j
      real*8 a(*),b(*)
C
       do i=1,n
         do j=1,i
          b(i+(j-1)*(2*n-j)/2)=a((i-1)*n+j)
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine ltru(a,b,n)
************************************************************************
* Unpack lower triangle matrix (Lapack format), a and b can be identical
************************************************************************
      implicit none
      integer n,i,j,ii
      real*8 a(*),b(*)
C
      ii=(n+1)*n/2
       do j=n,1,-1
         do i=n,j,-1
          a((j-1)*n+i)=b(ii)
          ii=ii-1
         enddo
       enddo
C
      return
      end
C
************************************************************************
      subroutine ltrpack(a,b,nir,sqroffset,ltroffset,nfunc,c1)
************************************************************************
* Un/pack lower triangle matrix (Lapack format)
************************************************************************
      implicit none
      integer nir,sqroffset(nir),ltroffset(nir),nfunc(nir),i
      real*8 a(*),b(*)
      character(1) c1
C
       if(c1.eq.'p') then
         do i=1,nir
           if(nfunc(i).gt.0) then
            call ltrp(a(sqroffset(i)),b(ltroffset(i)),nfunc(i))
           endif
         enddo
       else
         do i=nir,1,-1
           if(nfunc(i).gt.0) then
            call ltru(a(sqroffset(i)),b(ltroffset(i)),nfunc(i))
            call fillup(a(sqroffset(i)),nfunc(i))
           endif
         enddo
       endif
C
      return
      end
C
#if defined (MPI)
************************************************************************
      subroutine symreduce(a,scr,n)
************************************************************************
* Reduce symmetric matrix
************************************************************************
#include "MRCCCOMMON"
      integer n
      real*8 a(n,n),scr((n+1)*n/2)
C
      call ltrp(a,a,n)
      call mpi_allreduce(a,scr,(n+1)*n/2,
     $MPI_DOUBLE_PRECISION,MPI_SUM,MPI_COMM_WORLD,MPIERR)
      call ltru(a,scr,n)
      call fillup(a,n)
C
      return
      end
C
#endif
************************************************************************
      subroutine lindep(fock,scftype,nfunc,nfuns,nir,ndao,scr,mat,
     $scrfile3,sqrsize,sqroffset)
************************************************************************
* Cure linear dependence of the AO basis
************************************************************************
      implicit none
      integer scftype,nir,nfunc(nir),nfuns(nir),ndao,scrfile3,i,q,nq,nd
      integer j,sqrsize,sqroffset(nir)
      real*8 fock(*),mat(*),scr(*)
      character(len=16) c16
C
       if(ndao.eq.0) return
      nq=0
       if(scftype.eq._UHF_) nq=1
      open(scrfile3,file='DAO',form='unformatted')
       do i=1,nir
        nd=nfunc(i)-nfuns(i)
         if(nd.gt.0) then
          read(scrfile3) mat(1:nfunc(i)*nd)
          call dsyrk('u','n',nfunc(i),nd,-1.d0,mat,nfunc(i),0.d0,scr,
     $nfunc(i))
          call filllo(scr,nfunc(i))
           do j=1,nfunc(i)
            scr((j-1)*nfunc(i)+j)=1.d0+scr((j-1)*nfunc(i)+j)
           enddo
           do q=0,nq
            call dsymm('l','u',nfunc(i),nfunc(i),1.d0,
     $fock(q*sqrsize+sqroffset(i)),nfunc(i),scr,nfunc(i),0.d0,mat,
     $nfunc(i))
            call dsymm('l','u',nfunc(i),nfunc(i),1.d0,scr,nfunc(i),mat,
     $nfunc(i),0.d0,fock(q*sqrsize+sqroffset(i)),nfunc(i))
           enddo
         endif
       enddo
      close(scrfile3)
C
      return
      end
C
************************************************************************
      subroutine fockprint(fockfile,scftype,symfock,symtra,r8heap,i4heap
     $,fock,offset,lsa,nbasis,itol,eigenvalue,symfock2,sqrsize)
************************************************************************
* print FOCK file 
************************************************************************
      implicit none
      integer fockfile,scftype,offset,nbasis,sqrsize,i
      real*8 symfock,symtra,r8heap,fock(*),itol,eigenvalue(*),symfock2
      INTEGER*4 I4HEAP(*)
      logical lsa
c
          open(unit=fockfile,file='FOCK',form='unformatted')
          SELECT CASE (scftype)
            CASE (_RHF_)
              call mxto(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
              call woeint(r8heap,i4heap,symfock,fockfile,itol,nbasis)
              write(fockfile) (eigenvalue(i),i=1,nbasis)
            CASE (_ROHFSTD_)
              call mxto(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
              call woeint(r8heap,i4heap,symfock,fockfile,itol,nbasis)
              write(fockfile) (eigenvalue(i),i=1,nbasis)
            CASE (_UHF_)
              call mxto(symfock,symtra,r8heap,nbasis,fock,offset,lsa)
              call mxto(symfock2,symtra,r8heap,nbasis,fock(sqrsize+1),
     $    offset,lsa)
              call woeint(r8heap,i4heap,symfock ,fockfile,itol,nbasis)
              call woeint(r8heap,i4heap,symfock2,fockfile,itol,nbasis)
              write(fockfile) (eigenvalue(i),i=1,nbasis)
              write(fockfile) (eigenvalue(i+nbasis),i=1,nbasis)
            CASE (_ROHFSCN_) !Fock is saved under last fock_build calling
              read(fockfile)
              read(fockfile)
              write(fockfile) (eigenvalue(i),i=1,nbasis)
              write(fockfile) (eigenvalue(i+nbasis),i=1,nbasis)
          END SELECT
          close(fockfile)
C
      return
      end
************************************************************************
      subroutine moatransp(nocc,nbasis,mo1,mo2,nc)
************************************************************************
* Transpose MO coefficient matrix
************************************************************************
      implicit none
      integer nocc,nbasis,nc,i
      real*8 mo1(nocc,nbasis),mo2(nocc,nbasis)
C
      call dcopy(nocc*nbasis,mo1,1,mo2,1)
       do i=1,nocc-nc
        mo1(i,1:nbasis)=mo2(nc+i,1:nbasis)
       enddo
       do i=1,nc
        mo1(nocc-nc+i,1:nbasis)=mo2(i,1:nbasis)
       enddo
C
      return
      end
C
************************************************************************
      subroutine diagfock(nq,nir,nfunc,sqrsize,sqroffset,orbperir,
     $nbasis,r8heapsize,offset,r8heap,fock,c,eigenvalue,lrse,fock2,erse,
     $ncoreir,localcc)
************************************************************************
* Diagonalize Fock-matrix in MO basis
************************************************************************
      implicit none
      integer nq,nir,nfunc(*),sqrsize,sqroffset(*),orbperir(*),nbasis
      integer r8heapsize,offset(*),i,q,error,ncoreir(nir),ii,n,iiend
      real*8 r8heap(*),fock(*),c(*),eigenvalue(*),fock2(*),erse
      character*4 localcc
      logical lrse
C Transform Fock-matrix to MO basis (in blockdiagonal form)
       do q=1,nq
         do i=1,nir
           if(nfunc(i).gt.0) then
            call dsymm('l','l',nfunc(i),nfunc(i),1.d0,
     $fock((q-1)*sqrsize+sqroffset(i)),nfunc(i),
     $c((q-1)*sqrsize+sqroffset(i)),nfunc(i),0.d0,r8heap,nfunc(i))
            call dgemm('t','n',nfunc(i),nfunc(i),nfunc(i),1.d0,
     $c((q-1)*sqrsize+sqroffset(i)),nfunc(i),r8heap,nfunc(i),0.d0,
     $fock((q-1)*sqrsize+sqroffset(i)),nfunc(i))
           endif
         enddo
       enddo
C Treat core orbitals
      if (lrse.or.localcc.eq.'off ') then
       do i=1,nir
         if(ncoreir(i).gt.0) then
           do q=1,nq
            ii=(q-1)*sqrsize+sqroffset(i)
            fock(ii:ii+ncoreir(i)*nfunc(i)-1)=0.d0
             do n=1,ncoreir(i)
              fock(ii)=eigenvalue(offset(i))
              ii=ii+nfunc(i)+1
             enddo
           enddo
         endif
       enddo
      else 
       do i=1,nir
         if(ncoreir(i).gt.0) then
           do q=1,nq
             do n=1,ncoreir(i)
              ii=(q-1)*sqrsize+sqroffset(i)+(n-1)*nfunc(i)+ncoreir(i)
              iiend=(q-1)*sqrsize+sqroffset(i)+n*nfunc(i)-1
              fock(ii:iiend)=0.d0
             enddo
           enddo
         endif
       enddo
      endif
       if(lrse) call dcopy(nq*sqrsize,fock,1,fock2,1)
C Diagonalize MO Fock-matrix
       do q=1,nq
         do i=1,nir
           if(nfunc(i).gt.0) then
            call dsyev('v','l',orbperir((q-1)*nir+i), !occ-occ block
     $fock((q-1)*sqrsize+sqroffset(i)),nfunc(i),
     $eigenvalue((q-1)*nbasis+offset(i)),r8heap,r8heapsize,error)
            call dsyev('v','l',nfunc(i)-orbperir((q-1)*nir+i),fock(
     $(q-1)*sqrsize+sqroffset(i)+(nfunc(i)+1)*orbperir((q-1)*nir+i)),
     $nfunc(i),eigenvalue((q-1)*nbasis+offset(i)+orbperir((q-1)*nir+i)),
     $r8heap,r8heapsize,error) !virt-virt block
           endif
         enddo
       enddo
C Calculate rSE correction
       if(lrse) then
        erse=0.d0
         do q=1,nq
           do i=1,nir
             if(nfunc(i).gt.0.and.orbperir((q-1)*nir+i).gt.0.and.
     $nfunc(i)-orbperir((q-1)*nir+i).gt.0) then
              call rse(erse,nfunc(i),orbperir((q-1)*nir+i),
     $nfunc(i)-orbperir((q-1)*nir+i),eigenvalue((q-1)*nbasis+offset(i)),
     $eigenvalue((q-1)*nbasis+offset(i)+orbperir((q-1)*nir+i)),
     $fock((q-1)*sqrsize+sqroffset(i)),fock(
     $(q-1)*sqrsize+sqroffset(i)+(nfunc(i)+1)*orbperir((q-1)*nir+i)),
     $fock2((q-1)*sqrsize+sqroffset(i)+nfunc(i)*orbperir((q-1)*nir+i)),
     $r8heap)
             endif
           enddo
         enddo
         if(nq.eq.1) erse=2.d0*erse
       endif
C
      return
      end
C
************************************************************************
      subroutine rse(erse,nb,no,nv,eo,ev,co,cv,ff,sc)
************************************************************************
* Calculate rSE correction
************************************************************************
      implicit none
      integer nb,no,nv,a,i
      real*8 erse,eo(no),ev(nv),co(nb,no),cv(nb,nv),ff(no,nv)
      real*8 sc(no,nv),tmp,sum
C
      call dgemm('t','n',no,nv,no,1.d0,co,nb,ff,nb,0.d0,sc,no)
      call dgemm('n','n',no,nv,nv,1.d0,sc,no,cv,nb,0.d0,ff,no)
      sum=0.d0
C$OMP PARALLEL DO
C$OMP& DEFAULT(SHARED)
C$OMP& PRIVATE(a,i,tmp)
C$OMP& REDUCTION(+:sum)
       do a=1,nv
         do i=1,no
          tmp=ff(i,a)
          sum=sum+tmp*tmp/(eo(i)-ev(a))
         enddo
       enddo
C$OMP END PARALLEL DO
      erse=erse+sum
C
      return
      end
C
      subroutine make_alprmap(nir,nirmax,doccperir,orbperir,soccperir,
     &virtperir,nfunc,nbasis,mosym,offset,alprmap,ndocc,eigenvalue,
     &nsocc,nvirt,saverohfocc)
      implicit none
      integer q,nir,nirmax,doccperir(nirmax),orbperir(2*nirmax)
      integer soccperir(nirmax),virtperir(nirmax),nfunc(nirmax),ndocc
      integer pivot,i,nbasis,mosym(nbasis),offset(nir),alprmap(nbasis)
      integer itemp,j,nsocc,nvirt
      real*8 eigenvalue(*)
      logical noswapped,saverohfocc
c      real*8

       if (saverohfocc) then
        do q=1,nir!save rohf order occupations
          doccperir(q)=orbperir(q)
          soccperir(q)=orbperir(q+nir)
          virtperir(q)=nfunc(q)-(doccperir(q)+soccperir(q))
        enddo
       endif
          pivot=1                                                       !generate mosym array        
          do i=1,nir
            do j=1,nfunc(i)
              mosym(pivot)=i
              pivot=pivot+1
            enddo
          enddo 
c calculate printing order of orbitals
c sorting alpha orbitals
          pivot=0
          do i=1,nir                                                    !filling docc part
            do j=offset(i),offset(i)+doccperir(i)-1
              pivot=pivot+1
              alprmap(pivot)=j
            enddo 
          enddo
          do i=1,nir                                                    !filling socc part
            do j=offset(i)+doccperir(i),
     &        offset(i)+doccperir(i)+soccperir(i)-1
              pivot=pivot+1
              alprmap(pivot)=j
            enddo 
          enddo
          do i=1,nir                                                    !filling virt part
            do j=offset(i)+doccperir(i)+soccperir(i),
     &        offset(i)+doccperir(i)+soccperir(i)+virtperir(i)-1
              pivot=pivot+1
              alprmap(pivot)=j
            enddo 
          enddo
          do                                                            !sorting in docc block
            noswapped=.true.
            do i=1,ndocc-1
              if(eigenvalue(alprmap(i)).gt.
     &         eigenvalue(alprmap(i+1))) then
                itemp=alprmap(i)
                alprmap(i)=alprmap(i+1)
                alprmap(i+1)=itemp
                noswapped=.false.
              endif
            enddo
            if(noswapped) exit
          enddo
          do                                                            !sorting in socc block
            noswapped=.true.
            do i=ndocc+1,ndocc+nsocc-1
              if(eigenvalue(alprmap(i)).gt.
     &         eigenvalue(alprmap(i+1))) then
                itemp=alprmap(i)
                alprmap(i)=alprmap(i+1)
                alprmap(i+1)=itemp
                noswapped=.false.
              endif
            enddo
            if(noswapped) exit
          enddo
          do                                                            !sorting in virt block
            noswapped=.true.
            do i=ndocc+nsocc+1,ndocc+nsocc+nvirt-1
              if(eigenvalue(alprmap(i)).gt.
     &         eigenvalue(alprmap(i+1))) then
                itemp=alprmap(i)
                alprmap(i)=alprmap(i+1)
                alprmap(i+1)=itemp
                noswapped=.false.
              endif
            enddo
            if(noswapped) exit
          enddo
      return
      end subroutine
C
      subroutine wrtodfock(fockfile,oeintfile,scrfile1,r8heap2n,symfock,
     &symfock2,nbasis,cpr,cpr2,eigenvalue,i4heap,itol,symtra,c,offset,
     &lsa,beprmap,sqrsize)
      implicit none
      integer fockfile,nbasis,oeintfile,i,scrfile1,offset
      integer sqrsize,beprmap(nbasis)
      integer*4 i4heap(*)
      real*8 r8heap2n(*),symfock(nbasis,nbasis),cpr2(nbasis,nbasis)
      real*8 symfock2(nbasis,nbasis),symtra(nbasis,nbasis),c(2*sqrsize)
      real*8 r8heap(2*sqrsize),itol
      real*8 cpr(nbasis,nbasis),eigenvalue(*)
      logical lsa

      open(unit=fockfile,file='FOCK',form='unformatted')
      rewind(fockfile)
      call roeint(r8heap2n,r8heap2n,symfock,fockfile,nbasis)
c Read S to cpr2
      open(oeintfile,file='OEINT',form='unformatted')
       call roeint(r8heap2n,r8heap2n,cpr2,oeintfile,nbasis)
      close(oeintfile)
c Alpha off-diagonal Fock
c Calculate C^-1=C^T * S to r8heap2n
      call dgemm('t','n',nbasis,nbasis,nbasis,1.d0,cpr,nbasis,cpr2,
     & nbasis,0.d0,r8heap2n,nbasis)
c Save (C^-1)^T to cpr
      call dcopy(nbasis**2,r8heap2n,1,cpr,1)
c Calculate C^-1_mu i * E_i
      do i=1,nbasis
       call dscal(nbasis,eigenvalue(i),r8heap2n(i),nbasis)
      enddo
c Calculate off-diagonal AO Fock matrix
      call dgemm('t','n',nbasis,nbasis,nbasis,-1.d0,cpr,nbasis,
     & r8heap2n,nbasis,1.d0,symfock,nbasis)
c Write alpha off-diagonal Fock to FOCK.AOD
      open(scrfile1,file='FOCK.OD',form='unformatted')
        call woeint(r8heap2n,r8heap2n,symfock ,scrfile1,itol,nbasis)
c      close(scrfile1)
c Beta off-diagonal Fock
c Read beta AO Fock
      call roeint(r8heap2n,r8heap2n,symfock2,fockfile,nbasis)
c Extract beta mocoefs
      call moto(cpr,symtra,r8heap2n,nbasis,c(sqrsize+1),offset,lsa)
      call reorder(cpr,r8heap2n,nbasis,beprmap, !we don't need to reorder eigenvalues, it is already in order
     $ r8heap2n,r8heap2n)
c Read S to cpr2
      open(oeintfile,file='OEINT',form='unformatted')
       call roeint(r8heap2n,r8heap2n,cpr2,oeintfile,nbasis)
      close(oeintfile)
c Calculate C^-1=C^T * S to r8heap2n
      call dgemm('t','n',nbasis,nbasis,nbasis,1.d0,cpr,nbasis,cpr2,
     & nbasis,0.d0,r8heap2n,nbasis)
c Save (C^-1)^T to cpr
      call dcopy(nbasis**2,r8heap2n,1,cpr,1)
c Calculate C^-1_mu i * E_i
      do i=1,nbasis
       call dscal(nbasis,eigenvalue(nbasis+i),r8heap2n(i),nbasis)
      enddo
c Calculate off-diagonal AO Fock matrix
      call dgemm('t','n',nbasis,nbasis,nbasis,-1.d0,cpr,nbasis,
     & r8heap2n,nbasis,1.d0,symfock2,nbasis)
c Write beta off-diagonal Fock to FOCK.BOD
c      open(scrfile1,file='FOCK.BOD',form='unformatted')
        call woeint(r8heap2n,r8heap2n,symfock2,scrfile1,itol,nbasis)
      close(scrfile1)
      close(fockfile)
      return
      end
************************************************************************
      subroutine molden_rohfstd(nbasis,mapping,ndocc,nsocc,cpr,
     $eigenvalue,moldenfile)
************************************************************************
      implicit none
      integer nbasis,mapping(nbasis),ndocc,i,j,moldenfile,q,nsocc
      real*8 occupation,eigenvalue(nbasis),cpr(nbasis,nbasis)
      character*4 mark

      open(unit=moldenfile,file='MOLDEN.perm')
      read(moldenfile,*) (mapping(q),q=1,nbasis)
      close(moldenfile)
      open(unit=moldenfile,file='MOLDEN')
      mark='    '
      do while (mark.ne.'[MO]')
       read(moldenfile,"(4a)")mark
      enddo
      do i=1,nbasis                                             !alpha electrons        
        if(i.le.ndocc) then
          occupation=2.d0
        else if (i.gt.ndocc.and.i.le.ndocc+nsocc) then
          occupation=1.d0
        else
          occupation=0.d0
        endif
        write(moldenfile,"(' Ene=',f14.4)") 
     $        min(eigenvalue(i),1.d7) !NP
        write(moldenfile,"(' Spin= Alpha')")
        write(moldenfile,"(' Occup=',f14.4)") occupation
        do j=1,nbasis
          write(moldenfile,"(I4,f18.10)") j,cpr(mapping(j),i)
        enddo
      enddo  
      close(moldenfile)                                         !closing molden file         

      return
      end subroutine molden_rohfstd
